/*
	CVwTaskIdealize - Task class + info for IDL execution
	TaskIdealize( CVwTask * ) - Method to perform Idealization
*/

//-----------------------------------------------------------------------------
const int IDLMTHD_HALFAMP=0;		// note - these constants must correspond with the radio button selection values.
const int IDLMTHD_SKM=1;
const int IDLMTHD_SETVALUES=2;

const static int BUF_OPTIDL_SIZE=29;
class COptionsIdealize { 
	public :
		int m_iChannel;				// Channel to idealize 
		int m_iChannels;			// number of channels in data file
		int m_iDataMode;			// Data to IDL (0:File) (1:List) (2:Selection)
		int m_iModelSelected;		// Out only - model file selected
		int m_iEraseMode;			// Whether to erase existing IDL's (0:all) (1:overlapping) (2:none)
		int m_iMethod;				// Half-Amp or SKM
		COLORREF m_crColor;			// Color used for display of IDL

		bool m_bStatistics;			// generate transitions plot
		bool m_bHistogram;			// generate event histogram
		
		bool m_bSetValues;			// true when exit from dialog is to open amp setting histogram.
		
		CString m_cSetValues;		// manually set values for half amp 
		
		void ToBuffer( BYTE * buf );
		void FromBuffer( BYTE * buf );
		bool RegistryLoad( );
		bool RegistrySave( );
	};


//-----------------------------------------------------------------------------
// dialog for task progress
class CVwTaskIdealize : public CVwTask { 
	public : 
		COptionsIdealize * m_pOptionsIdealize;
		HWND m_hDlgVwData;			// handle to data window 
		
		CModel * m_pModel;		
		CSelectionSet m_oSelSet;
	};

//-----------------------------------------------------------------
DWORD WINAPI TaskIdealize( LPVOID pParam );
