/*
CDigitalProtocol - A collection of pulse patterns for digital output lines.
*/

const int MAXDOLINES=16;

class CDigitalTimeCourse {			// series of on/off durations parse from user string 
	public : 
		CDigitalTimeCourse();
		~CDigitalTimeCourse();
		int m_iSegCount;
		int * m_aiTimes;
		int m_iTotalTime;

		bool Parse( const char * pch );
		void SetPos0( );
		
		int m_iCurrSeg;					// during generation, segment which contains current pos.
										// also determines setting even=off odd=on.
		int m_iCurrSegOffset;			// offset to segment m_iCurrSeg within total
		int m_iNextChange;				// (ms) position of next change.
	};
	
class CDigitalProtocol { 
	public : 
		int m_iDuration;			// Duration in milliseconds
		int m_iIterations;			// default iterations of Protocol
		int m_iLines;
		CString m_acTimeString[MAXDOLINES];	// Off/On pattern, ex: 1000,2000,1000,1500,
		CDigitalTimeCourse m_aTimeCourse[MAXDOLINES];

		CDigitalProtocol( );
		~CDigitalProtocol( );

		bool LoadFile( const char * pchFile );
		bool SaveFile( const char * pchFile ) ;
		void Inject( int iTC, int iTime );
		
		bool GenPrepare( int iGenRate );
		bool GenerateData( unsigned int * pData, int iCount, bool bRepeat );

		int SampleCount( int iGenRate );		
		int NextChange( );					// find the minimum CDigitalTimeCourse NextChange value converted to sample count
		unsigned int Sample( );				// combine CDigitalTimeCourse values to output integer
		bool SetPos( int iPos );			// move any TC pointers to next segment if m_iGenSample exceeds next change
		int m_iGenSample;					// position ( in samples ) within iteration.
		int m_iGenRate;
		int m_iGenIteration;				// track iteration during generation
	};

void ProtocolDigitalToAnalog( CDigitalProtocol * pDig, int iLine, double dLevel, CProtocol * pAna );
