#include "stdafx.h"

//char * g_szTitleGenPulseProtocol = "Generate Pulse Protocol";

//---------------------------------------------------------
class CVwGenPulseProtocol : public CDialog { 
	private :
		CDlgEdit m_edtBaseAmp;
		CDlgEdit m_edtAmpMin;
		CDlgEdit m_edtAmpMax;
		CDlgEdit m_edtTotalDuration;
		CDlgEdit m_edtPulseDurMin;
		CDlgEdit m_edtPulseDurMax;
		CDlgCheck m_chkPulseExp;
		CDlgEdit m_edtSepDurMin;
		CDlgEdit m_edtSepDurMax;
		CDlgCheck m_chkSepExp;
		CDlgCheck m_chkRamps;
		CDlgButton m_btnCancel;

	public :
		COptionsGenPulseProtocol * m_pOptions;

		CVwGenPulseProtocol( ) {
			m_iID=IDD_GEN_PULSE_PROTOCOL;
			}

		~CVwGenPulseProtocol(){
			}

		//-- Initialize controls
		void InitializeControls( ) {
			m_edtBaseAmp.SetHandle( GetDlgItem(m_hDlg, IDC_EDT_BASE_AMP), "Base output between pulses");
			m_edtAmpMin.SetHandle( GetDlgItem(m_hDlg, IDC_EDT_AMP_MIN), "Minimum pulse amplitude");
			m_edtAmpMax.SetHandle( GetDlgItem(m_hDlg, IDC_EDT_AMP_MAX), "Maximum pulse amplitude");
			m_edtTotalDuration.SetHandle( GetDlgItem(m_hDlg, IDC_EDT_TOTAL_DURATION), "Total duration of protocol in milliseconds");
			m_edtPulseDurMin.SetHandle( GetDlgItem(m_hDlg, IDC_EDT_PULSE_DUR_MIN), "Minimum pulse duration in milliseconds");
			m_edtPulseDurMax.SetHandle( GetDlgItem(m_hDlg, IDC_EDT_PULSE_DUR_MAX), "Maximum pulse duration in milliseconds");
			m_chkPulseExp.SetHandle( GetDlgItem(m_hDlg, IDC_CHK_PULSE_EXP), "Favor smaller pulses");
			m_edtSepDurMin.SetHandle( GetDlgItem(m_hDlg, IDC_EDT_SEP_DUR_MIN), "Minimum pulse separation in milliseconds");
			m_edtSepDurMax.SetHandle( GetDlgItem(m_hDlg, IDC_EDT_SEP_DUR_MAX), "Maximum pulse separation in milliseconds");
			m_chkRamps.SetHandle( GetDlgItem(m_hDlg, IDC_CHK_RAMPS), "Generate ramps.  Default is square pulse.");
			m_chkSepExp.SetHandle( GetDlgItem(m_hDlg, IDC_CHK_SEP_EXP), "Favor smaller separations");
			m_btnCancel.SetHandle( GetDlgItem(m_hDlg, IDCANCEL), "Cancel - do not generate");
			}

		//-- Set Control Values
		void SetControlValues( ) {
			m_edtBaseAmp.SetTextDouble( m_pOptions->m_dBaseAmp );
			m_edtAmpMin.SetTextDouble( m_pOptions->m_dAmpMin );
			m_edtAmpMax.SetTextDouble( m_pOptions->m_dAmpMax );
			m_edtTotalDuration.SetTextInt( m_pOptions->m_iTotalDuration );
			m_edtPulseDurMin.SetTextInt( m_pOptions->m_iPulseDurMin );
			m_edtPulseDurMax.SetTextInt( m_pOptions->m_iPulseDurMax );
			m_chkPulseExp.SetCheck( m_pOptions->m_bPulseExp );
			m_edtSepDurMin.SetTextInt( m_pOptions->m_iSepDurMin );
			m_edtSepDurMax.SetTextInt( m_pOptions->m_iSepDurMax );
			m_chkSepExp.SetCheck( m_pOptions->m_bSepExp );
			m_chkRamps.SetCheck( m_pOptions->m_bRamp );
			}

		//-- Get Control Values
		bool GetControlValues(  ) {
			m_pOptions->m_dBaseAmp = m_edtBaseAmp.GetTextDouble( );
			m_pOptions->m_dAmpMin = m_edtAmpMin.GetTextDouble( );
			m_pOptions->m_dAmpMax = m_edtAmpMax.GetTextDouble( );
			m_pOptions->m_iTotalDuration=m_edtTotalDuration.GetTextInt();
			m_pOptions->m_iPulseDurMin=m_edtPulseDurMin.GetTextInt();
			m_pOptions->m_iPulseDurMax=m_edtPulseDurMax.GetTextInt();
			m_pOptions->m_bPulseExp=m_chkPulseExp.GetCheck();
			m_pOptions->m_iSepDurMin=m_edtSepDurMin.GetTextInt();
			m_pOptions->m_iSepDurMax=m_edtSepDurMax.GetTextInt();
			m_pOptions->m_bSepExp=m_chkSepExp.GetCheck();
			m_pOptions->m_bRamp=m_chkRamps.GetCheck();
			return true;
			}
		//-- Button event handlers
		void OnChangeBaseAmp( ) {	// edit contents changed
			//TODO
			}
		void OnChangeAmpMin( ) {	// edit contents changed
			//TODO
			}
		void OnChangeAmpMax( ) {	// edit contents changed
			//TODO
			}
		void OnChangeTotalDuration( ) {	// edit contents changed
			//TODO
			}
		void OnChangePulseDurMin( ) {	// edit contents changed
			//TODO
			}
		void OnChangePulseDurMax( ) {	// edit contents changed
			//TODO
			}
		void OnCheckPulseExp( ) {	// checkbox toggled
			//TODO
			}
		void OnChangeSepDurMin( ) {	// edit contents changed
			//TODO
			}
		void OnChangeSepDurMax( ) {	// edit contents changed
			//TODO
			}
		void OnCheckSepExp( ) {	// checkbox toggled
			//TODO
			}

		void OnBtnCancel( ) {	// close dialog - Cancel 
			EndDialog( m_hDlg, IDCANCEL );
			}

		void OnBtnOK( ) {	// close dialog - Cancel 
			if( GetControlValues( ) ) 
				EndDialog( m_hDlg, IDOK );
			}

	};

//-----------------------------------------------------------------------------
CVwGenPulseProtocol * g_pVwGenPulseProtocol;		// Modal - one and only instance

//-----------------------------------------------------------------------------
void OpenVwGenPulseProtocol( HWND hDlg ) {
	//-- create dialogue and options
	COptionsGenPulseProtocol oOpt;
	oOpt.RegistryLoad();

	//-- present dialogue, execute if [OK]
	g_pVwGenPulseProtocol = new CVwGenPulseProtocol;
	if( DialogBoxParam( GetInstance(), (LPCTSTR)IDD_GEN_PULSE_PROTOCOL, hDlg, (DLGPROC)VwGenPulseProtocolDlgProc, (LPARAM)&oOpt ) == IDOK ) {
		oOpt.RegistrySave();
		
		SendMessage( OpenProtocolView("QUBIO Protocol"), WM_PRO_GEN, 0, (LPARAM)&oOpt );
		}
	}

//-----------------------------------------------------------------------------
// Message Pump
BOOL CALLBACK VwGenPulseProtocolDlgProc( HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam) {
	int wmId, wmEvent;
	switch( iMsg ) {
		//----- DIALOG INIT -  Control Initialization
		case WM_INITDIALOG :
			g_pVwGenPulseProtocol->m_hDlg=hDlg;
			g_pVwGenPulseProtocol->InitializeControls();
			g_pVwGenPulseProtocol->m_pOptions = (COptionsGenPulseProtocol *)lParam;
			g_pVwGenPulseProtocol->SetControlValues(  );
			return TRUE;

		//----- MENU and CONTROL Commands
		case WM_COMMAND :
			wmId    = LOWORD(wParam);
			wmEvent = HIWORD(wParam);
			if( wmId == IDCANCEL )
				g_pVwGenPulseProtocol->OnBtnCancel( );
			if( wmId == IDOK )
				g_pVwGenPulseProtocol->OnBtnOK( );
			return TRUE;

		case WM_PAINT : {
			//PAINTSTRUCT ps;
			//HDC hdc = BeginPaint(hDlg, &ps);
			//----- TODO - extra drawing here 
			//EndPaint(hDlg, &ps);
			}
			return false;

		case WM_DESTROY :
			delete g_pVwGenPulseProtocol;
			return TRUE;

		default :
			break;
		}
	return FALSE;
	}

