/* 
Math utilities 
Small math algorithms and manipulations.
*/



//----- Exchange 
void Swap( double * d1, double * d2 );
void Swap( int * i1, int * i2 );
void Swap( int iItems, double * ad0, double * ad1 ) ;
void Swap( int iItems, int * ai0, int * ai1 ) ;

//----- 
int DistanceFromPointToLine( int iXpt, int iYpt, int iX1, int iY1, int iX2, int iY2 ) ;
double log2( double d );
double LogFactorial( int iVal );
double BinCoeff( int i, int j ); 
int BinCoeffInt( int i, int j ); 

//-- in array adData[iData], return the position of the maximum or minimum(bMax=false) value.
// If pdMax !NULL, will also output the max value.
int FindMaxPos( int iData, double * adData, bool bMax=true, double * pdMax=NULL );

//-- in array adData[iData], return the max and min values.  If min/max pos are not null, will also output the index to the min/max.
void FindRange( int iData, double * pdData, double * pdMin, double * pdMax, int * piMinPos=NULL, int * piMaxPos=NULL );

//-- Return the relative probability of value x occurring in a 'normal' (gaussian)
//-- distribution about dMean with Standard deviation dStdDev.
double GaussianWeightFactor( double dMean, double dStdDev, double dVal );

//-- return the sqrt() of the sum() of the inputs 
double Pythag( int iLen, double * ad );

//-- multiply a list of parameters by provided value 
void Scale( int iLen, double * ad, double dMult );

//--------------------------------------- DFPmin - Quasi-newton minimization 
//-- lnsrch returns -1:cancelled 0:normal 1:underflow 2:new too close to old, check the convergence
const int LNSRCH_EXIT = 0;
const int LNSRCH_RUND = 1;
const int LNSRCH_CHCK = 2;
const int LNSRCH_CANC = -1;

//-- dfpmin returns -1:cancelled 0:normal 1:too many iterations 2:gradient tolerance check exceeded
const int DFPMIN_CANC = -1;
const int DFPMIN_EXIT = 0;			// normal exit - convergence 
const int DFPMIN_ITER = 1;			// too many iterations
const int DFPMIN_GTOL = 2;

//-- callback signatures - return function evaluation(ll) for values(x) and cargo(CMil *)
typedef double (__cdecl * EvalFunc)( double * x, void * pCargo  );
typedef void (__cdecl * EvalGrad)( double * x, double * g, void * pCargo  );

int lnsrch( 
		int n, 
		double * xold,					// starting pt.
		double fold,					// log likelihood at starting pt
		double * g,						// gradient at starting pt
		double * p,						// direction
		double * x,						// new pt.
		double * f,						// sufficiently changed LL at new pt.
		double dStepMax,				// limit step size 
		EvalFunc func, 
		void * pCargo,					// data (CMil *)
		bool * pbStopped );				// user cancel flag 

int dfpmin( double * p,					// starting pt. (Z) / result
			int n,						// size of p (iZSize)
			double gtol,				// convergence requirement for gradient
			int iMaxIter,				// max iterations
			double * pdResult,			// minimum value achieved
			EvalFunc func,				// function to minimize
			EvalGrad dfunc,				// gradient calculation				
			void * pCargo,				// data to pass to lnsrch (CMil *)
			int * piIter, 				// iterations
			bool * pbStopped );			// user cancel flag 
