
void ZLibCompress( BYTE * p, int iLen, CString * pc );

//------------------------------------------------------------------------------------
// a bit based queue.  
const int BINSIZE = 1024;
class CBitBin { 
	private : 
		int m_iBit;							// pos in queue
		int m_iLen;							// length allocated to queue
		BYTE * m_pBuf;						// queue
		void EnsureSpace( int iLen );		// check / reallocate m_pBuf so at least iLen free space exists
		void FlushChar( );					// move bit ptr to start of next BYTE
		
	public : 
		CBitBin( int iLen=BINSIZE );		// constuctor ( initial buffer length ) 
		void PushBit( bool b );				// add various SWF bit fields to queue
		void PushInt( int i, int iBits );
		void PushDbl( double d, int iBits );
		void PushRct( int iBits, int ix0, int ix1, int iy0, int iy1 );
		void PushMtx( double dXScale, double dYScale, double dXSkew, double dYSkew, int iXTranslate, int iYTranslate );
		void PushRGB( BYTE r, BYTE g, BYTE b );
		void PushRGBA( BYTE r, BYTE g, BYTE b, BYTE a=255 );
		void PushString( const char * pch, int iLen=-1 );	// add character mode data to queue 
		void PushChar( char ch );			// add character mode data to queue 
		void PushBYTE( BYTE bt );			// Same as PushChar
		void PushShort( short i );
		void PushLong( int i );
		
		void GetQue( bool bClear, CString * pc );
		int GetLen( ); 
		void ClearQue();
		
		BYTE * Buffer();

		//void Create( const char * pchFile, int iMaxWid, int iMaxHgt, BYTE iFrameRate, short iFrames, CBitBin * pData );
	};

//------------------------------------------------------------------------------------
// Shockwave / Flash file 
class CSWF { 
	protected : 
		CBitBin m_oBin;
		int m_iHgt, m_iWid;
		void SetCodeLen( CBitBin * pBin, int iCode, int iLen );
		void FillStyleBitmap( CBitBin * pBin, int iCharID, int iXPos, int iYPos );
		
		int m_iFileLen;		
		FILE * m_h;
		
		void ShowFrame( int iCount );	//-- ShowFrame command (multiple times).
		void EndFile( );					//-- Required at end of SWF file	
		void SetBGR( BYTE r, BYTE g, BYTE b );
		void DefineBits5( int id, int iWid, int iHgt, BYTE * pImg );

		void StyleElement( CBitBin * pBin, int iCode1, int iCode2, int iSize, bool bNeg );
		void BitmapShapeWithStyle( CBitBin * pBin, int iCharID, int iX0, int iX1, int iY0, int iY1 );
		void LineStyle( CBitBin * pBin, int iPixelWidth, BYTE r, BYTE g, BYTE b );
		void RectangleShapeWithStyle( CBitBin * pBin, int iCharID, int iX0, int iX1, int iY0, int iY1, BYTE r, BYTE g, BYTE b );
		void BitmapPlace( int iShapeID, int iCharID, int iX0, int iX1, int iY0, int iY1 );
		//void RectanglePlace( int iShapeID, int iCharID, int iX0, int iX1, int iY0, int iY1, BYTE r, BYTE g, BYTE b );
		void PlaceObject2( int iDepth, int iCharID );
		//void MoveObject2( int iDepth, int iDX, int iDY );
		void RemoveObject2( int iDepth);

	public : 
		CSWF( BYTE r=64, BYTE g=64, BYTE b=64 );
		void BMPCopy( int iCharID, int iPlaceID, int iRows, int iCols, BYTE * pBmp );
		
		void AddFrame( int iPlaceID, int iDepth=1 );

		void Create( const char * pchFile, int iMaxWid, int iMaxHgt, BYTE iFrameRate, short iFrames );
		void Flush();
		void Close();
	};

