/*
Report window : This window holds a list of messages and the date/time created.

A single global array of strings is maintained and only one instance of the 
window should be available at any time.
	
The application must initialize the report window class one time at startup : 
	RegisterReportClass( );

The application can open the report window as a child of the MDI **client window**
	CreateReportWindow( GetWindow( hFrameWin, GW_CHILD ) );	

Messages can be added via : 
	AddMessage( crBgr=REPTYPE_ERROR|REPTYPE_WARNING|REPTYPE_NOTE, char * message )
	ErrorMessage( int iMsgID, int iCode, const char * pchInfo )

A queue of messages is maintained (100) whether the window is visible or not.	

*/

const COLORREF REPTYPE_ERROR = RGB(255,0,0);
const COLORREF REPTYPE_WARNING = RGB(255,255,0);
const COLORREF REPTYPE_NOTE = RGB(255,255,255);
const COLORREF REPTYPE_RESULT = RGB(0,0,255);

void ErrorMessage( int iMsgID, int iCode=0, const char * pchInfo=NULL );
void AddMessage( COLORREF crBgr, const char * pchMessage );
void MoveMessageWindow( int iX, int iY, int iWid, int iHgt );

void CreateReportWindow( HWND hPar );
void RegisterReportClass( );
LRESULT CALLBACK ReportProc(HWND hWnd, UINT iMsg, WPARAM wParam, LPARAM lParam);
