{

  Pascal (partial) translation of CVODE.h

         (C) 2003 Lorin Milescu

}


unit cvode_iface;


interface


uses


SysUtils, Classes,
AllocTypes;


const


CV_LMM_ADAMS            = 0;
CV_LMM_BDF              = 1;

CV_ITER_FUNCTIONAL      = 0;
CV_ITER_NEWTON          = 1;

CV_ITOL_SS              = 0;
CV_ITOL_SV              = 1;

CV_ITASK_NORMAL         = 0;
CV_ITASK_ONE_STEP       = 1;


CV_OPT_SIZE             = 40;


type


TCV_NVector             = record
  Length                :Integer;
  Data                  :TPADouble;
end;
TCV_PNVector            = ^TCV_NVector;

TCV_DenseMat            = record
  Size                  :Integer;
  Data                  :TPMDouble;
end;
TCV_PDenseMat           = ^TCV_DenseMat;


TCV_RhsFn               = procedure (N :Integer; t :Double; y, ydot :TCV_PNVector; f_data :Pointer); stdcall;

TCV_DenseJacFn          = procedure (N :Integer; J :TCV_PDenseMat; f :TCV_RhsFn; f_data :Pointer; t :Double;
                                    y, fy, ewt :TCV_PNVector; h, uround :Double; jac_data :Pointer;
                                    var nfePtr :LongInt; vtemp1, vtemp2, vtemp3 :TCV_PNVector); stdcall;


function CVodeMalloc(N :Integer; f :TCV_RhsFn; t0 :Double; y0 :TCV_PNVector;
                     lmm, iter, itol :Integer;
                     var reltol :Double; abstol :Pointer;
                     f_data :Pointer; errfp :Pointer;
                     optIn :Integer; iopt :Pointer; ropt :Pointer;
                     machEnv :Pointer) :Pointer; stdcall; external 'cvodelib.dll';

procedure CVodeFree(cvode_mem :Pointer); stdcall; external 'cvodelib.dll';

function CVode(cvode_mem :Pointer; tout :Double; yout :TCV_PNVector; var t :Double; itask :Integer) :Integer; stdcall; external 'cvodelib.dll';

procedure CVDense(cvode_mem :Pointer; djac :TCV_DenseJacFn; jac_data :Pointer); stdcall; external 'cvodelib.dll';


implementation


end.

