{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
// by Lorin c.2003
// A2Q refers to the process of finding the rates which produce a given A matrix.
// It is accomplished iteratively by DFPMIN (same as MIL etc),
// as an option in IdlBase.

unit QUB_A2Q_Global;


interface


uses


AllocTypes, Alloc,

QUB_Global,
QUB_QFS_QIF_Segments,
QUB_Thread,
QUB_Q_Model;


const


//Conditions
DEF_VOLTAGE                 :Double = 0;
MIN_VOLTAGE                 :Double = -1e6;
MAX_VOLTAGE                 :Double = +1e6;

DEF_CONC                    :Double = 1;
MIN_CONC                    :Double = 0;
MAX_CONC                    :Double = 1e6;

//Optimization
MIN_OPT_LLCONV              :Double = 1e-100;
MAX_OPT_LLCONV              :Double = 1e100;
DEF_OPT_LLCONV              :Double = 1e-10;

MIN_OPT_GRADCONV            :Double = 1e-100;
MAX_OPT_GRADCONV            :Double = 1e100;
DEF_OPT_GRADCONV            :Double = 1e-10;

MIN_OPT_MAXITER              = 1;
MAX_OPT_MAXITER              = 1000;
DEF_OPT_MAXITER              = 20;

MIN_OPT_MAXSTEP             :Double = 1e-10;
MAX_OPT_MAXSTEP             :Double = 1e3;
DEF_OPT_MAXSTEP             :Double = 0.1;


type


TQUB_A2Q_Opt_Params          = record

  OptLLConv                  :Double;
  OptGradConv                :Double;
  OptMaxIter                 :Integer;
  OptSearchLimit             :Double;
  OptMaxStep                 :Double;

  ModQMinRate                :Double;

end;
TQUB_A2Q_Opt_PParams         = ^TQUB_A2Q_Opt_Params;


implementation


//******************************************************************************
end.
