unit QUB_Acquisition_DIChannel_Frame;

{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}

interface


uses


Windows, Messages, SysUtils, Classes, Graphics, Controls,
Forms, Dialogs, StdCtrls, ExtCtrls, Buttons,

QUB_Acquisition_Hardware;


type


TQUB_Acquisition_DIChannelFrame = class(TFrame)


  panName                       :TPanel;
  panValue                      :TPanel;
  btnValue                      :TSpeedButton;
  panRead                       :TPanel;
  btnRead                       :TSpeedButton;
  panUnits                      :TPanel;


  procedure btnReadClick(Sender: TObject);
  procedure btnValueClick(Sender: TObject);

  
protected


  procedure prSetValue(v :Boolean);
  function prGetValue :Boolean;


public


  DIChannel                     :TQUB_Acquisition_DIChannel;

  OnRead                        :TNotifyEvent;


  constructor Create(AOwner :TComponent); override;


  procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;


  property Value :Boolean read prGetValue write prSetValue;

  
end;


implementation


{$R *.DFM}


//******************************************************************************
constructor TQUB_Acquisition_DIChannelFrame.Create(AOwner :TComponent);
begin
  inherited;
  Align  := alTop;
  Height := 20;
end;

procedure TQUB_Acquisition_DIChannelFrame.prSetValue(v :Boolean);
begin
  btnValue.Down := v;
  if v then btnValue.Caption := 'On' else btnValue.Caption := 'Off';
end;

function TQUB_Acquisition_DIChannelFrame.prGetValue :Boolean;
begin
  Result := btnValue.Down;
end;

procedure TQUB_Acquisition_DIChannelFrame.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
begin
  inherited;

  if panName  = nil then Exit;
  if btnValue = nil then Exit;
  if panValue = nil then Exit;

  panName.Width  := Round(ClientWidth * 0.3);
  panValue.Width := Round(ClientWidth * 0.4);
  panUnits.Width := Round(ClientWidth * 0.2);

  btnValue.SetBounds(2, 1, panValue.ClientWidth - 4, panValue.ClientHeight - 2);
  btnRead.SetBounds(0, 0, panRead.ClientWidth, panRead.ClientHeight);

end;

procedure TQUB_Acquisition_DIChannelFrame.btnReadClick(Sender: TObject);
begin
  if Assigned(OnRead) then OnRead(Self);
end;

procedure TQUB_Acquisition_DIChannelFrame.btnValueClick(Sender: TObject);
begin
  if Assigned(OnRead) then OnRead(Self);
end;


//******************************************************************************
end.
