unit QUB_Acquisition_DOChannel_Frame;

{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}

interface


uses


Windows, Messages, SysUtils, Classes, Graphics, Controls,
Forms, Dialogs, StdCtrls, ExtCtrls, Buttons,

QUB_Acquisition_Hardware;


type


TQUB_Acquisition_DOChannelFrame = class(TFrame)


  panName                       :TPanel;
  panValue                      :TPanel;
  btnValue                      :TSpeedButton;
  panWrite                      :TPanel;
  btnWrite                      :TSpeedButton;
  panUnits                      :TPanel;


  procedure btnWriteClick(Sender: TObject);
  procedure btnValueClick(Sender: TObject);


protected


  procedure prSetValue(v :Boolean);
  function prGetValue :Boolean;


public


  DOChannel                     :TQUB_Acquisition_DOChannel;

  OnWrite                       :TNotifyEvent;


  constructor Create(AOwner :TComponent); override;


  procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;


  property Value :Boolean read prGetValue write prSetValue;
  

end;


implementation


{$R *.DFM}


//******************************************************************************
constructor TQUB_Acquisition_DOChannelFrame.Create(AOwner :TComponent);
begin
  inherited;
  Align  := alTop;
  Height := 20;
end;

procedure TQUB_Acquisition_DOChannelFrame.prSetValue(v :Boolean);
begin
  btnValue.Down := v;
  if v then btnValue.Caption := 'On' else btnValue.Caption := 'Off';
end;

function TQUB_Acquisition_DOChannelFrame.prGetValue :Boolean;
begin
  Result := btnValue.Down;
end;

//******************************************************************************
procedure TQUB_Acquisition_DOChannelFrame.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
begin
  inherited;

  if panName  = nil then Exit;
  if btnValue = nil then Exit;
  if panValue = nil then Exit;

  panName.Width  := Round(ClientWidth * 0.3);
  panValue.Width := Round(ClientWidth * 0.4);
  panUnits.Width := Round(ClientWidth * 0.2);

  btnValue.SetBounds(2, 1, panValue.ClientWidth - 4, panValue.ClientHeight - 2);
  btnWrite.SetBounds(0, 0, panWrite.ClientWidth, panWrite.ClientHeight);

end;

procedure TQUB_Acquisition_DOChannelFrame.btnWriteClick(Sender: TObject);
begin
  DOChannel.Value := Value;
  if Assigned(OnWrite) then OnWrite(Self);
end;

procedure TQUB_Acquisition_DOChannelFrame.btnValueClick(Sender: TObject);
begin
  Value           := Value;
  DOChannel.Value := Value;
  if Assigned(OnWrite) then OnWrite(Self);
end;


//******************************************************************************
end.
