unit QUB_ActionSelector_Acquisition;

{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}

interface


uses


Classes, Controls, StdCtrls, Menus,

QUB_Action, QUB_ActionSelector;


type


TQUB_ActionSelector_Acquisition = class(TQUB_ActionSelector)
protected


  procedure prLClickAddNote(OnActionDone :TNotifyEvent);
  procedure prRClickAddNote(OnActionDone :TNotifyEvent);

  procedure prRestoreDefaults; override;


public


  constructor Create(AOwner :TComponent); reintroduce;


end;


implementation


{$R *.DFM}


uses


QUB_GUIInterface;


//******************************************************************************
constructor TQUB_ActionSelector_Acquisition.Create(AOwner :TComponent);
begin
  inherited CreateNamed(AOwner, 'Acquisition');

  prAddAction(TQUB_Action.Create('Add Note', prLClickAddNote, prRClickAddNote, nil,
                                 'Add a note at the current point in the data', 'Note'));
  RestoreDefaults;
end;

procedure TQUB_ActionSelector_Acquisition.prRestoreDefaults;
var
  Vis                 :TStringList;
begin
  Vis                 := ActionByName['Add Note'].VisLayouts;
  Vis.Clear;
  Vis.Add('Acquisition');
  Vis.Add('Preprocessing');
end;

procedure TQUB_ActionSelector_Acquisition.prLClickAddNote(OnActionDone :TNotifyEvent);
begin
  ViewportData.AddNote;
  if @OnActionDone <> nil then OnActionDone(nil);
end;

procedure TQUB_ActionSelector_Acquisition.prRClickAddNote(OnActionDone :TNotifyEvent);
begin
  ViewportData.AddNote;
  if @OnActionDone <> nil then OnActionDone(nil);
end;


//****************************************************************************//
end.
