unit QUB_BusyDialog;

{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Math;


const

MSG_START                    = 4321;


type
   
   // you are given this function; call it regularly.  negative percent is ignored.
   TQUB_BusyUpdate = function(Pct :Double): Boolean of object; // true to continue
   
   TQUB_BusyDlog = class(TForm)
    progIterations: TProgressBar;
    btnStop: TButton;
    procedure FormShow(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
   private
    prStopped :Boolean;
    procedure prOnStart(var Message :TMessage); message MSG_START;
    function prOnUpdate(Pct :Double): Boolean;
   public
      Action :procedure(OnUpdate :TQUB_BusyUpdate) of object;
  end;

var
  QUB_BusyDlog: TQUB_BusyDlog;


implementation

{$R *.dfm}

procedure TQUB_BusyDlog.FormShow(Sender: TObject);
begin
  prStopped := False;
  progIterations.Max := 100;
  progIterations.Position := 0;
  PostMessage(Handle, MSG_START, 0, 0);
end;

procedure TQUB_BusyDlog.prOnStart(var Message :TMessage);
begin
   if Assigned(Action) then Action(prOnUpdate);
   if prStopped
   then ModalResult := mrCancel
   else ModalResult := mrOK;
end;

procedure TQUB_BusyDlog.btnStopClick(Sender: TObject);
begin
   prStopped := True;
end;

function TQUB_BusyDlog.prOnUpdate(Pct :Double): Boolean;
begin
   if (Pct >= 0.0) and (Pct <= 100.0)
   then progIterations.Position := Round(Pct);
   Application.ProcessMessages;
   Result := not prStopped;
end;

end.
