unit QUB_Classic_Properties;

{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}

interface


uses

Classes, Controls, StdCtrls, Windows, Messages, SysUtils, Graphics, Forms, Dialogs,
ComCtrls, ExtCtrls,

QUB_Global;



type


TQUB_Classic_PropertiesForm = class(TForm)


  btnOK                           :TButton;
  btnCancel                       :TButton;
  btnHelp                         :TButton;


  procedure FormShow(Sender: TObject);
  procedure FormKeyPress(Sender: TObject; var Key: Char);
  procedure btnOKClick(Sender: TObject);
  procedure btnHelpClick(Sender: TObject);


protected


  prOnGetProperties               :TNotifyEvent;
  prOnPutProperties               :TNotifyEvent;
  prWikiTopic                             :String;

public


  property OnGetProperties        :TNotifyEvent          read prOnGetProperties           write prOnGetProperties;
  property OnPutProperties        :TNotifyEvent          read prOnPutProperties           write prOnPutProperties;
  property WikiTopic                      :String                read prWikiTopic                 write prWikiTopic;

end;


implementation


{$R *.DFM}



//******************************************************************************
procedure TQUB_Classic_PropertiesForm.FormShow(Sender: TObject);
begin
  inherited;
   
  if Assigned(prOnPutProperties) then begin
    prOnPutProperties(Self);
  end;
end;

procedure TQUB_Classic_PropertiesForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Word(Key) = VK_ESCAPE then begin
    Key := #0;
    ModalResult := mrCancel;
  end;
end;

procedure TQUB_Classic_PropertiesForm.btnOKClick(Sender: TObject);
begin
  if Assigned(prOnGetProperties) then begin
    prOnGetProperties(Self);
  end;
end;

procedure TQUB_Classic_PropertiesForm.btnHelpClick(Sender: TObject);
begin
  if WikiTopic <> '' then begin
    ShowWiki(WikiTopic, Handle);
  end else if HelpContext <> 0 then begin
    Application.HelpCommand(HELP_CONTEXT, HelpContext);
  end;
end;


//******************************************************************************
end.
