unit QUB_DataList_Form;

{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}

interface

uses

Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,

QUB_Global,
QUB_DataList;


type TQUB_DataList_Form = class(TForm)

  btnOK: TButton;
    btnHelp: TButton;
    procedure btnHelpClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);

public

  DataList       :TQUB_DataList;

end;


implementation


{$R *.DFM}


procedure TQUB_DataList_Form.FormCreate(Sender: TObject);
begin
  DataList         := TQUB_DataList.Create(Self);
  DataList.SetBounds(20, 20, ClientWidth - 40, btnOK.Top - 40);
  DataList.Anchors := [akLeft, akTop, akBottom, akRight];
  DataList.Parent  := Self;
  DataList.DataSourceAvail := False;
  DataList.ForceList       := True;
end;

procedure TQUB_DataList_Form.FormDestroy(Sender: TObject);
begin
  //
end;

procedure TQUB_DataList_Form.FormShow(Sender: TObject);
begin
  DataList.ShowFiles;
end;

procedure TQUB_DataList_Form.FormHide(Sender: TObject);
begin
  DataList.HideAll;
end;

procedure TQUB_DataList_Form.btnHelpClick(Sender: TObject);
begin
  ShowWiki('Edit_File_List', Handle);
end;


end.
