unit QUB_Exp_Global;

{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}

interface


uses


AllocTypes, Alloc,

QUB_Global,
QUB_Thread,
QUB_Task,
QUB_QVO_QVD,
QUB_QFS_QDF, QUB_QFS_QDF_Global;


const


MIN_OPT_SSCONV               :Double  = 1e-10;
MAX_OPT_SSCONV               :Double  = 1e10;
DEF_OPT_SSCONV               :Double  = 1e-3;
  
MIN_OPT_GRADCONV             :Double  = 1e-10;
MAX_OPT_GRADCONV             :Double  = 1e10;
DEF_OPT_GRADCONV             :Double  = 1e-3;

MIN_OPT_MAXITER              = 1;
MAX_OPT_MAXITER              = 1000;
DEF_OPT_MAXITER              = 20;

DEF_OPT_RESTART              = 0;

MIN_OPT_MAXSTEP              :Double  = 1e-10;
MAX_OPT_MAXSTEP              :Double  = 1e3;
DEF_OPT_MAXSTEP              :Double  = 1e-1;

DEF_OPT_SKIP                 :Double  = 0;
DEF_OPT_SKIPTIME             :Double  = 0;
MIN_OPT_SKIPTIME             :Double  = 0;
MAX_OPT_SKIPTIME             :Double  = 1e10;

DEF_OPT_SHOWFIT              = 0;

SHOWFIT_AVG                  = 0;
SHOWFIT_RES                  = 2;

DEF_OPT_SHOWFIT_WHAT         = SHOWFIT_AVG;

MIN_OPT_MAXBATCH             = 1;
MAX_OPT_MAXBATCH             = 1000000;
DEF_OPT_MAXBATCH             = 100;

DEF_OPT_IDENTICALCHUNKS      = 0;

DEF_OPT_MUXFILES             = 0;

DEF_OPT_PROPAGATEPARAMS      = 0;

//Exp
MAX_STATE_COUNT              = 20;

MIN_IEQ                      :Double  = -1e10;
MAX_IEQ                      :Double  = 1e10;
DEF_IEQ                      :Double  = 1;

MIN_TAU                      :Double  = 0;
MAX_TAU                      :Double  = 1e10;
DEF_TAU                      :Double  = 1;

MIN_AMP                      :Double  = -1e10;
MAX_AMP                      :Double  = 1e10;
DEF_AMP                      :Double  = 1;

//LeakCap
MAX_LKC_N                    = 20;

MIN_LKC_GL                   :Double  = 0;
MAX_LKC_GL                   :Double  = 1e10;
DEF_LKC_GL                   :Double  = 1;

MIN_LKC_VL                   :Double  = -1e10;
MAX_LKC_VL                   :Double  = 1e10;
DEF_LKC_VL                   :Double  = -50;

MIN_LKC_VCHANNEL             = 0;
MAX_LKC_VCHANNEL             = QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1;
DEF_LKC_VCHANNEL             = 1;

MIN_LKC_V0POINTS             = 1;
MAX_LKC_V0POINTS             = ONE_MEGABYTE;
DEF_LKC_V0POINTS             = 100;

MIN_LKC_SKIPPOINTS           = 0;
MAX_LKC_SKIPPOINTS           = ONE_MEGABYTE;
DEF_LKC_SKIPPOINTS           = 10;

{
MIN_TAU                      = 0;
MAX_TAU                      = 1e10;
DEF_TAU                      = 1;

MIN_AMP                      = -1e10;
MAX_AMP                      = 1e10;
DEF_AMP                      = 1;
}
//Sine
MIN_SINE_IEQ                 :Double  = -1.0e10;
MAX_SINE_IEQ                 :Double  = 1.0e10;
DEF_SINE_IEQ                 :Double  = 0.0;

MIN_SINE_AMP                 :Double  = -1.0e10;
MAX_SINE_AMP                 :Double  = 1.0e10;
DEF_SINE_AMP                 :Double  = 1.0;

MIN_SINE_FREQ                :Double  = 1.0e-10;
MAX_SINE_FREQ                :Double  = 1.0e10;
DEF_SINE_FREQ                :Double  = 60.0;

MIN_SINE_PHASE               :Double  = -1.0e10;
MAX_SINE_PHASE               :Double  = 1.0e10;
DEF_SINE_PHASE               :Double  = 0.0;

DEF_FIXED_IEQ                = 0;
DEF_FIXED_AMP                = 0;
DEF_FIXED_FREQ               = 0;
DEF_FIXED_PHASE              = 0;


type


{$Z4}
TQUB_Mac_Opt_Mode            = (MODE_OPTIMIZE, MODE_CHECK);
{$Z1}

{$Z4}
TQUB_Mac_Opt_FitDataMode     = (FITDATA_WHOLE, FITDATA_LIST);
{$Z1}

{$Z4}
TQUB_OptimizeSegments        = (OPTSEGS_TOGETHER, OPTSEGS_GROUP, OPTSEGS_GROUPLIST);
{$Z1}

function MacFitDataModeStringOf(x :TQUB_Mac_Opt_FitDataMode): String;
function MacFitDataModeOfString(x :String): TQUB_Mac_Opt_FitDataMode;
function MacOptModeStringOf(x :TQUB_Mac_Opt_Mode): String;
function MacOptModeOfString(x :String): TQUB_Mac_Opt_Mode;
function MacSegModeStringOf(x :TQUB_OptimizeSegments): String;
function MacSegModeOfString(x :String): TQUB_OptimizeSegments;


const


METHOD_EXP                   = 0;
METHOD_LKC                   = 1;
METHOD_SIN                   = 2;


DEF_OPT_MODE                 = MODE_OPTIMIZE;

DEF_OPT_SEGMENTS             = OPTSEGS_TOGETHER;
DEF_OPT_SEGMENTS_GROUPCOUNT  = 1;

DEF_OPT_FITDATAMODE          = FITDATA_WHOLE;


type


TQUB_Exp_Opt_Params          = record
  OptSSConv                  :Double;
  OptGradConv                :Double;
  OptMaxIter                 :Integer;
  OptRestart                 :Integer;
  OptSearchLimit             :Double;
  OptMaxStep                 :Double;
  OptSkip                    :Integer;
  OptSkipTime                :Double;
  OptShowFit                 :Integer;
  OptShowFitWhat             :Integer;
  OptMode                    :TQUB_Mac_Opt_Mode;
  OptSegments                :TQUB_OptimizeSegments;
  OptSegmentsGroupCount      :Integer;
  OptSegmentsMaxBatch        :Integer;
  OptFitDataMode             :TQUB_Mac_Opt_FitDataMode;
  OptIdenticalChunks         :Integer;
  OptMUXFiles                :Integer;
  OptPropagateParams         :Integer;

  //Exp
  StateCount                 :Integer;
  Ieq                        :Double;
  Tau                        :Array[0..MAX_STATE_COUNT - 2] of Double;
  Amp                        :Array[0..MAX_STATE_COUNT - 2] of Double;

  //LeakCap
  LKCN                       :Integer;
  LKCGL                      :Double;
  LKCVL                      :Double;
  LKCTau                     :Array[0..MAX_LKC_N - 1] of Double;
  LKCAmp                     :Array[0..MAX_LKC_N - 1] of Double;
  LKCVChannel                :Integer;
  LKCV0Points                :Integer;
  LKCSkipPoints              :Integer;
  
  //Sin
  SineIeq                    :Double;
  SineAmp                    :Double;
  SineFreq                   :Double;
  SinePhase                  :Double;
  FixedIeq                   :Boolean;
  FixedAmp                   :Boolean;
  FixedFreq                  :Boolean;
  FixedPhase                 :Boolean;
end;
TQUB_Exp_Opt_PParams         = ^TQUB_Exp_Opt_Params;


TQUB_Exp_Chunk               = record

  Chunk                      :TQUB_Thread_Chunk;                                //Sel is in Data Points

  Sampling                   :Double;                                           //Seconds
  Scaling                    :Double;
  Offset                     :Double;

  Data                       :TPAInteger;

  QVD                        :TQUB_QVO_QVD;
  QDF                        :TQUB_QFS_QDF;
  FitModel                   :TObject;
  FileIndex                  :Integer;

  V                          :Double;
  V0                         :Double;

  SS                         :Double;                                           //Output: the SS of this segment, after the last iteration

  FitCurve                   :TPAInteger;

end;
TQUB_Exp_PChunk              = ^TQUB_Exp_Chunk;


implementation


//******************************************************************************
function MacFitDataModeStringOf(x :TQUB_Mac_Opt_FitDataMode): String;
begin
  if          x = FITDATA_WHOLE    then begin
    Result := 'Whole';
  end else if x = FITDATA_LIST     then begin
    Result := 'List';
  end;
end;

function MacFitDataModeOfString(x :String): TQUB_Mac_Opt_FitDataMode;
begin
  if          x = 'Whole'          then begin
    Result := FITDATA_WHOLE;
  end else{if x = 'List'           then}begin
    Result := FITDATA_LIST;
  end;
end;

function MacOptModeStringOf(x :TQUB_Mac_Opt_Mode): String;
begin
  if          x = MODE_OPTIMIZE then begin
    Result := 'optimize';
  end else if x = MODE_CHECK    then begin
    Result := 'evaluate';
  end;
end;

function MacOptModeOfString(x :String): TQUB_Mac_Opt_Mode;
begin
  if          x = 'optimize' then begin
    Result := MODE_OPTIMIZE;
  end else{if x = 'evaluate' then}begin
    Result := MODE_CHECK;
  end;
end;

function MacSegModeStringOf(x :TQUB_OptimizeSegments): String;
begin
  if          x = OPTSEGS_TOGETHER  then begin
    Result := 'together';
  end else if x = OPTSEGS_GROUP     then begin
    Result := 'in groups of';
  end else if x = OPTSEGS_GROUPLIST then begin
    Result := 'in group list of';
  end;
end;

function MacSegModeOfString(x :String): TQUB_OptimizeSegments;
begin
  if          x = 'together'         then begin
    Result := OPTSEGS_TOGETHER;
  end else if x = 'in groups of'     then begin
    Result := OPTSEGS_GROUP;
  end else{if x = 'in group list of' then}begin
    Result := OPTSEGS_GROUPLIST;
  end;
end;
 

//******************************************************************************
end.
