// the global directories of top-level interface elements, used e.g. to get the current QVD


unit QUB_GUIInterface;

{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}

interface


uses


QUB_Node,

QUB_Interface,

QUB_Viewport,
QUB_Viewport_AcquisitionSShot, QUB_Viewport_AcquisitionInput, QUB_Viewport_AcquisitionOutput,
QUB_Viewport_AcquisitionNotes,
QUB_Viewport_Data, QUB_Viewport_DataComment, QUB_Viewport_DataOverlap,
//QUB_Viewport_TriggerGraph,
//QUB_Viewport_GlobalFitting,
//QUB_Viewport_Chart,
//QUB_Viewport_Graph,
QUB_Viewport_Histogram,
QUB_Viewport_Model,
QUB_Viewport_Protocol,
QUB_Viewport_Python,
QUB_Viewport_Report,
QUB_Viewport_Results,
//QUB_Viewport_Scriptlets,
//QUB_Viewport_Scriptlets_Properties,
//QUB_Viewport_Scripts,

QUB_ActionSelector,
QUB_TaskView,
QUB_QVO_QVD_SelectionProperties,
QUB_Task_Exp_Properties,
QUB_Task_Simulate_Properties,

QUB_Profiles;


var


InterfaceList               :TQUB_Interface_List                                = nil;
ViewportList                :TQUB_Viewport_List                                 = nil;

ActionsList                 :TQUB_ActionSelector_List                           = nil;
ActionsMod                  :TQUB_ActionSelector                                = nil;//must be typecast

TaskView                    :TQUB_TaskViewForm                                  = nil;

ViewportAcqInput            :TQUB_Viewport_AcquisitionInput                     = nil;
ViewportAcqOutput           :TQUB_Viewport_AcquisitionOutput                    = nil;
ViewportAcqNotes            :TQUB_Viewport_AcquisitionNotes                     = nil;
ViewportAcqSShot            :TQUB_Viewport_AcquisitionSShot                     = nil;
ViewportData                :TQUB_Viewport_Data                                 = nil;
ViewportDataComment         :TQUB_Viewport_DataComment                          = nil;
ViewportDataOverlap         :TQUB_Viewport_DataOverlap                          = nil;
//ViewportChart               :TQUB_Viewport_Chart                                = nil;
//ViewportGraph               :TQUB_Viewport_Graph                                = nil;
ViewportHistogram           :TQUB_Viewport_Histogram                            = nil;
ViewportModel               :TQUB_Viewport_Model                                = nil;
ViewportProtocol            :TQUB_Viewport_Protocol                             = nil;
ViewportPython              :TQUB_Viewport_Python                               = nil;
ViewportReport              :TQUB_Viewport_Report                               = nil;
ViewportResults             :TQUB_Viewport_Results                              = nil;
//ViewportScriptlets          :TQUB_Viewport_Scriptlets                           = nil;
//ViewportScripts             :TQUB_Viewport_Scripts                              = nil;
//ViewportGlobalFitting       :TQUB_Viewport_GlobalFitting                        = nil;
//ViewportTriggerGraph        :TQUB_Viewport_TriggerGraph                         = nil;
//add all of them here
// . . .

SelectionPropertiesForm     :TQUB_QVO_QVD_SelectionPropertiesForm               = nil;
//ScriptletPropertiesForm     :TQUB_Viewport_Scriptlets_PropertiesForm            = nil;
TaskExpPropertiesForm       :TQUB_Task_Exp_PropertiesForm                       = nil;
TaskSimulatePropertiesForm  :TQUB_Task_Simulate_PropertiesForm                  = nil;

ProfileMgr                  :TQUB_ProfileMgr                                    = nil;


implementation


end.
