{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
// some constants -- not sure how many are still in use


unit QUB_Globals;


interface


uses


Graphics;


type

  
// wrapper for parameters set in the rate properties dialogue and saved in the registry.
TRate = class
public
  
  m_K0    :Double;
  m_K1    :Double;
  m_P     :Boolean;
  m_Q     :Boolean;
  m_PName :String;
  m_QName :String;
  m_RateFormat :String;

  procedure Setup(k0,k1:Double; P,Q:Boolean; PName,QName,RateFormat:String);

end;

TQUB_SelPar = (QUB_SELPAR_PR, QUB_SELPAR_AMP, QUB_SELPAR_STD, QUB_SELPAR_K, QUB_SELPAR_D);

TQUB_OnChangeStatusEvent = procedure (Sender: TObject; Status :PChar) of object;
TQUB_OnSelectParEvent    = procedure (Sender: TObject; Index1, Index2 :Integer; SelPar :TQUB_SelPar) of object;


const


DEF_STATESIZE           :Integer   = 20;
MIN_STATESIZE           :Integer   = 10;
MAX_STATESIZE           :Integer   = 60;

DEF_LINEWIDTH           :Integer   = 2;
MIN_LINEWIDTH           :Integer   = 0;
MAX_LINEWIDTH           :Integer   = 10;

DEF_ALIGNTOGRID         :Boolean   = False;

DEF_MODELCOLOR          :TColor    = clBtnFace;

RATE_FORMAT             :String    = '%1.1e';

PASC_FMT                :String    = '#######0.0###';

RATE_WIDTH              :Integer   = 76;
RATE_HEIGHT             :Integer   = 16;
RATE_WIDTH2             :Integer   = 38;
RATE_HEIGHT2            :Integer   = 8;

LINE_START                         = 0;
LINE_MOVE                          = 1;
LINE_END                           = 2;

MAX_CLASS                          = 10;
MAX_STATE               :Integer   = 50;
MAX_PATH                :Integer   = 100;
MAX_AR                  :Integer   = 10;

MIN_FREQUENCY           :Double    = 0.1;
DEF_FREQUENCY           :Double    = 5;
MAX_FREQUENCY           :Double    = 100;

MIN_CHANNELS            :Integer   = 1;
DEF_CHANNELS            :Integer   = 1;
MAX_CHANNELS            :Integer   = 10000;

MIN_K                   :Double    = 1e-10;
DEF_K                   :Double    = 1000.0;
MAX_K                   :Double    = 1e10;

MIN_C                   :Double    = 0;
DEF_C                   :Double    = 1.0;
MAX_C                   :Double    = 1e1;

DEF_CI                  :Boolean   = False;

MIN_V                   :Double    = -2e1;
DEF_V                   :Double    = 0.0;
MAX_V                   :Double    = 2e1;

MIN_D                   :Double    = -2e1;
DEF_D                   :Double    = 0.0;
MAX_D                   :Double    = 2e1;

MIN_P                   :Double    = 0.0;
DEF_P                   :Double    = 0.0;
MAX_P                   :Double    = 1.0;

MIN_A                   :Double    = -1e6;
DEF_A                   :Double    = 0.0;
MAX_A                   :Double    = 1e6;

MIN_X                   :Double    = 1e-6;
DEF_X                   :Double    = 0.1;
MAX_X                   :Double    = 1e3;

MIN_CFF                 :Double    = -1;
DEF_CFF                 :Double    = 0;
MAX_CFF                 :Double    = 1;

MIN_COUNT               :Integer  = 1;
DEF_COUNT               :Integer  = 32000;
MAX_COUNT               :Integer  = 32767;

DEF_RANDOM              :Boolean  = False;
DEF_FILTER              :Boolean  = False;

MIN_CONC                :Double   = 0;
DEF_CONC                :Double   = 1.0;
MAX_CONC                :Double   = 1e10;

MIN_VOLT                :Double   = -1e10;
DEF_VOLT                :Double   = 0.0;
MAX_VOLT                :Double   = 1e10;

MIN_POINTS              :Integer  = 100;
DEF_POINTS              :Integer  = 10000;
MAX_POINTS              :Integer  = 10000000;

MIN_FREQ                :Double   = 0.5;
DEF_FREQ                :Double   = 10;
MAX_FREQ                :Double   = 100;

MIN_SAMPLING            :Double   = 1e-3;
DEF_SAMPLING            :Double   = 0.01;
MAX_SAMPLING            :Double   = 1e4;

MIN_SEGMENTS            :Integer  = 1;
DEF_SEGMENTS            :Integer  = 1;
MAX_SEGMENTS            :Integer  = 1000;

MIN_N                   :Integer  = 1;
DEF_N                   :Integer  = 1;
MAX_N                   :Integer  = 100;

MIN_M                   :Integer  = 1;
DEF_M                   :Integer  = 1;
MAX_M                   :Integer  = 100;

MIN_PPTRACE             :Integer  = 100;
DEF_PPTRACE             :Integer  = 5000;
MAX_PPTRACE             :Integer  = 500000;

MIN_TPPAGE              :Integer  = 1;
DEF_TPPAGE              :Integer  = 2;
MAX_TPPAGE              :Integer  = 20;

MAX_COEFF                         = 10;

MIN_ITERATIONS          :Integer  = 1;
DEF_ITERATIONS          :Integer  = 10;
MAX_ITERATIONS          :Integer  = 100;

MIN_LNLIKELIHOOD        :Double   = 1e-3;
DEF_LNLIKELIHOOD        :Double   = 0.5;
MAX_LNLIKELIHOOD        :Double   = 10;

LOOP_ITERATIONS                   = 0;
LOOP_CONTINUOUSLY                 = 1;
LOOP_LNLIKELIHOOD                 = 2;

DEF_LOOP                :Integer  = LOOP_ITERATIONS;

MIN_FILTERCOEFFS        :Integer  = 0;
DEF_FILTERCOEFFS        :Integer  = 0;
MAX_FILTERCOEFFS        :Integer  = 10;

DEF_NOISEFILE           :Boolean  = False;
DEF_DWTFILE             :Boolean  = False;
DEF_LDTFILE             :Boolean  = True;

DEF_ALLMODELS           :Boolean  = False;

MIN_SPECTRUMCOUNT       :Integer  = 1;
DEF_SPECTRUMCOUNT       :Integer  = 100;
MAX_SPECTRUMCOUNT       :Integer  = 100000;

DEF_SPECTRUMLOG         :Boolean  = True;

MIN_AMPLITUDECOUNT      :Integer  = 1;
DEF_AMPLITUDECOUNT      :Integer  = 100;
MAX_AMPLITUDECOUNT      :Integer  = 100000;

CLASS_COLORS            :Array[0..MAX_CLASS - 1] of TColor = (clBlack,   clRed,  clNavy, clGreen, clYellow, clFuchsia,  clLime,  clBlue,  clAqua, clPurple);
BACK_COLORS             :Array[0..MAX_CLASS - 1] of TColor = (clWhite, clBlack, clWhite, clWhite,  clBlack,   clBlack, clBlack, clWhite, clBlack,  clWhite);

DZERO                   :Double   = 1e-15;

RUN_AQ_MODE_NONE        :Integer  = 0;
RUN_AQ_MODE_ONE         :Integer  = 1;
RUN_AQ_MODE_ALL         :Integer  = 2;

LOOP_UNBALANCE          = 9;
LOOP_ADJUSTED           = 10;


MAX_NODECOUNT           = 10000000;

UNSET_VALUE             = 86738.82583; // telephone-pad equivalent for Double('')


implementation


//*********************************************************************************************
procedure TRate.Setup(k0, k1 :Double; P, Q :Boolean; PName, QName, RateFormat :String);
begin
  m_K0    := K0;
  m_K1    := K1;
  m_P     := P;
  m_Q     := Q;
  m_PName := PName;
  m_QName := QName;
  m_RateFormat := RateFormat;
end;


//*********************************************************************************************
end.
