unit QUB_Main;

{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}

interface


uses


Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, DDEMan,
Menus, ExtCtrls, ComCtrls, Buttons, StdCtrls, Registry, SyncObjs, ActnList,
ShellApi, Chart,
RegistryInterface, 
FileCtrl, 

QUB_Acquisition_Hardware,
QUB_Params,
QUB_Task,
QUB_Global,

QUB_Viewport,
QUB_Viewport_AcquisitionSShot, QUB_Viewport_AcquisitionInput, QUB_Viewport_AcquisitionOutput, 
QUB_Viewport_AcquisitionNotes,
QUB_Viewport_Data, QUB_Viewport_DataComment, QUB_Viewport_DataOverlap,
//QUB_Viewport_Chart,
//QUB_Viewport_TriggerGraph,
//QUB_Viewport_GlobalFitting,
//QUB_Viewport_Graph,
QUB_Viewport_Histogram,
QUB_Viewport_Model,
QUB_Viewport_Python,
QUB_Viewport_Protocol,
QUB_Viewport_Report,
QUB_Viewport_Results,
//QUB_Viewport_Scriptlets,
//QUB_Viewport_Scripts,

QUB_Interface,
QUB_UserInterfaceProperties,

QUB_Action,
QUB_ActionSelector,
QUB_ActionSelector_Acquisition,
QUB_ActionSelector_Simulation, QUB_ActionSelector_Preprocessing, QUB_ActionSelector_Modeling,
QUB_ActionSelector_Lists, QUB_ActionSelector_Sound,

QUB_TaskView,
Qub_Action_Properties,
QUB_WizardSetup,

QUB_QVO_QVD,
QUB_QVO_QVM,

QUB_AcquisitionInput,
QUB_AcquisitionOutput,

QUB_Rich_Console,

QUB_Node,

QUB_DockManager,

QUB_Profiles,

QUB_Python_Thread;

//KPL_Program;


const


FLOATINGWINDOWS_DEFAULT             = False;
BUTTONSVISIBLE_DEFAULT              = True;

DEF_SMALL_BUTTONS                   = False;

DEF_MRU_COUNT                       = 10;

DEF_WORKSPACEFILE                   = 'default.qwf';

STATUSBAR_PANEL_DATAFILE_MODIFIED   = 1;
STATUSBAR_PANEL_DATAFILE            = 2;
STATUSBAR_PANEL_MODELFILE_MODIFIED  = 3;
STATUSBAR_PANEL_MODELFILE           = 4;

WM_QUB_PYTHON_GUISYNC               = WM_USER + 108;
WM_QUB_PYTHON_GUISYNCRUN            = WM_USER + 109;
WM_QUB_PYTHON_ASYNC                 = WM_USER + 110;

WM_QUB_ACQ_CONTROL                  = 'WM_QUB_ACQ_CONTROL';
WM_QUB_ACQ_VERSION                  = 'WM_QUB_ACQ_VERSION';
ACQ_CONTROL_INPUT                   = 1;
ACQ_CONTROL_OUTPUT                  = 2;
ACQ_CONTROL_SYNCH                   = 3;
ACQ_CONTROL_START                   = 0; // input only; prepares for play
ACQ_CONTROL_PLAY                    = 1;
ACQ_CONTROL_STOP                    = 2;
ACQ_CONTROL_RESUME                  = 3;
ACQ_CONTROL_PAUSE                   = 4;
QUB_COPYDATA_ACQ_NOTE               = 101;


type


TQUB_Runnable = class;


TQUB_MainForm = class(TForm)


  mnuMain                                                   :TMainMenu;
    mnuMainFile                                             :TMenuItem;
      mnuMainFileNewData                                    :TMenuItem;
      mnuMainFileOpenData                                   :TMenuItem;
      mnuMainFileReOpenData                                 :TMenuItem;
      mnuMainFileSaveData                                   :TMenuItem;
      mnuMainFileSaveDataAs                                 :TMenuItem;
      mnuMainFileCloseData                                  :TMenuItem;
      mnuMainFileCloseAllData                               :TMenuItem;
      mnuMainFileDataList                                   :TMenuItem;
        mnuMainFileDataListSaveAs                           :TMenuItem;
        mnuMainFileDataListOpen                             :TMenuItem;
      mnuMainFile_1                                         :TMenuItem;
      mnuMainFileNewModel                                   :TMenuItem;
      mnuMainFileOpenModel                                  :TMenuItem;
      mnuMainFileReOpenModel                                :TMenuItem;
      mnuMainFileSaveModel                                  :TMenuItem;
      mnuMainFileSaveModelAs                                :TMenuItem;
      mnuMainFileCloseModel                                 :TMenuItem;
      mnuMainFileCloseAllModels                             :TMenuItem;
      mnuMainFile_2                                         :TMenuItem;
      mnuMainFileNewKinetic                                 :TMenuItem;
      mnuMainFileOpenKinetic                                :TMenuItem;
      mnuMainFileReOpenKinetic                              :TMenuItem;
      mnuMainFileSaveKineticAs                              :TMenuItem;
      mnuMainFile_3                                         :TMenuItem;
      mnuMainFileLoadWorkspace                              :TMenuItem;
      mnuMainFileSaveWorkspace                              :TMenuItem;
      mnuMainFile_4                                         :TMenuItem;
      mnuMainFileNewInputAcquisitionData                    :TMenuItem;
      mnuMainFileOpenInputAcquisitionData                   :TMenuItem;
      mnuMainFileAssignInputAcquisitionData                 :TMenuItem;
      mnuMainFileUnAssignInputAcquisitionData               :TMenuItem;
      mnuMainFile_5                                         :TMenuItem;
      mnuMainFileNewOutputAcquisitionData                   :TMenuItem;
      mnuMainFileOpenOutputAcquisitionData                  :TMenuItem;
      mnuMainFileAssignOutputAcquisitionData                :TMenuItem;
      mnuMainFileUnAssignOutputAcquisitionData              :TMenuItem;
      mnuMainFile_6                                         :TMenuItem;
      mnuMainFileIdealizedData                              :TMenuItem;
        mnuMainFileLoadIdealizedData                        :TMenuItem;
        mnuMainFileSaveIdealizedData                        :TMenuItem;
        mnuMainFileSaveIdealizedDataASCII                   :TMenuItem;
        mnuMainFileCopyIdlListToClip                        :TMenuItem;
      mnuMainFileBaselineNodes                              :TMenuItem;
        mnuMainFileBaselineNodesLoad                        :TMenuItem;
        mnuMainFileBaselineNodesSave                        :TMenuItem;
      mnuMainFile_7                                         :TMenuItem;
      mnuMainFileOpenResults                                :TMenuItem;
      mnuMainFileSaveResultsAs                              :TMenuItem;
      mnuMainFile_8                                         :TMenuItem;
      mnuMainFileUpdateProgram                              :TMenuItem;
      mnuMainFile_9                                         :TMenuItem;
      mnuMainFileExit                                       :TMenuItem;

    mnuMainEdit                                             :TMenuItem;

    mnuMainView                                             :TMenuItem;
      mnuMainViewServerList                                 :TMenuItem;
      mnuMainViewTaskList                                   :TMenuItem;

    mnuMainInterface                                        :TMenuItem;
      mnuMainInterfaceAcquisition                           :TMenuItem;
      mnuMainInterfaceSimulation                            :TMenuItem;
      mnuMainInterfacePreprocessing                         :TMenuItem;
      mnuMainInterfaceMacroscopic                           :TMenuItem;
      mnuMainInterfaceModeling                              :TMenuItem;
      mnuMainInterfaceResults                               :TMenuItem;
      mnuMainInterfaceScripts                               :TMenuItem;
      mnuMainInterface_1                                    :TMenuItem;
      mnuMainInterfaceRestoreDefaults                       :TMenuItem;
      mnuMainInterfaceRestoreDefaultsAll                    :TMenuItem;
      mnuMainInterface_2                                    :TMenuItem;
      mnuMainInterfaceFloatingWindows                       :TMenuItem;
      mnuMainInterfaceButtonsVisible                        :TMenuItem;
      mnuMainInterfaceAdditionalInterfaces                  :TMenuItem;

    mnuMainOptions                                          :TMenuItem;
      mnuMainOptionsHardwareList                            :TMenuItem;
      mnuMainOptionsAcqChannels                             :TMenuItem;
      mnuMainOptionsCalibrationAssistant                    :TMenuItem;
      mnuMainOptions_1                                      :TMenuItem;
      mnuMainOptionsOpenlastData                            :TMenuItem;
      mnuMainOptionsOpenlastModel                           :TMenuItem;
      mnuMainOptionsOpenlastKinetic                         :TMenuItem;
      mnuMainOptionsNewModel                                :TMenuItem;
      mnuMainOptions_2                                      :TMenuItem;
      mnuMainOptionsRememberMRUFiles                        :TMenuItem;
        mnuMainOptionsRememberMRUFiles10                    :TMenuItem;
        mnuMainOptionsRememberMRUFiles50                    :TMenuItem;
      mnuMainOptions_3                                      :TMenuItem;
      mnuMainOptionsAutoSaveWorkspace                       :TMenuItem;
      mnuMainOptionsOpenLastWorkspace                       :TMenuItem;

    mnuMainActions                                          :TMenuItem;
    mnuMainActionsStopTasks                                 :TMenuItem;
    mnuMainActionsDataSource                                :TMenuItem;
      mnuMainActionsDataSourceSelection                     :TMenuItem;
      mnuMainActionsDataSourceList                          :TMenuItem;
      mnuMainActionsDataSourceFile                          :TMenuItem;
      mnuMainActionsDataSourceFileList                      :TMenuItem;
    mnuMainActions_1                                        :TMenuItem;
    mnuMainActionsShowButtons                               :TMenuItem;
    mnuMainActionsSmallButtons                              :TMenuItem;
    mnuMainActionsEditButtons                               :TMenuItem;
    mnuMainActionsRestoreButtons                            :TMenuItem;
    mnuMainActions_2                                        :TMenuItem;

    mnuMainHelp                                             :TMenuItem;
      mnuMainHelpContent                                    :TMenuItem;
      mnuMainHelpAbout                                      :TMenuItem;

  panTop                                                    :TPanel;
    panFile                                                 :TPanel;

  panTaskSelector                                           :TPanel;
    panTasks                                                :TPanel;
    panDataSource                                           :TPanel;
      chkDataSourceSel                                      :TRadioButton;
      chkDataSourceList                                     :TRadioButton;
      chkDataSourceFile                                     :TRadioButton;
      chkDataSourceFileList                                 :TRadioButton;
    progTasks                                               :TProgressBar;
    panActions                                              :TPanel;

  panInterfaceSelector                                      :TPanel;

  barStatusBar                                              :TStatusBar;

  btnInterfaceAcq                                           :TSpeedButton;
  btnInterfaceSim                                           :TSpeedButton;
  btnInterfacePre                                           :TSpeedButton;
  btnInterfaceMac                                           :TSpeedButton;
  btnInterfaceMod                                           :TSpeedButton;
  btnInterfaceRes                                           :TSpeedButton;
  btnInterfaceScr                                           :TSpeedButton;

  btnNewData                                                :TSpeedButton;
  btnOpenData                                               :TSpeedButton;
  btnSaveData                                               :TSpeedButton;

  btnNewModel                                               :TSpeedButton;
  btnOpenModel                                              :TSpeedButton;
  btnSaveModel                                              :TSpeedButton;

  btnExit                                                   :TSpeedButton;

  btnStopAllTasks                                           :TSpeedButton;

  WorkSpace                                                 :TPanel;

  lblLayout                                                 :TLabel;
  lblDataSource                                             :TLabel;

   Wiki1: TMenuItem;

  ActionList1                                               :TActionList;
  Action1                                                   :TAction;
    mnuMainFileSaveIdealizedDataStat: TMenuItem;


  procedure FormCreate(Sender: TObject);
  procedure FormDestroy(Sender: TObject);
  procedure FormShow(Sender: TObject);
  procedure FormClose(Sender: TObject; var Action: TCloseAction);
  procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  procedure FormResize(Sender: TObject);
  procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

  procedure mnuMainFileClick(Sender: TObject);
  procedure mnuMainFileNewDataClick(Sender: TObject);
  procedure mnuMainFileOpenDataClick(Sender: TObject);
  procedure mnuMainFileSaveDataClick(Sender: TObject);
  procedure mnuMainFileSaveDataAsClick(Sender: TObject);
  procedure mnuMainFileCloseDataClick(Sender: TObject);
  procedure mnuMainFileCloseAllDataClick(Sender: TObject);
  procedure mnuMainFileDataListSaveAsClick(Sender: TObject);
  procedure mnuMainFileDataListOpenClick(Sender: TObject);
  procedure mnuMainFileNewModelClick(Sender: TObject);
  procedure mnuMainFileOpenModelClick(Sender: TObject);
  procedure mnuMainFileSaveModelClick(Sender: TObject);
  procedure mnuMainFileSaveModelAsClick(Sender: TObject);
  procedure mnuMainFileCloseModelClick(Sender: TObject);
  procedure mnuMainFileCloseAllModelsClick(Sender: TObject);
  procedure mnuMainFileOpenMRUClick(Sender: TObject);
  procedure mnuMainFileNewKineticClick(Sender: TObject);
  procedure mnuMainFileOpenKineticClick(Sender: TObject);
  procedure mnuMainFileSaveKineticAsClick(Sender: TObject);
  procedure mnuMainFileLoadWorkspaceClick(Sender: TObject);
  procedure mnuMainFileSaveWorkspaceClick(Sender: TObject);
  procedure mnuMainFileNewInputAcquisitionDataClick(Sender: TObject);
  procedure mnuMainFileOpenInputAcquisitionDataClick(Sender: TObject);
  procedure mnuMainFileAssignInputAcquisitionDataClick(Sender: TObject);
  procedure mnuMainFileUnAssignInputAcquisitionDataClick(Sender: TObject);
  procedure mnuMainFileNewOutputAcquisitionDataClick(Sender: TObject);
  procedure mnuMainFileOpenOutputAcquisitionDataClick(Sender: TObject);
  procedure mnuMainFileAssignOutputAcquisitionDataClick(Sender: TObject);
  procedure mnuMainFileUnAssignOutputAcquisitionDataClick(Sender: TObject);
  procedure mnuMainFileLoadIdealizedDataClick(Sender: TObject);
  procedure mnuMainFileSaveIdealizedDataClick(Sender: TObject);
  procedure mnuMainFileSaveIdealizedDataASCIIClick(Sender: TObject);
  procedure mnuMainFileCopyIdlToClipClick(Sender: TObject);
  procedure mnuMainFileBaselineNodesLoadClick(Sender: TObject);
  procedure mnuMainFileBaselineNodesSaveClick(Sender: TObject);
  procedure mnuMainFileOpenResultsClick(Sender: TObject);
  procedure mnuMainFileSaveResultsAsClick(Sender: TObject);
  procedure mnuMainFileUpdateProgramClick(Sender: TObject);
  procedure mnuMainFileExitClick(Sender: TObject);

  procedure mnuMainViewClick(Sender: TObject);
  procedure mnuMainViewServerListClick(Sender: TObject);
  procedure mnuMainViewTaskListClick(Sender: TObject);
  procedure mnuMainViewViewportClick(Sender: TObject);

  procedure mnuMainInterfaceClick(Sender: TObject);
  procedure mnuMainInterfaceSelectClick(Sender: TObject);
  procedure mnuMainInterfaceRestoreDefaultsClick(Sender: TObject);
  procedure mnuMainInterfaceRestoreDefaultsAllClick(Sender: TObject);
  procedure mnuMainInterfaceFloatingWindowsClick(Sender: TObject);
  procedure mnuMainInterfaceButtonsVisibleClick(Sender: TObject);
  procedure mnuMainInterfaceAdditionalInterfacesClick(Sender: TObject);

  procedure mnuMainOptionsHardwareListClick(Sender: TObject);
  procedure mnuMainOptionsAcqChannelsClick(Sender: TObject);
  procedure mnuMainOptionsCalibrationAssistantClick(Sender: TObject);
  procedure mnuMainOptionsOpenlastDataClick(Sender: TObject);
  procedure mnuMainOptionsOpenlastModelClick(Sender: TObject);
  procedure mnuMainOptionsOpenlastKineticClick(Sender: TObject);
  procedure mnuMainOptionsNewModelClick(Sender: TObject);
  procedure mnuMainOptionsRememberMRUFilesClick(Sender: TObject);
  procedure mnuMainOptionsAutoSaveWorkspaceClick(Sender: TObject);
  procedure mnuMainOptionsOpenLastWorkspaceClick(Sender: TObject);

  procedure mnuMainActionsStopTasksClick(Sender: TObject);
  procedure mnuMainActionsDataSourceClick(Sender: TObject);
  procedure mnuMainActionsShowButtonsClick(Sender: TObject);
  procedure mnuMainActionsSmallButtonsClick(Sender: TObject);
  procedure mnuMainActionsEditButtonsClick(Sender: TObject);
  procedure mnuMainActionsRestoreButtonsClick(Sender: TObject);

  procedure mnuMainHelpContentClick(Sender: TObject);
  procedure mnuMainHelpAboutClick(Sender: TObject);

  procedure WorkSpaceUnDock(Sender: TObject; Client: TControl; NewTarget: TWinControl; var Allow: Boolean);
  procedure WorkSpaceDockDrop(Sender: TObject; Source: TDragDockObject; X, Y: Integer);

  procedure btnStopAllTasksClick(Sender: TObject);

  procedure chkDataSourceClick(Sender: TObject);

  procedure Action1Execute(Sender: TObject);
  procedure Wiki1Click(Sender: TObject);
    procedure mnuMainFileSaveIdealizedDataStatClick(Sender: TObject);


protected


  prFloatRect                       :TRect;

  //Console
  prConsole                         :TQUB_Rich_Console;
  //prGraphConsole                    :TChart;

  //Views
  prTaskView                        :TQUB_TaskViewForm;
  //prServerView                      :TQUB_ServerViewForm;
  frmActionProperties               :TfrmActionProperties;    // New Button editor {JB}

  //Viewports
  qubViewportList                   :TQUB_Viewport_List;

  qubViewportData                   :TQUB_Viewport_Data;
  qubViewportDataComment            :TQUB_Viewport_DataComment;
  qubViewportDataOverlap            :TQUB_Viewport_DataOverlap;
  qubViewportModel                  :TQUB_Viewport_Model;

  qubViewportAcqSShot               :TQUB_Viewport_AcquisitionSShot;
  qubViewportAcqInput               :TQUB_Viewport_AcquisitionInput;
  qubViewportAcqOutput              :TQUB_Viewport_AcquisitionOutput;

  qubViewportAcqNotes               :TQUB_Viewport_AcquisitionNotes;

  qubViewportReport                 :TQUB_Viewport_Report;
  //qubViewportTriggerGraph           :TQUB_Viewport_TriggerGraph;
  //qubViewportGlobalFitting          :TQUB_Viewport_GlobalFitting;
  //qubViewportGraph                  :TQUB_Viewport_Graph;
  qubViewportHistogram              :TQUB_Viewport_Histogram;
  //qubViewportScriptlets             :TQUB_Viewport_Scriptlets;
  //qubViewportScripts                :TQUB_Viewport_Scripts;
  qubViewportPython                 :TQUB_Viewport_Python;
  qubViewportResults                :TQUB_Viewport_Results;
  qubViewportProtocol               :TQUB_Viewport_Protocol;

  //qubViewportChart                  :TQUB_Viewport_Chart;

  //ActionSelectors
  qubActionsList                    :TQUB_ActionSelector_List;
  qubActionsSim                     :TQUB_ActionSelector_Simulation;
  qubActionsMod                     :TQUB_ActionSelector_Modeling;

  //Interfaces
  prInterfaceIndex                  :Integer;
  prChangingInterface               :Boolean;
  prCurrentInterface                :TQUB_Interface;
  qubInterfaceList                  :TQUB_Interface_List;

  //DataSource
  prDataSource                      :TQUB_Task_Data_Source;

  prLastDataFile                    :String;
  prLastModelFile                   :String;
  prLastKineticFile                 :String;

  prCommandParams                   :TStringList;

  prSmallButtons                    :Boolean;

  prDDEServer                       :TDdeServerConv;
  prDDEServerItem                   :TDDEServerItem;

  prQUBNewsOldDate                  :TDateTime;
  prQUBNewsNewDate                  :TDateTime;

  prGUISyncLock                     :TCriticalSection;
  prGUISyncProc                     :TQUB_Proc_Method;
  prGUISyncRunn                     :TQUB_Runnable;
  prGUISyncException                :TObject;
  prGUISyncDone                     :TEvent;

  //Workspace
  prWorkspaceFile                   :String;
  prWorkspaceSession                :INode;

  prRememberMRUCount                :Integer;
  

  procedure prOnGUISyncMsg(var Message: TMessage); message WM_QUB_PYTHON_GUISYNC;
  procedure prOnGUISyncRunMsg(var Message: TMessage); message WM_QUB_PYTHON_GUISYNCRUN;
  procedure prOnAsyncMsg(var Message: TMessage); message WM_QUB_PYTHON_ASYNC;
  procedure prOnAcceptFiles(var Message :TMessage); message WM_DROPFILES;
  procedure prOnAcqControlMsg(Msg, wParam, lParam :Cardinal);
  procedure prOnCopyDataMsg(var Msg :TWMCopyData); message WM_COPYDATA;

  //The main form (application) responds to the following events:
  function prOnHelp(Command: Word; Data: Longint; var CallHelp: Boolean): Boolean;


  //Interface Events
  procedure prOnInterfaceActivate(Sender :TObject);
  procedure prOnInterfaceDeActivate(Sender :TObject);
  procedure prOnButtonsChanged(Sender :TObject);

  //Viewport Events
  procedure prOnViewportActivate(Sender :TObject);
  procedure prOnViewportDeActivate(Sender :TObject);

  //Data Events
  procedure prOnOpenDataFile(Sender :TObject);
  procedure prOnCloseDataFile(Sender :TObject);
  procedure prOnChangeDataFile(Sender :TObject);

  //Model Events
  procedure prOnOpenModelFile(Sender :TObject);
  procedure prOnCloseModelFile(Sender :TObject);
  procedure prOnChangeModelFile(Sender :TObject);

  //Kinetic Events
  //procedure prOnChangeKineticFile(Sender :TObject);

  //DDE Events
  procedure prOnDDEMacro(Sender: TObject; Msg: TStrings);
  procedure prOnDDEOpen(Sender: TObject);
  procedure prOnDDEClose(Sender: TObject);
  procedure prOnDDEPokeData(Sender: TObject);

  //TaskView Events
  procedure prOnTaskCountChange(Sender :TObject);
  procedure prOnGlobalPctChange(Sender :TObject);

  procedure prSetFloatingWindows;

  procedure prSetInterfaceIndex(Index :Integer);

  procedure prSetDataSource(x :TQUB_Task_Data_Source);

  procedure prSetSmallButtons(x :Boolean);
  procedure prRestoreButtonDefaults;

  //MRU's
  procedure prAddMRUItem(MRUMenu :TMenuItem; First :Boolean; const Caption :String);
  procedure prClearEmptyMRUs;

  procedure prSetMenusOnFile;

  procedure prCheckTemp;
  procedure prClearTemp;

  function prUpdateProgram :Boolean;

  procedure CreateViews;
  procedure CreateLists;
  procedure CreateViewports;
  procedure CreateInterfaces;
  procedure CreateActions;
  procedure CreateLinks;
  procedure DestroyLinks;

  procedure ViewsOnTop;

  procedure ExecuteArguments(Args :TStrings);

  procedure prPropertiesRegistry(Read :Boolean);

  function LoadWorkspace(const FileName :String; Silent :Boolean) :Boolean;
  function SaveWorkspaceAs(const FileName :String) :Boolean;
  function SaveWorkspace(const FileName :String) :Boolean;


public


  procedure AddMenuTask(cSubmenu :String; action :TQUB_Action);
  
  procedure OnChangeHardware(Sender:TObject);
  procedure OnChangeChannels(Sender:TObject);

  procedure OnAboutHide(Sender: TObject);

  procedure ReadParams;

  procedure DoSyncGUIProc( proc :TQUB_Proc_Method );
  procedure DoSyncGUIRunnable( proc :TQUB_Runnable );
  procedure Asynchronize( proc :TQUB_Runnable );


  property CommandParams            :TStringList               read prCommandParams;

  property Console                  :TQUB_Rich_Console         read prConsole;
  //property GraphConsole             :TChart                    read prGraphConsole;
  property InterfaceList            :TQUB_Interface_List       read qubInterfaceList;
  property ViewportList             :TQUB_Viewport_List        read qubViewportList;
  property ActionList               :TQUB_ActionSelector_List  read qubActionsList;
  property ActionMod                :TQUB_ActionSelector_Modeling  read qubActionsMod;

  property DataSource               :TQUB_Task_Data_Source     read prDataSource           write prSetDataSource;

  property InterfaceIndex           :Integer                   read prInterfaceIndex       write prSetInterfaceIndex;
  property CurrentInterface         :TQUB_Interface            read prCurrentInterface;

  property SmallButtons             :Boolean                   read prSmallButtons         write prSetSmallButtons;


end;


TQUB_Runnable = class
public
  procedure Run; virtual; abstract;
end;


//----- Some quick access methods
function g_CurrData :TQUB_QVO_QVD;
function g_CurrModel :TQUB_QVO_QVM;


procedure SyncGUIProc( proc :TQUB_Proc_Method );
procedure SyncGUIRunnable( proc :TQUB_Runnable );

procedure Asynchronize( proc :TQUB_Runnable );


var


m_lstActions :TStringList;
QUB_MainForm :TQUB_MainForm;


threadvar


ThisIsTheVCLThread     :Boolean;


//------------------------------------------------------------------------------
implementation


uses


UpdateCt,
SystemPath,
QUB_About,
QUB_WizardScaling,
QUB_GUIInterface;


{$R *.DFM}


var

msgAcqControl                     :DWord;
msgAcqVersion                     :DWord;
Main_WProc                        :Pointer;




function NewWndProc(Handle: hWnd; Msg, wParam, lParam: Cardinal): LongInt; stdcall;
begin
  if Msg = msgAcqControl then begin
    QUB_MainForm.prOnAcqControlMsg(Msg, wParam, lParam);
    Result := 1;
  end else if Msg = msgAcqVersion then begin
    Result := 2;
  end else begin
    Result := CallWindowProc(Main_WProc, Handle, Msg, wParam, lParam);
  end;
end;


//******************************************************************************
procedure TQUB_MainForm.FormCreate(Sender: TObject);
var
  AppPath, UserPath          :String;
  i                          :Integer;
begin

  msgAcqControl      := RegisterWindowMessage(WM_QUB_ACQ_CONTROL);
  msgAcqVersion      := RegisterWindowMessage(WM_QUB_ACQ_VERSION);
  Main_WProc         := Pointer(SetWindowLong(Handle, gwl_WndProc, Integer(@NewWndProc)));

  Application.OnHelp         := prOnHelp;

  prDDEServer                := TDDEServerConv.Create(Self);
  prDDEServerItem            := TDDEServerItem.Create(Self);

  prDDEServer.Name           := 'Commands';
  prDDEServerItem.Name       := 'CommandsItem';

  prDDEServer.OnExecuteMacro := prOnDDEMacro;
  prDDEServer.OnOpen         := prOnDDEOpen;
  prDDEServer.OnClose        := prOnDDEClose;

  prDDEServerItem.ServerConv := prDDEServer;

  prDDEServerItem.OnPokeData := prOnDDEPokeData;

  prGUISyncLock         := TCriticalSection.Create;
  prGUISyncDone         := TEvent.Create(nil{security}, False{auto-reset}, False{init:off}, ''{unique});

  AppPath                       := ExtractFilePath(Application.ExeName)+'Profiles\';
  if not DirectoryExists(AppPath) then CreateDir(AppPath);
  UserPath                      := GetSystemPath(AppData)+'QUB\';
  if not DirectoryExists(UserPath) then CreateDir(UserPath);
  UserPath                      := UserPath + 'Profiles\';
  if not DirectoryExists(UserPath) then CreateDir(UserPath);

  QUB_Profiles.ProfileMgr       := TQUB_ProfileMgr.Create(AppPath, UserPath);
  QUB_GUIInterface.ProfileMgr   := QUB_Profiles.ProfileMgr;

  CreateViews;
  CreateLists;

  CreateViewports;
  QUB_GUIInterface.ViewportList            := ViewportList;
  QUB_GUIInterface.ViewportAcqInput        := qubViewportAcqInput;
  QUB_GUIInterface.ViewportAcqOutput       := qubViewportAcqOutput;
  QUB_GUIInterface.ViewportAcqSShot        := qubViewportAcqSShot;
  QUB_GUIInterface.ViewportAcqNotes        := qubViewportAcqNotes;
  QUB_GUIInterface.ViewportData            := qubViewportData;
  QUB_GUIInterface.ViewportDataComment     := qubViewportDataComment;
  QUB_GUIInterface.ViewportDataOverlap     := qubViewportDataOverlap;
  //QUB_GUIInterface.ViewportChart           := qubViewportChart;
  //QUB_GUIInterface.ViewportTriggerGraph    := qubViewportTriggerGraph;
  //QUB_GUIInterface.ViewportGlobalFitting   := qubViewportGlobalFitting;
  //QUB_GUIInterface.ViewportGraph           := qubViewportGraph;
  QUB_GUIInterface.ViewportHistogram       := qubViewportHistogram;
  QUB_GUIInterface.ViewportModel           := qubViewportModel;
  QUB_GUIInterface.ViewportProtocol        := qubViewportProtocol;
  QUB_GUIInterface.ViewportPython          := qubViewportPython;
  QUB_GUIInterface.ViewportReport          := qubViewportReport;
  QUB_GUIInterface.ViewportResults         := qubViewportResults;
  //QUB_GUIInterface.ViewportScriptlets      := qubViewportScriptlets;
  //QUB_GUIInterface.ViewportScripts         := qubViewportScripts;

  CreateInterfaces;
  QUB_GUIInterface.InterfaceList           := InterfaceList;

  CreateActions;
  QUB_GUIInterface.ActionsList             := ActionList;
  QUB_GUIInterface.ActionsMod              := TQUB_ActionSelector(ActionMod);

  CreateLinks;

  WorkSpace.DockManager                    := nil;
  WorkSpace.DockManager                    := TQUB_DockManager.Create(WorkSpace);

  {
    Move from here to exit. This way, if it crashes during,
    say, acquisition, the files will not be automatically deleted
    on starting. Of contrary, we can have a procedure to recover them.
  }
  //prClearTemp;

  prCommandParams                        := TStringList.Create;

  // i.e. load the scripts now that the program is all set up
  qubViewportPython.FinishInitialization;

  while not qubViewportPython.PythonAvailable do Application.ProcessMessages;

  // load ActionSelector properties after the scripts so script button visibility is preserved
  for i := 0 to ActionList.Count - 1 do begin
    ActionList[i].PropertiesRegistry(True);
  end;

  Application.HelpFile := ExtractFilePath(Application.ExeName) + 'qubhelp.hlp';

  DragAcceptFiles(Handle, True);

end;

procedure TQUB_MainForm.FormDestroy(Sender: TObject);
begin

  prCommandParams.Free;
  OnResize := nil;
  DestroyLinks;
  qubInterfaceList.Free;
  qubInterfaceList := nil;

  qubActionsList.Free;
  qubActionsList := nil;

  // qubViewportPython.FinalizePython;

  qubViewportList.Free;
  qubViewportList := nil;

  prDDEServer.OnExecuteMacro := nil;
  prDDEServer.Free;

  prGUISyncLock.Free;
  prGUISyncDone.Free;

  //Clear Temp directory on Exit. 
  prClearTemp;

  prTaskView.StopAll;

  ProfileMgr.SaveAll;
  ProfileMgr.Free;

end;

procedure TQUB_MainForm.FormShow(Sender: TObject);
begin

  //Read properties from registry:
  prPropertiesRegistry(True{Read});

  prSetMenusOnFile;

  Params(prCommandParams);

  prCheckTemp;

end;

procedure TQUB_MainForm.ReadParams;
begin
  Params(prCommandParams);
end;

procedure TQUB_MainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  try
    OnCloseQuery := nil;
    mnuMainFileExitClick(nil);
  finally
    OnCloseQuery := FormCloseQuery;
  end;
end;

procedure TQUB_MainForm.FormResize(Sender: TObject);
begin
  // Note : WindowState is the state being changed from, not to.
  if WindowState = wsNormal then prFloatRect := BoundsRect;

end;

procedure TQUB_MainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  i :Integer;
begin

  SaveWorkspace(prWorkspaceFile);

  //Can be unsaved !!!
  prLastDataFile  := '';
  if qubViewportData    <> nil then if qubViewportData.CurrData   <> nil then if qubViewportData.CurrData.Saved   then prLastDataFile    := qubViewportData.CurrData.FileName;
  prLastModelFile := '';
  if qubViewportModel   <> nil then if qubViewportModel.CurrModel <> nil then if qubViewportModel.CurrModel.Saved then prLastModelFile   := qubViewportModel.CurrModel.FileName;
  //prLastKineticFile := '';
  //if qubViewportScripts <> nil then if                                           qubViewportScripts.Script.Saved  then prLastKineticFile := qubViewportScripts.Script.FileName;

  TQUB_ActionSelector_Modeling(qubActionsList.ByName['Modeling']).StopMacLiveFit;
  TQUB_ActionSelector_Simulation(qubActionsList.ByName['Simulation']).StopSimLive;

  for i := 0 to qubViewportList.Count - 1 do begin
    CanClose := qubViewportList[i].CanClose;
    if not CanClose then Break;
    qubViewportList[i].CloseAll;
  end;

  //if CanClose then begin
  //  if QUB_GUIInterface.TaskSimulatePropertiesForm <> nil then begin
  //    CanClose := QUB_GUIInterface.TaskSimulatePropertiesForm.Source.CanClose;
  //  end;
  //end;

end;

procedure TQUB_MainForm.OnAboutHide(Sender: TObject);
begin

  QUB_AboutForm.OnHide := nil;
  QUB_AboutForm.Hide;
  QUB_AboutForm.Refresh;

  ViewsOnTop;

  ExecuteArguments(prCommandParams);

  if mnuMainOptionsOpenLastWorkspace.Checked then begin

    LoadWorkspace(prWorkspaceFile, True{Silent});

  end else begin

    if mnuMainOptionsOpenLastData.Checked then begin
      try
        if prLastDataFile <> '' then qubViewportData.Open(prLastDataFile, False{Silent});
      except
      end;
    end;
    if mnuMainOptionsNewModel.Checked then begin
      try
        qubViewportModel.New('', True{Silent});
      except
      end;
    end;
    if mnuMainOptionsOpenLastModel.Checked then begin
      try
        if prLastModelFile <> '' then qubViewportModel.Open(prLastModelFile, False{Silent});
      except
      end;
    end;
    //if mnuMainOptionsOpenLastKinetic.Checked then begin
    //  try
    //    if prLastKineticFile <> '' then qubViewportScripts.Open(prLastKineticFile, False{Silent});
    //  except
    //  end;
    //end;

  end;//LoadWorkspace

end;


//******************************************************************************
procedure TQUB_MainForm.prSetMenusOnFile;
begin
  mnuMainFileCloseData.Enabled                      := qubViewportData.HasData;
  mnuMainFileCloseAllData.Enabled                   := qubViewportData.DataCount > 1;
  mnuMainFileReOpenData.Enabled                     := mnuMainFileReOpenData.Count <> 0;
  //TO DO: LM. Check this
  //mnuMainFileSaveData.Enabled                       := qubViewportData.CanSave;
  mnuMainFileSaveData.Enabled                       := qubViewportData.HasData;
  mnuMainFileSaveDataAs.Enabled                     := qubViewportData.HasData;
  mnuMainFileDataListSaveAs.Enabled                 := qubViewportData.HasData;
  mnuMainFileDataListOpen.Enabled                   := True;

  mnuMainFileLoadIdealizedData.Enabled              := (qubViewportData.HasData) and (qubViewportData.CurrData <> nil) and (qubViewportData.CurrData.CanLoadInfo(qubViewportData.CurrData.ActiveChannel));
  mnuMainFileSaveIdealizedData.Enabled              := (qubViewportData.HasData) and (qubViewportData.CurrData <> nil) and (qubViewportData.CurrData.CanSaveInfo(qubViewportData.CurrData.ActiveChannel));
  mnuMainFileSaveIdealizedDataStat.Enabled          := (qubViewportData.HasData) and (qubViewportData.CurrData <> nil) and (qubViewportData.CurrData.CanSaveInfo(qubViewportData.CurrData.ActiveChannel));

  mnuMainFileBaselineNodesLoad.Enabled              := (qubViewportData.HasData) and (qubViewportData.CurrData <> nil) and (qubViewportData.CurrData.CanLoadBaseNodes(qubViewportData.CurrData.ActiveChannel));
  mnuMainFileBaselineNodesSave.Enabled              := (qubViewportData.HasData) and (qubViewportData.CurrData <> nil) and (qubViewportData.CurrData.CanSaveBaseNodes(qubViewportData.CurrData.ActiveChannel));

  //btnSaveData.Enabled                               := qubViewportData.CanSave;
  btnSaveData.Enabled                               := qubViewportData.HasData; // qubViewportData.CanSave;

  mnuMainFileCloseModel.Enabled                     := qubViewportModel.HasModel;
  mnuMainFileCloseAllModels.Enabled                 := qubViewportModel.ModelCount > 1;
  mnuMainFileReOpenModel.Enabled                    := mnuMainFileReOpenModel.Count <> 0;
  mnuMainFileSaveModel.Enabled                      := qubViewportModel.CanSave;
  mnuMainFileSaveModelAs.Enabled                    := qubViewportModel.HasModel;

  btnSaveModel.Enabled                              := qubViewportModel.CanSave;

  //Kinetic
  //mnuMainFileNewKinetic.Enabled                     := (not qubViewportScripts.Script.Compiling) and (not qubViewportScripts.Script.Running);
  //mnuMainFileOpenKinetic.Enabled                    := (not qubViewportScripts.Script.Compiling) and (not qubViewportScripts.Script.Running);
  //mnuMainFileReOpenKinetic.Enabled                  := (mnuMainFileReOpenKinetic.Count <> 0) and (not qubViewportScripts.Script.Compiling) and (not qubViewportScripts.Script.Running);
  //mnuMainFileSaveKineticAs.Enabled                  := (not qubViewportScripts.Script.Compiling) and (not qubViewportScripts.Script.Running);

  mnuMainFileNewInputAcquisitionData.Enabled        := qubViewportAcqInput.AcquisitionInput.AcqState    = ACQ_INPUT_STATE_STOPPED;
  mnuMainFileOpenInputAcquisitionData.Enabled       := qubViewportAcqInput.AcquisitionInput.AcqState    = ACQ_INPUT_STATE_STOPPED;
  mnuMainFileAssignInputAcquisitionData.Enabled     := (qubViewportAcqInput.AcquisitionInput.AcqState   = ACQ_INPUT_STATE_STOPPED)  and (qubViewportData.CurrData <> nil);
  mnuMainFileUnAssignInputAcquisitionData.Enabled   := (qubViewportAcqInput.AcquisitionInput.AcqState   = ACQ_INPUT_STATE_STOPPED)  and (qubViewportAcqInput.AcquisitionInput.Data   <> nil);
  mnuMainFileNewOutputAcquisitionData.Enabled       := qubViewportAcqOutput.AcquisitionOutput.AcqState  = ACQ_OUTPUT_STATE_STOPPED;
  mnuMainFileOpenOutputAcquisitionData.Enabled      := qubViewportAcqOutput.AcquisitionOutput.AcqState  = ACQ_OUTPUT_STATE_STOPPED;
  mnuMainFileAssignOutputAcquisitionData.Enabled    := (qubViewportAcqOutput.AcquisitionOutput.AcqState = ACQ_OUTPUT_STATE_STOPPED) and (qubViewportData.CurrData <> nil);
  mnuMainFileUnAssignOutputAcquisitionData.Enabled  := (qubViewportAcqOutput.AcquisitionOutput.AcqState = ACQ_OUTPUT_STATE_STOPPED) and (qubViewportAcqOutput.AcquisitionOutput.Data <> nil);

end;

procedure TQUB_MainForm.prAddMRUItem(MRUMenu :TMenuItem; First :Boolean; const Caption :String);
var
  MRUItem :TMenuItem;
  i       :Integer;
begin

  //Delete any existing menu with the same name
  for i := MRUMenu.Count - 1 downto 0 do begin
    if Lowercase(MRUMenu.Items[i].Caption) = Lowercase(Caption) then begin
      MRUMenu.Items[i].Free;
    end;
  end;

  MRUItem         := TMenuItem.Create(Self);
  MRUItem.Caption := Caption;
  MRUItem.OnClick := mnuMainFileOpenMRUClick;

  if First then begin
    MRUMenu.Insert(0, MRUItem);
    i := MRUMenu.Count - 1;
  end else begin
    MRUMenu.Add(MRUItem);
    i := 0;
  end;
  if MRUMenu.Count > prRememberMRUCount then begin
    MRUMenu.Items[i].Free;
  end;

end;

//****************************************************************************//
//                                                                            //
//                              F I L E   Commands                            //
//                                                                            //
//****************************************************************************//
procedure TQUB_MainForm.mnuMainFileClick(Sender: TObject);
begin

  prClearEmptyMRUs;

  mnuMainFileSaveData.Enabled   := qubViewportData.CanSave;

  prSetMenusOnFile;
  
end;

//Data -------------------------------------------------------------------------
procedure TQUB_MainForm.mnuMainFileNewDataClick(Sender: TObject);
begin
  qubViewportData.New('', False{Silent});
end;

procedure TQUB_MainForm.mnuMainFileOpenDataClick(Sender: TObject);
begin
  qubViewportData.Open('', False{Silent});
end;

//Acquisition Input
procedure TQUB_MainForm.mnuMainFileNewInputAcquisitionDataClick(Sender: TObject);
begin
  qubViewportAcqInput.NewInputAcq('');
end;

procedure TQUB_MainForm.mnuMainFileOpenInputAcquisitionDataClick(Sender: TObject);
begin
  qubViewportAcqInput.OpenInputAcq('');
end;

procedure TQUB_MainForm.mnuMainFileAssignInputAcquisitionDataClick(Sender: TObject);
begin
  qubViewportAcqInput.AssignInputAcq(qubViewportData.CurrData);
end;

procedure TQUB_MainForm.mnuMainFileUnAssignInputAcquisitionDataClick(Sender: TObject);
begin
  qubViewportAcqInput.AssignInputAcq(nil);
end;

//Acquisition Output
procedure TQUB_MainForm.mnuMainFileNewOutputAcquisitionDataClick(Sender: TObject);
begin
  qubViewportAcqOutput.NewOutputAcq('');
end;

procedure TQUB_MainForm.mnuMainFileOpenOutputAcquisitionDataClick(Sender: TObject);
begin
  qubViewportAcqOutput.OpenOutputAcq('');
end;

procedure TQUB_MainForm.mnuMainFileAssignOutputAcquisitionDataClick(Sender: TObject);
begin
  qubViewportAcqOutput.AssignOutputAcq(qubViewportData.CurrData);
end;

procedure TQUB_MainForm.mnuMainFileUnAssignOutputAcquisitionDataClick(Sender: TObject);
begin
  qubViewportAcqOutput.AssignOutputAcq(nil);
end;

//******************************************************************************
procedure TQUB_MainForm.mnuMainFileSaveDataClick(Sender: TObject);
begin
  qubViewportData.Save('', False{Silent});
end;

procedure TQUB_MainForm.mnuMainFileSaveDataAsClick(Sender: TObject);
begin
  qubViewportData.SaveAs('', False{Silent});
end;

procedure TQUB_MainForm.mnuMainFileCloseDataClick(Sender: TObject);
begin
  if qubViewportData.CanCloseActive then qubViewportData.Close;
end;

procedure TQUB_MainForm.mnuMainFileCloseAllDataClick(Sender: TObject);
begin
  if qubViewportData.CanClose then qubViewportData.CloseAll;
end;

//******************************************************************************
procedure TQUB_MainForm.mnuMainFileDataListSaveAsClick(Sender: TObject);
begin
  qubViewportData.DataListSaveAs;
end;

procedure TQUB_MainForm.mnuMainFileDataListOpenClick(Sender: TObject);
begin
  qubViewportData.DataListOpen;
end;

//Idealized Data
procedure TQUB_MainForm.mnuMainFileLoadIdealizedDataClick(Sender: TObject);
begin
  qubViewportData.LoadIdealizedData('');
end;

procedure TQUB_MainForm.mnuMainFileSaveIdealizedDataClick(Sender: TObject);
begin
  qubViewportData.SaveIdealizedData('', False);
end;

procedure TQUB_MainForm.mnuMainFileSaveIdealizedDataStatClick(Sender: TObject);
begin
  qubViewportData.SaveIdealizedData('', True);
end;

procedure TQUB_MainForm.mnuMainFileSaveIdealizedDataASCIIClick(Sender: TObject);
begin
  qubViewportData.SaveIdealizedDataASCII('');
end;

procedure TQUB_MainForm.mnuMainFileCopyIdlToClipClick( Sender: TObject );
begin
  qubViewportData.SaveIdealizedToClipBoard;
end;

//Baseline Nodes
procedure TQUB_MainForm.mnuMainFileBaselineNodesLoadClick(Sender: TObject);
begin
  qubViewportData.LoadBaselineNodes('');
end;

procedure TQUB_MainForm.mnuMainFileBaselineNodesSaveClick(Sender: TObject);
begin
  qubViewportData.SaveBaselineNodes('');
end;


//Model ------------------------------------------------------------------------
procedure TQUB_MainForm.mnuMainFileNewModelClick(Sender: TObject);
begin
  qubViewportModel.New('', False{Silent});
end;

procedure TQUB_MainForm.mnuMainFileOpenModelClick(Sender: TObject);
begin
  qubViewportModel.Open('', False{Silent});
end;

procedure TQUB_MainForm.mnuMainFileSaveModelClick(Sender: TObject);
begin
  qubViewportModel.Save('', False{Silent});
end;

procedure TQUB_MainForm.mnuMainFileSaveModelAsClick(Sender: TObject);
begin
  qubViewportModel.SaveAs('', False{Silent});
end;

procedure TQUB_MainForm.mnuMainFileCloseModelClick(Sender: TObject);
begin
  if qubViewportModel.CanCloseActive then qubViewportModel.Close;
end;

procedure TQUB_MainForm.mnuMainFileCloseAllModelsClick(Sender: TObject);
begin
  if qubViewportModel.CanClose then qubViewportModel.CloseAll;
end;

//Kinetic ----------------------------------------------------------------------

procedure TQUB_MainForm.mnuMainFileNewKineticClick(Sender: TObject);
begin
  //qubViewportScripts.New('', False{Silent});
end;

procedure TQUB_MainForm.mnuMainFileOpenKineticClick(Sender: TObject);
begin
  //qubViewportScripts.Open('', False{Silent});
end;

procedure TQUB_MainForm.mnuMainFileSaveKineticAsClick(Sender: TObject);
begin
  //qubViewportScripts.Save('', False{Silent});
end;


//MRU --------------------------------------------------------------------------
procedure TQUB_MainForm.mnuMainFileOpenMRUClick(Sender: TObject);
begin
  if TMenuItem(Sender).Parent = mnuMainFileReOpenData then begin
    qubViewportData.Open(TMenuItem(Sender).Caption, False{Silent});
  end else if TMenuItem(Sender).Parent = mnuMainFileReOpenModel then begin
    qubViewportModel.Open(TMenuItem(Sender).Caption, False{Silent});
  //end else if TMenuItem(Sender).Parent = mnuMainFileReOpenKinetic then begin
  //  qubViewportScripts.Open(TMenuItem(Sender).Caption, False{Silent});
  end;
end;

//Workspace
procedure TQUB_MainForm.mnuMainFileLoadWorkspaceClick(Sender: TObject);
begin
  LoadWorkspace('', False{Silent});
end;

procedure TQUB_MainForm.mnuMainFileSaveWorkspaceClick(Sender: TObject);
begin
  SaveWorkspaceAs('');
end;

//Results
procedure TQUB_MainForm.mnuMainFileOpenResultsClick(Sender: TObject);
begin
 qubViewportResults.Open('', False{Silent});
end;

procedure TQUB_MainForm.mnuMainFileSaveResultsAsClick(Sender: TObject);
begin
  qubViewportResults.SaveAs('', False{Silent});
end;

//Update Program ---------------------------------------------------------------
procedure TQUB_MainForm.mnuMainFileUpdateProgramClick(Sender: TObject);
begin
  prUpdateProgram;
end;

//Exit -------------------------------------------------------------------------
procedure TQUB_MainForm.mnuMainFileExitClick(Sender: TObject);
begin
  if CloseQuery then begin
    //Write properties to the registry
    prPropertiesRegistry(False{Write});
    InterfaceIndex := INTERFACE_NONE;

    Screen.OnActiveFormChange := nil;
    Release;
    Application.Terminate;
  end;
end;


//****************************************************************************//
//                                                                            //
//                              V I E W   Commands                            //
//                                                                            //
//****************************************************************************//
procedure TQUB_MainForm.mnuMainViewClick(Sender: TObject);
begin
  //mnuMainViewTaskList.Enabled := prTaskView.HasTask;
end;

procedure TQUB_MainForm.mnuMainViewTaskListClick(Sender: TObject);
begin
  prTaskView.Show;
end;

procedure TQUB_MainForm.mnuMainViewServerListClick(Sender: TObject);
begin
  //prServerView.Show;
end;

procedure TQUB_MainForm.mnuMainViewViewportClick(Sender: TObject);
begin
  qubViewportList[TMenuItem(Sender).Tag].ShowHide(True{Show});
  WorkSpace.DockManager.ResetBounds(True);
end;


//****************************************************************************//
//                                                                            //
//                         I N T E R F A C E   Commands                       //
//                                                                            //
//****************************************************************************//

procedure TQUB_MainForm.mnuMainInterfaceClick(Sender: TObject);
begin
  mnuMainInterfaceAcquisition.Checked   := mnuMainInterfaceAcquisition.Tag   = InterfaceIndex;
  mnuMainInterfaceSimulation.Checked    := mnuMainInterfaceSimulation.Tag    = InterfaceIndex;
  mnuMainInterfacePreprocessing.Checked := mnuMainInterfacePreprocessing.Tag = InterfaceIndex;
  mnuMainInterfaceModeling.Checked      := mnuMainInterfaceModeling.Tag      = InterfaceIndex;
  mnuMainInterfaceMacroscopic.Checked   := mnuMainInterfaceMacroscopic.Tag   = InterfaceIndex;
  mnuMainInterfaceResults.Checked       := mnuMainInterfaceResults.Tag       = InterfaceIndex;
  mnuMainInterfaceScripts.Checked       := mnuMainInterfaceScripts.Tag       = InterfaceIndex;
end;

procedure TQUB_MainForm.mnuMainInterfaceSelectClick(Sender: TObject);
begin
  //UserInterfaceNameWriteRegistry
  if prChangingInterface then Exit;
  prChangingInterface := True;
  try
    InterfaceIndex := TControl(Sender).Tag;
  finally
    prChangingInterface := False;
  end;
end;

procedure TQUB_MainForm.mnuMainInterfaceRestoreDefaultsClick(Sender: TObject);
begin
  if CurrentInterface <> nil then begin
    CurrentInterface.DoPropertiesDisplayWriteDefault;
    CurrentInterface.Activate;
  end;
end;

procedure TQUB_MainForm.mnuMainInterfaceRestoreDefaultsAllClick(Sender: TObject);
var
  i :Integer;
begin
  for i := 0 to qubInterfaceList.Count - 1 do begin
    qubInterfaceList[i].DoPropertiesDisplayWriteDefault;
  end;
  if CurrentInterface <> nil then begin
    CurrentInterface.Activate;
  end;
end;          

procedure TQUB_MainForm.mnuMainInterfaceFloatingWindowsClick(Sender: TObject);
begin
  mnuMainInterfaceFloatingWindows.Checked := not mnuMainInterfaceFloatingWindows.Checked;
  prSetFloatingWindows;
  if CurrentInterface <> nil then CurrentInterface.Activate;
end;

procedure TQUB_MainForm.mnuMainInterfaceButtonsVisibleClick(Sender: TObject);
begin
  mnuMainInterfaceButtonsVisible.Checked := not mnuMainInterfaceButtonsVisible.Checked;
  panInterfaceSelector.Visible := mnuMainInterfaceButtonsVisible.Checked;
end;

procedure TQUB_MainForm.mnuMainActionsSmallButtonsClick(Sender: TObject);
begin
  SmallButtons          := not SmallButtons;
end;

procedure TQUB_MainForm.mnuMainActionsEditButtonsClick(Sender: TObject);
begin
  frmActionProperties.ShowModal;
end;

procedure TQUB_MainForm.mnuMainActionsRestoreButtonsClick(Sender: TObject);
begin
  prRestoreButtonDefaults;
end;


//Options

//----- Edit Hardware / channels & Setup Wizard
procedure TQUB_MainForm.mnuMainOptionsHardwareListClick(Sender: TObject);
var
  frmHardwareConfigure : TfrmHardwareConfigure;
begin
  frmHardwareConfigure := TfrmHardwareConfigure.Create(Self);
  frmHardwareConfigure.SetVisible(HVM_NORMAL,HDW_PAGE);
  frmHardwareConfigure.ShowModal();
end;

procedure TQUB_MainForm.mnuMainOptionsAcqChannelsClick(Sender: TObject);
var
  frmHardwareConfigure : TfrmHardwareConfigure;
begin
  frmHardwareConfigure := TfrmHardwareConfigure.Create(Self);
  frmHardwareConfigure.SetVisible(HVM_NORMAL,CHN_PAGE);
  frmHardwareConfigure.ShowModal();
end;

procedure TQUB_MainForm.mnuMainOptionsOpenlastDataClick(Sender: TObject);
begin
  TMenuItem(Sender).Checked := not TMenuItem(Sender).Checked;
end;

procedure TQUB_MainForm.mnuMainOptionsOpenlastModelClick(Sender: TObject);
begin
  TMenuItem(Sender).Checked := not TMenuItem(Sender).Checked;
end;

procedure TQUB_MainForm.mnuMainOptionsOpenlastKineticClick(Sender: TObject);
begin
  //TMenuItem(Sender).Checked := not TMenuItem(Sender).Checked;
end;

procedure TQUB_MainForm.mnuMainOptionsNewModelClick(Sender: TObject);
begin
  TMenuItem(Sender).Checked := not TMenuItem(Sender).Checked;
end;

procedure TQUB_MainForm.mnuMainOptionsRememberMRUFilesClick(Sender: TObject);
begin
  prRememberMRUCount := TMenuItem(Sender).Tag;
  mnuMainOptionsRememberMRUFiles10.Checked := prRememberMRUCount = 10;
  mnuMainOptionsRememberMRUFiles50.Checked := prRememberMRUCount = 50;
end;

procedure TQUB_MainForm.mnuMainOptionsAutoSaveWorkspaceClick(Sender: TObject);
begin
  TMenuItem(Sender).Checked := not TMenuItem(Sender).Checked;
end;

procedure TQUB_MainForm.mnuMainOptionsOpenLastWorkspaceClick(Sender: TObject);
begin
  TMenuItem(Sender).Checked := not TMenuItem(Sender).Checked;
end;


//****************************************************************************//
//                                                                            //
//                              H E L P   Commands                            //
//                                                                            //
//****************************************************************************//

//Content
procedure TQUB_MainForm.mnuMainHelpContentClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_FINDER, 0);
end;

//About
procedure TQUB_MainForm.mnuMainHelpAboutClick(Sender: TObject);
begin
  if not QUB_AboutForm.FirstTime then QUB_AboutForm.Show;
end;

//****************************************************************************//
//                                                                            //
//                          right-panel   Commands                            //
//                                                                            //
//****************************************************************************//

//Stop tasks
procedure TQUB_MainForm.btnStopAllTasksClick(Sender: TObject);
begin
  prTaskView.StopAll;

  qubViewportPython.DoInterrupt;
end;

// DataSource
procedure TQUB_MainForm.chkDataSourceClick(Sender: TObject);
begin
  inherited;
  DataSource := TQUB_Task_Data_Source(TRadioButton(Sender).Tag);
end;


//****************************************************************************//
//                                                                            //
//                                 E V E N T S                                //
//                                                                            //
//                        the application responds to                         //
//                                                                            //
//****************************************************************************//

//****************************************************************************//
//                                                                            //
//                      I N T E R F A C E   E V E N T S                       //
//                                                                            //
//****************************************************************************//
procedure TQUB_MainForm.prOnInterfaceActivate(Sender :TObject);
var
  oInterface : TQUB_Interface;
begin
  oInterface := TQUB_Interface(Sender);
  if oInterface.ID >= INTERFACE_USER Then
    Caption := Application.Title + ' - ' + oInterface.InterfaceButton.Hint
  else
    Caption := Application.Title + ' - ' + oInterface.Name;
end;

procedure TQUB_MainForm.prOnInterfaceDeActivate(Sender :TObject);
begin
end;

procedure TQUB_MainForm.prOnButtonsChanged(Sender :TObject);
begin
  if CurrentInterface <> nil then CurrentInterface.Activate;
end;

//****************************************************************************//
//                                                                            //
//                       V I E W P O R T   E V E N T S                        //
//                                                                            //
//****************************************************************************//
procedure TQUB_MainForm.prOnViewportActivate(Sender :TObject);
var
  i :Integer;
begin
  //DeActivate the other viewports
  // Removed -- this is done automatically by the windows Activate/Deactivate mechanism? Chris 2/9/4
  // Restored -- this is required when window is programmatically activated    200403 {JB}
  for i := 0 to qubViewportList.Count - 1 do begin
    if qubViewportList[i] <> Sender then begin
      qubViewportList[i].DeActivate;
    end;
  end;
  
  //Forces a Paint - used to paint the caption bar in the appropriate color
  WorkSpace.Refresh;

end;

procedure TQUB_MainForm.prOnViewportDeActivate(Sender :TObject);
begin
end;


//****************************************************************************//
//                                                                            //
//                  V I E W P O R T    D A T A    E V E N T S                 //
//                                                                            //
//****************************************************************************//
procedure TQUB_MainForm.prOnOpenDataFile(Sender :TObject);
begin

  barStatusBar.Panels[STATUSBAR_PANEL_DATAFILE].Text := TQUB_QVO_QVD(Sender).FileName;
  if TQUB_QVO_QVD(Sender).Modified then begin
    barStatusBar.Panels[STATUSBAR_PANEL_DATAFILE_MODIFIED].Text := 'Modified';
  end else begin
    barStatusBar.Panels[STATUSBAR_PANEL_DATAFILE_MODIFIED].Text := '';
  end;

  if qubViewportData.CurrData   <> nil then qubViewportData.CurrData.CurrModel  := qubViewportModel.CurrModel;
  if qubViewportModel.CurrModel <> nil then qubViewportModel.CurrModel.CurrData := qubViewportData.CurrData;

  prSetMenusOnFile;

end;

procedure TQUB_MainForm.prOnCloseDataFile(Sender :TObject);
begin

  if TQUB_QVO_QVD(Sender).Saved then begin
    prAddMRUItem(mnuMainFileReOpenData, True{First}, TQUB_QVO_QVD(Sender).FileName);
  end;

  if qubViewportData.CurrData   <> nil then qubViewportData.CurrData.CurrModel  := qubViewportModel.CurrModel;
  if qubViewportModel.CurrModel <> nil then qubViewportModel.CurrModel.CurrData := qubViewportData.CurrData;

  prSetMenusOnFile;

end;

procedure TQUB_MainForm.prOnChangeDataFile(Sender :TObject);
begin

  if Sender <> nil then begin
    if TQUB_QVO_QVD(Sender).Saved then begin
      prAddMRUItem(mnuMainFileReOpenData, True{First}, TQUB_QVO_QVD(Sender).FileName);
    end;
  end;

  if Sender <> nil then begin
    barStatusBar.Panels[STATUSBAR_PANEL_DATAFILE].Text := TQUB_QVO_QVD(Sender).FileName;
    if TQUB_QVO_QVD(Sender).Modified then begin
      barStatusBar.Panels[STATUSBAR_PANEL_DATAFILE_MODIFIED].Text := 'Modified';
    end else begin
      barStatusBar.Panels[STATUSBAR_PANEL_DATAFILE_MODIFIED].Text := '';
    end;
  end else begin
    barStatusBar.Panels[STATUSBAR_PANEL_DATAFILE].Text := '';
    barStatusBar.Panels[STATUSBAR_PANEL_DATAFILE_MODIFIED].Text := '';
  end;

  if qubViewportData.CurrData   <> nil then qubViewportData.CurrData.CurrModel  := qubViewportModel.CurrModel;
  if qubViewportModel.CurrModel <> nil then qubViewportModel.CurrModel.CurrData := qubViewportData.CurrData;

  prSetMenusOnFile;

end;


//****************************************************************************//
//                                                                            //
//                 V I E W P O R T    M O D E L    E V E N T S                //
//                                                                            //
//****************************************************************************//
procedure TQUB_MainForm.prOnOpenModelFile(Sender :TObject);
begin

  barStatusBar.Panels[STATUSBAR_PANEL_MODELFILE].Text := TQUB_QVO_QVM(Sender).FileName;
  if TQUB_QVO_QVM(Sender).Modified then begin
    barStatusBar.Panels[STATUSBAR_PANEL_MODELFILE_MODIFIED].Text := 'Modified';
  end else begin
    barStatusBar.Panels[STATUSBAR_PANEL_MODELFILE_MODIFIED].Text := '';
  end;

  if qubViewportData.CurrData   <> nil then qubViewportData.CurrData.CurrModel  := qubViewportModel.CurrModel;
  if qubViewportModel.CurrModel <> nil then qubViewportModel.CurrModel.CurrData := qubViewportData.CurrData;

  prSetMenusOnFile;

end;

procedure TQUB_MainForm.prOnCloseModelFile(Sender :TObject);
begin

  if TQUB_QVO_QVM(Sender).Saved then begin
    prAddMRUItem(mnuMainFileReOpenModel, True{First}, TQUB_QVO_QVM(Sender).FileName);
  end;

  if qubViewportData.CurrData   <> nil then qubViewportData.CurrData.CurrModel  := qubViewportModel.CurrModel;
  if qubViewportModel.CurrModel <> nil then qubViewportModel.CurrModel.CurrData := qubViewportData.CurrData;

  prSetMenusOnFile;

end;

procedure TQUB_MainForm.prOnChangeModelFile(Sender :TObject);
begin

  if Sender <> nil then begin
    if TQUB_QVO_QVM(Sender).Saved then begin
      prAddMRUItem(mnuMainFileReOpenModel, True{First}, TQUB_QVO_QVM(Sender).FileName);
    end;
  end;

  if Sender <> nil then begin
    barStatusBar.Panels[STATUSBAR_PANEL_MODELFILE].Text := TQUB_QVO_QVM(Sender).FileName;
    if TQUB_QVO_QVM(Sender).Modified then begin
      barStatusBar.Panels[STATUSBAR_PANEL_MODELFILE_MODIFIED].Text := 'Modified';
    end else begin
      barStatusBar.Panels[STATUSBAR_PANEL_MODELFILE_MODIFIED].Text := '';
    end;
  end else begin
    barStatusBar.Panels[STATUSBAR_PANEL_MODELFILE].Text := '';
    barStatusBar.Panels[STATUSBAR_PANEL_MODELFILE_MODIFIED].Text := '';
  end;

  if qubViewportData.CurrData   <> nil then qubViewportData.CurrData.CurrModel  := qubViewportModel.CurrModel;
  if qubViewportModel.CurrModel <> nil then qubViewportModel.CurrModel.CurrData := qubViewportData.CurrData;

  prSetMenusOnFile;

end;

//Kinetic
(*
procedure TQUB_MainForm.prOnChangeKineticFile(Sender :TObject);
begin

  if Sender <> nil then begin
    if TKPL_Program(Sender).Saved then begin
      prAddMRUItem(mnuMainFileReOpenKinetic, True{First}, TKPL_Program(Sender).FileName);
    end;
  end;

  prSetMenusOnFile;

end;
*)

//******************************************************************************
procedure TQUB_MainForm.prSetDataSource(x :TQUB_Task_Data_Source);
begin
  prDataSource := x;

  chkDataSourceSel.Checked                  := Integer(x) = chkDataSourceSel.Tag;
  chkDataSourceList.Checked                 := Integer(x) = chkDataSourceList.Tag;
  chkDataSourceFile.Checked                 := Integer(x) = chkDataSourceFile.Tag;
  chkDataSourceFileList.Checked             := Integer(x) = chkDataSourceFileList.Tag;

  mnuMainActionsDataSourceSelection.Checked := Integer(x) = chkDataSourceSel.Tag;
  mnuMainActionsDataSourceList.Checked      := Integer(x) = chkDataSourceList.Tag;
  mnuMainActionsDataSourceFile.Checked      := Integer(x) = chkDataSourceFile.Tag;
  mnuMainActionsDataSourceFileList.Checked  := Integer(x) = chkDataSourceFileList.Tag;
end;

//******************************************************************************
procedure TQUB_MainForm.prSetInterfaceIndex(Index :Integer);
var
  i :Integer;
begin

  if InterfaceIndex = Index then Exit;

  try

    if InterfaceIndex <> INTERFACE_NONE then begin
    //Deactivate the Current Interface, if any

      try
        if CurrentInterface <> nil then CurrentInterface.Deactivate;
      except
      end;

    end;

    if Index <> INTERFACE_NONE then begin

      //Find the interface selector button
      prCurrentInterface := nil;
      for i := 0 to qubInterfaceList.Count - 1 do begin
        if qubInterfaceList[i].ID = Index then begin
          prCurrentInterface := qubInterfaceList[i];
          prCurrentInterface.InterfaceButton.Down := True;
          Break;
        end;
      end;
      try
        if prCurrentInterface <> nil then prCurrentInterface.Activate;
      except
      end;
      prInterfaceIndex := Index;

    end else begin

      prInterfaceIndex   := Index;
      prCurrentInterface := nil;

    end;

  except
    Beep;
  end;

  prSetMenusOnFile;

end;

procedure TQUB_MainForm.prSetSmallButtons(x :Boolean);
var
  i                                     :Integer;
begin
  prSmallButtons                        := x;
  mnuMainActionsSmallButtons.Checked  := x;

  for i := 0 to ActionList.Count - 1 do begin
    ActionList[i].SmallButtons         := x;
  end;
end;

procedure TQUB_MainForm.prRestoreButtonDefaults;
var
  i                                     :Integer;
begin
  for i := 0 to ActionList.Count - 1 do begin
    ActionList[i].RestoreDefaults;
  end;
end;

function TQUB_MainForm.prUpdateProgram :Boolean;
begin
  Result := False;
  ShellExecute(0, 'open', 'http://www.qub.buffalo.edu/win.php', nil, nil, 0);
end;


//Properties
procedure TQUB_MainForm.prPropertiesRegistry(Read :Boolean);
var
  Reg :TRegistry;
  r   :TRect;
  i   :Integer;
  f   :String;
begin

  Reg  := TRegistry.Create;

  try
    with Reg do begin
      if OpenKey('Software\QUB\Main Form', True) then begin

        if Read then begin
          if ValueExists('Bounds') then ReadBinaryData('Bounds', r, SizeOf(r)) else r := Bounds(0, 0, Screen.Width, Screen.Height);
          WindowState := wsNormal;
          BoundsRect  := r;
          prFloatRect := BoundsRect;
          WindowState := TWindowState(ReadRegistryInteger(Reg,'Window State', Integer(wsMaximized)));
          mnuMainInterfaceButtonsVisible.Checked := ReadRegistryBoolean(Reg, 'Buttons visible', BUTTONSVISIBLE_DEFAULT);
          panInterfaceSelector.Visible := mnuMainInterfaceButtonsVisible.Checked;
          mnuMainInterfaceFloatingWindows.Checked := ReadRegistryBoolean(Reg, 'Floating Windows', FLOATINGWINDOWS_DEFAULT);

        end else begin

          WriteBinaryData('Bounds', prFloatRect, SizeOf(prFloatRect));
          WriteInteger('Window State', Integer(WindowState));
          WriteBool('Buttons visible', mnuMainInterfaceButtonsVisible.Checked);
          WriteBool('Floating Windows', mnuMainInterfaceFloatingWindows.Checked);

        end;

        prSetFloatingWindows;

        //All the interactive properties must be here **********************
        //MRUCount
        if Read then begin
          prRememberMRUCount := ReadRegistryInteger(Reg, 'Remember MRU Count', DEF_MRU_COUNT);
          mnuMainOptionsRememberMRUFiles10.Checked := prRememberMRUCount = 10;
          mnuMainOptionsRememberMRUFiles50.Checked := prRememberMRUCount = 50;
        end else begin
          WriteInteger('Remember MRU Count', prRememberMRUCount);
        end;

        //MRU Data
        for i := 0 to prRememberMRUCount - 1 do begin
          if Read then begin
            if ValueExists('MRU Data ' + IntToStr(i)) then begin
              prAddMRUItem(mnuMainFileReOpenData, False{First}, ReadString('MRU Data ' + IntToStr(i)));
            end else begin
              Break;
            end;
          end else begin
            if i > (mnuMainFileReOpenData.Count - 1) then begin
              DeleteKey('MRU Data ' + IntToStr(i));
            end else begin
              WriteString('MRU Data ' + IntToStr(i), mnuMainFileReOpenData.Items[i].Caption);
            end;
          end;
        end;
        //MRU Model
        for i := 0 to prRememberMRUCount - 1 do begin
          if Read then begin
            if ValueExists('MRU Model ' + IntToStr(i)) then begin
              prAddMRUItem(mnuMainFileReOpenModel, False{First}, ReadString('MRU Model ' + IntToStr(i)));
            end else begin
              Break;
            end;
          end else begin
            if i > (mnuMainFileReOpenModel.Count - 1) then begin
              DeleteKey('MRU Model ' + IntToStr(i));
            end else begin
              WriteString('MRU Model ' + IntToStr(i), mnuMainFileReOpenModel.Items[i].Caption);
            end;
          end;
        end;
        //MRU Kinetic
        (*
        for i := 0 to prRememberMRUCount - 1 do begin
          if Read then begin
            if ValueExists('MRU Kinetic ' + IntToStr(i)) then begin
              prAddMRUItem(mnuMainFileReOpenKinetic, False{First}, ReadString('MRU Kinetic ' + IntToStr(i)));
            end else begin
              Break;
            end;
          end else begin
            if i > (mnuMainFileReOpenKinetic.Count - 1) then begin
              DeleteKey('MRU Kinetic ' + IntToStr(i));
            end else begin
              WriteString('MRU Kinetic ' + IntToStr(i), mnuMainFileReOpenKinetic.Items[i].Caption);
            end;
          end;
        end;           *)

        //Ask interfaces to write their Default properties, if necessary
        for i := 0 to qubInterfaceList.Count - 1 do begin
          qubInterfaceList[i].DoPropertiesDisplayCheckDefault;
        end;

        if Read then begin
          if ValueExists('Interface Index') then begin
            InterfaceIndex := ReadInteger('Interface Index');
          end else begin
            InterfaceIndex := INTERFACE_DEFAULT;
          end;
        end else begin
          WriteInteger('Interface Index', InterfaceIndex);
        end;

        //Last opened files
        if Read then begin
          prLastDataFile    := ReadRegistryString( Reg, 'Last Data File', '' );
          prLastModelFile   := ReadRegistryString( Reg, 'Last Model File', '' );
          //prLastKineticFile := ReadRegistryString( Reg, 'Last Kinetic File', '' );
        end else begin
          WriteString('Last Data File',    prLastDataFile);
          WriteString('Last Model File',   prLastModelFile);
          //WriteString('Last Kinetic File', prLastKineticFile);
        end;

        //Workspace
        if Read then begin
          prWorkspaceFile := ReadRegistryString(Reg, 'Workspace File', ExtractFilePath(Application.ExeName) + DEF_WORKSPACEFILE);
        end else begin
          WriteString('Workspace File',    prWorkspaceFile);
        end;

        //Options
        if Read then begin
          mnuMainOptionsOpenlastData.Checked      := ReadRegistryBoolean(Reg, 'Open Last Data', false);
          mnuMainOptionsOpenlastModel.Checked     := ReadRegistryBoolean(Reg, 'Open Last Model', false);
          //mnuMainOptionsOpenlastKinetic.Checked   := ReadRegistryBoolean(Reg, 'Open Last Kinetic Script', false);
          mnuMainOptionsNewModel.Checked          := ReadRegistryBoolean(Reg, 'New Model', true);
          mnuMainOptionsOpenLastWorkspace.Checked := ReadRegistryBoolean(Reg, 'Open Last Workspace', False);
          if not mnuMainOptionsOpenLastWorkspace.Checked then prWorkspaceFile := ExtractFilePath(Application.ExeName) + DEF_WORKSPACEFILE;
          mnuMainOptionsAutoSaveWorkspace.Checked := ReadRegistryBoolean(Reg, 'Auto Save Workspace', False);

          DataSource := TQUB_Task_Data_Source( ReadRegistryInteger(Reg, 'Data Source', Integer(DEF_DATA_SOURCE)));

          SmallButtons := ReadRegistryBoolean(Reg, 'SmallButtons', DEF_SMALL_BUTTONS);
          mnuMainActionsShowButtons.Checked := ReadRegistryBoolean(Reg, 'ActionButtons', True);
          panTaskSelector.Visible := mnuMainActionsShowButtons.Checked;
        end else begin
          WriteBool('Open Last Data',           mnuMainOptionsOpenlastData.Checked);
          WriteBool('Open Last Model',          mnuMainOptionsOpenlastModel.Checked);
          //WriteBool('Open Last Kinetic Script', mnuMainOptionsOpenlastKinetic.Checked);
          WriteBool('New Model',                mnuMainOptionsNewModel.Checked);
          WriteBool('Open Last Workspace',      mnuMainOptionsOpenLastWorkspace.Checked);
          WriteBool('Auto Save Workspace',      mnuMainOptionsAutoSaveWorkspace.Checked);

          WriteInteger('Data Source', Integer(DataSource));

          WriteBool('SmallButtons', SmallButtons);

          WriteBool('ActionButtons', mnuMainActionsShowButtons.Checked);
        end;

        //Date of qubnews.txt
        if Read then begin
          prQUBNewsOldDate := ReadRegistryFloat( Reg,'qubnews Date', 0.0 );
          f := ExtractFilePath(Application.ExeName) + 'qubnews.txt';
          i := FileAge(f);
          if i <> -1 then begin
            prQUBNewsNewDate := FileDateToDateTime(i);
          end else begin
            prQUBNewsNewDate := 0;
          end;
          if prQUBNewsOldDate <> prQUBNewsNewDate then begin
            WinExec(PChar(Format('%s %s', ['notepad.exe', ExtractFilePath(Application.ExeName) + 'qubnews.txt'])), SW_SHOW);
          end;
        end else begin
          WriteFloat('qubnews Date', prQUBNewsNewDate);
        end;


      end;
      CloseKey;

      //Register extensions
      //Now done by the installer
      {
      Apparently, not done properly. LM.
      }
      {
      Keep some code as a reference. LM

      disable because it screws up windows vista
      if not Read then begin
        //QDF
        RootKey := HKEY_CLASSES_ROOT;
        if OpenKey('.qdf', True) then begin
          WriteString('', 'QuB.QDFFile');
        end;
        //QMF
        RootKey := HKEY_CLASSES_ROOT;
        if OpenKey('.qmf', True) then begin
          WriteString('', 'QuB.QMFFile');
        end;
        //KIN
        RootKey := HKEY_CLASSES_ROOT;
        if OpenKey('.kin', True) then begin
          WriteString('', 'QuB.KINFile');
        end;
        CloseKey;
        //QDF
        RootKey := HKEY_CLASSES_ROOT;
        if OpenKey('QuB.QDFFile', True) then begin
          WriteString('', 'QuB QDF File');
          if OpenKey('shell', True) then begin
            WriteString('', 'open');
            if OpenKey('open', True) then begin
              if OpenKey('command', True) then begin
                WriteString('', Application.ExeName + ' -od "%1"');
              end;
            end;
          end;
        end;
        CloseKey;
        //QMF
        RootKey := HKEY_CLASSES_ROOT;
        if OpenKey('QuB.QMFFile', True) then begin
          WriteString('', 'QuB QMF File');
          if OpenKey('shell', True) then begin
            WriteString('', 'open');
            if OpenKey('open', True) then begin
              if OpenKey('command', True) then begin
                WriteString('', Application.ExeName + ' -om "%1"');
              end;
            end;
          end;
        end;
        CloseKey;
        //KIN
        RootKey := HKEY_CLASSES_ROOT;
        if OpenKey('QuB.KINFile', True) then begin
          WriteString('', 'QuB Kinetic File');
          if OpenKey('shell', True) then begin
            WriteString('', 'open');
            if OpenKey('open', True) then begin
              if OpenKey('command', True) then begin
                WriteString('', Application.ExeName + ' -ok "%1"');
              end;
            end;
          end;
        end;
        CloseKey;
      end;
      }

      //Console
      // this should screw up vista/7 but they "virtualize" our access to program folder.
      try
        Console.PlainText := False;
        if Read then begin
          Console.Lines.LoadFromFile(ExtractFilePath(Application.ExeName) + 'console.txt');
        end else begin
          DeleteFile(ExtractFilePath(Application.ExeName) + 'console.txt');
          Console.Lines.SaveToFile(ExtractFilePath(Application.ExeName) + 'console.txt');
        end;
      except
      end;


    end;

  finally

    Reg.Free;

  end;
end;


//Public Methods ***************************************************************
procedure TQUB_MainForm.ViewsOnTop;
var
  i :Integer;
begin
  for i := 0 to qubViewportList.Count - 1 do begin
    if qubViewportList[i].FormStyle <> fsStayOnTop then qubViewportList[i].FormStyle := fsStayOnTop;
  end;
end;


//Protected Methods ************************************************************


//****************************************************************************//
//                                                                            //
//                                  V I E W S                                 //
//                                                                            //
//****************************************************************************//
procedure TQUB_MainForm.CreateViews;
begin
  //Task
  prTaskView                             := TQUB_TaskViewForm.Create(Self);
  TaskView                               := prTaskView;
  //Server
  //prServerView                           := TQUB_ServerViewForm.Create(Self);
  //Edit Buttons
  frmActionProperties                    := TfrmActionProperties.Create(Self);
end;


//****************************************************************************//
//                                                                            //
//                                  L I S T S                                 //
//                                                                            //
//****************************************************************************//
procedure TQUB_MainForm.CreateLists;
begin
  //Interfaces
  qubInterfaceList                       := TQUB_Interface_List.Create;
  //Viewports
  qubViewportList                        := TQUB_Viewport_List.Create;
  //ActionSelectors
  qubActionsList                         := TQUB_ActionSelector_List.Create;
end;


//****************************************************************************//
//                                                                            //
//                              V I E W P O R T S                             //
//                                                                            //
//****************************************************************************//
procedure TQUB_MainForm.CreateViewports;
begin

  //Python Scripts - created first so other viewports can extend the language
  qubViewportPython                      := TQUB_Viewport_Python.CreateName(Self, 'Python Scripts');
  qubViewportList.AddViewport(qubViewportPython);

  //Data
  qubViewportData                        := TQUB_Viewport_Data.CreateName(Self, 'Data');
  qubViewportList.AddViewport(qubViewportData);

  qubViewportDataComment                 := TQUB_Viewport_DataComment.CreateName(Self, 'Data Notes');
  qubViewportList.AddViewport(qubViewportDataComment);

  qubViewportDataOverlap                 := TQUB_Viewport_DataOverlap.CreateName(Self, 'Data Overlap');
  qubViewportList.AddViewport(qubViewportDataOverlap);

  //Model
  qubViewportModel                       := TQUB_Viewport_Model.CreateName(Self, 'Model');
  qubViewportList.AddViewport(qubViewportModel);

  //Acquisition Input
  qubViewportAcqInput                    := TQUB_Viewport_AcquisitionInput.CreateName(Self, 'Acquisition Input');
  qubViewportList.AddViewport(qubViewportAcqInput);

  //Acquisition SShot
  qubViewportAcqSShot                    := TQUB_Viewport_AcquisitionSShot.CreateName(Self, 'Acquisition SShot');
  qubViewportList.AddViewport(qubViewportAcqSShot);

  //Acquisition Output
  qubViewportAcqOutput                   := TQUB_Viewport_AcquisitionOutput.CreateName(Self, 'Acquisition Output');
  qubViewportList.AddViewport(qubViewportAcqOutput);

  //Acquisition Notes
  qubViewportAcqNotes                    := TQUB_Viewport_AcquisitionNotes.CreateName(Self, 'Acquisition Notes');
  qubViewportList.AddViewport(qubViewportAcqNotes);

  //Acquisition Protocol
  qubViewportProtocol                    := TQUB_Viewport_Protocol.CreateName(Self, 'Acquisition Protocol');
  qubViewportList.AddViewport(qubViewportProtocol);

  //Histogram
  qubViewportHistogram                   := TQUB_Viewport_Histogram.CreateName(Self, 'Histogram');
  qubViewportList.AddViewport(qubViewportHistogram);

  //Results
  qubViewportResults                     := TQUB_Viewport_Results.CreateName(Self, 'Results');
  qubViewportList.AddViewport(qubViewportResults);

  //Report
  qubViewportReport                      := TQUB_Viewport_Report.CreateName(Self, 'Report');
  qubViewportList.AddViewport(qubViewportReport);

  //Graph
  //qubViewportGraph                       := TQUB_Viewport_Graph.CreateName(Self, 'Graph');
  //qubViewportList.AddViewport(qubViewportGraph);

  //TriggerGraph
  //qubViewportTriggerGraph                := TQUB_Viewport_TriggerGraph.CreateName(Self, 'Trigger Graph');
  //qubViewportList.AddViewport(qubViewportTriggerGraph);

  //Chart
  //qubViewportChart                       := TQUB_Viewport_Chart.CreateName(Self, 'Chart');
  //qubViewportList.AddViewport(qubViewportChart);

  //GlobalFitting
  //qubViewportGlobalFitting               := TQUB_Viewport_GlobalFitting.CreateName(Self, 'Global Fitting');
  //qubViewportList.AddViewport(qubViewportGlobalFitting);

  //Scripts
  //qubViewportScripts                     := TQUB_Viewport_Scripts.CreateName(Self, 'Scripts');
  //qubViewportList.AddViewport(qubViewportScripts);

    //Scriptlets
  //qubViewportScriptlets                  := TQUB_Viewport_Scriptlets.CreateName(Self, 'Scriptlets');
  //qubViewportList.AddViewport(qubViewportScriptlets);

end;


//****************************************************************************//
//                                                                            //
//                             I N T E R F A C E S                            //
//                                                                            //
//****************************************************************************//
procedure TQUB_MainForm.CreateInterfaces;
var
  btnUser            :TSpeedButton;
  iBtn               :Integer;
  iUserInterfaces    :Integer;
  cBtnText, cBtnName :String;
begin
  prInterfaceIndex := INTERFACE_NONE;
  qubInterfaceList.AddInterface( TQUB_Interface.Create('Acquisition', INTERFACE_ACQUISITION,    btnInterfaceAcq));
  qubInterfaceList.AddInterface( TQUB_Interface.Create('Modeling',    INTERFACE_MODELING,       btnInterfaceMod));
  qubInterfaceList.AddInterface( TQUB_Interface.Create('Simulation',  INTERFACE_SIMULATION,     btnInterfaceSim));
  qubInterfaceList.AddInterface( TQUB_Interface.Create('Preprocessing',INTERFACE_PREPROCESSING, btnInterfacePre));
  qubInterfaceList.AddInterface( TQUB_Interface.Create('Macroscopic', INTERFACE_MACROSCOPIC,    btnInterfaceMac));
  qubInterfaceList.AddInterface( TQUB_Interface.Create('Results',     INTERFACE_RESULTS,        btnInterfaceRes));
  qubInterfaceList.AddInterface( TQUB_Interface.Create('Scripts',     INTERFACE_SCRIPTS,        btnInterfaceScr));

  //----- Additional interfaces - 8 buttons are created, but only the in use ones are visible
  iUserInterfaces := UserInterfaceCountReadRegistry();
  for iBtn := 0 to INTERFACE_COUNTUSER-1 do begin
    //-- Get text
    UserInterfaceReadRegistry( iBtn, cBtnText, cBtnName );
    //-- create button
    btnUser := TSpeedButton.Create(panInterfaceSelector);
    btnUser.Left := 4;
    btnUser.Top := btnInterfaceScr.Top + 68 + 24 * iBtn;   // offset from last fixed interface
    btnUser.Height := 22;
    btnUser.Width := 41;
    btnUser.Flat := True;
    btnUser.ShowHint := True;
    btnUser.Down := True;
    btnUser.Tag := INTERFACE_USER+iBtn;
    btnUser.OnClick := mnuMainInterfaceSelectClick;
    btnUser.Down := True;
    btnUser.GroupIndex := 1;
    btnUser.Caption := cBtnText;
    btnUser.Hint := cBtnName;
    btnUser.Visible := (iBtn<iUserInterfaces);
    //-- add to panel
    panInterfaceSelector.InsertControl(btnUser);
    //-- add corresponding interace object
    qubInterfaceList.AddInterface( TQUB_Interface.Create('User'+IntToStr(iBtn), INTERFACE_USER+iBtn, btnUser));
  end;

end;

//---- Form to modify names for up to 8 additional user interfaces
procedure TQUB_MainForm.mnuMainInterfaceAdditionalInterfacesClick(Sender: TObject);
var
  frmUserInterfaceProperties: TUserInterfaceProperties;
begin
  frmUserInterfaceProperties := TUserInterfaceProperties.Create(Self);
  frmUserInterfaceProperties.ShowModal();
  frmUserInterfaceProperties.Free();
end;


//****************************************************************************//
//                                                                            //
//                               A C T I O N S                                //
//                                                                            //
//****************************************************************************//
procedure TQUB_MainForm.CreateActions;
begin
  qubActionsList.AddActionSelector( TQUB_ActionSelector_Acquisition.Create(Self), panActions );

  qubActionsSim          := TQUB_ActionSelector_Simulation.Create(Self);
  qubActionsList.AddActionSelector( qubActionsSim, panActions );

  qubActionsMod          := TQUB_ActionSelector_Modeling.Create(Self);
  qubActionsList.AddActionSelector( qubActionsMod, panActions );

  qubActionsList.AddActionSelector( TQUB_ActionSelector_Preprocessing.Create(Self), panActions );

  qubActionsList.AddActionSelector( TQUB_ActionSelector_Lists.Create(Self), panActions );

  qubActionsList.AddActionSelector( TQUB_ActionSelector_Sound.Create(Self), panActions );

  qubActionsList.AddActionSelector( TQUB_ActionSelector.CreateNamed(Self, 'Scripts'), panActions );

end;


//****************************************************************************//
//                                                                            //
//                                 L I N K S                                  //
//                                                                            //
//****************************************************************************//
procedure TQUB_MainForm.CreateLinks;
var
  Item :TMenuItem;
  i    :Integer;
begin

  //Data shortcuts
  qubViewportData.Shortcuts.Parent  := panTop;
  qubViewportData.Shortcuts.Top     := panFile.Top;
  qubViewportData.Shortcuts.Left    := panFile.Left + panFile.ClientWidth;// + 10;

  //Who wants to know what ViewportData does: ..................................
  //Main
  qubViewportData.Events.AddEvent('OnOpenFile',     prOnOpenDataFile);
  qubViewportData.Events.AddEvent('OnCloseFile',    prOnCloseDataFile);
  qubViewportData.Events.AddEvent('OnChangeFile',   prOnChangeDataFile);
  //DataComment
  qubViewportData.Events.AddEvent('OnChangeFile',   qubViewportDataComment.DoOnChangeData);
  qubViewportData.Events.AddEvent('OnClosingFile',  qubViewportDataComment.DoOnClosingData);
  //DataOverlap
  qubViewportData.Events.AddEvent('OnChangeFile',   qubViewportDataOverlap.DoOnChangeData);
  qubViewportData.Events.AddEvent('OnClosingFile',  qubViewportDataOverlap.DoOnClosingData);
  qubViewportData.Events.AddEvent('OnOpenFile',     qubViewportDataOverlap.FileView.OnOpenData);
  qubViewportData.Events.AddEvent('OnClosingFile',  qubViewportDataOverlap.FileView.OnClosingData);
  qubViewportData.Events.AddEvent('OnChangeFile',   qubViewportDataOverlap.FileView.OnChangeData);
  //AcqNotes
  qubViewportData.Events.AddEvent('OnChangeFile',   qubViewportAcqNotes.DoOnChangeData);
  qubViewportData.Events.AddEvent('OnClosingFile',  qubViewportAcqNotes.DoOnClosingData);
  //AcqInput
  qubViewportData.Events.AddEvent('OnCloseFile',    qubViewportAcqInput.DoOnCloseData);
  //AcqOutput
  qubViewportData.Events.AddEvent('OnCloseFile',    qubViewportAcqOutput.DoOnCloseData);
  //ActionsSim
  qubViewportData.Events.AddEvent('OnCloseFile',    qubActionsSim.DoOnCloseData);
  //Histogram
  qubViewportData.Events.AddEvent('OnChangeFile',   qubViewportHistogram.DoOnChangeData);
  qubViewportData.Events.AddEvent('OnCloseFile',    qubViewportHistogram.DoOnCloseData);
  //Model
  qubViewportData.Events.AddEvent('OnChangeFile',   qubViewportModel.DoOnChangeData);
  qubViewportData.Events.AddEvent('OnClosingFile',  qubViewportModel.DoOnClosingData);

  //Chart
  //...

  //GlobalFitting
  //qubViewportGlobalFitting.TriggerGraph := qubViewportTriggerGraph.TriggerGraph;
  //qubViewportScripts.Events.AddEvent('OnStartRun',   qubViewportGlobalFitting.DoOnStartKinetic);
  //qubViewportScripts.Events.AddEvent('OnSuspendRun', qubViewportGlobalFitting.DoOnSuspendKinetic);
  //qubViewportScripts.Events.AddEvent('OnResumeRun',  qubViewportGlobalFitting.DoOnResumeKinetic);
  //qubViewportScripts.Events.AddEvent('OnEndRun',     qubViewportGlobalFitting.DoOnEndKinetic);

  //ViewportScriptlets
  //qubViewportScripts.Events.AddEvent('OnStartCompile', qubViewportScriptlets.DoOnStartCompileKinetic);
  //qubViewportScripts.Events.AddEvent('OnEndCompile',   qubViewportScriptlets.DoOnEndCompileKinetic);
  //qubViewportScripts.Events.AddEvent('OnStartRun',     qubViewportScriptlets.DoOnStartRunKinetic);
  //qubViewportScripts.Events.AddEvent('OnSuspendRun',   qubViewportScriptlets.DoOnSuspendRunKinetic);
  //qubViewportScripts.Events.AddEvent('OnResumeRun',    qubViewportScriptlets.DoOnResumeRunKinetic);
  //qubViewportScripts.Events.AddEvent('OnEndRun',       qubViewportScriptlets.DoOnEndRunKinetic);
  //qubViewportScripts.Events.AddEvent('OnChangeFile',   qubViewportScriptlets.DoOnChangeKineticFile);

  //Who wants to know what ViewportModel does: .................................
  //Main
  qubViewportModel.Events.AddEvent('OnOpenFile',    prOnOpenModelFile);
  qubViewportModel.Events.AddEvent('OnCloseFile',   prOnCloseModelFile);
  qubViewportModel.Events.AddEvent('OnChangeFile',  prOnChangeModelFile);

  //Who wants to know what ViewportScripts does: .................................
  //Main
  //qubViewportScripts.Events.AddEvent('OnChangeFile',    prOnChangeKineticFile);


  //Viewport common properties
  for i := 0 to qubViewportList.Count - 1 do begin
    qubViewportList[i].Events.AddEvent('OnActivate',   prOnViewportActivate);
    qubViewportList[i].Events.AddEvent('OnDeActivate', prOnViewportDeActivate);
  end;

  //ActionSelector common properties
  //for i := 0 to qubActionsList.Count - 1 do begin
  //  qubActionsList[i].Servers            := prServerView;
  //end;

  //Console
  prConsole                              := qubViewportReport.Console;
  //GraphConsole
  //prGraphConsole                         := qubViewportGraph.Graphic;

  //Interface common properties
  for i := 0 to qubInterfaceList.Count - 1 do begin
    qubInterfaceList[i].Events.AddEvent('OnActivate',   prOnInterfaceActivate);
    qubInterfaceList[i].Events.AddEvent('OnDeActivate', prOnInterfaceDeActivate);
    qubInterfaceList[i].ViewportList := qubViewportList;
    qubInterfaceList[i].Workspace    := Workspace;
  end;

  //Other Specific Properties
  //prHardwareView.AcquisitionInput   := qubViewportAcqInput.AcquisitionInput;
  //prHardwareView.AcquisitionOutput  := qubViewportAcqOutput.AcquisitionOutput;

  //qubViewportScripts.AcqInput      := qubViewportAcqInput.AcquisitionInput;
  //qubViewportScripts.AcqOutput     := qubViewportAcqOutput.AcquisitionOutput;

  //AcqInput Data events
  qubViewportAcqInput.AcquisitionInput.OnDataNew      := mnuMainFileNewInputAcquisitionDataClick;
  qubViewportAcqInput.AcquisitionInput.OnDataOpen     := mnuMainFileOpenInputAcquisitionDataClick;
  qubViewportAcqInput.AcquisitionInput.OnDataAssign   := mnuMainFileAssignInputAcquisitionDataClick;
  qubViewportAcqOutput.AcquisitionOutput.OnDataNew    := mnuMainFileNewOutputAcquisitionDataClick;
  qubViewportAcqOutput.AcquisitionOutput.OnDataOpen   := mnuMainFileOpenOutputAcquisitionDataClick;
  qubViewportAcqOutput.AcquisitionOutput.OnDataAssign := mnuMainFileAssignOutputAcquisitionDataClick;

  //Create View Viewport menus
  Item := nil;
  for i := 0 to qubViewportList.Count - 1 do begin
    Item             := TMenuItem.Create(Self);
    Item.Tag         := i;
    Item.Caption     := qubViewportList[i].Name;
    Item.OnClick     := mnuMainViewViewportClick;
    mnuMainView.Insert(i, Item);
  end;
  if Item <> nil then mnuMainView.InsertNewLineAfter(Item);

  {*
  //Load Task Selectors
  h := 0;
  for i := 0 to qubInterfaceList.Count - 1 do begin
    if qubInterfaceList[i].TaskSelector <> nil then begin
      if qubInterfaceList[i].TaskSelector.ControlCount > 1 then begin
        qubInterfaceList[i].TaskSelector.Parent := panTaskSelector;
        h := h + qubInterfaceList[i].TaskSelector.Top + qubInterfaceList[i].TaskSelector.Height;
      end;
    end;
  end;
  for i := 0 to qubViewportList.Count - 1 do begin
    if qubViewportList[i].TaskSelector <> nil then begin
      if qubViewportList[i].TaskSelector.ControlCount > 1 then begin
        qubViewportList[i].TaskSelector.Parent := panTaskSelector;
        h := h + qubViewportList[i].TaskSelector.Top + qubViewportList[i].TaskSelector.Height;
      end;
    end;
  end;

  // layout of task percent and stop
  progTasks.SetBounds(0, h + 10, panTaskSelector.ClientWidth, progTasks.Height);
  btnStopAllTasks.SetBounds(0, h + 10 + progTasks.Height, panTaskSelector.ClientWidth, btnStopAllTasks.Height);
  *}

  prTaskView.OnGlobalPctChange := prOnGlobalPctChange;
  prTaskView.OnTaskCountChange := prOnTaskCountChange;

end;

procedure TQUB_MainForm.DestroyLinks;
var
  i :Integer;
begin

  //Who wanted to know what ViewportData did:
  //Main
  qubViewportData.Events.DelEvent('OnOpenFile',     prOnOpenDataFile);
  qubViewportData.Events.DelEvent('OnCloseFile',    prOnCloseDataFile);
  qubViewportData.Events.DelEvent('OnChangeFile',   prOnChangeDataFile);
  //DataComment
  qubViewportData.Events.DelEvent('OnChangeFile',   qubViewportDataComment.DoOnChangeData);
  qubViewportData.Events.DelEvent('OnClosingFile',  qubViewportDataComment.DoOnClosingData);
  //DataOverlap
  qubViewportData.Events.DelEvent('OnChangeFile',   qubViewportDataOverlap.DoOnChangeData);
  qubViewportData.Events.DelEvent('OnClosingFile',  qubViewportDataOverlap.DoOnClosingData);
  qubViewportData.Events.DelEvent('OnOpenFile',     qubViewportDataOverlap.FileView.OnOpenData);
  qubViewportData.Events.DelEvent('OnClosingFile',  qubViewportDataOverlap.FileView.OnClosingData);
  qubViewportData.Events.DelEvent('OnChangeFile',   qubViewportDataOverlap.FileView.OnChangeData);
  //AcqNotes
  qubViewportData.Events.DelEvent('OnChangeFile',   qubViewportAcqNotes.DoOnChangeData);
  qubViewportData.Events.DelEvent('OnClosingFile',  qubViewportAcqNotes.DoOnClosingData);
  //AcqInput
  qubViewportData.Events.DelEvent('OnCloseFile',    qubViewportAcqInput.DoOnCloseData);
  //AcqOutput
  qubViewportData.Events.DelEvent('OnCloseFile',    qubViewportAcqOutput.DoOnCloseData);
  //ActionsSim
  qubViewportData.Events.DelEvent('OnCloseFile',    qubActionsSim.DoOnCloseData);
  //Histogram
  qubViewportData.Events.DelEvent('OnChangeFile',   qubViewportHistogram.DoOnChangeData);
  qubViewportData.Events.DelEvent('OnCloseFile',    qubViewportHistogram.DoOnCloseData);
  //Model
  qubViewportData.Events.DelEvent('OnChangeFile',   qubViewportModel.DoOnChangeData);
  qubViewportData.Events.DelEvent('OnClosingFile',  qubViewportModel.DoOnClosingData);

  //Chart
  //...

  //GlobalFitting
  //qubViewportGlobalFitting.TriggerGraph := nil;
  //qubViewportScripts.Events.DelEvent('OnStartRun',   qubViewportGlobalFitting.DoOnStartKinetic);
  //qubViewportScripts.Events.DelEvent('OnSuspendRun', qubViewportGlobalFitting.DoOnSuspendKinetic);
  //qubViewportScripts.Events.DelEvent('OnResumeRun',  qubViewportGlobalFitting.DoOnResumeKinetic);
  //qubViewportScripts.Events.DelEvent('OnEndRun',     qubViewportGlobalFitting.DoOnEndKinetic);

  //ViewportScriptlets
  //qubViewportScripts.Events.DelEvent('OnStartCompile', qubViewportScriptlets.DoOnStartCompileKinetic);
  //qubViewportScripts.Events.DelEvent('OnEndCompile',   qubViewportScriptlets.DoOnEndCompileKinetic);
  //qubViewportScripts.Events.DelEvent('OnStartRun',     qubViewportScriptlets.DoOnStartRunKinetic);
  //qubViewportScripts.Events.DelEvent('OnSuspendRun',   qubViewportScriptlets.DoOnSuspendRunKinetic);
  //qubViewportScripts.Events.DelEvent('OnResumeRun',    qubViewportScriptlets.DoOnResumeRunKinetic);
  //qubViewportScripts.Events.DelEvent('OnEndRun',       qubViewportScriptlets.DoOnEndRunKinetic);
  //qubViewportScripts.Events.DelEvent('OnChangeFile',   qubViewportScriptlets.DoOnChangeKineticFile);

  //Who wanted to know what ViewportModel did: .................................
  //Main
  qubViewportModel.Events.DelEvent('OnOpenFile',   prOnOpenModelFile);
  qubViewportModel.Events.DelEvent('OnCloseFile',  prOnCloseModelFile);
  qubViewportModel.Events.DelEvent('OnChangeFile', prOnChangeModelFile);

  //Who wanted to know what ViewportScripts does: ..............................
  //Main
  //qubViewportScripts.Events.DelEvent('OnChangeFile',    prOnChangeKineticFile);


  //qubViewportScripts.AcqInput      := nil;
  //qubViewportScripts.AcqOutput     := nil;

  //Viewport common properties
  for i := 0 to qubViewportList.Count - 1 do begin
    qubViewportList[i].Events.DelEvent('OnActivate',   prOnViewportActivate);
    qubViewportList[i].Events.DelEvent('OnDeActivate', prOnViewportDeActivate);
  end;

  //Interface common properties
  for i := 0 to qubInterfaceList.Count - 1 do begin
    qubInterfaceList[i].Events.DelEvent('OnActivate',   prOnInterfaceActivate);
    qubInterfaceList[i].Events.DelEvent('OnDeActivate', prOnInterfaceDeActivate);
  end;

  for i := 0 to qubInterfaceList.Count - 1 do begin
    qubInterfaceList[i].ViewportList := nil;
  end;

  prTaskView.OnTaskCountChange := nil;

end;

procedure TQUB_MainForm.OnChangeHardware(Sender:TObject);
begin
  qubViewportAcqSShot.DoOnChangeHardware(Sender);
  qubViewportAcqInput.DoOnChangeHardware(Sender);
  qubViewportAcqOutput.DoOnChangeHardware(Sender);
  qubViewportAcqInput.AcquisitionInput.DoOnChangeHardware(Sender);
  qubViewportAcqOutput.AcquisitionOutput.DoOnChangeHardware(Sender);
end;

procedure TQUB_MainForm.OnChangeChannels(Sender:TObject);
begin
  qubViewportAcqSShot.DoOnChangeChannels(Sender);
  qubViewportAcqInput.DoOnChangeChannels(Sender);
  qubViewportAcqOutput.DoOnChangeChannels(Sender);
  qubViewportAcqInput.AcquisitionInput.DoOnChangeChannels(Sender);
  qubViewportAcqOutput.AcquisitionOutput.DoOnChangeChannels(Sender);
end;


//Workspace
function TQUB_MainForm.SaveWorkspaceAs(const FileName :String) :Boolean;
var
  Dlg      :TSaveDialog;
  f        :String;
begin

  //Process FileName
  f := FileName;
  if f = '' then f := prWorkspaceFile;

  Dlg := nil;

  try

    Dlg := TSaveDialog.Create(Application);
    Dlg.Filter := 'QUB workspace files (*.qwf)|*.qwf|' +
                  'All files (*.*)|*.*';

    Dlg.Options := [ofPathMustExist, ofOverwritePrompt, ofEnableSizing];
    Dlg.Title := 'Save workspace file as';
    Dlg.FileName := ChangeFileExt(f, '');
    if Dlg.Execute then begin
      f := Dlg.FileName;
      f := ChangeFileExt(f, '.qwf');
    end else begin
      Result := True;
      Exit;
    end;

    Result := SaveWorkSpace(f);

  finally

    Dlg.Free;

  end;

end;

function TQUB_MainForm.SaveWorkspace(const FileName :String) :Boolean;
var
  PNode :INode;
  Node  :INode;
  CNode :INode;
  i, j  :Integer;
begin

  Result := False;

  prWorkspaceSession := TNode.Create('QuB Workspace');

  //prSaveWorkspaceMain(prWorkspaceSession);
  PNode := TNode.CreateParented('MainWindow', prWorkspaceSession);

  //prSaveWorkspaceInterfaces(prWorkspaceSession);
  PNode := TNode.CreateParented('Interfaces', prWorkspaceSession);
  for i := 0 to InterfaceList.Count - 1 do begin
    Node := TNode.CreateParented(InterfaceList[i].Name, PNode);
  end;

  //prSaveWorkspaceViewports(prWorkspaceSession);
  PNode := TNode.CreateParented('Viewports', prWorkspaceSession);
  for i := 0 to ViewportList.Count - 1 do begin
    Node := TNode.CreateParented(ViewportList[i].Name, PNode);
    //In the future, pass this to Viewport

    //ViewportData
    if ViewportList[i] = ViewportData then begin
      for j := 0 to ViewportData.ListObjects.Items.Count - 1 do begin
        if ViewportData.ListObjects[j].Saved then begin
          CNode := TNode.CreateParented(ViewportData.ListObjects[j].FileName, Node);
        end;
      end;

    //ViewportModel
    end else if ViewportList[i] = ViewportModel then begin
      for j := 0 to ViewportModel.ListObjects.Items.Count - 1 do begin
        if ViewportModel.ListObjects[j].Saved then begin
          CNode := TNode.CreateParented(ViewportModel.ListObjects[j].FileName, Node);
        end;
      end;

    //ViewportScripts
    //end else if ViewportList[i] = ViewportScripts then begin
    //  if ViewportScripts.Script.Saved then begin
    //    CNode := TNode.CreateParented(ViewportScripts.Script.FileName, Node);
    //  end;
    end;
  end;

  //prSaveWorkspaceActions(prWorkspaceSession);
  PNode := TNode.CreateParented('Actions', prWorkspaceSession);
  for i := 0 to ActionList.Count - 1 do begin
    Node := TNode.CreateParented(ActionList[i].Name, PNode);
  end;

  //Anything else?

  prWorkspaceSession.SaveAsText(FileName);

  prWorkspaceFile := FileName;

end;

function TQUB_MainForm.LoadWorkspace(const FileName :String; Silent :Boolean) :Boolean;
var
  PNode :INode;
  Node  :INode;
  CNode :INode;
  Dlg   :TOpenDialog;
  i     :Integer;
  f     :String;
begin

  Result := False;

  //Process FileName
  f := FileName;
  if f = '' then f := prWorkspaceFile;

  f := ChangeFileExt(f, '.qwf');

  if not Silent then begin

    Dlg := TOpenDialog.Create(Application);
    Dlg.DefaultExt := 'qwf';
    Dlg.Filter := 'QUB workspace files (*.qwf)|*.qwf|All files (*.*)|*.*';
    Dlg.Options := [ofPathMustExist, ofFileMustExist, ofEnableSizing];
    Dlg.Title := 'Load workspace file';

    try

      Dlg.FileName := ChangeFileExt(f, '');
      if Dlg.Execute then begin
        f := ChangeFileExt(Dlg.FileName, '.qwf');
      end else begin
        Result := True;
        Exit;
      end;

    finally

      Dlg.Free;

    end;

  end;//not Silent


  try


    prWorkspaceSession := TNode.CreateFromText(f);

    //prLoadWorkspaceMainWindow
    PNode := prWorkspaceSession.Find('MainWindow');

    //prLoadWorkspaceInterfaces(prWorkspaceSession);
    PNode := prWorkspaceSession.Find('Interfaces');

    //prLoadWorkspaceViewports(prWorkspaceSession);
    PNode := prWorkspaceSession.Find('Viewports');
    for i := 0 to ViewportList.Count - 1 do begin
      Node := PNode.Find(ViewportList[i].Name);
      //In the future, pass this to Viewport

      //ViewportData
      if ViewportList[i] = ViewportData then begin
        ViewportData.CloseAll;
        CNode := Node.Child;
        while not CNode.IsNull do begin
          ViewportData.Open(CNode.Name, True{Silent});
          CNode := CNode.Sibling;
        end;

      //ViewportModel
      end else if ViewportList[i] = ViewportModel then begin
        ViewportModel.CloseAll;
        CNode := Node.Child;
        while not CNode.IsNull do begin
          ViewportModel.Open(CNode.Name, True{Silent});
          CNode := CNode.Sibling;
        end;

      //ViewportScripts
      //end else if ViewportList[i] = ViewportScripts then begin
      //  CNode := Node.Child;
      //  if not CNode.IsNull then begin
      //    ViewportScripts.Script.Open(CNode.Name, True{Silent});
      //  end;

      end;
    end;

    //prLoadWorkspaceActions(prWorkspaceSession);
    PNode := prWorkspaceSession.Find('Actions');

    //Anything else?

  finally

    prWorkspaceSession.Close;

  end;

  if not Result then begin
    prWorkspaceFile := f;
  end;

end;


//******************************************************************************
procedure TQUB_MainForm.prSetFloatingWindows;
var
  i :Integer;
begin
  for i := 0 to qubInterfaceList.Count - 1 do begin
    qubInterfaceList[i].Floating := mnuMainInterfaceFloatingWindows.Checked;
  end;
end;

procedure TQUB_MainForm.prClearEmptyMRUs;
var
  i :Integer;
begin
  for i := mnuMainFileReOpenData.Count - 1 downto 0 do begin
    if mnuMainFileReOpenData.Items[i].Caption = '' then mnuMainFileReOpenData.Items[i].Free;
  end;
  for i := mnuMainFileReOpenModel.Count - 1 downto 0 do begin
    if mnuMainFileReOpenModel.Items[i].Caption = '' then mnuMainFileReOpenModel.Items[i].Free;
  end;
  //for i := mnuMainFileReOpenKinetic.Count - 1 downto 0 do begin
  //  if mnuMainFileReOpenKinetic.Items[i].Caption = '' then mnuMainFileReOpenKinetic.Items[i].Free;
  //end;
end;

procedure TQUB_MainForm.prClearTemp;
var
  f  :String;
  sr :TSearchRec;
begin
  try
    // 1/2005 JTB - Delete everything in <current>\Temp folder  - this is not
    // very safe - what if user installs to root or such. Changed to only
    // clear temp folder if running in c:\Program Files\Qub
    {
      Not to worry about this. In any case, deleting all in Temp is harmless, 
      even in root or so. Not everyone will install in Program Files. 
      L.M.
    }
    f := ExtractFilePath(Application.ExeName) + 'Temp\';
    //if UpperCase(Copy(f,0,21))='C:\PROGRAM FILES\QUB\' Then Begin
    if FindFirst(f + '*.*', faReadOnly + faArchive, sr) = 0 then begin
      try DeleteFile(f + sr.Name); except end;
      while FindNext(sr) = 0 do begin
        try DeleteFile(f + sr.Name); except end;
      end;
      FindClose(sr);
    end;
    //end;
  except
  end;
end;

//todo: LM.
procedure TQUB_MainForm.prCheckTemp;
begin
  try
    {
      Check for files that might indicate a crashed acquisition
      and prompt for recovery. 
    }
  except
  end;
end;

procedure TQUB_MainForm.ExecuteArguments(Args :TStrings);
var
  i   :Integer;
  Par :String;
  Arg :String;
begin

  for i := 0 to Args.Count - 1 do begin

    Par := Trim(Copy(Args[i], 1, 4));
    Arg := Trim(Copy(Args[i], 5, Length(Args[i]) - 4));

    if          Par = 'od' then begin

      qubViewportData.Open(Arg, False{Silent});

    end else if Par = 'om' then begin

      qubViewportModel.Open(Arg, False{Silent});

    //end else if Par = 'ok' then begin

    //  qubViewportScripts.Open(Arg, False{Silent});

    end;

  end;
end;

//DDE Macro
procedure TQUB_MainForm.prOnDDEMacro(Sender: TObject; Msg: TStrings);
begin
  Console.NewEntry('DDEMacro', COLOR_GRAY);
end;

procedure TQUB_MainForm.prOnDDEOpen(Sender: TObject);
begin
  Console.NewEntry('DDEOpen', COLOR_GRAY);
end;

procedure TQUB_MainForm.prOnDDEClose(Sender: TObject);
begin
  Console.NewEntry('DDEClose', COLOR_GRAY);
end;

procedure TQUB_MainForm.prOnDDEPokeData(Sender: TObject);
begin
  Console.NewEntry('DDEPokeData', COLOR_GRAY);
  ExecuteArguments(prDDEServerItem.Lines);
end;


//TaskView Events
procedure TQUB_MainForm.prOnTaskCountChange(Sender :TObject);
begin
  // btnStopAllTasks.Enabled := TQUB_TaskViewForm(Sender).HasTask;
  if prTaskView.HasTask then begin
    btnStopAllTasks.Font.Color := clRed;
  end else begin
    btnStopAllTasks.Font.Color := clBlack;
  end;
end;

procedure TQUB_MainForm.prOnGlobalPctChange(Sender :TObject);
begin
  progTasks.Position := TQUB_TaskViewForm(Sender).GlobalPct;
  progTasks.Visible  := TQUB_TaskViewForm(Sender).JobCount > 0;
end;

//WorkSpace Manager

//Occurs when a Viewport is UnDocked
procedure TQUB_MainForm.WorkSpaceUnDock(Sender: TObject; Client: TControl; NewTarget: TWinControl; var Allow: Boolean);
var
  Viewport :TQUB_Viewport;
begin
  Allow := False;

  if CurrentInterface = nil then Exit;
  if not (Client is TQUB_Viewport) then Exit;

  Allow    := True;
  Viewport := TQUB_Viewport(Client);
  if not CurrentInterface.CanDragDock then begin
  //User operation
    if NewTarget <> WorkSpace then begin
      Viewport.UnDocked := True;
    end;
  end;
end;

//Occurs when a Viewport is Docked
procedure TQUB_MainForm.WorkSpaceDockDrop(Sender: TObject; Source: TDragDockObject; X, Y: Integer);
var
  Viewport :TQUB_Viewport;
begin
  if CurrentInterface = nil then Exit;
  if not (Source.Control is TQUB_Viewport) then Exit;

  Viewport := TQUB_Viewport(Source.Control);
  if not CurrentInterface.CanDragDock then begin
    Viewport.UnDocked     := False;
    Viewport.UnDockWidth  := Viewport.UnDockBounds.Right  - Viewport.UnDockBounds.Left;
    Viewport.UnDockHeight := Viewport.UnDockBounds.Bottom - Viewport.UnDockBounds.Top;
  end;
end;


// *****************************************************************************
// we intercept help system calls to show a wiki topic instead,
// if registered by QUB_Global.MessageHelpDlg:
function TQUB_MainForm.prOnHelp(Command: Word; Data: Longint; var CallHelp: Boolean): Boolean;
begin
  Result := CheckWikiHelp(Command, Data, CallHelp);
end;


//******************************************************************************
// this is delphi 5 specific undocumented innards (replaced by delphi2k5 AcquireExceptionObject
{$IFNDEF DELPHI6_OR_HIGHER}
type
  PRaiseFrame = ^TRaiseFrame;
  TRaiseFrame = record
    NextRaise: PRaiseFrame;
    ExceptAddr: Pointer;
    ExceptObject: TObject;
    ExceptionRecord: PExceptionRecord;
  end;
{$ENDIF}

procedure TQUB_MainForm.prOnGUISyncMsg(var Message: TMessage);
begin
  try
    prGUISyncException := nil;
    prGUISyncProc;
  except
{$IFDEF DELPHI6_OR_HIGHER}
    prGUISyncException := AcquireExceptionObject;
{$ELSE}
    if RaiseList <> nil then
    begin
      prGUISyncException := PRaiseFrame(RaiseList)^.ExceptObject;
      PRaiseFrame(RaiseList)^.ExceptObject := nil;
    end;
{$ENDIF}
  end;

  prGUISyncDone.SetEvent;
end;

procedure TQUB_MainForm.DoSyncGUIProc( proc :TQUB_Proc_Method );
var
  guiException        :TObject;
begin
  if ThisIsTheVCLThread then begin
    proc;
    Exit;
  end;

  while prGUISyncLock = nil do Sleep( 200 );

  prGUISyncLock.Acquire;
  prGUISyncProc := proc;
  guiException  := nil;
  if PostMessage( Self.Handle, WM_QUB_PYTHON_GUISYNC, WPARAM(0), LPARAM(0) ) then begin
    prGUISyncDone.WaitFor(INFINITE);
    prGUISyncDone.ResetEvent;
    guiException := prGUISyncException;
  end;
  prGUISyncLock.Release;
  if guiException <> nil then raise guiException;
end;

procedure TQUB_MainForm.prOnGUISyncRunMsg(var Message: TMessage);
begin
  try
    prGUISyncException := nil;
    prGUISyncRunn.Run;
  except
{$IFDEF DELPHI6_OR_HIGHER}
    prGUISyncException := AcquireExceptionObject;
{$ELSE}
    if RaiseList <> nil then
    begin
      prGUISyncException := PRaiseFrame(RaiseList)^.ExceptObject;
      PRaiseFrame(RaiseList)^.ExceptObject := nil;
    end;
{$ENDIF}
  end;

  prGUISyncDone.SetEvent;
end;

procedure TQUB_MainForm.DoSyncGUIRunnable( proc :TQUB_Runnable );
var
  guiException        :TObject;
begin
  if ThisIsTheVCLThread then begin
    proc.Run;
    Exit;
  end;

  while prGUISyncLock = nil do Sleep( 200 );

  prGUISyncLock.Acquire;
  prGUISyncRunn := proc;
  guiException  := nil;
  if PostMessage( Self.Handle, WM_QUB_PYTHON_GUISYNCRUN, WPARAM(0), LPARAM(0) ) then begin
    prGUISyncDone.WaitFor(INFINITE);
    prGUISyncDone.ResetEvent;
    guiException := prGUISyncException;
  end;
  prGUISyncLock.Release;
  if guiException <> nil then raise guiException;
end;

procedure SyncGUIProc( proc :TQUB_Proc_Method );
begin
  QUB_MainForm.DoSyncGUIProc(proc);
end;

procedure SyncGUIRunnable( proc :TQUB_Runnable );
begin
  QUB_MainForm.DoSyncGUIRunnable(proc);
end;

procedure TQUB_MainForm.prOnAsyncMsg(var Message: TMessage);
var
  proc         :TQUB_Runnable;
begin
  proc         := TQUB_Runnable(Message.LParam);
  try
    proc.Run();
  finally
    proc.Free;
  end;
end;

procedure TQUB_MainForm.prOnAcceptFiles(var Message :TMessage);
const
  cnMaxFileNameLen = 255;
var
  i, nCount    :Integer;
  acFileName   :array[0..cnMaxFileNameLen] of char;
  FName, Ext   :String;
begin
  nCount       := DragQueryFile( message.WParam, $FFFFFFFF, acFileName, cnMaxFileNameLen );
  for i := 0 to nCount - 1 do begin
    DragQueryFile( message.WParam, i, acFileName, cnMaxFileNameLen );
    FName      := PChar(@acFileName);
    Ext        := LowerCase(ExtractFileExt(FName));
    if (Ext = '.qmf') or (Ext = '.mdl') then begin
      qubViewportModel.Open(FName, False{Silent});
    end else if Ext = '.qpf' then begin
      qubViewportProtocol.Open(FName, False);
    end else begin
      qubViewportData.Open(FName, False{Silent});
    end;
  end;
  DragFinish( Message.WParam );
end;


procedure TQUB_MainForm.Asynchronize( proc :TQUB_Runnable );
begin
  PostMessage( Self.Handle, WM_QUB_PYTHON_ASYNC, WPARAM(0), LPARAM(proc) );
end;

procedure Asynchronize( proc :TQUB_Runnable );
begin
  QUB_MainForm.Asynchronize(proc);
end;


//----- Terminate currently executing task from menu choice
procedure TQUB_MainForm.mnuMainActionsStopTasksClick(Sender: TObject);
begin
  btnStopAllTasksClick(Sender);
end;

//----- When action menu is clicked, invoke the OnRClick member from action object.
procedure TQUB_MainForm.Action1Execute(Sender: TObject);
var
  mnu : TMenuItem;
  action : TQUB_Action;
  i,iPos : Integer;
  cCaption : String;
begin
  //-- caption from selected menu item
  mnu := TMenuItem(Sender);

  //-- remove '&' from menu caption
  cCaption := mnu.Caption;
  iPos := Pos('&',cCaption);
  while iPos > 0 do begin
    Delete(cCaption,iPos,1);
    iPos := Pos('&',cCaption);
  end;

  //-- find menu item and execute function
  i := m_lstActions.IndexOf(cCaption);
  if i >= 0 then begin
    action := TQUB_Action(m_lstActions.Objects[i]);
    action.OnRClick(nil);
  end;
end;

//----- add a menu choice for a given task - called from action button create
procedure TQUB_MainForm.AddMenuTask( cSubmenu : String; action : TQUB_Action );
var
  mnuSub : TMenuItem;
  mnuNew : TMenuItem;
begin
  mnuSub := mnuMainActions.Find(cSubmenu);
  if mnuSub = nil then begin
    mnuSub := TMenuItem.Create(mnuMainActions);
    mnuSub.Caption := cSubmenu;
    mnuMainActions.Add(mnuSub);
  end;
  mnuNew := TMenuItem.Create(mnuSub);
    // Re: mnuSub From delphi help : The Component parameter is the Owner
    // component that is responsible for freeing the menu item.
  mnuNew.OnClick := Action1Execute;
  mnuNew.Caption := action.Name;
  mnuSub.Add(mnuNew);
  m_lstActions.AddObject(action.Name,action);
end;

//----- Toggle action buttons display
procedure TQUB_MainForm.mnuMainActionsShowButtonsClick(Sender: TObject);
begin
  mnuMainActionsShowButtons.Checked := not mnuMainActionsShowButtons.Checked;
  panTaskSelector.Visible           := mnuMainActionsShowButtons.Checked;
end;

//******************************************************************************
procedure TQUB_MainForm.mnuMainActionsDataSourceClick(Sender: TObject);
begin
  prSetDataSource(TQUB_Task_Data_Source(TControl(Sender).Tag));
end;

//--------------------------------------------------
function g_CurrData : TQUB_QVO_QVD;
begin
  Result := ViewportData.CurrData;
end;

function g_CurrModel : TQUB_QVO_QVM;
begin
  Result := ViewportModel.CurrModel;
end;

//-- Open the scaling assistant window
procedure TQUB_MainForm.mnuMainOptionsCalibrationAssistantClick( Sender: TObject);
begin
  if frmWizardScaling = nil then begin
    frmWizardScaling := TfrmWizardScaling.Create(nil);
  end;
  frmWizardScaling.Show();
  frmWizardScaling.SetStatus();
end;

procedure TQUB_MainForm.Wiki1Click(Sender: TObject);
begin
  ShowWiki('Outline', Handle);
end;

//Key Shortcuts
procedure TQUB_MainForm.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin

  case Key of

    VK_F7:
      begin
       qubViewportAcqInput.AcquisitionInput.AcqRecord;
      end;

    VK_F8:
      begin
        qubViewportAcqInput.AcquisitionInput.AcqPause;
      end;

    VK_F9:
      begin
        ViewportData.AddNote;
      end;

    //Kinetic scripts
    //VK_F4://Compile
    //  begin
    //    {if IsWindowVisible(ViewportScripts.Script.Handle) then }ViewportScripts.Script.Compile;
    //  end;

    //VK_F5://Run
    //  begin
    //    {if IsWindowVisible(ViewportScripts.Script.Handle) then }ViewportScripts.Script.Run;
    //  end;

    //VK_F6://Stop
    //  begin
    //    {if IsWindowVisible(ViewportScripts.Script.Handle) then }ViewportScripts.Script.Stop;
    //  end;

  end;//case

end;


procedure TQUB_MainForm.prOnAcqControlMsg(Msg, wParam, lParam :Cardinal);
begin
  if wParam = ACQ_CONTROL_INPUT then begin
    if lParam = ACQ_CONTROL_START then begin
      qubViewportAcqInput.AcquisitionInput.btnRunClick(Self);
    end else if lParam = ACQ_CONTROL_PLAY then begin
      qubViewportAcqInput.AcquisitionInput.btnRecordClick(Self);
    end else if lParam = ACQ_CONTROL_STOP then begin
      qubViewportAcqInput.AcquisitionInput.btnStopClick(Self);
    end else if lParam = ACQ_CONTROL_PAUSE then begin
      qubViewportAcqInput.AcquisitionInput.btnPauseClick(Self);
    end else if lParam = ACQ_CONTROL_RESUME then begin
      qubViewportAcqInput.AcquisitionInput.btnRecordClick(Self);
    end;
  end else if wParam = ACQ_CONTROL_OUTPUT then begin
    if lParam = ACQ_CONTROL_PLAY then begin
      qubViewportAcqOutput.AcquisitionOutput.btnRunClick(Self);
    end else if lParam = ACQ_CONTROL_STOP then begin
      qubViewportAcqOutput.AcquisitionOutput.btnStopClick(Self);
    end else if lParam = ACQ_CONTROL_PAUSE then begin
      qubViewportAcqOutput.AcquisitionOutput.btnStopClick(Self);
    end else if lParam = ACQ_CONTROL_RESUME then begin
      qubViewportAcqOutput.AcquisitionOutput.btnRunClick(Self);
    end;
  end else if wParam = ACQ_CONTROL_SYNCH then begin
    if lParam = ACQ_CONTROL_PLAY then begin
      qubViewportAcqOutput.AcquisitionOutput.btnSynchRunClick(Self);
    end else if lParam = ACQ_CONTROL_STOP then begin
      qubViewportAcqOutput.AcquisitionOutput.btnStopClick(Self);
    end else if lParam = ACQ_CONTROL_PAUSE then begin
      qubViewportAcqInput.AcquisitionInput.AcqPause;
    end else if lParam = ACQ_CONTROL_RESUME then begin
      qubViewportAcqInput.AcquisitionInput.AcqRecord;
    end;
  end;
end;

procedure TQUB_MainForm.prOnCopyDataMsg(var Msg :TWMCopyData);
var
  s   :String;
begin
  Msg.Result := 0;
  
  if Msg.CopyDataStruct.dwData = QUB_COPYDATA_ACQ_NOTE then begin
    s := PChar(Msg.CopyDataStruct.lpData);
    if qubViewportData.CurrData <> nil then begin
      qubViewportData.CurrData.AddNote('AcqNotes', s, '');
    end;
    Msg.Result := 1;
  end;
end;



//******************************************************************************
initialization


m_lstActions       := TStringList.Create;
ThisIsTheVCLThread := True;

finalization


m_lstActions.Free;


//******************************************************************************
end.
