{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
// what you see when >>> QUB.editTree( someNode )

unit QUB_NodeEditForm;

interface

uses
Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
QUB_NodeEditor;

type
  TQUB_NodeEditForm = class(TForm)
    procedure FormHide(Sender: TObject);
  protected
    prEditFrame      :TQUB_NodeEditor;

  public
    OnDone           :TNotifyEvent;

    constructor Create(AOwner :TComponent); override;

    property EditFrame      :TQUB_NodeEditor       read prEditFrame;
  end;

implementation


uses QUB_Node;


{$R *.DFM}

constructor TQUB_NodeEditForm.Create(AOwner :TComponent);
begin
  inherited;

  prEditFrame           := TQUB_NodeEditor.Create(Self);
  prEditFrame.Parent    := Self;
  prEditFrame.Align     := alClient;
end;


procedure TQUB_NodeEditForm.FormHide(Sender: TObject);
begin
  ModalResult := mrOK;
  if Assigned(OnDone) then OnDone(Self);
  prEditFrame.Root      := QUB_Node_Null;
end;

// *****************************************************************************
end.
