{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
// used by QUB_Main to help interpret command-line arguments which specify e.g. open this model on startup


unit QUB_Params;


interface


uses


SysUtils, Classes;


procedure Params(Pars :TStrings);


//******************************************************************************
implementation


//******************************************************************************
procedure Params(Pars :TStrings);
var
  p   :Integer;
  Par :String;
begin

  Pars.Clear;

  p := 1;
  while (p < ParamCount) do begin

    Par := LowerCase(ParamStr(p));

    if          (Par = '-od') or (Par = '/od') then begin
    //Open data

      Inc(p);
      Pars.Add('od  ' + ParamStr(p));
      Inc(p);

    end else if (par = '-om') or (par = '/om') then begin
    //Open model

      Inc(p);
      Pars.Add('om  ' + ParamStr(p));
      Inc(p);

    end else if (par = '-ok') or (par = '/ok') then begin
    //Open kinetic script
    
      Inc(p);
      Pars.Add('ok  ' + ParamStr(p));
      Inc(p);

    end;

  end;

end;


//******************************************************************************
end.
