{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
{

               Qub Acquisition Protocol
                         unit



               (C) 2003 Lorin Milescu

idea in progress:  control acquisition with a state machine that controls input and output

}
//10-04-2003   Creation date


unit QUB_Protocol;


interface


uses


SysUtils, Classes, Contnrs;


type


TQUB_Protocol_Machine_State       = (PROTOCOL_STATE_STOPPED, PROTOCOL_STATE_STARTED, PROTOCOL_STATE_PAUSED);


//forward class declarations
TQUB_Protocol_Operations          = class;
TQUB_Protocol_Operation           = class;
TQUB_Protocol_Machine             = class;


//Classes

//Operations
TQUB_Protocol_Operations          = class(TObjectList)
public


  function Add(AObject: TObject): Integer;


end;

//Operation
TQUB_Protocol_Operation           = class(TObject)
protected


  prIndex                         :Integer;
  prNext                          :Integer;


public


  function Execute(var NextOp :Integer) :Boolean; virtual;


  property Index                  :Integer        read prIndex         write prIndex;
  property Next                   :Integer        read prNext          write prNext;


end;

//Machine
TQUB_Protocol_Machine             = class(TThread)
protected


  prInputBuffer                   :Pointer;
  prOutputBuffer                  :Pointer;

  prOperations                    :TQUB_Protocol_Operations;

  prState                         :TQUB_Protocol_Machine_State;


public


  constructor Create(Suspended :Boolean);
  destructor Destroy; override;


  procedure Execute; override;


  function Start :Boolean;
  function Pause :Boolean;
  function Stop :Boolean;


end;


implementation


//Operations *******************************************************************
function TQUB_Protocol_Operations.Add(AObject: TObject): Integer;
begin
  Result := inherited Add(AObject);
  TQUB_Protocol_Operation(AObject).Index := Result;
end;


//Operation ********************************************************************
function TQUB_Protocol_Operation.Execute(var NextOp :Integer) :Boolean;
begin
  Result := False;
  NextOp := prIndex + 1;
end;

constructor TQUB_Protocol_Machine.Create(Suspended :Boolean);
begin
  inherited Create(Suspended);

  FreeOnTerminate := True;
  Priority        := tpNormal;

  prState         := PROTOCOL_STATE_STOPPED;

end;

destructor TQUB_Protocol_Machine.Destroy;
begin
  try

  finally
    inherited;
  end;
end;

procedure TQUB_Protocol_Machine.Execute;
begin

  repeat


  until(Terminated);

end;

function TQUB_Protocol_Machine.Start :Boolean;
begin
  Result := False;
end;

function TQUB_Protocol_Machine.Pause :Boolean;
begin
  Result := False;
end;

function TQUB_Protocol_Machine.Stop :Boolean;
begin
  Result := False;
end;


//******************************************************************************
end.
