{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
// dialog on open file to determine sampling etc.


unit QUB_QFS_QDF_Properties;


interface


uses


Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ComCtrls, ExtCtrls, Registry,

RegistryInterface,

QUB_Global,
QUB_Profiles,
QUB_Node,
QUB_QVO_QVD_Global,
QUB_QFS_QDF_Global,
QUB_QFS_QDF_ScalingPanel,
QUB_Classic_Properties;


{$include 'QUB_QFS_QDF_Properties.hct'}


type


TQUB_QFS_QDF_PropertiesForm = class(TQUB_Classic_PropertiesForm)


  lblADCount                :TLabel;
  lblSampling               :TLabel;
  lblSamplingms             :TLabel;
  lblSamplingkHz            :TLabel;
  lblADSize                 :TLabel;
  txtScaling                :TQUB_QFS_QDF_ScalingPanel;
  txtChannelCount           :TEdit;
  udChannelCount            :TUpDown;
  chkADDataSize2            :TRadioButton;
  chkADDataSize4            :TRadioButton;
  chkTimeColumn             :TCheckBox;
  chkUnevenSampling         :TCheckBox;
  chkSinglePrec             :TCheckBox;
  chkSegmented              :TCheckBox;
  chkMultiplexed            :TCheckBox;
  txtSamplingMS             :TEdit;
  txtSamplingKHz            :TEdit;
  btnPreScan                :TButton;
  Label1                    :TLabel;
  lblFileName               :TLabel;
  panMPX                    :TPanel;
  chkMPXAA                  :TRadioButton;
  chkMPXAB                  :TRadioButton;
    panPRT: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    txtPRTSampling: TEdit;
    Label4: TLabel;
    Label6: TLabel;
    panAcrit: TPanel;
    chkPRTNonzero: TRadioButton;
    chkPRTAcrit: TRadioButton;
    txtPRTAcrit: TEdit;
    Label5: TLabel;


  procedure FormCreate(Sender: TObject);
  procedure FormShow(Sender: TObject);
  procedure FormHide(Sender: TObject);
  procedure FormKeyPress(Sender: TObject; var Key: Char);

  procedure udChannelCountClick(Sender: TObject; Button: TUDBtnType);
  procedure chkTimeColumnClick(Sender: TObject);
  procedure chkUnevenSamplingClick(Sender: TObject);
  procedure chkSinglePrecClick(Sender: TObject);
  procedure chkSegmentedClick(Sender: TObject);
  procedure chkMultiplexedClick(Sender: TObject);
  procedure txtSamplingMSKeyPress(Sender: TObject; var Key: Char);
  procedure txtSamplingMSExit(Sender: TObject);
  procedure txtSamplingKHzKeyPress(Sender: TObject; var Key: Char);
  procedure txtSamplingKHzExit(Sender: TObject);
  procedure chkADDataSizeClick(Sender: TObject);
  procedure btnPreScanClick(Sender: TObject);
  procedure txtScalingEditDblClick(Sender: TObject);
    procedure chkMPXAAClick(Sender: TObject);
    procedure txtPRTSamplingKeyPress(Sender: TObject; var Key: Char);
    procedure txtPRTSamplingExit(Sender: TObject);
    procedure chkPRTNonzeroClick(Sender: TObject);
    procedure chkPRTAcritClick(Sender: TObject);
    procedure txtPRTAcritKeyPress(Sender: TObject; var Key: Char);
    procedure txtPRTAcritExit(Sender: TObject);


protected


  mnuProfiles               :TQUB_ProfileEditBox;
  prProfile                 :INode;

  //----- Vars used for data pre-scan for scaling estimation
  m_RefStream               :TStream;
  m_FileType                :TQUB_QFS_QDF_FILETYPE;
  m_phFile                  :Integer;
  m_pdwMaxEpi               :LongWord;

  prADChannelCount          :Integer;
  prADDataSize              :Integer;
  prTimeColumn              :Boolean;
  prUnevenSampling          :Boolean;
  prSinglePrec              :Boolean;
  prSegmented               :Boolean;
  prMultiplexed             :Boolean;
  prMPXAA                   :Boolean;
  prScaling                 :Double;
  prSampling                :Double;
  prHideScaling             :Boolean;
  prPRTSampling             :Double;
  prPRTUseAcrit             :Boolean;
  prPRTAcrit                :String;


  procedure prInitProfile;
  procedure prOnSetProfile(Cat :TQUB_ProfileCat; Updates :INode);

  procedure prOnScalingChange(Sender :TObject);
  procedure prOnScalingEditing(Sender :TObject);
  procedure prOnScalingMinimize(Sender :TObject);
  procedure prOnScalingClose(Sender :TObject);

  procedure prSetADChannelCount(c :Integer);
  procedure prSetADDataSize(s :Integer);
  procedure prSetTimeColumn(t :Boolean);
  procedure prSetUnevenSampling(u :Boolean);
  procedure prSetSinglePrec(s :Boolean);
  procedure prSetSegmented(s :Boolean);
  procedure prSetMultiplexed(m :Boolean);
  procedure prSetMPXAA(a :Boolean);
  procedure prSetScaling(s :Double);
  procedure prSetSampling(s :Double);
  procedure prSetPRTSampling(x :Double);
  procedure prSetPRTUseAcrit(x :Boolean);
  procedure prSetPRTAcrit(x :String);


public


  procedure SetupAscPreScan(RefStream :TStream );


  property ADChannelCount   :Integer          read prADChannelCount write prSetADChannelCount;
  property ADDataSize       :Integer          read prADDataSize     write prSetADDataSize;
  property TimeColumn       :Boolean          read prTimeColumn     write prSetTimeColumn;
  property UnevenSampling   :Boolean          read prUnevenSampling write prSetUnevenSampling;
  property SinglePrec       :Boolean          read prSinglePrec     write prSetSinglePrec;
  property Segmented        :Boolean          read prSegmented      write prSetSegmented;
  property Multiplexed      :Boolean          read prMultiplexed    write prSetMultiplexed;
  property MPXAA            :Boolean          read prMPXAA          write prSetMPXAA;
  property Scaling          :Double           read prScaling        write prSetScaling;
  property Sampling         :Double           read prSampling       write prSetSampling; // [ms]

  property PRTSampling      :Double           read prPRTSampling    write prSetPRTSampling; // ms
  property PRTUseAcrit      :Boolean          read prPRTUseAcrit    write prSetPRTUseAcrit;
  property PRTAcrit         :String           read prPRTAcrit       write prSetPRTAcrit;

end;


implementation


uses


Math,

QUB_GUIInterface,
QUB_Parser;


{$R *.DFM}


//******************************************************************************
procedure TQUB_QFS_QDF_PropertiesForm.prSetADChannelCount(c :Integer);
begin
  udChannelCount.Position := c;
  prProfile['ADChannelCount'].Data[0] := udChannelCount.Position;
  prADChannelCount := udChannelCount.Position;
end;

procedure TQUB_QFS_QDF_PropertiesForm.prSetADDataSize(s :Integer);
begin
  prADDataSize := s;
  chkADDataSize2.Checked := s = 2;
  chkADDataSize4.Checked := s = 4;
  prProfile['ADDataSize'].Data[0] := s;
  if s = 2 then begin
    txtScaling.MaxInt := High(SmallInt);
  end else begin
    txtScaling.MaxInt := High(LongInt);
  end;
end;

procedure TQUB_QFS_QDF_PropertiesForm.prSetTimeColumn(t :Boolean);
begin
  prTimeColumn := t;
  chkTimeColumn.Checked := prTimeColumn;
  prProfile['TimeColumn'].Data[0] := t;
end;

procedure TQUB_QFS_QDF_PropertiesForm.prSetUnevenSampling(u :Boolean);
begin
  prUnevenSampling := u;
  chkUnevenSampling.Checked := prUnevenSampling;
  prProfile['UnevenSampling'].Data[0] := u;
end;

procedure TQUB_QFS_QDF_PropertiesForm.prSetSinglePrec(s :Boolean);
begin
  prSinglePrec := s;
  chkSinglePrec.Checked := prSinglePrec;
  prProfile['SinglePrecision'].Data[0] := s;
end;

procedure TQUB_QFS_QDF_PropertiesForm.prSetSegmented(s :Boolean);
begin
  prSegmented := s;
  chkSegmented.Checked := prSegmented;
  prProfile['Segmented'].Data[0] := s;
end;

procedure TQUB_QFS_QDF_PropertiesForm.prSetMultiplexed(m :Boolean);
begin
  prMultiplexed := m;
  chkMultiplexed.Checked := prMultiplexed;
  prProfile['Multiplexed'].Data[0] := m;
end;

procedure TQUB_QFS_QDF_PropertiesForm.prSetMPXAA(a :Boolean);
begin
  prMPXAA := a;
  if a then chkMPXAA.Checked := True else chkMPXAB.Checked := True;
  prProfile['MPXAA'].Data[0] := a;
end;

procedure TQUB_QFS_QDF_PropertiesForm.prSetScaling(s :Double);
begin
  prScaling := s;
  prProfile['Scaling'].Data[0] := s;
  txtScaling.OnScalingChange := nil;
  txtScaling.Scaling := s;
  txtScaling.OnScalingChange := prOnScalingChange;
end;

procedure TQUB_QFS_QDF_PropertiesForm.prSetSampling(s :Double);
begin
  prSampling := s;
  txtSamplingMS.Text      := FloatToStr(Sampling);
  try txtSamplingKHz.Text := FloatToStr(1 / Sampling); except end;
  prProfile['Sampling'].Data[0] := 1/s;
end;

procedure TQUB_QFS_QDF_PropertiesForm.prSetPRTSampling(x :Double);
begin
  prPRTSampling := x;
  txtPRTSampling.Text    := FloatToStr(x);
  prProfile['PRT Sampling'].Data[0] := x;
end;

procedure TQUB_QFS_QDF_PropertiesForm.prSetPRTUseAcrit(x :Boolean);
begin
  prPRTUseAcrit := x;
  chkPRTNonzero.Checked := not x;
  chkPRTAcrit.Checked := x;
  prProfile['PRT Use Acrit'].Data[0] := Integer(x);
end;

procedure TQUB_QFS_QDF_PropertiesForm.prSetPRTAcrit(x :String);
begin
  prPRTAcrit := x;
  txtPRTAcrit.Text := x;
  prProfile['PRT Acrit'].SetData(x);
end;


//******************************************************************************
procedure TQUB_QFS_QDF_PropertiesForm.FormCreate(Sender: TObject);
begin
  inherited;

  udChannelCount.Max := QUB_QFS_QDF_MAX_ADCHANNELCOUNT;

  prProfile       := ProfileMgr['Data'].Active;
  prInitProfile;

  mnuProfiles                             := TQUB_ProfileEditBox.Create(Self);
  mnuProfiles.Parent                      := Self;
  mnuProfiles.SetBounds(24{248}, 170, 198, mnuProfiles.Height);
  mnuProfiles.Anchors                     := [akRight, akBottom];
  mnuProfiles.Cat                         := 'Data';

  txtScaling.OnScalingChange              := prOnScalingChange;
  txtScaling.OnEditing                    := prOnScalingEditing;
  txtScaling.OnMinimize                   := prOnScalingMinimize;
  txtScaling.OnClose                      := prOnScalingClose;

  {$include 'QUB_QFS_QDF_Properties.htx'}
end;

procedure TQUB_QFS_QDF_PropertiesForm.FormShow(Sender: TObject);
begin
  inherited;

  prOnSetProfile(ProfileMgr['Data'], prProfile);
  ProfileMgr['Data'].OnSet := prOnSetProfile;

end;

procedure TQUB_QFS_QDF_PropertiesForm.FormHide(Sender: TObject);
begin
  inherited;

  ProfileMgr['Data'].OnSet := nil;
end;

procedure TQUB_QFS_QDF_PropertiesForm.prInitProfile;
var
  Node            :INode;
  function HasData(const Name :String): Boolean;
  begin
    Node          := prProfile[Name];
    Result        := Node.DataCount > 0;
  end;
begin
  if not HasData('ADChannelCount')  then Node.SetData(1);
  if not HasData('ADDataSize')      then Node.SetData(SizeOf(SmallInt));
  if not HasData('Sampling')        then Node.SetData(QUB_QVO_QVD_DEF_SAMPLING);
  if not HasData('Scaling')         then Node.SetData(QUB_QVO_QVD_DEF_SCALING);
  if not HasData('TimeColumn')      then Node.SetData(0);
  if not HasData('Segmented')       then Node.SetData(0);
  if not HasData('Multiplexed')     then Node.SetData(0);
  if not HasData('MPXAA')           then Node.SetData(0);
  if not HasData('UnevenSampling')  then Node.SetData(0);
  if not HasData('SinglePrecision') then Node.SetData(0);
  if not HasData('PRT Sampling')    then Node.SetData(QUB_QVO_QVD_DEF_PRT_SAMPLING);
  if not HasData('PRT Use Acrit')   then Node.SetData(QUB_QVO_QVD_DEF_PRT_USE_ACRIT);
  if not HasData('PRT Acrit')       then Node.SetData(QUB_QVO_QVD_DEF_PRT_ACRIT);

  prOnSetProfile(ProfileMgr['Data'], prProfile);
end;

procedure TQUB_QFS_QDF_PropertiesForm.prOnSetProfile(Cat :TQUB_ProfileCat; Updates :INode);
var
  Node            :INode;
  function HasData(const Name :String): Boolean;
  begin
    Node          := Updates.Find(Name);
    Result        := Node.DataCount > 0;
  end;
begin
  if HasData('ADChannelCount')  then ADChannelCount := Node.Data[0];
  if HasData('ADDataSize')      then ADDataSize     := Node.Data[0];
  if HasData('Sampling')        then Sampling       := 1.0/Node.Data[0];
  if HasData('Scaling')         then Scaling        := Node.Data[0];
  if HasData('UnevenSampling')  then UnevenSampling := 0<>Node.Data[0];
  if HasData('SinglePrecision') then SinglePrec     := 0<>Node.Data[0];
  if HasData('TimeColumn')      then TimeColumn     := 0<>Node.Data[0];
  if HasData('Segmented')       then Segmented      := 0<>Node.Data[0];
  if HasData('Multiplexed')     then Multiplexed    := 0<>Node.Data[0];
  if HasData('MPXAA')           then MPXAA          := 0<>Node.Data[0];
  if HasData('PRT Sampling')    then PRTSampling    := Node.Data[0];
  if HasData('PRT Use Acrit')   then PRTUseAcrit    := 0<>Node.Data[0];
  if HasData('PRT Acrit')       then PRTAcrit       := Node.DataAsString;
end;

//******************************************************************************

procedure TQUB_QFS_QDF_PropertiesForm.prOnScalingChange(Sender :TObject);
begin
  Scaling := txtScaling.Scaling;
end;

procedure TQUB_QFS_QDF_PropertiesForm.prOnScalingEditing(Sender :TObject);
begin
  if prHideScaling then Exit;
  with TQUB_QFS_QDF_ScalingDetails(txtScaling.Details) do begin
    if Parent <> Self then begin
      Parent := Self;
      SetBounds(txtScaling.Left + txtScaling.Width + 4,
                txtScaling.Top - 12, Width, Height);
    end;
  end;
end;

procedure TQUB_QFS_QDF_PropertiesForm.prOnScalingMinimize(Sender :TObject);
begin
  prHideScaling := True;
  prOnScalingClose(Sender);
end;

procedure TQUB_QFS_QDF_PropertiesForm.prOnScalingClose(Sender :TObject);
begin
  txtScaling.Details.Parent := nil;
end;

procedure TQUB_QFS_QDF_PropertiesForm.txtScalingEditDblClick(Sender: TObject);
begin
  inherited;
  prHideScaling := False;
  prOnScalingEditing(txtScaling);
end;

//******************************************************************************
procedure TQUB_QFS_QDF_PropertiesForm.udChannelCountClick(Sender: TObject; Button: TUDBtnType);
begin
  inherited;

  ADChannelCount := TUpDown(Sender).Position;

end;

procedure TQUB_QFS_QDF_PropertiesForm.chkADDataSizeClick(Sender: TObject);
begin
  inherited;

  ADDataSize := TRadioButton(Sender).Tag;

end;

procedure TQUB_QFS_QDF_PropertiesForm.chkTimeColumnClick(Sender: TObject);
begin
  inherited;

  TimeColumn := TCheckBox(Sender).Checked;

end;

procedure TQUB_QFS_QDF_PropertiesForm.chkUnevenSamplingClick(Sender: TObject);
begin
  inherited;

  UnevenSampling := TCheckBox(Sender).Checked;

end;

procedure TQUB_QFS_QDF_PropertiesForm.chkSinglePrecClick(Sender: TObject);
begin
  inherited;

  SinglePrec := TCheckBox(Sender).Checked;

end;

procedure TQUB_QFS_QDF_PropertiesForm.chkSegmentedClick(Sender: TObject);
begin
  inherited;

  Segmented := TCheckBox(Sender).Checked;

end;

procedure TQUB_QFS_QDF_PropertiesForm.chkMultiplexedClick(Sender: TObject);
begin
  inherited;

  Multiplexed := TCheckBox(Sender).Checked;

end;

procedure TQUB_QFS_QDF_PropertiesForm.chkMPXAAClick(Sender: TObject);
begin
  inherited;

  MPXAA := Boolean(TCheckBox(Sender).Tag <> 0);

end;

procedure TQUB_QFS_QDF_PropertiesForm.txtSamplingMSKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtSamplingMSExit(Sender);
    try btnOK.SetFocus; except end;
  end;
end;

procedure TQUB_QFS_QDF_PropertiesForm.txtSamplingMSExit(Sender: TObject);
var
  s   :Double;
  khz :Double;
begin
  inherited;
  try
    s    := StrToFloat(TEdit(Sender).Text);
    khz  := 1.0 / s;
    if ((khz < QUB_QVO_QVD_MIN_SAMPLING) or (khz > QUB_QVO_QVD_MAX_SAMPLING)) then raise Exception.Create('');
  except
    MessageDlg('Invalid value; must be between ' + FloatToStr(1.0 / QUB_QVO_QVD_MIN_SAMPLING) + ' and ' + FloatToStr(1.0 / QUB_QVO_QVD_MAX_SAMPLING), mtError, [mbOK], 0);
    Sampling := Sampling;
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if s <> Sampling then begin
    Sampling := s;
  end;
end;

procedure TQUB_QFS_QDF_PropertiesForm.txtSamplingKHzKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtSamplingKHzExit(Sender);
    try btnOK.SetFocus; except end;
  end;
end;

procedure TQUB_QFS_QDF_PropertiesForm.txtSamplingKHzExit(Sender: TObject);
var
  s   :Double;
begin
  inherited;
  try
    s    := StrToFloat(TEdit(Sender).Text);
    if ((s < QUB_QVO_QVD_MIN_SAMPLING) or (s > QUB_QVO_QVD_MAX_SAMPLING)) then raise Exception.Create('');
  except
    MessageDlg('Invalid value; must be between ' + FloatToStr(QUB_QVO_QVD_MIN_SAMPLING) + ' and ' + FloatToStr(QUB_QVO_QVD_MAX_SAMPLING), mtError, [mbOK], 0);
    Sampling := Sampling;
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if s <> (1.0 / Sampling) then begin
    Sampling := 1.0 / s;
  end;
end;


procedure TQUB_QFS_QDF_PropertiesForm.txtPRTSamplingKeyPress(
  Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtPRTSamplingExit(Sender);
    try btnOK.SetFocus; except end;
  end;
end;

procedure TQUB_QFS_QDF_PropertiesForm.txtPRTSamplingExit(Sender: TObject);
var
  s   :Double;
  khz :Double;
begin
  inherited;
  try
    s    := StrToFloat(TEdit(Sender).Text);
    khz  := 1.0 / s;
    if ((khz < QUB_QVO_QVD_MIN_SAMPLING) or (khz > QUB_QVO_QVD_MAX_SAMPLING)) then raise Exception.Create('');
  except
    MessageDlg('Invalid value; must be between ' + FloatToStr(1.0 / QUB_QVO_QVD_MIN_SAMPLING) + ' and ' + FloatToStr(1.0 / QUB_QVO_QVD_MAX_SAMPLING), mtError, [mbOK], 0);
    PRTSampling := PRTSampling;
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if s <> PRTSampling then begin
    PRTSampling := s;
  end;
end;

procedure TQUB_QFS_QDF_PropertiesForm.chkPRTNonzeroClick(Sender: TObject);
begin
  inherited;
  PRTUseAcrit := not TRadioButton(Sender).Checked;
end;

procedure TQUB_QFS_QDF_PropertiesForm.chkPRTAcritClick(Sender: TObject);
begin
  inherited;
  PRTUseAcrit := TRadioButton(Sender).Checked;
end;

procedure TQUB_QFS_QDF_PropertiesForm.txtPRTAcritKeyPress(Sender: TObject;
  var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtPRTAcritExit(Sender);
    try btnOK.SetFocus; except end;
  end;
end;

procedure TQUB_QFS_QDF_PropertiesForm.txtPRTAcritExit(Sender: TObject);
begin
  inherited;
  PRTAcrit    := TEdit(Sender).Text;
end;

procedure TQUB_QFS_QDF_PropertiesForm.btnPreScanClick(Sender: TObject);
var
  Parser        :TQUB_Parser;
  OldPos        :LongInt;
  Text          :String;
  iCol          :Integer;
  nMax          :Double;
  bytesRead     :Integer;

  epi           :Integer;
  epiFileOffset :LongWord;
  puNumSamples  :Cardinal;

begin

  nMax          := 0;
  bytesRead     := 0;

  //----- Pre-read ascii text file
  if m_FileType = QFS_QDF_TYPE_ASC then begin

    Parser               := TQUB_Parser.Create; // Create a Qub_Parser object
    try
      Parser.ReturnTab     := False;
      Parser.ReturnNewLine := True;

      OldPos := m_RefStream.Position;  // remember file pos prior to messing with it
      SetLength(Text, ONE_MEGABYTE);   // Allocate a 1 MB buffer to preread data
      bytesRead := m_RefStream.Read(PChar(Text)^, ONE_MEGABYTE); // Fill in buffer with lesser of file, buffer
      m_RefStream.Position := OldPos;

      if bytesRead > 0 then begin      // If nothing read in, exit
        SetLength(Text, bytesRead);
        Parser.Start;
        iCol := 0;
        repeat
          Parser.Next(Text);
          if Parser.Token.TokenType = TOKEN_NEWLINE then begin
            iCol := 0;
          end else if Parser.Token.TokenType = TOKEN_NUMBER then begin
            if (iCol > 0) or (prTimeColumn) then begin
              nMax := Max(nMax, abs(Parser.Token.TokenNumber));
            end;
            iCol := iCol + 1;
          end;
        until Parser.Token.TokenType = TOKEN_NULL;
      end;

    finally
      Parser.Free;
    end;

  end;

  Application.ProcessMessages;
  nMax := 32768.0/nMax;
  if nMax >= 1.0 then nMax := Max(1, Round(nMax - 0.5));
  prSetScaling( nMax );
end;

procedure TQUB_QFS_QDF_PropertiesForm.SetupAscPreScan( RefStream : TStream );
begin
  m_RefStream := RefStream;
  btnPreScan.Visible := True;
  m_FileType := QFS_QDF_TYPE_ASC;
end;

procedure TQUB_QFS_QDF_PropertiesForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Word(Key) = VK_ESCAPE then begin
    Key := #0;
    ModalResult := mrCancel;
  end;
end;


//******************************************************************************
end.
