{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
// wav file header info


unit QUB_QFS_QDF_WAV;


interface


uses


Alloc;


const


QUB_QFS_QDF_STRING_RIFF = 1179011410;
QUB_QFS_QDF_STRING_WAVE = 1163280727;
QUB_QFS_QDF_STRING_FMT  = 544501094;
QUB_QFS_QDF_STRING_DATA = 1635017060;


type


TQUB_QFS_QDF_WAV_RIFF_Chunk   = record                  //(12 bytes in length total)
  riff                        :LongInt;                 //'RIFF' (ASCII Characters)
  length                      :LongInt;                 //Total Length Of Package To Follow (Binary, little endian)
  wave                        :LongInt;                 //'WAVE' (ASCII Characters)
end;

TQUB_QFS_QDF_WAV_FORMAT_Chunk = record                  //(24 bytes in length total)
  fmt                         :LongInt;                 //'fmt ' (ASCII Characters)
  length                      :LongInt;                 //Length Of FORMAT Chunk (Binary, always 0x10)
  formattag                   :Word;                    //Always 0x01
  channels                    :Word;                    //Channel Numbers (Always 0x01=Mono, 0x02=Stereo)
  samplerate                  :LongInt;                 //Sample Rate (Binary, in Hz)
  bytespersec                 :LongInt;                 //Bytes Per Second
  bytespersample              :Word;                    //Bytes Per Sample: 1=8 bit Mono, 2=8 bit Stereo or 16 bit Mono, 4=16 bit Stereo
  bitspersample               :Word;                    //Bits Per Sample
end;

TQUB_QFS_QDF_WAV_DATA_Chunk   = record                  //(24 bytes in length total)
  data                        :LongInt;                 //'data' (ASCII Characters)
  length                      :LongInt;                 //Length Of Data To Follow
  //samples
end;

TQUB_QFS_QDF_WAV_Chunk        = record
  riff                        :TQUB_QFS_QDF_WAV_RIFF_Chunk;
  format                      :TQUB_QFS_QDF_WAV_FORMAT_Chunk;
  data                        :TQUB_QFS_QDF_WAV_DATA_Chunk;
end;


implementation


//******************************************************************************
end.
