{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
// base class for model and data properties forms


unit QUB_QVO_Properties;


interface


uses


Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls;


type


TQUB_QVO_PropertiesForm = class(TForm)


  btnOK                                   :TButton;
  btnApply                                :TButton;
  btnDefault                              :TButton;
  btnReset                                :TButton;
  btnCancel                               :TButton;


  procedure FormShow(Sender: TObject);
  procedure FormKeyPress(Sender: TObject; var Key: Char);
  procedure btnOKClick(Sender: TObject);
  procedure btnApplyClick(Sender: TObject);
  procedure btnResetClick(Sender: TObject);
  procedure btnDefaultClick(Sender: TObject);


protected


  prPropertyChanged                       :Boolean;

  prOnGetProperties                       :TNotifyEvent;
  prOnPutProperties                       :TNotifyEvent;
  prOnResetProperties                     :TNotifyEvent;
  prOnSetAsDefaultProperties              :TNotifyEvent;


public


  property OnGetProperties                :TNotifyEvent          read prOnGetProperties           write prOnGetProperties;
  property OnPutProperties                :TNotifyEvent          read prOnPutProperties           write prOnPutProperties;
  property OnResetProperties              :TNotifyEvent          read prOnResetProperties         write prOnResetProperties;
  property OnSetAsDefaultProperties       :TNotifyEvent          read prOnSetAsDefaultProperties  write prOnSetAsDefaultProperties;


end;


implementation


{$R *.DFM}


//******************************************************************************
procedure TQUB_QVO_PropertiesForm.FormShow(Sender: TObject);
begin
  if Assigned(prOnPutProperties) then begin
    prOnPutProperties(Self);
  end;
  prPropertyChanged := False;
end;

procedure TQUB_QVO_PropertiesForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Word(Key) = VK_ESCAPE then begin
    Key := #0;
    ModalResult := mrCancel;
  end;
end;

procedure TQUB_QVO_PropertiesForm.btnOKClick(Sender: TObject);
begin
  if prPropertyChanged then begin
    if Assigned(prOnGetProperties) then begin
      prOnGetProperties(Self);
    end;
    prPropertyChanged := False;
  end;
end;

procedure TQUB_QVO_PropertiesForm.btnApplyClick(Sender: TObject);
begin
  if Assigned(prOnGetProperties) then begin
    prOnGetProperties(Self);
  end;
  prPropertyChanged := False;
end;

procedure TQUB_QVO_PropertiesForm.btnResetClick(Sender: TObject);
begin
  if Assigned(prOnResetProperties) then begin
    prOnResetProperties(Self);
  end;
  if Assigned(prOnPutProperties) then begin
    prOnPutProperties(Self);
  end;
  prPropertyChanged := False;
end;

procedure TQUB_QVO_PropertiesForm.btnDefaultClick(Sender: TObject);
begin
  if Assigned(prOnGetProperties) then begin
    prOnGetProperties(Self);
  end;
  if Assigned(prOnSetAsDefaultProperties) then begin
    prOnSetAsDefaultProperties(Self);
  end;
end;


//******************************************************************************
end.
