{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
// qub visual data properties


unit QUB_QVO_QVD_XProperties;


interface


uses


Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ComCtrls,
StdCtrls, ExtCtrls, Buttons, Grids,

QUB_Global,

QUB_QVO_QVD_Global,
QUB_QFS_QDF_Global, QUB_Table,
QUB_Profiles,
QUB_Properties,
QUB_QVO_XProperties,
QUB_ExpCond_Editor, QUB_ExpCond_Parameters,
QUB_Node;



type


TQUB_QVO_QVD_XPropertiesForm                = class(TQUB_QVO_XPropertiesForm)


  pagControl                                :TPageControl;
  tabColors                                 :TTabSheet;
  tabDisplay                                :TTabSheet;
  tabGraphics                               :TTabSheet;
  Panel5                                    :TPanel;
  chkTraceChangeOnBreak                     :TCheckBox;
  chkOverlapChannels                        :TCheckBox;
  chkOverlapTraces                          :TCheckBox;
  chkDrawPoints                             :TCheckBox;
  chkDrawInverted                           :TCheckBox;
  chkDrawBaseline                           :TCheckBox;
  chkDrawBaselineNodes                      :TCheckBox;
  Panel6                                    :TPanel;
  Panel7                                    :TPanel;
  Panel8                                    :TPanel;
  Label8                                    :TLabel;
  txtTracesPerPage                          :TEdit;
  Label9                                    :TLabel;
  txtPointsPerTrace                         :TEdit;
  txtCacheSize                              :TEdit;
  udCacheSize                               :TUpDown;
  udPointsPerTrace                          :TUpDown;
  udTracesPerPage                           :TUpDown;
  Panel9                                    :TPanel;
  Label7                                    :TLabel;
  Label3                                    :TLabel;
  Label6                                    :TLabel;
  Label4                                    :TLabel;
  Label18                                   :TLabel;
  Label28                                   :TLabel;
  Label29                                   :TLabel;
  Label5                                    :TLabel;
  Label1                                    :TLabel;
  panColor                                  :TPanel;
  panColorFrame                             :TPanel;
  panColorIdealized                         :TPanel;
  panColorIdealizedSel                      :TPanel;
  panColorBaselineNodes                     :TPanel;
  panColorBaseline                          :TPanel;
  panColorBreak                             :TPanel;
  panColorCurr                              :TPanel;
  panColorSel                               :TPanel;
  panColorBack                              :TPanel;
  Label2                                    :TLabel;
  panColorData0                             :TPanel;
  panColorData1                             :TPanel;
  panColorData2                             :TPanel;
  panColorData3                             :TPanel;
  panColorData4                             :TPanel;
  panColorData5                             :TPanel;
  panColorData6                             :TPanel;
  panColorData7                             :TPanel;
  Label27                                   :TLabel;
  Label26                                   :TLabel;
  Label22                                   :TLabel;
  Label25                                   :TLabel;
  Label24                                   :TLabel;
  Label23                                   :TLabel;
  Label21                                   :TLabel;
  Label20                                   :TLabel;
  Label36                                   :TLabel;
  panColorSelList                           :TPanel;
  Label34                                   :TLabel;
  Label40                                   :TLabel;
  panColorSegLabel                          :TPanel;
  chkDrawSegLabels                          :TCheckBox;
  Label10                                   :TLabel;
  chkDrawSelList                            :TCheckBox;
  Label30                                   :TLabel;
  Label31                                   :TLabel;
  txtMarginH                                :TEdit;
  Label32                                   :TLabel;
  txtMarginV                                :TEdit;
  Panel1                                    :TPanel;
  Label11                                   :TLabel;
  optDrawMode0                              :TRadioButton;
  optDrawMode1                              :TRadioButton;
  optDrawMode2                              :TRadioButton;
  chkDrawRaster                             :TCheckBox;
  chkDrawIdealized                          :TCheckBox;
  chkDrawIdealizedAbove                     :TCheckBox;
  chkDrawIdealizedColor                     :TCheckBox;
  chkChannelVIsible                         :TCheckBox;
  chkFilterOn                               :TCheckBox;
  chkFilterMAOn                             :TCheckBox;
  Label15                                   :TLabel;
  txtFilterFreq                             :TEdit;
  txtFilterMACount                          :TEdit;
  Label33                                   :TLabel;
  Label41                                   :TLabel;
  txtDisplayChannel                         :TEdit;
  udDisplayChannel                          :TUpDown;
  chkAutoScale                              :TCheckBox;
  Label13                                   :TLabel;
  Label14                                   :TLabel;
  txtDataYMax                               :TEdit;
  txtDataYMin                               :TEdit;
  udDataYMin                                :TUpDown;
  udDataYMax                                :TUpDown;
  chkBaselineOn                             :TCheckBox;
  chkDrawListOverlapped                     :TCheckBox;
  Label42                                   :TLabel;
  chkDrawItoG                               :TCheckBox;
  txtDataYMinReal                           :TEdit;
  txtDataYMaxReal                           :TEdit;
    tabData: TTabSheet;
    Label12: TLabel;
    txtChannelIndex: TEdit;
    udChannelIndex: TUpDown;
    Panel3: TPanel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    txtDataChannelName: TEdit;
    txtDataChannelUnits: TEdit;
    txtDataChannelScaling: TEdit;
    Panel2: TPanel;
    Label17: TLabel;
    Label19: TLabel;
    Label16: TLabel;
    txtSamplingFrequency: TEdit;
    txtSamplingTime: TEdit;
    txtScaling: TEdit;
    ComboBox1: TComboBox;
    Label35: TLabel;
    Panel10: TPanel;
    Label43: TLabel;
    txtGraphicsChannel: TEdit;
    udGraphicsChannel: TUpDown;
    Panel4: TPanel;
    chkDrawLabels: TCheckBox;
    Label44: TLabel;
    txtXAxisTickCount: TEdit;
    Label45: TLabel;
    txtYAxisTickCount: TEdit;
    Label46: TLabel;
    txtDataYFactor: TEdit;
    chkDrawActiveThick: TCheckBox;
    chkDrawParameters: TCheckBox;
    txtDataChannelOffset: TEdit;
    lblOffset: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    panColorParameters: TPanel;


  procedure FormCreate(Sender: TObject);
  procedure FormShow(Sender: TObject);
  procedure FormHide(Sender: TObject);

  procedure pagControlChange(Sender: TObject);

  procedure txtTracesPerPageKeyPress(Sender: TObject; var Key: Char);
  procedure txtTracesPerPageExit(Sender: TObject);
  procedure txtPointsPerTraceKeyPress(Sender: TObject; var Key: Char);
  procedure txtPointsPerTraceExit(Sender: TObject);
  procedure udTracesPerPageChanging(Sender: TObject; var AllowChange: Boolean);
  procedure udTracesPerPageClick(Sender: TObject; Button: TUDBtnType);
  procedure udPointsPerTraceChanging(Sender: TObject; var AllowChange: Boolean);
  procedure udPointsPerTraceClick(Sender: TObject; Button: TUDBtnType);
  procedure txtCacheSizeKeyPress(Sender: TObject; var Key: Char);
  procedure txtCacheSizeExit(Sender: TObject);
  procedure udCacheSizeChanging(Sender: TObject; var AllowChange: Boolean);
  procedure udCacheSizeClick(Sender: TObject; Button: TUDBtnType);

  procedure txtScalingExit(Sender: TObject);
  procedure txtScalingKeyPress(Sender: TObject; var Key: Char);
  procedure txtSamplingTimeExit(Sender: TObject);
  procedure txtSamplingTimeKeyPress(Sender: TObject; var Key: Char);
  procedure txtSamplingFrequencyKeyPress(Sender: TObject; var Key: Char);
  procedure txtSamplingFrequencyExit(Sender: TObject);
  procedure udChannelIndexClick(Sender: TObject; Button: TUDBtnType);
  procedure txtDataYMinKeyPress(Sender: TObject; var Key: Char);
  procedure txtDataYMinExit(Sender: TObject);
  procedure txtDataYMaxKeyPress(Sender: TObject; var Key: Char);
  procedure txtDataYMaxExit(Sender: TObject);
  procedure txtDataYFactorKeyPress(Sender: TObject; var Key: Char);
  procedure txtDataYFactorExit(Sender: TObject);
  procedure udDataYMinChanging(Sender: TObject; var AllowChange: Boolean);
  procedure udDataYMinClick(Sender: TObject; Button: TUDBtnType);
  procedure udDataYMaxChanging(Sender: TObject; var AllowChange: Boolean);
  procedure udDataYMaxClick(Sender: TObject; Button: TUDBtnType);
  procedure txtDataChannelNameKeyPress(Sender: TObject; var Key: Char);
  procedure txtDataChannelNameExit(Sender: TObject);
  procedure txtDataChannelUnitsKeyPress(Sender: TObject; var Key: Char);
  procedure txtDataChannelUnitsExit(Sender: TObject);
  procedure txtDataChannelScalingKeyPress(Sender: TObject; var Key: Char);
  procedure txtDataChannelScalingExit(Sender: TObject);
  procedure txtDataChannelOffsetExit(Sender: TObject);
  procedure txtXAxisTickCountKeyPress(Sender: TObject; var Key: Char);
  procedure txtXAxisTickCountExit(Sender: TObject);
  procedure txtYAxisTickCountKeyPress(Sender: TObject; var Key: Char);
  procedure txtYAxisTickCountExit(Sender: TObject);
  procedure udDisplayChannelClick(Sender: TObject; Button: TUDBtnType);
  procedure udGraphicsChannelClick(Sender: TObject; Button: TUDBtnType);
  procedure txtDataChannelOffsetKeyPress(Sender: TObject; var Key: Char);


protected


  grdExpCond                              :TQUB_ExpCond_Editor;
  prExpCond                               :TQUB_ExpCond_Parameters;

  mnuDataProfiles                         :TQUB_ProfileEditBox;
  prDataProfile                           :INode;

  prError                                 :Boolean;

  prData                                  :TObject;

  prADChannelCount                        :Integer;

  prScaling                               :Double;
  prSampling                              :Double;
  prChannelIndex                          :Integer;
  prDataYMin                              :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT] of Integer;
  prDataYMax                              :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT] of Integer;
  prDataYFactor                           :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT] of Double;
  prDataYMinChanging                      :Boolean;
  prDataYMaxChanging                      :Boolean;
  prDataChannelName                       :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT] of String;
  prDataChannelUnits                      :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT] of String;
  prDataChannelScaling                    :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT] of Double;
  prDataChannelOffset                     :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT] of Double;
  prXAxisTickCount                        :Integer;
  prYAxisTickCount                        :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT] of Integer;

  prTracesPerPageChanging                 :Boolean;
  prPointsPerTraceChanging                :Boolean;
  prCacheSizeChanging                     :Boolean;

  procedure prUpdateComponents; override;

  procedure prOnExpCondChange(Sender: TObject);

  procedure prInitDataProfile;
  procedure prOnSetDataProfile(Cat :TQUB_ProfileCat; Updates :INode);

  procedure prSetScaling(s :Double);
  procedure prSetSampling(s :Double);

  procedure prSetADChannelCount(x :Integer);

  procedure prSetChannelIndex(i :Integer);
  procedure prSetDataYMin(Index :Integer; m :Integer);
  function  prGetDataYMin(Index :Integer) :Integer;
  procedure prSetDataYMax(Index :Integer; m :Integer);
  function  prGetDataYMax(Index :Integer) :Integer;
  procedure prSetDataYFactor(Index :Integer; f :Double);
  function  prGetDataYFactor(Index :Integer) :Double;
  procedure prSetDataChannelName(Index :Integer; x :String);
  function prGetDataChannelName(Index :Integer): String;
  procedure prSetDataChannelUnits(Index :Integer; x :String);
  function prGetDataChannelUnits(Index :Integer): String;
  procedure prSetDataChannelScaling(Index :Integer; x :Double);
  function prGetDataChannelScaling(Index :Integer): Double;
  procedure prSetDataChannelOffset(Index :Integer; x :Double);
  function prGetDataChannelOffset(Index :Integer): Double;
  procedure prSetXAxisTickCount(c :Integer);
  function prGetXAxisTickCount: Integer;
  procedure prSetYAxisTickCount(Index :Integer; c :Integer);
  function prGetYAxisTickCount(Index :Integer): Integer;

  function prGetExpCond: INode;
  procedure prSetExpCond(ecNode :INode);


public


  constructor Create(AOwner :TComponent); override;
  destructor Destroy; override;


  property Data                           :TObject               read prData                  write prData;
  property ADChannelCount                 :Integer               read prADChannelCount        write prSetADChannelCount;

  property Scaling                        :Double                read prScaling               write prSetScaling;
  property Sampling                       :Double                read prSampling              write prSetSampling;//Frequency, in kHz

  property DataYMin[Index :Integer]       :Integer               read prGetDataYMin           write prSetDataYMin;
  property DataYMax[Index :Integer]       :Integer               read prGetDataYMax           write prSetDataYMax;
  property DataYFactor[Index :Integer]        :Double            read prGetDataYFactor        write prSetDataYFactor;
  property DataChannelName[Index :Integer]    :String            read prGetDataChannelName    write prSetDataChannelName;
  property DataChannelUnits[Index :Integer]   :String            read prGetDataChannelUnits   write prSetDataChannelUnits;
  property DataChannelScaling[Index :Integer] :Double            read prGetDataChannelScaling write prSetDataChannelScaling;
  property DataChannelOffset[Index :Integer]  :Double            read prGetDataChannelOffset  write prSetDataChannelOffset;
  property XAxisTickCount                 :Integer               read prGetXAxisTickCount     write prSetXAxisTickCount;
  property YAxisTickCount[Index :Integer] :Integer               read prGetYAxisTickCount     write prSetYAxisTickCount;

  property ChannelIndex                   :Integer               read prChannelIndex          write prSetChannelIndex;

  property ExpCond                        :INode                 read prGetExpCond            write prSetExpCond;


end;


implementation


uses


Math,

QUB_QVO_QVD, QUB_GUIInterface;



{$R *.DFM}


constructor TQUB_QVO_QVD_XPropertiesForm.Create(AOwner :TComponent);
begin
  inherited;
  grdExpCond              := TQUB_ExpCond_Editor.Create(Self);
  grdExpCond.Parent       := tabData;
  grdExpCond.Left         := 16;
  grdExpCond.Top          := 184;
  grdExpCond.Width        := 502;
  grdExpCond.Height       := 192;

  prExpCond               := TQUB_ExpCond_Parameters.Create;
  prExpCond.Events.AddEvent('OnChange', prOnExpCondChange);

  prDataProfile             := ProfileMgr['Data'].Active;
  prInitDataProfile;

  mnuDataProfiles             := TQUB_ProfileEditBox.Create(Self);
  mnuDataProfiles.Parent      := tabData;
  mnuDataProfiles.SetBounds(369, 134, 145, mnuDataProfiles.Height);
  mnuDataProfiles.Anchors     := [akRight, akTop];
  mnuDataProfiles.Cat         := 'Data';
end;

destructor TQUB_QVO_QVD_XPropertiesForm.Destroy;
begin
  try
    grdExpCond.ExpCond := nil;
    prExpCond.Free;
  finally
    inherited;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.prUpdateComponents;
begin
  inherited;

  txtTracesPerPage.Text  := IntToStr(Properties['TracesPerPage'].Data[0]);
  txtPointsPerTrace.Text := IntToStr(Properties['PointsPerTrace'].Data[0]);
  txtCacheSize.Text      := IntToStr(Properties['CacheSize'].Data[0] div ONE_MEGABYTE);
end;

procedure TQUB_QVO_QVD_XPropertiesForm.prSetScaling(s :Double);
begin
  prScaling := s;
  txtScaling.Text := FloatToStr(prScaling);
  prPropertyChanged := True;
  prDataProfile['Scaling'].Data[0] := s;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.prSetSampling(s :Double);
begin
  prSampling := s;
  txtSamplingFrequency.Text := FloatToStr(Sampling);
  txtSamplingTime.Text      := FloatToStr(1 / Sampling);
  prPropertyChanged := True;
  prDataProfile['Sampling'].Data[0] := s;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.prSetADChannelCount(x :Integer);
var
  DataChannels            :INode;
  Channel, Last           :INode;
  i                       :Integer;
begin
  DataChannels            := prDataProfile['DataChannels'];
  Channel                 := DataChannels.Find('Channel');
  Last                    := QUB_Node_NULL;
  i                       := 0;
  while (i < x) and not Channel.IsNull do begin
    if Channel['Scaling'].DataType = NODE_DATATYPE_LONGINT then Channel['Scaling'].SetData(1.0/1.0);
    Last                  := Channel;
    Channel               := Channel.SiblingSameName;
    Inc(i);
  end;
  while (i < x) do begin
    Last               := DataChannels.InsertChild(Last, 'Channel');
    Last['Scaling'].SetData(1.0/1.0);
    Last['Offset'].SetData(0.0/1.0);
    Inc(i);
  end;
  while not Channel.IsNull do begin
    DataChannels.RemoveChild(Channel, Last);
    Channel               := Last.SiblingSameName;
  end;

  prADChannelCount := x;
  ChannelIndex := Max(0, Min(x-1, ChannelIndex));
  udChannelIndex.Max      := x-1;
  udDisplayChannel.Max    := x-1;
  udGraphicsChannel.Max   := x-1;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.prSetChannelIndex(i :Integer);
var
  OldPropertyChanged :Boolean;
begin
  OldPropertyChanged := prPropertyChanged;
  prChannelIndex     := i;
  if udChannelIndex.Position <> i then udChannelIndex.Position := i;
  DataYMin[i]           := DataYMin[i];
  DataYMax[i]           := DataYMax[i];
  DataYFactor[i]        := DataYFactor[i];
  DataChannelName[i]    := DataChannelName[i];
  DataChannelUnits[i]   := DataChannelUnits[i];
  DataChannelScaling[i] := DataChannelScaling[i];
  DataChannelOffset[i]  := DataChannelOffset[i];
  YAxisTickCount[i]     := YAxisTickCount[i];
  prPropertyChanged     := OldPropertyChanged;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.prSetDataYMin(Index :Integer; m :Integer);
begin
  prDataYMin[Index] := m;
  if Index = ChannelIndex then begin
    txtDataYMin.Text     := IntToStr(prDataYMin[Index]);
    txtDataYMinReal.Text := FloatToStr(prDataYMin[Index]/(Scaling*DataChannelScaling[Index]) + DataChannelOffset[Index]);
  end;
  prPropertyChanged := True;

  if not prProperties.Find('DataYMin').IsNull then begin
    prProperties['DataYMin'].SetDataElem(Index, m);
  end;
end;

function TQUB_QVO_QVD_XPropertiesForm.prGetDataYMin(Index :Integer) :Integer;
begin
  Result := prDataYMin[Index];
end;

procedure TQUB_QVO_QVD_XPropertiesForm.prSetDataYMax(Index :Integer; m :Integer);
begin
  prDataYMax[Index] := m;
  if Index = ChannelIndex then begin
    txtDataYMax.Text     := IntToStr(prDataYMax[Index]);
    txtDataYMaxReal.Text := FloatToStr(prDataYMax[Index]/(Scaling*DataChannelScaling[Index]) + DataChannelOffset[Index]);
  end;
  prPropertyChanged := True;

  if not prProperties.Find('DataYMax').IsNull then begin
    prProperties['DataYMax'].SetDataElem(Index, m);
  end;
end;

function TQUB_QVO_QVD_XPropertiesForm.prGetDataYMax(Index :Integer) :Integer;
begin
  Result := prDataYMax[Index];
end;

procedure TQUB_QVO_QVD_XPropertiesForm.prSetDataYFactor(Index :Integer; f :Double);
begin
  prDataYFactor[Index] := f;
  if Index = ChannelIndex then begin
    txtDataYFactor.Text := FloatToStr(prDataYFactor[Index]);
  end;
  prPropertyChanged := True;

  if not prProperties.Find('DataYFactor').IsNull then begin
    prProperties['DataYFactor'].SetDataElem(Index, f);
  end;
end;

function TQUB_QVO_QVD_XPropertiesForm.prGetDataYFactor(Index :Integer) :Double;
begin
  Result := prDataYFactor[Index];
end;

procedure TQUB_QVO_QVD_XPropertiesForm.prSetDataChannelName(Index :Integer; x :String);
var
  Ch    :INode;
  i     :Integer;
begin
  prDataChannelName[Index] := x;
  if Index = ChannelIndex then txtDataChannelName.Text := x;
  prPropertyChanged := True;

  Ch    := prDataProfile['DataChannels'].Find('Channel');
  for i := 0 to Index - 1 do begin
    Ch  := Ch.SiblingSameName;
  end;
  Ch['Name'].SetData( x );
end;

function TQUB_QVO_QVD_XPropertiesForm.prGetDataChannelName(Index :Integer) :String;
begin
  Result := prDataChannelName[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD_XPropertiesForm.prSetDataChannelUnits(Index :Integer; x :String);
var
  Ch    :INode;
  i     :Integer;
begin
  prDataChannelUnits[Index] := x;
  if Index = ChannelIndex then txtDataChannelUnits.Text := x;
  prPropertyChanged := True;

  Ch    := prDataProfile['DataChannels'].Find('Channel');
  for i := 0 to Index - 1 do begin
    Ch  := Ch.SiblingSameName;
  end;
  Ch['Units'].SetData( x );
end;

function TQUB_QVO_QVD_XPropertiesForm.prGetDataChannelUnits(Index :Integer): String;
begin
  Result := prDataChannelUnits[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD_XPropertiesForm.prSetDataChannelScaling(Index :Integer; x :Double);
var
  Ch    :INode;
  i     :Integer;
begin
  prDataChannelScaling[Index] := x;
  if Index = ChannelIndex then txtDataChannelScaling.Text := FloatToStr(x);
  prPropertyChanged := True;

  Ch    := prDataProfile['DataChannels'].Find('Channel');
  for i := 0 to Index - 1 do begin
    Ch  := Ch.SiblingSameName;
  end;
  Ch['Scaling'].Data[0] := x;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.prSetDataChannelOffset(Index :Integer; x :Double);
var
  Ch    :INode;
  i     :Integer;
begin
  prDataChannelOffset[Index] := x;
  if Index = ChannelIndex then txtDataChannelOffset.Text := FloatToStr(x);
  prPropertyChanged := True;

  Ch    := prDataProfile['DataChannels'].Find('Channel');
  for i := 0 to Index - 1 do begin
    Ch  := Ch.SiblingSameName;
  end;
  Ch['Offset'].SetData(x);
end;

//Graphics settings
function TQUB_QVO_QVD_XPropertiesForm.prGetXAxisTickCount: Integer;
begin
  Result := prXAxisTickCount;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.prSetXAxisTickCount(c :Integer);
var
  Ch    :INode;
begin
  prXAxisTickCount := c;
  txtXAxisTickCount.Text := IntToStr(c);
  prPropertyChanged := True;

  Ch    := prDataProfile['Graphics'].Find('XAxisTickCount');
  if not Ch.IsNull then begin
    Ch.SetDataElem(0, c);
  end;
end;

function TQUB_QVO_QVD_XPropertiesForm.prGetYAxisTickCount(Index :Integer): Integer;
begin
  Result := prYAxisTickCount[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD_XPropertiesForm.prSetYAxisTickCount(Index :Integer; c :Integer);
var
  Ch    :INode;
  i     :Integer;
begin
  prYAxisTickCount[Index] := c;
  if Index = ChannelIndex then txtYAxisTickCount.Text := IntToStr(c);
  prPropertyChanged := True;

  Ch    := prDataProfile['Graphics'].Find('Channel');
  if not Ch.IsNull then begin
    for i := 0 to Index - 1 do begin
      Ch  := Ch.SiblingSameName;
    end;
    Ch['YAxisTickCount'].SetDataElem(0, c);
  end;
end;

function TQUB_QVO_QVD_XPropertiesForm.prGetDataChannelScaling(Index :Integer): Double;
begin
  Result := prDataChannelScaling[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

function TQUB_QVO_QVD_XPropertiesForm.prGetDataChannelOffset(Index :Integer): Double;
begin
  Result := prDataChannelOffset[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

//Events ***********************************************************************

//Form *************************************************************************
procedure TQUB_QVO_QVD_XPropertiesForm.FormCreate(Sender: TObject);
var
  Indexed        :TQUB_Property_Indexer;
  Prop           :TQUB_Property;
begin
  inherited;

  prChannelIndex := -1;
  udChannelIndex.Max := QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1;

  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color Back"]',
                          panColorBack));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color Sel"]',
                          panColorSel));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color Curr"]',
                          panColorCurr));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color Break"]',
                          panColorBreak));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color Baseline"]',
                          panColorBaseline));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color BaselineNodes"]',
                          panColorBaselineNodes));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color Idealized"]',
                          panColorIdealized));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color IdealizedSel"]',
                          panColorIdealizedSel));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color Frame"]',
                          panColorFrame));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color"]',
                          panColor));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color SelList"]',
                          panColorSelList));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color Parameters"]',
                          panColorParameters));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color SegLabel"]',
                          panColorSegLabel));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color Data 0"]',
                          panColorData0));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color Data 1"]',
                          panColorData1));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color Data 2"]',
                          panColorData2));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color Data 3"]',
                          panColorData3));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color Data 4"]',
                          panColorData4));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color Data 5"]',
                          panColorData5));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color Data 6"]',
                          panColorData6));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Color Data 7"]',
                          panColorData7));
  { managed manually in event handlers and prUpdateComponents
  AddUpDownProperty(TQUB_Property_UpDown.Create('["TracesPerPage"]',
                      udTracesPerPage,
                      txtTracesPerPage,
                      AcceptIntBetween(udTracesPerPage.Min, udTracesPerPage.Max)));
  AddUpDownProperty(TQUB_Property_UpDown.Create('["PointsPerTrace"]',
                      udPointsPerTrace,
                      txtPointsPerTrace,
                      AcceptIntBetween(udPointsPerTrace.Min, udPointsPerTrace.Max)));
  AddUpDownProperty(TQUB_Property_UpDown.Create('["CacheSize"]',
                      udCacheSize,
                      txtCacheSize,
                      AcceptIntBetween(udCacheSize.Min, udCacheSize.Max)));
  }
  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["DrawMode"]')
            .AddButton(TQUB_Property_RadioButton.Create(optDrawMode0, 0))
            .AddButton(TQUB_Property_RadioButton.Create(optDrawMode1, 1))
            .AddButton(TQUB_Property_RadioButton.Create(optDrawMode2, 2))
                        );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DrawRaster"]',
                        chkDrawRaster) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DrawLabels"]',
                        chkDrawLabels) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DrawIdealized"]',
                        chkDrawIdealized)
                      .Enables(chkDrawIdealizedAbove)
                      .Enables(chkDrawIdealizedColor)
                      );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DrawIdealizedAbove"]',
                        chkDrawIdealizedAbove));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DrawIdealizedColor"]',
                        chkDrawIdealizedColor));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DrawListOverlapped"]',
                        chkDrawListOverlapped)
                      );

  AddEditProperty(TQUB_Property_Edit.Create('["MarginH"]',
                    txtMarginH,
                    AcceptIntBetween(QUB_QVO_QVD_MIN_MARGIN, QUB_QVO_QVD_MAX_MARGIN),
                    ''));
  AddEditProperty(TQUB_Property_Edit.Create('["MarginV"]',
                    txtMarginV,
                    AcceptIntBetween(QUB_QVO_QVD_MIN_MARGIN, QUB_QVO_QVD_MAX_MARGIN),
                    ''));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["TraceChangeOnBreak"]',
                        chkTraceChangeOnBreak) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["OverlapChannels"]',
                        chkOverlapChannels) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["OverlapTraces"]',
                        chkOverlapTraces) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DrawPoints"]',
                        chkDrawPoints) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DrawInverted"]',
                        chkDrawInverted) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DrawActiveThick"]',
                        chkDrawActiveThick));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DrawBaseline"]',
                        chkDrawBaseline) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DrawBaselineNodes"]',
                        chkDrawBaselineNodes) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DrawSegLabels"]',
                        chkDrawSegLabels) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DrawSelList"]',
                        chkDrawSelList) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DrawParameters"]',
                        chkDrawParameters) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["AutoScale"]',
                        chkAutoScale) );

  Indexed := TQUB_Property_Indexer.Create(udDisplayChannel, 0);
  AddIndexer(Indexed);

  //DataYMin/Max
  Prop    := TQUB_Property_Edit.Create('["DataYMin"]', txtDataYMin, AcceptIntBetween(QUB_QVO_QVD_MIN_DATAY, QUB_QVO_QVD_MAX_DATAY), '');
  AddEditProperty(TQUB_Property_Edit(Prop));
  Indexed.Add(Prop);
  Prop    := TQUB_Property_Edit.Create('["DataYMax"]', txtDataYMax, AcceptIntBetween(QUB_QVO_QVD_MIN_DATAY, QUB_QVO_QVD_MAX_DATAY), '');
  AddEditProperty(TQUB_Property_Edit(Prop));
  Indexed.Add(Prop);

  //TO DO: LM
  //Draw ItoG
  //Prop    := TQUB_Property_CheckBox.Create('["DrawItoG"]', chkDrawItoG);
  //AddCheckBoxProperty(TQUB_Property_CheckBox(Prop));
  //Indexed.Add(Prop);

  Prop    := TQUB_Property_CheckBox.Create('["ChannelVisible"]', chkChannelVisible );
  AddCheckBoxProperty( TQUB_Property_CheckBox(Prop) );
  Indexed.Add( Prop );

  Prop    := TQUB_Property_CheckBox.Create('["FilterOn"]', chkFilterOn );
  AddCheckBoxProperty( TQUB_Property_CheckBox(Prop) );
  Indexed.Add( Prop );

  Prop    := TQUB_Property_CheckBox.Create('["FilterMAOn"]', chkFilterMAOn );
  AddCheckBoxProperty( TQUB_Property_CheckBox(Prop) );
  Indexed.Add( Prop );

  Prop    := TQUB_Property_Edit.Create('["FilterFreq"]', txtFilterFreq,
                    //TO DO: this below crashes on my computer. LM
                    //'lambda x: acceptFloatBetw('+FloatToStr(QUB_QVO_QVD_MIN_FILTERFREQ/1000)+', '+FloatToStr(QUB_QVO_QVD_MAX_FILTERFREQ/1000)+', x) * 1000.0',
                    'lambda x: acceptFloatBetween('+FloatToStr(QUB_QVO_QVD_MIN_FILTERFREQ/1000)+', '+FloatToStr(QUB_QVO_QVD_MAX_FILTERFREQ/1000)+')(x) * 1000.0',
                    'lambda node, ix: str(node.data[ix] / 1000.0)');
  AddEditProperty( TQUB_Property_Edit(Prop) );
  Indexed.Add( Prop );

  Prop    := TQUB_Property_Edit.Create('["FilterMACount"]', txtFilterMACount,
                    AcceptIntBetween(QUB_QVO_QVD_MIN_FILTERMACOUNT, QUB_QVO_QVD_MAX_FILTERMACOUNT),
                    '');
  AddEditProperty( TQUB_Property_Edit(Prop) );
  Indexed.Add( Prop );

  Prop    := TQUB_Property_CheckBox.Create('["BaselineOn"]', chkBaselineOn );
  AddCheckBoxProperty( TQUB_Property_CheckBox(Prop) );
  Indexed.Add( Prop );

  ProfileCatName       := 'QVD';

  WikiTopic            := 'Data_Properties';

end;

procedure TQUB_QVO_QVD_XPropertiesForm.FormShow(Sender: TObject);
begin
  inherited;

  prOnSetDataProfile(ProfileMgr['Data'], prDataProfile);
  ProfileMgr['Data'].OnSet := prOnSetDataProfile;

  ChannelIndex := ChannelIndex;
  udDisplayChannel.Position := ChannelIndex;
  udGraphicsChannel.Position := ChannelIndex;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.FormHide(Sender: TObject);
begin
  inherited;

  ChannelIndex := 0; // so it doesn't come back next file too large
  ProfileMgr['Data'].OnSet := nil;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.pagControlChange(Sender: TObject);
begin
  inherited;
  mnuProfiles.Visible     :=    (pagControl.ActivePage = tabColors)
                             or (pagControl.ActivePage = tabDisplay);
end;

procedure TQUB_QVO_QVD_XPropertiesForm.prInitDataProfile;
var
  Node            :INode;
  function HasData(const Name :String): Boolean;
  begin
    Node          := prDataProfile[Name];
    Result        := Node.DataCount > 0;
  end;
begin
  if not HasData('Sampling')       then Node.SetData(QUB_QVO_QVD_DEF_SAMPLING);    //TO DO: 1/ ???
  if not HasData('Scaling')        then Node.SetData(QUB_QVO_QVD_DEF_SCALING);

  prOnSetDataProfile(ProfileMgr['Data'], prDataProfile);
end;

procedure TQUB_QVO_QVD_XPropertiesForm.prOnSetDataProfile(Cat :TQUB_ProfileCat; Updates :INode);
var
  Node            :INode;
  i               :Integer;
  function HasData(const Name :String): Boolean;
  begin
    Node          := Updates.Find(Name);
    Result        := Node.DataCount > 0;
  end;
begin
  if HasData('Sampling')       then Sampling       := Node.Data[0];
  if HasData('Scaling')        then Scaling        := Node.Data[0];
  try
    //DataChannels
    Node          := Updates.Find('DataChannels').Find('Channel');
    i             := 0;
    while (i < ADChannelCount) and not Node.IsNull do begin
      DataChannelName[i]     := Node['Name'].DataAsString;
      DataChannelUnits[i]    := Node['Units'].DataAsString;
      DataChannelScaling[i]  := Node['Scaling'].Data[0];
      if Node['Offset'].DataCount > 0 then DataChannelOffset[i]   := Node['Offset'].Data[0];
      Node                   := Node.SiblingSameName;
      Inc(i);
    end;
    //Graphics settings
    Node := Updates.Find('Graphics').Find('XAxisTickCount');
    if not Node.IsNull then XAxisTickCount := Node.Data[0];
    Node          := Updates.Find('Graphics').Find('Channel');
    i             := 0;
    while (i < ADChannelCount) and not Node.IsNull do begin
      YAxisTickCount[i]      := Node['YAxisTickCount'].Data[0];
      Node                   := Node.SiblingSameName;
      Inc(i);
    end;
  except
  end;
end;


//Page *************************************************************************
procedure TQUB_QVO_QVD_XPropertiesForm.txtTracesPerPageKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtTracesPerPageExit(Sender);
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtTracesPerPageExit(Sender: TObject);
var
  Trc :Integer;
  Old :Integer;
begin
  inherited;
  prError := False;
  Old     := Properties['TracesPerPage'].Data[0];
  try
    Trc := StrToInt(TEdit(Sender).Text);
    if ((Trc < QUB_QVO_QVD_MIN_TRACESPERPAGE) or (Trc > QUB_QVO_QVD_MAX_TRACESPERPAGE)) then raise Exception.Create('');
  except
    prError := True;
    MessageDlg('Invalid value; must be between ' + IntToStr(QUB_QVO_QVD_MIN_TRACESPERPAGE) + ' and ' + IntToStr(QUB_QVO_QVD_MAX_TRACESPERPAGE), mtError, [mbOK], 0);
    TEdit(Sender).Text := IntToStr(Old);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if Trc <> Old then begin
    Properties['TracesPerPage'].Data[0] := Trc;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtPointsPerTraceKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtPointsPerTraceExit(Sender);
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtPointsPerTraceExit(Sender: TObject);
var
  Pts :Integer;
  Old :Integer;
begin
  inherited;
  prError := False;
  Old     := Properties['PointsPerTrace'].Data[0];
  try
    Pts := StrToInt(TEdit(Sender).Text);
    if ((Pts < QUB_QVO_QVD_MIN_POINTSPERTRACE) or (Pts > QUB_QVO_QVD_MAX_POINTSPERTRACE)) then raise Exception.Create('');
  except
    prError := True;
    MessageDlg('Invalid value; must be between ' + IntToStr(QUB_QVO_QVD_MIN_POINTSPERTRACE) + ' and ' + IntToStr(QUB_QVO_QVD_MAX_POINTSPERTRACE), mtError, [mbOK], 0);
    TEdit(Sender).Text := IntToStr(Old);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if Pts <> Old then begin
    Properties['PointsPerTrace'].Data[0] := Pts;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.udTracesPerPageChanging(Sender: TObject; var AllowChange: Boolean);
begin
  inherited;
  AllowChange := True;
  if not prTracesPerPageChanging then begin
    prTracesPerPageChanging := True;
    try
      udTracesPerPage.Position := 2;
    finally
      prTracesPerPageChanging := False;
    end;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.udTracesPerPageClick(Sender: TObject; Button: TUDBtnType);
var
  Trc :Integer;
  Old :Integer;
begin
  inherited;
  Trc := Properties['TracesPerPage'].Data[0];
  Old := Trc;
  if Button = btPrev then begin
    if          Trc >= 20 then begin
      Dec(Trc, 10);
    end else if Trc >= 2 then begin
      Dec(Trc, 1);
    end;
    if Trc < QUB_QVO_QVD_MIN_TRACESPERPAGE then Trc := QUB_QVO_QVD_MIN_TRACESPERPAGE;
  end else begin
    if          Trc >= 10 then begin
      Inc(Trc, 10);
    end else if Trc >= 1 then begin
      Inc(Trc, 1);
    end;
    if Trc > QUB_QVO_QVD_MAX_TRACESPERPAGE then Trc := QUB_QVO_QVD_MAX_TRACESPERPAGE;
  end;
  if Trc <> Old then begin
    Properties['TracesPerPage'].Data[0] := Trc;
    txtTracesPerPage.Text := IntToStr(Trc);
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.udPointsPerTraceChanging(Sender: TObject; var AllowChange: Boolean);
begin
  inherited;
  AllowChange := True;
  if not prPointsPerTraceChanging then begin
    prPointsPerTraceChanging := True;
    try
      udPointsPerTrace.Position := 2;
    finally
      prPointsPerTraceChanging := False;
    end;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.udPointsPerTraceClick(Sender: TObject; Button: TUDBtnType);
var
  Pts :Integer;
  Old :Integer;
begin
  inherited;
  Pts := Properties['PointsPerTrace'].Data[0];
  Old := Pts;
  if Button = btPrev then begin
    if          Pts >= 2000000 then begin
      Dec(Pts, 1000000);
    end else if Pts >= 200000 then begin
      Dec(Pts, 100000);
    end else if Pts >= 20000 then begin
      Dec(Pts, 10000);
    end else if Pts >= 2000 then begin
      Dec(Pts, 1000);
    end else if Pts >= 200 then begin
      Dec(Pts, 100);
    end else if Pts >= 20 then begin
      Dec(Pts, 10);
    end else if Pts >  2 then begin
      Dec(Pts, 1);
    end;
    if Pts < QUB_QVO_QVD_MIN_POINTSPERTRACE then Pts := QUB_QVO_QVD_MIN_POINTSPERTRACE;
  end else begin
    if          Pts >= 1000000 then begin
      Inc(Pts, 1000000);
    end else if Pts >= 100000 then begin
      Inc(Pts, 100000);
    end else if Pts >= 10000 then begin
      Inc(Pts, 10000);
    end else if Pts >= 1000 then begin
      Inc(Pts, 1000);
    end else if Pts >= 100 then begin
      Inc(Pts, 100);
    end else if Pts >= 10 then begin
      Inc(Pts, 10);
    end else if Pts >  1 then begin
      Inc(Pts, 1);
    end;
    if Pts > QUB_QVO_QVD_MAX_POINTSPERTRACE then Pts := QUB_QVO_QVD_MAX_POINTSPERTRACE;
  end;
  if Pts <> Old then begin
    Properties['PointsPerTrace'].Data[0] := Pts;
    txtPointsPerTrace.Text := IntToStr(Pts);
  end;
end;


procedure TQUB_QVO_QVD_XPropertiesForm.txtCacheSizeKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtCacheSizeExit(Sender);
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtCacheSizeExit(Sender: TObject);
var
  Cac :Integer;
  Old :Integer;
begin
  inherited;
  prError := False;
  Old     := Properties['CacheSize'].Data[0];
  try
    Cac := StrToInt(TEdit(Sender).Text) * ONE_MEGABYTE;
    if ((Cac < QUB_QVO_QVD_MIN_CACHESIZE) or (Cac > QUB_QVO_QVD_MAX_CACHESIZE)) then raise Exception.Create('');
  except
    prError := True;
    MessageDlg('Invalid value; must be between ' + IntToStr(QUB_QVO_QVD_MIN_CACHESIZE div ONE_MEGABYTE) + ' and ' + IntToStr(QUB_QVO_QVD_MAX_CACHESIZE div ONE_MEGABYTE), mtError, [mbOK], 0);
    TEdit(Sender).Text := IntToStr(Old div ONE_MEGABYTE);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if Cac <> Old then begin
    Properties['CacheSize'].Data[0] := Cac;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.udCacheSizeChanging(Sender: TObject; var AllowChange: Boolean);
begin
  inherited;
  AllowChange := True;
  if not prCacheSizeChanging then begin
    prCacheSizeChanging := True;
    try
      udCacheSize.Position := 2;
    finally
      prCacheSizeChanging := False;
    end;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.udCacheSizeClick(Sender: TObject; Button: TUDBtnType);
var
  Cac :Integer;
  Old :Integer;
begin
  inherited;
  Cac := Properties['CacheSize'].Data[0] div ONE_MEGABYTE;
  Old := Cac;
  if Button = btPrev then begin
    if          Cac >= 200 then begin
      Dec(Cac, 100);
    end else if Cac >= 20 then begin
      Dec(Cac, 10);
    end else if Cac >= 2 then begin
      Dec(Cac, 1);
    end;
    if Cac * ONE_MEGABYTE < QUB_QVO_QVD_MIN_CACHESIZE then Cac := QUB_QVO_QVD_MIN_CACHESIZE div ONE_MEGABYTE;
  end else begin
    if          Cac >= 100 then begin
      Inc(Cac, 100);
    end else if Cac >= 10 then begin
      Inc(Cac, 10);
    end else if Cac >= 1 then begin
      Inc(Cac, 1);
    end;
    if Cac * ONE_MEGABYTE > QUB_QVO_QVD_MAX_CACHESIZE then Cac := QUB_QVO_QVD_MAX_CACHESIZE div ONE_MEGABYTE;
  end;
  if Cac <> Old then begin
    Properties['CacheSize'].Data[0] := Cac * ONE_MEGABYTE;
    txtCacheSize.Text      := IntToStr(Cac);
  end;
end;

//******************************************************************************
procedure TQUB_QVO_QVD_XPropertiesForm.udChannelIndexClick(Sender: TObject; Button: TUDBtnType);
begin
  inherited;
  ChannelIndex := TUpDown(Sender).Position;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.udDisplayChannelClick(Sender: TObject; Button: TUDBtnType);
begin
  inherited;
  ChannelIndex := TUpDown(Sender).Position;
  DataYMin[ChannelIndex]    := DataYMin[ChannelIndex];
  DataYMax[ChannelIndex]    := DataYMax[ChannelIndex];
  DataYFactor[ChannelIndex] := DataYFactor[ChannelIndex];
end;

procedure TQUB_QVO_QVD_XPropertiesForm.udGraphicsChannelClick(Sender: TObject; Button: TUDBtnType);
begin
  inherited;
  ChannelIndex := TUpDown(Sender).Position;
  YAxisTickCount[ChannelIndex] := YAxisTickCount[ChannelIndex];
end;


procedure TQUB_QVO_QVD_XPropertiesForm.txtDataYMinKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtDataYMinExit(Sender);
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtDataYMinExit(Sender: TObject);
var
  Min  :Integer;
  MinR :Double;
begin
  inherited;
  prError := False;
  if TEdit(Sender).Tag = 0 then begin
    try
      Min := StrToInt(TEdit(Sender).Text);
      if ((Min < QUB_QVO_QVD_MIN_DATAY) or (Min > QUB_QVO_QVD_MAX_DATAY)) then raise Exception.Create('');
    except
      prError := True;
      MessageDlg('Invalid value; must be between ' + IntToStr(QUB_QVO_QVD_MIN_DATAY) + ' and ' + IntToStr(QUB_QVO_QVD_MIN_DATAY), mtError, [mbOK], 0);
      TEdit(Sender).Text := IntToStr(DataYMin[ChannelIndex]);
      TEdit(Sender).SetFocus;
      Exit;
    end;
  end else begin
    try
      MinR := StrToFloat(TEdit(Sender).Text);
      Min  := Round((MinR-DataChannelOffset[ChannelIndex])*Scaling*DataChannelScaling[ChannelIndex]);
      if DataChannelScaling[ChannelIndex] > 0 then begin
        if ((MinR < (QUB_QVO_QVD_MIN_DATAY/(Scaling*DataChannelScaling[ChannelIndex])+DataChannelOffset[ChannelIndex])) or (MinR > (QUB_QVO_QVD_MAX_DATAY/(Scaling*DataChannelScaling[ChannelIndex])+DataChannelOffset[ChannelIndex]))) then raise Exception.Create('');
      end else begin
        if ((MinR < (QUB_QVO_QVD_MAX_DATAY/(Scaling*DataChannelScaling[ChannelIndex])+DataChannelOffset[ChannelIndex])) or (MinR > (QUB_QVO_QVD_MIN_DATAY/(Scaling*DataChannelScaling[ChannelIndex])+DataChannelOffset[ChannelIndex]))) then raise Exception.Create('');
      end;
    except
      prError := True;
      if DataChannelScaling[ChannelIndex] > 0 then begin
        MessageDlg('Invalid value; must be between ' + FloatToStr((QUB_QVO_QVD_MIN_DATAY/(Scaling*DataChannelScaling[ChannelIndex])+DataChannelOffset[ChannelIndex])) + ' and ' + FloatToStr((QUB_QVO_QVD_MAX_DATAY/(Scaling*DataChannelScaling[ChannelIndex])+DataChannelOffset[ChannelIndex])), mtError, [mbOK], 0);
      end else begin
        MessageDlg('Invalid value; must be between ' + FloatToStr((QUB_QVO_QVD_MAX_DATAY/(Scaling*DataChannelScaling[ChannelIndex])+DataChannelOffset[ChannelIndex])) + ' and ' + FloatToStr((QUB_QVO_QVD_MIN_DATAY/(Scaling*DataChannelScaling[ChannelIndex])+DataChannelOffset[ChannelIndex])), mtError, [mbOK], 0);
      end;
      TEdit(Sender).Text := FloatToStr(DataYMin[ChannelIndex]/(Scaling*DataChannelScaling[ChannelIndex])+DataChannelOffset[ChannelIndex]);
      TEdit(Sender).SetFocus;
      Exit;
    end;
  end;
  if Min <> DataYMin[ChannelIndex] then begin
    DataYMin[ChannelIndex] := Min;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtDataYMaxKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtDataYMaxExit(Sender);
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtDataYMaxExit(Sender: TObject);
var
  Max :Integer;
  MaxR :Double;
begin
  inherited;
  prError := False;
  if TEdit(Sender).Tag = 0 then begin
    try
      Max := StrToInt(TEdit(Sender).Text);
      if ((Max < QUB_QVO_QVD_MIN_DATAY) or (Max > QUB_QVO_QVD_MAX_DATAY)) then raise Exception.Create('');
    except
      prError := True;
      MessageDlg('Invalid value; must be between ' + IntToStr(QUB_QVO_QVD_MIN_DATAY) + ' and ' + IntToStr(QUB_QVO_QVD_MIN_DATAY), mtError, [mbOK], 0);
      TEdit(Sender).Text := IntToStr(DataYMax[ChannelIndex]);
      TEdit(Sender).SetFocus;
      Exit;
    end;
  end else begin
    try
      MaxR := StrToFloat(TEdit(Sender).Text);
      Max  := Round((MaxR-DataChannelOffset[ChannelIndex])*Scaling*DataChannelScaling[ChannelIndex]);
      if DataChannelScaling[ChannelIndex] > 0 then begin
        if ((MaxR < (QUB_QVO_QVD_MIN_DATAY/(Scaling*DataChannelScaling[ChannelIndex])+DataChannelOffset[ChannelIndex])) or (MaxR > (QUB_QVO_QVD_MAX_DATAY/(Scaling*DataChannelScaling[ChannelIndex]))+DataChannelOffset[ChannelIndex])) then raise Exception.Create('');
      end else begin
        if ((MaxR < (QUB_QVO_QVD_MAX_DATAY/(Scaling*DataChannelScaling[ChannelIndex])+DataChannelOffset[ChannelIndex])) or (MaxR > (QUB_QVO_QVD_MIN_DATAY/(Scaling*DataChannelScaling[ChannelIndex]))+DataChannelOffset[ChannelIndex])) then raise Exception.Create('');
      end;
    except
      prError := True;
      if DataChannelScaling[ChannelIndex] > 0 then begin
        MessageDlg('Invalid value; must be between ' + FloatToStr(QUB_QVO_QVD_MIN_DATAY/(Scaling*DataChannelScaling[ChannelIndex])+DataChannelOffset[ChannelIndex]) + ' and ' + FloatToStr(QUB_QVO_QVD_MAX_DATAY/(Scaling*DataChannelScaling[ChannelIndex])+DataChannelOffset[ChannelIndex]), mtError, [mbOK], 0);
      end else begin
        MessageDlg('Invalid value; must be between ' + FloatToStr(QUB_QVO_QVD_MAX_DATAY/(Scaling*DataChannelScaling[ChannelIndex])+DataChannelOffset[ChannelIndex]) + ' and ' + FloatToStr(QUB_QVO_QVD_MIN_DATAY/(Scaling*DataChannelScaling[ChannelIndex])+DataChannelOffset[ChannelIndex]), mtError, [mbOK], 0);
      end;
      TEdit(Sender).Text := FloatToStr(DataYMax[ChannelIndex]/(Scaling*DataChannelScaling[ChannelIndex])+DataChannelOffset[ChannelIndex]);
      TEdit(Sender).SetFocus;
      Exit;
    end;
  end;
  if Max <> DataYMax[ChannelIndex] then begin
    DataYMax[ChannelIndex] := Max;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtDataYFactorKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtDataYFactorExit(Sender);
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtDataYFactorExit(Sender: TObject);
var
  F :Double;
begin
  inherited;
  prError := False;
  try
    F := StrToFloat(TEdit(Sender).Text);
  except
    prError := True;
    MessageDlg('Invalid value', mtError, [mbOK], 0);
    TEdit(Sender).Text := FloatToStr(DataYFactor[ChannelIndex]);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if F <> DataYFactor[ChannelIndex] then begin
    DataYFactor[ChannelIndex] := F;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.udDataYMinChanging(Sender: TObject; var AllowChange: Boolean);
begin
  inherited;
  AllowChange := True;
  if not prDataYMinChanging then begin
    prDataYMinChanging := True;
    try
      udDataYMin.Position := 2;
    finally
      prDataYMinChanging := False;
    end;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.udDataYMinClick(Sender: TObject; Button: TUDBtnType);
var
  Min :Integer;
  Sgn :Boolean;
begin
  inherited;
  Min := prDataYMin[ChannelIndex];
  Sgn := Min >= 0;
  Min := Abs(Min);
  if not Sgn then begin
    if Button = btPrev then begin
      Button := btNext;
    end else begin
      Button := btPrev;
    end;
  end;
  if Button = btPrev then begin
    if          Min >= 20000000 then begin
      Dec(Min, 10000000);
    end else if Min >= 2000000 then begin
      Dec(Min, 1000000);
    end else if Min >= 200000 then begin
      Dec(Min, 100000);
    end else if Min >= 20000 then begin
      Dec(Min, 10000);
    end else if Min >= 2000 then begin
      Dec(Min, 1000);
    end else if Min >= 200 then begin
      Dec(Min, 100);
    end else if Min >= 20 then begin
      Dec(Min, 10);
    end else if Min >= 0 then begin
      Dec(Min, 1);
    end;
    if Min < QUB_QVO_QVD_MIN_DATAY then Min := QUB_QVO_QVD_MIN_DATAY;
  end else begin
    if          Min >= 10000000 then begin
      Inc(Min, 10000000);
    end else if Min >= 1000000 then begin
      Inc(Min, 1000000);
    end else if Min >= 100000 then begin
      Inc(Min, 100000);
    end else if Min >= 10000 then begin
      Inc(Min, 10000);
    end else if Min >= 1000 then begin
      Inc(Min, 1000);
    end else if Min >= 100 then begin
      Inc(Min, 100);
    end else if Min >= 10 then begin
      Inc(Min, 10);
    end else if Min >= 0 then begin
      Inc(Min, 1);
    end;
    if Min > QUB_QVO_QVD_MAX_DATAY then Min := QUB_QVO_QVD_MAX_DATAY;
  end;
  if not Sgn then Min := -Min;
  if Min <> DataYMin[ChannelIndex] then begin
    DataYMin[ChannelIndex] := Min;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.udDataYMaxChanging(Sender: TObject; var AllowChange: Boolean);
begin
  inherited;
  AllowChange := True;
  if not prDataYMaxChanging then begin
    prDataYMaxChanging := True;
    try
      udDataYMax.Position := 2;
    finally
      prDataYMaxChanging := False;
    end;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.udDataYMaxClick(Sender: TObject; Button: TUDBtnType);
var
  Max :Integer;
  Sgn :Boolean;
begin
  inherited;
  Max := prDataYMax[ChannelIndex];
  Sgn := Max >= 0;
  Max := Abs(Max);
  if not Sgn then begin
    if Button = btPrev then begin
      Button := btNext;
    end else begin
      Button := btPrev;
    end;
  end;
  if Button = btPrev then begin
    if          Max >= 20000000 then begin
      Dec(Max, 10000000);
    end else if Max >= 2000000 then begin
      Dec(Max, 1000000);
    end else if Max >= 200000 then begin
      Dec(Max, 100000);
    end else if Max >= 20000 then begin
      Dec(Max, 10000);
    end else if Max >= 2000 then begin
      Dec(Max, 1000);
    end else if Max >= 200 then begin
      Dec(Max, 100);
    end else if Max >= 20 then begin
      Dec(Max, 10);
    end else if Max >= 0 then begin
      Dec(Max, 1);
    end;
    if Max < QUB_QVO_QVD_MIN_DATAY then Max := QUB_QVO_QVD_MIN_DATAY;
  end else begin
    if          Max >= 10000000 then begin
      Inc(Max, 10000000);
    end else if Max >= 1000000 then begin
      Inc(Max, 1000000);
    end else if Max >= 100000 then begin
      Inc(Max, 100000);
    end else if Max >= 10000 then begin
      Inc(Max, 10000);
    end else if Max >= 1000 then begin
      Inc(Max, 1000);
    end else if Max >= 100 then begin
      Inc(Max, 100);
    end else if Max >= 10 then begin
      Inc(Max, 10);
    end else if Max >= 0 then begin
      Inc(Max, 1);
    end;
    if Max > QUB_QVO_QVD_MAX_DATAY then Max := QUB_QVO_QVD_MAX_DATAY;
  end;
  if not Sgn then Max := -Max;
  if Max <> DataYMax[ChannelIndex] then begin
    DataYMax[ChannelIndex] := Max;
  end;
end;

//Data Channel Units etc. ******************************************************
procedure TQUB_QVO_QVD_XPropertiesForm.txtDataChannelNameKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtDataChannelNameExit(Sender);
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtDataChannelNameExit(Sender: TObject);
begin
  inherited;
  if TEdit(Sender).Text <> DataChannelName[ChannelIndex] then DataChannelName[ChannelIndex] := TEdit(Sender).Text;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtDataChannelUnitsKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtDataChannelUnitsExit(Sender);
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtDataChannelUnitsExit(Sender: TObject);
begin
  inherited;
  if TEdit(Sender).Text <> DataChannelUnits[ChannelIndex] then DataChannelUnits[ChannelIndex] := TEdit(Sender).Text;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtDataChannelScalingKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtDataChannelScalingExit(Sender);
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtDataChannelScalingExit(Sender: TObject);
var
  s           :Double;
begin
  inherited;
  prError := False;
  try
    s := StrToFloat(TEdit(Sender).Text);
    if s = 0.0 then raise Exception.Create('');
    // if ((s < QUB_QVO_QVD_MIN_SCALING) or (s > QUB_QVO_QVD_MAX_SCALING)) then raise Exception.Create('');
  except
    prError := True;
    MessageDlg('Invalid value'{; must be between ' + FloatToStr(QUB_QVO_QVD_MIN_SCALING) + ' and ' + FloatToStr(QUB_QVO_QVD_MAX_SCALING)}, mtError, [mbOK], 0);
    TEdit(Sender).Text := FloatToStr(DataChannelScaling[ChannelIndex]);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if s <> DataChannelScaling[ChannelIndex] then begin
    DataChannelScaling[ChannelIndex] := s;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtDataChannelOffsetKeyPress(
  Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtDataChannelOffsetExit(Sender);
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtDataChannelOffsetExit(Sender: TObject);
var
  s           :Double;
begin
  inherited;
  prError := False;
  try
    s := StrToFloat(TEdit(Sender).Text);
  except
    prError := True;
    MessageDlg('Invalid value', mtError, [mbOK], 0);
    TEdit(Sender).Text := FloatToStr(DataChannelOffset[ChannelIndex]);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if s <> DataChannelOffset[ChannelIndex] then begin
    DataChannelOffset[ChannelIndex] := s;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtXAxisTickCountKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtXAxisTickCountExit(Sender);
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtXAxisTickCountExit(Sender: TObject);
var
  c :Integer;
begin
  inherited;
  prError := False;
  try
    c := StrToInt(TEdit(Sender).Text);
    if ((c < QUB_QVO_QVD_MIN_AXIS_TICKCOUNT) or (c > QUB_QVO_QVD_MAX_AXIS_TICKCOUNT)) then raise Exception.Create('');
  except
    prError := True;
    MessageDlg('Invalid value; must be between ' + IntToStr(QUB_QVO_QVD_MIN_AXIS_TICKCOUNT) + ' and ' + IntToStr(QUB_QVO_QVD_MAX_AXIS_TICKCOUNT), mtError, [mbOK], 0);
    TEdit(Sender).Text := IntToStr(XAxisTickCount);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if c <> XAxisTickCount then begin
    XAxisTickCount := c;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtYAxisTickCountKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtYAxisTickCountExit(Sender);
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtYAxisTickCountExit(Sender: TObject);
var
  c :Integer;
begin
  inherited;
  prError := False;
  try
    c := StrToInt(TEdit(Sender).Text);
    if ((c < QUB_QVO_QVD_MIN_AXIS_TICKCOUNT) or (c > QUB_QVO_QVD_MAX_AXIS_TICKCOUNT)) then raise Exception.Create('');
  except
    prError := True;
    MessageDlg('Invalid value; must be between ' + IntToStr(QUB_QVO_QVD_MIN_AXIS_TICKCOUNT) + ' and ' + IntToStr(QUB_QVO_QVD_MAX_AXIS_TICKCOUNT), mtError, [mbOK], 0);
    TEdit(Sender).Text := IntToStr(YAxisTickCount[ChannelIndex]);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if c <> YAxisTickCount[ChannelIndex] then begin
    YAxisTickCount[ChannelIndex] := c;
  end;
end;

//Default Scaling/Sampling *****************************************************
procedure TQUB_QVO_QVD_XPropertiesForm.txtScalingKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtScalingExit(Sender);
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtScalingExit(Sender: TObject);
var
  s :Extended;
begin
  inherited;
  prError := False;
  try
    s := StrToFloat(TEdit(Sender).Text);
    if ((s < QUB_QVO_QVD_MIN_SCALING) or (s > QUB_QVO_QVD_MAX_SCALING)) then raise Exception.Create('');
  except
    prError := True;
    MessageDlg('Invalid value; must be between ' + FloatToStr(QUB_QVO_QVD_MIN_SCALING) + ' and ' + FloatToStr(QUB_QVO_QVD_MAX_SCALING), mtError, [mbOK], 0);
    TEdit(Sender).Text := FloatToStr(Scaling);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if s <> Scaling then begin
    Scaling := s;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtSamplingFrequencyKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtSamplingFrequencyExit(Sender);
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtSamplingFrequencyExit(Sender: TObject);
var
  s :Extended;
begin
  inherited;
  prError := False;
  try
    s := StrToFloat(TEdit(Sender).Text);
    if ((s < QUB_QVO_QVD_MIN_SAMPLING) or (s > QUB_QVO_QVD_MAX_SAMPLING)) then raise Exception.Create('');
  except
    prError := True;
    MessageDlg('Invalid value; must be between ' + FloatToStr(QUB_QVO_QVD_MIN_SAMPLING) + ' and ' + FloatToStr(QUB_QVO_QVD_MAX_SAMPLING), mtError, [mbOK], 0);
    TEdit(Sender).Text := FloatToStr(Sampling);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if s <> Sampling then begin
    Sampling := s;
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtSamplingTimeKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtSamplingTimeExit(Sender);
  end;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.txtSamplingTimeExit(Sender: TObject);
var
  s :Extended;
begin
  inherited;
  prError := False;
  try
    s := 1 / StrToFloat(TEdit(Sender).Text);
    if ((s < QUB_QVO_QVD_MIN_SAMPLING) or (s > QUB_QVO_QVD_MAX_SAMPLING)) then raise Exception.Create('');
  except
    prError := True;
    MessageDlg('Invalid value; must be between ' + FloatToStr(QUB_QVO_QVD_MIN_SAMPLING) + ' and ' + FloatToStr(QUB_QVO_QVD_MAX_SAMPLING), mtError, [mbOK], 0);
    TEdit(Sender).Text := FloatToStr(Sampling);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if s <> Sampling then begin
    Sampling := s;
  end;
end;


procedure TQUB_QVO_QVD_XPropertiesForm.prOnExpCondChange(Sender: TObject);
begin
  inherited;
  prPropertyChanged := True;
end;

function TQUB_QVO_QVD_XPropertiesForm.prGetExpCond: INode;
begin
  Result := prExpCond.ToTree;
end;

procedure TQUB_QVO_QVD_XPropertiesForm.prSetExpCond(ecNode :INode);
begin
  prExpCond.Events.DelEvent('OnChange', prOnExpCondChange);
  prExpCond.Clear;
  prExpCond.ReadTree(ecNode);
  prExpCond.Events.AddEvent('OnChange', prOnExpCondChange);
  grdExpCond.ExpCond := prExpCond;
end;


//******************************************************************************
end.



