{

                               Qub Visual Model
                                     unit



(C) 2000 Lorin Milescu
}
{
/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}


//01-31-2000   Creation date

unit QUB_QVO_QVM;


//******************************************************************************
interface


uses


Windows, SysUtils, Classes, Menus, Controls, Messages, Printers, Registry, StdCtrls, ExtCtrls, Dialogs, Math, ComCtrls, Graphics,

AllocTypes, Alloc,
RegistryInterface,

QUB_Console, QUB_Rich_Console,
QUB_Global,
QUB_QFS, QUB_QFS_File,
QUB_QFS_QMF, QUB_QFS_Channels,
QUB_ExpCond_Parameters,
QUB_QVO,
QUB_QVO_QVD_Global,
QUB_QVO_QVM_XProperties,
QUB_QVO_QVM_State_Properties,
QUB_QVO_QVM_Print_Properties,
QUB_Node,
QUB_Q_Global,
QUB_Globals,
ModelEnergyPlot, ModelEnergyPlotProperties,
PythonEngine,
Single_Entry,
QUB_Profiles, QUB_Properties;


const


QUB_QVO_QVM_DEF_COLOR                       :TColor                             = clBtnFace;
QUB_QVO_QVM_DEF_COLORBACK                   :TColor                             = TColor($c5fefb); // clNavy;
QUB_QVO_QVM_DEF_COLORFRAME                  :TColor                             = clWhite;
QUB_QVO_QVM_DEF_COLORLINE                   :TColor                             = clBlack; // clWhite;
QUB_QVO_QVM_DEF_COLORRATE                   :TColor                             = clBlack; // clBtnFace;
QUB_QVO_QVM_DEF_COLORSELECTED               :TColor                             = clRed; 


QUB_QVO_QVM_DEF_STATESIZE                   :Integer                            = 20;
QUB_QVO_QVM_DEF_LINEWIDTH                   :Integer                            = 0;
QUB_QVO_QVM_DEF_ALIGNTOGRID                 :Boolean                            = False;
QUB_QVO_QVM_DEF_USEGLOBALCOND               :Boolean                            = False;

QUB_QVO_QVM_DEF_SCROLLRATES                 :Boolean                            = True;
QUB_QVO_QVM_DEF_DIAGONALRATES               :Boolean                            = False;
QUB_QVO_QVM_DEF_SHOWK1                      :Boolean                            = False;
QUB_QVO_QVM_DEF_ENFORCECONSTRAINTS          :Boolean                            = False;
QUB_QVO_QVM_DEF_I_EQ_F_V                    :Boolean                            = False;

QUB_QVO_QVM_RATE_WIDTH                      :Integer                            = 76;
QUB_QVO_QVM_RATE_HEIGHT                     :Integer                            = 16;
QUB_QVO_QVM_RATE_WIDTH2                     :Integer                            = 38;
QUB_QVO_QVM_RATE_HEIGHT2                    :Integer                            = 8;

QUB_QVO_QVM_LINE_START                                                          = 0;
QUB_QVO_QVM_LINE_MOVE                                                           = 1;
QUB_QVO_QVM_LINE_END                                                            = 2;

QUB_QVO_QVM_HINTZONE_Y                                                          = 25;

//******************************************************************************
type


//Forward class declarations ***************************************************
TQUB_QVO_QVM                                   = class;
TQUB_Python_Model                              = class;


//Object
TQUB_QVO_QVM                                   = class(TQUB_QVO)
protected


  prPyHandle                                   :TQUB_Python_Model; // python surrogate of Self

  prModelObject                                :TQUB_QFS_QMF;

  prCopyRect                                   :TRect;

  prLinePrev                                   :TPoint;
  prLineColor                                  :TColor;

  prHintZone                                   :TPanel;
  txtChannelCount                              :TEdit;
  udChannelCount                               :TUpDown;
  prChannelCountChanging                       :Boolean;

  //Interactive properties - all should be here ********************************

  //Colors
  prColorLine                                  :TColor;
  prColorRate                                  :TColor;
  prColorSelected                              :TColor;

  prStateSize                                  :Integer;
  prLineWidth                                  :Integer;
  prAlignToGrid                                :Boolean;
  prUseGlobalCond                              :Boolean;
  prScrollRates                                :Boolean;
  prDiagonalRates                              :Boolean;
  prShowK1                                     :Boolean;
  prEnforceConstraints                         :Boolean;
  prIeqFv                                      :Boolean;

  prPrintNamedStates                           :Boolean;
  prPrintDrawStatePanel                        :Boolean;
  prPrintDrawStatePanelColor                   :Boolean;
  prPrintStateFontSize                         :Integer;
  prPrintRateFontSize                          :Integer;

  prMarginH                                    :Integer;
  prMarginV                                    :Integer;

  //Flags
  prMouse                                      :TPoint;
  prState                                      :TPoint;
  prMouseLine                                  :TPoint;
  prConnState                                  :TQUB_QFS_State;
  prDoingRate                                  :Boolean;

  prPropertiesForm                             :TQUB_QVO_QVM_XPropertiesForm;
  prStatePropertiesForm                        :TQUB_QVO_QVM_State_PropertiesForm;
  prPrintPropertiesForm                        :TQUB_QVO_QVM_Print_PropertiesForm;

  //Popup menus
  prEqProbItem                                 :TMenuItem;
  prEqProbCalcItem                             :TMenuItem;
  prEqProbCalcAndAssignItem                    :TMenuItem;
  prAdvanceProbItem                            :TMenuItem;
  prMakeStartStateItem                         :TMenuItem;
  prEnforceConstraintsItem                     :TMenuItem;
  prRandomizeRatesItem                         :TMenuItem;
  prEnergyLandscapeItem                        :TMenuItem;
  prUseGlobalCondItem                          :TMenuItem;
  prEditGlobalCondItem                         :TMenuItem;
  prSetIndexItem                               :TMenuItem;
  prUnmergeItem                                :TMenuItem;
  prGrabItem                                   :TMenuItem;
  prGrabAllIncItem                             :TMenuItem;
  prGrabAllDecItem                             :TMenuItem;
  prEditCutItem                                :TMenuItem;
  prEditCopyItem                               :TMenuItem;
  prEditPasteItem                              :TMenuItem;
  prEditDeleteItem                             :TMenuItem;

  //State and Rate used for properties
  prStateForProperties                         :TQUB_QFS_State;
  prRateForProperties                          :TQUB_QFS_Rate;
  prRateIndexForProperties                     :Integer;
  prRateK01ForProperties                       :Integer;
  prPopupTarget                                :TObject;  // the logical popup component may be a rate panel not descended from tcomponent and thus not able to be popupmenu.popupcomponent

  prCurrData                                   :TQUB_QVO;

  prHoverRate                                  :TQUB_QFS_RatePanel;

  prFactors                                    :INode;

  prRateK0                                     :Double;
  prRateK1                                     :Double;
  prRateP                                      :Boolean;
  prRateQ                                      :Boolean;
  prRatePName                                  :String;
  prRateQName                                  :String;
  prRateFormat                                 :String;

  prShowSelectedRate                           :Boolean;

  //----- Default rate values for new rate.
  //Check this
  m_aDefaultRate                               :Array[1..2] of TRate;

  // allow numerical edits e.g. changing a rate, even if LockedWrite
  // but not structural edits e.g. deleting a rate, unless not LockedWrite
  prAllowNumEdit                               :Boolean;

  prSimData                                    :TQUB_QVO;
  prSimStored                                  :IUnknown;

  prLastAdvancePStep                           :Double;


  procedure prCreatePyInstance;
  procedure prCleanupPyInstance;

  //Events
  procedure DoOnFileOpen(Sender :TObject); override;
  procedure DoOnFileClose(Sender :TObject); override;
  procedure DoOnFileEdit(Sender :TObject; EditOper :TQUB_EditOperation; var Param, Param2); override;
  procedure DoOnFileNewState(Sender :TObject);
  procedure DoOnFileOpenState(Sender :TObject);
  procedure DoOnFileNewRate(Sender :TObject);
  procedure DoOnFileOpenRate(Sender :TObject);
  procedure DoOnFileChangeActiveState(Sender :TObject);
  procedure DoOnFileNeedDraw(Sender :TObject);

  //Event setters
  procedure prAddModelEvents(ModelObject :TQUB_QFS_QMF);
  procedure prDelModelEvents(ModelObject :TQUB_QFS_QMF);

  //Draw
  procedure prErase; override;

  procedure prDrawModel;
  procedure prDrawGraphic;
  procedure prDrawObjects;
  procedure prDrawLine(Color :TColor; x, y :Integer; State :Integer);

  procedure prCalcCopyRect;
  procedure prGridPosition(const p :TPoint; var np :TPoint);

  //Print
  function prPrint(Dlg :TPrintDialog) :Boolean; override;

  //Interactive properties
  procedure prSetColor(c :TColor); override;
  procedure prSetColorBack(c :TColor); override;
  procedure prSetColorFrame(c :TColor); override;
  procedure prSetColorLine(c :TColor);
  procedure prSetColorRate(c :TColor);
  procedure prSetColorSelected(c :TColor);
  procedure prSetStateSize(s :Integer);
  procedure prSetLineWidth(w :Integer);
  procedure prSetAlignToGrid(a :Boolean);//There is no grid though...
  procedure prSetUseGlobalCond(a :Boolean);
  procedure prSetScrollRates(a :Boolean);
  procedure prSetDiagonalRates(a :Boolean);
  procedure prSetShowK1(a :Boolean);
  procedure prSetEnforceConstraints(x :Boolean);
  procedure prSetIeqFv(x :Boolean);

  procedure prSetMarginH(m :Integer);
  procedure prSetMarginV(m :Integer);

  //State properties
  procedure prSetStateAmp(Index :Integer; a :Double);
  function  prGetStateAmp(Index :Integer) :Double;
  procedure prSetStateStd(Index :Integer; s :Double);
  function  prGetStateStd(Index :Integer) :Double;
  procedure prSetStateCond(Index :Integer; c :Double);
  function  prGetStateCond(Index :Integer) :Double;
  procedure prSetStateCondStd(Index :Integer; x :Double);
  function  prGetStateCondStd(Index :Integer): Double;
  procedure prSetStateVrev(Index :Integer; x :Double);
  function  prGetStateVrev(Index :Integer): Double;
  procedure prSetStateNar(Index :Integer; n :Integer);
  function  prGetStateNar(Index :Integer) :Integer;
  procedure prSetStateCff(Index1, Index2 :Integer; c :Double);
  function  prGetStateCff(Index1, Index2 :Integer) :Double;

  procedure prModelSetHint;

  procedure prSetInitialProperties; override;
  procedure prCleanupOnOpen;

  function prGetExpCond: TQUB_ExpCond_Parameters;
  procedure prSetExpCond(EC :TQUB_ExpCond_Parameters);

  //Registry
  procedure prPropertiesRegistry(Read :Boolean); override;
  procedure prStatePropertiesRegistry(Read :Boolean);
  procedure prRatePropertiesRegistry(Read :Boolean);
  //****************************************************************************

  //State and Rate properties
  procedure prStateProperties(State :TQUB_QFS_State);
  procedure prRateProperties(Rate :TQUB_QFS_Rate);
  //Check this
  //procedure prRateProperties(Rate :TQUB_QFS_Rate; iIndex : Integer );

  function prGetFileName :String; override;
  function prGetFileExt :String; override;
  function prGetModified :Boolean; override;
  function prGetSaved :Boolean; override;

  //Properties
  procedure prOnGetProperties(Sender :TObject); override;
  procedure prOnPutProperties(Sender :TObject); override;

  //State properties
  procedure prOnStateGetProperties(Sender :TObject);
  procedure prOnStatePutProperties(Sender :TObject);
  procedure prOnStateResetProperties(Sender :TObject);
  procedure prOnStateSetAsDefaultProperties(Sender :TObject);

  //Rate properties
  procedure prOnRateGetProperties(Sender :TObject);
  procedure prOnRatePutProperties(Sender :TObject);
  procedure prOnRateResetProperties(Sender :TObject);
  procedure prOnRateSetAsDefaultProperties(Sender :TObject);

  //Popup Menu
  procedure prCreatePopUpMenu; override;

  //PopUp Menu Events
  procedure prOnEqProbCalc(Sender :TObject);
  procedure prOnEqProbCalcAndAssign(Sender :TObject);
  procedure prOnAdvanceProb(Sender :TObject);
  procedure prOnMakeStartState(Sender :TObject);
  procedure prOnEnforceConstraints(Sender :TObject);
  procedure prOnRandomizeRates(Sender :TObject);
  procedure prOnEnergyLandscape(Sender :TObject);
  procedure prOnUseGlobalCond(Sender :TObject);
  procedure prOnEditGlobalCond(Sender :TObject);
  procedure prOnSetIndex(Sender :TObject);
  procedure prOnUnmerge(Sender :TObject);
  procedure prOnCut(Sender :TObject);
  procedure prOnCopy(Sender :TObject);
  procedure prOnPaste(Sender :TObject);
  procedure prOnDelete(Sender :TObject);
  procedure prOnGrab(Sender :TObject);
  procedure prOnGrabAll(Sender :TObject);
  procedure prOnCopyImage(Sender :TObject); override;
  procedure prOnPrint(Sender :TObject); override;
  procedure prOnProperties(Sender :TObject); override;
  procedure prOnPopUp(Sender :TObject); override;

  function prConfirmRemoveFactors(Action :String): Boolean;

  //Mouse
  procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
  procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  procedure MouseWheel(Sender :TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
  procedure DblClick; override;

  procedure prStateMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure prStateMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  procedure prStateMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure prStateDblClick(Sender: TObject);
  procedure prRateMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure prRateMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  procedure prRateMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure prRateMouseWheel(Sender :TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
  procedure DoOnRateDblClick(Sender :TObject);

  procedure prHintZoneMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure prHintZoneMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  procedure prHintZoneMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure prHintZoneDblClick(Sender: TObject);

  procedure txtChannelCountKeyPress(Sender: TObject; var Key: Char);
  procedure txtChannelCountExit(Sender: TObject);
  procedure udChannelCountClick(Sender: TObject; Button: TUDBtnType);
  procedure udChannelCountChanging(Sender: TObject; var AllowChange: Boolean);

  //Key
  procedure CNKeyDown(var Message: TWMKeyDown); message CN_KEYDOWN;

  procedure prMoveStates(Code :Word; KeyShift :Boolean; KeyControl :Boolean);


  procedure prWriteModelStats;


public


  constructor Create(AOwner :TComponent); override;
  destructor Destroy; override;

  
  procedure Paint; override;
  procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;

  procedure Activate; override;
  procedure DeActivate; override;

  //File .......................................................................
  function New(const FileName :String) :Boolean; override;
  function Open(const FileName :String) :Boolean; override;
  function Open(const FileName :String; OpenStream :TStream) :Boolean; override;
  function Save(const FileName :String) :Boolean; override;
  function Close :Boolean; override;
  function OpenFromString(const MemFile :String) :Boolean; override;
  function SaveToString(var MemFile :String; FileType :Integer) :Boolean; override;

  function CanSaveAs(var FileName :String; Confirmation :Boolean) :Boolean;

  function CopyImage(ShowProperties :Boolean) :Boolean; override;

  function DrawToPos(Canvas :TCanvas; Left, Right, Width, Height :Integer; StatePos :TPAPoint; RatePos :TRatePanelPosList) :Boolean;

  function GetAsNode: INode;
  procedure SetAsNode(ModelNode :INode);
  function MakeNewRateNode: INode;
  
  function Properties :Boolean; override;
  procedure DoOnInitProperties(Sender :TObject);
  procedure DoOnSetProperties(Sender :TQUB_ProfileCat; Updates :INode);


  //Edit .......................................................................
  function AddState(const p :TPoint) :Boolean;
  function DelState(State :TQUB_QFS_State) :Boolean;
  function PosState(State :TQUB_QFS_State; x, y :Integer) :Boolean;
  function AddRate(State1, State2 :TQUB_QFS_State) :Boolean;
  function DelRate(Rate :TQUB_QFS_Rate) :Boolean;

  //Draw .......................................................................
  function Draw :Boolean; override;
  procedure ResizeModel(const NewWidth, NewHeight :Integer);
  procedure MouseToStateRate(x, y :Integer; StatePos :TPAPoint; RatePos :TRatePanelPosList; var StateIdx, RateIdx, HalfIdx, K01 :Integer);

  //Lock
  procedure LockWrite; override;
  procedure UnLockWrite; override;
  procedure LockReadWrite; override;
  procedure UnLockReadWrite; override;


  //Interactive properties
  property ColorLine                           :TColor                             read prColorLine                 write prSetColorLine;
  property ColorRate                           :TColor                             read prColorRate                 write prSetColorRate;
  property ColorSelected                       :TColor                             read prColorSelected             write prSetColorSelected;
  property StateSize                           :Integer                            read prStateSize                 write prSetStateSize;
  property LineWidth                           :Integer                            read prLineWidth                 write prSetLineWidth;
  property AlignToGrid                         :Boolean                            read prAlignToGrid               write prSetAlignToGrid;
  property UseGlobalCond                       :Boolean                            read prUseGlobalCond             write prSetUseGlobalCond;
  property ScrollRates                         :Boolean                            read prScrollRates               write prSetScrollRates;
  property DiagonalRates                       :Boolean                            read prDiagonalRates             write prSetDiagonalRates;
  property ShowK1                              :Boolean                            read prShowK1                    write prSetShowK1;
  property EnforceConstraints                  :Boolean                            read prEnforceConstraints        write prSetEnforceConstraints;
  property IeqFv                               :Boolean                            read prIeqFv                     write prSetIeqFv;

  property PrintNamedStates                    :Boolean                            read prPrintNamedStates          write prPrintNamedStates;
  property PrintDrawStatePanel                 :Boolean                            read prPrintDrawStatePanel       write prPrintDrawStatePanel;
  property PrintDrawStatePanelColor            :Boolean                            read prPrintDrawStatePanelColor  write prPrintDrawStatePanelColor;
  property PrintStateFontSize                  :Integer                            read prPrintStateFontSize        write prPrintStateFontSize;
  property PrintRateFontSize                   :Integer                            read prPrintRateFontSize         write prPrintRateFontSize;

  property MarginH                             :Integer                            read prMarginH                   write prSetMarginH;
  property MarginV                             :Integer                            read prMarginV                   write prSetMarginV;

  property StateAmp[Index :Integer]            :Double                             read prGetStateAmp               write prSetStateAmp;
  property StateStd[Index :Integer]            :Double                             read prGetStateStd               write prSetStateStd;
  property StateCond[Index :Integer]           :Double                             read prGetStateCond              write prSetStateCond;
  property StateCondStd[Index :Integer]        :Double                             read prGetStateCondStd           write prSetStateCondStd;
  property StateVrev[Index :Integer]           :Double                             read prGetStateVrev              write prSetStateVrev;
  property StateNar[Index :Integer]            :Integer                            read prGetStateNar               write prSetStateNar;
  property StateCff[Index1, Index2 :Integer]   :Double                             read prGetStateCff               write prSetStateCff;

  property ModelObject                         :TQUB_QFS_QMF                       read prModelObject;

  property PropertiesForm                      :TQUB_QVO_QVM_XPropertiesForm        read prPropertiesForm            write prPropertiesForm;
  property StatePropertiesForm                 :TQUB_QVO_QVM_State_PropertiesForm  read prStatePropertiesForm       write prStatePropertiesForm;
  property PrintPropertiesForm                 :TQUB_QVO_QVM_Print_PropertiesForm  read prPrintPropertiesForm       write prPrintPropertiesForm;

  property CurrData                            :TQUB_QVO                           read prCurrData                  write prCurrData;
  property Factors                             :INode                              read prFactors                   write prFactors;

  property ExpCond                             :TQUB_ExpCond_Parameters            read prGetExpCond                write prSetExpCond;

  property PyHandle                            :TQUB_Python_Model                  read prPyHandle;

  property ShowSelectedRate                    :Boolean                            read prShowSelectedRate          write prShowSelectedRate;

  property AllowNumEdit                        :Boolean                            read prAllowNumEdit              write prAllowNumEdit;

  property SimData                             :TQUB_QVO                           read prSimData                   write prSimData;                                                       
  property SimStored                           :IUnknown                           read prSimStored                 write prSimStored;


end;
//..............................................................................

TQUB_Python_Model = class(TPyObject)
protected


  prModel              :TQUB_QVO_QVM;

  prSyncNode           :INode;
  prCopyImageConfig    :PPyObject;

  prArgD               :Double;
  prResult             :PPyObject;


  procedure prDoGet;
  procedure prDoSet;
  procedure prCopyImage;
  procedure prCalcPeq;
  procedure prEnforceConstraints;
  procedure prGetAMatrix;


public


  // function  GetAttr(key : PChar) : PPyObject; override;
  //function  SetAttr(key : PChar; value : PPyObject) : Integer; override;

  function GetAsNode(args :PPyObject): PPyObject; cdecl;
  function SetAsNode(args :PPyObject): PPyObject; cdecl;

  function CopyImage( args : PPyObject ) : PPyObject; cdecl;
  function CalcPeq( args : PPyObject ) : PPyObject; cdecl;
  function EnforceConstraints( args : PPyObject ) : PPyObject; cdecl;
  function GetAMatrix(args :PPyObject): PPyObject; cdecl;

  class procedure RegisterMethods( PythonType : TPythonType ); override;


  property Model   :TQUB_QVO_QVM  read prModel   write prModel;


end;


var


ModelPyType                        :TPythonType;


procedure Register;


//******************************************************************************
implementation


uses


QUB_Viewport_Python,
QUB_Python_Thread,
QUB_Node_Python,
QUB_Node_Model,
QUB_Viewport_Data,
QUB_QVO_QVD,
QUB_GUIInterface,
QUB_Viewport_Model,
QUB_Task,
QUB_Task_AMP,
QUB_Main;


//******************************************************************************
//                              TQUB_QVO_QVM
//******************************************************************************
constructor TQUB_QVO_QVM.Create(AOwner :TComponent);
var
  Lbl                             :TLabel;
begin
  inherited Create(AOwner);

  prHintZone                      := TPanel.Create(Self);
  prHintZone.Parent               := Self;
  prHintZone.AutoSize             := False;
  prHintZone.Color                := ColorBack;
  prHintZone.BevelOuter           := bvNone;
  prHintZone.SetBounds(MarginH, MarginV, Width-2*MarginH, QUB_QVO_QVM_HINTZONE_Y);
  prHintZone.OnMouseDown          := prHintZoneMouseDown;
  prHintZone.OnMouseMove          := prHintZoneMouseMove;
  prHintZone.OnMouseUp            := prHintZoneMouseUp;
  prHintZone.OnDblClick           := prHintZoneDblClick;
  prHintZone.PopupMenu            := nil;

  udChannelCount                  := TUpDown.Create(Self);
  udChannelCount.Parent           := prHintZone;
  udChannelCount.SetBounds(prHintZone.Width-udChannelCount.Width-10, 0, udChannelCount.Width, udChannelCount.Height);
  udChannelCount.Anchors          := [akTop, akRight];
  udChannelCount.Min              := 1;
  udChannelCount.Max              := High(SmallInt);
  udChannelCount.OnClick          := udChannelCountClick;
  udChannelCount.OnChanging       := udChannelCountChanging;
  txtChannelCount                 := TEdit.Create(Self);
  txtChannelCount.Parent          := prHintZone;
  txtChannelCount.Width           := 50;
  txtChannelCount.SetBounds(udChannelCount.Left-50, 0, 50, txtChannelCount.Height);
  txtChannelCount.Anchors         := [akTop, akRight];
  txtChannelCount.OnExit          := txtChannelCountExit;
  txtChannelCount.OnKeyPress      := txtChannelCountKeyPress;
  udChannelCount.Associate        := txtChannelCount;
  Lbl                             := TLabel.Create(Self);
  Lbl.Parent                      := prHintZone;
  Lbl.Caption                     := 'Channel count: ';
  Lbl.Height                      := prHintZone.Height;
  Lbl.SetBounds(txtChannelCount.Left-Lbl.Width, (prHintZone.Height-Lbl.Height), Lbl.Width, Lbl.Height);
  Lbl.Anchors                     := [akTop, akRight];

  //Create the model object and set its events
  prModelObject                   := TQUB_QFS_QMF.Create(CHANNELS_MODEL_FILE_NAME, nil);
  prModelObject.Permanent := True;

  prAddModelEvents(ModelObject);

  prModelObject.Canvas            := prBitmapCanvas;

  //PopUp Menu
  prCreatePopUpMenu;

  prDrawFocusRect                 := True;

  //To give some initial values, before any calculations are made:
  prSetInitialProperties;

  //Read properties from registry:
  prPropertiesRegistry(True{Read});
  prStatePropertiesRegistry(True{Read});
  prRatePropertiesRegistry(True{Read});
  //Check
  //m_aDefaultRate[1] := TRate.Create;
  //m_aDefaultRate[2] := TRate.Create;
  //ModelRateReadRegistry(m_aDefaultRate[1], m_aDefaultRate[2]);

  ShowHint                        := True;

  //Flags
  prMustRedraw                    := True;

  PythonThread.SneakPyProc( prCreatePyInstance );

  prFactors                       := TNode.CreateNull;

  OnMouseWheel                    := MouseWheel;

  prLastAdvancePStep              := 1e-3;

end;

destructor TQUB_QVO_QVM.Destroy;
begin
  try

    PythonThread.SneakPyProc( prCleanupPyInstance );

    prDelModelEvents(ModelObject);

    prModelObject.Canvas := nil;

    //prModelObject.Reset;

    if ModelObject.Parameters <> nil then begin
      ModelObject.Parameters.Events.DelEvent('OnChange', ModelObject.DoOnParametersChanged);
    end;

    prModelObject.Free;

  finally
    inherited;
  end;
end;

procedure TQUB_QVO_QVM.prCreatePyInstance;
var
  PyInst                  :PPyObject;
begin
  PyInst                  := ModelPyType.CreateInstance;
  prPyHandle              := TQUB_Python_Model( PythonToDelphi(PyInst) );
  prPyHandle.Model        := Self;
end;

procedure TQUB_QVO_QVM.prCleanupPyInstance;
begin
  prPyHandle.Model := nil;
  GetPythonEngine.Py_DECREF( prPyHandle.GetSelf );
end;

//Events;
procedure TQUB_QVO_QVM.prAddModelEvents(ModelObject :TQUB_QFS_QMF);
begin
  ModelObject.OnOpen              := DoOnFileOpen;
  ModelObject.OnClose             := DoOnFileClose;
  ModelObject.OnEdit              := DoOnFileEdit;
  ModelObject.OnNewState          := DoOnFileNewState;
  ModelObject.OnOpenState         := DoOnFileOpenState;
  ModelObject.OnNewRate           := DoOnFileNewRate;
  ModelObject.OnOpenRate          := DoOnFileOpenRate;
  ModelObject.OnChangeActiveState := DoOnFileChangeActiveState;
  ModelObject.OnNeedDraw          := DoOnFileNeedDraw;
  ModelObject.OnInitProperties    := DoOnInitProperties;
  ModelObject.OnSetProperties     := DoOnSetProperties;
end;

procedure TQUB_QVO_QVM.prDelModelEvents(ModelObject :TQUB_QFS_QMF);
begin
  ModelObject.OnOpen              := nil;
  ModelObject.OnClose             := nil;
  ModelObject.OnEdit              := nil;
  ModelObject.OnNewState          := nil;
  ModelObject.OnOpenState         := nil;
  ModelObject.OnNewRate           := nil;
  ModelObject.OnOpenRate          := nil;
  ModelObject.OnChangeActiveState := nil;
  ModelObject.OnNeedDraw          := nil;
  ModelObject.OnInitProperties    := nil;
  ModelObject.OnSetProperties     := nil;
end;

procedure TQUB_QVO_QVM.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
begin
  if prDrawForPrinting then Exit;
  try
    if (AWidth <> Width) or (AHeight <> Height) then begin
      ResizeModel(AWidth, AHeight);
      prMustRedraw := True;
    end;
  finally
    inherited;
  end;
end;


procedure TQUB_QVO_QVM.prCreatePopUpMenu;
var
  ItemPos :Integer;
begin

  inherited;

  ItemPos := 0;

  //EqProb
  prEqProbItem              := AddPopUpMenuItem(0, 'Equilibrium P',        nil,                     prPopUpMenu, ItemPos);
  prEqProbCalcItem          := AddPopUpMenuItem(0, 'Calculate',            prOnEqProbCalc,          nil,         TPInteger(nil)^, prEqProbItem);
  prEqProbCalcAndAssignItem := AddPopUpMenuItem(0, 'Calculate and assign', prOnEqProbCalcAndAssign, nil,         TPInteger(nil)^, prEqProbItem);

  //AdvanceProb
  prAdvanceProbItem         := AddPopUpMenuItem(0, 'Advance P',            prOnAdvanceProb,         prPopUpMenu, ItemPos);

  //MakeStartState
  prMakeStartStateItem      := AddPopUpMenuItem(0, 'Make start state',     prOnMakeStartState,      prPopUpMenu, ItemPos);

  //EnforceConstraints
  prEnforceConstraintsItem  := AddPopUpMenuItem(0, 'Enforce constraints',  prOnEnforceConstraints,  prPopUpMenu, ItemPos);

  //RandomizeRates
  prRandomizeRatesItem      := AddPopUpMenuItem(0, 'Randomize rates',      prOnRandomizeRates,      prPopUpMenu, ItemPos);

  //Energy landscape
  prEnergyLandscapeItem     := AddPopUpMenuItem(0, 'Energy landscape',     prOnEnergyLandscape,     prPopUpMenu, ItemPos);
                               AddPopUpMenuItem(0, '-',                    nil,                     prPopUpMenu, ItemPos);

  //Global conditions
  prUseGlobalCondItem       := AddPopUpmenuItem(0, 'Use global conditions', prOnUseGlobalCond,      prPopupMenu, ItemPos);
  prEditGlobalCondItem      := AddPopUpMenuItem(0, 'Edit global conditions...', prOnEditGlobalCond, prPopupMenu, ItemPos);
                               AddPopUpMenuItem(0, '-',                    nil,                     prPopUpMenu, ItemPos);

  // Set state index
  prSetIndexItem            := AddPopUpMenuItem(0, 'Set Index',            prOnSetIndex,            prPopUpMenu, ItemPos);

  //Unmerge
  prUnMergeItem             := AddPopUpMenuItem(0, 'Un-Merge models',      prOnUnMerge,             prPopUpMenu, ItemPos);
                               AddPopUpMenuItem(0, '-',                    nil,                     prPopUpMenu, ItemPos);

  //Edit
  prEditCutItem             := AddPopUpMenuItem(ShortCut(Word('X'), [ssCtrl]),
                                                   'Cut',                  prOnCut,                 prPopUpMenu, ItemPos);
  prEditCopyItem            := AddPopUpMenuItem(ShortCut(Word('C'), [ssCtrl]),
                                                   'Copy',                 prOnCopy,                prPopUpMenu, ItemPos);
  prEditPasteItem           := AddPopUpMenuItem(ShortCut(Word('V'), [ssCtrl]),
                                                   'Paste',                prOnPaste,               prPopUpMenu, ItemPos);
  prEditDeleteItem          := AddPopUpMenuItem(0{ShortCut(VK_DELETE, [])},
                                                   'Delete',               prOnDelete,              prPopUpMenu, ItemPos);
                               AddPopUpMenuItem(0, '-',                    nil,                     prPopUpMenu, ItemPos);

  //Grab
  prGrabItem                := AddPopUpMenuItem(0, 'Grab',                 prOnGrab,                prPopUpMenu, ItemPos);
  prGrabAllIncItem          := AddPopUpMenuItem(0, 'Grab all amps increasing',
                                                                           prOnGrabAll,             prPopUpMenu, ItemPos);
  prGrabAllIncItem.Tag      := 1;

  prGrabAllDecItem          := AddPopUpMenuItem(0, 'Grab all amps decreasing',
                                                                           prOnGrabAll,             prPopUpMenu, ItemPos);
  prGrabAllDecItem.Tag      := 0;
                               AddPopUpMenuItem(0, '-',                    nil,                     prPopUpMenu, ItemPos);

end;

procedure TQUB_QVO_QVM.Activate;
var
  Cat          :TQUB_ProfileCat;
begin
  inherited;

  Cat          := ProfileMgr['QVM'];
  Cat.Active   := ModelObject.Properties;
  Cat.OnSet    := ModelObject.DoOnSetProperties;
end;

procedure TQUB_QVO_QVM.Deactivate;
var
  Cat          :TQUB_ProfileCat;
  Foo          :TQUB_Profile_OnSet;
begin
  inherited;

  Cat          := ProfileMgr['QVM'];
  Foo          := ModelObject.DoOnSetProperties;
  if (@Cat.OnSet = @Foo)
  then Cat.OnSet := nil;
end;

//****************************************************************************//
//                                                                            //
//                                  F I L E                                   //
//                                                                            //
//****************************************************************************//
function TQUB_QVO_QVM.New(const FileName :String) :Boolean;
var
  Point :TPoint;
begin
  Result := prModelObject.New(FileName);

  if not Result then begin
    if prModelObject.CanEdit then begin
      try
        Point.x := ClientWidth  div 3;
        Point.y := ClientHeight div 2;
        AddState(Point);
        Point.x := 2 * ClientWidth div 3;
        AddState(Point);
        ModelObject.States[0].Cls  := 0;
        ModelObject.States[0].Amp  := StateAmp[0];
        ModelObject.States[0].Std  := StateStd[0];
        ModelObject.States[0].Cond := StateCond[0];
        ModelObject.States[0].CondStd := StateCondStd[0];
        ModelObject.States[0].Vrev    := StateVrev[0];
        ModelObject.States[1].Cls  := 1;
        ModelObject.States[1].Amp  := StateAmp[1];
        ModelObject.States[1].Std  := StateStd[1];
        ModelObject.States[1].Cond := StateCond[1];
        ModelObject.States[1].CondStd := StateCondStd[1];
        ModelObject.States[1].Vrev    := StateVrev[1];
        AddRate(ModelObject.States[0], ModelObject.States[1]);
        ModelObject.States.UpdateStates;
      finally
        ModelObject.UnModify;
      end;
    end;

    ModelObject.States.CurrState := ModelObject.States.CurrState;

    Invalidate;

  end;

end;

function TQUB_QVO_QVM.Open(const FileName :String) :Boolean;
begin
  Result := ModelObject.Open(FileName);

  if not Result then begin

    ModelObject.States.CurrState := ModelObject.States.CurrState;

    Invalidate;

  end;

  prCleanupOnOpen;
end;

procedure TQUB_QVO_QVM.prCleanupOnOpen;
var
  i        :Integer;

  procedure TrimNode(Node :INode);
  begin
    if Node.DataCount = 0 then Exit;
    Node.SetData(Trim(Node.DataAsString));
  end;
begin

  ModelObject.UpdateParameters; // set up P and Q pointers
  
  TrimNode( ModelObject.Properties.Find('PreFormat') );
  TrimNode( ModelObject.Properties.Find('ExpFormat') );

  for i := 0 to prModelObject.Rates.RateCount - 1 do begin
    prModelObject.Rates[i].UpdateCaptions;
  end;

  Draw;

  // RotLabel has no canvas to measure auto-sized text until it's drawn.
  // However, the rates are laid out first (using default width of 100).
  // Therefore, the first time through, re-layout the rates after drawing.

  for i := 0 to prModelObject.Rates.RateCount - 1 do begin
    prModelObject.Rates[i].Update;
  end;
  Draw;

  prModelSetHint;
  txtChannelCount.Text := IntToStr(ModelObject.ChannelCount);
end;

function TQUB_QVO_QVM.Open(const FileName :String; OpenStream :TStream) :Boolean;
begin
  Result := ModelObject.Open(FileName, OpenStream);

  if not Result then begin

    ModelObject.States.CurrState := ModelObject.States.CurrState;

    Invalidate;

  end;

  prCleanupOnOpen;

end;

function TQUB_QVO_QVM.Save(const FileName :String) :Boolean;
begin
  Result := prModelObject.Save(FileName);
  prCleanupOnOpen;
end;

function TQUB_QVO_QVM.CanSaveAs(var FileName :String; Confirmation :Boolean) :Boolean;
begin
  Result := prModelObject.CanSaveAs(FileName, Confirmation);
end;

function TQUB_QVO_QVM.Close :Boolean;
begin
  if LockedAny then begin
    Result := True;
  end else begin
    Result := prModelObject.Close;
  end;
end;

function TQUB_QVO_QVM.OpenFromString(const MemFile :String) :Boolean;
begin
  Result := False;
end;

function TQUB_QVO_QVM.SaveToString(var MemFile :String; FileType :Integer) :Boolean;
begin
  Result := prModelObject.SaveToString(MemFile, TQUB_QFS_QMF_FileType(FileType));
end;

function TQUB_QVO_QVM.CopyImage(ShowProperties :Boolean) :Boolean;
begin
  Result := prPrintPropertiesForm.Print(Self, nil, True{CopyImage}, ShowProperties);
end;

function TQUB_QVO_QVM.prPrint(Dlg :TPrintDialog) :Boolean;
begin
  Result := prPrintPropertiesForm.Print(Self, Dlg, False{CopyImage}, True);
end;

function TQUB_QVO_QVM.DrawToPos(Canvas :TCanvas; Left, Right, Width, Height :Integer; StatePos :TPAPoint; RatePos :TRatePanelPosList) :Boolean;
var
  OldCanvas               :TCanvas;
  OldWidth                :Integer;
  OldHeight               :Integer;
  OldMargin               :TRect;
  OldDrawFrame            :Boolean;
  i, j                    :Integer;
begin

  Result                  := False;

  OldCanvas               := BitmapCanvas;
  OldWidth                := DrawWidth;
  OldHeight               := DrawHeight;
  OldMargin               := Margin;
  OldDrawFrame            := DrawFrame;

  try

    NoDraw                := True;
    BitmapCanvas          := nil;

    //testing
    prMargin.Left         := 0;
    prMargin.Top          := 0;
    prMargin.Right        := 0;
    prMargin.Bottom       := 0;

    prDrawFrame           := False;

    ResizeModel(Width, Height);

    DrawWidth             := Width;
    DrawHeight            := Height;

    if StatePos <> nil then begin
      for i := 0 to ModelObject.States.StateCount - 1 do begin
        StatePos[i].x        := ModelObject.States[i].Panel.Left;
        StatePos[i].y        := ModelObject.States[i].Panel.Top;
      end;
    end;
    if RatePos <> nil then begin
      RatePos.Size := 4*ModelObject.Rates.RateCount;
      for i := 0 to ModelObject.Rates.RateCount - 1 do begin
        for j := 1 to 4 do begin
          RatePos.Panel[4*i + j-1] := ModelObject.Rates[i].Panels[j];
          RatePos.Rect[4*i + j-1].CopyFrom(ModelObject.Rates[i].Panels[j].Rect);
        end;
      end;
    end;

    NoDraw                := False;
    BitmapCanvas          := Canvas;

    Draw;
    NoDraw                := True;

    BitmapCanvas          := nil;

  finally

    prDrawWidth           := OldWidth;
    prDrawHeight          := OldHeight;
    prMargin              := OldMargin;
    prDrawFrame           := OldDrawFrame;

    ResizeModel(ClientWidth, ClientHeight);

    NoDraw                := False;

    BitmapCanvas          := OldCanvas;

  end;

end;

function TQUB_QVO_QVM.GetAsNode: INode;
begin
  try
    Result      := ModelObject.CloneAsNode(True, TNode.CreateNull);
    Result['FileName'].SetData( FileName );

    if not Result.Find('Properties').IsNull then begin
      Result.RemoveChild(Result['Properties']);
    end;
    Result.AppendClone(ModelObject.Properties, True);
  except
    Result      := TNode.CreateNull;
  end;
end;

procedure TQUB_QVO_QVM.SetAsNode(ModelNode :INode );
begin
  try
    prFactors := TNode.CreateNull;
    SetModelFromNode( ModelObject, ModelNode );
    DoOnSetProperties(ProfileMgr['QVM'], ModelNode.Find('Properties'));
  except
  end;
end;


//****************************************************************************//
//                                                                            //
//                                  E D I T                                   //
//                                                                            //
//****************************************************************************//

//****************************************************************************//
//                                                                            //
//                                 S T A T E                                  //
//                                                                            //
//****************************************************************************//
function TQUB_QVO_QVM.AddState(const p :TPoint) :Boolean;
var
  np   :TPoint;
begin
  if not prConfirmRemoveFactors('adding a state') then begin
    Result := True;
    Exit;
  end;

  if prAlignToGrid then begin
    prGridPosition(p, np);
  end else begin
    np := p;
  end;

  if np.x < 0            then np.x := 0;
  if np.y < 0            then np.y := 0;
  if np.x > prDrawWidth  then np.x := prDrawWidth;
  if np.y > prDrawHeight then np.y := prDrawHeight;

  Result := prModelObject.AddState(np.x * 100 / prDrawWidth, np.y * 100 / prDrawHeight);

end;

function TQUB_QVO_QVM.DelState(State :TQUB_QFS_State) :Boolean;
begin

  if not prConfirmRemoveFactors('deleting a state') then begin
    Result := True;
    Exit;
  end;

  Result := prModelObject.DelState(State);

end;

function TQUB_QVO_QVM.AddRate(State1, State2 :TQUB_QFS_State) :Boolean;
begin

  Result := prModelObject.AddRate(State1, State2);

end;

function TQUB_QVO_QVM.DelRate(Rate :TQUB_QFS_Rate) :Boolean;
begin

  if not prConfirmRemoveFactors('deleting a rate') then begin
    Result := True;
    Exit;
  end;

  Result := prModelObject.DelRate(Rate);

end;

function TQUB_QVO_QVM.PosState(State :TQUB_QFS_State; x, y :Integer) :Boolean;
var
  np   :TPoint;
begin

  Result := False;

  np.x := x;
  np.y := y;
  if prAlignToGrid then begin
    prGridPosition(np, np);
  end;
  if np.x < 0            then np.x := 0;
  if np.y < 0            then np.y := 0;
  if np.x > prDrawWidth  then np.x := prDrawWidth;
  if np.y > prDrawHeight then np.y := prDrawHeight;

  if (np.x <> (State.Panel.Left + (StateSize div 2))) or (np.y <> (State.Panel.Top + (StateSize div 2))) then begin
    Result := prModelObject.PosState(State, np.x * 100 / prDrawWidth, np.y * 100 / prDrawHeight, np.x, np.y);
  end;

end;

//******************************************************************************
procedure TQUB_QVO_QVM.prGridPosition(const p :TPoint; var np :TPoint);
begin
  np.x := (p.x div 10{prStateSize}) * 10{prStateSize};
  np.y := (p.y div 10{prStateSize}) * 10{prStateSize};
end;





//****************************************************************************//
//                                                                            //
//                                 V I E W                                    //
//                                                                            //
//****************************************************************************//



//****************************************************************************//
//                                                                            //
//                                  D R A W                                   //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVM.Paint;
begin
  if prDrawing then Exit;

  try

    if ((csDesigning in ComponentState) or prMustRedraw) then begin
      prMustRedraw := False;
      if not prNoDraw then begin
      //This flag is used when setting many properties at once, to prevent drawing each time
        try
          prDrawCritSection.Acquire;
          Canvas.Lock;
          prBitmapCanvas.Lock;
          prErase;
          prDrawModel;
        finally
          prBitmapCanvas.UnLock;
          Canvas.UnLock;
          prDrawCritSection.Release;
        end;
      end;
    end;

  finally

    inherited;

  end;
end;

function TQUB_QVO_QVM.Draw :Boolean;
begin
  Result := inherited Draw;
  Update;
end;

procedure TQUB_QVO_QVM.prErase;
begin
  inherited;

  if prDrawForPrinting then begin
    prBitmapCanvas.Pen.Width := prPrintPenWidth;
  end else begin
    prBitmapCanvas.Pen.Width := 0;
  end;
  prBitmapCanvas.Pen.Style   := psSolid;
  if prDrawForPrinting then begin
    if prDrawFrame then begin
      prBitmapCanvas.Brush.Style := Graphics.bsClear;
      prBitmapCanvas.Pen.Color   := clBlack;
      prBitmapCanvas.Rectangle(MarginLeft - 1, MarginTop - 1, prDrawWidth - MarginRight, prDrawHeight - MarginBottom);
    end;
  end else begin
    prBitmapCanvas.Brush.Style := bsSolid;
    prBitmapCanvas.Brush.Color := ColorBack;
    //testing. LM
    if prDrawFrame then begin
      prBitmapCanvas.Pen.Color := ColorFrame;
    end else begin
      prBitmapCanvas.Pen.Color := ColorBack;
    end;
    prBitmapCanvas.Rectangle(MarginLeft - 1, MarginTop - 1, prDrawWidth - MarginRight, prDrawHeight - MarginBottom);
  end;

end;

procedure TQUB_QVO_QVM.prDrawModel;
begin

  if prDrawing then Exit;

  prDrawing := True;

  try

    //TO DO: LM Check this
    // Chris sez: not perfect, sometimes the hint zone draws outside here, and hides the top of states and rates
    if (Parent <> nil) and (not prDrawForPrinting) then begin
      txtChannelCount.Invalidate; // Paint overwrites edit which is already drawn.
      prHintZone.PaintTo(prBitmapCanvas.Handle, prHintZone.Left, prHintZone.Top);
    end;

    //Draw rate lines connecting states
    prDrawGraphic;
    //Draw states
    prDrawObjects;

  finally

    prDrawing := False;

  end;

end;

procedure TQUB_QVO_QVM.prDrawGraphic;
var
  i :Integer;
begin
  if (prDrawForPrinting) and (prDrawBW) then begin
    prBitmapCanvas.Pen.Width := prPrintPenWidth;
    prBitmapCanvas.Pen.Color := clBlack;
  end else begin
    prBitmapCanvas.Pen.Width := prLineWidth;
    prBitmapCanvas.Pen.Color := prColorLine;
  end;

  for i := 0 to prModelObject.Rates.RateCount - 1 do begin
    if (prDrawForPrinting) and (prDrawBW) then begin
      prBitmapCanvas.Pen.Width := prPrintPenWidth;
      prModelObject.Rates[i].Paint(prBitmapCanvas, 0, 0);
    end else if (ShowSelectedRate) and (i = prModelObject.Rates.CurrRateIdx) then begin
      //TODO
      prBitmapCanvas.Pen.Width := 2*(prLineWidth + 1);
      prBitmapCanvas.Pen.Color := prColorSelected;
      prModelObject.Rates[i].PaintActive(prBitmapCanvas, 0, 0, prModelObject.Rates.CurrHalfIdx);
    end else begin
      prBitmapCanvas.Pen.Width := prLineWidth;
      prBitmapCanvas.Pen.Color := prColorLine;
      prModelObject.Rates[i].Paint(prBitmapCanvas, 0, 0);
    end;
  end;
end;

procedure TQUB_QVO_QVM.prDrawObjects;
var
  Text, Texts        :String;
  i, j               :Integer;
  l, t, h, w, ws, wi :Integer;
  x, y               :Integer;
  LogFont            :TLogFont;
  OldFont            :TLogFont;
  Hyp                :Integer;
  Angle              :Double;
  dx, dy             :Double;
  sina, cosa         :Double;
  OldTextAlign       :Integer;
  OldBrushStyle      :TBrushStyle;
  OldBrushColor      :TColor;
  OldBkMode          :Integer;
  OldFontColor       :TColor;
  Flipped            :Boolean;
begin

  if prDrawForPrinting then begin
    GetObject(prBitmapCanvas.Font.Handle, SizeOf(OldFont), @OldFont);
    prBitmapCanvas.Font.Size := Round(prPrintStateFontSize);
    prBitmapCanvas.Font.Style := [fsBold];
    GetObject(prBitmapCanvas.Font.Handle, SizeOf(LogFont), @LogFont);
    with LogFont do begin
      lfOutPrecision := OUT_TT_ONLY_PRECIS;
      lfFaceName     := 'Arial';
      lfWeight       := FW_BOLD;//FW_NORMAL;
      lfQuality      := PROOF_QUALITY;
    end;
    prBitmapCanvas.Font.Handle := CreateFontIndirect(LogFont);
    OldTextAlign := GetTextAlign(prBitmapCanvas.Handle);
    prBitmapCanvas.Brush.Style := Graphics.bsClear;
    OldBkMode := GetBkMode(prBitmapCanvas.Handle);
    OldFontColor := prBitmapCanvas.Font.Color;
  end;

  try

    SetTextAlign(prBitmapCanvas.Handle, TA_LEFT or TA_TOP);

    for i := 0 to prModelObject.States.StateCount - 1 do begin


      if prDrawForPrinting then begin
      //Print or CopyImage

        with prBitmapCanvas do begin
          l := prModelObject.States[i].Panel.Left + prModelObject.States[i].Panel.Width  div 2 - prStateSize div 2;             
          t := prModelObject.States[i].Panel.Top  + prModelObject.States[i].Panel.Height div 2 - prStateSize div 2;
          w := {prModelObject.States[i].Panel.Width} prStateSize;
          h := {prModelObject.States[i].Panel.Height} prStateSize;
          if prPrintDrawStatePanel then begin
            OldBrushStyle := prBitmapCanvas.Brush.Style;
            OldBrushColor := prBitmapCanvas.Brush.Color;
            if prPrintDrawStatePanelColor then begin
              prBitmapCanvas.Brush.Style := Graphics.bsSolid;
              prBitmapCanvas.Brush.Color := QUB_GetClassColor(prModelObject.States[i].Cls);
            end;
            Rectangle(l, t, l + w, t + h);
            prBitmapCanvas.Brush.Style := OldBrushStyle;
            prBitmapCanvas.Brush.Color := OldBrushColor;
          end;

          if prPrintDrawStatePanel then begin
            SetBkMode(prBitmapCanvas.Handle, TRANSPARENT);
            if prPrintDrawStatePanelColor then begin
              prBitmapCanvas.Font.Color := QUB_GetClassBackColor(prModelObject.States[i].Cls);;
            end;
          end;

          l := l + w div 2;
          t := t + h div 2;
          if prPrintNamedStates then begin
            prBitmapCanvas.Font.Size := prPrintStateFontSize;
            Text  := Choice(prModelObject.States[i].Cls = 0, 'C', 'O');
            Texts := IntToStr(i + 1);
            w     := TextWidth(Text);
            h     := TextHeight('H');
            prBitmapCanvas.Font.Size := Round(0.66*prPrintStateFontSize);
            ws    := TextWidth(Texts);
            wi    := TextWidth(' ') div 3;
            l     := l - (w + ws + wi) div 2;
            prBitmapCanvas.Font.Size := prPrintStateFontSize;
            TextOut(l,     Round(t - 0.5*h), Text);
            prBitmapCanvas.Font.Size := Round(0.66*prPrintStateFontSize);
            TextOut(l + w + wi, Round(t - 0.2*h),  Texts);
          end else begin
            prBitmapCanvas.Font.Size := prPrintStateFontSize;
            Text := prModelObject.States[i].Panel.StateCaption;
            w := TextWidth(Text);
            h := TextHeight('H');
            TextOut(l - w div 2, t - h div 2, Text);
          end;

          if prPrintDrawStatePanel then begin
            SetBkMode(prBitmapCanvas.Handle, OldBkMode);
            if prPrintDrawStatePanelColor then begin
              prBitmapCanvas.Font.Color := OldFontColor;
            end;
          end;
          
        end;

      end else begin
      //Draw

        prModelObject.States[i].Panel.PaintTo(prBitmapCanvas.Handle, prModelObject.States[i].Panel.Left, prModelObject.States[i].Panel.Top);

      end;

    end;

    if prDrawForPrinting then begin
      prBitmapCanvas.Font.Size := prPrintRateFontSize;
      prBitmapCanvas.Font.Style := [];
      GetObject(prBitmapCanvas.Font.Handle, SizeOf(LogFont), @LogFont);
      LogFont.lfWeight := FW_NORMAL;
      prBitmapCanvas.Font.Handle := CreateFontIndirect(LogFont);
    end;

    prBitmapCanvas.Font.Color := prColorRate;

    SetTextAlign(prBitmapCanvas.Handle, TA_CENTER or TA_TOP);

    for i := 0 to prModelObject.Rates.RateCount - 1 do begin

      if (prDrawForPrinting) then begin
      //Print or CopyImage

        Hyp := Round(Hypot(prModelObject.Rates[i].LinesPos[2].x - prModelObject.Rates[i].LinesPos[1].x, prModelObject.Rates[i].LinesPos[2].y - prModelObject.Rates[i].LinesPos[1].y));
        if Hyp = 0 then Hyp := 1;

        for j := 1 to 2 do begin

          with prBitmapCanvas do begin

            if prDiagonalRates then begin

              with LogFont do begin
                Angle := prModelObject.Rates[i].Angle * (180/PI);
                if Angle <= -45 then begin
                  Angle := Angle + 180;
                  Flipped := True;
                end else begin
                  Flipped := False;
                end;
                lfEscapement := Round(Angle * 10);
                lfOrientation := Round(Angle * 10);
              end;
              prBitmapCanvas.Font.Handle := CreateFontIndirect(LogFont);

              with prModelObject.Rates[i] do begin

                Text := ValueFormat[j];
                //w    := TextWidth(Text);
                h    := TextHeight('H');
                x := Round(LinesPos[1].x + Hyp/2);
                dx := LinesPos[2].x - LinesPos[1].x;
                dy := LinesPos[2].y - LinesPos[1].y;
                if j = 1 then begin
                  y  := Round(LinesPos[1].y - h);
                  SetTextAlign(prBitmapCanvas.Handle, TA_CENTER or Choice(Flipped, TA_BOTTOM, TA_TOP));
                end else begin
                  y  := Round(LinesPos[1].y + h);
                  SetTextAlign(prBitmapCanvas.Handle, TA_CENTER or Choice(Flipped, TA_TOP, TA_BOTTOM));
                end;
                if dx = 0 then dx := 1e-10;
                if dy = 0 then dy := 1e-10;
                sina := dy / Hyp;
                cosa := dx / Hyp;
                l := Round(LinesPos[1].x + ((x - LinesPos[1].x)*cosa - (y - LinesPos[1].y)*sina));
                t := Round(LinesPos[1].y + ((x - LinesPos[1].x)*sina + (y - LinesPos[1].y)*cosa));
                TextOut(l, t, Text);
              end;

            end else begin

              l := prModelObject.Rates[i].Panels[j].Rect.TL.x;
              t := prModelObject.Rates[i].Panels[j].Rect.TL.y;
              w := prModelObject.Rates[i].Panels[j].Rect.TR.x - prModelObject.Rates[i].Panels[j].Rect.TL.x + 1;
              h := prModelObject.Rates[i].Panels[j].Rect.TR.y - prModelObject.Rates[i].Panels[j].Rect.TL.y + 1;
              Text := prModelObject.Rates[i].ValueFormat[j];
              l := l + w div 2;
              t := t + h div 2;
              //w := TextWidth(Text);
              TextOut(l, t, Text);

            end;
          end;

        end;

      end else begin
      //Draw

        for j := 1 to 4 do begin
          prModelObject.Rates[i].Panels[j].{Font.}Color := prColorRate;
        end;
        if (ShowSelectedRate) and (i = ModelObject.Rates.CurrRateIdx) then begin
          //TODO
          prModelObject.Rates[i].Panels[ModelObject.Rates.CurrHalfIdx].{Font.}Color := prColorSelected;
          prModelObject.Rates[i].Panels[ModelObject.Rates.CurrHalfIdx+2].{Font.}Color := prColorSelected;
        end;
        //Draw labels on arrows
        for j := 1 to 4 do begin
          prModelObject.Rates[i].Panels[j].PaintTo(prBitmapCanvas);
        end;

      end;

    end;

  finally

    if prDrawForPrinting then begin
      prBitmapCanvas.Font.Handle := CreateFontIndirect(OldFont);
      prBitmapCanvas.Brush.Style := bsSolid;
      SetTextAlign(prBitmapCanvas.Handle, OldTextAlign);
    end;

  end;

end;

procedure TQUB_QVO_QVM.prDrawLine(Color :TColor; x, y :Integer; State :Integer);
begin

  Canvas.Pen.Mode  := pmNotXor;
  Canvas.Pen.Style := psSolid;
  Canvas.Pen.Width := LineWidth;

  case State of

    QUB_QVO_QVM_LINE_START:
      begin

        Canvas.Pen.Color := Color;
        Canvas.MoveTo(prMouseLine.x, prMouseLine.y);
        Canvas.LineTo(x, y);

      end;

    QUB_QVO_QVM_LINE_MOVE, QUB_QVO_QVM_LINE_END:
      begin

        Canvas.Pen.Color := prLineColor;
        Canvas.MoveTo(prMouseLine.x, prMouseLine.y);
        Canvas.LineTo(prLinePrev.x, prLinePrev.y);

        if State = QUB_QVO_QVM_LINE_MOVE then begin
          Canvas.Pen.Color := Color;
          Canvas.MoveTo(prMouseLine.x, prMouseLine.y);
          Canvas.LineTo(x, y);
        end;

      end;
  end;

  Canvas.Pen.Width := 0;
  Canvas.Pen.Mode  := pmCopy;
  Canvas.Pen.Color := clBlack;

  prLinePrev.x     := x;
  prLinePrev.y     := y;
  prLineColor      := Color;

end;

procedure TQUB_QVO_QVM.prCalcCopyRect;
var
  minx, miny :Integer;
  maxx, maxy :Integer;
  l, t, i, j :Integer;
  RateBounds :TRect;
begin
  minx := prModelObject.States[0].Panel.Left;
  miny := prModelObject.States[0].Panel.Top;
  maxx := minx + prStateSize;
  maxy := miny + prStateSize;
  for i := 0 to prModelObject.States.StateCount - 1 do begin
    l := prModelObject.States[i].Panel.Left;
    t := prModelObject.States[i].Panel.Top;
    if l < minx then minx := l;
    if t < miny then miny := t;
    if (l + prStateSize) > maxx then maxx := l + prStateSize;
    if (t + prStateSize) > maxy then maxy := t + prStateSize;
  end;
  for i := 0 to prModelObject.Rates.RateCount - 1 do begin
    for j := 1 to 4 do begin
      prModelObject.Rates[i].Panels[j].Rect.GetBoundingRect(RateBounds);
      if RateBounds.Left < minx then minx := RateBounds.Left;
      if RateBounds.Top < miny then miny := RateBounds.Top;
      if RateBounds.Right > maxx then maxx := RateBounds.Right;
      if RateBounds.Bottom > maxy then maxy := RateBounds.Bottom;
    end;
  end;
  prCopyRect.Left   := minx - 2;
  prCopyRect.Top    := miny - 2;
  prCopyRect.Right  := maxx + 2;
  prCopyRect.Bottom := maxy + 2;
end;

procedure TQUB_QVO_QVM.MouseToStateRate(x, y :Integer; StatePos :TPAPoint; RatePos :TRatePanelPosList; var StateIdx, RateIdx, HalfIdx, K01 :Integer);
var
  i, j     :Integer;
begin

  StateIdx := -1;
  RateIdx  := -1;
  HalfIdx  := -1;

  if RatePos <> nil then begin
    for i := 0 to prModelObject.Rates.RateCount - 1 do begin

      for j := 1 to 4 do begin
        if RatePos.Rect[4*i+j-1].PtInRect(x, y) then begin
          RateIdx := i;
          HalfIdx := RatePos.Panel[4*i+j-1].Dir;
          K01     := RatePos.Panel[4*i+j-1].K01;
          Exit;
        end;
      end;
    end;
  end;
  
end;

procedure TQUB_QVO_QVM.ResizeModel(const NewWidth, NewHeight :Integer);
var
  State :TQUB_QFS_State;
  i     :Integer;
  p     :TPoint;
begin

  if prModelObject = nil then Exit;

  prHintZone.SetBounds(MarginH, MarginV, NewWidth - 2*MarginH, QUB_QVO_QVM_HINTZONE_Y);

  for i := 0 to prModelObject.States.StateCount - 1 do begin
    State := prModelObject.States[i];
    p.x := Round(State.x * NewWidth  / 100);
    p.y := Round(State.y * NewHeight / 100);
    if prAlignToGrid then begin
      prGridPosition(p, p);
    end;
    State.Panel.SetBounds(p.x - (StateSize div 2), p.y - (StateSize div 2), StateSize, StateSize);
  end;

  for i := 0 to prModelObject.Rates.RateCount - 1 do begin
    prModelObject.Rates[i].Update;
  end;

end;

//******************************************************************************
function TQUB_QVO_QVM.prGetFileName :String;
begin
  Result := prModelObject.FileName;
end;

function TQUB_QVO_QVM.prGetFileExt :String;
begin
  Result := prModelObject.FileExt;
end;

function TQUB_QVO_QVM.prGetModified :Boolean;
begin
  Result := prModelObject.Modified;
end;

function TQUB_QVO_QVM.prGetSaved :Boolean;
begin
  Result := prModelObject.Saved;
end;

//Lock
procedure TQUB_QVO_QVM.LockWrite;
begin
  inherited;
  prModelObject.LockWrite;
  prHintZone.Enabled := False;
end;

procedure TQUB_QVO_QVM.UnLockWrite;
begin
  inherited;
  prModelObject.UnLockWrite;

  if prUseGlobalCond then begin
    ExpCond := ViewportModel.DefExpCond;
  end else begin
    ExpCond := ViewportModel.ExpCond;
  end;

  // when an algorithm wants to force the model to use data conditions,
  // it manually sets model.expcond to data.expcond then lock*;
  // the conditions will be reset to user-spec on unlock.

  prHintZone.Enabled := True;
end;

procedure TQUB_QVO_QVM.LockReadWrite;
begin
  inherited;
  prModelObject.LockReadWrite;
  prHintZone.Enabled := False;
end;

procedure TQUB_QVO_QVM.UnLockReadWrite;
begin
  inherited;
  prModelObject.UnLockReadWrite;

  if prUseGlobalCond then begin
    ExpCond := ViewportModel.DefExpCond;
  end else begin
    ExpCond := ViewportModel.ExpCond;
  end;

  prHintZone.Enabled := True;
end;


//****************************************************************************//
//                                                                            //
//                          M O D E L    E V E N T S                          //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVM.DoOnFileOpen(Sender :TObject);
begin
  prCleanupOnOpen;
end;

procedure TQUB_QVO_QVM.DoOnFileClose(Sender :TObject);
begin
  Draw;
end;

procedure TQUB_QVO_QVM.DoOnFileEdit(Sender :TObject; EditOper :TQUB_EditOperation; var Param, Param2);
begin
  Draw;
  DoOnEdit;
  prModelSetHint;
  txtChannelCount.Text := IntToStr(ModelObject.ChannelCount);
end;

procedure TQUB_QVO_QVM.DoOnFileNewState(Sender :TObject);
var
  State :TQUB_QFS_State;
  p, np :TPoint;
  i     :Integer;
begin
  State := TQUB_QFS_State(Sender);

  State.Panel.Parent := Self;

  State.StateSize              := StateSize;
  State.Panel.OnMouseDown      := prStateMouseDown;
  State.Panel.OnMouseMove      := prStateMouseMove;
  State.Panel.OnMouseUp        := prStateMouseUp;
  State.Panel.OnDblClick       := prStateDblClick;

  p.x := Round(State.x * prDrawWidth  / 100);
  p.y := Round(State.y * prDrawHeight / 100);
  if prAlignToGrid then begin
    prGridPosition(p, np);
  end else begin
    np := p;
  end;
  if np.x < 0            then np.x := 0;
  if np.y < 0            then np.y := 0;
  if np.x > prDrawWidth  then np.x := prDrawWidth;
  if np.y > prDrawHeight then np.y := prDrawHeight;

  State.x := np.x * 100 / prDrawWidth;
  State.y := np.y * 100 / prDrawHeight;
  State.Panel.SetBounds(Round(State.x * prDrawWidth / 100) - (StateSize div 2), Round(State.y * prDrawHeight / 100) - (StateSize div 2), StateSize, StateSize);

  State.Amp  := prModelObject.Amp[State.Cls];
  State.Std  := prModelObject.Std[State.Cls];
  State.Cond := prModelObject.Cond[State.Cls];
  State.CondStd := prModelObject.CondStd[State.Cls];
  State.Vrev    := prModelObject.ClsVrev[State.Cls];
  for i := 0 to QUB_QFS_QMF_MAX_COEFF - 1 do begin
    State.Cff[i] := prModelObject.Cff[State.Cls, i];
  end;

  State.Panel.PopUpMenu    := PopUpMenu;
  State.Panel.ShowHint     := True;
  State.SetHint;

  prModelObject.States.UpdateStates;

end;

procedure TQUB_QVO_QVM.DoOnFileOpenState(Sender :TObject);
var
  State :TQUB_QFS_State;
  p, np :TPoint;
begin
  State := TQUB_QFS_State(Sender);

  State.Panel.Parent := Self;

  State.StateSize              := StateSize;
  State.Panel.OnMouseDown      := prStateMouseDown;
  State.Panel.OnMouseMove      := prStateMouseMove;
  State.Panel.OnMouseUp        := prStateMouseUp;
  State.Panel.OnDblClick       := prStateDblClick;

  p.x := Round(State.x * prDrawWidth  / 100);
  p.y := Round(State.y * prDrawHeight / 100);
  if prAlignToGrid then begin
    prGridPosition(p, np);
  end else begin
    np := p;
  end;
  if np.x < 0            then np.x := 0;
  if np.y < 0            then np.y := 0;
  if np.x > prDrawWidth  then np.x := prDrawWidth;
  if np.y > prDrawHeight then np.y := prDrawHeight;

  State.x := np.x * 100 / prDrawWidth;
  State.y := np.y * 100 / prDrawHeight;
  State.Panel.SetBounds(Round(State.x * prDrawWidth / 100) - (StateSize div 2), Round(State.y * prDrawHeight / 100) - (StateSize div 2), StateSize, StateSize);

  State.Panel.PopUpMenu    := PopUpMenu;
  State.Panel.ShowHint     := True;
  State.SetHint;

end;

procedure TQUB_QVO_QVM.DoOnFileNewRate(Sender :TObject);
var
  Rate :TQUB_QFS_Rate;
  i    :Integer;
begin
  Rate := TQUB_QFS_Rate(Sender);

  ///Rate.Panels[1].Parent := Self;
  ///Rate.Panels[2].Parent := Self;

  for i := 1 to 4 do begin

    Rate.Panels[i].OnMouseDown  := prRateMouseDown;
    Rate.Panels[i].OnMouseMove  := prRateMouseMove;
    Rate.Panels[i].OnMouseUp    := prRateMouseUp;
    Rate.Panels[i].OnMouseWheel := prRateMouseWheel;
    Rate.Panels[i].OnDblClick   := DoOnRateDblClick;
    //Rate.Panels[i].PopUpMenu    := PopUpMenu;

    ///Rate.Panels[i].SetBounds(Rate.Panels[i].Left, Rate.Panels[i].Top, QUB_QVO_QVM_RATE_WIDTH, QUB_QVO_QVM_RATE_HEIGHT);
    Rate.Panels[i].Color        := prColor;
    Rate.Panels[i].{Font.}Color := prColorRate;

  end;
  for i := 1 to 2 do begin

    Rate.K0[i]                  := prRateK0;
    Rate.K1[i]                  := prRateK1;
    Rate.P[i]                   := prRateP;
    Rate.Q[i]                   := prRateQ;
    Rate.PName[i]               := prRatePName;
    Rate.QName[i]               := prRateQName;
    Rate.RateFormat[i]          := prRateFormat;
    //Check
    //Rate.SetRate(i, m_aDefaultRate[i]);

  end;

  Rate.Update;

  //Rate.Panels[1].Visible := True;
  //Rate.Panels[2].Visible := True;

end;

procedure TQUB_QVO_QVM.DoOnFileOpenRate(Sender :TObject);
var
  Rate :TQUB_QFS_Rate;
  i    :Integer;
begin
  Rate := TQUB_QFS_Rate(Sender);

  //Rate.Panels[1].Parent := Self;
  //Rate.Panels[2].Parent := Self;

  for i := 1 to 4 do begin

    Rate.Panels[i].OnMouseDown  := prRateMouseDown;
    Rate.Panels[i].OnMouseMove  := prRateMouseMove;
    Rate.Panels[i].OnMouseUp    := prRateMouseUp;
    Rate.Panels[i].OnMouseWheel := prRateMouseWheel;
    Rate.Panels[i].OnDblClick   := DoOnRateDblClick;
    //Rate.Panels[i].PopUpMenu    := PopUpMenu;

    //Rate.Panels[i].SetBounds(Rate.Panels[i].Left, Rate.Panels[i].Top, QUB_QVO_QVM_RATE_WIDTH, QUB_QVO_QVM_RATE_HEIGHT);
    Rate.Panels[i].Color        := prColor;
    Rate.Panels[i].{Font.}Color := prColorRate;

  end;

end;

procedure TQUB_QVO_QVM.DoOnFileChangeActiveState(Sender :TObject);
begin
  prDrawGraphic;
end;

procedure TQUB_QVO_QVM.DoOnFileNeedDraw(Sender :TObject);
begin
  prMustRedraw := True;
  Invalidate;
  // prDrawGraphic;
end;

//****************************************************************************//
//                                                                            //
//                             P R O P E R T I E S                            //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVM.DoOnInitProperties(Sender :TObject);
var
  Cat        :TQUB_ProfileCat;
  Reg        :TRegistry;
  RegKeyName :String;
  bVal       :Boolean;
  iVal       :Integer;

  procedure Init(const Name :String; Def :Variant; RegType :TQUB_Property_RegType; const RegName :String);
  var
    Node, ActiveNode :INode;
  begin
    Node     := ModelObject.Properties[Name];
    if Node.DataCount = 0 then begin
      ActiveNode  := Cat.Active.Find(Name);
      if ActiveNode.DataCount > 0 then begin
        Node.EmulateData(ActiveNode);
      end else begin
        if (RegType = REGTYPE_BOOL) and ReadXRegistryBoolean(Reg, RegKeyName, RegName, bVal) then begin
          Node.SetData(Integer(bVal));
        end else if (RegType = REGTYPE_INT) and ReadXRegistryInteger(Reg, RegKeyName, RegName, iVal) then begin
          Node.SetData(iVal);
        end else begin
          Node.SetData(Def);
        end;
      end;
    end;
  end;
begin
  Cat        := ProfileMgr['QVM'];
  RegKeyName := 'Software\QUB\Visual Model';

  Reg   := nil; // will be created as needed by ReadXRegistry*
  try
    Init('ColorBack',     Integer(QUB_QVO_QVM_DEF_COLORBACK),       REGTYPE_INT,  'Color Back');
    Init('ColorLine',     Integer(QUB_QVO_QVM_DEF_COLORLINE),       REGTYPE_INT,  'Color Line');
    Init('ColorRate',     Integer(QUB_QVO_QVM_DEF_COLORRATE),       REGTYPE_INT,  'Color Rate');
    Init('ColorSelected', Integer(QUB_QVO_QVM_DEF_COLORSELECTED),   REGTYPE_INT,  'Color Selected');
    Init('ColorFrame',    Integer(QUB_QVO_QVM_DEF_COLORFRAME),      REGTYPE_INT,  'Color Frame');
    Init('ColorPanel',    Integer(QUB_QVO_QVM_DEF_COLOR),           REGTYPE_INT,  'Color');
    Init('StateSize',     QUB_QVO_QVM_DEF_STATESIZE,                REGTYPE_INT,  'State Size');
    Init('LineWidth',     QUB_QVO_QVM_DEF_LINEWIDTH,                REGTYPE_INT,  'Line Width');
    Init('AlignToGrid',   Integer(QUB_QVO_QVM_DEF_ALIGNTOGRID),     REGTYPE_BOOL, 'Align To Grid');
    Init('UseGlobalCond', Integer(QUB_QVO_QVM_DEF_USEGLOBALCOND),   REGTYPE_BOOL, 'UseGlobalCond');
    Init('ScrollRates',   Integer(QUB_QVO_QVM_DEF_SCROLLRATES),     REGTYPE_BOOL, 'ScrollRates');
    Init('DiagonalRates', Integer(QUB_QVO_QVM_DEF_DIAGONALRATES),   REGTYPE_BOOL, 'DiagonalRates');
    Init('ShowK1',        Integer(QUB_QVO_QVM_DEF_SHOWK1),          REGTYPE_BOOL, 'ShowK1');
    Init('EnforceConstraints', Integer(QUB_QVO_QVM_DEF_ENFORCECONSTRAINTS), REGTYPE_BOOL, 'EnforceConstraints');
    Init('IeqFv',         Integer(QUB_QVO_QVM_DEF_I_EQ_F_V),        REGTYPE_NONE, '');
    Init('MarginH', QUB_QVO_QVM_DEF_MARGIN,                         REGTYPE_INT,  'MarginH');
    Init('MarginV', QUB_QVO_QVM_DEF_MARGIN,                         REGTYPE_INT,  'MarginV');
    Init('PreFormat', QUB_QVO_QVM_DEF_PREFORMAT,                    REGTYPE_NONE, '');
    Init('ExpFormat', QUB_QVO_QVM_DEF_EXPFORMAT,                    REGTYPE_NONE, '');
  finally
    if Reg <> nil then begin
      Reg.CloseKey;
      Reg.Free;
    end;
  end;

  DoOnSetProperties(Cat, ModelObject.Properties);
end;

procedure TQUB_QVO_QVM.DoOnSetProperties(Sender :TQUB_ProfileCat; Updates :INode);
var
  i                  :Integer;
  Data               :Variant;
  function Has1Data(const Name :String): Boolean;
  var
    Node             :INode;
  begin
    Node             := Updates.Find(Name);
    Result           := Node.DataCount > 0;
    if Result then Data := Node.Data[0];
  end;
begin
  if Has1Data('ColorBack')          then ColorBack := Data;
  if Has1Data('ColorLine')          then ColorLine := Data;
  if Has1Data('ColorRate')          then ColorRate := Data;
  if Has1Data('ColorSelected')      then ColorSelected := Data;
  if Has1Data('ColorFrame')         then ColorFrame := Data;
  if Has1Data('Color')              then Color := Data;
  if Has1Data('StateSize')          then StateSize := Data;
  if Has1Data('LineWidth')          then LineWidth := Data;
  if Has1Data('AlignToGrid')        then AlignToGrid := Data;
  if Has1Data('UseGlobalCond')      then UseGlobalCond := Data;
  if Has1Data('ScrollRates')        then ScrollRates := Data;
  if Has1Data('DiagonalRates')      then DiagonalRates := Data;
  if Has1Data('ShowK1')             then ShowK1 := Data;
  if Has1Data('EnforceConstraints') then EnforceConstraints := Data;
  if Has1Data('IeqFv')              then IeqFv   := Data;
  if Has1Data('MarginH')            then MarginH := Data;
  if Has1Data('MarginV')            then MarginV := Data;
  if not Updates.Find('PreFormat').IsNull then ModelObject.Properties['PreFormat'].SetData(Updates['PreFormat'].DataAsString);
  if not Updates.Find('ExpFormat').IsNull then ModelObject.Properties['ExpFormat'].SetData(Updates['ExpFormat'].DataAsString);

  Invalidate;

  for i := 0 to prModelObject.Rates.RateCount - 1 do begin
    prModelObject.Rates[i].UpdateCaptions;
    prModelObject.Rates[i].Update;
  end;
end;


function TQUB_QVO_QVM.Properties :Boolean;
begin
  prPropertiesForm.OnGetProperties          := prOnGetProperties;
  prPropertiesForm.OnPutProperties          := prOnPutProperties;
  prPropertiesForm.OnRateSetAsDefault       := prOnRateSetAsDefaultProperties;
  prPropertiesForm.ShowModal;
  Result := prPropertiesForm.ModalResult <> mrOK;
end;

procedure TQUB_QVO_QVM.prOnProperties(Sender :TObject);
var
  State :TQUB_QFS_State;
  Rate  :TQUB_QFS_Rate;
begin
  if prPopupTarget = Self then begin
    Properties;
  end else begin
    if (not prModelObject.LockedAny) and (prModelObject.CanEdit) then begin
      State := prModelObject.States.WhichState(TQUB_QFS_StatePanel(prPopUpTarget));
      if State <> nil then begin
        prStateProperties(State);
        Exit;
      end;
      Rate := TQUB_QFS_RatePanel(prPopUpTarget).Rate;
      if Rate <> nil then begin
        prRateIndexForProperties := TQUB_QFS_RatePanel(prPopUpTarget).Dir;
        prRateK01ForProperties   := TQUB_QFS_RatePanel(prPopUpTarget).K01;
        //prRateProperties(Rate);

        //Testing LM. **************************************
        prPropertiesForm.pagControl.ActivePage := prPropertiesForm.tabRates;
        Properties;
        //**************************************************

        //Check this (John's
        //prRateProperties(Rate, Rate.WhichState(TQUB_QFS_RatePanel(prPopUpMenu.PopUpComponent)));
        Exit;
      end;
    end;
  end;
end;

procedure TQUB_QVO_QVM.prOnGetProperties(Sender :TObject);
begin
  with Sender as TQUB_QVO_QVM_XPropertiesForm do begin
    try
      Self.ModelObject.ChannelCount        := ModelChannelCount;
      Self.ModelObject.VRev                := VRev;
      Self.ModelObject.Constraints.Copy(Constraints);
      Self.ModelObject.ExtraKineticPars.Copy(TQUB_QVO_QVM_XPropertiesForm(Sender).ExtraKineticPars);
      Self.ModelObject.ConstraintsAmpVar.Copy(ConstraintsAmpVar);
      prModelSetHint;
    finally
      ResizeModel(prDrawWidth, prDrawHeight);
      Draw;
    end;
  end;//with
end;

procedure TQUB_QVO_QVM.prOnPutProperties(Sender :TObject);
begin
  with Sender as TQUB_QVO_QVM_XPropertiesForm do begin
    Model                           := Self.ModelObject;
    ModelChannelCount               := Self.ModelObject.ChannelCount;
    VRev                            := Self.ModelObject.VRev;
    Constraints.Copy(Self.ModelObject.Constraints);
    ExtraKineticPars.Copy(Self.ModelObject.ExtraKineticPars);
    ConstraintsAmpVar.Copy(Self.ModelObject.ConstraintsAmpVar);
  end;//with
end;

procedure TQUB_QVO_QVM.prOnRateSetAsDefaultProperties(Sender :TObject);
begin
  with Sender as TQUB_QVO_QVM_XPropertiesForm do begin
      prRateK0     := K0;
      prRateK1     := K1;
      prRateP      := P;
      prRateQ      := Q;
      prRatePName  := PName;
      prRateQName  := QName;
      prRateFormat := RateFormat;
  end;//with
  prRatePropertiesRegistry(False{Write});
end;


//State properties *************************************************************
procedure TQUB_QVO_QVM.prStateProperties(State :TQUB_QFS_State);
begin
  prStateForProperties := State;
  prStatePropertiesForm.OnGetProperties          := prOnStateGetProperties;
  prStatePropertiesForm.OnPutProperties          := prOnStatePutProperties;
  prStatePropertiesForm.OnResetProperties        := prOnStateResetProperties;
  prStatePropertiesForm.OnSetAsDefaultProperties := prOnStateSetAsDefaultProperties;
  prStatePropertiesForm.ShowModal;
end;

//Rate properties
procedure TQUB_QVO_QVM.prRateProperties(Rate :TQUB_QFS_Rate);
begin
(*
  prRateForProperties := Rate;
  prRatePropertiesForm.OnGetProperties          := prOnRateGetProperties;
  prRatePropertiesForm.OnPutProperties          := prOnRatePutProperties;
  prRatePropertiesForm.OnResetProperties        := prOnRateResetProperties;
  prRatePropertiesForm.OnSetAsDefaultProperties := prOnRateSetAsDefaultProperties;
  prRatePropertiesForm.ShowModal;
  *)
end;


//State properties
procedure TQUB_QVO_QVM.prOnStateGetProperties(Sender :TObject);
var
  i, j :Integer;
begin
  with Sender as TQUB_QVO_QVM_State_PropertiesForm do begin
    try

      //ModelObject.OnEdit := nil;

      for i := 0 to ClassCount - 1 do begin
        StateAmp[i]  := Amp[i];
        StateStd[i]  := Std[i];
        StateCond[i] := Cond[i];
        StateCondStd[i] := CondStd[i];
        StateVrev[i]    := Vrev[i];

        StateNar[i] := Nar[Cls];//Nar[i]
        for j := 0 to QUB_QFS_QMF_MAX_COEFF - 1 do begin
          StateCff[i, j] := Cff[i, j];
        end;
      end;

      if prConfirmRemoveFactors('changing a state''s class') then begin
        prStateForProperties.Cls := Cls;
      end;

      prStateForProperties.Pr := Pr;
      prStateForProperties.Gr := Group;

      // this paragraph adapted from prOnStateDblClick by Chris 1-3-3
      prStateForProperties.Amp  := prModelObject.Amp[Cls];
      prStateForProperties.Std  := prModelObject.Std[Cls];
      prStateForProperties.Cond := prModelObject.Cond[Cls];
      prStateForProperties.CondStd := prModelObject.CondStd[Cls];
      prStateForProperties.Vrev    := prModelObject.ClsVrev[Cls];
      for i := 0 to QUB_QFS_QMF_MAX_COEFF - 1 do begin
        prStateForProperties.Cff[i] := prModelObject.Cff[Cls, i];
      end;

      Self.IeqFv := IeqFv;

      prModelObject.States.UpdateStates;

    finally

      //ModelObject.OnEdit := DoOnFileEdit;

      Draw;

    end;
  end;//with
end;

procedure TQUB_QVO_QVM.prOnStatePutProperties(Sender :TObject);
var
  GAmp, GStd :Double;
  i, j :Integer;
begin
  with Sender as TQUB_QVO_QVM_State_PropertiesForm do begin
    ClassCount := ModelObject.ClassCount;

    for i := 0 to ClassCount - 1 do begin
      Amp[i]  := StateAmp[i];
      Std[i]  := StateStd[i];
      Cond[i] := StateCond[i];
      CondStd[i] := StateCondStd[i];
      Vrev[i] := StateVrev[i];
      Nar[i] := StateNar[i];
      for j := 0 to QUB_QFS_QMF_MAX_COEFF - 1 do begin
        Cff[i, j] := StateCff[i, j];
      end;
    end;

    Cls    := prStateForProperties.Cls;
    Pr     := prStateForProperties.Pr;
    Group  := prStateForProperties.Gr;

    if CurrData <> nil then begin
      CanGrab := TQUB_QVO_QVD(CurrData).GrabAvgStd(GAmp, GStd);
    end else begin
      CanGrab := False;
    end;
    if CanGrab then begin
      GrabAmp := GAmp;
      GrabStd := GStd;
    end;

    IeqFv := Self.IeqFv;

  end;//with
end;

procedure TQUB_QVO_QVM.prOnStateResetProperties(Sender :TObject);
begin
  with Sender as TQUB_QVO_QVM_State_PropertiesForm do begin
    try
      prStatePropertiesRegistry(True{Read});
    finally
      Draw;
    end;
  end;//with
end;

procedure TQUB_QVO_QVM.prOnStateSetAsDefaultProperties(Sender :TObject);
begin
  prStatePropertiesRegistry(False{Write});
end;

//Rate properties ..............................................................
procedure TQUB_QVO_QVM.prOnRateGetProperties(Sender :TObject);
begin
                                                 (*
  with Sender as TQUB_QVO_QVM_Rate_PropertiesForm do begin

    try

      //ModelObject.OnEdit := nil;

      prRateForProperties.K0[prRateIndexForProperties]     := K0;
      prRateForProperties.K1[prRateIndexForProperties]     := K1;
      prRateForProperties.P[prRateIndexForProperties]      := P;
      prRateForProperties.Q[prRateIndexForProperties]      := Q;
      prRateForProperties.PName[prRateIndexForProperties]  := PName;
      prRateForProperties.QName[prRateIndexForProperties]  := QName;
      //prRateForProperties.RateFormat[prRateIndexForProperties] := RateFormat;

      //TODO: Check this. The Par should not be added to the data, or should it? LM
      if ExpCond.ParameterByName[PName]    = nil then ExpCond.AddPar(PName, 1.0, -1, False);
      //if DefExpCond.ParameterByName[PName] = nil then DefExpCond.AddPar(PName, 1.0, -1, False);
      if ExpCond.ParameterByName[QName]    = nil then ExpCond.AddPar(QName, 1.0, -1, False);
      //if DefExpCond.ParameterByName[QName] = nil then DefExpCond.AddPar(QName, 1.0, -1, False);

      ModelObject.UpdateParameters;

    finally

      //ModelObject.OnEdit := DoOnFileEdit;

      Draw;

    end;

  end;//with
                                                   *)
end;

procedure TQUB_QVO_QVM.prOnRatePutProperties(Sender :TObject);
begin
                                                     (*
  with Sender as TQUB_QVO_QVM_Rate_PropertiesForm do begin

    K0    := prRateForProperties.K0[prRateIndexForProperties];
    K1    := prRateForProperties.K1[prRateIndexForProperties];
    P     := prRateForProperties.P[prRateIndexForProperties];
    Q     := prRateForProperties.Q[prRateIndexForProperties];
    PName := prRateForProperties.PName[prRateIndexForProperties];
    QName := prRateForProperties.QName[prRateIndexForProperties];
    //RateFormat := prRateForProperties.RateFormat[prRateIndexForProperties];

  end;//with
                                                       *)
end;

procedure TQUB_QVO_QVM.prOnRateResetProperties(Sender :TObject);
begin                                            (*
  with Sender as TQUB_QVO_QVM_Rate_PropertiesForm do begin
    try
      prRatePropertiesRegistry(True{Read});
    finally
      Draw;
    end;
  end;//with                                       *)
end;
(*
procedure TQUB_QVO_QVM.prOnRateSetAsDefaultProperties(Sender :TObject);
begin
  with Sender as TQUB_QVO_QVM_Rate_PropertiesForm do begin
    prRateK0     := K0;
    prRateK1     := K1;
    prRateP      := P;
    prRateQ      := Q;
    prRatePName  := PName;
    prRateQName  := QName;
    prRateFormat := RateFormat;
  end;//with
  prRatePropertiesRegistry(False{Write});
end;
*)

//----- Rate properties
//----- Open the global rates properties dialogue as a modal
//Check this
(*
procedure TQUB_QVO_QVM.prRateProperties(Rate :TQUB_QFS_Rate; iIndex : Integer);
begin
  QUB_QVO_QVM_Rate_PropertiesForm.m_Model := prModelObject;
  QUB_QVO_QVM_Rate_PropertiesForm.m_Rate := Rate;
  QUB_QVO_QVM_Rate_PropertiesForm.m_RateIndex := iIndex;

  ModelObject.UpdateParameters;           // necc ?
  ModelObject.OnEdit := nil;              // necc ?
  QUB_QVO_QVM_Rate_PropertiesForm.ShowModal;
  ModelObject.OnEdit := DoOnFileEdit;     // necc ?

  if QUB_QVO_QVM_Rate_PropertiesForm.m_lModifiedDefault Then
    ModelRateReadRegistry(m_aDefaultRate[1], m_aDefaultRate[2]);

end;
*)


function TQUB_QVO_QVM.MakeNewRateNode: INode;
var
  El             :INode;
begin
  Result         := TNode.Create('Rate');
  Result['States'].SetupNumData(NODE_DATATYPE_LONGINT, 2, 1);

  El             := Result['k0'];
  El.SetupNumData(NODE_DATATYPE_DOUBLE, 2, 1);
  El.Data[0]     := prRateK0;
  El.Data[1]     := prRateK0; 
  //El.Data[0]     := m_aDefaultRate[1].m_K0;
  //El.Data[1]     := m_aDefaultRate[2].m_K0;

  El             := Result['k1'];
  El.SetupNumData(NODE_DATATYPE_DOUBLE, 2, 1);
  El.Data[0]     := prRateK1;
  El.Data[1]     := prRateK1;
  //El.Data[0]     := m_aDefaultRate[1].m_K1;
  //El.Data[1]     := m_aDefaultRate[2].m_K1;

  El             := Result['dk0'];
  El.SetupNumData(NODE_DATATYPE_DOUBLE, 2, 1);
  El.Data[0]     := 0.0;
  El.Data[1]     := 0.0;

  El             := Result['dk1'];
  El.SetupNumData(NODE_DATATYPE_DOUBLE, 2, 1);
  El.Data[0]     := 0.0;
  El.Data[1]     := 0.0;

  El             := Result['P'];
  El.SetupNumData(NODE_DATATYPE_LONGINT, 2, 1);
  El.Data[0]     := Choice(prRateP, 1, 0);
  El.Data[1]     := Choice(prRateP, 1, 0);;
  //El.Data[0]   := Choice(m_aDefaultRate[1].m_P, 1, 0);
  //El.Data[1]   := Choice(m_aDefaultRate[2].m_P, 1, 0);

  El             := Result['Q'];
  El.SetupNumData(NODE_DATATYPE_LONGINT, 2, 1);
  El.Data[0]     := Choice(prRateQ, 1, 0);
  El.Data[1]     := Choice(prRateQ, 1, 0);
  //El.Data[0]   := Choice(m_aDefaultRate[1].m_Q, 1, 0);
  //El.Data[1]   := Choice(m_aDefaultRate[2].m_Q, 1, 0);

  El             := TNode.Create('PName');
  El.SetData( prRatePName );
  Result['PNames'].AppendChild( El );
  Result['PNames'].AppendChild( El.Clone(True) );
  //El.SetData( m_aDefaultRate[1].m_PName );
  //Result['PNames'].AppendChild( El );
  //El             := TNode.Create('PName');
  //El.SetData( m_aDefaultRate[2].m_PName );
  //Result['PNames'].AppendChild( El );

  El             := TNode.Create('QName');
  El.SetData( prRateQName );
  Result['QNames'].AppendChild( El );
  Result['QNames'].AppendChild( El.Clone(True) );
  //El.SetData( m_aDefaultRate[1].m_QName );
  //Result['QNames'].AppendChild( El );
  //El             := TNode.Create('QName');
  //El.SetData( m_aDefaultRate[2].m_QName );
  //Result['QNames'].AppendChild( El );

  El             := Result['PValue'];
  El.SetupData(NODE_DATATYPE_POINTER, SizeOf(Pointer), 2);
  El.Data[0]     := 0;
  El.Data[1]     := 0;

  El             := Result['QValue'];
  El.SetupData(NODE_DATATYPE_POINTER, SizeOf(Pointer), 2);
  El.Data[0]     := 0;
  El.Data[1]     := 0;

  El             := TNode.Create('RateFormat');
  El.SetData( prRateFormat );
  Result['RateFormats'].AppendChild( El );
  Result['RateFormats'].AppendChild( El.Clone(True) );
end;


//Popup Menu Events ************************************************************

//Edit
//make commands, like in data...


procedure TQUB_QVO_QVM.prOnCut(Sender :TObject);
begin
  prModelObject.CutModel;
end;

procedure TQUB_QVO_QVM.prOnCopy(Sender :TObject);
begin
  prModelObject.CopyModel;
end;

procedure TQUB_QVO_QVM.prOnPaste(Sender :TObject);
begin
  if prConfirmRemoveFactors('pasting a model') then begin
    prModelObject.PasteModel;
  end;
end;

procedure TQUB_QVO_QVM.prOnDelete(Sender :TObject);
var
  State :TQUB_QFS_State;
  Rate  :TQUB_QFS_Rate;
begin
  if prPopUpTarget = Self then begin
  //Delete the Whole model

    if prConfirmRemoveFactors('deleting the model') then begin
      prModelObject.DeleteModel;
    end;

  end else begin
  //Delete a State or a Rate
    State := prModelObject.States.WhichState(TQUB_QFS_StatePanel(prPopUpTarget));
    if State <> nil then begin
      DelState(State);
      Exit;
    end;
    Rate := TQUB_QFS_RatePanel(prPopUpTarget).Rate;
    if Rate <> nil then begin
      DelRate(Rate);
      Exit;
    end;
  end;
end;


//Move states with key
procedure TQUB_QVO_QVM.prMoveStates(Code :Word; KeyShift :Boolean; KeyControl :Boolean);
var
  State :TQUB_QFS_State;
  d, s  :Integer;
  x, y  :Integer;
begin

  if KeyControl then d := prStateSize else d := prStateSize div 2;

  for s := 0 to ModelObject.States.StateCount - 1 do begin

    State := ModelObject.States[s];

    if (State = ModelObject.States.CurrState) or (KeyShift) then begin

      x := State.Panel.Left + (StateSize div 2);
      y := State.Panel.Top  + (StateSize div 2);

      case Code of

        VK_LEFT:   Dec(x, d);
        VK_RIGHT:  Inc(x, d);
        VK_UP:     Dec(y, d);
        VK_DOWN:   Inc(y, d);

      end;

      PosState(State, x, y);

    end;

  end;

end;

procedure TQUB_QVO_QVM.prWriteModelStats;
var
  c    :Double;
  t    :String;
  i, j :Integer;
  Vec  :TPADouble;
  //iPi : Double;
begin
  Vec := nil;
  t := #13#10'Statistics for ' + ModelObject.FileName;
  //Q Matrix
  if ModelObject.Q <> nil then begin
    t := t + #13#10'Q Matrix:'#13#10#13#10;
    for i := 0 to ModelObject.States.StateCount - 1 do begin
      for j := 0 to ModelObject.States.StateCount - 1 do begin
        t := t + Format(#9'%14.6g', [ModelObject.Q[i, j]]);
      end;
      t := t + #13#10;
    end;
  end;
  //A Matrix
  if ModelObject.A <> nil then begin
    t := t + #13#10'A Matrix:'#13#10#13#10;
    for i := 0 to ModelObject.States.StateCount - 1 do begin
      for j := 0 to ModelObject.States.StateCount - 1 do begin
        t := t + Format(#9'%-14.10g', [ModelObject.A[i, j]]);
      end;
      t := t + #13#10;
    end;
  end;
  //P Start
  if ModelObject.P0 <> nil then begin
    t := t + #13#10'P start:'#13#10#13#10;
    for i := 0 to ModelObject.States.StateCount - 1 do begin
      t := t + Format(#9'%-14.6g'#13#10, [ModelObject.P0[i]]);
    end;
  end;
  //P Equilibrium
  if ModelObject.PEq <> nil then begin
    // added 9/2004 for Tony - sum( i * p(i) )
    //iPi := 0.0;
    t := t + #13#10'P equilibrium:'#13#10#13#10;
    for i := 0 to ModelObject.States.StateCount - 1 do begin
      t := t + Format(#9'%-14.6g'#13#10, [ModelObject.PEq[i]]);
      //iPi := iPi + ModelObject.PEq[i] * i / (ModelObject.States.StateCount-1) ;
    end;
    //t := t + Format(#13#10#9'Pseudo (virtual) T(s) = %f '#13#10, [iPi] );
  end;
  //Eigen Values and Time Constants
  if ModelObject.Lambdas <> nil then begin
    t := t + #13#10'Eigenvalues of Q:'#13#10#13#10;
    for i := 0 to ModelObject.States.StateCount - 1 do begin
      t := t + Format(#9'%-14.6g'#13#10, [ModelObject.Lambdas[i]]);
    end;
  end;
  //Macroscopic current
  t := t + #13#10'Macroscopic current:'#13#10#13#10;
  t := t + 'I(t) = Ieq';
  for i := 1 to ModelObject.States.StateCount - 1 do begin
    t := t + Format(' + b%d*exp(-t/tau%d)', [i, i]);
  end;
  t := t + #13#10;
  //bi's
  t := t + #13#10'bi''s(P0):'#13#10#13#10;
  try
    Vec := DAlloc1(ModelObject.States.StateCount);
    for i := 1 to ModelObject.States.StateCount - 1 do begin
      //bi = NC * P0 * Aki * Amp
      MulVecMatVec(ModelObject.P0, ModelObject.Ak[i], Vec, ModelObject.States.StateCount);
      c := 0;
      for j := 0 to ModelObject.States.StateCount - 1 do begin
        c := c + Vec[j] * ModelObject.Amp[ModelObject.States[j].Cls];
      end;
      t := t + Format(#9'%-14.6g'#13#10, [ModelObject.ChannelCount * c]);
    end;
  finally
    FreeMem(Vec);
  end;
  t := t + #13#10'tau''s [ms]:'#13#10#13#10;
  for i := 1 to ModelObject.States.StateCount - 1 do begin
    try
      t := t + Format(#9'%-14.6g'#13#10, [1e3 / Abs(ModelObject.Lambdas[i])]);
    except
    end;
  end;
  //Equilibrium current
  if ModelObject.PEq <> nil then begin
    t := t + #13#10'Ieq:'#13#10#13#10;
    c := 0;
    for i := 0 to ModelObject.States.StateCount - 1 do begin
      c := c + ModelObject.PEq[i] * ModelObject.Amp[ModelObject.States[i].Cls];
    end;
    t := t + Format(#9'%-14.6g'#13#10, [ModelObject.ChannelCount * c]);
  end;
  //Free Pars
  if ModelObject.FreePars <> nil then begin
    t := t + #13#10'Free Pars:'#13#10#13#10;
    for i := 0 to ModelObject.FreeParsCount - 1 do begin
      t := t + Format(#9'%-14.6g'#13#10, [ModelObject.FreePars[i]]);
    end;
  end;
  t := t + #13#10;
  Console.NewEntry(t, COLOR_TEXT);
end;

//TODO: change to Print stats
procedure TQUB_QVO_QVM.prOnEqProbCalc(Sender :TObject);
begin
  if CurrData <> nil then ModelObject.ADt := TQUB_QVO_QVD(CurrData).Sampling;
  if not ModelObject.CalculateProbEq(False{DoAssign}) then begin
    prWriteModelStats;
  end;
end;

procedure TQUB_QVO_QVM.prOnEqProbCalcAndAssign(Sender :TObject);
begin
  if CurrData <> nil then ModelObject.ADt := TQUB_QVO_QVD(CurrData).Sampling;
  if not ModelObject.CalculateProbEq(True{DoAssign}) then begin
    prWriteModelStats;
  end;
end;

procedure TQUB_QVO_QVM.prOnAdvanceProb(Sender :TObject);
var
  dt :String;
  t  :Double;
begin
  //if CurrData <> nil then begin
  //  dt := FloatToStr(TQUB_QVO_QVD(CurrData).Sampling);
  //end else begin
  //  dt := '1e-3';
  //end;
  dt := FloatToStr(prLastAdvancePStep);
  if InputQuery('Advance P', 'step [sec]:', dt) then begin
    try
      t := StrToFloat(dt);
    except
      Beep;
      Exit;
    end;
    if ModelObject.AdvanceProb(t) then begin
      Console.NewEntry('Error in Advance Prob', COLOR_ERROR);
    end else begin
      prLastAdvancePStep := t;
    end;
  end;
end;

procedure TQUB_QVO_QVM.prOnEnforceConstraints(Sender :TObject);
begin
  if ModelObject.EnforceConstraints then begin
    Console.NewEntry('Error in Enforce constraints', COLOR_ERROR);
  end;
end;

procedure TQUB_QVO_QVM.prOnRandomizeRates(Sender :TObject);
var
  se :String;
  e  :Double;
begin
  se := '10';
  if InputQuery('Randomize rates', 'standard error [%]', se) then begin
    try
      e := StrToFloat(se);
    except
      Beep;
      Exit;
    end;
    if ModelObject.RandomizeRates(e/100) then begin
      Console.NewEntry('Error in Randomize rates', COLOR_ERROR);
    end;
  end;
end;

procedure TQUB_QVO_QVM.prOnMakeStartState(Sender :TObject);
begin
  ModelObject.MakeStartState(ModelObject.States.IndexOf(ModelObject.States.CurrState));
end;

//----- Initialize the OpenGL 3-d Energy plot for the model
procedure TQUB_QVO_QVM.prOnEnergyLandscape(Sender :TObject);
const
  MAXRATE : Double = 100.0;
  MINSTATE : Double = -100.0;
  STATEDESCENT : Double = 10.0;   // Amount below diagram to place states
  STATESIZE : Double = 4.0;
var
  i, iStates, iRates, iSet : Integer;
  iPrevSet : Integer;                   // Sets in prior iteration, to determine if progress is being made
  iZeroState : Integer;                 // 'Base' state - which state is 0
  i1, i2 : Integer;                     // States for rate currently being examined
  nMaxZRate, nMinZState, nZLim : Double;// Range of Z rates for scaling
  k0_f, k0_b, k1_f, k1_b : Double;
  lQDependant, lPDependant : Boolean;   // Are any model rates P or Q dependant ?

  state, state2 : TQUB_QFS_State ;      // array of state levels
  aStateLevel0 : Array of double;
  aStateLevel1 : Array of double;

  rate : TQUB_QFS_RATE ;
  aRateLevel0 : Array of double;        // array of barrier heights
  aRateLevel1 : Array of double;        // array of barrier heights

  frmProperties : TModelEnergyPlotProperties;
  nMaxStimulus : Double;                // For stimulus dependent models (P or Q) - 2nd level
  nLnK0 : Double;                       // ln(Maxrate)

begin
  iStates := prModelObject.States.StateCount;
  iRates := prModelObject.Rates.RateCount;
  iZeroState := prModelObject.States.IndexOf(prModelObject.States.CurrState);

  //----- Check if model has any P or Q dependance
  lQDependant := False;
  lPDependant := False;
  for i:=0 to iRates-1 do Begin
    rate := prModelObject.Rates.rate[i];
    lQDependant := lQDependant or rate.Q[1] or rate.Q[2];
    lPDependant := lPDependant or rate.P[1] or rate.P[2];
  end;

  //----- Get user input
  frmProperties := TModelEnergyPlotProperties.Create(QUB_MainForm);
  frmProperties.Setup( iZeroState+1, iStates, lQDependant or lPDependant );
  frmProperties.ShowModal();
  if frmProperties.ModalResult=mrCancel Then
    exit;
  iZeroState := frmProperties.GetZeroState()-1;
  nMaxStimulus := frmProperties.GetMaxStimulus();
  nLnK0 := ln(max(1,frmProperties.GetReferenceRate()));
  frmProperties.Release();

  //----- Initialize array of state levels
  SetLength(aStateLevel0, iStates);
  SetLength(aStateLevel1, iStates);
  for i:=0 to iStates-1 do Begin
    aStateLevel0[i] := MINSTATE-1.0;
    aStateLevel1[i] := MINSTATE-1.0;
  end;

  //----- Initialize array of rate (barrier) levels
  SetLength( aRateLevel0, iRates );
  SetLength( aRateLevel1, iRates );
  for i:=0 to iRates-1 do begin
    aRateLevel0[i] := MAXRATE+1.0;
    aRateLevel1[i] := MAXRATE+1.0;
  end;

  //----- Use current state for zero state
  if (iZeroState<0) or (iZeroState>=iStates) Then
    iZeroState := 0;
  aStateLevel0[iZeroState] := 0.0;
  aStateLevel1[iZeroState] := 0.0;

  //----- Set level for rates until all have been set
  iSet := 0;
  iPrevSet := iSet-1;
  while (iSet<iRates) and (iSet>iPrevSet) do begin
    iPrevSet:=iSet;
    for i:=0 to iRates-1 do Begin
      rate := prModelObject.Rates.rate[i];
      k0_f := rate.k0[1];
      k0_b := rate.k0[2];
      if lQDependant Then Begin                     
        k1_f := rate.k0[1] * Choice(rate.Q[1], exp( rate.k1[1] * nMaxStimulus), 1.0 );
        k1_b := rate.k0[2] * Choice(rate.Q[2], exp( rate.k1[2] * nMaxStimulus), 1.0 );
      end else if lPDependant then Begin
        k1_f := rate.k0[1] * Choice(rate.P[1], nMaxStimulus, 1.0 );
        k1_b := rate.k0[2] * Choice(rate.P[2], nMaxStimulus, 1.0 );
      end else begin
        k1_f := rate.k0[1] ;
        k1_b := rate.k0[2] ;
      end;

      if (aRateLevel0[i]>MAXRATE) then begin
        i1 := rate.StateIndex[1];
        i2 := rate.StateIndex[2];
        if (aStateLevel0[i1]>=MINSTATE) and (aStateLevel0[i2]<MINSTATE) Then begin
          //-- 1 set, 2 not - set rate and 2
          aStateLevel0[i2] := aStateLevel0[i1] + ln( k0_b / k0_f );
          aRateLevel0[i] := nLnK0 + aStateLevel0[i1] - ln( k0_f );
          aStateLevel1[i2] := aStateLevel1[i1] + ln( k1_b / k1_f );
          aRateLevel1[i] := nLnK0 + aStateLevel1[i1] - ln( k1_f );
          inc(iSet);
        end else if (aStateLevel0[i1]<MINSTATE) and (aStateLevel0[i2]>=MINSTATE) Then begin
          //-- 2 set, 1 not - set rate and 1
          aStateLevel0[i1] := aStateLevel0[i2] + ln( k0_f / k0_b );
          aRateLevel0[i] := nLnK0 + aStateLevel0[i2] - ln( k0_b );
          aStateLevel1[i1] := aStateLevel1[i2] + ln( k1_f / k1_b );
          aRateLevel1[i] := nLnK0 + aStateLevel1[i2] - ln( k1_b );
          inc(iSet);
        end else if (aStateLevel0[i1]>=MINSTATE) and (aStateLevel0[i2]>=MINSTATE) Then begin
          //-- 1 and 2 set, set rate
          aRateLevel0[i] := min(MAXRATE, nLnK0 + aStateLevel0[i1] - ln( k0_f ));
          aRateLevel1[i] := min(MAXRATE, nLnK0 + aStateLevel1[i1] - ln( k1_f ));
          inc(iSet);
        end;
      end;
    end;
  end;

  //----- Find Z axis limit
  nMinZState := -1.0;
  for i:=0 to iStates-1 do
    nMinZState := min( min( nMinZState, aStateLevel0[i] ), aStateLevel1[i] );
  nMinZState := nMinZState - STATEDESCENT - STATESIZE;

  nMaxZRate := 1.0;
  for i:=0 to iRates-1 do
    nMaxZRate := max( max( nMaxZRate, aRateLevel0[i] ), aRateLevel1[i] );

  nZLim := 100.0 / max(-1.0*nMinZState,nMaxZRate);

  //----- Setup Energy Model
  if g_frmEnergyPlot = nil Then
    g_frmEnergyPlot := TEnergyPlot.Create(QUB_MainForm)
  else
    g_frmEnergyPlot.Free();
  g_frmEnergyPlot.SetStimulusDependency(lQDependant or lPDependant);


  for i:=0 to iRates-1 do Begin
    rate := prModelObject.Rates.Rate[i];
    state := prModelObject.States[rate.StateIndex[1]];
    state2 := prModelObject.States[rate.StateIndex[2]];
    g_frmEnergyPlot.AddRate(
                    state.X*2-100,
                    100.0-state.Y*2,
                    aStateLevel0[rate.StateIndex[1]] * nZLim,
                    aStateLevel1[rate.StateIndex[1]] * nZLim,
                    state2.X*2-100,
                    100.0-state2.Y*2,
                    aStateLevel0[rate.StateIndex[2]] * nZLim,
                    aStateLevel1[rate.StateIndex[2]] * nZLim,
                    aRateLevel0[i]*nZLim,
                    aRateLevel1[i]*nZLim );
  end;
  for i:=0 to iStates-1 do Begin
    state := prModelObject.States[i];
    g_frmEnergyPlot.AddState( state.X*2-100.0,
                      100.0 - state.Y*2,
                      aStateLevel0[i] * nZLim - STATEDESCENT,
                      aStateLevel1[i] * nZLim - STATEDESCENT,
                      STATESIZE, IntToStr(i+1),
                      QUB_QFS_QMF_CLASS_COLORS[state.Cls]
                      );
  end;

  g_frmEnergyPlot.Visible := True;
end;

//---------
procedure TQUB_QVO_QVM.prOnUseGlobalCond(Sender :TObject);
begin
  UseGlobalCond := not UseGlobalCond;
end;

procedure TQUB_QVO_QVM.prOnEditGlobalCond(Sender :TObject);
begin
  ViewportModel.EditDefExpCond;
end;


//----- Change the index number for a state
procedure TQUB_QVO_QVM.prOnSetIndex(Sender :TObject);
var
  iOldState, iNewState : Integer;
  iStates : Integer;
  oDlg : TSingleEntry;
begin
  iOldState:=prModelObject.States.IndexOf(prModelObject.States.WhichState(TQUB_QFS_StatePanel(prPopUpTarget)));
  iStates:=prModelObject.States.StateCount;

  oDlg := TSingleEntry.Create(Self);
  oDlg.Setup( iOldState+1, 1, iStates, 'New state index :', 'Change state index' );
  iNewState := oDlg.ShowModal()-1;

  if (iNewState>=0) and (iNewState<iStates) and (iNewState<>iOldState) Then Begin
    prModelObject.SwapStates(iOldState,iNewState);
  end;
end;

procedure TQUB_QVO_QVM.prOnUnmerge(Sender :TObject);
begin
  ViewportModel.Unmerge(Self);
end;

function TQUB_QVO_QVM.prConfirmRemoveFactors(Action :String): Boolean;
begin
  Result := False;
  
  if Factors.IsNull then begin
    Result := True;
  end else begin
    case MessageHelpDlg('You will not be able to UnMerge after ' + Action + '.  Do it anyway?', mtWarning, [mbYes, mbNo], 0, 'Warning:Not_Able_to_UnMerge') of
      mrYes:
        begin
          prFactors := TNode.CreateNull;
          Result    := True;
          Exit;
        end;
      //mrNo:
        //Continue;
    end;//case
  end;
end;

procedure TQUB_QVO_QVM.prOnGrab(Sender :TObject);
var
  State :TQUB_QFS_State;
  GAmp  :Double;
  GStd  :Double;
begin
  if (not prModelObject.LockedAny) and (prModelObject.CanEdit) then begin
    State := prModelObject.States.WhichState(TQUB_QFS_StatePanel(prPopUpTarget));
    if State = nil then Exit;
    if CurrData = nil then Exit;
    if not TQUB_QVO_QVD(CurrData).GrabAvgStd(GAmp, GStd) then Exit;
    StateAmp[State.Cls] := GAmp;
    StateStd[State.Cls] := GStd;
    State.Amp := StateAmp[State.Cls];
    State.Std := StateStd[State.Cls];
    prModelObject.States.UpdateStates;
  end;
end;

procedure TQUB_QVO_QVM.prOnGrabAll(Sender :TObject);
var
  SavedDataSource :TQUB_Task_Data_Source;
  Results         :INode;
  Amp, Std        :INode;
  i               :Integer;
  Warning         :Boolean;
begin

  if ViewportData.CurrData = nil then begin
    Beep;
    Exit;
  end;

  SavedDataSource := QUB_MainForm.DataSource;
  Warning         := False;

  try
    QUB_MainForm.DataSource := DATA_SOURCE_SELECTION;
    Results       := SimpleAMP(QUB_Node_Null, QUB_Node_Null, (TMenuItem(Sender).Tag <> 0), False{Idealize});
    Amp           := Results['amp'];
    Std           := Results['sd'];
    Warning       := Amp.DataCount = 0;
    for i := 0 to Min(Amp.DataCount, Std.DataCount) - 1 do begin
      Warning     := Warning or (StateAmp[i] = Amp.Data[i]) or (Std.Data[i] = 0.0);
      if Std.Data[i] <> 0.0 then begin
        StateAmp[i] := Amp.Data[i];
        StateStd[i] := Std.Data[i];
      end;
    end;
    prModelObject.States.UpdateStates;
  except
  end;

  QUB_MainForm.DataSource := SavedDataSource;
  if Warning then MessageHelpDlg('Trouble estimating amps.  Try selecting a different piece of single-channel data, or "grab" each level separately.', mtError, [mbOK], 0, 'Error:Trouble_Estimating_Amps');
end;

procedure TQUB_QVO_QVM.prOnCopyImage(Sender :TObject);
begin
  CopyImage(True);
end;

procedure TQUB_QVO_QVM.prOnPrint(Sender :TObject);
begin
  Print;
end;

procedure TQUB_QVO_QVM.prOnPopUp(Sender :TObject);
var
  IsM :Boolean;
  IsS :Boolean;
  IsR :Boolean;
  IsE :Boolean;
  RatePanel :TQUB_QFS_RatePanel;
begin

  IsM :=  prPopUpMenu.PopUpComponent = Self;
  IsS := (prPopUpMenu.PopUpComponent <> nil) and (prPopUpMenu.PopUpComponent is TQUB_QFS_StatePanel);
  IsR := False;
  ///IsR := (prPopUpMenu.PopUpComponent <> nil) and (prPopUpMenu.PopUpComponent is TQUB_QFS_RatePanel);
  IsE := (not prModelObject.LockedAny) and (prModelObject.CanEdit);
  prPopupTarget := prPopupMenu.PopupComponent;

  if IsM then begin
    RatePanel := prModelObject.Rates.WhichPanel(prMouse);
    if RatePanel <> nil then begin
      IsM := False;
      IsR := True;
      prPopupTarget := RatePanel;
    end;
  end;

  //Change menu items's visibility and caption according to the caller

  prEditCutItem.Visible            := IsM       and IsE;
  prEditCopyItem.Visible           := IsM       and IsE;
  prEditPasteItem.Visible          := IsM       and IsE;
  prEditDeleteItem.Visible         := (not IsM) and IsE;

  prEditDeleteItem.Caption         := Choice(IsM, 'Delete', Choice(IsS, 'Delete state', Choice(IsR, 'Delete connection', '')));

  prGrabItem.Visible               := IsS       and IsE;
  prGrabAllIncItem.Visible         := IsM       and IsE;
  prGrabAllDecItem.Visible         := prGrabAllIncItem.Visible;

  prEqProbItem.Visible             :=  IsM      and IsE;
  prAdvanceProbItem.Visible        :=  IsM      and IsE;
  prMakeStartStateItem.Visible     :=  IsS      and IsE;
  prEnforceConstraintsItem.Visible :=  IsM      and IsE;
  prRandomizeRatesItem.Visible     :=  IsM      and IsE;
  prEnergyLandscapeItem.Visible    :=  IsM;
  prUseGlobalCondItem.Visible      :=  IsM;
  prEditGlobalCondItem.Visible     :=  IsM;
  prSetIndexItem.Visible           :=  IsS;
  prUnmergeItem.Visible            :=  IsM      and (not Factors.IsNull);
  prPrintItem.Visible              :=  IsM;
  prEditCopyImageItem.Visible      :=  IsM;

  prUseGlobalCondItem.Checked      := UseGlobalCond;

end;


//****************************************************************************//
//                                                                            //
//                     M O D E L    M O U S E    E V E N T S                  //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVM.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Handled   :Boolean;
begin

  inherited;

  // chris 8-30-5, 12-21-5 why not?
  //LM. See below
// chris 2007-mar-01 no seriously it doesn't always run below
  prMouse.x := x;
  prMouse.y := y;


  Handled := False;
  prModelObject.Rates.DoMouseDown(Self, Button, Shift, X, Y, Handled);
  if Handled then begin
    //TO DO: LM. Check what is the problem (not with Chris!)
    //prMouse.x := x;
    //prMouse.y := y;
    Exit;
  end;

  try
    if not ViewportModel.Active then ViewportModel.Activate;

    if PopUpMenu <> nil then PopUpMenu.AutoPopup := True;

    prConnState := nil;

    if (Button = mbLeft) and (prMouseHitCount < 2) then begin
      prMouse.x := -1;
      Exit;
    end;

    if prHasDblClicked then Exit;

    //See above (Chris has it in only one place - top)
    //prMouse.x := x;
    //prMouse.y := y;

  finally

    prHasDblClicked := False;

  end;
end;

procedure TQUB_QVO_QVM.MouseMove(Shift: TShiftState; X, Y: Integer);
var
  Handled :Boolean;
  Rate    :TQUB_QFS_RatePanel;
begin
  try

    if prDoingRate then begin

      if PopUpMenu <> nil then PopUpMenu.AutoPopup := False;

      prMouse.x := x;
      prMouse.y := y;
      prDrawLine(clRed, x, y, QUB_QVO_QVM_LINE_MOVE);

    end else begin

      Handled := False;
      Rate := prModelObject.Rates.DoMouseMove(Self, Shift, X, Y, Handled);
      if Rate <> prHoverRate then begin
        if Rate <> nil then begin
          Hint := Rate.Hint;
        end else begin
          Hint := ''; // now no hint outside hint zone // was prModelSetHint;
        end;
        prHoverRate := Rate;
        ShowHint := False;     // hide currently-visible hint if any so it can be re-shown with new contents
      end else begin
        ShowHint := TipsOn;    // show the hint that was set on initial move
      end;
      if Handled then Exit;

    end;

  finally

    inherited;

  end;
end;

procedure TQUB_QVO_QVM.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Handled  :Boolean;
begin
  Handled := False;
  prModelObject.Rates.DoMouseUp(Self, Button, Shift, X, Y, Handled);
  if Handled then Exit;

  try

    prConnState := nil;

    if prDoingRate then begin

      if PopUpMenu <> nil then PopUpMenu.AutoPopup := False;
      prDrawLine(0, 0, 0, QUB_QVO_QVM_LINE_END);
      prDoingRate := False;

    end else if prMouseRunning then begin

      if PopUpMenu <> nil then PopUpMenu.AutoPopup := False;
      prMouseRunning := False;

    end else if Button = mbLeft then begin

      if PopUpMenu <> nil then PopUpMenu.AutoPopup := False;

      if (prMouseHitCount >= 2) and (prMouse.x <> - 1) then begin

        if (not prModelObject.LockedAny) and (prModelObject.CanEdit) then begin

          AddState(prMouse);

        end;

      end;

    end;

  finally

    prMouse.x := -1;

    if PopUpMenu <> nil then PopUpMenu.AutoPopup := True;

    inherited;

  end;

end;

procedure TQUB_QVO_QVM.MouseWheel(Sender :TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var
  LocalPos            :TPoint;
begin
  LocalPos            := ScreenToClient(MousePos);
  prModelObject.Rates.DoMouseWheel(Self, Shift, WheelDelta, LocalPos, Handled);
end;

procedure TQUB_QVO_QVM.DblClick;
var
  Handled  :Boolean;
begin
  try

    Handled := False;
    prModelObject.Rates.DoDblClick(Self, prMouse.x, prMouse.Y, Handled);
    if Handled then Exit;

  finally

    prHasDblClicked := True;

    inherited;

  end;
end;


//****************************************************************************//
//                                                                            //
//                     S T A T E    M O U S E    E V E N T S                  //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVM.prStateMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  
  // When model state is clicked on, force model viewport active.  2004-03 {JB}
  if not ViewportModel.Active then ViewportModel.Activate;

  if PopUpMenu <> nil then PopUpMenu.AutoPopup := True;

  prConnState := nil;

  prState.x := x;
  prState.y := y;

  prModelObject.States.CurrState := TQUB_QFS_StatePanel(Sender).State;
  {
  if ((prModelObject.States.CurrState <> nil) and (prModelObject.States.CurrState.Panel <> Sender)) or (prModelObject.States.CurrState = nil) then begin
    prModelObject.States.CurrState := TQUB_QFS_StatePanel(Sender).State; // prModelObject.States.WhichState(TQUB_QFS_StatePanel(Sender)); // was popupstate?
  end;
  }
  if Button = mbLeft then begin

    prMouseRunning := True;
    prDoingRate    := False;

  end else if Button = mbRight then begin

    prConnState := prModelObject.States.CurrState;

    prMouseRunning := False;

    prMouseLine.x := TControl(Sender).Left + x;
    prMouseLine.y := TControl(Sender).Top  + y;

    if (not prModelObject.LockedAny) and (prModelObject.CanEdit) then begin
      prDoingRate := True;
      prDrawLine(clRED, prMouseLine.x, prMouseLine.y, QUB_QVO_QVM_LINE_START);
      prConnState := prModelObject.States.CurrState;
    end;

  end;

end;

procedure TQUB_QVO_QVM.prStateMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  State :TQUB_QFS_State;
begin
  State := TQUB_QFS_StatePanel(Sender).State; // prModelObject.States.WhichState(TQUB_QFS_StatePanel(Sender));

  if prDoingRate then begin

    if (PopUpMenu <> nil) and ((Sqr(x-prState.x) + Sqr(y-prState.y)) > (State.Panel.Width div 2)) then begin
      PopUpMenu.AutoPopup := False;
    end;

    if prModelObject.States.CurrState <> State then begin

      prDrawLine(0, 0, 0, QUB_QVO_QVM_LINE_END);

      prModelObject.States.CurrState := State;
      Draw;

      if (State <> prConnState) and (not prModelObject.Connected(prConnState, State)) then begin
        prDrawLine(clGREEN, TControl(Sender).Left + x, TControl(Sender).Top + y, QUB_QVO_QVM_LINE_START);
      end else begin
        prDrawLine(clRED,   TControl(Sender).Left + x, TControl(Sender).Top + y, QUB_QVO_QVM_LINE_START);
      end;

    end else begin

      prDrawLine(clRED,   TControl(Sender).Left + x, TControl(Sender).Top + y, QUB_QVO_QVM_LINE_MOVE);

    end;

  end else if prMouseRunning then begin

    if PopUpMenu <> nil then PopUpMenu.AutoPopup := False;

    if prModelObject.States.CurrState <> State then begin // ((prModelObject.States.CurrState <> nil) and (prModelObject.States.CurrState <> State)) or (prModelObject.States.CurrState = nil) then begin
      prModelObject.States.CurrState := State; // prModelObject.States.WhichState(TQUB_QFS_StatePanel(Sender));
    end;

    PosState(prModelObject.States.CurrState, TControl(Sender).Left + (prStateSize div 2) + x - prState.x, TControl(Sender).Top + (prStateSize div 2) + y - prState.y);

  end else begin

    if PopUpMenu <> nil then PopUpMenu.AutoPopup := True;

    if prModelObject.States.CurrState <> State then begin // if ((prModelObject.States.CurrState <> nil) and (prModelObject.States.CurrState.Panel <> TPanel(Sender).Parent.Parent)) or (prModelObject.States.CurrState = nil) then begin
      prModelObject.States.CurrState := State; // prModelObject.States.WhichState(TQUB_QFS_StatePanel(Sender)); // prPopUpMenu.PopUpComponent));
      Invalidate;
    end;

  end;

end;

procedure TQUB_QVO_QVM.prStateMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  State :TQUB_QFS_State;
begin

  State := TQUB_QFS_StatePanel(Sender).State;

  if Button = mbRight then begin

    if prDoingRate then begin

      if PopUpMenu <> nil then PopUpMenu.AutoPopup := False;

      prDoingRate := False;
      prDrawLine(0, 0, 0, QUB_QVO_QVM_LINE_END);

      if (prConnState <> nil) and (prConnState <> State) then begin // (Sender <> prConnState.Panel) then begin

        if not prModelObject.Connected(prConnState, State) then begin // prModelObject.States.WhichState(TQUB_QFS_StatePanel(Sender))) then begin
          AddRate(prConnState, State); // prModelObject.States.WhichState(TQUB_QFS_StatePanel(Sender)));
        end;

      end;

      //end else begin        -- no wait...no matter what

        if PopUpMenu <> nil then begin
          PopUpMenu.AutoPopup := True;
        end;

      //end;

    end else begin

      if PopUpMenu <> nil then begin
        PopUpMenu.AutoPopup := True;
      end;

    end;

  end else if Button = mbLeft then begin

    if prMouseRunning then begin
      prMouseRunning := False;
    end;

  end;

  prDoingRate    := False;
  prMouseRunning := False;

end;

procedure TQUB_QVO_QVM.prStateDblClick(Sender: TObject);
var
  State :TQUB_QFS_State;
  c     :Integer;
begin

  c := 0;

  if (prModelObject.LockedAny) or (not prModelObject.CanEdit) then Exit;

  State := prModelObject.States.CurrState;
  if State = nil then Exit;

  if not prConfirmRemoveFactors('changing a state''s class') then Exit;

  if KeyShift then begin
    if State.Cls > 0 then c := State.Cls - 1;
  end else begin
    c := State.Cls + 1;
  end;

  //I modified the code to make class changing a scriptable function (LM)

  //This function is scriptable
  prModelObject.ChangeStateClass(State, c);

end;


//****************************************************************************//
//                                                                            //
//                      R A T E    M O U S E    E V E N T S                   //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVM.prRateMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  RateIdx :Integer;
  HalfIdx :Integer;
  K01     :Integer;
begin

  //Testing LM
  RateIdx     := prModelObject.Rates.RecordIndex(TQUB_QFS_RatePanel(Sender).Rate);
  HalfIdx     := TQUB_QFS_RatePanel(Sender).Dir;
  K01         := TQUB_QFS_RatePanel(Sender).K01;
  //if RateIdx >= 0 then begin
  //  HalfIdx   := Choice(prModelObject.Rates[RateIdx].Panels[1] = Sender, 1, 2);
  //end;
  if ((RateIdx >= 0) and (RateIdx <> prModelObject.Rates.CurrRateIdx)) or
     ((RateIdx >= 0) and (HalfIdx <> prModelObject.Rates.CurrHalfIdx)) or
     ((RateIdx >= 0) and (K01 <> prModelObject.Rates.CurrK01)) then begin
    prModelObject.Rates.CurrRateIdx := RateIdx;
    prModelObject.Rates.CurrHalfIdx := HalfIdx;
    prModelObject.Rates.CurrK01     := K01;
    if ShowSelectedRate then Draw;
  end;

  // When model rate is clicked on, force model viewport active.  2004-03 {JB}
  if not ViewportModel.Active then ViewportModel.Activate;

  if PopUpMenu <> nil then PopUpMenu.AutoPopup := True;

end;

procedure TQUB_QVO_QVM.prRateMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if prDoingRate then begin
    prDrawLine(clRED, TControl(Sender).Left + x, TControl(Sender).Top + y, QUB_QVO_QVM_LINE_MOVE);
  end;
end;

procedure TQUB_QVO_QVM.prRateMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin

  if Button = mbRight then begin

    if prDoingRate then begin

      if PopUpMenu <> nil then PopUpMenu.AutoPopup := False;
      prDoingRate := False;
      prDrawLine(0, 0, 0, QUB_QVO_QVM_LINE_END);

    end else begin

     if PopUpMenu <> nil then PopUpMenu.AutoPopup := True;

    end;

  end;

end;

procedure TQUB_QVO_QVM.prRateMouseWheel(Sender :TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var
  Rate       :TQUB_QFS_Rate;
  Dir        :Integer;
  Incr       :Double;
  Num        :Double;
  s1, s2     :Integer;
  k0ork1     :Boolean;
begin
  if (prModelObject.LockedAny and not AllowNumEdit) or
    (not prModelObject.CanEdit) or
    (not ScrollRates)
  then Exit;

  //TO DO: It's not clear how to distinguish between k0 and k1. I don't think it does,
  //so I'm changing it so that Ctrl+Shift will be used for k1 and the other combinations as before

  // actually it told them apart just fine, but only in "write rates along arrows" mode.
  // so I'm enabling both styles.

  Rate := TQUB_QFS_RatePanel(Sender).Rate;
  if Rate <> nil then begin
    Dir := TQUB_QFS_RatePanel(Sender).Dir;
    k0ork1 := not ((TQUB_QFS_RatePanel(Sender).K01 = QUB_QFS_QMF_RATE_K1)
                   or ((ssShift in Shift) and (ssCtrl in Shift)));

    if k0ork1 then begin
      Num := Rate.K0[Dir];
    end else begin
      Num := Rate.K1[Dir];
    end;

    // Incr := most significant digit (abs) changed to 1
    if Num = 0.0 then begin
      Incr := 1.0;
    end else begin
      Incr := 1.0e15;
      while Abs(Num) < Incr do begin
        Incr := Incr / 10.0;
      end;
      if WheelDelta < 0 then begin
        if Abs(Num) < (Incr + Incr/10) then begin
          Incr := Incr / 10.0;
        end;
      end;
    end;

    if ssShift in Shift then begin
      // full m.s.d. increment
    end else if ssCtrl in Shift then begin
      Incr := Incr / 100.0; // now 1/100 of m.s.d.
    end else begin
      Incr := Incr / 10.0; // default 1/10 of m.s.d.
    end;

    Num := Num + WheelDelta * Incr / 120.0;

    if Dir = 1 then begin
      s1 := Rate.StateIndex[1];
      s2 := Rate.StateIndex[2];
    end else begin
      s1 := Rate.StateIndex[2];
      s2 := Rate.StateIndex[1];
    end;

    if EnforceConstraints then begin
      ModelObject.ConstrainedSetRate(s1, s2, k0ork1, Num);
    end else begin
      if k0ork1 then begin
        Rate.K0[Dir] := Num;
      end else begin
        Rate.K1[Dir] := Num;
      end;
    end;
  end;

  Handled := True;
end;


procedure TQUB_QVO_QVM.DoOnRateDblClick(Sender: TObject);
var
  Rate  :TQUB_QFS_Rate;
begin
  if (prModelObject.LockedAny) or (not prModelObject.CanEdit) then Exit;

  Rate := TQUB_QFS_RatePanel(Sender).Rate;
  if Rate <> nil then begin
    prRateIndexForProperties := TQUB_QFS_RatePanel(Sender).Dir;
    prRateK01ForProperties   := TQUB_QFS_RatePanel(Sender).K01;
    //prRateProperties(Rate);

    //Testing LM. **************************************
    prPropertiesForm.pagControl.ActivePage := prPropertiesForm.tabRates;
    Properties;
    //**************************************************

    //Check this
    //prRateProperties(Rate, Rate.WhichState(TQUB_QFS_RatePanel(Sender)));
  end;
end;

procedure TQUB_QVO_QVM.prHintZoneMouseDown(Sender :TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MouseDown(Button, Shift, X, Y);
end;

procedure TQUB_QVO_QVM.prHintZoneMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  MouseMove(Shift, X, Y);
end;

procedure TQUB_QVO_QVM.prHintZoneMouseUp(Sender: TObject;Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MouseUp(Button, Shift, X, Y);
end;

procedure TQUB_QVO_QVM.prHintZoneDblClick(Sender: TObject);
begin
  DblClick;
end;


procedure TQUB_QVO_QVM.txtChannelCountKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtChannelCountExit(Sender);
  end;
end;

procedure TQUB_QVO_QVM.txtChannelCountExit(Sender: TObject);
var
  c :Integer;
begin
  inherited;
  if LockedAny then begin
    TEdit(Sender).Text := IntToStr(ModelObject.ChannelCount);
    Exit;
  end;
  try
    c := StrToInt(TEdit(Sender).Text);
    if ((c < QUB_QFS_QMF_MIN_CHANNEL_COUNT) {or (c > QUB_QFS_QMF_MAX_CHANNEL_COUNT)}) then raise Exception.Create('');
  except
    MessageDlg('Invalid value; must be between ' + IntToStr(QUB_QFS_QMF_MIN_CHANNEL_COUNT) + ' and ' + IntToStr(QUB_QFS_QMF_MAX_CHANNEL_COUNT), mtError, [mbOK], 0);
    TEdit(Sender).Text := IntToStr(ModelObject.ChannelCount);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if c <> ModelObject.ChannelCount then begin
    ModelObject.ChannelCount := c;
  end;
end;

procedure TQUB_QVO_QVM.udChannelCountClick(Sender: TObject; Button: TUDBtnType);
var
  Cnt :Integer;
begin
  inherited;
  Cnt := ModelObject.ChannelCount;
  if Button = btPrev then begin
    if      Cnt >= 20000000 then Dec(Cnt, 10000000)
    else if Cnt >= 2000000  then Dec(Cnt, 1000000)
    else if Cnt >= 200000   then Dec(Cnt, 100000)
    else if Cnt >= 20000    then Dec(Cnt, 10000)
    else if Cnt >= 2000     then Dec(Cnt, 1000)
    else if Cnt >= 200      then Dec(Cnt, 100)
    else if Cnt >= 20       then Dec(Cnt, 10)
    else                         Dec(Cnt, 1);
    if Cnt < QUB_QFS_QMF_MIN_CHANNEL_COUNT then Cnt := QUB_QFS_QMF_MIN_CHANNEL_COUNT;
  end else begin
    if      Cnt >= 10000000 then Inc(Cnt, 10000000)
    else if Cnt >= 1000000  then Inc(Cnt, 1000000)
    else if Cnt >= 100000   then Inc(Cnt, 100000)
    else if Cnt >= 10000    then Inc(Cnt, 10000)
    else if Cnt >= 1000     then Inc(Cnt, 1000)
    else if Cnt >= 100      then Inc(Cnt, 100)
    else if Cnt >= 10       then Inc(Cnt, 10)
    else                         Inc(Cnt, 1);
    //if Cnt > QUB_QFS_QMF_MAX_CHANNEL_COUNT then Cnt := QUB_QFS_QMF_MAX_CHANNEL_COUNT;
  end;
  if Cnt <> ModelObject.ChannelCount then begin
    ModelObject.ChannelCount := Cnt;
  end;
end;

procedure TQUB_QVO_QVM.udChannelCountChanging(Sender: TObject; var AllowChange: Boolean);
begin
  inherited;
  if prChannelCountChanging then Exit;
  prChannelCountChanging := True;
  try
    udChannelCount.Position := 2;
  finally
    prChannelCountChanging := False;
  end;
end;

{
procedure TQUB_QVO_QVM.txtVRevKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtVRevExit(Sender);
  end;
end;

procedure TQUB_QVO_QVM.txtVRevExit(Sender: TObject);
var
  c :Integer;
begin
  inherited;
  if LockedAny then begin
    TEdit(Sender).Text := IntToStr(ModelObject.ChannelCount);
    Exit;
  end;
  try
    c := StrToInt(TEdit(Sender).Text);
    if ((c < QUB_QFS_QMF_MIN_CHANNEL_COUNT) or (c > QUB_QFS_QMF_MAX_CHANNEL_COUNT)) then raise Exception.Create('');
  except
    MessageDlg('Invalid value; must be between ' + IntToStr(QUB_QFS_QMF_MIN_CHANNEL_COUNT) + ' and ' + IntToStr(QUB_QFS_QMF_MAX_CHANNEL_COUNT), mtError, [mbOK], 0);
    TEdit(Sender).Text := IntToStr(ModelObject.ChannelCount);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if c <> ModelObject.ChannelCount then begin
    ModelObject.ChannelCount := c;
  end;
end;
}

//****************************************************************************//
//                                                                            //
//                             K E Y   E V E N T S                            //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVM.CNKeyDown(var Message: TWMKeyDown);
const
  VK_OEM_PLUS   = 187;
  VK_OEM_MINUS  = 189;
var
  Eaten         :Boolean;
  VoidPos       :TPoint;
begin

  Eaten         := False;

  case Message.CharCode of

    //Browse Commands
    VK_LEFT, VK_RIGHT, VK_UP, VK_DOWN://, VK_PRIOR, VK_NEXT, VK_END, VK_HOME:
      begin
        prMoveStates(Message.CharCode, KeyShift, KeyControl);
        Eaten := True;
      end;

    VK_DELETE:
      begin
        if ModelObject.States.CurrState <> nil then begin
          DelState(ModelObject.States.CurrState);
          Eaten := True;
        end;
      end;

    Word('P')://Properties
      begin
        if KeyControl then begin
          prOnProperties(nil);
          Eaten := True;
        end;
      end;

    VK_SUBTRACT, VK_OEM_MINUS:
      begin
        if prHoverRate <> nil then begin
          prRateMouseWheel(prHoverRate, [], -120, VoidPos, Eaten);
        end;
      end;

    VK_ADD, VK_OEM_PLUS:
      begin
        if prHoverRate <> nil then begin
          prRateMouseWheel(prHoverRate, [], 120, VoidPos, Eaten);
        end;
      end;

  end;//case

  if not Eaten then inherited;

end;



//Interactive properties
procedure TQUB_QVO_QVM.prSetColor(c :TColor);
var
  i :Integer;
begin
  inherited;
  if ModelObject <> nil then begin
    for i := 0 to prModelObject.Rates.RateCount - 1 do begin
      prModelObject.Rates[i].Panels[1].Color := prColor;        //??
      prModelObject.Rates[i].Panels[2].Color := prColor;
    end;
  end;
  prMustRedraw := True;
  ModelObject.Properties['ColorPanel'].Data[0] := Integer(c);
end;

procedure TQUB_QVO_QVM.prSetColorBack(c :TColor);
begin
  inherited;
  ModelObject.Properties['ColorBack'].Data[0] := Integer(c);
  prMustRedraw := True;
  prHintZone.Color := c;
end;

procedure TQUB_QVO_QVM.prSetColorFrame(c :TColor);
begin
  inherited;
  prMustRedraw := True;
  ModelObject.Properties['ColorFrame'].Data[0] := Integer(c);
end;

procedure TQUB_QVO_QVM.prSetColorLine(c :TColor);
begin
  prColorLine := c;
  prMustRedraw := True;
  ModelObject.Properties['ColorLine'].Data[0] := Integer(c);
end;

procedure TQUB_QVO_QVM.prSetColorRate(c :TColor);
var
  i, j :Integer;
begin
  prColorRate := c;
  for i := 0 to prModelObject.Rates.RateCount - 1 do begin
    for j := 1 to 4 do begin
      prModelObject.Rates[i].Panels[j].{Font.}Color := prColorRate;
    end;
  end;
  prMustRedraw := True;
  ModelObject.Properties['ColorRate'].Data[0] := Integer(c);
end;

procedure TQUB_QVO_QVM.prSetColorSelected(c :TColor);
begin
  prColorSelected := c;
  with prModelObject do begin
    if (Rates.CurrRateIdx >= 0) and (prShowSelectedRate) then begin
      Rates[Rates.CurrRateIdx].Panels[Rates.CurrHalfIdx].{Font.}Color := prColorSelected;
      Rates[Rates.CurrRateIdx].Panels[Rates.CurrHalfIdx+2].{Font.}Color := prColorSelected;
      prMustRedraw := True;
    end;
  end;
  ModelObject.Properties['ColorSelected'].Data[0] := Integer(c);
end;

procedure TQUB_QVO_QVM.prSetStateSize(s :Integer);
begin
  prStateSize := s;
  ResizeModel(Width, Height);
  prMustRedraw := True;
  ModelObject.Properties['StateSize'].Data[0] := s;
end;

procedure TQUB_QVO_QVM.prSetLineWidth(w :Integer);
begin
  prLineWidth := w;
  prMustRedraw := True;
  ModelObject.Properties['LineWidth'].Data[0] := w;
end;

procedure TQUB_QVO_QVM.prSetAlignToGrid(a :Boolean);
begin
  prAlignToGrid := a;
  prMustRedraw := True;
  ModelObject.Properties['AlignToGrid'].Data[0] := Integer(a);
end;

procedure TQUB_QVO_QVM.prSetUseGlobalCond(a :Boolean);
begin
  if prUseGlobalCond <> a then begin
    prUseGlobalCond := a;
    if prUseGlobalCond then begin
      ExpCond := ViewportModel.DefExpCond;
    end else begin
      ExpCond := ViewportModel.ExpCond;
    end;
  end;
  ModelObject.Properties['UseGlobalCond'].Data[0] := Integer(a);
end;

procedure TQUB_QVO_QVM.prSetScrollRates(a :Boolean);
begin
  prScrollRates := a;
  ModelObject.Properties['ScrollRates'].Data[0] := Integer(a);
end;

procedure TQUB_QVO_QVM.prSetDiagonalRates(a :Boolean);
begin
  prDiagonalRates := a;
  prModelObject.Rates.DiagonalRates := a;
  prMustRedraw := True;
  ModelObject.Properties['DiagonalRates'].Data[0] := Integer(a);
end;

procedure TQUB_QVO_QVM.prSetShowK1(a :Boolean);
begin
  prShowK1 := a;
  prModelObject.Rates.ShowK1 := a;
  prMustRedraw := True;
  ModelObject.Properties['ShowK1'].Data[0] := Integer(a);
end;

procedure TQUB_QVO_QVM.prSetEnforceConstraints(x :Boolean);
begin
  prEnforceConstraints := x;
  if x then ModelObject.EnforceConstraints;
  ModelObject.Properties['EnforceConstraints'].Data[0] := Integer(x);
end;

procedure TQUB_QVO_QVM.prSetIeqFv(x :Boolean);
begin
  prIeqFv := x;
  ModelObject.Properties['IeqFv'].Data[0] := Integer(x);
end;

procedure TQUB_QVO_QVM.prSetMarginH(m :Integer);
begin
  prMarginH       := m;
  prMargin.Left   := m;
  prMargin.Right  := m;
  prMustRedraw    := True;
  ModelObject.Properties['MarginH'].Data[0] := m;
end;

procedure TQUB_QVO_QVM.prSetMarginV(m :Integer);
begin
  prMarginV       := m;
  prMargin.Top    := m;
  prMargin.Bottom := m;
  prMustRedraw    := True;
  ModelObject.Properties['MarginV'].Data[0] := m;
end;

//State Interactive properties
procedure TQUB_QVO_QVM.prSetStateAmp(Index :Integer; a :Double);
begin
  prModelObject.Amp[Index] := a;
  prMustRedraw := True;
end;

function  TQUB_QVO_QVM.prGetStateAmp(Index :Integer) :Double;
begin
  Result := prModelObject.Amp[Index];
end;

procedure TQUB_QVO_QVM.prSetStateStd(Index :Integer; s :Double);
begin
  prModelObject.Std[Index] := s;
  prMustRedraw := True;
end;

function  TQUB_QVO_QVM.prGetStateStd(Index :Integer) :Double;
begin
  Result := prModelObject.Std[Index];
end;

procedure TQUB_QVO_QVM.prSetStateCond(Index :Integer; c :Double);
begin
  prModelObject.Cond[Index] := c;
  prMustRedraw := True;
end;

function  TQUB_QVO_QVM.prGetStateCond(Index :Integer) :Double;
begin
  Result := prModelObject.Cond[Index];
end;

procedure TQUB_QVO_QVM.prSetStateCondStd(Index :Integer; x :Double);
begin
  prModelObject.CondStd[Index] := x;
  prMustRedraw := True;
end;

function  TQUB_QVO_QVM.prGetStateCondStd(Index :Integer): Double;
begin
  Result := prModelObject.CondStd[Index];
end;

procedure TQUB_QVO_QVM.prSetStateVrev(Index :Integer; x :Double);
begin
  prModelObject.ClsVrev[Index] := x;
  prMustRedraw := True;
end;

function  TQUB_QVO_QVM.prGetStateVrev(Index :Integer): Double;
begin
  Result := prModelObject.ClsVrev[Index];
end;

procedure TQUB_QVO_QVM.prSetStateNar(Index :Integer; n :Integer);
begin
  prModelObject.Nar[Index] := n;
  prMustRedraw := True;
end;

function  TQUB_QVO_QVM.prGetStateNar(Index :Integer) :Integer;
begin
  Result := prModelObject.Nar[Index];
end;

procedure TQUB_QVO_QVM.prSetStateCff(Index1, Index2 :Integer; c :Double);
begin
  prModelObject.Cff[Index1, Index2] := c;
  prMustRedraw := True;
end;

function  TQUB_QVO_QVM.prGetStateCff(Index1, Index2 :Integer) :Double;
begin
  Result := prModelObject.Cff[Index1, Index2];
end;


procedure TQUB_QVO_QVM.prModelSetHint;
var
  c, s       :Integer;
  t          :String;
  ClsPresent :array of Boolean;
begin
  prHintZone.Color := ColorBack;
  prHintZone.SetBounds(MarginH, MarginV, Width-2*MarginH, QUB_QVO_QVM_HINTZONE_Y);
  
  SetLength( ClsPresent, ModelObject.ClassCount );
  for c := 0 to ModelObject.ClassCount - 1 do begin
    ClsPresent[c] := False;
  end;
  for s := 0 to ModelObject.States.StateCount - 1 do begin
    ClsPresent[ ModelObject.States[s].Cls ] := True;
  end;

  t :=     Format('Channel Count: %d'#13#10,    [ModelObject.ChannelCount]);
  t := t + Format('Constraint Count: %d'#13#10, [ModelObject.Constraints.ConstraintCount]);
  t := t + Format('ExtraKinPar Count: %d'#13#10, [ModelObject.ExtraKineticPars.ExtraKineticParCount]);
  t := t + Format('Constraint AmpVar Count: %d'#13#10, [ModelObject.ConstraintsAmpVar.ConstraintCount]);
  if IeqFv then begin
    t := t + 'Classes: Cls, Cond, Std'#13#10;
    for c := 0 to ModelObject.ClassCount - 1 do begin
      if ClsPresent[c] then begin
        t := t + Format('   %d, %8.4g, %8.4g'#13#10, [c, ModelObject.Cond[c], ModelObject.CondStd[c]]);
      end;
    end;
  end else begin
    t := t + 'Classes: Cls, Amp, Std'#13#10;
    for c := 0 to ModelObject.ClassCount - 1 do begin
      if ClsPresent[c] then begin
        t := t + Format('   %d, %8.4g, %8.4g'#13#10, [c, ModelObject.Amp[c], ModelObject.Std[c]]);
      end;
    end;
  end;
  t := t + 'States: Idx, Cls, Pr'#13#10;
  for s := 0 to ModelObject.States.StateCount - 1 do begin
    t := t + Format('   %d, %d, %8.4g'#13#10, [s + 1, ModelObject.States[s].Cls, ModelObject.States[s].Pr]);
  end;
  prHintZone.Hint := t;
end;

function TQUB_QVO_QVM.prGetExpCond: TQUB_ExpCond_Parameters;
begin
  Result := ModelObject.Parameters;
end;

procedure TQUB_QVO_QVM.prSetExpCond(EC :TQUB_ExpCond_Parameters);
begin
  if LockedAny then Sleep(100);
  if LockedAny then begin
    // Beep;
    Exit;
  end;

  if ModelObject.Parameters <> nil then begin
    ModelObject.Parameters.Events.DelEvent('OnChange', ModelObject.DoOnParametersChanged);
  end;
  ModelObject.Parameters := EC;
  if ModelObject.Parameters <> nil then begin
    ModelObject.Parameters.Events.AddEvent('OnChange', ModelObject.DoOnParametersChanged);
  end;
  ModelObject.UpdateParameters;
end;


//******************************************************************************
procedure TQUB_QVO_QVM.prPropertiesRegistry(Read :Boolean);
begin
end;

procedure TQUB_QVO_QVM.prStatePropertiesRegistry(Read :Boolean);
var
  Reg  :TRegistry;
  i, j :Integer;
  ci   :String;
begin

  Reg := TRegistry.Create;
  try
    with Reg do begin
      if OpenKey('Software\QUB\Visual Model\State', True) then begin
        for i := 0 to QUB_QFS_QMF_DEF_NCLASS - 1 do begin
          ci := IntToStr(i);
          if Read then begin
            StateAmp[i]  := ReadRegistryFloat(Reg, 'Class Amp ' + ci, QUB_QFS_QMF_DEF_AMP[i]);
            StateStd[i]  := ReadRegistryFloat(Reg, 'Class Std ' + ci, QUB_QFS_QMF_DEF_STD[i]);
            StateCond[i] := ReadRegistryFloat(Reg, 'Class Cond ' + ci, QUB_QFS_QMF_DEF_COND[i]);
            StateCondStd[i] := ReadRegistryFloat(Reg, 'Class Cond Std ' + ci, QUB_QFS_QMF_DEF_CONDSTD[i]);
            StateVrev[i] := ReadRegistryFloat(Reg, 'Class Vrev ' + ci, QUB_QFS_QMF_DEF_CLSVREV[i]);
            StateNar[i]  := ReadRegistryInteger(Reg, 'Class Nar ' + ci,QUB_QFS_QMF_DEF_NAR);
            for j := 0 to QUB_QFS_QMF_MAX_COEFF - 1 do begin
              StateCff[i, j] := ReadRegistryFloat(Reg, 'Class Coeff ' + ci + ' ' + IntToStr(j), QUB_QFS_QMF_DEF_CFF);
            end;
          end else begin
            WriteFloat('Class Amp ' + ci, StateAmp[i]);
            WriteFloat('Class Std ' + ci, StateStd[i]);
            WriteFloat('Class Cond ' + ci, StateCond[i]);
            WriteFloat('Class Cond Std ' + ci, StateCondStd[i]);
            WriteFloat('Class Vrev ' + ci, StateVrev[i]);
            WriteInteger('Class Nar ' + ci, StateNar[i]);
            for j := 0 to QUB_QFS_QMF_MAX_COEFF - 1 do begin
              WriteFloat('Class Cff ' + ci + ' ' + IntToStr(j), StateCff[i, j]);
            end;
          end;
        end;
      end;
      CloseKey;

    end;

  finally

    Reg.Free;

  end;
end;

procedure TQUB_QVO_QVM.prRatePropertiesRegistry(Read :Boolean);
var
  Reg :TRegistry;
begin

  Reg := TRegistry.Create;
  try
    with Reg do begin
      if OpenKey('Software\QUB\Visual Model\Rate', True) then begin

        if Read then begin

          prRateK0       := ReadRegistryFloat(Reg, 'Rate K0', QUB_QFS_QMF_DEF_K0);
          prRateK1       := ReadRegistryFloat(Reg, 'Rate K1', QUB_QFS_QMF_DEF_K1);
          prRateP        := ReadRegistryBoolean(Reg, 'Rate P', QUB_QFS_QMF_DEF_P);
          prRateQ        := ReadRegistryBoolean(Reg, 'Rate Q', QUB_QFS_QMF_DEF_Q);
          prRatePName    := ReadRegistryString(Reg, 'Rate PName', QUB_QFS_QMF_DEF_PNAME);
          prRateQName    := ReadRegistryString(Reg, 'Rate QName', QUB_QFS_QMF_DEF_QNAME);
          prRateFormat   := ReadRegistryString(Reg, 'Rate Format', QUB_QFS_QMF_DEF_RATEFORMAT);

        end else begin

          WriteFloat('Rate K0', prRateK0);
          WriteFloat('Rate K1', prRateK1);
          WriteBool('Rate P', prRateP);
          WriteBool('Rate Q', prRateQ);
          WriteString('Rate PName', prRatePName);
          WriteString('Rate QName', prRateQName);
          WriteString('Rate Format', prRateFormat);

        end;

      end;
      CloseKey;
    end;

  finally

    Reg.Free;

  end;
end;

procedure TQUB_QVO_QVM.prSetInitialProperties;
begin
end;

//******************************************************************************
class procedure TQUB_Python_Model.RegisterMethods( PythonType : TPythonType );
begin
  inherited;
  with PythonType do begin
    AddMethod( 'getAsNode',          @TQUB_Python_Model.GetAsNode,           'Model.getAsNode()' );
    AddMethod( 'setAsNode',          @TQUB_Python_Model.SetAsNode,           'Model.setAsNode(qtr.Node)' );
    AddMethod( 'copyImage',          @TQUB_Python_Model.CopyImage,           'Model.copyImage(optionsDict)' );
    AddMethod( 'CalcPeq',            @TQUB_Python_Model.CalcPeq,             'Model.CalcPeq()' );
    AddMethod( 'EnforceConstraints', @TQUB_Python_Model.EnforceConstraints,  'Model.EnforceConstraints()' );
    AddMethod( 'getAMatrix',         @TQUB_Python_Model.GetAMatrix,          'ModelView.getAMatrix( dt_sec )' );
  end;
end;

function TQUB_Python_Model.GetAsNode( args :PPyObject ): PPyObject;
var
  ResultNode               :INode;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if Model = nil then begin
      ResultNode           := TNode.CreateNull;
    end else begin
      PythonThread.SyncGUIProc( prDoGet );
      ResultNode           := prSyncNode;
    end;

    Result                 := PyNode_FromNode(ResultNode);
  end;
end;

function TQUB_Python_Model.SetAsNode( args :PPyObject ): PPyObject;
var
  ModelNode               :PPyObject;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    ModelNode             := nil;
    if PyArg_ParseTuple( args, 'O:Model.SetAsNode(qtr.Node)', [@ModelNode] ) <> 0 then begin
      if PyNode_IsNode( ModelNode ) then begin
        prSyncNode        := PyNode_ToNode( ModelNode );
        PythonThread.SyncGuiProc( prDoSet );
        Result                 := ReturnNone;
      end else begin
        PyErr_SetString( PyExc_TypeError^, PChar('model must be a qtr.Node') );
        Result            := nil;
      end;
    end else begin
      Result := nil;
    end;
  end;
end;

procedure TQUB_Python_Model.prDoGet;
begin
  prSyncNode           := Model.GetAsNode;
end;

procedure TQUB_Python_Model.prDoSet;
begin
  Model.SetAsNode( prSyncNode );
end;

function TQUB_Python_Model.CopyImage( args : PPyObject ) : PPyObject;
begin
  Adjust(@Self);

  prCopyImageConfig    := nil;
  with GetPythonEngine do begin
    if PyArg_ParseTuple( args, '|O:Model.CopyImage( configDict )', [@prCopyImageConfig] ) <> 0 then begin
      if (prCopyImageConfig = nil) or (PyMapping_Check( prCopyImageConfig ) <> 0) then begin
        PythonThread.SyncGUIProc( prCopyImage );
        Result := ReturnNone;
      end else begin
        PyErr_SetString( PyExc_TypeError^, PChar('config must be a dictionary') );
        Result            := nil;
      end;
    end else begin
      Result := nil;
    end;
  end;
end;

procedure TQUB_Python_Model.prCopyImage;
var
  PyVal, PyInt                 :PPyObject;
  SavedProps                   :INode;
  NewProps                     :INode;
begin
  PythonThread.BeginPython;
  try
  if Model <> nil then with GetPythonEngine do begin
    SavedProps    := ProfileMgr['CopyModel'].Active.Clone(True);
    NewProps      := TNode.Create('Properties');

    if prCopyImageConfig <> nil then begin
      if PyMapping_HasKeyString(prCopyImageConfig, 'NamedStates') <> 0 then begin
	//----- Added 02-25-2004 by JB - Named states option 
	PyVal               := PyMapping_GetItemString(prCopyImageConfig, 'NamedStates');
        NewProps['Named States'].SetData(PyObject_IsTrue(PyVal));
	Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prCopyImageConfig, 'DrawFrame') <> 0 then begin
        PyVal               := PyMapping_GetItemString(prCopyImageConfig, 'DrawFrame');
        NewProps['Draw Frame'].SetData(PyObject_IsTrue(PyVal));
        Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prCopyImageConfig, 'ShowTitles') <> 0 then begin
        PyVal               := PyMapping_GetItemString(prCopyImageConfig, 'ShowTitles');
        NewProps['Show Titles'].SetData(PyObject_IsTrue(PyVal));
        Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prCopyImageConfig, 'Landscape') <> 0 then begin
        PyVal               := PyMapping_GetItemString(prCopyImageConfig, 'Landscape');
        NewProps['Orientation'].SetData(PyObject_IsTrue(PyVal));
        Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prCopyImageConfig, 'Bitmap') <> 0 then begin
        PyVal               := PyMapping_GetItemString(prCopyImageConfig, 'Bitmap');
        NewProps['Format'].SetData(PyObject_IsTrue(PyVal));
        Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prCopyImageConfig, 'Width') <> 0 then begin
        PyVal               := PyMapping_GetItemString(prCopyImageConfig, 'Width');
        if PyNumber_Check( PyVal ) <> 0 then begin
          PyInt             := PyNumber_Int( PyVal );
          NewProps['Draw Width'].SetData(PyInt_AsLong(PyInt));
          Py_DECREF( PyInt );
        end;
        Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prCopyImageConfig, 'Height') <> 0 then begin
        PyVal               := PyMapping_GetItemString(prCopyImageConfig, 'Height');
        if PyNumber_Check( PyVal ) <> 0 then begin
          PyInt               := PyNumber_Int( PyVal );
          NewProps['Draw Height'].SetData(PyInt_AsLong(PyInt));
          Py_DECREF( PyInt );
        end;
        Py_DECREF( PyVal );
      end;
    end;

    PythonThread.EndPython;

    ProfileMgr['CopyModel'].SetProperties(NewProps);
    Model.CopyImage(False);
    ProfileMgr['CopyModel'].SetProperties(SavedProps);

    PythonThread.BeginPython;
  end;
  
  finally
    PythonThread.EndPython;
  end;
end;

function TQUB_Python_Model.CalcPeq(args :PPyObject) :PPyObject;
var
  S         :String;
  i         :Integer;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    PythonThread.SyncGuiProc(prCalcPeq);
    S := 'numpy.matrix("';
    for i := 0 to Model.ModelObject.States.StateCount - 1 do begin
      S := S + Format('%f ', [Model.ModelObject.Peq[i]]);
    end;
    S := S + '", dtype="float64")';
    Result := EvalString(S);
  end;
end;

procedure TQUB_Python_Model.prCalcPeq;
begin
  Model.ModelObject.CalculateProbEq(True{assign});
end;

function TQUB_Python_Model.EnforceConstraints( args :PPyObject ): PPyObject;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    PythonThread.SyncGuiProc(prEnforceConstraints);
    Result := ReturnNone;
  end;
end;

procedure TQUB_Python_Model.prEnforceConstraints;
begin
  Model.ModelObject.EnforceConstraints;
end;

function TQUB_Python_Model.GetAMatrix(args :PPyObject): PPyObject; cdecl;
begin
  Adjust(@Self);

  if Model.CurrData <> nil then prArgD := TQUB_QVO_QVD(Model.CurrData).Sampling
                           else prArgD := 1e-3;

  with GetPythonEngine do begin
    if 0 = PyArg_ParseTuple(args, '|d', [@prArgD]) then begin
      Result := nil;
      Exit;
    end;
    PythonThread.SyncGuiProc(prGetAMatrix);
  end;

  if prResult <> nil then begin
    Result := prResult;
  end else begin
    Result := GetPythonEngine.ReturnNone;
  end;
end;

procedure TQUB_Python_Model.prGetAMatrix;
var
  A    :TPMDouble;
  i, j :Integer;
  S    :String;
begin
  PythonThread.BeginPython;
  try
    with GetPythonEngine do begin
      Model.ModelObject.ADt := prArgD;
      Model.ModelObject.CalculateMath(False);
      A        := Model.ModelObject.A;
      S        := 'numpy.matrix("';
      for i := 0 to Model.ModelObject.States.StateCount - 1 do begin
        if i > 0 then S := S + '; ';
        for j := 0 to Model.ModelObject.States.StateCount - 1 do begin
          S    := S + Format('%.16g ', [A[i,j]]);
        end;
      end;
      S        := S + '", dtype="float64")';
      prResult := EvalString(S);

      if Model.CurrData <> nil then Model.ModelObject.ADt := TQUB_QVO_QVD(Model.CurrData).Sampling;
    end;
  finally
    PythonThread.EndPython;
  end;
end;


//******************************************************************************
procedure Register;
begin
  RegisterComponents('QUB', [TQUB_QVO_QVM]);
end;


//******************************************************************************
end.

