{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
// properties for the qub visual model


unit QUB_QVO_QVM_XProperties;


interface


uses


Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ComCtrls, ExtCtrls,

AllocTypes, Alloc,

QUB_Node,
QUB_Parser,
QUB_Global,
QUB_Profiles,
QUB_Properties,
QUB_QVO_XProperties,
QUB_QFS_QMF, QUB_QFS_Channels,
QUB_QVO_QVM_GenConstraint_Properties;



const


QUB_QVO_QVM_DEF_MARGIN                      :Integer                            = 5;
QUB_QVO_QVM_MIN_MARGIN                      :Integer                            = 0;
QUB_QVO_QVM_MAX_MARGIN                      :Integer                            = 50;

QUB_QVO_QVM_DEF_PREFORMAT                   = '';
QUB_QVO_QVM_DEF_EXPFORMAT                   = '';


type


TQUB_QVO_QVM_XPropertiesForm = class(TQUB_QVO_XPropertiesForm)


  pagControl                :TPageControl;
  tabColors                 :TTabSheet;
  tabDisplay                :TTabSheet;

  Label1                    :TLabel;
  Label3                    :TLabel;
  Label5                    :TLabel;
  Label7                    :TLabel;
  Label8                    :TLabel;
  Label9                    :TLabel;
  Label10                   :TLabel;
  Label28                   :TLabel;
  Label30                   :TLabel;
  Label31                   :TLabel;
  Label32                   :TLabel;

  panColor                  :TPanel;
  panColorLine              :TPanel;
  panColorRate              :TPanel;
  panColorSelected          :TPanel;
  panColorFrame             :TPanel;
  panColorBack              :TPanel;

  txtStateSize              :TEdit;
  txtLineWidth              :TEdit;
  udStateSize               :TUpDown;
  udLineWidth               :TUpDown;
  chkAlignToGrid            :TCheckBox;
  chkUseGlobalCond          :TCheckBox;
  chkScrollRates            :TCheckBox;
  chkDiagonalRates          :TCheckBox;
  chkShowK1                 :TCheckBox;
  txtMarginH                :TEdit;
  txtMarginV                :TEdit;

  tabModel                  :TTabSheet;
  Label11                   :TLabel;
  txtModelChannelCount      :TEdit;
  udModelChannelCount       :TUpDown;

  tabConstraints            :TTabSheet;
  lstConstraints            :TListBox;
  Label12                   :TLabel;
  lstConstraintTypes        :TListBox;
  txtConstraint             :TEdit;
  btnAddConstraint          :TButton;
  btnDelConstraint          :TButton;
  tabExtraKineticParameters :TTabSheet;
  tabAmpConstraints         :TTabSheet;
  Label13                   :TLabel;
  lstConstraintsAmp         :TListBox;
  lstConstraintAmpTypes     :TListBox;
  txtConstraintAmp          :TEdit;
  btnAddConstraintAmp       :TButton;
  btnDelConstraintAmp       :TButton;
  chkConstraintValue        :TCheckBox;
  txtConstraintValue        :TEdit;
  btnFixAllRates            :TButton;
  Label14                   :TLabel;
  btnClearConstraint        :TButton;
  Label15                   :TLabel;
  txtVrev                   :TEdit;
  Label16                   :TLabel;

  tabRates                  :TTabSheet;
  Label17                   :TLabel;
  Label18                   :TLabel;
  Label19                   :TLabel;
  txtK1                     :TEdit;
  txtK0                     :TEdit;
  chkP                      :TCheckBox;
  chkQ                      :TCheckBox;
  txtPName                  :TEdit;
  txtQName                  :TEdit;
  picModel                  :TImage;
  chkEnforceConstraints     :TCheckBox;
  btnBalanceAllLoops        :TButton;
  btnRateSetAsDefault       :TButton;
  btnDelDependent           :TButton;
  btnUpdateConstraint       :TButton;
    Label2: TLabel;
    lstExtraKineticPars: TListBox;
    txtExtraKineticParValue: TEdit;
    btnAddExtraKineticPar: TButton;
    btnUpdateExtraKineticPar: TButton;
    btnDelExtraKineticPar: TButton;
    lblExtraKineticParValue: TLabel;
    lblExtraKineticParName: TLabel;
    txtExtraKineticParName: TEdit;
    Label4: TLabel;
    Label6: TLabel;
    txtPreFormat: TEdit;
    txtExpFormat: TEdit;
    Label20: TLabel;
    txtRateFormat: TEdit;


  procedure FormCreate(Sender: TObject);
  procedure FormDestroy(Sender: TObject);
  procedure FormShow(Sender: TObject);

  procedure txtModelChannelCountKeyPress(Sender: TObject; var Key: Char);
  procedure txtModelChannelCountExit(Sender: TObject);
  procedure udModelChannelCountClick(Sender: TObject; Button: TUDBtnType);
  procedure udModelChannelCountChanging(Sender: TObject; var AllowChange: Boolean);
  procedure btnAddConstraintClick(Sender: TObject);
  procedure btnUpdateConstraintClick(Sender: TObject);
  procedure btnDelConstraintClick(Sender: TObject);
  procedure txtConstraintKeyPress(Sender: TObject; var Key: Char);
  procedure lstConstraintTypesClick(Sender: TObject);
  procedure lstConstraintAmpTypesClick(Sender: TObject);
  procedure txtConstraintAmpKeyPress(Sender: TObject; var Key: Char);
  procedure btnAddConstraintAmpClick(Sender: TObject);
  procedure btnDelConstraintAmpClick(Sender: TObject);
  procedure btnFixAllRatesClick(Sender: TObject);
  procedure btnClearConstraintClick(Sender: TObject);
  procedure txtVrevKeyPress(Sender: TObject; var Key: Char);
  procedure txtVrevExit(Sender: TObject);
  procedure picModelMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure btnApplyClick(Sender: TObject);
  procedure btnResetClick(Sender: TObject);
  procedure btnCancelClick(Sender: TObject);
  procedure txtK0KeyPress(Sender: TObject; var Key: Char);
  procedure txtK0Exit(Sender: TObject);
  procedure txtK1KeyPress(Sender: TObject; var Key: Char);
  procedure txtK1Exit(Sender: TObject);
  procedure chkPClick(Sender: TObject);
  procedure chkQClick(Sender: TObject);
  procedure txtPNameKeyPress(Sender: TObject; var Key: Char);
  procedure txtPNameExit(Sender: TObject);
  procedure txtQNameKeyPress(Sender: TObject; var Key: Char);
  procedure txtQNameExit(Sender: TObject);
  procedure tabRatesShow(Sender: TObject);
  procedure btnBalanceAllLoopsClick(Sender: TObject);
  procedure btnRateSetAsDefaultClick(Sender: TObject);
  procedure pagControlChange(Sender: TObject);
  procedure btnDelDependentClick(Sender: TObject);
  procedure tabRatesResize(Sender :TObject);
  procedure lstConstraintsClick(Sender: TObject);
  procedure btnAddExtraKineticParClick(Sender: TObject);
  procedure btnUpdateExtraKineticParClick(Sender: TObject);
  procedure btnDelExtraKineticParClick(Sender: TObject);
  procedure lstExtraKineticParsClick(Sender: TObject);
    procedure txtRateFormatKeyPress(Sender: TObject; var Key: Char);
    procedure txtRateFormatExit(Sender: TObject);


protected


  prError                                 :Boolean;

  prModel                                 :TQUB_QFS_QMF;
  prModelChannelCount                     :Integer;
  prModelChannelCountChanging             :Boolean;
  prModelModified                         :Boolean;

  //Kinetic constraints
  prConstraints                           :TQUB_QFS_Constraints;
  prConstraintType                        :TQUB_QFS_QMF_ConstraintType;

  //Extra kinetic parameters
  prExtraKineticPars                      :TQUB_QFS_ExtraKineticPars;

  //Current constraints
  prConstraintsAmpVar                     :TQUB_QFS_ConstraintsAmpVar;
  prConstraintAmpVarType                  :TQUB_QFS_QMF_ConstraintAmpVarType;

  prVrev                                  :Double;

  prStatePosCount                         :Integer;
  prStatePos                              :TPAPoint;
  prRatePos                               :TRatePanelPosList;

  prBackupRates                           :TQUB_QFS_Rates;

  prK0                                    :Double;
  prK1                                    :Double;
  prP                                     :Boolean;
  prQ                                     :Boolean;
  prPName                                 :String;
  prQName                                 :String;
  prRateFormat                            :String;
  prEnforceConstraints                    :Boolean;

  prGenConstraintPropertiesForm           :TQUB_QVO_QVM_GenConstraint_PropertiesForm;


  procedure prSetModelChannelCount(c :Integer);

  procedure prSetVrev(V :Double);


  //Kinetic Constraints
  procedure prSetConstraintType(t :TQUB_QFS_QMF_ConstraintType);
  procedure prShowConstraints;
  function prConstraintToText(c :TQUB_QFS_Constraint) :String;
  procedure prAddConstraintList(c :TQUB_QFS_Constraint);
  function prAddConstraint :Boolean;
  function prAddGenConstraint :Boolean;
  function prAddGeneralizedConstraint :Boolean;
  function prUpdateConstraint :Boolean;
  function prUpdateGenConstraint :Boolean;
  function prUpdateGeneralizedConstraint :Boolean;
  procedure prDelConstraint;
  procedure prFixAllRates;
  function prGetConstrainedModelNode: INode;
  procedure prBalanceAllLoops;
  function prPareConstraints: Word; // mrYes, mrNo, mrCancel
  procedure prShowConstraint;

  //Extra Kinetic Parameters
  procedure prShowExtraKineticPars;
  function prAddExtraKineticPar :Boolean;
  procedure prAddExtraKineticParList(p :TQUB_QFS_ExtraKineticPar);
  function prUpdateExtraKineticPar :Boolean;
  procedure prDelExtraKineticPar;
  procedure prShowExtraKineticPar;

  //Current
  procedure prSetConstraintAmpVarType(t :TQUB_QFS_QMF_ConstraintAmpVarType);
  procedure prShowConstraintsAmpVar;
  procedure prAddConstraintAmpVarList(c :TQUB_QFS_ConstraintAmpVar);
  function prAddConstraintAmpVar :Boolean;
  procedure prDelConstraintAmpVar;

  //Select editable rate
  procedure prSetRateIndexHalfIndex(RIdx, HIdx, K01 :Integer);
  procedure prSetRate(K0, K1 :Double; P, Q :Boolean; const PName, QName, RateFormat :String);
  procedure prDrawModel;

  function prGetK0 :Double;
  procedure prSetK0(k0 :Double);
  function prGetK1 :Double;
  procedure prSetK1(k1 :Double);

  function prGetP :Boolean;
  procedure prSetP(p :Boolean);
  function prGetQ :Boolean;
  procedure prSetQ(q :Boolean);

  function prGetPName :String;
  procedure prSetPName(p :String);
  function prGetQName :String;
  procedure prSetQName(q :String);
  function prGetRateFormat: String;
  procedure prSetRateFormat(x :String);


  function StatePos: TPAPoint;
  // reallocates to correct number of states if necessary before giving you prStatePos
  // (always use this instead, at least the first mention in a function)


  function prReadyToClose: Boolean; override;


public

  OnRateSetAsDefault                      :TNotifyEvent;


  property K0                             :Double                            read prGetK0                 write prSetK0;
  property K1                             :Double                            read prGetK1                 write prSetK1;
  property P                              :Boolean                           read prGetP                  write prSetP;
  property Q                              :Boolean                           read prGetQ                  write prSetQ;
  property PName                          :String                            read prGetPName              write prSetPName;
  property QName                          :String                            read prGetQName              write prSetQName;
  property RateFormat                     :String                            read prGetRateFormat         write prSetRateFormat;

  property Model                          :TQUB_QFS_QMF                      read prModel                 write prModel;
  property ModelChannelCount              :Integer                           read prModelChannelCount     write prSetModelChannelCount;

  property Vrev                           :Double                            read prVrev                  write prSetVrev;

  property Constraints                    :TQUB_QFS_Constraints              read prConstraints;
  property ConstraintType                 :TQUB_QFS_QMF_ConstraintType       read prConstraintType        write prSetConstraintType;
  property ExtraKineticPars               :TQUB_QFS_ExtraKineticPars         read prExtraKineticPars;
  property ConstraintsAmpVar              :TQUB_QFS_ConstraintsAmpVar        read prConstraintsAmpVar;
  property ConstraintAmpVarType           :TQUB_QFS_QMF_ConstraintAmpVarType read prConstraintAmpVarType  write prSetConstraintAmpVarType;


end;


implementation


uses


Math,

QUB_Node_Model,
qubopt_iface,

QUB_GUIInterface;


{$R *.DFM}


//******************************************************************************
//K0
function TQUB_QVO_QVM_XPropertiesForm.prGetK0 :Double;
begin
  Result := prModel.Rates[prModel.Rates.CurrRateIdx].K0[prModel.Rates.CurrHalfIdx];
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prSetK0(k0 :Double);
var
  s1, s2  :Integer;
begin
  txtK0.Text := Format('%.6g', [k0]);
  if 0<>Properties['EnforceConstraints'].Data[0] then begin
    prModel.Rates.GetStatesOfRate(prModel.Rates.CurrRateIdx, prModel.Rates.CurrHalfIdx, s1, s2);
    prModel.ConstrainedSetRate(s1, s2, True{is K0}, k0);
  end else begin
    prModel.Rates[prModel.Rates.CurrRateIdx].K0[prModel.Rates.CurrHalfIdx] := k0;
  end;
  prPropertyChanged := True;
end;

//K1
function TQUB_QVO_QVM_XPropertiesForm.prGetK1 :Double;
begin
  Result := prModel.Rates[prModel.Rates.CurrRateIdx].K1[prModel.Rates.CurrHalfIdx];
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prSetK1(k1 :Double);
var
  s1, s2  :Integer;
begin
  txtK1.Text := Format('%.6g', [k1]);
  if 0<>Properties['EnforceConstraints'].Data[0] then begin
    prModel.Rates.GetStatesOfRate(prModel.Rates.CurrRateIdx, prModel.Rates.CurrHalfIdx, s1, s2);
    prModel.ConstrainedSetRate(s1, s2, False{is not K0}, k1);
  end else begin
    prModel.Rates[prModel.Rates.CurrRateIdx].K1[prModel.Rates.CurrHalfIdx] := k1;
  end;
  prPropertyChanged := True;
end;

//P
function TQUB_QVO_QVM_XPropertiesForm.prGetP :Boolean;
begin
  Result := prModel.Rates[prModel.Rates.CurrRateIdx].P[prModel.Rates.CurrHalfIdx];
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prSetP(p :Boolean);
begin
  chkP.Checked := p;
  prModel.Rates[prModel.Rates.CurrRateIdx].P[prModel.Rates.CurrHalfIdx] := p;
  prPropertyChanged := True;
end;

//Q
function TQUB_QVO_QVM_XPropertiesForm.prGetQ :Boolean;
begin
  Result := prModel.Rates[prModel.Rates.CurrRateIdx].Q[prModel.Rates.CurrHalfIdx];
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prSetQ(q :Boolean);
var
  Rate      :TQUB_QFS_Rate;
begin
  chkQ.Checked := q;
  Rate := prModel.Rates[prModel.Rates.CurrRateIdx];
  Rate.Q[prModel.Rates.CurrHalfIdx] := q;
  prPropertyChanged := True;

  if q and (0 = Rate.K1[prModel.Rates.CurrHalfIdx]) then begin
    Rate.K1[prModel.Rates.CurrHalfIdx] := 1.0e-3;
  end else if (not q) and (0 <> Rate.K1[prModel.Rates.CurrHalfIdx]) then begin
    Rate.K1[prModel.Rates.CurrHalfIdx] := 0.0;
  end;
end;

//PName
function TQUB_QVO_QVM_XPropertiesForm.prGetPName :String;
begin
  Result := prModel.Rates[prModel.Rates.CurrRateIdx].PName[prModel.Rates.CurrHalfIdx];
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prSetPName(p :String);
begin
  txtPName.Text := Trim(p);
  prModel.Rates[prModel.Rates.CurrRateIdx].PName[prModel.Rates.CurrHalfIdx] := p;
  prPropertyChanged := True;
end;

//QName
function TQUB_QVO_QVM_XPropertiesForm.prGetQName :String;
begin
  Result := prModel.Rates[prModel.Rates.CurrRateIdx].QName[prModel.Rates.CurrHalfIdx];
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prSetQName(q :String);
begin
  txtQName.Text := Trim(q);
  prModel.Rates[prModel.Rates.CurrRateIdx].QName[prModel.Rates.CurrHalfIdx] := q;
  prPropertyChanged := True;
end;

function TQUB_QVO_QVM_XPropertiesForm.prGetRateFormat: String;
begin
  Result := prModel.Rates[prModel.Rates.CurrRateIdx].RateFormat[prModel.Rates.CurrHalfIdx];
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prSetRateFormat(x :String);
begin
  txtRateFormat.Text := x;
  prModel.Rates[prModel.Rates.CurrRateIdx].RateFormat[prModel.Rates.CurrHalfIdx] := x;
  prPropertyChanged := True;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prSetModelChannelCount(c :Integer);
begin
  prModelChannelCount := c;
  txtModelChannelCount.Text := IntToStr(prModelChannelCount);
  prPropertyChanged := True;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prSetVrev(V :Double);
begin
  prVrev := V;
  txtVrev.Text := FloatToStr(prVrev);
  prPropertyChanged := True;
end;

//Kinetic Constraints
procedure TQUB_QVO_QVM_XPropertiesForm.prSetConstraintType(t :TQUB_QFS_QMF_ConstraintType);
begin
  prConstraintType := t;
  lstConstraintTypes.ItemIndex := Integer(ConstraintType);
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prShowConstraints;
var
  i :Integer;
begin
  lstConstraints.Clear;
  for i := 0 to prConstraints.ConstraintCount - 1 do begin
    prAddConstraintList(prConstraints[i]);
  end;
  btnDelConstraint.Enabled := prConstraints.ConstraintCount > 0;
end;

function TQUB_QVO_QVM_XPropertiesForm.prConstraintToText(c :TQUB_QFS_Constraint) :String;
var
  t :String;
  n :String;
  i :Integer;
begin

  n := c.Name;

  if          n = CHANNELS_CONSTRAINT_FIX_RATE_NAME then begin

    t := Format('Fix rate:      %d->%d', [c.Index[0] + 1, c.Index[1] + 1]);

  end else if n = CHANNELS_CONSTRAINT_SCALE_RATE_NAME then begin

    t := Format('Scale rate:  %d->%d vs %d->%d', [c.Index[0] + 1, c.Index[1] + 1, c.Index[2] + 1, c.Index[3] + 1]);

  end else if n = CHANNELS_CONSTRAINT_FIX_EXP_NAME then begin

    t := Format('Fix exp:       %d->%d', [c.Index[0] + 1, c.Index[1] + 1]);

  end else if n = CHANNELS_CONSTRAINT_SCALE_EXP_NAME then begin

    t := Format('Scale exp:  %d->%d vs %d->%d', [c.Index[0] + 1, c.Index[1] + 1, c.Index[2] + 1, c.Index[3] + 1]);

  end else if n = CHANNELS_CONSTRAINT_LOOP_BAL_NAME then begin

    t := 'Loop:          ';
    for i := 0 to c.IndexCount - 1 do begin
      t := t + IntToStr(c.Index[i] + 1);
      if i <> c.IndexCount - 1 then begin
        t := t + '->';
      end;
    end;

  end else if n = CHANNELS_CONSTRAINT_LOOP_IMBAL_NAME then begin

    t := 'Loop imbal:     ';
    for i := 0 to c.IndexCount - 1 do begin
      t := t + IntToStr(c.Index[i] + 1);
      if i <> c.IndexCount - 1 then begin
        t := t + '->';
      end;
    end;

  end else if n = CHANNELS_CONSTRAINT_LOOP_BAL_EXP_NAME then begin
  //Hidden constraint

    //Testing
    t := 'Loop exp:      ';
    for i := 0 to c.IndexCount - 1 do begin
      t := t + IntToStr(c.Index[i] + 1);
      if i <> c.IndexCount - 1 then begin
        t := t + '->';
      end;
    end;

  end else if n = CHANNELS_CONSTRAINT_LOOP_IMBAL_EXP_NAME then begin
  //Hidden constraint

    //Testing
    t := 'Loop imbal exp:     ';
    for i := 0 to c.IndexCount - 1 do begin
      t := t + IntToStr(c.Index[i] + 1);
      if i <> c.IndexCount - 1 then begin
        t := t + '->';
      end;
    end;

  end else if n = CHANNELS_CONSTRAINT_GEN_NAME then begin
  //Generalized constraint

    t := 'Generalized';

  end;

  if c.HasValue then begin
    t := t + ' (' + FloatToStr(c.Value) + ')';
  end;

  Result := t;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prAddConstraintList(c :TQUB_QFS_Constraint);
begin
  lstConstraints.Items.Add(Format('(%d) %s', [lstConstraints.Items.Count + 1, prConstraintToText(c)]));
  lstConstraints.ItemIndex := lstConstraints.Items.Count - 1;
end;

//----- Modified by JB 7-24-2004 : Increased size of edit areas, added more
// error message details for specified states; was not displaying constraint
// value on loaded models; Combined code where checking rate and exp similarly;
// Display error when click on add with no states filled in.
function TQUB_QVO_QVM_XPropertiesForm.prAddConstraint :Boolean;
var
  Constraint :TQUB_QFS_Constraint;
  aStates    :TIntegerArray;
  Parser     :TQUB_Parser;
  Text       :String;
  HasValue   :Boolean;
  Value      :Double;
  i          :Integer;
  cErrorMessage : String;
begin

  Result     := False;
  cErrorMessage := 'Invalid format or state index';

  //----- Process the Value selection
  Text       := Trim(txtConstraint.Text);
  if Text = '' then Exit;

  HasValue   := chkConstraintValue.Checked;
  try
    Value    := StrToFloat(txtConstraintValue.Text);
  except
    Value := 0;
  end;

  //TO DO: Lorin. No longer reset
  //----- Reset the constraint value section
  //chkConstraintValue.Checked := False;
  //txtConstraintValue.Text := '1';

  //----- Parse the state list to StringList aStates
  aStates := TIntegerArray.Create();
  Parser  := TQUB_Parser.Create;


  try

    Parser.Start;

    repeat

      Parser.Next(Text);
      if Parser.Token.TokenType = TOKEN_NUMBER then begin
        aStates.Add( StrToInt(Parser.Token.Token));
      end else if Parser.Token.TokenType <> TOKEN_NULL then begin
        Result := True;
        txtConstraint.SelStart  := Parser.Token.TokenPos - 1;
        txtConstraint.SelLength := Parser.Token.TokenLen;
        Exit;
      end;

    until(Parser.Token.TokenType = TOKEN_NULL);

    //----- Validate correct number of states specified for constraint type
    try
      if aStates.Count() = 0 then begin
        //-- No entries in the list
        Result := True;
        cErrorMessage := 'You must specify the states to constrain in the states box.';

      end else if (prConstraintType = CSTR_FIX_RATE) or (prConstraintType = CSTR_FIX_EXP) then begin
        //-- FIX_RATE or
        //-- FIX_EXP
        if aStates.Count() <> 2 then begin
          Result := True;
          if prConstraintType = CSTR_FIX_RATE Then
            cErrorMessage := 'You must specify 2 states.  Example, specify [1 2   ] for constraint [Fix rates 1 -> 2 ]'
          else
            cErrorMessage := 'You must specify 2 states.  Example, specify [1 2   ] for constraint [Fix exp 1 -> 2 ]';
        end else if not Model.Connected(Model.States[aStates.Get(0) - 1], Model.States[aStates.Get(1)-1]) then begin
          Result := True;
          cErrorMessage := 'You have specified 2 unconnected states';
        end;

      end else if (prConstraintType = CSTR_SCALE_RATE) or (prConstraintType = CSTR_SCALE_EXP) then begin
        //-- SCALE_RATE or
        //-- SCALE_EXP
        if aStates.Count() <> 4 then begin
          Result := True;
          if prConstraintType = CSTR_SCALE_RATE Then
            cErrorMessage := 'You must specify 4 states.  Example, specify [1 2 3 4  ] for constraint [Scale rates 1->2 vs 3->4 ]'
          else
            cErrorMessage := 'You must specify 4 states.  Example, specify [1 2 3 4  ] for constraint [Scale exp 1->2 vs 3->4 ]';
        end else if (not Model.Connected(Model.States[aStates.Get(0)-1], Model.States[aStates.Get(1)-1])) then begin
          Result := True;
          cErrorMessage := 'Your first 2 specified states are not connected.';
        end else if (not Model.Connected(Model.States[aStates.Get(2)-1], Model.States[aStates.Get(3)-1])) then begin
          Result := True;
          cErrorMessage := 'Your last 2 specified states are not connected.';
        end;

      end else if (prConstraintType = CSTR_LOOP_BALANCE) or (prConstraintType = CSTR_LOOP_IMBALANCE) {testing}or (prConstraintType = CSTR_LOOP_BALANCE_EXP) or (prConstraintType = CSTR_LOOP_IMBALANCE_EXP){/testing} then begin
        //-- LOOP_(IM)BALANCE or
        //-- LOOP_(IM)BALANCE_EXP - testing - it seems that sometimes LOOP_BALANCE together with LOOP_BALANCE_EXP crash, so I will try to make them explicit. LM
        if aStates.Count() < 3 then begin
          Result := True;
          cErrorMessage := 'You must specify at least 3 states and the states must form a loop.';
        end else begin
          for i := 0 to aStates.Count() - 2 do begin
            if not Model.Connected(Model.States[aStates.Get(i)-1], Model.States[aStates.Get(i+1)-1]) then begin
              cErrorMessage := Format('The states [%d] and [%d] are not connected.', [ aStates.Get(i), aStates.Get(i+1) ]);
              Result := True;
              Break;
            end;
          end;
          if not Model.Connected(Model.States[aStates.Get(0)-1], Model.States[aStates.GetLast() - 1]) then begin
          Result := True;
            cErrorMessage := Format('The last state [%d] does not loop to the first state [%d].', [aStates.GetLast(), aStates.Get(0)]);
        end;
        end;

      //testing
      //end else if prConstraintType = CSTR_LOOP_BALANCE_EXP then begin
      //Hidden constraint, only created silently by Q_Model to accompany CSTR_LOOP_(IM)BALANCE

      end;

    except
      //----- Generic error message if any exeption occurs
      Result := True;
      cErrorMessage := 'There is an error in the states list, possibly an out of range state number.';
    end;


  finally


    if not Result then begin

      //-- Build a new constraint and add it to the list.
      Constraint := TQUB_QFS_Constraint.Create(CHANNELS_CONSTRAINT_TYPE_NAME[prConstraintType], nil);
      Constraint.HasValue := HasValue;
      Constraint.Value    := Value;
      prConstraints.AddConstraint(Constraint, prConstraints.ConstraintCount);
      for i := 0 to aStates.Count - 1 do begin
        Constraint.Index[i] := aStates.Get(i)-1;
      end;

      prAddConstraintList(Constraint);

    end else begin

      MessageHelpDlg( cErrorMessage, mtError, [mbOK], 0, 'Error:Kinetic_Constraints');

    end;

    aStates.Free;
    Parser.Free;

  end;

  if not Result then begin
    txtConstraint.Text := '';
    prPropertyChanged := True;
  end;

  btnDelConstraint.Enabled := prConstraints.ConstraintCount > 0;

end;

function TQUB_QVO_QVM_XPropertiesForm.prAddGenConstraint :Boolean;
begin
  Result := False;
  if prGenConstraintPropertiesForm = nil then begin
    prGenConstraintPropertiesForm := TQUB_QVO_QVM_GenConstraint_PropertiesForm.Create(Self);
  end;
  prGenConstraintPropertiesForm.Model := prModel;
  prGenConstraintPropertiesForm.Constraint := nil;
  prGenConstraintPropertiesForm.ShowModal;
  if prGenConstraintPropertiesForm.ModalResult <> mrOK then begin
    Result := True;
    Exit;
  end;
  prAddGeneralizedConstraint;
end;

function TQUB_QVO_QVM_XPropertiesForm.prAddGeneralizedConstraint :Boolean;
var
  Constraint :TQUB_QFS_Constraint;
  Value      :Double;
  i          :Integer;
begin

  Result     := False;

  try
    with prGenConstraintPropertiesForm.grdConstraint, prModel do begin
      Value  := StrToFloat(Cells[Rates.RateCount*4 + ExtraKineticPars.ExtraKineticParCount + 1, 1]);
    end;
  except
    Value    := 0;
  end;

  //-- Build a new constraint and add it to the list.
  Constraint := TQUB_QFS_Constraint.Create(CHANNELS_CONSTRAINT_GEN_NAME, nil);
  Constraint.HasValue := True;
  Constraint.Value    := Value;
  prConstraints.AddConstraint(Constraint, prConstraints.ConstraintCount);
  with prGenConstraintPropertiesForm.grdConstraint, prModel do begin
    for i := 0 to Rates.RateCount*4 + ExtraKineticPars.ExtraKineticParCount - 1 do begin
      try
        if Trim(Cells[i + 1, 1]) <> '' then begin
          Constraint.Coeff[i] := StrToFloat(Cells[i + 1, 1]);
        end else begin
          Constraint.Coeff[i] := 0;
        end;
      except
        Constraint.Coeff[i] := 0;
      end;
    end;
  end;

  prAddConstraintList(Constraint);

  prPropertyChanged := True;

  btnDelConstraint.Enabled := prConstraints.ConstraintCount > 0;
end;

function TQUB_QVO_QVM_XPropertiesForm.prUpdateConstraint :Boolean;
var
  Constraint :TQUB_QFS_Constraint;
  aStates    :TIntegerArray;
  Parser     :TQUB_Parser;
  Text       :String;
  HasValue   :Boolean;
  Value      :Double;
  Idx        :Integer;
  i          :Integer;
  cErrorMessage : String;
begin

  Result     := False;
  cErrorMessage := 'Invalid format or state index';

  Idx := lstConstraints.ItemIndex;
  if Idx < 0 then Exit;

  Constraint := prConstraints.Constraint[Idx];

  //----- Process the Value selection
  Text       := Trim(txtConstraint.Text);
  if Text = '' then Exit;

  HasValue   := chkConstraintValue.Checked;
  try
    Value    := StrToFloat(txtConstraintValue.Text);
  except
    Value := 0;
  end;

  //TO DO: Lorin. No longer reset
  //----- Reset the constraint value section
  //chkConstraintValue.Checked := False;
  //txtConstraintValue.Text := '1';

  //----- Parse the state list to StringList aStates
  aStates := TIntegerArray.Create();
  Parser     := TQUB_Parser.Create;


  try

    Parser.Start;

    repeat

      Parser.Next(Text);
      if Parser.Token.TokenType = TOKEN_NUMBER then begin
        aStates.Add( StrToInt(Parser.Token.Token));
      end else if Parser.Token.TokenType <> TOKEN_NULL then begin
        Result := True;
        txtConstraint.SelStart  := Parser.Token.TokenPos - 1;
        txtConstraint.SelLength := Parser.Token.TokenLen;
        Exit;
      end;

    until(Parser.Token.TokenType = TOKEN_NULL);

    //----- Validate correct number of states specified for constraint type
    try
      if aStates.Count <> Constraint.IndexCount then begin
        //-- Not the same State.Count
        Result := True;
        cErrorMessage := 'You must specify the same number of states, else delete this constraint and add a new one.';

      end else if (prConstraintType <> Constraint.cType) then begin
        //-- Not the same Constraint type
        Result := True;
        cErrorMessage := 'You cannot change the type';

      end;

    except
      //----- Generic error message if any exeption occurs
      Result := True;
      cErrorMessage := 'There is an error in the states list, possibly an out of range state number.';
    end;


  finally


    if not Result then begin

      Constraint.HasValue := HasValue;
      Constraint.Value    := Value;
      for i := 0 to aStates.Count - 1 do begin
        Constraint.Index[i] := aStates.Get(i)-1;
      end;

      lstConstraints.Items.Strings[Idx] := prConstraintToText(Constraint);


    end else begin

      MessageDlg(cErrorMessage, mtError, [mbOK], 0);

    end;

    aStates.Free;
    Parser.Free;

  end;

  if not Result then begin
    txtConstraint.Text := '';
    prPropertyChanged := True;
  end;

  btnDelConstraint.Enabled := prConstraints.ConstraintCount > 0;

end;

function TQUB_QVO_QVM_XPropertiesForm.prUpdateGenConstraint :Boolean;
var
  Idx :Integer;
begin
  Result := False;

  Idx := lstConstraints.ItemIndex;
  if Idx < 0 then Exit;

  if prGenConstraintPropertiesForm = nil then begin
    prGenConstraintPropertiesForm := TQUB_QVO_QVM_GenConstraint_PropertiesForm.Create(Self);
  end;
  prGenConstraintPropertiesForm.Model := prModel;
  prGenConstraintPropertiesForm.Constraint := prConstraints[lstConstraints.ItemIndex];
  prGenConstraintPropertiesForm.ShowModal;
  if prGenConstraintPropertiesForm.ModalResult <> mrOK then begin
    Result := True;
    Exit;
  end;
  prUpdateGeneralizedConstraint;
end;

function TQUB_QVO_QVM_XPropertiesForm.prUpdateGeneralizedConstraint :Boolean;
var
  Constraint :TQUB_QFS_Constraint;
  Value      :Double;
  Idx        :Integer;
  i          :Integer;
begin

  Result     := False;

  Idx := lstConstraints.ItemIndex;
  if Idx < 0 then Exit;

  try
    with prGenConstraintPropertiesForm.grdConstraint, prModel do begin
      Value  := StrToFloat(Cells[Rates.RateCount*4 + ExtraKineticPars.ExtraKineticParCount + 1, 1]);
    end;
  except
    Value    := 0;
  end;

  //Select the constraint
  Constraint := prConstraints[Idx];
  Constraint.HasValue := True;
  Constraint.Value    := Value;
  with prGenConstraintPropertiesForm.grdConstraint, prModel do begin
    for i := 0 to Rates.RateCount*4 + ExtraKineticPars.ExtraKineticParCount - 1 do begin
      try
        if Trim(Cells[i + 1, 1]) <> '' then begin
          Constraint.Coeff[i] := StrToFloat(Cells[i + 1, 1]);
        end else begin
          Constraint.Coeff[i] := 0;
        end;
      except
        Constraint.Coeff[i] := 0;
      end;
    end;
  end;

  //lstConstraints.Items.Strings[Idx] := prConstraintToText(Constraint);
  prShowConstraint;

  prPropertyChanged := True;

  btnDelConstraint.Enabled := prConstraints.ConstraintCount > 0;
end;

//----- Delete a constraint.  Modified 7/24/2004 by JB : pseudo edit via load of
// edit controls from constraint being deleted.
procedure TQUB_QVO_QVM_XPropertiesForm.prDelConstraint;
var
  i :Integer;
begin
  //-- Ensure there is a constraint to delete
  i := lstConstraints.ItemIndex;
  if i < 0 then Exit;

  prShowConstraint;

  //-- Remove the constraint
  prConstraints.DelConstraint(i);
  lstConstraints.Items.Delete(i);
  if i > (prConstraints.ConstraintCount - 1) then begin
    i := (prConstraints.ConstraintCount - 1);
  end;
  lstConstraints.ItemIndex := i;
  btnDelConstraint.Enabled := prConstraints.ConstraintCount > 0;
  prPropertyChanged := True;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prShowConstraint;
var
  Constraint :TQUB_QFS_Constraint;
  txt        :String;
  n          :String;
  i, j       :Integer;
begin
  //-- Ensure there is a constraint to delete
  i := lstConstraints.ItemIndex;
  if i < 0 then Exit;

  //-- Load deleted constraint values to edit fields for easy edit.
  Constraint := prConstraints[i];
  chkConstraintValue.Checked := Constraint.HasValue;
  txtConstraintValue.Text := FloatToStr(Constraint.Value);
  n := Constraint.Name;
  // TODO - make state index lookup a method of the constraint class.
  if n=CHANNELS_CONSTRAINT_FIX_RATE_NAME then
    lstConstraintTypes.ItemIndex := 0
  else if n=CHANNELS_CONSTRAINT_SCALE_RATE_NAME then
    lstConstraintTypes.ItemIndex := 1
  else if n=CHANNELS_CONSTRAINT_FIX_EXP_NAME then
    lstConstraintTypes.ItemIndex := 2
  else if n=CHANNELS_CONSTRAINT_SCALE_EXP_NAME then
    lstConstraintTypes.ItemIndex := 3
  else if n=CHANNELS_CONSTRAINT_LOOP_BAL_NAME then
    lstConstraintTypes.ItemIndex := 4
  else if n=CHANNELS_CONSTRAINT_LOOP_IMBAL_NAME then
    lstConstraintTypes.ItemIndex := 5;

  // TODO - make states string construction a method of the constraint class.
  txt := '';
  if (n=CHANNELS_CONSTRAINT_FIX_RATE_NAME) or(n=CHANNELS_CONSTRAINT_FIX_EXP_NAME) then begin
    txt := Format('%d %d', [Constraint.Index[0] + 1, Constraint.Index[1] + 1])
  end else if (n=CHANNELS_CONSTRAINT_SCALE_RATE_NAME) or (n=CHANNELS_CONSTRAINT_SCALE_EXP_NAME) then begin
    txt := Format('%d %d %d %d', [Constraint.Index[0] + 1, Constraint.Index[1] + 1, Constraint.Index[2] + 1, Constraint.Index[3] + 1])
  end else if (n=CHANNELS_CONSTRAINT_LOOP_BAL_NAME) or (n=CHANNELS_CONSTRAINT_LOOP_IMBAL_NAME) then begin
    for j := 0 to Constraint.IndexCount - 1 do begin
      txt := txt + IntToStr(Constraint.Index[j] + 1) + ' ';
    end;
  end;
  txtConstraint.Text := txt;

end;

procedure TQUB_QVO_QVM_XPropertiesForm.prFixAllRates;
var
  i, j       :Integer;
  Constraint :TQUB_QFS_Constraint;
begin
  for i := 0 to Model.States.StateCount - 1 do begin
    for j := 0 to Model.States.StateCount - 1 do begin
      if (Model.Connected(Model.States[i], Model.States[j])) and (not Model.RateFixed(i, j)) then begin
        Constraint := TQUB_QFS_Constraint.Create(CHANNELS_CONSTRAINT_TYPE_NAME[CSTR_FIX_RATE], nil);
        Constraint.HasValue := False;
        prConstraints.AddConstraint(Constraint, prConstraints.ConstraintCount);
        Constraint.Index[0] := i;
        Constraint.Index[1] := j;

        prAddConstraintList(Constraint);
      end;
    end;
  end;
  prPropertyChanged        := True;
  btnDelConstraint.Enabled := prConstraints.ConstraintCount > 0;
end;

function TQUB_QVO_QVM_XPropertiesForm.prGetConstrainedModelNode: INode;
var
  i          :Integer;
  Parent     :INode;
  CNode      :INode;
begin
  Result     := GetModelAsNode();
  Result.RemoveChild( Result['Constraints'] );
  Parent     := Result['Constraints'];
  CNode      := TNode.CreateNull;
  for i := 0 to prConstraints.ConstraintCount - 1 do begin
    CNode      := Parent.InsertChild(CNode, prConstraints[i].CloneAsNode(True, TNode.CreateNull));
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prBalanceAllLoops;
var
  Model      :INode;
  i, j       :Integer;
  Constraint :TQUB_QFS_Constraint;
  CNode      :INode;
begin
  Model      := BalanceAllLoops(prGetConstrainedModelNode());

  // remove any existing loop constraints
  for i := prConstraints.ConstraintCount - 1 downto 0 do begin
    if (prConstraints[i].CType = CSTR_LOOP_BALANCE)
    or (prConstraints[i].CType = CSTR_LOOP_IMBALANCE) then begin

    //TO DO: LM. This is not checking for LOOP_BALANCE_EXP

      //-- Remove the constraint
      prConstraints.DelConstraint(i);
      lstConstraints.Items.Delete(i);
    end;
  end;

  // add any loop constraints from tree

  //TO DO: LM. This is not checking for either LOOP_BALANCE_EXP or LOOP_IMBALANCE (they have different names than _BALANCE)

  CNode := Model.Find('Constraints').Find(CHANNELS_CONSTRAINT_LOOP_BAL_NAME);
  while not CNode.IsNull do begin
    Constraint := TQUB_QFS_Constraint.Create(CHANNELS_CONSTRAINT_LOOP_BAL_NAME, nil);
    prConstraints.AddConstraint(Constraint, prConstraints.ConstraintCount);
    for j := 0 to CNode.DataCount - 1 do begin
      Constraint.Index[j] := Integer( CNode.Data[j] );
    end;
    prAddConstraintList(Constraint);

    CNode := CNode.SiblingSameName;
  end;

  prPropertyChanged        := True;
  btnDelConstraint.Enabled := prConstraints.ConstraintCount > 0;
end;

function TQUB_QVO_QVM_XPropertiesForm.prPareConstraints: Word;
var
  Model      :INode;
  Removed    :INode;
  Msg        :String;
  i, j       :Integer;
  Constraint :TQUB_QFS_Constraint;
  CNode      :INode;
begin
  Removed    := TNode.Create('');
  Model      := PareConstraints(prGetConstrainedModelNode(), Removed);

  if Removed.Child.IsNull then begin
    Result   := mrNo; // no changes
    Exit;
  end;

  Msg   := 'The following constraints are extra.  Delete them?'#13#10;
  CNode := Removed.Child;
  while not CNode.IsNull do begin
    Msg := Msg + #9 + CNode.Name + ':';
    for i := 0 to CNode.DataCount - 1 do begin
      Msg := Msg + #9 + IntToStr(CNode.Data[i]);
    end;
    Msg := Msg + #13#10;
    CNode := CNode.Sibling;
  end;
  Result := MessageHelpDlg(Msg, mtWarning, [mbYes, mbNo, mbCancel], 0, 'Warning:ExtraConstraints');
  if Result <> mrYes then Exit;

  // remove all constraints
  for i := prConstraints.ConstraintCount - 1 downto 0 do begin
    prConstraints.DelConstraint(i);
    lstConstraints.Items.Delete(i);
  end;

  // add constraints from tree
  CNode := Model.Find('Constraints').Child;
  while not CNode.IsNull do begin
    Constraint := TQUB_QFS_Constraint.Create(CNode.Name, nil);
    prConstraints.AddConstraint(Constraint, prConstraints.ConstraintCount);
    for j := 0 to CNode.DataCount - 1 do begin
      Constraint.Index[j] := Integer( CNode.Data[j] );
    end;
    prAddConstraintList(Constraint);

    CNode := CNode.Sibling;
  end;

  prPropertyChanged        := True;
  btnDelConstraint.Enabled := prConstraints.ConstraintCount > 0;
end;


//Extra Kinetic Parameters
procedure TQUB_QVO_QVM_XPropertiesForm.prShowExtraKineticPars;
var
  i :Integer;
begin
  lstExtraKineticPars.Clear;
  for i := 0 to prExtraKineticPars.ExtraKineticParCount - 1 do begin
    prAddExtraKineticParList(prExtraKineticPars[i]);
  end;

  prShowExtraKineticPar;

  btnDelExtraKineticPar.Enabled := prExtraKineticPars.ExtraKineticParCount > 0;
end;

function TQUB_QVO_QVM_XPropertiesForm.prAddExtraKineticPar :Boolean;
var
  ExtraKineticPar :TQUB_QFS_ExtraKineticPar;
  Value           :Double;
begin

  Result          := True;

  try
    Value         := StrToFloat(txtExtraKineticParValue.Text);
  except
    Value         := 0;
  end;

  Name            := txtExtraKineticParName.Text;
  if Trim(Name) = '' then Exit;

  prConstraints.AddExtraKineticPar(prModel.States.StateCount, prModel.Rates.RateCount, prExtraKineticPars.ExtraKineticParCount);

  //-- Build a new ExtraKineticPar and add it to the list.
  ExtraKineticPar := TQUB_QFS_ExtraKineticPar.Create(Name, nil);
  prExtraKineticPars.AddExtraKineticPar(ExtraKineticPar, prExtraKineticPars.ExtraKineticParCount);
  ExtraKineticPar.Flags    := ExtraKineticPar.Flags or NODE_FLAG_PRELOAD;
  ExtraKineticPar.DataType := NODE_DATATYPE_DOUBLE;
  ExtraKineticPar.Value    := Value;

  prAddExtraKineticParList(ExtraKineticPar);

  Result := False;
  
  prPropertyChanged := True;

  btnDelExtraKineticPar.Enabled := prExtraKineticPars.ExtraKineticParCount > 0;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prAddExtraKineticParList(p :TQUB_QFS_ExtraKineticPar);
begin
  lstExtraKineticPars.Items.Add(Format('(%d) %s = %g', [lstExtraKineticPars.Items.Count + 1, p.Name, p.Value]));
  lstExtraKineticPars.ItemIndex := lstExtraKineticPars.Items.Count - 1;
end;

function TQUB_QVO_QVM_XPropertiesForm.prUpdateExtraKineticPar :Boolean;
var
  ExtraKineticPar :TQUB_QFS_ExtraKineticPar;
  Value           :Double;
  Idx             :Integer;
begin

  Result          := False;

  Idx := lstExtraKineticPars.ItemIndex;
  if Idx < 0 then Exit;

  try
    Value := StrToFloat(txtExtraKineticParValue.Text);
  except
    Value := 0;
  end;

  //Select the constraint
  ExtraKineticPar := prExtraKineticPars[Idx];
  ExtraKineticPar.Value := Value;

  prShowExtraKineticPar;

  prPropertyChanged := True;

  btnDelExtraKineticPar.Enabled := prExtraKineticPars.ExtraKineticParCount > 0;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prDelExtraKineticPar;
var
  i :Integer;
begin

  //-- Ensure there is a parameter to delete
  i := lstExtraKineticPars.ItemIndex;
  if i < 0 then Exit;

  prConstraints.DelExtraKineticPar(i, prModel.States.StateCount, prModel.Rates.RateCount, prExtraKineticPars.ExtraKineticParCount);

  prExtraKineticPars.DelExtraKineticPar(i);
  lstExtraKineticPars.Items.Delete(i);
  if i > (prExtraKineticPars.ExtraKineticParCount - 1) then begin
    i := (prExtraKineticPars.ExtraKineticParCount - 1);
  end;

  lstExtraKineticPars.ItemIndex := i;

  prShowExtraKineticPar;

  prPropertyChanged := True;

  btnDelExtraKineticPar.Enabled := prExtraKineticPars.ExtraKineticParCount > 0;

end;

procedure TQUB_QVO_QVM_XPropertiesForm.prShowExtraKineticPar;
var
  ExtraKineticPar :TQUB_QFS_ExtraKineticPar;
  i               :Integer;
begin

  i := lstExtraKineticPars.ItemIndex;
  if i < 0 then Exit;

  ExtraKineticPar := prExtraKineticPars[i];
  txtExtraKineticParName.Text  := ExtraKineticPar.Name;
  txtExtraKineticParValue.Text := FloatToStr(ExtraKineticPar.Value);

  lstExtraKineticPars.Items.Strings[i] := Format('(%d) %s = %g', [i + 1, ExtraKineticPar.Name, ExtraKineticPar.Value])

end;
             

//Amplitude Constraints
procedure TQUB_QVO_QVM_XPropertiesForm.prSetConstraintAmpVarType(t :TQUB_QFS_QMF_ConstraintAmpVarType);
begin
  prConstraintAmpVarType := t;
  lstConstraintAmpTypes.ItemIndex := Integer(ConstraintAmpVarType);
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prShowConstraintsAmpVar;
var
  i :Integer;
begin
  lstConstraintsAmp.Clear;
  for i := 0 to prConstraintsAmpVar.ConstraintCount - 1 do begin
    prAddConstraintAmpVarList(prConstraintsAmpVar[i]);
  end;
  btnDelConstraintAmp.Enabled := prConstraintsAmpVar.ConstraintCount > 0;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prAddConstraintAmpVarList(c :TQUB_QFS_ConstraintAmpVar);
var
  t :String;
  n :String;
begin

  n := c.Name;

  //Amplitude
  if          n = CHANNELS_CONSTRAINT_FIX_AMP_NAME            then begin

    t := Format('Fix amp:             %d',                    [c.Index[0] + 1]);

  end else if n = CHANNELS_CONSTRAINT_FIX_EXC_AMP_NAME        then begin

    t := Format('Fix exc amp:         %d',                    [c.Index[0] + 1]);

  end else if n = CHANNELS_CONSTRAINT_FIX_DIFF_EXC_AMP_NAME   then begin

    t := Format('Fix diff exc amps:   %d - %d',               [c.Index[0] + 1, c.Index[1] + 1]);

  end else if n = CHANNELS_CONSTRAINT_SCALE_EXC_AMP_NAME      then begin

    t := Format('Scale exc amps:      %d / %d',               [c.Index[0] + 1, c.Index[1] + 1]);

  end else if n = CHANNELS_CONSTRAINT_SCALE_DIFF_EXC_AMP_NAME then begin

    t := Format('Scale diff exc amps: (%d - %d) / (%d - %d)', [c.Index[0] + 1, c.Index[1] + 1, c.Index[2] + 1, c.Index[3] + 1]);

  //Variance
  end else if n = CHANNELS_CONSTRAINT_FIX_VAR_NAME            then begin

    t := Format('Fix var:             %d',                    [c.Index[0] + 1]);

  end else if n = CHANNELS_CONSTRAINT_FIX_EXC_VAR_NAME        then begin

    t := Format('Fix exc var:         %d',                    [c.Index[0] + 1]);

  end else if n = CHANNELS_CONSTRAINT_FIX_DIFF_EXC_VAR_NAME   then begin

    t := Format('Fix diff exc vars:   %d - %d',               [c.Index[0] + 1, c.Index[1] + 1]);

  end else if n = CHANNELS_CONSTRAINT_SCALE_EXC_VAR_NAME      then begin

    t := Format('Scale exc vars:      %d / %d',               [c.Index[0] + 1, c.Index[1] + 1]);

  end else if n = CHANNELS_CONSTRAINT_SCALE_DIFF_EXC_VAR_NAME then begin

    t := Format('Scale diff exc vars: (%d - %d) / (%d - %d)', [c.Index[0] + 1, c.Index[1] + 1, c.Index[2] + 1, c.Index[3] + 1]);

  end;

  lstConstraintsAmp.Items.Add(t);
  lstConstraintsAmp.ItemIndex := lstConstraintsAmp.Items.Count - 1;
end;

function TQUB_QVO_QVM_XPropertiesForm.prAddConstraintAmpVar :Boolean;
var
  Constraint :TQUB_QFS_ConstraintAmpVar;
  Constr     :TStringList;
  Parser     :TQUB_Parser;
  Text       :String;
  i          :Integer;
begin

  Result     := False;

  Text       := Trim(txtConstraintAmp.Text);
  if Text = '' then Exit;

  Constr     := TStringList.Create;
  Parser     := TQUB_Parser.Create;


  try

    Parser.Start;

    repeat

      Parser.Next(Text);
      if Parser.Token.TokenType = TOKEN_NUMBER then begin
        Constr.Add(Parser.Token.Token);
      end else if Parser.Token.TokenType <> TOKEN_NULL then begin
        Result := True;
        txtConstraint.SelStart  := Parser.Token.TokenPos - 1;
        txtConstraint.SelLength := Parser.Token.TokenLen;
        Exit;
      end;

    until(Parser.Token.TokenType = TOKEN_NULL);


    try

      if Constr.Count = 0 then begin
      //No entries in the list
        Result := True;

      end else if (prConstraintAmpVarType = CSTR_FIX_AMP) or (prConstraintAmpVarType = CSTR_FIX_VAR) then begin
      //FIX_AMP | VAR

        if Constr.Count <> 1 then begin
          Result := True;
        //end else if Class not in the model then begin
        //  Result := True;
        end;

      end else if (prConstraintAmpVarType = CSTR_FIX_EXC_AMP) or (prConstraintAmpVarType = CSTR_FIX_EXC_VAR) then begin
      //FIX_EXC_AMP | VAR

        if Constr.Count <> 1 then begin
          Result := True;
        //end else if Class not in the model then begin
        //  Result := True;
        end;

      end else if (prConstraintAmpVarType = CSTR_FIX_DIFF_EXC_AMP) or (prConstraintAmpVarType = CSTR_FIX_DIFF_EXC_VAR) then begin
      //FIX_DIFF_EXC_AMP | VAR

        if Constr.Count <> 2 then begin
          Result := True;
        //end else if Classes not in the Model then begin
        //  Result := True;
        end;

      end else if (prConstraintAmpVarType = CSTR_SCALE_EXC_AMP) or (prConstraintAmpVarType = CSTR_SCALE_EXC_VAR) then begin
      //SCALE_EXC_AMP | VAR

        if Constr.Count < 2 then begin
          Result := True;
        //end else if Classes not in the Model then begin
        //  Result := True;
        end;

      end else if (prConstraintAmpVarType = CSTR_SCALE_DIFF_EXC_AMP) or (prConstraintAmpVarType = CSTR_SCALE_DIFF_EXC_VAR) then begin
      //SCALE_DIFF_EXC_AMP | VAR

        if Constr.Count < 4 then begin
          Result := True;
        //end else if Classes not in the Model then begin
        //  Result := True;
        end;

      end;

    except

      Result := True;

    end;


  finally


    if not Result then begin

      Constraint := TQUB_QFS_ConstraintAmpVar.Create(CHANNELS_CONSTRAINT_AMPVAR_TYPE_NAME[prConstraintAmpVarType], nil);
      prConstraintsAmpVar.AddConstraint(Constraint, prConstraintsAmpVar.ConstraintCount);
      for i := 0 to Constr.Count - 1 do begin
        Constraint.Index[i] := StrToInt(Constr.Strings[i]) - 1;
      end;

      prAddConstraintAmpVarList(Constraint);

    end else begin

      MessageHelpDlg('Invalid format or class index', mtError, [mbOK], 0, 'Error:AmpVar_Constraints');

    end;

    Constr.Free;
    Parser.Free;

  end;

  if not Result then begin
    txtConstraintAmp.Text := '';
    prPropertyChanged := True;
  end;

  btnDelConstraintAmp.Enabled := prConstraintsAmpVar.ConstraintCount > 0;

end;


procedure TQUB_QVO_QVM_XPropertiesForm.prDelConstraintAmpVar;
var
  i :Integer;
begin
  i := lstConstraintsAmp.ItemIndex;
  if i < 0 then Exit;
  prConstraintsAmpVar.DelConstraint(i);
  lstConstraintsAmp.Items.Delete(i);
  if i > (prConstraintsAmpVar.ConstraintCount - 1) then begin
    i := (prConstraintsAmpVar.ConstraintCount - 1);
  end;
  lstConstraintsAmp.ItemIndex := i;
  btnDelConstraintAmp.Enabled := prConstraintsAmpVar.ConstraintCount > 0;
  prPropertyChanged := True;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prSetRateIndexHalfIndex(RIdx, HIdx, K01 :Integer);
begin

  with prModel, ViewportModel.CurrModel do begin

    try

      Rates.CurrRateIdx := RIdx;
      Rates.CurrHalfIdx := HIdx;
      Rates.CurrK01     := K01;

      ShowSelectedRate  := True;
      prDrawModel;

    finally

      ShowSelectedRate  := False;
      ViewportModel.CurrModel.Draw;

    end;

    if RIdx >= 0 then begin
      with Rates[RIdx] do begin
        prSetRate(K0[HIdx], K1[HIdx], P[HIdx], Q[HIdx], PName[HIdx], QName[HIdx], RateFormat[HIdx]);
      end;
    end;
  end;//with

end;

procedure TQUB_QVO_QVM_XPropertiesForm.prSetRate(K0, K1 :Double; P, Q :Boolean; const PName, QName, RateFormat :String);
begin
  txtK0.Text    := Format('%.6g', [K0]);
  txtK1.Text    := Format('%.6g', [K1]);
  chkP.Checked  := P;
  chkQ.Checked  := Q;
  txtPName.Text := PName;
  txtQName.Text := QName;
  txtRateFormat.Text := RateFormat;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.prDrawModel;
begin
  ViewportModel.CurrModel.DrawToPos(picModel.Canvas, 0, 0, picModel.ClientWidth, picModel.ClientHeight, StatePos, prRatePos);
end;

//******************************************************************************
procedure TQUB_QVO_QVM_XPropertiesForm.FormCreate(Sender: TObject);
var
  Prop                           :TQUB_Property_Edit;
begin
  inherited;

  udStateSize.Min                := 10;
  udStateSize.Max                := 100;
  udLineWidth.Min                := 0;
  udLineWidth.Max                := 20;

  prConstraints                  := TQUB_QFS_Constraints.Create(CHANNELS_CONSTRAINTS_NAME, nil);
  ConstraintType                 := CSTR_FIX_RATE;
  prExtraKineticPars             := TQUB_QFS_ExtraKineticPars.Create(CHANNELS_EXTRAKINETICPARS_NAME, nil);
  prConstraintsAmpVar            := TQUB_QFS_ConstraintsAmpVar.Create(CHANNELS_CONSTRAINTS_AMPVAR_NAME, nil);
  ConstraintAmpVarType           := CSTR_FIX_AMP;

  prRatePos := TRatePanelPosList.Create;
  //{$include 'QUB_QVO_QVM_Properties.htx'}

  prStatePosCount                := 0;
  prStatePos                     := nil;

  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["ColorBack"]',
                          panColorBack));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["ColorLine"]',
                          panColorLine));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["ColorRate"]',
                          panColorRate));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["ColorSelected"]',
                          panColorSelected));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["ColorFrame"]',
                          panColorFrame));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["ColorPanel"]',
                          panColor));
  AddUpDownProperty(TQUB_Property_UpDown.Create('["StateSize"]',
                      udStateSize,
                      txtStateSize,
                      AcceptIntBetween(udStateSize.Min, udStateSize.Max)));
  AddUpDownProperty(TQUB_Property_UpDown.Create('["LineWidth"]',
                      udLineWidth,
                      txtLineWidth,
                      AcceptIntBetween(udLineWidth.Min, udLineWidth.Max)));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["AlignToGrid"]',
                        chkAlignToGrid) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["UseGlobalCond"]',
                        chkUseGlobalCond) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["ScrollRates"]',
                        chkScrollRates) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DiagonalRates"]',
                        chkDiagonalRates)
                      .Enables(chkShowK1) //Why disable Showk1?! LM.  because it's ignored unless DiagonalRates. CN
                      );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["ShowK1"]',
                        chkShowK1) );
  Prop  := TQUB_Property_Edit.Create('["PreFormat"]',
                    txtPreFormat,
                    AcceptString, '%s');
  Prop.Ix := -1; // so it doesn't fill out blank string with '0'
  AddEditProperty(Prop);
  Prop  := TQUB_Property_Edit.Create('["ExpFormat"]',
                    txtExpFormat,
                    AcceptString, '%s');
  Prop.Ix := -1; // so it doesn't fill out blank string with '0'
  AddEditProperty(Prop);

  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["EnforceConstraints"]',
                        chkEnforceConstraints) );
  AddEditProperty(TQUB_Property_Edit.Create('["MarginH"]',
                    txtMarginH,
                    AcceptIntBetween(QUB_QVO_QVM_MIN_MARGIN, QUB_QVO_QVM_MAX_MARGIN),
                    ''));
  AddEditProperty(TQUB_Property_Edit.Create('["MarginV"]',
                    txtMarginV,
                    AcceptIntBetween(QUB_QVO_QVM_MIN_MARGIN, QUB_QVO_QVM_MAX_MARGIN),
                    ''));

  ProfileCatName       := 'QVM';

  WikiTopic            := 'Model_Properties';

end;

procedure TQUB_QVO_QVM_XPropertiesForm.FormDestroy(Sender: TObject);
begin
  try
    prBackUpRates.Free;
    prConstraints.Free;
    prExtraKineticPars.Free;
    prConstraintsAmpVar.Free;
    FreeMem(prStatePos);
    prRatePos.Free;
  finally
    inherited;
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.FormShow(Sender: TObject);
var
  RIdx, HIdx, K01 :Integer;
begin
  inherited;

  picModel.Canvas.Brush.Style := bsSolid;
  picModel.Canvas.Brush.Color := clBtnFace;
  picModel.Canvas.Rectangle(0, 0, picModel.ClientWidth, picModel.ClientHeight);

  prModelModified := prModel.Modified;

  prShowConstraints;
  prShowExtraKineticPars;
  prShowConstraintsAmpVar;

  prBackUpRates.Free;
  prBackUpRates := TQUB_QFS_Rates.Create('BackupRates', nil);
  prBackupRates.CopyFrom(prModel.Rates);
  prBackupRates.UpdateFrom(prModel.Rates, False{Change});

  with prModel do begin

    RIdx := Rates.CurrRateIdx;
    HIdx := Rates.CurrHalfIdx;
    K01  := Rates.CurrK01;
    if (Rates.RateCount > 0) and ((RIdx < 0) or (RIdx >= Rates.RateCount)) then RIdx := 0;
    prSetRateIndexHalfIndex(RIdx, HIdx, K01);

    if pagControl.ActivePage = tabRates then begin
      if K01 = QUB_QFS_QMF_RATE_K0 then begin
        txtK0.SetFocus;
      end else begin
        txtK1.SetFocus;
      end;
    end;

  end;

  pagControlChange(Self);

end;

function TQUB_QVO_QVM_XPropertiesForm.prReadyToClose: Boolean;
begin
  Result := prPareConstraints <> mrCancel;
end;

function TQUB_QVO_QVM_XPropertiesForm.StatePos: TPAPoint;
begin
  if prStatePosCount <> prModel.States.StateCount then begin
    prStatePosCount := prModel.States.StateCount;
    FreeMem(prStatePos);
    if prStatePosCount > 0 then begin
      prStatePos := PointAlloc1(prStatePosCount);
    end else begin
      prStatePos := nil;
    end;
  end;
  Result := prStatePos;
end;

//******************************************************************************
procedure TQUB_QVO_QVM_XPropertiesForm.pagControlChange(Sender: TObject);
begin
  inherited;
  mnuProfiles.Visible     :=    (pagControl.ActivePage = tabColors)
                             or (pagControl.ActivePage = tabDisplay);
  btnRateSetAsDefault.Visible := pagControl.ActivePage = tabRates;
end;

//Model properties
procedure TQUB_QVO_QVM_XPropertiesForm.txtModelChannelCountKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtModelChannelCountExit(Sender);
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.txtModelChannelCountExit(Sender: TObject);
var
  c :Integer;
begin
  inherited;
  prError := False;
  try
    c := StrToInt(TEdit(Sender).Text);
    if ((c < QUB_QFS_QMF_MIN_CHANNEL_COUNT) or (c > QUB_QFS_QMF_MAX_CHANNEL_COUNT)) then raise Exception.Create('');
  except
    prError := False;
    MessageDlg('Invalid value; must be between ' + IntToStr(QUB_QFS_QMF_MIN_CHANNEL_COUNT) + ' and ' + IntToStr(QUB_QFS_QMF_MAX_CHANNEL_COUNT), mtError, [mbOK], 0);
    TEdit(Sender).Text := IntToStr(ModelChannelCount);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if c <> ModelChannelCount then begin
    ModelChannelCount := c;
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.udModelChannelCountClick(Sender: TObject; Button: TUDBtnType);
var
  Cnt :Integer;
begin
  inherited;
  Cnt := ModelChannelCount;
  if Button = btPrev then begin
    if      Cnt >= 20000000 then Dec(Cnt, 10000000)
    else if Cnt >= 2000000  then Dec(Cnt, 1000000)
    else if Cnt >= 200000   then Dec(Cnt, 100000)
    else if Cnt >= 20000    then Dec(Cnt, 10000)
    else if Cnt >= 2000     then Dec(Cnt, 1000)
    else if Cnt >= 200      then Dec(Cnt, 100)
    else if Cnt >= 20       then Dec(Cnt, 10)
    else                         Dec(Cnt, 1);
    if Cnt < QUB_QFS_QMF_MIN_CHANNEL_COUNT then Cnt := QUB_QFS_QMF_MIN_CHANNEL_COUNT;
  end else begin
    if      Cnt >= 10000000 then Inc(Cnt, 10000000)
    else if Cnt >= 1000000  then Inc(Cnt, 1000000)
    else if Cnt >= 100000   then Inc(Cnt, 100000)
    else if Cnt >= 10000    then Inc(Cnt, 10000)
    else if Cnt >= 1000     then Inc(Cnt, 1000)
    else if Cnt >= 100      then Inc(Cnt, 100)
    else if Cnt >= 10       then Inc(Cnt, 10)
    else                         Inc(Cnt, 1);
    if Cnt > QUB_QFS_QMF_MAX_CHANNEL_COUNT then Cnt := QUB_QFS_QMF_MAX_CHANNEL_COUNT;
  end;
  if Cnt <> ModelChannelCount then begin
    ModelChannelCount := Cnt;
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.udModelChannelCountChanging(Sender: TObject; var AllowChange: Boolean);
begin
  inherited;
  if prModelChannelCountChanging then Exit;
  prModelChannelCountChanging := True;
  try
    udModelChannelCount.Position := 2;
  finally
    prModelChannelCountChanging := False;
  end;
end;

//V reversal
procedure TQUB_QVO_QVM_XPropertiesForm.txtVrevKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtVrevExit(Sender);
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.txtVrevExit(Sender: TObject);
var
  V :Double;
begin
  inherited;
  prError := False;
  try
    V := StrToFloat(TEdit(Sender).Text);
    if (V < QUB_QFS_QMF_MIN_VREV) or (V > QUB_QFS_QMF_MAX_VREV) then raise Exception.Create('');
  except
    prError := True;
    MessageDlg('Invalid value; must be between ' + FloatToStr(QUB_QFS_QMF_MIN_VREV) + ' and ' + FloatToStr(QUB_QFS_QMF_MAX_VREV), mtError, [mbOK], 0);
    Vrev := Vrev;
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if V <> Vrev then begin
    Vrev := V;
  end;
end;

//Kinetic Constraints
procedure TQUB_QVO_QVM_XPropertiesForm.btnAddConstraintClick(Sender: TObject);
begin
  inherited;
  if ConstraintType = CSTR_GEN then begin
    prAddGenConstraint;
  end else begin
    prAddConstraint;
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.btnUpdateConstraintClick(Sender: TObject);
var
  Idx :Integer;
begin
  inherited;
  Idx := lstConstraints.ItemIndex;
  if Idx < 0 then Exit;
  if prConstraints[Idx].cType = CSTR_GEN then begin
    prUpdateGenConstraint;
  end else begin
    prUpdateConstraint;
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.btnDelConstraintClick(Sender: TObject);
begin
  inherited;
  prDelConstraint;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.txtConstraintKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    prAddConstraint;
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.lstConstraintTypesClick(Sender: TObject);
begin
  inherited;
  if lstConstraintTypes.ItemIndex <> -1 then begin
    ConstraintType := TQUB_QFS_QMF_ConstraintType(lstConstraintTypes.ItemIndex);
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.btnFixAllRatesClick(Sender: TObject);
begin
  inherited;
  prFixAllRates;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.btnBalanceAllLoopsClick(Sender: TObject);
begin
  inherited;
  prBalanceAllLoops;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.btnDelDependentClick(Sender: TObject);
begin
  inherited;
  prPareConstraints;
end;

//Extra Kinetic Parameters
procedure TQUB_QVO_QVM_XPropertiesForm.btnAddExtraKineticParClick(Sender: TObject);
begin
  inherited;
  prAddExtraKineticPar;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.btnUpdateExtraKineticParClick(Sender: TObject);
begin
  inherited;
  prUpdateExtraKineticPar;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.btnDelExtraKineticParClick(Sender: TObject);
begin
  inherited;
  prDelExtraKineticPar;
end;

//Amplitude Constraints
procedure TQUB_QVO_QVM_XPropertiesForm.btnAddConstraintAmpClick(Sender: TObject);
begin
  inherited;
  prAddConstraintAmpVar;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.btnDelConstraintAmpClick(Sender: TObject);
begin
  inherited;
  prDelConstraintAmpVar;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.txtConstraintAmpKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    prAddConstraintAmpVar;
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.lstConstraintAmpTypesClick(Sender: TObject);
begin
  inherited;
  if lstConstraintAmpTypes.ItemIndex <> -1 then begin
    ConstraintAmpVarType := TQUB_QFS_QMF_ConstraintAmpVarType(lstConstraintAmpTypes.ItemIndex);
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.btnClearConstraintClick(sender: TObject);
begin
  inherited;
  chkConstraintValue.Checked := False;
  txtConstraintValue.Text := '';
  lstConstraintTypes.ItemIndex := 0;
  txtConstraint.Text := '';
end;

procedure TQUB_QVO_QVM_XPropertiesForm.picModelMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  StateIdx :Integer;
  RateIdx  :Integer;
  HalfIdx  :Integer;
  K01      :Integer;
begin
  inherited;
  //Determine whether the user clicked on a rate; if so, update Model.CurrRate/HalfRate
  //then redraw Model in picModel and update values in ModelProperties editor
  ViewportModel.CurrModel.MouseToStateRate(x, y, StatePos, prRatePos, StateIdx, RateIdx, {1->2 or 2->1}HalfIdx, K01);
  if (RateIdx <> - 1) and ((RateIdx <> prModel.Rates.CurrRateIdx) or (HalfIdx <> prModel.Rates.CurrHalfIdx) or (K01 <> prModel.Rates.CurrK01)) then begin
    pagControl.SetFocus;
    prSetRateIndexHalfIndex(RateIdx, HalfIdx, K01);
    if K01 = QUB_QFS_QMF_RATE_K0 then begin
      txtK0.SetFocus;
    end else begin
      txtK1.SetFocus;
    end;
  end;
end;

//******************************************************************************
// re-add this but only visible for the rates tab -- same with setasdefault
procedure TQUB_QVO_QVM_XPropertiesForm.btnResetClick(Sender: TObject);
begin
  with prModel.Rates do begin
    UpdateFrom(prBackupRates, True{Change});
    prSetRateIndexHalfIndex(CurrRateIdx, CurrHalfIdx, CurrK01);
  end;
  inherited;
end;


procedure TQUB_QVO_QVM_XPropertiesForm.btnApplyClick(Sender: TObject);
begin
  with prModel do begin
    prBackupRates.UpdateFrom(Rates, False{Change});
    with Rates do begin
      prSetRateIndexHalfIndex(CurrRateIdx, CurrHalfIdx, CurrK01);
    end;
  end;
  inherited;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.btnCancelClick(Sender: TObject);
begin
  prModel.Rates.UpdateFrom(prBackupRates, True{Change});
  if (not prModelModified) and (prModel.Modified) then begin
    Model.Unmodify;
  end;
  inherited;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.btnRateSetAsDefaultClick(Sender: TObject);
begin
  inherited;
  if Assigned(OnRateSetAsDefault) then OnRateSetAsDefault(Self);
end;


//Rate events ******************************************************************
procedure TQUB_QVO_QVM_XPropertiesForm.txtK0KeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtK0Exit(Sender);
    btnOK.SetFocus;
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.txtK0Exit(Sender: TObject);
var
  Kk :Double;
begin
  inherited;
  if prModel.Rates.CurrRateIdx < 0 then Exit;
  prError := False;
  try
    Kk := StrToFloat(TEdit(Sender).Text);
    if (Kk < MIN_K0) or (Kk > MAX_K0) then raise Exception.Create('');
  except
    prError := True;
    MessageDlg('Invalid value; must be between ' + FloatToStr(MIN_K0) + ' and ' + FloatToStr(MAX_K0), mtError, [mbOK], 0);
    TEdit(Sender).Text := FloatToStr(K0);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if Kk <> K0 then begin
    K0 := Kk;
    prSetRateIndexHalfIndex(prModel.Rates.CurrRateIdx, prModel.Rates.CurrHalfIdx, prModel.Rates.CurrK01);
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.txtK1KeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtK1Exit(Sender);
    btnOK.SetFocus;
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.txtK1Exit(Sender: TObject);
var
  Kk :Double;
begin
  inherited;
  if prModel.Rates.CurrRateIdx < 0 then Exit;
  prError := False;
  try
    Kk := StrToFloat(TEdit(Sender).Text);
    if (Kk < MIN_K1) or (Kk > MAX_K1) then raise Exception.Create('');
  except
    prError := True;
    MessageDlg('Invalid value; must be between ' + FloatToStr(MIN_K1) + ' and ' + FloatToStr(MAX_K1), mtError, [mbOK], 0);
    TEdit(Sender).Text := FloatToStr(K1);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if Kk <> K1 then begin
    K1 := Kk;
    prSetRateIndexHalfIndex(prModel.Rates.CurrRateIdx, prModel.Rates.CurrHalfIdx, prModel.Rates.CurrK01);
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.chkPClick(Sender: TObject);
begin
  inherited;
  if prModel.Rates.CurrRateIdx < 0 then Exit;
  if P <> TCheckBox(Sender).Checked then begin
    P := TCheckBox(Sender).Checked;
    prModel.UpdateParameters;
    prSetRateIndexHalfIndex(prModel.Rates.CurrRateIdx, prModel.Rates.CurrHalfIdx, prModel.Rates.CurrK01);
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.chkQClick(Sender: TObject);
begin
  inherited;
  if prModel.Rates.CurrRateIdx < 0 then Exit;
  if Q <> TCheckBox(Sender).Checked then begin
    Q := TCheckBox(Sender).Checked;
    prModel.UpdateParameters;
    prSetRateIndexHalfIndex(prModel.Rates.CurrRateIdx, prModel.Rates.CurrHalfIdx, prModel.Rates.CurrK01);
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.txtPNameKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtPNameExit(Sender);
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.txtPNameExit(Sender: TObject);
begin
  inherited;
  if prModel.Rates.CurrRateIdx < 0 then Exit;
  if PName <> TEdit(Sender).Text then begin
    PName := TEdit(Sender).Text;
    prModel.UpdateParameters;
    prSetRateIndexHalfIndex(prModel.Rates.CurrRateIdx, prModel.Rates.CurrHalfIdx, prModel.Rates.CurrK01);
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.txtQNameKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtQNameExit(Sender);
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.txtQNameExit(Sender: TObject);
begin
  inherited;
  if prModel.Rates.CurrRateIdx < 0 then Exit;
  if QName <> TEdit(Sender).Text then begin
    QName := TEdit(Sender).Text;
    prModel.UpdateParameters;
    prSetRateIndexHalfIndex(prModel.Rates.CurrRateIdx, prModel.Rates.CurrHalfIdx, prModel.Rates.CurrK01);
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.txtRateFormatKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtRateFormatExit(Sender);
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.txtRateFormatExit(Sender: TObject);
begin
  inherited;
  if prModel.Rates.CurrRateIdx < 0 then Exit;
  if RateFormat <> TEdit(Sender).Text then begin
    RateFormat := TEdit(Sender).Text;
    prModel.UpdateParameters;
    prSetRateIndexHalfIndex(prModel.Rates.CurrRateIdx, prModel.Rates.CurrHalfIdx, prModel.Rates.CurrK01);
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.tabRatesShow(Sender: TObject);
begin
  inherited;
  if prModel = nil then Exit;
  with prModel.Rates do begin
    if CurrK01 = QUB_QFS_QMF_RATE_K0 then begin
      txtK0.SetFocus;
    end else begin
      txtK1.SetFocus;
    end;
    prSetRateIndexHalfIndex(CurrRateIdx, CurrHalfIdx, CurrK01);
  end;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.tabRatesResize(Sender: TObject);
var
  RePicture :TPicture;
begin
  inherited;
  // tpicture won't resize so we need a fresh one when size changes
  RePicture := TPicture.Create;
  picModel.Picture := RePicture;
  RePicture.Free;

  if prModel <> nil then prDrawModel;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.lstConstraintsClick(Sender: TObject);
begin
  inherited;
  prShowConstraint;
end;

procedure TQUB_QVO_QVM_XPropertiesForm.lstExtraKineticParsClick(Sender: TObject);
begin
  inherited;
  prShowExtraKineticPar;
end;


//******************************************************************************
end.
