{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
unit QUB_QVO_QVR_Window;


interface


uses
  

Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,

QUB_QVO_QVR, QUB_Results;


type


TQUB_QVO_QVR_Window = class(TForm)


  procedure FormClose(Sender: TObject; var Action: TCloseAction);
  procedure FormActivate(Sender: TObject);
  procedure FormDeactivate(Sender: TObject);

  
public


  QVR              :TQUB_QVO_QVR;


  constructor Create(AOwner :TComponent; Results :TQUB_Results); reintroduce;


end;


implementation


uses


QUB_GUIInterface,
QUB_Viewport_Results;


{$R *.DFM}


//******************************************************************************
constructor TQUB_QVO_QVR_Window.Create(AOwner :TComponent; Results :TQUB_Results);
begin
  inherited Create(AOwner);

  QVR         := TQUB_QVO_QVR.Create(ViewportResults, Results);
  QVR.Parent  := Self;
  QVR.Align   := alClient;
  QVR.BuildInterface;

  Caption     := 'Results: ' + ExtractFileName( Results.FileName );

  Show;
end;

procedure TQUB_QVO_QVR_Window.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  QVR.Free;
  QVR := nil;
  ViewportResults.PopupResults := nil;
  Release;
end;

procedure TQUB_QVO_QVR_Window.FormActivate(Sender: TObject);
begin
  if QVR = nil then Exit;
  QVR.Activate;
  ViewportResults.PopupResults := QVR;
end;

procedure TQUB_QVO_QVR_Window.FormDeactivate(Sender: TObject);
begin
  if QVR = nil then Exit;
  QVR.Deactivate;
  ViewportResults.PopupResults := nil;
end;


//******************************************************************************
end.
