{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
// QUB Visual Scope properties form


unit QUB_QVO_QVS_Properties;


interface


uses


Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ComCtrls, StdCtrls, ExtCtrls, Buttons,
QUB_QVO_QVD_Global, QUB_Global, QUB_QVO_Properties,
QUB_QFS_QDF_Global, QUB_Interface_Button;


{$include 'QUB_QVO_QVS_Properties.hct'}


type


TQUB_QVO_QVS_PropertiesForm = class(TQUB_QVO_PropertiesForm)


  Label1                    :TLabel;
  Label2                    :TLabel;
  Label3                    :TLabel;
  Label4                    :TLabel;
  Label5                    :TLabel;
  Label7                    :TLabel;
  Label12                   :TLabel;
  Label13                   :TLabel;
  Label27                   :TLabel;
  Label26                   :TLabel;
  Label22                   :TLabel;
  Label25                   :TLabel;
  Label24                   :TLabel;
  Label23                   :TLabel;
  Label21                   :TLabel;
  Label20                   :TLabel;

  panColorBack              :TPanel;
  panColorFrame             :TPanel;
  panColor                  :TPanel;
  panColorData0             :TPanel;
  panColorData1             :TPanel;
  panColorData2             :TPanel;
  panColorData3             :TPanel;
  panColorData4             :TPanel;
  panColorData5             :TPanel;
  panColorData6             :TPanel;
  panColorData7             :TPanel;

  chkShowMinMax             :TCheckBox;
  chkDrawAllPoints          :TCheckBox;
  chkDrawRMS                :TCheckBox;

  txtXResolution            :TEdit;

  txtChannelIndex           :TEdit;
  udChannelIndex            :TUpDown;

  txtOffset                 :TEdit;

  chkDisplay                :TCheckBox;

  chkFilterOn               :TCheckBox;
  txtFilterPts              :TEdit;


  procedure FormCreate(Sender: TObject);
  procedure FormDestroy(Sender: TObject);
  procedure FormShow(Sender: TObject);

  procedure panColorClick(Sender: TObject);
  procedure panColorBackClick(Sender: TObject);
  procedure panColorDataClick(Sender: TObject);
  procedure panColorFrameClick(Sender: TObject);

  procedure chkShowMinMaxClick(Sender: TObject);
  procedure chkDrawAllPointsClick(Sender: TObject);
  procedure chkDrawRMSClick(Sender: TObject);

  procedure txtXResolutionKeyPress(Sender: TObject; var Key: Char);
  procedure txtXResolutionExit(Sender: TObject);
  procedure txtOffsetKeyPress(Sender: TObject; var Key: Char);
  procedure txtOffsetExit(Sender: TObject);
  procedure udChannelIndexClick(Sender: TObject; Button: TUDBtnType);
  procedure chkDisplayClick(Sender: TObject);
  procedure chkFilterOnClick(Sender: TObject);
  procedure txtFilterPtsKeyPress(Sender: TObject; var Key: Char);
  procedure txtFilterPtsExit(Sender: TObject);


protected


  prError                                 :Boolean;

  prDlgColor                              :TColorDialog;

  prColor                                 :TColor;
  prColorBack                             :TColor;
  prColorData                             :Array[0..7] of TColor;
  prColorFrame                            :TColor;

  prShowMinMax                            :Boolean;
  prDrawAllPoints                         :Boolean;
  prDrawRMS                               :Boolean;
  
  prXResolution                           :Double;

  prChannelIndex                          :Integer;
  prOffset                                :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Double;
  prDisplay                               :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Boolean;

  prFilterOn                              :Boolean;
  prFilterPts                             :Integer;


  procedure prSetColor(c :TColor);
  procedure prSetColorBack(c :TColor);
  function prGetColorData(Index :Integer) :TColor;
  procedure prSetColorData(Index :Integer; c :TColor);
  procedure prSetColorFrame(c :TColor);
  procedure prSetShowMinMax(s :Boolean);
  procedure prSetDrawRMS(r :Boolean);
  procedure prSetDrawAllPoints(s :Boolean);
  procedure prSetXResolution(x :Double);
  procedure prSetChannelIndex(c :Integer);
  procedure prSetOffset(Index :Integer; o :Double);
  function prGetOffset(Index :Integer) :Double;
  procedure prSetDisplay(Index :Integer; d :Boolean);
  function prGetDisplay(Index :Integer) :Boolean;
  procedure prSetFilterOn(f :Boolean);
  procedure prSetFilterPts(p :Integer);


public


  property Color                          :TColor                read prColor                 write prSetColor;
  property ColorBack                      :TColor                read prColorBack             write prSetColorBack;
  property ColorData[Index :Integer]      :TColor                read prGetColorData          write prSetColorData;
  property ColorFrame                     :TColor                read prColorFrame            write prSetColorFrame;
  property ShowMinMax                     :Boolean               read prShowMinMax            write prSetShowMinMax;
  property DrawRMS                        :Boolean               read prDrawRMS               write prSetDrawRMS;
  property DrawAllPoints                  :Boolean               read prDrawAllPoints         write prSetDrawAllPoints;
  property XResolution                    :Double                read prXResolution           write prSetXResolution;
  property ChannelIndex                   :Integer               read prChannelIndex          write prSetChannelIndex;
  property Offset [Index :Integer]        :Double                read prGetOffset             write prSetOffset;
  property Display[Index :Integer]        :Boolean               read prGetDisplay            write prSetDisplay;
  property FilterOn                       :Boolean               read prFilterOn              write prSetFilterOn;
  property FilterPts                      :Integer               read prFilterPts             write prSetFilterPts;


end;


implementation


{$R *.DFM}


uses


QUB_QVO_QVS;


//Colors ***********************************************************************
procedure TQUB_QVO_QVS_PropertiesForm.prSetColor(c :TColor);
begin
  prColor := c;
  panColor.Color := prColor;
  prPropertyChanged := True;
end;

procedure TQUB_QVO_QVS_PropertiesForm.prSetColorBack(c :TColor);
begin
  prColorBack := c;
  panColorBack.Color := prColorBack;
  prPropertyChanged := True;
end;

procedure TQUB_QVO_QVS_PropertiesForm.prSetColorData(Index :Integer; c :TColor);
begin
  prColorData[Index] := c;
  case Index of
    0:panColorData0.Color := prColorData[Index];
    1:panColorData1.Color := prColorData[Index];
    2:panColorData2.Color := prColorData[Index];
    3:panColorData3.Color := prColorData[Index];
    4:panColorData4.Color := prColorData[Index];
    5:panColorData5.Color := prColorData[Index];
    6:panColorData6.Color := prColorData[Index];
    7:panColorData7.Color := prColorData[Index];
  end;//case
  prPropertyChanged := True;
end;

function TQUB_QVO_QVS_PropertiesForm.prGetColorData(Index :Integer) :TColor;
begin
  Result := prColorData[Index];
end;

procedure TQUB_QVO_QVS_PropertiesForm.prSetColorFrame(c :TColor);
begin
  prColorFrame := c;
  panColorFrame.Color := prColorFrame;
  prPropertyChanged := True;
end;

procedure TQUB_QVO_QVS_PropertiesForm.prSetShowMinMax(s :Boolean);
begin
  prShowMinMax := s;
  chkShowMinMax.Checked := prShowMinMax;
  prPropertyChanged := True;
end;

procedure TQUB_QVO_QVS_PropertiesForm.prSetDrawRMS(r :Boolean);
begin
  prDrawRMS := r;
  chkDrawRMS.Checked := prDrawRMS;
  prPropertyChanged := True;
end;

procedure TQUB_QVO_QVS_PropertiesForm.prSetDrawAllPoints(s :Boolean);
begin
  prDrawAllPoints := s;
  chkDrawAllPoints.Checked := prDrawAllPoints;
  prPropertyChanged := True;
end;

procedure TQUB_QVO_QVS_PropertiesForm.prSetXResolution(x :Double);
begin
  prXResolution := x;
  txtXResolution.Text := FloatToStr(XResolution);
  prPropertyChanged := True;
end;

procedure TQUB_QVO_QVS_PropertiesForm.prSetChannelIndex(c :Integer);
var
  p :Boolean;
begin
  prChannelIndex := c;
  udChannelIndex.Position := ChannelIndex;
  p := prPropertyChanged;
  Offset [ChannelIndex] := Offset [ChannelIndex];
  Display[ChannelIndex] := Display[ChannelIndex];
  prPropertyChanged := p;
end;

procedure TQUB_QVO_QVS_PropertiesForm.prSetOffset(Index :Integer; o :Double);
begin
  prOffset[Index] := o;
  txtOffset.Text := Format('%.6g', [prOffset[ChannelIndex] * 1000]);
  prPropertyChanged := True;
end;

function TQUB_QVO_QVS_PropertiesForm.prGetOffset(Index :Integer) :Double;
begin
  Result := prOffset[Index];
end;

procedure TQUB_QVO_QVS_PropertiesForm.prSetDisplay(Index :Integer; d :Boolean);
begin
  prDisplay[Index] := d;
  chkDisplay.Checked := prDisplay[ChannelIndex];
  prPropertyChanged := True;
end;

function TQUB_QVO_QVS_PropertiesForm.prGetDisplay(Index :Integer) :Boolean;
begin
  Result := prDisplay[Index];
end;

procedure TQUB_QVO_QVS_PropertiesForm.prSetFilterOn(f :Boolean);
begin
  prFilterOn := f;
  chkFilterOn.Checked := prFilterOn;
  prPropertyChanged := True;
end;

procedure TQUB_QVO_QVS_PropertiesForm.prSetFilterPts(p :Integer);
begin
  prFilterPts := p;
  txtFilterPts.Text := IntToStr(prFilterPts);
  prPropertyChanged := True;
end;


//Events ***********************************************************************

//Form *************************************************************************
procedure TQUB_QVO_QVS_PropertiesForm.FormCreate(Sender: TObject);
begin
  inherited;
  prDlgColor := TColorDialog.Create(Self);
  {$include 'QUB_QVO_QVS_Properties.htx'}
end;

procedure TQUB_QVO_QVS_PropertiesForm.FormDestroy(Sender: TObject);
begin
  try
    prDlgColor.Free;
  finally
    inherited;
  end;
end;

procedure TQUB_QVO_QVS_PropertiesForm.FormShow(Sender: TObject);
begin
  inherited;
end;


//Colors ***********************************************************************
procedure TQUB_QVO_QVS_PropertiesForm.panColorClick(Sender: TObject);
begin
  inherited;
  prDlgColor.Color := Color;
  if prDlgColor.Execute then begin
    Color := prDlgColor.Color;
    btnApplyClick(btnApply);
  end;
end;

procedure TQUB_QVO_QVS_PropertiesForm.panColorBackClick(Sender: TObject);
begin
  inherited;
  prDlgColor.Color := ColorBack;
  if prDlgColor.Execute then begin
    ColorBack := prDlgColor.Color;
    btnApplyClick(btnApply);
  end;
end;

procedure TQUB_QVO_QVS_PropertiesForm.panColorDataClick(Sender: TObject);
begin
  inherited;
  prDlgColor.Color := ColorData[TPanel(Sender).Tag];
  if prDlgColor.Execute then begin
    ColorData[TPanel(Sender).Tag] := prDlgColor.Color;
    btnApplyClick(btnApply);
  end;
end;

procedure TQUB_QVO_QVS_PropertiesForm.panColorFrameClick(Sender: TObject);
begin
  inherited;
  prDlgColor.Color := ColorFrame;
  if prDlgColor.Execute then begin
    ColorFrame := prDlgColor.Color;
    btnApplyClick(btnApply);
  end;
end;

//Channel Index
procedure TQUB_QVO_QVS_PropertiesForm.udChannelIndexClick(Sender: TObject; Button: TUDBtnType);
begin
  inherited;
  ChannelIndex := TUpDown(Sender).Position;
end;

//ShowMinMax
procedure TQUB_QVO_QVS_PropertiesForm.chkShowMinMaxClick(Sender: TObject);
begin
  inherited;
  if ShowMinMax <> TCheckBox(Sender).Checked then begin
    ShowMinMax := TCheckBox(Sender).Checked;
    btnApplyClick(btnApply);
  end;
end;

//DrawRMS
procedure TQUB_QVO_QVS_PropertiesForm.chkDrawRMSClick(Sender: TObject);
begin
  inherited;
  if DrawRMS <> TCheckBox(Sender).Checked then begin
    DrawRMS := TCheckBox(Sender).Checked;
    btnApplyClick(btnApply);
  end;
end;

//DrawAllPoints
procedure TQUB_QVO_QVS_PropertiesForm.chkDrawAllPointsClick(Sender: TObject);
begin
  inherited;

  if DrawAllPoints <> TCheckBox(Sender).Checked then begin
    DrawAllPoints := TCheckBox(Sender).Checked;
    btnApplyClick(btnApply);
  end;
end;

//RefreshFrequency
procedure TQUB_QVO_QVS_PropertiesForm.txtXResolutionKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtXResolutionExit(Sender);
  end;
end;

procedure TQUB_QVO_QVS_PropertiesForm.txtXResolutionExit(Sender: TObject);
var
  x :Extended;
begin
  inherited;
  try
    x := StrToFloat(TEdit(Sender).Text);
    if ((x < MAX_XRESOLUTION) or (x > MIN_XRESOLUTION)) then raise Exception.Create('');
  except
    MessageDlg('Invalid value; must be between ' + FloatToStr(MAX_XRESOLUTION) + ' and ' + FloatToStr(MIN_XRESOLUTION), mtError, [mbOK], 0);
    TEdit(Sender).Text := FloatToStr(XRESOLUTION);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if x <> XResolution then begin
    XResolution := x;
    btnApplyClick(btnApply);
  end;
end;

//Offset
procedure TQUB_QVO_QVS_PropertiesForm.txtOffsetKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtOffsetExit(Sender);
  end;
end;

procedure TQUB_QVO_QVS_PropertiesForm.txtOffsetExit(Sender: TObject);
var
  o :Double;
begin
  inherited;
  try
    o := StrToFloat(TEdit(Sender).Text) / 1000;
    if ((o < MIN_OFFSET) or (o > MAX_OFFSET)) then raise Exception.Create('');
  except
    MessageDlg('Invalid value; must be between ' + FloatToStr(MIN_OFFSET*1000) + ' and ' + FloatToStr(MAX_OFFSET*1000), mtError, [mbOK], 0);
    Offset[ChannelIndex] := Offset[ChannelIndex];
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if o <> Offset[ChannelIndex] then begin
    Offset[ChannelIndex] := o;
    btnApplyClick(btnApply);
  end;
end;

//Display
procedure TQUB_QVO_QVS_PropertiesForm.chkDisplayClick(Sender: TObject);
begin
  inherited;
  if Display[ChannelIndex] <> TCheckBox(Sender).Checked then begin
    Display[ChannelIndex] := TCheckBox(Sender).Checked;
    btnApplyClick(btnApply);
  end;
end;

//Filter
procedure TQUB_QVO_QVS_PropertiesForm.chkFilterOnClick(Sender: TObject);
begin
  inherited;
  if FilterOn <> TCheckBox(Sender).Checked then begin
    FilterOn := TCheckBox(Sender).Checked;
    btnApplyClick(btnApply);
  end;
end;

procedure TQUB_QVO_QVS_PropertiesForm.txtFilterPtsKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then begin
    Key := #0;
    txtFilterPtsExit(Sender);
  end;
end;

procedure TQUB_QVO_QVS_PropertiesForm.txtFilterPtsExit(Sender: TObject);
var
  Pts :Integer;
begin
  try
    Pts := (StrToInt(TEdit(Sender).Text) div 2) * 2 + 1;
    if ((Pts < MIN_FILTERPTS) or (Pts > MAX_FILTERPTS)) then raise Exception.Create('');
  except
    MessageDlg('Invalid value; must be between ' + IntToStr(MIN_FILTERPTS) + ' and ' + IntToStr(MAX_FILTERPTS), mtError, [mbOK], 0);
    FilterPts := FilterPts;
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if Pts <> FilterPts then begin
    FilterPts := Pts;
    btnApplyClick(btnApply);
  end;
end;


//******************************************************************************
end.



