{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
// QUB Visual Spectrum properties form


unit QUB_QVO_QVSpectrum_Properties;


interface


uses


Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ComCtrls, StdCtrls, ExtCtrls, Buttons,
QUB_QVO_QVD_Global, QUB_Global, QUB_QVO_Properties,
QUB_QFS_QDF_Global, QUB_Interface_Button;


type


TQUB_QVO_QVSpectrum_PropertiesForm = class(TQUB_QVO_PropertiesForm)


  Label1                    :TLabel;
  Label2                    :TLabel;
  Label3                    :TLabel;
  Label4                    :TLabel;
  Label5                    :TLabel;
  Label7                    :TLabel;
  Label27                   :TLabel;
  Label26                   :TLabel;
  Label22                   :TLabel;
  Label25                   :TLabel;
  Label24                   :TLabel;
  Label23                   :TLabel;
  Label21                   :TLabel;
  Label20                   :TLabel;

  panColorBack              :TPanel;
  panColorFrame             :TPanel;
  panColor                  :TPanel;
  panColorText              :TPanel;
  panColorData0             :TPanel;
  panColorData1             :TPanel;
  panColorData2             :TPanel;
  panColorData3             :TPanel;
  panColorData4             :TPanel;
  panColorData5             :TPanel;
  panColorData6             :TPanel;
  panColorData7             :TPanel;


  procedure FormCreate(Sender: TObject);
  procedure FormDestroy(Sender: TObject);
  procedure FormShow(Sender: TObject);

  procedure panColorClick(Sender: TObject);
  procedure panColorBackClick(Sender: TObject);
  procedure panColorDataClick(Sender: TObject);
  procedure panColorFrameClick(Sender: TObject);
  procedure panColorTextClick(Sender: TObject);


protected


  prError                                 :Boolean;

  prDlgColor                              :TColorDialog;

  prColor                                 :TColor;
  prColorBack                             :TColor;
  prColorData                             :Array[0..7] of TColor;
  prColorFrame                            :TColor;
  prColorText                             :TColor;


  procedure prSetColor(c :TColor);
  procedure prSetColorBack(c :TColor);
  function prGetColorData(Index :Integer) :TColor;
  procedure prSetColorData(Index :Integer; c :TColor);
  procedure prSetColorFrame(c :TColor);
  procedure prSetColorText(c :TColor);


public


  property Color                          :TColor                read prColor                 write prSetColor;
  property ColorBack                      :TColor                read prColorBack             write prSetColorBack;
  property ColorData[Index :Integer]      :TColor                read prGetColorData          write prSetColorData;
  property ColorFrame                     :TColor                read prColorFrame            write prSetColorFrame;
  property ColorText                      :TColor                read prColorText             write prSetColorText;


end;


implementation


{$R *.DFM}


uses


QUB_QVO_QVSpectrum;


//Colors ***********************************************************************
procedure TQUB_QVO_QVSpectrum_PropertiesForm.prSetColor(c :TColor);
begin
  prColor := c;
  panColor.Color := prColor;
  prPropertyChanged := True;
end;

procedure TQUB_QVO_QVSpectrum_PropertiesForm.prSetColorBack(c :TColor);
begin
  prColorBack := c;
  panColorBack.Color := prColorBack;
  prPropertyChanged := True;
end;

procedure TQUB_QVO_QVSpectrum_PropertiesForm.prSetColorData(Index :Integer; c :TColor);
begin
  prColorData[Index] := c;
  case Index of
    0:panColorData0.Color := prColorData[Index];
    1:panColorData1.Color := prColorData[Index];
    2:panColorData2.Color := prColorData[Index];
    3:panColorData3.Color := prColorData[Index];
    4:panColorData4.Color := prColorData[Index];
    5:panColorData5.Color := prColorData[Index];
    6:panColorData6.Color := prColorData[Index];
    7:panColorData7.Color := prColorData[Index];
  end;//case
  prPropertyChanged := True;
end;

function TQUB_QVO_QVSpectrum_PropertiesForm.prGetColorData(Index :Integer) :TColor;
begin
  Result := prColorData[Index];
end;

procedure TQUB_QVO_QVSpectrum_PropertiesForm.prSetColorFrame(c :TColor);
begin
  prColorFrame := c;
  panColorFrame.Color := prColorFrame;
  prPropertyChanged := True;
end;

procedure TQUB_QVO_QVSpectrum_PropertiesForm.prSetColorText(c :TColor);
begin
  prColorText := c;
  panColorText.Color := prColorText;
  prPropertyChanged := True;
end;


//Events ***********************************************************************

//Form *************************************************************************
procedure TQUB_QVO_QVSpectrum_PropertiesForm.FormCreate(Sender: TObject);
begin
  inherited;
  prDlgColor := TColorDialog.Create(Self);
end;

procedure TQUB_QVO_QVSpectrum_PropertiesForm.FormDestroy(Sender: TObject);
begin
  try
    prDlgColor.Free;
  finally
    inherited;
  end;
end;

procedure TQUB_QVO_QVSpectrum_PropertiesForm.FormShow(Sender: TObject);
begin
  inherited;
end;


//Colors ***********************************************************************
procedure TQUB_QVO_QVSpectrum_PropertiesForm.panColorClick(Sender: TObject);
begin
  inherited;
  prDlgColor.Color := Color;
  if prDlgColor.Execute then begin
    Color := prDlgColor.Color;
    btnApplyClick(btnApply);
  end;
end;

procedure TQUB_QVO_QVSpectrum_PropertiesForm.panColorBackClick(Sender: TObject);
begin
  inherited;
  prDlgColor.Color := ColorBack;
  if prDlgColor.Execute then begin
    ColorBack := prDlgColor.Color;
    btnApplyClick(btnApply);
  end;
end;

procedure TQUB_QVO_QVSpectrum_PropertiesForm.panColorDataClick(Sender: TObject);
begin
  inherited;
  prDlgColor.Color := ColorData[TPanel(Sender).Tag];
  if prDlgColor.Execute then begin
    ColorData[TPanel(Sender).Tag] := prDlgColor.Color;
    btnApplyClick(btnApply);
  end;
end;

procedure TQUB_QVO_QVSpectrum_PropertiesForm.panColorFrameClick(Sender: TObject);
begin
  inherited;
  prDlgColor.Color := ColorFrame;
  if prDlgColor.Execute then begin
    ColorFrame := prDlgColor.Color;
    btnApplyClick(btnApply);
  end;
end;

procedure TQUB_QVO_QVSpectrum_PropertiesForm.panColorTextClick(Sender: TObject);
begin
  inherited;
  prDlgColor.Color := ColorText;
  if prDlgColor.Execute then begin
    ColorText := prDlgColor.Color;
    btnApplyClick(btnApply);
  end;
end;


//******************************************************************************
end.



