{

                               Qub Visual Trace
                                     unit


the high-res line at the bottom of Viewport:Data


(C) 2000 Lorin Milescu
}
{
/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}


//01-31-2000   Creation date

unit QUB_QVO_QVT;


interface


uses


Windows, SysUtils, Classes, Messages, Graphics, Controls, StdCtrls, Menus, Dialogs, Registry, Clipbrd, Forms,

AllocTypes, Alloc,

QUB_Node,
QUB_Global,
QUB_QVO_QVD_Global,
QUB_QVO,
QUB_QFS_File, QUB_QFS_Channels, QUB_QFS_QDF, QUB_QFS_QDF_Global,
QUB_Viewport,
QUB_Baseline,
QUB_Idealization,
QUB_FitCurves,
QUBFits,
QUBFits_Dialog;


type


//Draw Map
TQUB_QVO_QVT_DrawMap                           = record
  DrawRect                                     :TRect;
  TraceRect                                    :TRect;
  TraceRegn                                    :TRect;
  TraceWidth                                   :Integer;
  TraceHeight                                  :Integer;
  TraceHeightM                                 :Integer;
  TraceXFirst                                  :Integer;
  TraceXLast                                   :Integer;
  TraceDX                                      :Integer;
  TraceDY                                      :Integer;

  DrawRegion                                   :HRGN;
  DataRegion                                   :HRGN;
  CursorRegion                                 :HRGN;

  ActualDrawMode                               :TQUB_QVO_QVD_DrawMode;
  ActualDrawData                               :Boolean;
  ActualDrawPoints                             :Boolean;
  ActualDrawInverted                           :Integer;
  ActualTraceHeightM                           :Integer;
  ActualTraceVOffset                           :Integer;
  ActualYMin                                   :Integer;
  ActualYMax                                   :Integer;

  yAdd                                         :Integer;
end;


TQUB_QVO_QVT_ClipRgnMode = (CLIP_RGN_CREATE, CLIP_RGN_UPDATE, CLIP_RGN_DESTROY);


//Forward class declarations ***************************************************
TQUB_QVO_QVT                                   = class;


//Object
TQUB_QVO_QVT                                   = class(TQUB_QVO)
protected


  prDataSource                                 :TQUB_QVO;

  prDataObject                                 :TQUB_QFS_QDF;

  //Data
  prDataChannelCount                           :Integer;
  //prData                                       :TPMInteger;
  prData                                       :TQUB_QVO_QVD_PDataChannelDisplay;

  prDataDraw                                   :TQUB_FirstLast;
  prDataOffset                                 :Integer;
  prDataWindow                                 :TQUB_FirstLast;
  prDataSel                                    :TQUB_FirstLast;
  prDataCurr                                   :Integer;
  prDataOldCurr                                :Integer;
  prActiveChannel                              :Integer;

  prChannelVisible                             :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Boolean;
  prDataChannelName                            :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of String;
  prDataChannelScaling                         :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Double;
  prDataChannelOffset                          :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Double;
  prDataChannelUnits                           :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of String;

  //Graphics settings
  prXAxisTickCount                             :Integer;
  prYAxisTickCount                             :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Integer;

  prDataBaseline                               :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Integer;
  prBaselineNodes                              :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of TQUB_Baseline;

  //Data Markers
  prDataMarker                                 :Integer;
  prDataMarkers                                :TPADouble;
  prDataMarkersCh                              :TPAInteger;
  prDataMarkersCount                           :Integer;

  //Time Markers
  prDataTimeMarker                             :Integer;
  prDataTimeMarkers                            :TPADouble;
  prDataTimeMarkersCount                       :Integer;

  //Kinetic Parameters Markers
  prDataKinParamsMarker                        :Integer;
  prDataKinParamsMarkers                       :TPAInteger;
  prDataKinParamsMarkersPars                   :TArrayofString;
  prDataKinParamsMarkersNote                   :TArrayofString;
  prDataKinParamsMarkersCount                  :Integer;

  prOldHint                                    :String;

  prFitCurves                                  :TQUB_FitCurves;

  (*
  //Data to be overlapped
  prOverlapData                                :TPAInteger;
  prOverlapDataCount                           :Integer;
  prOverlapDataOffset                          :Integer;//set this when overlapping - use it.
  *)

  prFitData                                    :INode;
  prMustRedrawFit                              :Boolean;

  prHintCycle                                  :Integer;

  //Page settings
  prSelectable                                 :Boolean;
  prOverlapChannels                            :Boolean;
  prDrawMode                                   :TQUB_QVO_QVD_DrawMode;
  prDrawPoints                                 :Boolean;
  prDrawInverted                               :Boolean;
  prDrawRaster                                 :Boolean;
  prDrawLabels                                 :Boolean;
  prLabelsWidth                                :Integer;
  prLabelsHeight                               :Integer;
  prTraceVMargin                               :Integer;

  //Scale Bar
  prScaleBarSamples                            :Integer;
  prScaleBarADUnits                            :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Integer;
  //prScaleBarCount                              :TPoint;
  prScaleBarPixel                              :TPoint;

  prDataYMin                                   :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Integer;
  prDataYMax                                   :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Integer;
  prDataYFactor                                :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Double;

  prDrawItoG                                   :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Boolean;

  prDrawActiveThick                            :Boolean;

  prDrawBaseline                               :Boolean;
  prDrawBaselineNodes                          :Boolean;
  prDrawIdealized                              :Boolean;
  prDrawIdealizedAbove                         :Boolean;
  prDrawIdealizedColor                         :Boolean;
  prDrawListOverlapped                         :Boolean;
  prDrawParameters                             :Boolean;

  //Colors
  prColorData                                  :Array[0..7] of TColor;
  prColorSel                                   :TColor;
  prColorBreak                                 :TColor;
  prColorFrame                                 :TColor;
  prColorBaseline                              :TColor;
  prColorBaselineNodes                         :TColor;
  prColorIdealized                             :TColor;
  prColorIdealizedSel                          :TColor;
  prColorParameters                            :TColor;
  prColorCurr                                  :TColor;

  //Flags
  prSelMove                                    :TQUB_FirstLast;
  prWindowDrawMode                             :Boolean;
  prSelecting                                  :Boolean;
  prVMarkering                                 :Boolean;
  prTMarkering                                 :Boolean;
  prKMarkering                                 :Boolean;

  prMouse                                      :TPoint;
  prMouseSel                                   :TPoint;
  prKeyeing                                    :Boolean;
  prKeyCode                                    :Integer;

  prPrintDrawData                              :Boolean;
  prPrintDrawIDLData                           :Boolean;
  prPrintDrawBase                              :Boolean;
  prPrintDrawMode                              :TQUB_QVO_QVD_DrawMode;

  //Mapping
  prDrawMap                                    :TQUB_QVO_QVT_DrawMap;

  prPopUpMenu                                  :TPopUpMenu;

  prSampling                                   :Double;
  prScaling                                    :Double;

  //Events
  prOnChangeSel                                :TNotifyEvent;
  prOnEditPoint                                :TQUB_OnEditPointEvent;
  prOnChangeVMarker                            :TNotifyEvent;
  prOnChangeTMarker                            :TNotifyEvent;
  prOnChangeKMarker                            :TNotifyEvent;

  prOnBeforeDrawChannel                        :TQUB_OnDrawChannel;
  prOnAfterDrawChannel                         :TQUB_OnDrawChannel;
  prOnBeforeDrawIdlChannel                     :TQUB_OnDrawChannel;
  prOnAfterDrawIdlChannel                      :TQUB_OnDrawChannel;


  procedure prResetData;

  function prMouseToPoint(const p :TPoint) :Integer;

  //Markers
  procedure prMoveMarker(x, y: Integer);
  function prMarkering(Button: TMouseButton; Shift: TShiftState; X, Y: Integer) :Boolean;
  procedure prSetVMarkHint;

  //Time Markers
  procedure prMoveTimeMarker(x, y: Integer);
  function prTimeMarkering(Button: TMouseButton; Shift: TShiftState; X, Y: Integer) :Boolean;
  procedure prSortTimeMarkers;
  procedure prSetTMarkHint;

  //Kinetic Parameters Markers
  function prKinParamsMarkering(Button: TMouseButton; Shift: TShiftState; X, Y: Integer) :Boolean;
  procedure prSetKMarkHint;

  function prChangePoint(Up :Boolean) :Boolean;

  procedure prDoClipRegns(Mode :TQUB_QVO_QVT_ClipRgnMode);

  procedure prErase; override;
  procedure prDrawData;
  procedure prDrawDataSel;
  procedure prDrawDataSelDowning;
  procedure prDrawDataSelRunning;
  procedure prDrawDataSelKeyeing;

  function prPrint(Dlg :TPrintDialog) :Boolean; override;

  //Property setters

  //Colors
  procedure prSetColorData(Index :Integer; c :TColor);
  function  prGetColorData(Index :Integer) :TColor;
  procedure prSetColorSel(c :TColor);
  procedure prSetColorBreak(c :TColor);
  procedure prSetColorCurr(c :TColor);
  procedure prSetColorBaseline(c :TColor);
  procedure prSetColorBaselineNodes(c :TColor);
  procedure prSetColorIdealized(c :TColor);
  procedure prSetColorIdealizedSel(c :TColor);
  procedure prSetColorParameters(c :TColor);

  procedure prSetOverlapChannels(o :Boolean);
  procedure prSetDrawPoints(p :Boolean);
  procedure prSetDrawInverted(i :Boolean);
  procedure prSetDrawRaster(r :Boolean);
  procedure prSetDrawLabels(l :Boolean);
  procedure prSetDrawActiveThick(t :Boolean);
  procedure prSetDrawBaseline(b :Boolean);
  procedure prSetDrawBaselineNodes(b :Boolean);
  procedure prSetDrawIdealized(i :Boolean);
  procedure prSetDrawIdealizedAbove(a :Boolean);
  procedure prSetDrawIdealizedColor(c :Boolean);
  procedure prSetDrawListOverlapped(l :Boolean);
  procedure prSetDrawParameters(p :Boolean);
  procedure prSetDrawMode(m :TQUB_QVO_QVD_DrawMode);
  function  prGetScaleBarADUnits(Index :Integer): Integer;
  procedure prSetDataYMin(Index :Integer; m :Integer);
  function  prGetDataYMin(Index :Integer) :Integer;
  procedure prSetDataYMax(Index :Integer; m :Integer);
  function  prGetDataYMax(Index :Integer) :Integer;
  procedure prSetDataYFactor(Index :Integer; f :Double);
  function  prGetDataYFactor(Index :Integer) :Double;
  procedure prSetDrawItoG(Index :Integer; d :Boolean);
  function prGetDrawItoG(Index :Integer) :Boolean;
  procedure prSetChannelVisible(Index :Integer; b :Boolean);
  function  prGetChannelVisible(Index :Integer) :Boolean;
  procedure prSetDataChannelName(Index :Integer; x :String);
  function prGetDataChannelName(Index :Integer): String;
  procedure prSetDataChannelUnits(Index :Integer; x :String);
  function prGetDataChannelUnits(Index :Integer): String;
  procedure prSetDataChannelScaling(Index :Integer; x :Double);
  function prGetDataChannelScaling(Index :Integer): Double;
  procedure prSetDataChannelOffset(Index :Integer; x :Double);
  function prGetDataChannelOffset(Index :Integer): Double;
  procedure prSetXAxisTickCount(c :Integer);
  function prGetXAxisTickCount: Integer;
  procedure prSetYAxisTickCount(Index :Integer; c :Integer);
  function prGetYAxisTickCount(Index :Integer): Integer;
  procedure prSetDataBaseline(Index :Integer; b :Integer);
  function  prGetDataBaseline(Index :Integer) :Integer;
  function  prGetBaselineNodes(Ix :Integer): TQUB_Baseline;
  procedure prSetBaselineNodes(Ix :Integer; x :TQUB_Baseline);

  procedure prSetDataCurr(c :Integer);

  procedure prSetPopUpMenu(p :TPopUpMenu);

  procedure prOnCurvesChanged(Sender :TObject);    // prFitter (curve fitting) has new curves to copy into FitCurves

  //Event procedures
  procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
  procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;

  procedure CNKeyDown(var Message: TWMKeyDown); message CN_KEYDOWN;

  function New(const FileName :String) :Boolean; override;
  function Open(const FileName :String) :Boolean; override;
  function Open(const FileName :String; OpenStream :TStream) :Boolean; override;
  function Save(const FileName :String) :Boolean; override;
  function Close :Boolean; override;
  function OpenFromString(const MemFile :String) :Boolean; override;
  function SaveToString(var MemFile :String; FileType :Integer) :Boolean; override;


public


  constructor Create(AOwner :TComponent); override;
  destructor Destroy; override;

  
  function Print :Boolean; override;

  procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;

  procedure Paint; override;

  procedure UpdateData;
  procedure Erase;
  function Draw :Boolean; override;

  procedure DoOnFitCurvesChanged(Sender :TObject); // prFitCurves from whatever source need redraw

  procedure ShowFitDlog;
  procedure ShowFit(State :INode; ShowDlog :Boolean);
  procedure CopyFit;
  procedure DelFit;

  procedure SendToQtiPlot(Script :String);

  //Maps physical coordinates to trace coordinates
  function MapPhysToDrawCoord(PhysX, PhysY :Double; var DrawX, DrawY :Integer) :Boolean;

  //Return the selection
  function GetSelection :TQUB_FirstLast;


  //Programmatic properties ****************************************************
  property DataSource                          :TQUB_QVO               read prDataSource                write prDataSource;

  property DataObject                          :TQUB_QFS_QDF           read prDataObject                write prDataObject;

  //property Data                                :TPMInteger             read prData                      write prData;
  property Data                                :TQUB_QVO_QVD_PDataChannelDisplay read prData            write prData;
  property DataDraw                            :TQUB_FirstLast         read prDataDraw                  write prDataDraw;
  property DataWindow                          :TQUB_FirstLast         read prDataWindow                write prDataWindow;
  property DataSel                             :TQUB_FirstLast         read prDataSel                   write prDataSel;
  property DataCurr                            :Integer                read prDataCurr                  write prSetDataCurr;
  property DataChannelCount                    :Integer                read prDataChannelCount          write prDataChannelCount;
  property DataOffset                          :Integer                read prDataOffset                write prDataOffset;
  property ActiveChannel                       :Integer                read prActiveChannel             write prActiveChannel;

  property FitCurves                           :TQUB_FitCurves         read prFitCurves                 write prFitCurves;

  property ChannelVisible[Index :Integer]      :Boolean                read prGetChannelVisible         write prSetChannelVisible;
  property DataChannelName[Index :Integer]     :String                 read prGetDataChannelName        write prSetDataChannelName;
  property DataChannelUnits[Index :Integer]    :String                 read prGetDataChannelUnits       write prSetDataChannelUnits;
  property DataChannelScaling[Index :Integer]  :Double                 read prGetDataChannelScaling     write prSetDataChannelScaling;
  property DataChannelOffset[Index :Integer]   :Double                 read prGetDataChannelOffset      write prSetDataChannelOffset;

  //Graphics settings
  property XAxisTickCount                      :Integer                read prGetXAxisTickCount         write prSetXAxisTickCount;
  property YAxisTickCount[Index :Integer]      :Integer                read prGetYAxisTickCount         write prSetYAxisTickCount;

  property DataBaseline[Index :Integer]        :Integer                read prGetDataBaseline           write prSetDataBaseline;
  property BaselineNodes[Ix :Integer]          :TQUB_Baseline          read prGetBaselineNodes          write prSetBaselineNodes;

  //Markers
  property DataMarker                          :Integer                read prDataMarker                write prDataMarker;
  property DataMarkers                         :TPADouble              read prDataMarkers               write prDataMarkers;
  property DataMarkersCh                       :TPAInteger             read prDataMarkersCh             write prDataMarkersCh;
  property DataMarkersCount                    :Integer                read prDataMarkersCount          write prDataMarkersCount;

  //Time Markers
  property DataTimeMarker                      :Integer                read prDataTimeMarker            write prDataTimeMarker;
  property DataTimeMarkers                     :TPADouble              read prDataTimeMarkers           write prDataTimeMarkers;
  property DataTimeMarkersCount                :Integer                read prDataTimeMarkersCount      write prDataTimeMarkersCount;

  //Kinetic Parameters Markers
  property DataKinParamsMarker                 :Integer                read prDataKinParamsMarker       write prDataKinParamsMarker;
  property DataKinParamsMarkers                :TPAInteger             read prDataKinParamsMarkers      write prDataKinParamsMarkers;
  property DataKinParamsMarkersPars            :TArrayofString         read prDataKinParamsMarkersPars  write prDataKinParamsMarkersPars;
  property DataKinParamsMarkersNote            :TArrayofString         read prDataKinParamsMarkersNote  write prDataKinParamsMarkersNote;
  property DataKinParamsMarkersCount           :Integer                read prDataKinParamsMarkersCount write prDataKinParamsMarkersCount;

  //Colors
  property ColorData[Index :Integer]           :TColor                 read prGetColorData              write prSetColorData;
  property ColorSel                            :TColor                 read prColorSel                  write prSetColorSel;
  property ColorBreak                          :TColor                 read prColorBreak                write prSetColorBreak;
  property ColorBaseline                       :TColor                 read prColorBaseline             write prSetColorBaseline;
  property ColorBaselineNodes                  :TColor                 read prColorBaselineNodes        write prSetColorBaselineNodes;
  property ColorIdealized                      :TColor                 read prColorIdealized            write prSetColorIdealized;
  property ColorIdealizedSel                   :TColor                 read prColorIdealizedSel         write prSetColorIdealizedSel;
  property ColorParameters                     :TColor                 read prColorParameters           write prSetColorParameters;
  property ColorCurr                           :TColor                 read prColorCurr                 write prSetColorCurr;

  property OverlapChannels                     :Boolean                read prOverlapChannels           write prSetOverlapChannels;
  property DrawPoints                          :Boolean                read prDrawPoints                write prSetDrawPoints;
  property DrawInverted                        :Boolean                read prDrawInverted              write prSetDrawInverted;
  property DrawRaster                          :Boolean                read prDrawRaster                write prSetDrawRaster;
  property DrawLabels                          :Boolean                read prDrawLabels                write prSetDrawLabels;
  property DrawActiveThick                     :Boolean                read prDrawActiveThick           write prSetDrawActiveThick;
  property DrawBaseline                        :Boolean                read prDrawBaseline              write prSetDrawBaseline;
  property DrawBaselineNodes                   :Boolean                read prDrawBaselineNodes         write prSetDrawBaselineNodes;
  property DrawIdealized                       :Boolean                read prDrawIdealized             write prSetDrawIdealized;
  property DrawIdealizedAbove                  :Boolean                read prDrawIdealizedAbove        write prSetDrawIdealizedAbove;
  property DrawIdealizedColor                  :Boolean                read prDrawIdealizedColor        write prSetDrawIdealizedColor;
  property DrawParameters                      :Boolean                read prDrawParameters            write prSetDrawParameters;
  property DrawListOverlapped                  :Boolean                read prDrawListOverlapped        write prSetDrawListOverlapped;
  property DrawMode                            :TQUB_QVO_QVD_DrawMode  read prDrawMode                  write prSetDrawMode;

  //ScaleBar
  //property ScaleBarCount                       :TPoint                 read prScaleBarCount;
  property ScaleBarSamples                     :Integer                read prScaleBarSamples;
  property ScaleBarADUnits[Index :Integer]     :Integer                read prGetScaleBarADUnits;
  property ScaleBarPixel                       :TPoint                 read prScaleBarPixel;

  property DataYMin[Index :Integer]            :Integer                read prGetDataYMin               write prSetDataYMin;
  property DataYMax[Index :Integer]            :Integer                read prGetDataYMax               write prSetDataYMax;
  property DataYFactor[Index :Integer]         :Double                 read prGetDataYFactor            write prSetDataYFactor;

  property DrawItoG[Index :Integer]            :Boolean                read prGetDrawItoG               write prSetDrawItoG;
  //****************************************************************************

  property Scaling                             :Double                 read prScaling                   write prScaling;
  property Sampling                            :Double                 read prSampling                  write prSampling;
  //****************************************************************************

  property MustRedraw                          :Boolean                                                 write prMustRedraw;

  property WindowDrawMode                      :Boolean                read prWindowDrawMode            write prWindowDrawMode;                                 

  property PopUpMenu                           :TPopUpMenu                                              write prSetPopUpMenu;


  //Events
  property OnChangeSel                         :TNotifyEvent           read prOnChangeSel               write prOnChangeSel;
  property OnEditPoint                         :TQUB_OnEditPointEvent  read prOnEditPoint               write prOnEditPoint;
  property OnChangeVMarker                     :TNotifyEvent           read prOnChangeVMarker           write prOnChangeVMarker;
  property OnChangeTMarker                     :TNotifyEvent           read prOnChangeTMarker           write prOnChangeTMarker;
  property OnChangeKMarker                     :TNotifyEvent           read prOnChangeKMarker           write prOnChangeKMarker;

  property OnBeforeDrawChannel                 :TQUB_OnDrawChannel     read prOnBeforeDrawChannel       write prOnBeforeDrawChannel;
  property OnAfterDrawChannel                  :TQUB_OnDrawChannel     read prOnAfterDrawChannel        write prOnAfterDrawChannel;
  property OnBeforeDrawIdlChannel              :TQUB_OnDrawChannel     read prOnBeforeDrawIdlChannel    write prOnBeforeDrawIdlChannel;
  property OnAfterDrawIdlChannel               :TQUB_OnDrawChannel     read prOnAfterDrawIdlChannel     write prOnAfterDrawIdlChannel;


  //DrawMap
  property DrawMap                             :TQUB_QVO_QVT_DrawMap   read prDrawMap;


  //Print properties
  property PrintDrawData                       :Boolean                read prPrintDrawData             write prPrintDrawData;
  property PrintDrawIDLData                    :Boolean                read prPrintDrawIDLData          write prPrintDrawIDLData;
  property PrintDrawBase                       :Boolean                read prPrintDrawBase             write prPrintDrawBase;
  property PrintDrawMode                       :TQUB_QVO_QVD_DrawMode  read prPrintDrawMode             write prPrintDrawMode;


end;
//..............................................................................



procedure Register;



//******************************************************************************
implementation


uses


Math,

QUB_QtiPlot,
QUB_Console, QUB_Rich_Console,
QUB_Profiles,
QUB_QVO_QVD,
QUB_QFS,
QUB_ExpCond_Parameters;


//******************************************************************************
//                              TQUB_QVO_QVD
//******************************************************************************
constructor TQUB_QVO_QVT.Create(AOwner :TComponent);
begin
  inherited Create(AOwner);

  prDataMarker          := -1;
  prDataTimeMarker      := -1;
  prDataKinParamsMarker := -1;

  prSelectable          := True;

  prResetData;

  ShowHint              := False;
  prHintCycle           := 0;

  prDoClipRegns(CLIP_RGN_CREATE);

   //Flags
  prMustRedraw          := True;
end;

destructor TQUB_QVO_QVT.Destroy;
begin
  try

    prOnChangeSel := nil;

    prResetData;

    prDoClipRegns(CLIP_RGN_DESTROY);

  finally

    inherited;

  end;
end;


function TQUB_QVO_QVT.Print :Boolean;
begin
  Result := False;
end;



//****************************************************************************//
//                                                                            //
//                           D R A W   Methods                                //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVT.Paint;
var
  MustDraw          :Boolean;
begin
  if prDrawing then Exit;

  try
  
    MustDraw := prMustRedraw or prMustRedrawFit;
    prMustRedrawFit := False;

    if ((csDesigning in ComponentState) or MustDraw) then begin
      prMustRedraw     := False;
      if not prNoDraw then begin
      //This flag is used when setting many properties at once, to prevent drawing each time
        try
          prDrawCritSection.Acquire;
          Canvas.Lock;
          prBitmapCanvas.Lock;
          try
            if not prWindowDrawMode then begin
            //In WindowDrawMode, do NOT erase
              prErase;
            end;
            if prData <> nil then begin
              if prDataDraw.First <> prDataDraw.Last then begin
                prDrawData;
              end;
            end;
          except
          end;
        finally
          prBitmapCanvas.UnLock;
          Canvas.UnLock;
          prDrawCritSection.Release;
        end;
      end;
    end;

  finally

    inherited;

  end;
end;

function TQUB_QVO_QVT.prPrint(Dlg :TPrintDialog) :Boolean; 
begin
  Result := False;
end;

function TQUB_QVO_QVT.Draw :Boolean;
begin
  Result := False;
  prMustRedraw := True;
  Paint;
end;

procedure TQUB_QVO_QVT.UpdateData;
begin
  if prData = nil then begin
    prResetData;
  end;
end;


//Maps physical coordinates to trace coordinates
function TQUB_QVO_QVT.MapPhysToDrawCoord(PhysX, PhysY :Double; var DrawX, DrawY :Integer) :Boolean;
begin

  Result := False;

  with prDrawMap do begin

    DrawX := Round(((PhysX {- TraceXFirst})             * TraceWidth)             / (TraceDx) + TraceRect.Left);
    DrawY := Round(((ActualDrawInverted * PhysY + yAdd) * ActualTraceHeightM + 1) / (TraceDy) + ActualTraceVOffset);

    //TO DO: check it with DrawYFactors

  end;

end;

procedure TQUB_QVO_QVT.prDoClipRegns(Mode :TQUB_QVO_QVT_ClipRgnMode);
begin

  with prDrawMap do begin

    if prDrawLabels then begin
      prLabelsWidth  := prBitmapCanvas.TextWidth('0000000.xxx') + 5 + 5;
      prLabelsHeight := prBitmapCanvas.TextHeight('H') + 5 + 5;
      prTraceVMargin := prLabelsHeight;
    end else begin
      prLabelsWidth  := 0;
      prLabelsHeight := 0;
      prTraceVMargin := QUB_QVO_QVD_TraceVMargin;
    end;

    TraceWidth          := prDrawWidth  - prMargin.Left - prLabelsWidth  - prMargin.Right  - 1  - prLabelsWidth div 2;
    TraceHeight         := prDrawHeight - prMargin.Top  - prLabelsHeight div 2 - prMargin.Bottom - 1;
    TraceHeightM        := TraceHeight  - 2 * prTraceVMargin;

    TraceRect.Left      := prMargin.Left + prLabelsWidth;// + prLabelsHeight;
    TraceRect.Right     := prDrawWidth  - prMargin.Right  - 1 - prLabelsWidth div 2;
    TraceRect.Top       := prMargin.Top;
    TraceRect.Bottom    := prDrawHeight - prMargin.Bottom - 1;// - prLabelsHeight;

    TraceRegn.Left      := prMargin.Left;
    TraceRegn.Right     := prDrawWidth  - prMargin.Right  - 1 - prLabelsWidth div 2;
    TraceRegn.Top       := prMargin.Top + prTraceVMargin;
    TraceRegn.Bottom    := prDrawHeight - prMargin.Bottom - 1 - prTraceVMargin - prLabelsHeight div 2;

    DrawRect.Left       := 0;
    DrawRect.Top        := 0;
    DrawRect.Right      := prDrawWidth  - 1;
    DrawRect.Bottom     := prDrawHeight - 1;

    if (Mode = CLIP_RGN_DESTROY) or (Mode = CLIP_RGN_UPDATE) then begin

      DeleteObject(CursorRegion);
      DeleteObject(DataRegion);
      DeleteObject(DrawRegion);

    end;

    if (Mode = CLIP_RGN_CREATE) or (Mode = CLIP_RGN_UPDATE) then begin

      DrawRegion        := CreateRectRgnIndirect(DrawRect);
      DataRegion        := CreateRectRgnIndirect(TraceRegn);
      CursorRegion      := CreateRectRgnIndirect(TraceRect);

    end;

  end;

end;



procedure TQUB_QVO_QVT.prDrawData;
var

  ChannelIndex        :Integer;
  PointIndex          :Integer;

  PrvX                :Integer;
  MinY                :Integer;
  MaxY                :Integer;
  MinYu, MaxYu        :Integer;//y unscaled (raw)

  MorePoints          :Boolean;

  VisChannelCount     :Integer;
  VisChannelIndex     :Integer;

  BaseSegs            :TList;
  BaseSeg             :TQUB_BaselineSeg;
  BaseFrom            :TQUB_BaselineSeg_Node;
  BaseTo              :TQUB_BaselineSeg_Node;
  BaseValid           :Boolean;

  ActualSel           :TQUB_FirstLast;

  x, x1, x2           :Integer;
  y, y1, y2           :Integer;

  yu                  :Integer;//y unscaled (raw)

  xp, yp              :Integer;

  p, n, s             :Integer;
  o                   :Boolean;

  ColorZone           :Integer;

  IdlFound            :Boolean;
  IdlDataSet          :INode;
  IdlSeg              :INode;
  Firsts              :TPAInteger;
  Lasts               :TPAInteger;
  Classes             :TPAInteger;
  DwellCount          :Integer;
  AmpCount            :Integer;
  Amp                 :TPADouble;
  iscal               :Double;
  jscal               :Integer;
  ioff                :Double;

  IdlIter             :TQUB_IdlSegmentsIter;
  F, L, C             :Integer;
  A                   :Double;

  CurveIter           :TQUB_FitCurveIter;
  CurveData           :TPAInteger;
  CurveSel            :TQUB_FirstLast;
  CurveOff            :Integer;

  IsDWT               :Boolean;

  cList               :TQUB_QVO_QVD_SelectionList;
  cSel                :TQUB_FirstLast;
  lIdx                :Integer;
  lSelected           :Integer;
  DataDisplay         :TQUB_QVO_QVD_DataChannelDisplay;
  DataDisplayDraw     :TQUB_FirstLast;
  DataDisplaySel      :TQUB_FirstLast;
  IsSel               :Boolean;

  Par                 :TQUB_ExpCond_PParameter;
  ActualDrawItoG      :Boolean;
  ActualDrawItoGD     :Integer;
  ActualDrawItoGCh    :Integer;
  ActualDrawItoGVrev  :Double;
  ActualDrawItoGV     :Double;
  ActualDrawItoGS     :Double;
  ActualDrawItoGO     :Double;

  ActualDrawTime      :Boolean;
  ActualDrawTimeCh    :Integer;
  ActualDrawTimeD     :Double;
  ActualDrawTimeMin   :Double;
  ActualDrawTimeMax   :Double;
  ActualDrawTimeT     :Double;
  ActualDrawTimeS     :Double;
  ActualDrawTimeO     :Double;

  FactorSum           :Double;
  ActualTraceHeightMF :Integer;
  SumActualTraceHeightMF:Integer;
  h, w                :Integer;

  LogFont             :TLogFont;
  OldFont             :TLogFont;

  LabelDrawCount      :Integer;
  LabeledClipRgn      :HRGN;

  procedure SetTraceWindow;
  begin
    with prDrawMap do begin
      if not prOverlapChannels then begin
        ActualTraceHeightMF := Round(ActualTraceHeightM * prDataYFactor[ChannelIndex] / (FactorSum / VisChannelCount));
        if prDrawIdealizedAbove then begin
          //ActualTraceVOffset := TraceRect.Top + prTraceVMargin + ActualTraceHeightMF + Round(VisChannelIndex * (2*ActualTraceHeightM + prTraceVMargin));
          ActualTraceVOffset := TraceRect.Top + prTraceVMargin + ActualTraceHeightMF + SumActualTraceHeightMF;
        end else begin
          //ActualTraceVOffset := TraceRect.Top + prTraceVMargin + Round(VisChannelIndex * (ActualTraceHeightM + prTraceVMargin));
          //ActualTraceVOffset := TraceRect.Top + prTraceVMargin + Round(VisChannelIndex * (((TraceHeightM - (VisChannelCount - 1)*prTraceVMargin) / VisChannelCount) + prTraceVMargin));
          ActualTraceVOffset := TraceRect.Top + prTraceVMargin + SumActualTraceHeightMF;
        end;
      end else begin
        ActualTraceHeightMF := ActualTraceHeightM;
        if prDrawIdealizedAbove then begin
          ActualTraceVOffset := TraceRect.Top + prTraceVMargin + ActualTraceHeightM;
        end else begin
          ActualTraceVOffset := TraceRect.Top + prTraceVMargin;
        end;
      end;
      if prDrawIdealizedAbove then begin
        SumActualTraceHeightMF := SumActualTraceHeightMF + 2*ActualTraceHeightMF + prTraceVMargin;
      end else begin
        SumActualTraceHeightMF := SumActualTraceHeightMF +   ActualTraceHeightMF + prTraceVMargin;
      end;
    end;
  end;

begin

  if prDrawing then Exit;

  try


    prDoClipRegns(CLIP_RGN_UPDATE);

    prDrawCritSection.Acquire;


    prDrawing := True;
    try


      with prDrawMap do begin

        IsDWT := (DataObject.FileType = QFS_QDF_TYPE_DWT) or (DataObject.FileType = QFS_QDF_TYPE_EVL) or (DataObject.FileType = QFS_QDF_TYPE_PRT) or (DataObject.FileType = QFS_QDF_TYPE_QSF);

        //Trace settings .............................................................
        TraceDx             := prDataDraw.Last - prDataDraw.First;
        if TraceDx = 0 then Exit;

        prBitmapCanvas.Pen.Style := psSolid;
        if prDrawForPrinting then begin
          prBitmapCanvas.Pen.Width := prPrintPenWidth;
        end else begin
          prBitmapCanvas.Pen.Width := 0;
        end;

        TraceXFirst         := prDataDraw.First;
        TraceXLast          := prDataDraw.Last;

        MorePoints          := (TraceDx > (3 * TraceWidth));

        //Actual settings ............................................................
         ActualSel           := prDataSel;
        if ActualSel.First = ActualSel.Last then begin
          if prDrawListOverlapped then begin
            ActualSel.First   := - 1;
            ActualSel.Last    := - 1;
          end else begin
            ActualSel.First   := prDataDraw.First - 1;
            ActualSel.Last    := prDataDraw.First - 1;
          end;
        end;

        VisChannelCount   := 0;
        FactorSum         := 0;
        for ChannelIndex := 0 to prDataChannelCount - 1 do begin
          if ChannelVisible[ChannelIndex] then begin
            VisChannelCount := VisChannelCount + 1;
            if prDataYFactor[ChannelIndex] <= 0 then prDataYFactor[ChannelIndex] := 1;
            FactorSum := FactorSum + prDataYFactor[ChannelIndex];
          end;
        end;


        if prOverlapChannels then begin
          ActualTraceHeightM := TraceHeightM;
        end else begin
          //ActualTraceHeightM := TraceHeightM div Max(1,VisChannelCount);
          if VisChannelCount > 0 then begin
            ActualTraceHeightM := (TraceHeightM - (VisChannelCount - 1)*prTraceVMargin) div VisChannelCount;
          end else begin
            ActualTraceHeightM := TraceHeightM;
          end;
        end;
        if prDrawIdealizedAbove then begin
          ActualTraceHeightM := ActualTraceHeightM div 2;
        end;
        if ActualTraceHeightM = 0 then ActualTraceHeightM := 1;


        //New from John&Chris
        //Scaling Bar **************************************************************
        for ChannelIndex := 0 to prDataChannelCount - 1 do begin
          prScaleBarADUnits[ChannelIndex] := Abs(DataYMax[ChannelIndex] - DataYMin[ChannelIndex]);
          if prScaleBarADUnits[ChannelIndex] = 0 then prScaleBarADUnits[ChannelIndex] := 1;
          //prScaleBarCount.y := Abs(DataYMax[ActiveChannel] - DataYMin[ActiveChannel]);
        end;
        prScaleBarPixel.y := ActualTraceHeightM;
        prScaleBarSamples := TraceDx;
        //prScaleBarCount.x := TraceDx;
        prScaleBarPixel.x := TraceWidth;
        //**************************************************************************


        if (prDrawMode = DRAWMODE_SLOW)  or
           //Slow Draw - draw every point
           ((prDrawMode = DRAWMODE_NORM) and (not MorePoints)) or
           //Slow Draw - Norm Draw, but less points than pixels - draw every point
           ((prDrawMode = DRAWMODE_FAST) and (not MorePoints)) then begin
           //Slow Draw - Fast Draw, but less points than pixels - draw every point
          ActualDrawMode := DRAWMODE_SLOW;
        end else if ((prDrawMode = DRAWMODE_NORM) and (MorePoints)) then begin
           //Norm Draw
          ActualDrawMode := DRAWMODE_NORM;
        end else if ((prDrawMode = DRAWMODE_FAST) and (MorePoints)) then begin
           //Fast Draw
          ActualDrawMode := DRAWMODE_FAST;
        end else begin
          ActualDrawMode := prDrawMode;
        end;

        if prDrawForPrinting then ActualDrawMode := prPrintDrawMode;

        if (prDrawPoints) and (TraceDx < (TraceWidth div 6)) then begin
          ActualDrawPoints := True;
        end else begin
          ActualDrawPoints := False;
        end;

        if prDrawInverted then ActualDrawInverted := -1 else ActualDrawInverted := 1;


        ActualDrawData     := True;

        if prDrawRaster then begin
          ActualDrawData   := False;
          ActualDrawPoints := False;
        end;


        ActualDrawItoG := False;
        //TO DO: For the time being, it's turned on by the presence of "ItoG" par in ExpCond, until Chris and John fix it. LM
        //for ChannelIndex := 0 to prDataChannelCount - 1 do begin
        //  if DrawItoG[ChannelIndex] then ActualDrawItoG := True;
        //  Break;
        //end;
        Par := TQUB_QVO_QVD(prDataSource).ExpCond.ParameterByName['ItoG'];
        if Par <> nil then begin
          ActualDrawItoG  := True;
          ActualDrawItoGD := Round(Par.Value);
        end;
        if ActualDrawItoG then begin
          ActualDrawItoG := False;
          Par := TQUB_QVO_QVD(prDataSource).ExpCond.ParameterByName['Vrev'];
          if Par <> nil then begin
            ActualDrawItoGVrev := Par.Value;
            Par := TQUB_QVO_QVD(prDataSource).ExpCond.ParameterByName['Voltage'];
            if Par <> nil then begin
              ActualDrawItoGCh := Par.Channel;
              if Par.Channel = -1 then begin
                ActualDrawItoGV := Par.Value;
                ActualDrawItoGS := 1;
                ActualDrawItoGO := 0;
              end else begin
                // why not (Scaling * DataChannelScaling[ActualDrawItoGCh]) or its inverse?
                // was: ActualDrawItoGS := Scaling / DataChannelScaling[ActualDrawItoGCh];
                ActualDrawItoGS := Scaling * DataChannelScaling[ActualDrawItoGCh];
                ActualDrawItoGO := DataChannelOffset[ActualDrawItoGCh];
              end;
              ActualDrawItoG := True;
            end;
          end;
        end;


        ActualDrawTime := False;
        //TO DO: For the time being, it's turned on by the presence of "TimeCh" par in ExpCond, until Chris and John fix it. LM
        Par := TQUB_QVO_QVD(prDataSource).ExpCond.ParameterByName['TimeCh'];
        if Par <> nil then begin
          ActualDrawTimeCh := Round(Par.Value);
          if (ActualDrawTimeCh >= 0) and (ActualDrawTimeCh < prDataChannelCount) then begin
            ActualDrawTime  := True;
            ActualDrawTimeS := 1 / (Scaling * DataChannelScaling[ActualDrawTimeCh]);
            ActualDrawTimeO := DataChannelOffset[ActualDrawTimeCh];
          end;
        end;


        ColorZone       := 0;


        if prDrawListOverlapped then begin


        //********************************************************************//
        //                                                                    //
        //           Draw the current list with overlapped selections         //
        //                                                                    //
        //********************************************************************//

          DataDisplay     := TQUB_QVO_QVD(prDataSource).DataChannelDisplay;
          DataDisplayDraw := TQUB_QVO_QVD(prDataSource).DataDraw;
          DataDisplaySel  := TQUB_QVO_QVD(prDataSource).DataSel;

          cList := TQUB_QVO_QVD(prDataSource).CurrList;
          if cList <> nil then begin

            cList.Lock;

            try

              LabelDrawCount := 0;
              //Loop twice, first draw the non-selected, then the selected traces
              for lSelected := 1 to 2 do begin

                //Draw each selection
                for lIdx := 0 to cList.Items.Count - 1 do begin

                  IsSel := cList.Selected[lIdx];
                  if (lSelected = 1) and (IsSel)     then Continue;
                  if (lSelected = 2) and (not IsSel) then Continue;

                  cSel.First := Min(cList.Selection[lIdx].Sel.First + DataDisplaySel.First, cList.Selection[lIdx].Sel.Last);
                  //cSel.Last  := cList.Selection[lIdx].Sel.Last  + DataDisplaySel.First;
                  cSel.Last  := Min(cList.Selection[lIdx].Sel.First + DataDisplaySel.Last,  cList.Selection[lIdx].Sel.Last);
                  if (cSel.First > DataDisplayDraw.Last) or (cSel.Last < DataDisplayDraw.First) then Continue;

                  if cSel.First < DataDisplayDraw.First then cSel.First := DataDisplayDraw.First;
                  if cSel.Last  > DataDisplayDraw.Last  then cSel.Last  := DataDisplayDraw.Last;

                  //Calculate boundaries of the current selection
                  TraceXFirst := cSel.First;
                  TraceXLast  := cSel.Last;

                  //ActualTraceXFirst := TraceXFirst;
                  //ActualTraceXLast  := TraceXLast;

                  //New
                  if ActualDrawTime then begin
                    ActualDrawTimeMin := DataDisplay[ActualDrawTimeCh, TraceXFirst - DataDisplayDraw.First] * ActualDrawTimeS + ActualDrawTimeO;
                    ActualDrawTimeMax := DataDisplay[ActualDrawTimeCh, TraceXLast  - DataDisplayDraw.First] * ActualDrawTimeS + ActualDrawTimeO;
                    ActualDrawTimeD   := ActualDrawTimeMax - ActualDrawTimeMin;
                  end;


                  SumActualTraceHeightMF := 0;

                  //Channel Loop
                  VisChannelIndex := -1;
                  for ChannelIndex := 0 to prDataChannelCount - 1 do begin

                    if not ChannelVisible[ChannelIndex] then Continue;
                    VisChannelIndex := VisChannelIndex + 1;

                    ActualYMin := DataYMin[ChannelIndex];
                    ActualYMax := DataYMax[ChannelIndex];

                    TraceDy    := DataYMin[ChannelIndex] - DataYMax[ChannelIndex];
                    if TraceDy = 0 then TraceDy := 1;//in case all the points have the same y

                    if prDrawInverted then begin
                      yAdd :=  ActualYMin;
                    end else begin
                      yAdd := -ActualYMax;
                    end;

                    SetTraceWindow;

                    if prDrawLabels then begin
                    //Draw labels
                      //Select clip region
                      SelectClipRgn(prBitmapCanvas.Handle, DrawRegion);
                      if (prDrawForPrinting) then begin
                      //Printing B/W
                        prBitmapCanvas.Font.Color  := clBlack;
                        prBitmapCanvas.Font.Size   := prPrintFontSize;
                        prBitmapCanvas.Pen.Color   := clBlack;
                      end else if prOverlapChannels then begin
                        prBitmapCanvas.Font.Color  := ColorData[ActiveChannel];
                        prBitmapCanvas.Font.Size   := 8;
                        prBitmapCanvas.Pen.Color   := ColorData[ActiveChannel];
                      end else begin
                        prBitmapCanvas.Font.Color  := ColorData[ChannelIndex];
                        prBitmapCanvas.Font.Size   := 8;
                        prBitmapCanvas.Pen.Color   := ColorData[ChannelIndex];
                      end;
                      prBitmapCanvas.Font.Style  := [];
                      prBitmapCanvas.Font.Name   := 'Arial';
                      prBitmapCanvas.Brush.Style := bsClear;

                      GetObject(prBitmapCanvas.Font.Handle, SizeOf(OldFont), @OldFont);
                      GetObject(prBitmapCanvas.Font.Handle, SizeOf(LogFont), @LogFont);
                      with LogFont do begin
                        lfEscapement   := 90 * 10;
                        lfOrientation  := 90 * 10;
                        //lfOutPrecision := OUT_TT_ONLY_PRECIS;
                        //lfFaceName     := 'Arial';
                        //lfHeight       := Font.Height;
                        //lfWeight       := FW_NORMAL;
                        //lfQuality      := PROOF_QUALITY;
                      end;

                      if (prOverlapChannels and (ChannelIndex = ActiveChannel)) or (not prOverlapChannels) then begin
                        prBitmapCanvas.MoveTo(TraceRect.Left, ActualTraceVOffset);
                        prBitmapCanvas.LineTo(TraceRect.Left, ActualTraceVOffset + ActualTraceHeightMF);
                        prBitmapCanvas.MoveTo(TraceRect.Left, ActualTraceVOffset + ActualTraceHeightMF);
                        prBitmapCanvas.LineTo(TraceRect.Right, ActualTraceVOffset + ActualTraceHeightMF);
                      end;

                      if LabelDrawCount = 0 then begin

                        if (prOverlapChannels and (ChannelIndex = ActiveChannel)) or (not prOverlapChannels) then begin
                          //YAxis
                          for x := 0 to prYAxisTickCount[ChannelIndex] do begin
                            prBitmapCanvas.MoveTo(TraceRect.Left,     ActualTraceVOffset + Round(x*ActualTraceHeightMF/prYAxisTickCount[ChannelIndex]));
                            prBitmapCanvas.LineTo(TraceRect.Left - 5, ActualTraceVOffset + Round(x*ActualTraceHeightMF/prYAxisTickCount[ChannelIndex]));
                            Text := Format('%2.4g', [prDataYMax[ChannelIndex]/(Scaling*DataChannelScaling[ChannelIndex]) - x/prYAxisTickCount[ChannelIndex]*(prDataYMax[ChannelIndex] - prDataYMin[ChannelIndex])/(Scaling*DataChannelScaling[ChannelIndex])]);
                            w := prBitmapCanvas.TextWidth(Text);
                            h := prBitmapCanvas.TextHeight(Text);
                            prBitmapCanvas.TextOut(TraceRect.Left - 8 - w, ActualTraceVOffset - h div 2 + Round(x*ActualTraceHeightMF/prYAxisTickCount[ChannelIndex]), Text);
                          end;
                        end;
                        //XAxis
                        for x := 0 to prXAxisTickCount do begin
                          prBitmapCanvas.MoveTo(TraceRect.Left + Round(x*(TraceRect.Right - TraceRect.Left)/prXAxisTickCount), ActualTraceVOffset + ActualTraceHeightMF);
                          prBitmapCanvas.LineTo(TraceRect.Left + Round(x*(TraceRect.Right - TraceRect.Left)/prXAxisTickCount), ActualTraceVOffset + ActualTraceHeightMF + 5);
                          if (VisChannelIndex + 1) = VisChannelCount then begin
                            Text := Format('%2.4g', [x*TraceDx*Sampling/prXAxisTickCount]);
                            w := prBitmapCanvas.TextWidth(Text);
                            h := prBitmapCanvas.TextHeight(Text);
                            prBitmapCanvas.TextOut(TraceRect.Left - w div 2 + Round(x*(TraceRect.Right - TraceRect.Left)/prXAxisTickCount), ActualTraceVOffset + ActualTraceHeightMF + 5, Text);
                          end;
                        end;
                        //XAxis label
                        Text := 'Time [s]';
                        w := prBitmapCanvas.TextWidth(Text);
                        h := prBitmapCanvas.TextHeight(Text);
                        prBitmapCanvas.TextOut(TraceRect.Left - w div 2 + (TraceRect.Right - TraceRect.Left) div 2, prDrawHeight - prMargin.Bottom - 5 - h, Text);
                        if (prOverlapChannels and (ChannelIndex = ActiveChannel)) or (not prOverlapChannels) then begin
                        //YAxis label
                          prBitmapCanvas.Font.Handle := CreateFontIndirect(LogFont);
                          Text := DataChannelName[ChannelIndex];
                          if DataChannelUnits[ChannelIndex] <> '' then Text := Text + ' [' + DataChannelUnits[ChannelIndex] + ']';
                          w := prBitmapCanvas.TextWidth(Text);
                          h := prBitmapCanvas.TextHeight(Text);
                          prBitmapCanvas.TextOut(prMargin.Left + 5, ActualTraceVOffset + ActualTraceHeightMF div 2 + w div 2, Text);
                          prBitmapCanvas.Font.Handle := CreateFontIndirect(OldFont);
                        end;

                      end;//LabelDrawCount

                    end;

                    //Select clip region
                    SelectClipRgn(prBitmapCanvas.Handle, DataRegion);

                    PointIndex := TraceXFirst;

                    //Color Change
                    if (prDrawForPrinting) and (prDrawBW) then begin
                    //Printing B/W
                      prBitmapCanvas.Pen.Color   := clBlack;
                      prBitmapCanvas.Brush.Color := clBlack;
                    end else begin
                      if ((PointIndex - cSel.First) >= ActualSel.First) and ((PointIndex - cSel.First) <= ActualSel.Last) then begin
                        if not IsSel then prBitmapCanvas.Pen.Color := prColorSel else prBitmapCanvas.Pen.Color := ColorData[ChannelIndex];
                        if ActualDrawPoints then begin
                          if not IsSel then prBitmapCanvas.Brush.Color := prColorSel else prBitmapCanvas.Brush.Color := ColorData[ChannelIndex];
                        end;
                        ColorZone := 1;//Selection Color
                      end else begin
                        if not IsSel then prBitmapCanvas.Pen.Color := ColorData[ChannelIndex] else prBitmapCanvas.Pen.Color := prColorSel;
                        if ActualDrawPoints then begin
                          if not IsSel then prBitmapCanvas.Brush.Color := ColorData[ChannelIndex] else prBitmapCanvas.Brush.Color := prColorSel;
                        end;
                        ColorZone := 0;//Normal Color
                      end;
                    end;

                    //BeforeDrawChannel
                    if Assigned(prOnBeforeDrawChannel) then begin
                      prOnBeforeDrawChannel(Self, ChannelIndex);
                    end;


                    if (IsSel) and (prDrawActiveThick) then begin
                      prBitmapCanvas.Pen.Width := 3;
                    end else begin
                      if prDrawForPrinting then begin
                        prBitmapCanvas.Pen.Width := prPrintPenWidth;
                      end else begin
                        prBitmapCanvas.Pen.Width := 0;
                     end;
                    end;

                    //Draw data
                    if ((prDrawForPrinting) and (prPrintDrawData)) or (not prDrawForPrinting) then begin

                      //MoveTo TraceXFirst
                      x  := TraceRect.Left;
                      //yu := prData[ChannelIndex, TraceXFirst];
                      yu := DataDisplay[ChannelIndex, TraceXFirst - DataDisplayDraw.First];

                      if ActualDrawTime then begin
                        x := Round(((DataDisplay[ActualDrawTimeCh, TraceXFirst - DataDisplayDraw.First] * ActualDrawTimeS + ActualDrawTimeO) - ActualDrawTimeMin) * TraceWidth / ActualDrawTimeD + TraceRect.Left);
                      end;

                      //New
                      if (ActualDrawItoG) and (ChannelIndex = ActualDrawItoGD{DrawItoG[ChannelIndex]}) then begin
                        if ActualDrawItoGCh <> -1 then begin
                          ActualDrawItoGV := DataDisplay[ActualDrawItoGCh, TraceXFirst - DataDisplayDraw.First] / ActualDrawItoGS + ActualDrawItoGO;
                        end;
                        if (ActualDrawItoGV - ActualDrawItoGVrev) <> 0 then yu := Round(yu / (ActualDrawItoGV - ActualDrawItoGVrev));
                      end;

                      y  := ((ActualDrawInverted * yu + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

                      if ActualDrawData then prBitmapCanvas.MoveTo(x, y);

                      if ActualDrawPoints then prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                      if prDrawRaster then begin
                        if yu > 0 then prBitmapCanvas.Rectangle(x, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, x + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
                      end;

                      PrvX    := x;
                      MinY    := y;
                      MaxY    := y;
                      MinYu   := yu;
                      MaxYu   := yu;

                      //PointLoop
                      for PointIndex := TraceXFirst + 1 to TraceXLast do begin

                        //Color Change
                        if (not prDrawForPrinting) or ((prDrawForPrinting) and (not prDrawBW)) then begin
                          if (PointIndex - cSel.First) = (ActualSel.First + 1) then begin
                            if ColorZone <> 1 then begin
                              if not IsSel then prBitmapCanvas.Pen.Color := prColorSel else prBitmapCanvas.Pen.Color := ColorData[ChannelIndex];
                              if ActualDrawPoints then begin
                                if not IsSel then prBitmapCanvas.Brush.Color := prColorSel else prBitmapCanvas.Brush.Color := ColorData[ChannelIndex];
                              end;
                              ColorZone := 1;
                            end;
                          end else if (PointIndex - cSel.First) = (ActualSel.Last + 1) then begin
                            if ColorZone <> 0 then begin
                              if not IsSel then prBitmapCanvas.Pen.Color := ColorData[ChannelIndex] else prBitmapCanvas.Pen.Color := prColorSel;
                              if ActualDrawPoints then begin
                                if not IsSel then prBitmapCanvas.Brush.Color := ColorData[ChannelIndex] else prBitmapCanvas.Brush.Color := prColorSel;
                              end;
                              ColorZone := 0;
                            end;
                          end;
                        end;

                        x  := ((PointIndex - TraceXFirst)       * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                        //yu := prData[ChannelIndex, PointIndex];
                        yu := DataDisplay[ChannelIndex, PointIndex - DataDisplayDraw.First];

                        if ActualDrawTime then begin
                          x := Round(((DataDisplay[ActualDrawTimeCh, PointIndex - DataDisplayDraw.First] * ActualDrawTimeS + ActualDrawTimeO) - ActualDrawTimeMin) * TraceWidth / ActualDrawTimeD + TraceRect.Left);
                        end;

                        //New
                        if (ActualDrawItoG) and (ChannelIndex = ActualDrawItoGD{DrawItoG[ChannelIndex]}) then begin
                          if ActualDrawItoGCh <> -1 then begin
                            ActualDrawItoGV := DataDisplay[ActualDrawItoGCh, PointIndex - DataDisplayDraw.First] / ActualDrawItoGS + ActualDrawItoGO;
                          end;
                          if (ActualDrawItoGV - ActualDrawItoGVrev) <> 0 then yu := Round(yu / (ActualDrawItoGV - ActualDrawItoGVrev));
                        end;

                        y  := ((ActualDrawInverted * yu + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;
                        case ActualDrawMode of
                          DRAWMODE_SLOW:
                            begin
                              //LineTo PointIndex
                              if ActualDrawData then prBitmapCanvas.LineTo(x, y);
                              if ActualDrawPoints then prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                              if prDrawRaster then begin
                                 if yu > 0 then prBitmapCanvas.Rectangle(x, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, x + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
                              end;
                            end;
                          DRAWMODE_NORM:
                            begin
                              if MinY > y then begin
                                MinY  := y;
                                MinYu := yu;
                              end;
                              if MaxY < y then begin
                                MaxY  := y;
                                MaxYu := yu;
                              end;
                              if x <> PrvX then begin
                                //LineTo PointIndex
                                if ActualDrawData then begin
                                  prBitmapCanvas.MoveTo(PrvX, MinY);
                                  prBitmapCanvas.LineTo(PrvX, MaxY + 1);
                                end;
                                if prDrawRaster then begin
                                  if (MaxYu > 0) or (MinYu > 0) then prBitmapCanvas.Rectangle(prvX, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, prvX + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
                                end;
                                PrvX  := x;
                                MinY  := y;
                                MaxY  := y;
                                MinYu := yu;
                                MaxYu := yu;
                              end;
                            end;
                          DRAWMODE_FAST:
                            begin
                              if x <> PrvX then begin
                                //LineTo PointIndex
                                if ActualDrawData then prBitmapCanvas.LineTo(x, y);
                                if ActualDrawPoints then prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                                if prDrawRaster then begin
                                  if yu > 0 then prBitmapCanvas.Rectangle(x, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, x + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
                                end;
                                PrvX := x;
                              end;
                            end;
                        end;//case ActualDrawMode

                      end;//PointIndex

                      //Draw the remaining points, if in Norm or Fast mode ...................
                      case ActualDrawMode of
                        DRAWMODE_NORM:
                          begin
                            if x = PrvX then begin
                              if ActualDrawData then begin
                                prBitmapCanvas.MoveTo(PrvX, MinY);
                                prBitmapCanvas.LineTo(PrvX, MaxY + 1);
                              end;
                              if prDrawRaster then begin
                                if MaxYu > 0 then prBitmapCanvas.Rectangle(x, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, x + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
                              end;
                            end;
                          end;
                        DRAWMODE_FAST:
                          begin
                            if x = PrvX then begin
                              if ActualDrawData then prBitmapCanvas.LineTo(x, y);
                              if ActualDrawPoints then prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                              if prDrawRaster then begin
                                if yu > 0 then prBitmapCanvas.Rectangle(x, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, x + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
                              end;
                            end;
                          end;
                      end;//case ActualDrawMode
                      //......................................................................

                      (*
                      //Draw current point
                      if (prDataCurr >= TraceXFirst) and (prDataCurr <= TraceXLast) then begin
                        if not prDrawForPrinting then begin
                          if not prDrawRaster then begin
                            x := ((prDataCurr - TraceXFirst)                                     * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                            y := ((ActualDrawInverted * prData[ChannelIndex, prDataCurr] + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;
                            prBitmapCanvas.Brush.Color := ColorCurr;
                            prBitmapCanvas.Pen.Color   := ColorCurr;
                            if ActualDrawPoints then begin
                              prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                            end else begin
                              prBitmapCanvas.MoveTo(x,     y);
                              prBitmapCanvas.LineTo(x + 1, y);
                            end;
                          end;
                        end;
                      end;//Draw current point
                      *)

                    end;

                    if prDrawForPrinting then begin
                      prBitmapCanvas.Pen.Width := prPrintPenWidth;
                    end else begin
                      prBitmapCanvas.Pen.Width := 0;
                    end;

                    if ((prDrawForPrinting) and (prPrintDrawBase)) or (not prDrawForPrinting) then begin

                      //Draw Markers
                      //if {(prDrawMarkers) and} (prDataMarkersCount > 0) then begin
                      if (prDataMarkersCount > 0) and (((prDrawForPrinting) and (prPrintDrawIDLData)) or (not prDrawForPrinting)) then begin
                        try
                          SelectClipRgn(prBitmapCanvas.Handle, DrawRegion);
                          if (prDrawForPrinting) and (prDrawBW) then begin
                            prBitmapCanvas.Pen.Color   := clBlack;
                            prBitmapCanvas.Brush.Color := clBlack;
                          end else begin
                            prBitmapCanvas.Pen.Color   := ColorCurr;
                            prBitmapCanvas.Brush.Color := ColorCurr;
                          end;
                          x1 := TraceRect.Left;//((TraceXFirst - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
                          x2 := TraceRect.Right + 1;//((TraceXLast  - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
                          for p := 0 to prDataMarkersCount - 1 do begin
                            if prDataMarkersCh[p] = ChannelIndex then begin
                              y := ((ActualDrawInverted * Round(Scaling * DataChannelScaling[ChannelIndex] * (prDataMarkers[p]-DataChannelOffset[ChannelIndex])) + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;
                              prBitmapCanvas.MoveTo(x1,     y);
                              prBitmapCanvas.LineTo(x2 - 1, y);
                              prBitmapCanvas.Polygon([Point(x2 - 1, y),
                                                      Point(x2 + 2, y - 3),
                                                      Point(x2 + 8, y - 3),
                                                      Point(x2 + 8, y + 3),
                                                      Point(x2 + 2, y + 3)]);
                            end;
                          end;
                        finally
                          SelectClipRgn(prBitmapCanvas.Handle, DataRegion);
                        end;
                      end;

                    end;


                    //AfterDrawChannel
                    if Assigned(prOnAfterDrawChannel) then begin
                      prOnAfterDrawChannel(Self, ChannelIndex);
                    end;


                  end;//ChannelIndex

                  LabelDrawCount := 1;

                end;//lIdx

              end;//lSelected;


              //Draw Curves only - they should be on top
              if ((prDrawForPrinting) and (prPrintDrawIdlData)) or (not prDrawForPrinting) then begin

                //Overlap Data *********************************************************
                if prDrawIdealized then begin

                  //Loop twice, first draw the non-selected, then the selected traces
                  for lSelected := 1 to 2 do begin

                    //Draw each selection
                    for lIdx := 0 to cList.Items.Count - 1 do begin

                      IsSel := cList.Selected[lIdx];
                      if (lSelected = 1) and (IsSel)     then Continue;
                      if (lSelected = 2) and (not IsSel) then Continue;

                      cSel.First := cList.Selection[lIdx].Sel.First + DataDisplaySel.First;
                      cSel.Last  := cList.Selection[lIdx].Sel.Last  + DataDisplaySel.First;
                      if (cSel.First > DataDisplayDraw.Last) or (cSel.Last < DataDisplayDraw.First) then Continue;

                      if cSel.First < DataDisplayDraw.First then cSel.First := DataDisplayDraw.First;
                      if cSel.Last  > DataDisplayDraw.Last  then cSel.Last  := DataDisplayDraw.Last;

                      //Calculate boundaries of the current selection
                      TraceXFirst := cSel.First;
                      TraceXLast  := cSel.Last;

                      //New
                      if ActualDrawTime then begin
                        ActualDrawTimeMin := DataDisplay[ActualDrawTimeCh, TraceXFirst - DataDisplayDraw.First] * ActualDrawTimeS + ActualDrawTimeO;
                        ActualDrawTimeMax := DataDisplay[ActualDrawTimeCh, TraceXLast  - DataDisplayDraw.First] * ActualDrawTimeS + ActualDrawTimeO;
                        ActualDrawTimeD   := ActualDrawTimeMax - ActualDrawTimeMin;
                      end;

                      SumActualTraceHeightMF := 0;


                      if (IsSel) and (prDrawActiveThick) then begin
                        prBitmapCanvas.Pen.Width := 3;
                      end else begin
                        if prDrawForPrinting then begin
                          prBitmapCanvas.Pen.Width := prPrintPenWidth;
                        end else begin
                          prBitmapCanvas.Pen.Width := 0;
                       end;
                      end;


                      //Channel Loop
                      VisChannelIndex := -1;
                      for ChannelIndex := 0 to prDataChannelCount - 1 do begin

                        if not ChannelVisible[ChannelIndex] then Continue;
                        VisChannelIndex := VisChannelIndex + 1;

                        //Select clip region
                        //SelectClipRgn(prBitmapCanvas.Handle, DataRegion);

                        ActualYMin := DataYMin[ChannelIndex];
                        ActualYMax := DataYMax[ChannelIndex];

                        TraceDy    := DataYMin[ChannelIndex] - DataYMax[ChannelIndex];
                        if TraceDy = 0 then TraceDy := 1;//in case all the points have the same y

                        if prDrawInverted then begin
                          yAdd :=  ActualYMin;
                        end else begin
                          yAdd := -ActualYMax;
                        end;

                        SetTraceWindow;
                        
                        (*
                        if prOverlapChannels then begin
                          ActualTraceVOffset := TraceRect.Top + prTraceVMargin;
                        end else begin
                          ActualTraceVOffset := TraceRect.Top + prTraceVMargin + Round(VisChannelIndex * TraceHeightM / VisChannelCount);
                        end;

                        if prDrawIdealizedAbove then begin
                          Inc(ActualTraceVOffset, ActualTraceHeightMF);
                        end;
                        *)


                        CurveIter    := nil;

                        //if prDrawIdealizedAbove then begin
                        //  Dec(ActualTraceVOffset, ActualTraceHeightMF);
                        //end;

                        //Select clip region
                        SelectClipRgn(prBitmapCanvas.Handle, DataRegion);


                        try

                          CurveIter    := FitCurves.Find(cSel.First);

                          if (ChannelIndex = ActiveChannel) and (not Boolean(CurveIter.Done)) then begin

                            if ((prDrawForPrinting) and (prPrintDrawIDLData{prPrintDrawData})) or (not prDrawForPrinting) then begin

                              while (not Boolean(CurveIter.Done)) and (CurveIter.Curve.First <= cSel.Last) do begin
                                CurveData       := CurveIter.Curve.Data;

                                CurveSel.First  := CurveIter.Curve.First;
                                CurveSel.Last   := CurveIter.Curve.Last;
                                CurveOff        := CurveIter.Curve.First;
                                if CurveSel.First < cSel.First then CurveSel.First := cSel.First;
                                if CurveSel.Last  > cSel.Last  then CurveSel.Last  := cSel.Last;

                                //MoveTo TraceXFirst
                                x := ((CurveSel.First - cSel.First)                                      * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                                y := ((ActualDrawInverted * CurveData[CurveSel.First - CurveOff] + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

                                if ActualDrawTime then begin
                                  x := Round(((DataDisplay[ActualDrawTimeCh, CurveSel.First - cSel.First] * ActualDrawTimeS + ActualDrawTimeO) - ActualDrawTimeMin) * TraceWidth / ActualDrawTimeD + TraceRect.Left);
                                end;


                                prBitmapCanvas.MoveTo(x, y);

                                if ActualDrawPoints then begin
                                  prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                                end;

                                PrvX    := x;
                                MinY    := y;
                                MaxY    := y;

                                PointIndex := CurveSel.First;

                                //Color Change
                                //if (prDrawForPrinting) and (prDrawBW) then begin
                                //Printing B/W
                                //  prBitmapCanvas.Pen.Color   := clBlack;
                                //  prBitmapCanvas.Brush.Color := clBlack;
                                //end else begin
                                  if ((PointIndex - cSel.First) >= ActualSel.First) and ((PointIndex - cSel.First) <= ActualSel.Last) then begin
                                    if not IsSel then prBitmapCanvas.Pen.Color := prColorIdealizedSel else prBitmapCanvas.Pen.Color := prColorIdealized;
                                    if ActualDrawPoints then begin
                                      if not IsSel then prBitmapCanvas.Brush.Color := prColorIdealizedSel else prBitmapCanvas.Brush.Color := prColorIdealized;
                                    end;
                                    ColorZone := 1;//Selection Color
                                  end else begin
                                    if not IsSel then prBitmapCanvas.Pen.Color := prColorIdealized else prBitmapCanvas.Pen.Color := prColorIdealizedSel;
                                    if ActualDrawPoints then begin
                                      if not IsSel then prBitmapCanvas.Brush.Color := prColorIdealized else prBitmapCanvas.Brush.Color := prColorIdealizedSel;
                                    end;
                                    ColorZone := 0;//Normal Color
                                  end;
                                //end;

                                //PointLoop
                                for PointIndex := CurveSel.First + 1 to CurveSel.Last do begin

                                  //Color Change
                                  //if (not prDrawForPrinting) or ((prDrawForPrinting) and (not prDrawBW)) then begin
                                    if (PointIndex - cSel.First) = (ActualSel.First + 1) then begin
                                      if ColorZone <> 1 then begin
                                        if not IsSel then prBitmapCanvas.Pen.Color := prColorIdealizedSel else prBitmapCanvas.Pen.Color := prColorIdealized;
                                        if ActualDrawPoints then begin
                                          if not IsSel then prBitmapCanvas.Brush.Color := prColorIdealizedSel else prBitmapCanvas.Brush.Color := prColorIdealized;
                                        end;
                                        ColorZone := 1;
                                      end;
                                    end else if (PointIndex - cSel.First) = (ActualSel.Last + 1) then begin
                                      if ColorZone <> 0 then begin
                                        if not IsSel then prBitmapCanvas.Pen.Color := prColorIdealized else prBitmapCanvas.Pen.Color := prColorIdealizedSel;
                                        if ActualDrawPoints then begin
                                          if not IsSel then prBitmapCanvas.Brush.Color := prColorIdealized else prBitmapCanvas.Brush.Color := prColorIdealizedSel;
                                        end;
                                        ColorZone := 0;
                                      end;
                                    end;
                                  //end;

                                  x := ((PointIndex - cSel.First)                                      * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                                  y := ((ActualDrawInverted * CurveData[PointIndex - CurveOff] + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

                                  if ActualDrawTime then begin
                                    x := Round(((DataDisplay[ActualDrawTimeCh, PointIndex - cSel.First] * ActualDrawTimeS + ActualDrawTimeO) - ActualDrawTimeMin) * TraceWidth / ActualDrawTimeD + TraceRect.Left);
                                  end;

                                  case ActualDrawMode of
                                    DRAWMODE_SLOW:
                                      begin
                                        //LineTo PointIndex
                                        prBitmapCanvas.LineTo(x, y);
                                        if ActualDrawPoints then begin
                                          prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                                        end;
                                      end;
                                    DRAWMODE_NORM:
                                      begin
                                        if MinY > y then MinY := y;
                                        if MaxY < y then MaxY := y;
                                        if x <> PrvX then begin
                                          //LineTo PointIndex
                                          prBitmapCanvas.MoveTo(PrvX, MinY);
                                          prBitmapCanvas.LineTo(PrvX, MaxY + 1);
                                          PrvX := x;
                                          MinY := y;
                                          MaxY := y;
                                        end;
                                      end;
                                    DRAWMODE_FAST:
                                      begin
                                        if x <> PrvX then begin
                                          //LineTo PointIndex
                                          prBitmapCanvas.LineTo(x, y);
                                          if ActualDrawPoints then begin
                                            prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                                          end;
                                          PrvX := x;
                                        end;
                                      end;
                                  end;//case ActualDrawMode

                                end;//PointIndex

                                //Draw the remaining points, if in Norm or Fast mode .........
                                case ActualDrawMode of
                                  DRAWMODE_NORM:
                                    begin
                                      if x = PrvX then begin
                                        prBitmapCanvas.MoveTo(PrvX, MinY);
                                        prBitmapCanvas.LineTo(PrvX, MaxY + 1);
                                      end;
                                    end;
                                  DRAWMODE_FAST:
                                    begin
                                      if x = PrvX then begin
                                        prBitmapCanvas.LineTo(x, y);
                                        if ActualDrawPoints then begin
                                          prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                                        end;
                                      end;
                                    end;
                                end;//case ActualDrawMode
                                //............................................................

                                CurveIter.Next;

                              end;

                            end;

                          end;//**************************************************************

                        finally

                          CurveIter.Free;

                        end;

                        //if prDrawIdealizedAbove then begin
                        //  Inc(ActualTraceVOffset, ActualTraceHeightMF);
                        //end;

                      end;//ChannelIndex

                    end;//lIdx

                  end;//lSelected;

                end;//Draw Idealized

              end;//if ((prDrawForPrinting) and (prPrintDrawData)) or (not prDrawForPrinting) then begin

              //DeleteObject(ViewRegion);



              //Cursor & Time Markers **********************************************
              //Erase old Cursor
              if not prDrawForPrinting then begin
                if (prDataOldCurr >= (TraceXFirst - cSel.First)) and (prDataOldCurr <= (TraceXLast - cSel.First)) then begin
                  SelectClipRgn(prBitmapCanvas.Handle, CursorRegion);
                  x := ((prDataOldCurr - (TraceXFirst - cSel.First)) * TraceWidth) div (TraceDx) + TraceRect.Left;
                  if ActualDrawTime then begin
                    x := Round(((DataDisplay[ActualDrawTimeCh, prDataOldCurr - (TraceXFirst - cSel.First)] * ActualDrawTimeS + ActualDrawTimeO) - ActualDrawTimeMin) * TraceWidth / ActualDrawTimeD + TraceRect.Left);
                  end;
                  prBitmapCanvas.Brush.Color := prColorBack;
                  prBitmapCanvas.Pen.Color   := prColorBack;
                  prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Top),        Point(x + 3, TraceRect.Top),        Point(x, TraceRect.Top        + (QUB_QVO_QVD_TraceVMargin - 1))]);
                  prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Bottom - 1), Point(x + 3, TraceRect.Bottom - 1), Point(x, TraceRect.Bottom - 1 - (QUB_QVO_QVD_TraceVMargin - 1))]);
                end;
              end;//Old Cursor

              //Draw Time Markers
              if (prDataTimeMarkersCount > 0) and (((prDrawForPrinting) and (prPrintDrawIDLData)) or (not prDrawForPrinting)) then begin
                SelectClipRgn(prBitmapCanvas.Handle, DrawRegion);
                if (prDrawForPrinting) and (prDrawBW) then begin
                  prBitmapCanvas.Pen.Color   := clBlack;
                  prBitmapCanvas.Brush.Color := clBlack;
                end else begin
                  prBitmapCanvas.Pen.Color   := ColorData[ActiveChannel];//Curr;
                  prBitmapCanvas.Brush.Color := ColorData[ActiveChannel];//Curr;
                end;
                y1 := TraceRect.Top;
                y2 := TraceRect.Bottom;
                for p := 0 to prDataTimeMarkersCount - 1 do begin
                  //if (Round(prDataTimeMarkers[p]) < (prDataOffset + TraceXFirst)) or (Round(prDataTimeMarkers[p]) > (prDataOffset + TraceXLast)) then Continue;
                  if (Round(prDataTimeMarkers[p]) < (TraceXFirst {- cSel.First})) or (Round(prDataTimeMarkers[p]) > (TraceXLast {- cSel.First})) then Continue;
                  x := ((Round(prDataTimeMarkers[p]) - (TraceXFirst {- cSel.First})) * TraceWidth) div (TraceDx) + TraceRect.Left;
                  if ActualDrawTime then begin
                    x := Round(((DataDisplay[ActualDrawTimeCh, Round(prDataTimeMarkers[p]) - (TraceXFirst {- cSel.First})] * ActualDrawTimeS + ActualDrawTimeO) - ActualDrawTimeMin) * TraceWidth / ActualDrawTimeD + TraceRect.Left);
                  end;
                  prBitmapCanvas.Pen.Style := psDot;
                  prBitmapCanvas.MoveTo(x, y1);
                  prBitmapCanvas.LineTo(x, y2);
                  prBitmapCanvas.Pen.Style := psSolid;
                  prBitmapCanvas.Polygon([Point(x - 3, y1),
                                          Point(x + 3, y1),
                                          Point(x,     y1 +     (QUB_QVO_QVD_TraceVMargin - 1))]);
                  prBitmapCanvas.Polygon([Point(x - 3, y2 - 1),
                                          Point(x + 3, y2 - 1),
                                          Point(x,     y2 - 1 - (QUB_QVO_QVD_TraceVMargin - 1))]);
                end;
              end;//Time Markers

              //Draw new Cursor
              if not prDrawForPrinting then begin
                if (prDataCurr >= (TraceXFirst - cSel.First)) and (prDataCurr <= (TraceXLast - cSel.First)) then begin
                  SelectClipRgn(prBitmapCanvas.Handle, CursorRegion);
                  x := ((prDataCurr - (TraceXFirst - cSel.First)) * TraceWidth) div (TraceDx) + TraceRect.Left;
                  if ActualDrawTime then begin
                    x := Round(((DataDisplay[ActualDrawTimeCh, prDataCurr - (TraceXFirst - cSel.First)] * ActualDrawTimeS + ActualDrawTimeO) - ActualDrawTimeMin) * TraceWidth / ActualDrawTimeD + TraceRect.Left);
                  end;
                  prBitmapCanvas.Brush.Color := prColorCurr;
                  prBitmapCanvas.Pen.Color   := prColorCurr;
                  prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Top),        Point(x + 3, TraceRect.Top),        Point(x, TraceRect.Top        + (QUB_QVO_QVD_TraceVMargin - 1))]);
                  prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Bottom - 1), Point(x + 3, TraceRect.Bottom - 1), Point(x, TraceRect.Bottom - 1 - (QUB_QVO_QVD_TraceVMargin - 1))]);
                end;
              end;//New Cursor


            finally
              cList.Unlock;
            end;

          end;//cList <> nil;


        end else begin


        //********************************************************************//
        //                                                                    //
        //                             Draw normal                            //
        //                                                                    //
        //********************************************************************//

          SumActualTraceHeightMF := 0;

          //Channel Loop
          VisChannelIndex := -1;
          for ChannelIndex := 0 to prDataChannelCount - 1 do begin

            if not ChannelVisible[ChannelIndex] then Continue;
            VisChannelIndex := VisChannelIndex + 1;

            ActualYMin := DataYMin[ChannelIndex];
            ActualYMax := DataYMax[ChannelIndex];

            TraceDy    := DataYMin[ChannelIndex] - DataYMax[ChannelIndex];
            if TraceDy = 0 then TraceDy := 1;//in case all the points have the same y

            if prDrawInverted then begin
              yAdd :=  ActualYMin;
            end else begin
              yAdd := -ActualYMax;
            end;

            if not prOverlapChannels then begin
              ActualTraceHeightMF := Round(ActualTraceHeightM * prDataYFactor[ChannelIndex] / (FactorSum / VisChannelCount));
              if prDrawIdealizedAbove then begin
                //ActualTraceVOffset := TraceRect.Top + prTraceVMargin + ActualTraceHeightMF + Round(VisChannelIndex * (2*ActualTraceHeightM + prTraceVMargin));
                ActualTraceVOffset := TraceRect.Top + prTraceVMargin + ActualTraceHeightMF + SumActualTraceHeightMF;
              end else begin
                //ActualTraceVOffset := TraceRect.Top + prTraceVMargin + Round(VisChannelIndex * (ActualTraceHeightM + prTraceVMargin));
                //ActualTraceVOffset := TraceRect.Top + prTraceVMargin + Round(VisChannelIndex * (((TraceHeightM - (VisChannelCount - 1)*prTraceVMargin) / VisChannelCount) + prTraceVMargin));
                ActualTraceVOffset := TraceRect.Top + prTraceVMargin + SumActualTraceHeightMF;
              end;
            end else begin
              ActualTraceHeightMF := ActualTraceHeightM;
              if prDrawIdealizedAbove then begin
                ActualTraceVOffset := TraceRect.Top + prTraceVMargin + ActualTraceHeightM;
              end else begin
                ActualTraceVOffset := TraceRect.Top + prTraceVMargin;
              end;
            end;

            if prDrawIdealizedAbove then begin
              SumActualTraceHeightMF := SumActualTraceHeightMF + 2*ActualTraceHeightMF + prTraceVMargin;
            end else begin
              SumActualTraceHeightMF := SumActualTraceHeightMF +   ActualTraceHeightMF + prTraceVMargin;
            end;


            if prDrawLabels then begin
            //Draw labels
              //Select clip region
              SelectClipRgn(prBitmapCanvas.Handle, DrawRegion);
              if (prDrawForPrinting) then begin
              //Printing B/W
                prBitmapCanvas.Font.Color  := clBlack;
                prBitmapCanvas.Font.Size   := prPrintFontSize;
                prBitmapCanvas.Pen.Color   := clBlack;
              end else if prOverlapChannels then begin
                prBitmapCanvas.Font.Color  := ColorData[ActiveChannel];
                prBitmapCanvas.Font.Size   := 8;
                prBitmapCanvas.Pen.Color   := ColorData[ActiveChannel];
              end else begin
                prBitmapCanvas.Font.Color  := ColorData[ChannelIndex];
                prBitmapCanvas.Font.Size   := 8;
                prBitmapCanvas.Pen.Color   := ColorData[ChannelIndex];
              end;
              prBitmapCanvas.Font.Style  := [];
              prBitmapCanvas.Font.Name   := 'Arial';
              prBitmapCanvas.Brush.Style := bsClear;

              if (prOverlapChannels and (ChannelIndex = ActiveChannel)) or (not prOverlapChannels) then begin
                prBitmapCanvas.MoveTo(TraceRect.Left, ActualTraceVOffset);
                prBitmapCanvas.LineTo(TraceRect.Left, ActualTraceVOffset + ActualTraceHeightMF);
                prBitmapCanvas.MoveTo(TraceRect.Left, ActualTraceVOffset + ActualTraceHeightMF);
                prBitmapCanvas.LineTo(TraceRect.Right, ActualTraceVOffset + ActualTraceHeightMF);
              end;

              if (prOverlapChannels and (ChannelIndex = ActiveChannel)) or (not prOverlapChannels) then begin
                for x := 0 to prYAxisTickCount[ChannelIndex] do begin
                  prBitmapCanvas.MoveTo(TraceRect.Left,     ActualTraceVOffset + Round(x*ActualTraceHeightMF/prYAxisTickCount[ChannelIndex]));
                  prBitmapCanvas.LineTo(TraceRect.Left - 5, ActualTraceVOffset + Round(x*ActualTraceHeightMF/prYAxisTickCount[ChannelIndex]));
                  Text := Format('%2.4g ' + DataChannelUnits[ChannelIndex], [prDataYMax[ChannelIndex]/(Scaling*DataChannelScaling[ChannelIndex]) - x/prYAxisTickCount[ChannelIndex]*(prDataYMax[ChannelIndex] - prDataYMin[ChannelIndex])/(Scaling*DataChannelScaling[ChannelIndex])]);
                  w := prBitmapCanvas.TextWidth(Text);
                  h := prBitmapCanvas.TextHeight(Text);
                  prBitmapCanvas.TextOut(TraceRect.Left - 8 - w, ActualTraceVOffset - h div 2 + Round(x*ActualTraceHeightMF/prYAxisTickCount[ChannelIndex]), Text);
                end;
              end;
              for x := 0 to prXAxisTickCount do begin
                prBitmapCanvas.MoveTo(TraceRect.Left + Round(x*(TraceRect.Right - TraceRect.Left)/prXAxisTickCount), ActualTraceVOffset + ActualTraceHeightMF);
                prBitmapCanvas.LineTo(TraceRect.Left + Round(x*(TraceRect.Right - TraceRect.Left)/prXAxisTickCount), ActualTraceVOffset + ActualTraceHeightMF + 5);
                if (VisChannelIndex + 1) = VisChannelCount then begin
                  Text := Format('%2.4g s', [x*TraceDx*Sampling/prXAxisTickCount]);
                  w := prBitmapCanvas.TextWidth(Text);
                  h := prBitmapCanvas.TextHeight(Text);
                  prBitmapCanvas.TextOut(TraceRect.Left - w div 2 + Round(x*(TraceRect.Right - TraceRect.Left)/prXAxisTickCount), ActualTraceVOffset + ActualTraceHeightMF + 5, Text);
                end;
              end;

              //Select clip region
              BeginPath(prBitmapCanvas.Handle);
              Rectangle(prBitmapCanvas.Handle, TraceRect.Left, ActualTraceVOffset, TraceRect.Right, ActualTraceVOffset + ActualTraceHeightMF);
              EndPath(prBitmapCanvas.Handle);
              LabeledClipRgn := PathToRegion(prBitmapCanvas.Handle);
              SelectClipRgn(prBitmapCanvas.Handle, LabeledClipRgn);

            end else begin

              //Select clip region
              SelectClipRgn(prBitmapCanvas.Handle, DataRegion);

            end;

            PointIndex := TraceXFirst;

            //Color Change
            if (prDrawForPrinting) and (prDrawBW) then begin
            //Printing B/W
              prBitmapCanvas.Pen.Color   := clBlack;
              prBitmapCanvas.Brush.Color := clBlack;
            end else begin
              if (PointIndex >= ActualSel.First) and (PointIndex <= ActualSel.Last) then begin
                prBitmapCanvas.Pen.Color := prColorSel;
                if ActualDrawPoints then begin
                  prBitmapCanvas.Brush.Color := prColorSel;
                end;
                ColorZone := 1;//Selection Color
              end else begin
                prBitmapCanvas.Pen.Color := ColorData[ChannelIndex];
                if ActualDrawPoints then begin
                  prBitmapCanvas.Brush.Color := ColorData[ChannelIndex];
                end;
                ColorZone := 0;//Normal Color
              end;
            end;



            //BeforeDrawChannel
            if Assigned(prOnBeforeDrawChannel) then begin
              prOnBeforeDrawChannel(Self, ChannelIndex);
            end;


            if ((prDrawForPrinting) and (prPrintDrawData)) or (not prDrawForPrinting) then begin

              //MoveTo TraceXFirst
              x  := TraceRect.Left;
              yu := prData[ChannelIndex, TraceXFirst];
              y  := ((ActualDrawInverted * yu + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

              if ActualDrawData then prBitmapCanvas.MoveTo(x, y);

              //Old:
              {
              if not prDrawRaster then begin
                if ActualDrawPoints then prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
              end else begin
                if yu <> 0          then //prBitmapCanvas.Rectangle(x - 1, y - 1, x + 1, y + 1);
                                         //prBitmapCanvas.Rectangle(x, ActualTraceVOffset + 4, x + 1, ActualTraceVOffset - 5 + ActualTraceHeightMF);
                                         prBitmapCanvas.Rectangle(x, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, x + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
              end;
              }
              //New
              if ActualDrawPoints then prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
              if prDrawRaster then begin
                if yu > 0 then prBitmapCanvas.Rectangle(x, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, x + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
              end;

              PrvX    := x;
              MinY    := y;
              MaxY    := y;
              MinYu   := yu;
              MaxYu   := yu;

              //PointLoop
              for PointIndex := TraceXFirst + 1 to TraceXLast do begin

                //Color Change
                if (not prDrawForPrinting) or ((prDrawForPrinting) and (not prDrawBW)) then begin
                  if PointIndex = (ActualSel.First + 1) then begin
                    if ColorZone <> 1 then begin
                      prBitmapCanvas.Pen.Color := prColorSel;
                      if ActualDrawPoints then begin
                        prBitmapCanvas.Brush.Color := prColorSel;
                      end;
                      ColorZone := 1;
                    end;
                  end else if PointIndex = (ActualSel.Last + 1) then begin
                    if ColorZone <> 0 then begin
                      prBitmapCanvas.Pen.Color := ColorData[ChannelIndex];
                      if ActualDrawPoints then begin
                        prBitmapCanvas.Brush.Color := ColorData[ChannelIndex];
                      end;
                      ColorZone := 0;
                    end;
                  end;
                end;

                x  := ((PointIndex - TraceXFirst)       * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                yu := prData[ChannelIndex, PointIndex];
                y  := ((ActualDrawInverted * yu + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

                case ActualDrawMode of

                  DRAWMODE_SLOW:

                    begin

                      //LineTo PointIndex
                      if ActualDrawData then prBitmapCanvas.LineTo(x, y);

                      //Old:
                      {
                      if not prDrawRaster then begin
                        if ActualDrawPoints then prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                      end else begin
                        if yu <> 0          then //prBitmapCanvas.Rectangle(x - 1, y - 1, x + 1, y + 1);
                                                 //prBitmapCanvas.Rectangle(x, ActualTraceVOffset + 4, x + 1, ActualTraceVOffset - 5 + ActualTraceHeightMF);
                                                 prBitmapCanvas.Rectangle(x, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, x + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
                      end;
                      }
                      //New:
                      if ActualDrawPoints then prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                      if prDrawRaster then begin
                         if yu > 0 then prBitmapCanvas.Rectangle(x, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, x + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
                      end;


                    end;

                  DRAWMODE_NORM:

                    begin

                      if MinY > y then begin
                        MinY  := y;
                        MinYu := yu;
                      end;
                      if MaxY < y then begin
                        MaxY  := y;
                        MaxYu := yu;
                      end;

                      if x <> PrvX then begin

                        //LineTo PointIndex
                        if ActualDrawData then begin
                          prBitmapCanvas.MoveTo(PrvX, MinY);
                          prBitmapCanvas.LineTo(PrvX, MaxY + 1);
                        end;

                        //Old:
                        {
                        if prDrawRaster then begin
                          if MaxYu <> 0 then begin
                            prBitmapCanvas.Rectangle(prvX - 2, MaxY - 2, PrvX + 2, MaxY + 2);
                          end else if MinYu <> 0 then begin
                            prBitmapCanvas.Rectangle(prvX, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, prvX + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
                          end;
                        end;
                        }
                        //New:
                        if prDrawRaster then begin
                          if (MaxYu > 0) or (MinYu > 0) then prBitmapCanvas.Rectangle(prvX, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, prvX + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
                        end;


                        PrvX  := x;
                        MinY  := y;
                        MaxY  := y;
                        MinYu := yu;
                        MaxYu := yu;

                      end;

                    end;

                  DRAWMODE_FAST:

                    begin

                      if x <> PrvX then begin

                        //LineTo PointIndex
                        if ActualDrawData then prBitmapCanvas.LineTo(x, y);

                        //Old:
                        {
                        if not prDrawRaster then begin
                          if ActualDrawPoints then prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                        end else begin
                          if yu <> 0 then prBitmapCanvas.Rectangle(x, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, x + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
                        end;
                        }
                        //New:
                        if ActualDrawPoints then prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                        if prDrawRaster then begin
                          if yu > 0 then prBitmapCanvas.Rectangle(x, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, x + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
                        end;


                        PrvX := x;

                      end;

                    end;

                end;//case ActualDrawMode


              end;//PointIndex

              //Draw the remaining points, if in Norm or Fast mode ...................
              case ActualDrawMode of
                DRAWMODE_NORM:
                  begin
                    if x = PrvX then begin
                      if ActualDrawData then begin
                        prBitmapCanvas.MoveTo(PrvX, MinY);
                        prBitmapCanvas.LineTo(PrvX, MaxY + 1);
                      end;
                      //Old:
                      {
                      if prDrawRaster then begin
                        if          MaxYu <> 0 then begin
                          prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                        end else if MinYu <> 0 then begin
                          //prBitmapCanvas.Rectangle(x - 1, y - 1, x + 1, y + 1);
                          //prBitmapCanvas.Rectangle(x, ActualTraceVOffset + 4, x + 1, ActualTraceVOffset - 5 + ActualTraceHeightMF);
                          prBitmapCanvas.Rectangle(x, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, x + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
                        end;
                      end;
                      }
                      //New:
                      if prDrawRaster then begin
                        if MaxYu > 0 then prBitmapCanvas.Rectangle(x, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, x + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
                      end;

                    end;
                  end;
                DRAWMODE_FAST:
                  begin
                    if x = PrvX then begin
                      if ActualDrawData then prBitmapCanvas.LineTo(x, y);
                      //Old:
                      {
                      if not prDrawRaster then begin
                        if ActualDrawPoints then prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                      end else begin
                        if yu <> 0          then //prBitmapCanvas.Rectangle(x - 1, y - 1, x + 1, y + 1);
                                                 //prBitmapCanvas.Rectangle(x, ActualTraceVOffset + 4, x + 1, ActualTraceVOffset - 5 + ActualTraceHeightMF);
                                                 prBitmapCanvas.Rectangle(x, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, x + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
                      end;
                      }
                      //New:
                      if ActualDrawPoints then prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                      if prDrawRaster then begin
                        if yu > 0 then prBitmapCanvas.Rectangle(x, ActualTraceVOffset + (ActualTraceHeightMF div 2) - 2, x + 1, ActualTraceVOffset + (ActualTraceHeightMF div 2) + 3);
                      end;

                    end;
                  end;
              end;//case ActualDrawMode
              //......................................................................


              //Overlap Data *********************************************************
              if prDrawIdealized then begin
                CurveIter    := nil;

                if prDrawIdealizedAbove then begin
                  Dec(ActualTraceVOffset, ActualTraceHeightMF);
                end;

                try

                  CurveIter    := FitCurves.Find(prDataOffset + prDataDraw.First);

                  if (ChannelIndex = ActiveChannel) and (not Boolean(CurveIter.Done)) then begin

                    //Color Change
                    if (prDrawForPrinting) and (prDrawBW) then begin
                      prBitmapCanvas.Pen.Color   := clBlack;
                      prBitmapCanvas.Brush.Color := clBlack;
                    end else begin
                      prBitmapCanvas.Pen.Color   := ColorIdealized;
                      prBitmapCanvas.Brush.Color := ColorIdealized;
                    end;

                    if ((prDrawForPrinting) and (prPrintDrawIDLData{prPrintDrawData})) or (not prDrawForPrinting) then begin

                      while (not Boolean(CurveIter.Done)) and (CurveIter.Curve.First <= (prDataOffset + DataDraw.Last)) do begin
                        CurveData       := CurveIter.Curve.Data;
                        CurveSel.First  := CurveIter.Curve.First - prDataOffset;
                        CurveSel.Last   := CurveIter.Curve.Last - prDataOffset;
                        CurveOff        := 0;
                        if CurveSel.First < TraceXFirst then begin
                          CurveOff       := TraceXFirst - CurveSel.First;
                          CurveSel.First := TraceXFirst;
                        end;
                        if CurveSel.Last  > TraceXLast  then CurveSel.Last  := TraceXLast;

                        //MoveTo TraceXFirst
                        x := ((CurveSel.First - TraceXFirst)                                                                   * TraceWidth)                      div (TraceDx) + TraceRect.Left;
                        y := ((ActualDrawInverted * CurveData[CurveSel.First{TraceXFirst} - CurveSel.First + CurveOff] + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

                        prBitmapCanvas.MoveTo(x, y);

                        if ActualDrawPoints then begin
                          prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                        end;

                        PrvX    := x;
                        MinY    := y;
                        MaxY    := y;

                        //PointLoop

                        for PointIndex := CurveSel.First + 1{TraceXFirst + 1} to CurveSel.Last{TraceXLast} do begin

                          x := ((PointIndex - TraceXFirst)                                                       * TraceWidth)                      div (TraceDx) + TraceRect.Left;
                          y := ((ActualDrawInverted * CurveData[PointIndex  - CurveSel.First + CurveOff] + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

                          case ActualDrawMode of

                            DRAWMODE_SLOW:

                              begin

                                //LineTo PointIndex
                                prBitmapCanvas.LineTo(x, y);

                                if ActualDrawPoints then begin
                                  prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                                end;

                              end;

                            DRAWMODE_NORM:

                              begin

                                if MinY > y then MinY := y;
                                if MaxY < y then MaxY := y;

                                if x <> PrvX then begin

                                  //LineTo PointIndex
                                  prBitmapCanvas.MoveTo(PrvX, MinY);
                                  prBitmapCanvas.LineTo(PrvX, MaxY + 1);

                                  PrvX := x;
                                  MinY := y;
                                  MaxY := y;

                                end;

                              end;

                            DRAWMODE_FAST:

                              begin

                                if x <> PrvX then begin

                                  //LineTo PointIndex
                                  prBitmapCanvas.LineTo(x, y);

                                  if ActualDrawPoints then begin
                                    prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                                  end;

                                  PrvX := x;

                                end;

                              end;

                          end;//case ActualDrawMode


                        end;//PointIndex

                        //Draw the remaining points, if in Norm or Fast mode .........
                        case ActualDrawMode of
                          DRAWMODE_NORM:
                            begin
                              if x = PrvX then begin
                                prBitmapCanvas.MoveTo(PrvX, MinY);
                                prBitmapCanvas.LineTo(PrvX, MaxY + 1);
                              end;
                           end;
                        DRAWMODE_FAST:
                          begin
                            if x = PrvX then begin
                              prBitmapCanvas.LineTo(x, y);
                              if ActualDrawPoints then begin
                                prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                              end;
                            end;
                          end;
                      end;//case ActualDrawMode
                      //............................................................

                      CurveIter.Next;

                    end;

                  end;

                end;//**************************************************************

              finally

                CurveIter.Free;

              end;

              if prDrawIdealizedAbove then begin
                Inc(ActualTraceVOffset, ActualTraceHeightMF);
              end;

              end;


              //Draw current point
              if (prDataCurr >= TraceXFirst) and (prDataCurr <= TraceXLast) then begin
                if not prDrawForPrinting then begin
                  if not prDrawRaster then begin
                    x := ((prDataCurr - TraceXFirst)                                     * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                    y := ((ActualDrawInverted * prData[ChannelIndex, prDataCurr] + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;
                    prBitmapCanvas.Brush.Color := ColorCurr;
                    prBitmapCanvas.Pen.Color   := ColorCurr;
                    if ActualDrawPoints then begin
                      prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                    end else begin
                      prBitmapCanvas.MoveTo(x,     y);
                      prBitmapCanvas.LineTo(x + 1, y);
                    end;
                  end;
                end;
              end;//Draw current point

            end;

            if ((prDrawForPrinting) and (prPrintDrawBase)) or (not prDrawForPrinting) then begin

              //Draw baseline
              if prDrawBaseline then begin
                if (prDrawForPrinting) and (prDrawBW) then begin
                  prBitmapCanvas.Pen.Color   := clBlack;
                end else begin
                  prBitmapCanvas.Pen.Color   := ColorBaseline;
                end;
                x := ((TraceXFirst - TraceXFirst)                                * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                // y := ((ActualDrawInverted * prDataBaseline[ChannelIndex] + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;
                y := ((ActualDrawInverted * 0 + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

                prBitmapCanvas.MoveTo(x, y);
                x := ((TraceXLast  - TraceXFirst)                                * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                prBitmapCanvas.LineTo(x + 1, y);

              end;

              //Draw Baseline Nodes
              if prDrawBaselineNodes then begin
                if (prDrawForPrinting) and (prDrawBW) then begin
                  prBitmapCanvas.Pen.Color   := clBlack;
                  prBitmapCanvas.Brush.Color := clBlack;
                end else begin
                  prBitmapCanvas.Pen.Color   := ColorBaselineNodes;
                  prBitmapCanvas.Brush.Color := ColorBaselineNodes;
                end;

                if TQUB_QVO_QVD(prDataSource).BaselineOn[ChannelIndex] then begin
                  jscal   := 0;
                end else begin
                  jscal   := 1;
                end;

                BaseSegs  := TList.Create;
                if not BaselineNodes[ChannelIndex].GetReadSegs(TraceXFirst + prDataOffset, TraceXLast + prDataOffset, BaseSegs) then begin
                  try
                    p := TraceXFirst + prDataOffset;
                    for n := 0 to BaseSegs.Count - 1 do begin
                      BaseSeg   := TQUB_BaselineSeg(BaseSegs[n]);
                      BaseValid := not BaseSeg.RangeAt(p, BaseFrom, BaseTo);
                      if not BaseValid then Continue;
                      if BaseFrom.Point >= p then begin
                        x := ((BaseFrom.Point - prDataOffset - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
                        y := ((ActualDrawInverted * jscal * (0 - BaseFrom.Value) + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;
                        prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                        prBitmapCanvas.MoveTo(x, y);
                      end else begin
                        x := ((p - prDataOffset - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
                        y := ((ActualDrawInverted * jscal * (0 - BaseSeg.ValueAt(p)) + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;
                        prBitmapCanvas.MoveTo(x, y);
                      end;
                      while BaseValid and ((BaseFrom.Point - prDataOffset) <= TraceXLast) do begin
                        if (BaseTo.Point - prDataOffset) <= TraceXLast then begin
                          xp := BaseTo.Point;
                          yp := 0 - BaseTo.Value;
                        end else begin
                          xp := TraceXLast + prDataOffset;
                          yp := 0 - BaseSeg.ValueAt(xp);
                        end;
                        x := ((xp - prDataOffset - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
                        y := ((ActualDrawInverted * jscal * yp + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;
                        prBitmapCanvas.LineTo(x, y);
                        if ((BaseTo.Point - prDataOffset) <= TraceXLast) {or (BaseTo.Point = BaseSeg.Last)} then begin
                          prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                        end;
                        BaseValid := not BaseSeg.NextRange(BaseFrom, BaseTo);
                      end;

                      p := BaseSeg.Last + 1;
                    end;
                  except
                  end;
                end;
                for n := 0 to BaseSegs.Count - 1 do begin
                  TQUB_BaselineSeg(BaseSegs[n]).Free;
                end;
                BaseSegs.Free;
              end;

              //Draw Markers
              //if {(prDrawMarkers) and} (prDataMarkersCount > 0) then begin
              if (prDataMarkersCount > 0) and (((prDrawForPrinting) and (prPrintDrawIDLData)) or (not prDrawForPrinting)) then begin
                try
                  SelectClipRgn(prBitmapCanvas.Handle, DrawRegion);
                  if (prDrawForPrinting) and (prDrawBW) then begin
                    prBitmapCanvas.Pen.Color   := clBlack;
                    prBitmapCanvas.Brush.Color := clBlack;
                  end else begin
                    prBitmapCanvas.Pen.Color   := ColorCurr;
                    prBitmapCanvas.Brush.Color := ColorCurr;
                  end;
                  x1 := TraceRect.Left;//((TraceXFirst - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
                  x2 := TraceRect.Right + 1;//((TraceXLast  - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
                  for p := 0 to prDataMarkersCount - 1 do begin
                    if prDataMarkersCh[p] = ChannelIndex then begin
                      y := ((ActualDrawInverted * Round(Scaling * DataChannelScaling[ChannelIndex] * (prDataMarkers[p]-DataChannelOffset[ChannelIndex])) + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;
                      prBitmapCanvas.MoveTo(x1,     y);
                      prBitmapCanvas.LineTo(x2 - 1, y);
                      prBitmapCanvas.Polygon([Point(x2 - 1, y),
                                              Point(x2 + 2, y - 3),
                                              Point(x2 + 8, y - 3),
                                              Point(x2 + 8, y + 3),
                                              Point(x2 + 2, y + 3)]);
                    end;
                  end;
                finally
                  SelectClipRgn(prBitmapCanvas.Handle, DataRegion);
                end;
              end;

            end;


            //AfterDrawChannel
            if Assigned(prOnAfterDrawChannel) then begin
              prOnAfterDrawChannel(Self, ChannelIndex);
            end;

            //Draw Idealized data
            if (prDrawIdealized) or (IsDWT) then begin

              if ((prDrawForPrinting) and (prPrintDrawIDLData)) or (not prDrawForPrinting) then begin

                IdlIter := nil;

                try

                  if prDrawIdealizedAbove then begin
                    Dec(ActualTraceVOffset, ActualTraceHeightMF);
                  end;

                  if (prDrawForPrinting) and (prDrawBW) then begin
                    prBitmapCanvas.Pen.Color   := clBlack;
                    prBitmapCanvas.Brush.Color := clBlack;
                  end else begin
                    prBitmapCanvas.Pen.Color   := ColorIdealized;
                    prBitmapCanvas.Brush.Color := ColorIdealized;
                  end;


                  //BeforeDrawIdlChannel
                  if Assigned(prOnBeforeDrawIdlChannel) then begin
                    prOnBeforeDrawIdlChannel(Self, ChannelIndex);
                  end;

                  if (not prDrawBW) and (prDrawIdealizedColor) then begin
                    if prBitmapCanvas.Pen.Width <> 0 then begin
                      prBitmapCanvas.Pen.Width   := prBitmapCanvas.Pen.Width * 2;
                    end else begin
                      prBitmapCanvas.Pen.Width   := 2;
                    end;
                  end;

                  // get segmentation
                  // find max ndwell, nclass; alloc flc, ampstd
                  // for seg:
                  //   load dwells, ampstd
                  //   draw

                  iscal      := Scaling * DataChannelScaling[ChannelIndex];
                  ioff       := DataChannelOffset[ChannelIndex];

                  IdlFound   := False;
                  IdlIter    := DataObject.Idealization[ChannelIndex].FindIter(TraceXFirst + prDataOffset);
                  while 0 <> IdlIter.Valid do begin
                    IdlIter.Read(@F, @L, @C, @A);
                    IdlIter.Next;

                    if C < 0 then begin
                      IdlFound := False;
                      Continue;
                    end;

                    F := F - prDataOffset;
                    L := L - prDataOffset;

                    if F > TraceXLast  then Break;
                    if F < TraceXFirst then F := TraceXFirst;
                    if L > TraceXLast  then L := TraceXLast;

                    x := Round(((F - 0.5 - TraceXFirst) * TraceWidth) / (TraceDx) + TraceRect.Left);
                    y := Round((A - ioff) * iscal);
                    y := ((ActualDrawInverted * y + yAdd) * ActualTraceHeightMF + 1) div (TraceDy) + ActualTraceVOffset;
                    if IdlFound then begin
                      {
                      if not prDrawForPrinting then begin
                        if prDrawIdealizedColor then begin
                          prBitmapCanvas.Pen.Color := ColorIdealized;
                        end;
                      end;
                      }
                      if (not prDrawForPrinting) and (prDrawIdealizedColor) then begin
                        prBitmapCanvas.MoveTo(x, y);
                      end else begin
                        prBitmapCanvas.LineTo(x, y);
                      end;
                    end else begin
                      prBitmapCanvas.MoveTo(x, y);
                    end;
                    IdlFound := True;
                    x := Round(((L + 0.5 - TraceXFirst) * TraceWidth) / (TraceDx) + TraceRect.Left);
                    if not prDrawForPrinting then begin
                      if prDrawIdealizedColor then begin
                        prBitmapCanvas.Pen.Color := QUB_QFS_QMF_CLASS_COLORS[C mod QUB_QFS_QMF_DEF_NCLASS];
                      end;
                    end;
                    prBitmapCanvas.LineTo(x, y);

                  end;

                  if (not prDrawBW) and (prDrawIdealizedColor) then begin
                    if prDrawForPrinting and (prBitmapCanvas.Pen.Width <> 2) then begin
                      prBitmapCanvas.Pen.Width   := prBitmapCanvas.Pen.Width div 2;
                    end else begin
                      prBitmapCanvas.Pen.Width   := 0;
                    end;
                  end;

                finally

                  if IdlIter <> nil then IdlIter.Free;

                end;

                //AfterDrawIdlChannel
                if Assigned(prOnAfterDrawIdlChannel) then begin
                  prOnAfterDrawIdlChannel(Self, ChannelIndex);
                end;

              end;

            end;//of Draw Idealized

            if prDrawLabels then begin
              SelectClipRgn(prBitmapCanvas.Handle, DataRegion);
              DeleteObject(LabeledClipRgn);
            end;

          end;//ChannelIndex


          //Cursor & Time Markers ************************************************

          //Erase old Cursor
          if not prDrawForPrinting then begin
            if (prDataOldCurr >= TraceXFirst) and (prDataOldCurr <= TraceXLast) then begin
              SelectClipRgn(prBitmapCanvas.Handle, CursorRegion);
              x := ((prDataOldCurr - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
              prBitmapCanvas.Brush.Color := prColorBack;
              prBitmapCanvas.Pen.Color   := prColorBack;
              prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Top),        Point(x + 3, TraceRect.Top),        Point(x, TraceRect.Top        + (QUB_QVO_QVD_TraceVMargin - 1))]);
              prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Bottom - 1), Point(x + 3, TraceRect.Bottom - 1), Point(x, TraceRect.Bottom - 1 - (QUB_QVO_QVD_TraceVMargin - 1))]);
            end;
          end;

          //Draw Time Markers
          if (prDataTimeMarkersCount > 0) and (((prDrawForPrinting) and (prPrintDrawIDLData)) or (not prDrawForPrinting)) then begin
            SelectClipRgn(prBitmapCanvas.Handle, DrawRegion);
            if (prDrawForPrinting) and (prDrawBW) then begin
              prBitmapCanvas.Pen.Color   := clBlack;
              prBitmapCanvas.Brush.Color := clBlack;
            end else begin
              prBitmapCanvas.Pen.Color   := ColorData[ActiveChannel];//Curr;
              prBitmapCanvas.Brush.Color := ColorData[ActiveChannel];//Curr;
            end;
            y1 := TraceRect.Top;
            y2 := TraceRect.Bottom;
            for p := 0 to prDataTimeMarkersCount - 1 do begin
              if (Round(prDataTimeMarkers[p]) < (prDataOffset + TraceXFirst)) or (Round(prDataTimeMarkers[p]) > (prDataOffset + TraceXLast)) then Continue;
              x := ((Round(prDataTimeMarkers[p]) - prDataOffset - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
              prBitmapCanvas.Pen.Style := psDot;
              prBitmapCanvas.MoveTo(x, y1);
              prBitmapCanvas.LineTo(x, y2);
              prBitmapCanvas.Pen.Style := psSolid;
              prBitmapCanvas.Polygon([Point(x - 3, y1),
                                      Point(x + 3, y1),
                                      Point(x,     y1 +     (QUB_QVO_QVD_TraceVMargin - 1))]);
              prBitmapCanvas.Polygon([Point(x - 3, y2 - 1),
                                      Point(x + 3, y2 - 1),
                                      Point(x,     y2 - 1 - (QUB_QVO_QVD_TraceVMargin - 1))]);
            end;
          end;

          //Draw Kinetic Parameters Markers
          if (prDataKinParamsMarkersCount > 0) and (((prDrawForPrinting) and (prPrintDrawIDLData)) or (not prDrawForPrinting)) then begin
            SelectClipRgn(prBitmapCanvas.Handle, DrawRegion);
            if (prDrawForPrinting) and (prDrawBW) then begin
              prBitmapCanvas.Pen.Color   := clBlack;
              prBitmapCanvas.Brush.Color := clBlack;
            end else begin
              prBitmapCanvas.Pen.Color   := ColorParameters;
              prBitmapCanvas.Brush.Color := ColorParameters;
            end;
            y1 := TraceRect.Top;
            y2 := TraceRect.Bottom;
            for p := 0 to prDataKinParamsMarkersCount - 1 do begin
              if (prDataKinParamsMarkers[p] < (TraceXFirst {- cSel.First})) or (prDataKinParamsMarkers[p] > (TraceXLast {- cSel.First})) then Continue;
              x := ((prDataKinParamsMarkers[p] - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
              prBitmapCanvas.Pen.Style := psDot;
              prBitmapCanvas.MoveTo(x, y1);
              prBitmapCanvas.LineTo(x, y2);
              prBitmapCanvas.Pen.Style := psSolid;
              prBitmapCanvas.Polygon([Point(x - 3, y1),
                                      Point(x + 3, y1),
                                      Point(x,     y1 +     (QUB_QVO_QVD_TraceVMargin - 1))]);
              prBitmapCanvas.Polygon([Point(x - 3, y2 - 1),
                                      Point(x + 3, y2 - 1),
                                      Point(x,     y2 - 1 - (QUB_QVO_QVD_TraceVMargin - 1))]);
            end;
            (*
            ParamsToDraw := DataObject.Session.Find('KineticParameters');
            if not ParamsToDraw.IsNull then begin
              try
                SelectClipRgn(prBitmapCanvas.Handle, DrawRegion);
                if (prDrawForPrinting) and (prDrawBW) then begin
                  prBitmapCanvas.Pen.Color   := clBlack;
                  prBitmapCanvas.Brush.Color := clBlack;
                end else begin
                  prBitmapCanvas.Pen.Color   := ColorParameters;
                  prBitmapCanvas.Brush.Color := ColorParameters;
                end;
                y1 := TraceRect.Top;
                y2 := TraceRect.Bottom;

                ChangePoint := ParamsToDraw.Find('ChangePoint');
                while not ChangePoint.IsNull do begin
                  CurrPoint := ChangePoint.Find('CurrPoint');
                  ThisPoint := CurrPoint.Data[0];
                  if (Round(ThisPoint) < (TraceXFirst {- cSel.First})) or (Round(ThisPoint) > (TraceXLast {- cSel.First})) then begin
                    ChangePoint := ChangePoint.SiblingSameName;
                    Continue;
                  end;
                  x := ((ThisPoint - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
                  prBitmapCanvas.Pen.Style := psDot;
                  prBitmapCanvas.MoveTo(x, y1);
                  prBitmapCanvas.LineTo(x, y2);
                  prBitmapCanvas.Pen.Style := psSolid;
                  prBitmapCanvas.Polygon([Point(x - 3, y1),
                                          Point(x + 3, y1),
                                          Point(x,     y1 +     (QUB_QVO_QVD_TraceVMargin - 1))]);
                  prBitmapCanvas.Polygon([Point(x - 3, y2 - 1),
                                          Point(x + 3, y2 - 1),
                                          Point(x,     y2 - 1 - (QUB_QVO_QVD_TraceVMargin - 1))]);
                  ChangePoint := ChangePoint.SiblingSameName;
                end;

              finally
                //SelectClipRgn(prBitmapCanvas.Handle, DataRegion);
              end;
            end;//IsNull
            *)

          end;//Kinetic Parameters Markers

          //Draw new Cursor
          if not prDrawForPrinting then begin
            if (prDataCurr >= TraceXFirst) and (prDataCurr <= TraceXLast) then begin
              SelectClipRgn(prBitmapCanvas.Handle, CursorRegion);
              x := ((prDataCurr - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
              prBitmapCanvas.Brush.Color := prColorCurr;
              prBitmapCanvas.Pen.Color   := prColorCurr;
              prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Top),        Point(x + 3, TraceRect.Top),        Point(x, TraceRect.Top        + (QUB_QVO_QVD_TraceVMargin - 1))]);
              prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Bottom - 1), Point(x + 3, TraceRect.Bottom - 1), Point(x, TraceRect.Bottom - 1 - (QUB_QVO_QVD_TraceVMargin - 1))]);
            end;
          end;


        end;//DrawListOverlapped


        SelectClipRgn(prBitmapCanvas.Handle, 0);

      end;//with DrawMap


    finally


      prDrawing := False;


    end;


  finally


    prDrawCritSection.Release;


  end;

end;

(*
procedure TQUB_QVO_QVT.OverlapData(FitData :TPAInteger; FitCount :Integer);
begin
  try
    prDrawCritSection.Acquire;

    if HasFit then begin
      prFitter.Finalize;
      prFitter.Release;
      prFitter  := nil;
    end;

    if prOverlapDataCount <> FitCount then begin
      ReAllocMem(prOverlapData, SizeOf(Integer) * FitCount);
    end;
    prOverlapDataCount  := 0;
    prOverlapDataOffset := prDataDraw.First;
    if prOverlapData <> nil then prOverlapDataCount := FitCount else prOverlapDataCount := 0;
    if prOverlapDataCount <> 0 then begin
      Move(FitData^, prOverlapData^, SizeOf(Integer) * FitCount);
    end;
  finally
    prDrawCritSection.Release;
  end;
end;
*)

procedure TQUB_QVO_QVT.CopyFit;
var
  CurveIter      :TQUB_FitCurveIter;
  CurveData      :TPAInteger;
  CurveDataCount :Integer;
  ASCII          :String;
  i              :Integer;
begin

  CurveIter      := nil;
  try

    CurveIter    := FitCurves.Find(prDataOffset + prDataCurr);

    if not Boolean(CurveIter.Done) then begin

      CurveData       := CurveIter.Curve.Data;
      CurveDataCount  := CurveIter.Curve.Last - CurveIter.Curve.First + 1;

      ASCII           := '';

      for i := 0 to CurveDataCount - 1 do begin

        ASCII := ASCII + Format('%.6g', [CurveData[i] / Scaling]);
        if i < (CurveDataCount - 1) then begin
          ASCII := ASCII + #13#10;
        end;

      end;//i

      Clipboard.SetTextBuf(PChar(ASCII));

    end;

  finally

    CurveIter.Free;

  end;

end;

procedure TQUB_QVO_QVT.ShowFitDlog;
begin
  ShowFit(ProfileMgr['Fitter-QVT'].Active, True);
end;

procedure TQUB_QVO_QVT.ShowFit(State :INode; ShowDlog :Boolean);
var
  X, Y               :INode;
  i, N                     :Integer;
  TraceXFirst, TraceXLast  :Integer;
  s, o                     :Double;
  DataSet                  :TQUB_FitDataSet;
begin
  try
    prDrawCritSection.Acquire;

    FitDlog.SetState(State);
    FitDlog.Data.AbsX := False;
    FitDlog.Data.DisplayStyle := QUBFITS_DISPLAY_DEFAULT;

    TraceXFirst              := prDataDraw.First;
    TraceXLast               := prDataDraw.Last;
    N                        := TraceXLast - TraceXFirst + 1;
    if N = 0 then Exit;

    prFitData                := TNode.Create('DataSet');
    X                        := prFitData['X'];
    X.SetupNumData( NODE_DATATYPE_DOUBLE, N, 1 );
    Y                        := prFitData['Y'];
    Y.SetupNumData( NODE_DATATYPE_DOUBLE, N, 1 );

    s                        := Scaling * DataChannelScaling[ActiveChannel];
    o                        := DataChannelOffset[ActiveChannel];
    for i := 0 to N - 1 do begin
      X.Data[i]              := i * Sampling;
      Y.Data[i]              := prData[ActiveChannel, TraceXFirst + i] / s + o;
    end;

    DataSet           := TQUB_FitDataSet.Create(N);
    DataSet.AddVar('X', TPADouble(X.DataPtr));
    DataSet.AddVar('Y', TPADouble(Y.DataPtr));
    FitDlog.Data.UseData(DataSet);
    DataSet.Free;
  finally
    prDrawCritSection.Release;
  end;

  if ShowDlog then FitDlog.ShowModal;
  prOnCurvesChanged(Self);
  FitDlog.Data.UseData(nil);
  prFitData := nil;

  ProfileMgr['Fitter-QVT'].Active := FitDlog.GetState;
end;

procedure TQUB_QVO_QVT.DelFit;
begin
  FitCurves.Clear;
  FitCurves.RaiseChanged;
end;

procedure TQUB_QVO_QVT.prOnCurvesChanged(Sender :TObject);
var
  i, N                :Integer;
  Actual              :TQUB_FirstLast;
  s, o                :Double;
  CurveIter           :TQUB_FitCurveIter;
  CurveData           :TPAInteger;
begin
  CurveIter           := nil;
  try
    N                 := FitDlog.Data.UseDataSet.N;
    Actual.First      := prDataDraw.First + prDataOffset
                         + Ceil(FitDlog.Data.SelFromS / DataObject.Sampling);
    Actual.Last       := Actual.First + N - 1;

    CurveIter          := FitCurves.Find(Actual.First);
    if (0 <> CurveIter.Done){isdone} or (CurveIter.Curve.First <> Actual.First) or (CurveIter.Curve.Last <> Actual.Last) then begin
      CurveIter.Free;
      FitCurves.Clear;
      CurveIter        := FitCurves.Add(Actual.First, Actual.Last);
    end;
    CurveData          := CurveIter.Curve.Data;

    s := Scaling * DataChannelScaling[ActiveChannel];
    o := DataChannelOffset[ActiveChannel];
    for i := 0 to N - 1 do begin
      CurveData[i] := Round((FitDlog.Data.FY[i] - o) * s);
    end;

    CurveIter.MarkChanged;

  finally
    CurveIter.Free;
  end;

  prMustRedrawFit := True;
  FitCurves.RaiseChanged;
end;

procedure TQUB_QVO_QVT.DoOnFitCurvesChanged(Sender :TObject);
begin

end;



procedure TQUB_QVO_QVT.SendToQtiPlot(Script :String);
var
  QtiPlot                  :TQUB_QtiPlot_Connection;
  i, N, c                  :Integer;
  TraceXFirst, TraceXLast  :Integer;
begin
  TraceXFirst       := prDataDraw.First;
  TraceXLast        := prDataDraw.Last;
  N                 := TraceXLast - TraceXFirst + 1;
  if N = 0 then Exit;

  QtiPlot           := TQUB_QtiPlot_Connection.Create;
  try
    QtiPlot.BringToFront;
    QtiPlot.ExecScript('Trace', Script);
    QtiPlot.Exec(Format('xx = arange(0, %s, %s)', [QtiFormat(N*Sampling), QtiFormat(Sampling)]));
    QtiPlot.Exec('yy = []');
    for c := 0 to DataObject.ADChannelCount - 1 do begin
      QtiPlot.SetArray(@(prData[c, TraceXFirst]), N, 1, 'int32', 'y');
      QtiPlot.Exec(Format('y = y / float(%s); y += %s; yy.append(y)',
                          [QtiFormat(Scaling * DataChannelScaling[c]),
                           QtiFormat(DataChannelOffset[c])]));
    end;
    QtiPlot.Exec(Format('add_data_plot("QuB - %s - %d - %d", "%s", "%s", %d, xx, yy)',
                        [ExtractFileName(DataObject.FileName),
                         TraceXFirst, TraceXLast,
                         'seconds', DataChannelUnits[ActiveChannel],
                         ActiveChannel]));
  finally
    QtiPlot.Free;
  end;
end;



//****************************************************************************//
//                                                                            //
//                 This method is used to draw the Selection                  //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVT.prDrawDataSel;
begin

  //Find the Selection point, stored in prMouseSel

  if prMouseDowning then begin
  //The Mouse just hit the cheese

    if KeyShift then begin
    //If Shift then extend selection ... simulate selection mode

      prDrawDataSelRunning;

    end else begin

      prDrawDataSelDowning;

    end;

  end else if prMouseRunning then begin
  //The Mouse is running scared

    prDrawDataSelRunning;

  end else if prKeyeing then begin
  //A key was hit

    prDrawDataSelKeyeing;

  end;

end;

procedure TQUB_QVO_QVT.prDrawDataSelDowning;
var
  f, i, n    :Integer;
begin
  f := prMouseToPoint(prMouseSel);
  prDataCurr            := f;

  if prDrawListOverlapped then begin

    prDataSel.First    := f;
    prDataSel.Last     := f;
    Draw;
    prSelMove.First     := f;
    prSelMove.Last      := f;

  end else begin

    prWindowDrawMode      := True;
    if (prDataCurr >= prDataSel.First) and (prDataCurr <= prDataSel.Last) then begin
      n := 1;
    end else begin
      n := 2;
    end;
    try
      for i := 1 to n do begin
        //Draw the window only if within Display range !!!
        prDataWindow.First := prDataSel.First;
        prDataWindow.Last  := prDataSel.Last;
        prDataSel.First    := f;
        prDataSel.Last     := f;
        Draw;
      end;
    finally
      prWindowDrawMode    := False;
      prSelMove.First     := f;
      prSelMove.Last      := f;
    end;

  end;//DrawListOverlapped;

  DataCurr            := prDataCurr;
end;

procedure TQUB_QVO_QVT.prDrawDataSelRunning;
begin

  prDataCurr := prMouseToPoint(prMouseSel);

  prDataWindow.First := prSelMove.Last;
  prDataWindow.Last  := prDataCurr;
  if prDataWindow.First > prDataWindow.Last then begin
    prDataWindow.First := prDataCurr;
    prDataWindow.Last  := prSelMove.Last;
  end;
  prWindowDrawMode := True;

  prSelMove.Last := prDataCurr;

  prDataSel.First := prSelMove.First;
  prDataSel.Last  := prSelMove.Last;
  if prDataSel.First > prDataSel.Last then begin
    prDataSel.First := prSelMove.Last;
    prDataSel.Last  := prSelMove.First;
  end;

  try
    Draw;
  finally
    prWindowDrawMode := False;
  end;

  DataCurr            := prDataCurr;
end;

procedure TQUB_QVO_QVT.prDrawDataSelKeyeing;
begin

  case prKeyCode of

    VK_LEFT:
      begin
        if (KeyControl) and (((prDataDraw.Last - prDataDraw.First + 1) div 100) <> 0) then begin
          Dec(prDataCurr, (prDataDraw.Last - prDataDraw.First + 1) div 100);
        end else begin
          Dec(prDataCurr);
        end;
      end;
    VK_RIGHT:
      begin
        if (KeyControl) and (((prDataDraw.Last - prDataDraw.First + 1) div 100) <> 0) then begin
          Inc(prDataCurr, (prDataDraw.Last - prDataDraw.First + 1) div 100);
        end else begin
          Inc(prDataCurr);
        end;
      end;
    VK_HOME:
      begin
        prDataCurr := prDataDraw.First;
      end;
    VK_END:
      begin
        prDataCurr := prDataDraw.Last;
      end;

  end;//case

  if prDataCurr < prDataDraw.First then prDataCurr := prDataDraw.First;
  if prDataCurr > prDataDraw.Last  then prDataCurr := prDataDraw.Last;


  {*****************************************************************************

  Set the coordinates for window drawing

  *****************************************************************************}


  //If extending selection
  if KeyShift then begin

    prDataWindow.First := prSelMove.Last;
    prDataWindow.Last  := prDataCurr;
    if prDataWindow.First > prDataWindow.Last then begin
      prDataWindow.First := prDataCurr;
      prDataWindow.Last  := prSelMove.Last;
    end;

  //if clearing selection
  end else begin

    prDataWindow.First := prDataSel.First;
    prDataWindow.Last  := prDataSel.Last;
    if prDataCurr > prDataWindow.Last then begin
      prDataWindow.Last := prDataCurr;
    end;
    if prDataCurr < prDataWindow.First then begin
      prDataWindow.First := prDataCurr;
    end;

  end;

  prWindowDrawMode := True;

  prSelMove.Last := prDataCurr;


  {*****************************************************************************

  Set the coordinates for selection

  *****************************************************************************}

  //No shift, erase selection
  if not KeyShift then begin

    prDataSel.First := prDataCurr;
    prDataSel.Last  := prDataCurr;
    prSelMove.First := prDataCurr;

  //shift, extend selection
  end else begin

    prDataSel.First := prSelMove.First;
    prDataSel.Last  := prSelMove.Last;
    if prDataSel.First > prDataSel.Last then begin
      prDataSel.First := prSelMove.Last;
      prDataSel.Last  := prSelMove.First;
    end;

  end;

  try
    Draw;
  finally
    prWindowDrawMode    := False;
  end;

  DataCurr            := prDataCurr;
end;

procedure TQUB_QVO_QVT.Erase;
begin
  prErase;
end;

procedure TQUB_QVO_QVT.prErase;
begin
  inherited;

  if prDrawForPrinting then begin
    prBitmapCanvas.Pen.Width := prPrintPenWidth;
  end else begin
    prBitmapCanvas.Pen.Width := 0;
  end;
  prBitmapCanvas.Pen.Style := psSolid;

  if prDrawForPrinting then begin
    if prDrawFrame then begin
      prBitmapCanvas.Brush.Style := bsClear;
      prBitmapCanvas.Pen.Color   := clBlack;
      prBitmapCanvas.Rectangle(MarginLeft - 1, MarginTop - 1, prDrawWidth - MarginRight, prDrawHeight - MarginBottom);
    end;
  end else begin
    prBitmapCanvas.Brush.Style := bsSolid;
    prBitmapCanvas.Pen.Color   := ColorFrame;
    prBitmapCanvas.Brush.Color := ColorBack;
    prBitmapCanvas.Rectangle(MarginLeft - 1, MarginTop - 1, prDrawWidth - MarginRight, prDrawHeight - MarginBottom);
  end;

end;

procedure TQUB_QVO_QVT.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
begin
  try

    prMustRedraw := True;

  finally

    inherited;

    prDoClipRegns(CLIP_RGN_UPDATE);

  end;
end;


//******************************************************************************
function TQUB_QVO_QVT.prChangePoint(Up :Boolean) :Boolean;
var
  d :Integer;
begin

  Result := False;

  d := (prDataYMax[ActiveChannel] - prDataYMin[ActiveChannel]) div 20;
  if d = 0 then d := 1;

  if not Up then d := -d;
  if prDrawInverted then d := -d;

  if Assigned(prOnEditPoint) then begin
    prOnEditPoint(Self, DataCurr + DataOffset, d);
  end;

end;


//******************************************************************************
function TQUB_QVO_QVT.prMouseToPoint(const p :TPoint) :Integer;
var
  x   :Integer;
  o   :Integer;
begin

  if prDataDraw.First = prDataDraw.Last then begin
    Result := 0;
    Exit;
  end;

  x := p.x;

  if x < (prMargin.Left + prLabelsWidth) then x := prMargin.Left + prLabelsWidth;
  if x > (Width  - prMargin.Right  - 1 - prLabelsWidth div 2)  then x := (Width  - prMargin.Right  - 1 - prLabelsWidth div 2);

  if prDrawListOverlapped then begin

    o := ((x - prMargin.Left - prLabelsWidth) * (prDataDraw.Last - prDataDraw.First)) div (Width - prMargin.Left - prLabelsWidth - prMargin.Right - 1 - prLabelsWidth div 2);

  end else begin

    o := ((x - prMargin.Left - prLabelsWidth) * (prDataDraw.Last - prDataDraw.First)) div (Width - prMargin.Left - prLabelsWidth - prMargin.Right - 1 - prLabelsWidth div 2);
    o := o + prDataDraw.First;

    if o > prDataDraw.Last  then o := prDataDraw.Last;
    if o < prDataDraw.First then o := prDataDraw.First;

  end;//DrawListOverlapped

  Result := o;

end;


//****************************************************************************//
//                                                                            //
//                           D A T A    R E S E T                             //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVT.prResetData;
begin

  prData                                       := nil;

  //OverlapData(nil, 0);

  prDataChannelCount                           := 0;

  prDataDraw.First                             := 0;
  prDataDraw.Last                              := 0;

  prDataWindow.First                           := 0;
  prDataWindow.Last                            := 0;

  prDataSel.First                              := 0;
  prDataSel.Last                               := 0;

  prDataOffset                                 := 0;

  DataCurr                                     := 0;
end;


//Vertical Marker user-interaction
procedure TQUB_QVO_QVT.prMoveMarker(x, y: Integer);
var
  ChannelIndex         :Integer;
  VisChannelCount      :Integer;
  VisChannelIndex      :Integer;
  AYMin                :Integer;
  AYMax                :Integer;

  FactorSum           :Double;
  ActualTraceHeightMF :Integer;
  SumActualTraceHeightMF:Integer;

  procedure SetTraceWindow;
  begin
    with prDrawMap do begin
      if not prOverlapChannels then begin
        ActualTraceHeightMF := Round(ActualTraceHeightM * prDataYFactor[ChannelIndex] / (FactorSum / VisChannelCount));
        if prDrawIdealizedAbove then begin
          ActualTraceVOffset := TraceRect.Top + prTraceVMargin + ActualTraceHeightMF + SumActualTraceHeightMF;
        end else begin
          ActualTraceVOffset := TraceRect.Top + prTraceVMargin + SumActualTraceHeightMF;
        end;
      end else begin
        ActualTraceHeightMF := ActualTraceHeightM;
        if prDrawIdealizedAbove then begin
          ActualTraceVOffset := TraceRect.Top + prTraceVMargin + ActualTraceHeightM;
        end else begin
          ActualTraceVOffset := TraceRect.Top + prTraceVMargin;
        end;
      end;
      if prDrawIdealizedAbove then begin
        SumActualTraceHeightMF := SumActualTraceHeightMF + 2*ActualTraceHeightMF + prTraceVMargin;
      end else begin
        SumActualTraceHeightMF := SumActualTraceHeightMF +   ActualTraceHeightMF + prTraceVMargin;
      end;
    end;
  end;
begin

  if prDataMarker = -1 then Exit;
  if prDataMarkersCount = 0 then Exit;
  //if not prDrawMarkers then Exit;

  with prDrawMap do begin

    VisChannelCount   := 0;
    FactorSum         := 0;
    for ChannelIndex := 0 to prDataChannelCount - 1 do begin
      if ChannelVisible[ChannelIndex] then begin
        VisChannelCount := VisChannelCount + 1;
        if prDataYFactor[ChannelIndex] <= 0 then prDataYFactor[ChannelIndex] := 1;
        FactorSum := FactorSum + prDataYFactor[ChannelIndex];
      end;
    end;

    if prOverlapChannels then begin
      ActualTraceHeightM := TraceHeightM;
    end else begin
      if VisChannelCount > 0 then begin
        ActualTraceHeightM := (TraceHeightM - (VisChannelCount - 1)*prTraceVMargin) div VisChannelCount;
      end else begin
        ActualTraceHeightM := TraceHeightM;
      end;
    end;
    if prDrawIdealizedAbove then begin
      ActualTraceHeightM := ActualTraceHeightM div 2;
    end;
    if ActualTraceHeightM = 0 then ActualTraceHeightM := 1;

    if prDrawInverted then ActualDrawInverted := -1 else ActualDrawInverted := 1;

    SumActualTraceHeightMF := 0;

    //ChannelLoop
    VisChannelIndex := -1;
    for ChannelIndex := 0 to prDataChannelCount - 1 do begin

      if not ChannelVisible[ChannelIndex] then Continue;
      Inc(VisChannelIndex);
      //if ChannelIndex <> prDataMarkersCh[prDataMarker] then Continue;

      AYMin := DataYMin[ChannelIndex];
      AYMax := DataYMax[ChannelIndex];

      TraceDy := DataYMin[ChannelIndex] - DataYMax[ChannelIndex];
      if TraceDy = 0 then TraceDy := 1;

      if prDrawInverted then begin
        yAdd :=  AYMin;
      end else begin
        yAdd := -AYMax;
      end;

      SetTraceWindow;

      if ChannelIndex = prDataMarkersCh[prDataMarker] then begin
        prDataMarkers[prDataMarker] := (((((y - ActualTraceVOffset) * TraceDy) - 1) / ActualTraceHeightMF) - yAdd) / (ActualDrawInverted * (Scaling * prDataChannelScaling[ChannelIndex]));
        prMustRedraw := True;
        Paint;
        prSetVMarkHint;

        if Assigned(prOnChangeVMarker) then prOnChangeVMarker(Self);
        Break;
      end;

    end;//ChannelIndex

  end;//DrawMap;

end;


function TQUB_QVO_QVT.prMarkering(Button: TMouseButton; Shift: TShiftState; X, Y: Integer) :Boolean;
var
  ChannelIndex         :Integer;
  VisChannelCount      :Integer;
  VisChannelIndex      :Integer;
  AYMin                :Integer;
  AYMax                :Integer;
  v                    :Integer;
  vx, vy               :Integer;

  FactorSum           :Double;
  ActualTraceHeightMF :Integer;
  SumActualTraceHeightMF:Integer;

  procedure SetTraceWindow;
  begin
    with prDrawMap do begin
      if not prOverlapChannels then begin
        ActualTraceHeightMF := Round(ActualTraceHeightM * prDataYFactor[ChannelIndex] / (FactorSum / VisChannelCount));
        if prDrawIdealizedAbove then begin
          ActualTraceVOffset := TraceRect.Top + prTraceVMargin + ActualTraceHeightMF + SumActualTraceHeightMF;
        end else begin
          ActualTraceVOffset := TraceRect.Top + prTraceVMargin + SumActualTraceHeightMF;
        end;
      end else begin
        ActualTraceHeightMF := ActualTraceHeightM;
        if prDrawIdealizedAbove then begin
          ActualTraceVOffset := TraceRect.Top + prTraceVMargin + ActualTraceHeightM;
        end else begin
          ActualTraceVOffset := TraceRect.Top + prTraceVMargin;
        end;
      end;
      if prDrawIdealizedAbove then begin
        SumActualTraceHeightMF := SumActualTraceHeightMF + 2*ActualTraceHeightMF + prTraceVMargin;
      end else begin
        SumActualTraceHeightMF := SumActualTraceHeightMF +   ActualTraceHeightMF + prTraceVMargin;
      end;
    end;
  end;

begin

  Result               := False;

  if prDataMarkersCount = 0 then Exit;
  //if not prDrawMarkers then Exit;

  with prDrawMap do begin

    VisChannelCount   := 0;
    FactorSum         := 0;
    for ChannelIndex := 0 to prDataChannelCount - 1 do begin
      if ChannelVisible[ChannelIndex] then begin
        VisChannelCount := VisChannelCount + 1;
        if prDataYFactor[ChannelIndex] <= 0 then prDataYFactor[ChannelIndex] := 1;
        FactorSum := FactorSum + prDataYFactor[ChannelIndex];
      end;
    end;

    if prOverlapChannels then begin
      ActualTraceHeightM := TraceHeightM;
    end else begin
      if VisChannelCount > 0 then begin
        ActualTraceHeightM := (TraceHeightM - (VisChannelCount - 1)*prTraceVMargin) div VisChannelCount;
      end else begin
        ActualTraceHeightM := TraceHeightM;
      end;
    end;
    if prDrawIdealizedAbove then begin
      ActualTraceHeightM := ActualTraceHeightM div 2;
    end;
    if ActualTraceHeightM = 0 then ActualTraceHeightM := 1;

    if prDrawInverted then ActualDrawInverted := -1 else ActualDrawInverted := 1;

    SumActualTraceHeightMF := 0;

    //ChannelLoop
    VisChannelIndex := -1;
    for ChannelIndex := 0 to prDataChannelCount - 1 do begin

      if not ChannelVisible[ChannelIndex] then Continue;
      VisChannelIndex := VisChannelIndex + 1;

      AYMin := DataYMin[ChannelIndex];
      AYMax := DataYMax[ChannelIndex];

      TraceDy := DataYMin[ChannelIndex] - DataYMax[ChannelIndex];
      if TraceDy = 0 then TraceDy := 1;

      if prDrawInverted then begin
        yAdd :=  AYMin;
      end else begin
        yAdd := -AYMax;
      end;

      SetTraceWindow;

      vx := TraceRect.Right + 1;
      for v := 0 to prDataMarkersCount - 1 do begin
        if prDataMarkersCh[v] = ChannelIndex then begin
          vy := ((ActualDrawInverted * Round(Scaling * prDataChannelScaling[ChannelIndex] * (prDataMarkers[v] - prDataChannelOffset[ChannelIndex])) + yAdd) * ActualTraceHeightMF + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;
          if ((vx - 2) < x) and ((vx + 9) > x) and ((vy - 4) < y) and ((vy + 4) > y) then begin
          //Hit!

            Result               := True;
            prDataMarker         := v;
            prOldHint            := Hint;

            prSetVMarkHint;

            if Assigned(prOnChangeVMarker) then prOnChangeVMarker(Self);

            Break;

          end;
        end;
      end;

      if Result then Break;

    end;//ChannelIndex

  end;//DrawMap;

end;

procedure TQUB_QVO_QVT.prSetVMarkHint;
var
  Min, Max, Per :Double;
  Count         :Integer;
  m             :Integer;
begin
  Min := prDataMarkers[prDataMarker];
  Max := prDataMarkers[prDataMarker];
  Count := 0;
  for m := 0 to prDataMarkersCount - 1 do begin
    if prDataMarkersCh[m] = prDataMarkersCh[prDataMarker] then begin
      Inc(Count);
      if Min > prDataMarkers[m] then Min := prDataMarkers[m];
      if Max < prDataMarkers[m] then Max := prDataMarkers[m];
    end;
  end;
  if Count = 1 then begin
  Hint := 'VMarker = ' + Format('%.6g', [prDataMarkers[prDataMarker]]);
  end else begin
    Per  := (prDataMarkers[prDataMarker] - Min) / (Max - Min) * 100;
    Hint := 'VMarker = ' + Format('%.6g (%.4g/%.4g%%)', [prDataMarkers[prDataMarker], Per, 100 - Per]);
  end;
end;

//Time Marker User-Interaction
procedure TQUB_QVO_QVT.prMoveTimeMarker(x, y: Integer);
begin

  if prDataTimeMarker = -1 then Exit;
  if prDataTimeMarkersCount = 0 then Exit;
  //if not prDrawTimeMarkers then Exit;

  with prDrawMap do begin

    prDataTimeMarkers[prDataTimeMarker] := (x - TraceRect.Left) * TraceDx / TraceWidth + prDataOffset + TraceXFirst;

    prMustRedraw := True;
    Paint;

    prSetTMarkHint;

    if Assigned(prOnChangeTMarker) then prOnChangeTMarker(Self);

  end;//DrawMap;

end;


function TQUB_QVO_QVT.prTimeMarkering(Button: TMouseButton; Shift: TShiftState; X, Y: Integer) :Boolean;
var
  y1, y2, xx :Integer;
  p          :Integer;
begin

  Result     := False;

  if prDataTimeMarkersCount = 0 then Exit;
  //if not prDrawTimeMarkers then Exit;

  with prDrawMap do begin

    y1 := TraceRect.Top;
    y2 := TraceRect.Bottom;

    for p := 0 to prDataTimeMarkersCount - 1 do begin

      if (Round(prDataTimeMarkers[p]) < (prDataOffset + TraceXFirst)) or (Round(prDataTimeMarkers[p]) > (prDataOffset + TraceXLast)) then Continue;

      xx := ((Round(prDataTimeMarkers[p]) - prDataOffset - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;

      if ((xx - 3) <= x) and ((xx + 3) >= x) and
         ((((y1 - 0) <= y) and ((y1 + (prTraceVMargin - 1)) >= y)) or (((y2 - 1) <= y) and ((y2 - 1 + (prTraceVMargin - 1)) >= y))) then begin
      //Hit!

        Result               := True;
        prDataTimeMarker     := p;
        prOldHint            := Hint;

        prSetTMarkHint;

        if Assigned(prOnChangeTMarker) then prOnChangeTMarker(Self);

        Break;

      end;

    end;//p

  end;//DrawMap;

end;

procedure TQUB_QVO_QVT.prSortTimeMarkers;
var
  m :Double;
  i :Integer;
  f :Boolean;
begin

  if prDataTimeMarkersCount < 2 then Exit;

  repeat
    f := False;
    for i := 0 to prDataTimeMarkersCount - 2 do begin
      if prDataTimeMarkers[i] > prDataTimeMarkers[i + 1] then begin
        m := prDataTimeMarkers[i];
        prDataTimeMarkers[i] := prDataTimeMarkers[i + 1];
        prDataTimeMarkers[i + 1] := m;
        f := True;
      end;
    end;
  until not f;

end;

procedure TQUB_QVO_QVT.prSetTMarkHint;
begin
  Hint := 'Time Marker = ' + Format('%d', [Round(prDataTimeMarkers[prDataTimeMarker])]);
end;
//End Time Marker User-Interaction


function TQUB_QVO_QVT.prKinParamsMarkering(Button: TMouseButton; Shift: TShiftState; X, Y: Integer) :Boolean;
var
  y1, y2, xx :Integer;
  p          :Integer;
begin

  Result     := False;

  if prDataKinParamsMarkersCount = 0 then Exit;
  //if not prDrawKinParamsMarkers then Exit;

  with prDrawMap do begin

    y1 := TraceRect.Top;
    y2 := TraceRect.Bottom;

    for p := 0 to prDataKinParamsMarkersCount - 1 do begin

      if (prDataKinParamsMarkers[p] < (prDataOffset + TraceXFirst)) or (prDataKinParamsMarkers[p] > (prDataOffset + TraceXLast)) then Continue;

      xx := ((prDataKinParamsMarkers[p] - prDataOffset - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;

      if ((xx - 3) <= x) and ((xx + 3) >= x) and
         ((((y1 - 0) <= y) and ((y1 + (prTraceVMargin - 1)) >= y)) or (((y2 - 1) <= y) and ((y2 - 1 + (prTraceVMargin - 1)) >= y))) then begin
      //Hit!

        Result                := True;
        prDataKinParamsMarker := p;
        prOldHint             := Hint;

        prSetKMarkHint;

        if Assigned(prOnChangeKMarker) then prOnChangeKMarker(Self);

        Break;

      end;

    end;//p

  end;//DrawMap;

end;

procedure TQUB_QVO_QVT.prSetKMarkHint;
begin
  Hint := 'Kinetic parameters change at point ' + IntToStr(prDataKinParamsMarkers[prDataKinParamsMarker]) +
          #13#10 + prDataKinParamsMarkersNote[prDataKinParamsMarker] +
          #13#10 + prDataKinParamsMarkersPars[prDataKinParamsMarker];
end;
//End Kinetic Parameters Marker User-Interaction


//****************************************************************************//
//                                                                            //
//                          M O U S E   E V E N T S                           //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVT.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  vm, tm, km :Boolean;
begin

  inherited;

  TQUB_QVO_QVD(prDataSource).PopUpComponent := Self;

  try

    vm := False;
    tm := False;
    km := False;
    if prDataMarkersCount > 0 then begin
      vm := prMarkering(Button, Shift, X, Y);
    end;
    if prDataTimeMarkersCount > 0 then begin
      if not vm then tm := prTimeMarkering(Button, Shift, X, Y);
    end;
    if prDataKinParamsMarkersCount > 0 then begin
      if (not vm) and (not tm) then km := prKinParamsMarkering(Button, Shift, X, Y);
    end;

    if vm then begin
    //Data Marker
      prVMarkering := True;
      Exit;
    end else if tm then begin
    //Time Marker
      prTMarkering := True;
      Exit;
    end else if km then begin
    //KinParams Marker
      prKMarkering := True;
      Exit;
    end else begin

      if prDataMarker <> -1 then begin
        prDataMarker := -1;
        if Assigned(prOnChangeVMarker) then prOnChangeVMarker(Self);
      end;
      if prDataTimeMarker <> - 1 then begin
        prDataTimeMarker := -1;
        if Assigned(prOnChangeTMarker) then prOnChangeTMarker(Self);
      end;
      if prDataKinParamsMarker <> - 1 then begin
        prDataKinParamsMarker := -1;
        if Assigned(prOnChangeKMarker) then prOnChangeKMarker(Self);
      end;

    end;



    if (prMouseHitCount < 2) and (Button = mbLeft) then begin
      prMouse.x := x;
      prMouse.y := y;
      prMouseSel := prMouse;
      Exit;
    end;

    if Button = mbLeft then begin

      prMouse.x := x;
      prMouse.y := y;
      prMouseSel := prMouse;

      if not prSelectable then Exit;

      //Start selecting
      prMouseDowning := True;
      prDrawDataSel;
      prSelecting := True;

    end

  finally

    prMouseDowning := False;

  end;
end;

procedure TQUB_QVO_QVT.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  try

    if prHintCycle = QUB_QVO_QVD_HINTCYCLE then begin
      ShowHint             := False;
      prHintCycle          := 0;
    end else begin
      if (prDataSource <> nil) and prDataSource.TipsOn then begin
        ShowHint             := True;
      end;
      prHintCycle          := prHintCycle + 1;
    end;

    if prVMarkering then begin
      prMoveMarker(x, y);
    end else if prTMarkering then begin
      prMoveTimeMarker(x, y);
    end else if prKMarkering then begin

    end;

    if prSelecting then begin
    //Update selection
      prMouseRunning := True;
      prMouseSel.x := x;
      prMouseSel.y := y;
      prDrawDataSel;
    end;

  finally

    prMouseRunning := False;
    inherited;

  end;
end;

procedure TQUB_QVO_QVT.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  try

    if (prVMarkering) or (prTMarkering) or (prKMarkering) then Hint := prOldHint;

    if prTMarkering then begin
      prSortTimeMarkers;//TO DO: very inefficient - just one pass should suffice. LM
    end;

    prSelecting  := False;
    prVMarkering := False;
    prTMarkering := False;
    prKMarkering := False;

  finally

    inherited;

  end;
end;


//****************************************************************************//
//                                                                            //
//                             K E Y   E V E N T S                            //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVT.CNKeyDown(var Message: TWMKeyDown);
var
  Eaten :Boolean;
begin

  Eaten := False;

  case Message.CharCode of

    VK_LEFT, VK_RIGHT, VK_UP, VK_DOWN, VK_PRIOR, VK_NEXT, VK_END, VK_HOME:
      begin
        prKeyeing := True;
        prKeyCode := Message.CharCode;
        try
          if ((Message.CharCode = VK_UP) or (Message.CharCode = VK_DOWN)) and (KeyShift) and (KeyControl) then begin
            prChangePoint(Message.CharCode = VK_UP);
          end;
          prDrawDataSel;
        finally
          prKeyeing := False;
        end;
        Eaten := True;
      end;

    Word('H')://Expand
      begin
        if prDataSource <> nil then begin
          //if KeyControl then begin
            TQUB_QVO_QVD(prDataSource).ExpandZoom;
            Eaten := True;
          //end;
        end;
      end;

    Word('U')://Un-Expand
      begin
        if prDataSource <> nil then begin
          //if KeyControl then begin
            TQUB_QVO_QVD(prDataSource).UnExpandZoom;
            Eaten := True;
          //end;
        end;
      end;

    Word('F')://FindTrace
      begin
        if prDataSource <> nil then begin
          TQUB_QVO_QVD(prDataSource).FindTrace;
          Eaten := True;
        end;
      end;

    Word('L')://Add List
      begin
        if prDataSource <> nil then begin
          TQUB_QVO_QVD(prDataSource).AddList;
          Eaten := True;
        end;
      end;

    Word('S')://Add Selection
      begin
        if prDataSource <> nil then begin
          if TQUB_QVO_QVD(prDataSource).DrawListOverlapped then begin
            TQUB_QVO_QVD(prDataSource).AddSelections(True{FromZoom});
          end else begin
            TQUB_QVO_QVD(prDataSource).AddSelection;
          end;
          Eaten := True;
        end;
      end;

    Word('A')://Select All
      begin
        //Do it, useful
      end;

  end;//case

  if not Eaten then inherited;

end;


//****************************************************************************//
//                                                                            //
//                           P R O P E R T I E S                              //
//                                                                            //
//****************************************************************************//

//Interactive properties *******************************************************
procedure TQUB_QVO_QVT.prSetColorData(Index :Integer; c :TColor);
begin
  prColorData[((Index) mod 8)] := c;
  prMustRedraw := True;
end;

function TQUB_QVO_QVT.prGetColorData(Index :Integer) :TColor;
begin
  Result := prColorData[((Index) mod 8)];
end;

procedure TQUB_QVO_QVT.prSetColorSel(c :TColor);
begin
  prColorSel := c;
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVT.prSetColorBreak(c :TColor);
begin
  prColorBreak := c;
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVT.prSetColorBaseline(c :TColor);
begin
  prColorBaseline := c;
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVT.prSetColorBaselineNodes(c :TColor);
begin
  prColorBaselineNodes := c;
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVT.prSetColorIdealized(c :TColor);
begin
  prColorIdealized := c;
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVT.prSetColorIdealizedSel(c :TColor);
begin
  prColorIdealizedSel := c;
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVT.prSetColorParameters(c :TColor);
begin
  prColorParameters := c;
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVT.prSetColorCurr(c :TColor);
begin
  prColorCurr := c;
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVT.prSetOverlapChannels(o :Boolean);
begin
  prOverlapChannels := o;
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVT.prSetDrawPoints(p :Boolean);
begin
  prDrawPoints := p;
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVT.prSetDrawInverted(i :Boolean);
begin
  prDrawInverted := i;
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVT.prSetDrawRaster(r :Boolean);
begin
  prDrawRaster := r;
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVT.prSetDrawLabels(l :Boolean);
begin
  prDrawLabels := l;
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVT.prSetDrawMode(m :TQUB_QVO_QVD_DrawMode);
begin
  prDrawMode := m;
  prMustRedraw := True;
end;

function TQUB_QVO_QVT.prGetScaleBarADUnits(Index :Integer) :Integer;
begin
  Result := prScaleBarADUnits[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVT.prSetDataYMin(Index :Integer; m :Integer);
begin
  prDataYMin[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := m;
  prMustRedraw := True;
end;

function TQUB_QVO_QVT.prGetDataYMin(Index :Integer) :Integer;
begin
  Result := prDataYMin[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVT.prSetDataYMax(Index :Integer; m :Integer);
begin
  prDataYMax[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := m;
  prMustRedraw := True;
end;

function TQUB_QVO_QVT.prGetDataYMax(Index :Integer) :Integer;
begin
  Result := prDataYMax[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVT.prSetDataYFactor(Index :Integer; f :Double);
begin
  prDataYFactor[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := f;
  prMustRedraw := True;
end;

function TQUB_QVO_QVT.prGetDataYFactor(Index :Integer) :Double;
begin
  Result := prDataYFactor[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVT.prSetDrawItoG(Index :Integer; d :Boolean);
begin
  prDrawItoG[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := d;
  prMustRedraw := True;
end;

function TQUB_QVO_QVT.prGetDrawItoG(Index :Integer) :Boolean;
begin
  Result := prDrawItoG[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVT.prSetDrawActiveThick(t :Boolean);
begin
  prDrawActiveThick := t;
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVT.prSetDrawBaseline(b :Boolean);
begin
  prDrawBaseline := b;
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVT.prSetDrawBaselineNodes(b :Boolean);
begin
  prDrawBaselineNodes := b;
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVT.prSetDrawIdealized(i :Boolean);
begin
  prDrawIdealized := i;
end;

procedure TQUB_QVO_QVT.prSetDrawIdealizedAbove(a :Boolean);
begin
  prDrawIdealizedAbove := a;
end;

procedure TQUB_QVO_QVT.prSetDrawIdealizedColor(c :Boolean);
begin
  prDrawIdealizedColor := c;
end;

procedure TQUB_QVO_QVT.prSetDrawParameters(p :Boolean);
begin
  prDrawParameters := p;
end;

procedure TQUB_QVO_QVT.prSetDrawListOverlapped(l :Boolean);
begin
  prDrawListOverlapped := l;
end;

procedure TQUB_QVO_QVT.prSetChannelVisible(Index :Integer; b :Boolean);
begin
  prChannelVisible[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := b;
  prMustRedraw := True;
end;

function TQUB_QVO_QVT.prGetChannelVisible(Index :Integer) :Boolean;
begin
  Result := prChannelVisible[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVT.prSetDataChannelName(Index :Integer; x :String);
begin
  prDataChannelName[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := x;
  if prDrawLabels then prMustRedraw := True;
end;

function TQUB_QVO_QVT.prGetDataChannelName(Index :Integer): String;
begin
  Result := prDataChannelName[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVT.prSetDataChannelUnits(Index :Integer; x :String);
begin
  prDataChannelUnits[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := x;
  if prDrawLabels then prMustRedraw := True;
end;

function TQUB_QVO_QVT.prGetDataChannelUnits(Index :Integer): String;
begin
  Result := prDataChannelUnits[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVT.prSetDataChannelScaling(Index :Integer; x :Double);
begin
  prDataChannelScaling[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := x;
  if prDrawLabels then prMustRedraw := True;
end;

function TQUB_QVO_QVT.prGetDataChannelScaling(Index :Integer) :Double;
begin
  Result := prDataChannelScaling[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVT.prSetDataChannelOffset(Index :Integer; x :Double);
begin
  prDataChannelOffset[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := x;
  if prDrawLabels then prMustRedraw := True;
end;

function TQUB_QVO_QVT.prGetDataChannelOffset(Index :Integer) :Double;
begin
  Result := prDataChannelOffset[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

//Graphics settings
procedure TQUB_QVO_QVT.prSetXAxisTickCount(c :Integer);
begin
  prXAxisTickCount := c;
  if prDrawLabels then prMustRedraw := True;
end;

function TQUB_QVO_QVT.prGetXAxisTickCount :Integer;
begin
  Result := prXAxisTickCount;
end;

procedure TQUB_QVO_QVT.prSetYAxisTickCount(Index :Integer; c :Integer);
begin
  prYAxisTickCount[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := c;
  if prDrawLabels then prMustRedraw := True;
end;

function TQUB_QVO_QVT.prGetYAxisTickCount(Index :Integer) :Integer;
begin
  Result := prYAxisTickCount[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVT.prSetDataBaseline(Index :Integer; b :Integer);
begin
  prDataBaseline[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := b;
  prMustRedraw := True;
end;

function TQUB_QVO_QVT.prGetDataBaseline(Index :Integer) :Integer;
begin
  Result := prDataBaseline[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

function  TQUB_QVO_QVT.prGetBaselineNodes(Ix :Integer): TQUB_Baseline;
begin
  Result := prBaselineNodes[Ix mod QUB_QFS_QDF_MAX_ADCHANNELCOUNT];
end;

procedure TQUB_QVO_QVT.prSetBaselineNodes(Ix :Integer; x :TQUB_Baseline);
begin
  prBaselineNodes[Ix mod QUB_QFS_QDF_MAX_ADCHANNELCOUNT] := x;
  prMustRedraw := True;
end;

//******************************************************************************


procedure TQUB_QVO_QVT.prSetDataCurr(c :Integer);
var
  Avg        :Double;
  Std        :Double;
  VoI        :Double;
  p, f, l    :Integer;
  Scl        :Double;
  AvgHint    :String;
  StdHint    :String;
  VoIHint    :String;
  List       :TQUB_QVO_QVD_SelectionList;
  Sel        :TQUB_QVO_QVD_Selection;
  First      :Integer;
  Last       :Integer;
  DrawFirst  :Integer;
  DrawLast   :Integer;
  Offset     :Integer;
  ch         :Integer;
begin

  prDataCurr     := c;
  prDataOldCurr  := prDataCurr;

  AvgHint  := '';
  StdHint  := '';
  VoIHint  := '';

  //TO DO: LM. Still buggy.

  if prData <> nil then begin

    First     := prDataSel.First;
    Last      := prDataSel.Last;
    DrawFirst := TQUB_QVO_QVD(prDataSource).DataDraw.First;
    DrawLast  := TQUB_QVO_QVD(prDataSource).DataDraw.Last;
    Offset    := 0;

    Sel := nil;

    if prDrawListOverlapped then begin
      List := TQUB_QVO_QVD(prDataSource).CurrList;
      if List <> nil then Sel := List.CurrSelection else Sel := nil;
      if Sel <> nil then begin
        First := Sel.Sel.First + TQUB_QVO_QVD(prDataSource).DataSel.First + First;
        Last  := Sel.Sel.First + TQUB_QVO_QVD(prDataSource).DataSel.First + Last;
      end;
    end else begin
        First :=                 TQUB_QVO_QVD(prDataSource).DataSel.First + First - prDataDraw.First;
        Last  :=                 TQUB_QVO_QVD(prDataSource).DataSel.First + Last  - prDataDraw.First;
    end;

    //Sel := prDataSel;

    if ((not prDrawListOverlapped) and ((First - DrawFirst) >= prDataDraw.First) and ((Last - DrawFirst) <= prDataDraw.Last)) or
       ((prDrawListOverlapped) and (Sel <> nil))                                                                              then begin

      f := First;
      l := Last;
      if f < DrawFirst then f := DrawFirst;
      if f > DrawLast  then f := DrawLast;
      if l < DrawFirst then l := DrawFirst;
      if l > DrawLast  then l := DrawLast;

      f := f - DrawFirst;
      l := l - DrawFirst;

      for ch := 0 to prDataChannelCount - 1 do begin

        Avg := 0;
        Std := 0;
        Scl := 1 / Scaling;
        try
          for p := f to l do begin
            Avg := Avg + Scl * prData[ch, p];
          end;
        except
        end;
        Avg := Avg / (l - f + 1);
        try
          for p := f to l do begin
            Std := Std + Sqr(Scl * prData[ch, p] - Avg);
          end;
        except
        end;
        Std := Sqrt(Std / (l - f + 1));

        //AvgHint := AvgHint + FormatFloat('0.0000e+', Avg);
        //StdHint := StdHint + FormatFloat('0.0000e+', Std);
        AvgHint := AvgHint + Format('%10.6g ' + DataChannelUnits[ch], [Avg/DataChannelScaling[ch]+DataChannelOffset[ch]]);
        StdHint := StdHint + Format('%10.6g ' + DataChannelUnits[ch], [Std/DataChannelScaling[ch]+DataChannelOffset[ch]]);

        if (Avg/DataChannelScaling[c]+DataChannelOffset[c]) <> 0.0 then begin
          VoI := (Std/DataChannelScaling[ch]+DataChannelOffset[ch])*(Std/DataChannelScaling[ch]+DataChannelOffset[ch])/(Avg/DataChannelScaling[ch]+DataChannelOffset[ch]);
        end else begin
          VoI := 0.0;
        end;
        VoIHint := VoIHint + Format('%10.6g', [VoI]);

        if ch < (prDataChannelCount - 1) then begin
          AvgHint := AvgHint + ', ';
          StdHint := StdHint + ', ';
          VoIHint := VoIHint + ', ';
        end;

      end;//ch

    end;//Sel

    if not prDrawListOverlapped then Offset := prDataOffset;

    Hint := 'Start  ' + TimeText((First + Offset) * Sampling) + #13#10 +
            'Length ' + TimeText((Last - First) * Sampling) + #13#10 +
            'Avg         = ' + AvgHint               + #13#10 +
            'Std          = ' + StdHint               + #13#10 +
            'Var / I      = ' + VoIHint               + #13#10 +
            'Points     = ' + IntToStr(Last - First + 1) + '  [' + IntToStr(First + Offset) + ' - ' + IntToStr(Last + Offset) + ']';

  end else begin

    Hint := 'Start  ' + TimeText((0) * Sampling) + #13#10 +
            'Length ' + TimeText((0) * Sampling) + #13#10 +
            'Avg         = ' + AvgHint               + #13#10 +
            'Std          = ' + StdHint               + #13#10 +
            'Var / I      = ' + VoIHint               + #13#10 +
            'Points     = ' + IntToStr(0) + '  [' + IntToStr(0) + ' - ' + IntToStr(0) + ']';

  end;//prData <> nil

  if Assigned(prOnChangeSel) then begin
    prOnChangeSel(Self);
  end;

end;

function TQUB_QVO_QVT.GetSelection :TQUB_FirstLast;
var
  //Avg        :Double;
  //Std        :Double;
  //p          :Integer;
  //Scl        :Double;
  //AvgHint    :String;
  //StdHint    :String;
  List       :TQUB_QVO_QVD_SelectionList;
  Sel        :TQUB_QVO_QVD_Selection;
  //First      :Integer;
  //Last       :Integer;
  DrawFirst  :Integer;
  Offset     :Integer;
  //ch         :Integer;
begin

  Result.First := prDataSel.First;
  Result.Last  := prDataSel.Last;
  DrawFirst    := TQUB_QVO_QVD(prDataSource).DataDraw.First;
  Offset       := 0;

  Sel := nil;

  if prDrawListOverlapped then begin
    List := TQUB_QVO_QVD(prDataSource).CurrList;
    if List <> nil then Sel := List.CurrSelection else Sel := nil;
    if Sel <> nil then begin
      Result.First := Sel.Sel.First + TQUB_QVO_QVD(prDataSource).DataSel.First + Result.First;
      Result.Last  := Sel.Sel.First + TQUB_QVO_QVD(prDataSource).DataSel.First + Result.Last;
    end;
  end;

  //if ((not prDrawListOverlapped) and (First >= prDataDraw.First) and (Last <= prDataDraw.Last)) or
  //   ((prDrawListOverlapped) and (Sel <> nil))                                                  then begin

    //First - DrawFirst;
    //Last - DrawFirst;

  //end;//Sel

  //if not prDrawListOverlapped then Offset := prDataOffset;

  Result.First := Result.First + Offset;
  Result.Last  := Result.Last + Offset;
end;



procedure TQUB_QVO_QVT.prSetPopUpMenu(p :TPopUpMenu);
begin
  inherited PopUpMenu := p;
end;

//File methods *****************************************************************
function TQUB_QVO_QVT.New(const FileName :String) :Boolean;
begin
  Result := False;
end;
function TQUB_QVO_QVT.Open(const FileName :String) :Boolean;
begin
  Result := False;
end;
function TQUB_QVO_QVT.Open(const FileName :String; OpenStream :TStream) :Boolean;
begin
  Result := False;
end;
function TQUB_QVO_QVT.Save(const FileName :String) :Boolean;
begin
  Result := False;
end;
function TQUB_QVO_QVT.Close :Boolean;
begin
  Result := False;
end;
function TQUB_QVO_QVT.OpenFromString(const MemFile :String) :Boolean;
begin
  Result := False;
end;
function TQUB_QVO_QVT.SaveToString(var MemFile :String; FileType :Integer) :Boolean; 
begin
  Result := False;
end;



//******************************************************************************
procedure Register;
begin
  RegisterComponents('QUB', [TQUB_QVO_QVT]);
end;


//******************************************************************************
end.

