{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
// no clue


unit QUB_Socket;


interface


const


QUB_SOCKET_PORT                       = 654;


type


TQUB_Socket_ID_Task                   = (QUB_SOCKET_ID_TASK_NULL,
                                         QUB_SOCKET_ID_TASK_SERVER,
                                         QUB_SOCKET_ID_TASK_IDEALIZE, QUB_SOCKET_ID_TASK_BASELINE
                                        );

TQUB_Socket_ID_Thread                 = (QUB_SOCKET_ID_THREAD_NULL,
                                         QUB_SOCKET_ID_THREAD_SERVER,
                                         QUB_SOCKET_ID_THREAD_IDEALIZE, QUB_SOCKET_ID_THREAD_BASELINE
                                        );


TQUB_Socket_Expect                    = (QUB_SOCKET_EXPECT_NOTHING,
                                         QUB_SOCKET_EXPECT_SEND_IDENTIFICATION,   QUB_SOCKET_EXPECT_RECV_IDENTIFICATION,
                                         QUB_SOCKET_EXPECT_RECV_SERVICEAVAILABLE,
                                         QUB_SOCKET_EXPECT_RECV_SERVICESTARTED,
                                         QUB_SOCKET_EXPECT_RECV_REQUESTS,
                                         QUB_SOCKET_EXPECT_RECV_ACK
                                        );

TQUB_Socket_Identification            = record
  Task                                :TQUB_Socket_ID_Task;
  Thread                              :TQUB_Socket_ID_Thread;
end;
TQUB_Socket_PIdentification           = ^TQUB_Socket_Identification;


TQUB_Socket_ServiceAvailable          = record
  Available                           :Boolean;
end;

TQUB_Socket_ServiceStarted            = record
  Started                             :Boolean;
end;


TQUB_Socket_Message                   = record
  Message                             :Integer;
  Size                                :Integer;
  Data                                :Array[0..63 - 2 * SizeOf(Integer)] of Byte; //Used for user defined Requests
end;
TQUB_Socket_PMessage                  = ^TQUB_Socket_Message;


TQUB_Socket_Message_State             = (MSGSTATE_UNINITIALIZED,
                                         MSGSTATE_UPDATING,
                                         MSGSTATE_READING
                                        );



const



//Errors
QUB_SOCKET_ERROR_CLIENT_UNSUPPORTED   =   0;

QUB_SOCKET_ERROR_USER_DEFINED         = 255;




//Messages
QUB_SOCKET_MESSAGE_NULL               =   0;//Data is empty
QUB_SOCKET_MESSAGE_ACK                =   1;//Data is True or False
QUB_SOCKET_MESSAGE_CLIENT_ID          =   2;//Data has the Client's ID
QUB_SOCKET_MESSAGE_SERVER_ID          =   3;//Data has the Server's ID
QUB_SOCKET_MESSAGE_ERROR              =   4;//Data has the error message/code
QUB_SOCKET_MESSAGE_INIT_SERVICE       =   5;//Data is empty
QUB_SOCKET_MESSAGE_START_SERVICE      =   6;//Data is empty
QUB_SOCKET_MESSAGE_STOP_SERVICE       =   7;//Data is empty
QUB_SOCKET_MESSAGE_SERVICE_STATUS     =   8;//Data is empty
QUB_SOCKET_MESSAGE_SERVICE_STOPPED    =   9;//Data is empty
QUB_SOCKET_MESSAGE_SERVICE_TERMINATED =  10;//Data is empty

QUB_SOCKET_MESSAGE_USER_DEFINED       = 255;//Data is decripted by the thread




implementation

end.
