{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
unit QUB_Task_DataWav_Properties;


interface


uses


Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, ComCtrls, Registry,

RegistryInterface,

QUB_Task,
QUB_Properties,
QUB_Task_Properties,
QUB_Task_Data_Properties,
QUB_Node;

//{$include 'QUB_Task_DataWav_Properties.hct'}

const


//Data Source
DEF_DATA_SOURCE               = DATA_SOURCE_WHOLEFILE;

DEF_DATAWAV_SCALE             :Double = 1.0;
MIN_DATAWAV_SCALE             :Double = 1.0e-3;
MAX_DATAWAV_SCALE             :Double = 1.0e9;

type


TQUB_Task_DataWav_PropertiesForm = class(TQUB_Task_PropertiesForm)
  Label3                          :TLabel;

  btnReset                        :TButton;

  panDataSource                   :TPanel;
  panDataSourceFile               :TPanel;
  chkDataSourceWholeFile          :TRadioButton;
  chkDataSourceSelectionList      :TRadioButton;
  chkDataSourceSelection          :TRadioButton;
    panOptions: TPanel;
    Label1: TLabel;
    txtScale: TEdit;


  procedure FormCreate(Sender: TObject);
  procedure FormShow(Sender: TObject);

  procedure chkDataSourceClick(Sender: TObject);


protected


  //Data Source
  prDataSource                    :TQUB_Task_Data_Source;
  prDataSourceInFile              :TQUB_Task_Data_Source;

  //Data Source
  procedure prSetDataSource(s :TQUB_Task_Data_Source);


public

  //Data Source
  property DataSource                     :TQUB_Task_Data_Source     read prDataSource                write prSetDataSource;


end;


implementation


{$R *.DFM}


//******************************************************************************
//Data Source
procedure TQUB_Task_DataWav_PropertiesForm.prSetDataSource(s :TQUB_Task_Data_Source);
begin
  prDataSource                       := s;
  chkDataSourceWholeFile.Checked     := DataSource =  DATA_SOURCE_WHOLEFILE;
  chkDataSourceSelectionList.Checked := DataSource =  DATA_SOURCE_SELECTIONLIST;
  chkDataSourceSelection.Checked     := DataSource =  DATA_SOURCE_SELECTION;
end;

procedure TQUB_Task_DataWav_PropertiesForm.chkDataSourceClick(Sender: TObject);
begin
  inherited;
  DataSource := TQUB_Task_Data_Source(TRadioButton(Sender).Tag);
end;
//******************************************************************************
procedure TQUB_Task_DataWav_PropertiesForm.FormCreate(Sender: TObject);
begin
  inherited;

  AddEditProperty(TQUB_Property_Edit.Create('["TimeScaling"]',
                    'Scale', REGTYPE_FLOAT, DEF_DATAWAV_SCALE,
                    txtScale,
                    AcceptFloatBetween(MIN_DATAWAV_SCALE, MAX_DATAWAV_SCALE),
                    '%.6g') );
                    
  RegKeyName            := 'Software\QUB\Task DataWav';
  ProfileCat            := 'dWAV';

  WikiTopic             := 'Actions:Sound';

//  {$include 'QUB_Task_DataWav_Properties.htx'}
end;

procedure TQUB_Task_DataWav_PropertiesForm.FormShow(Sender: TObject);
begin
  inherited;

  DataSource             := DataSource;

end;


//******************************************************************************
end.

