{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
unit QUB_Task_Data_Properties;


interface


uses


Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, ComCtrls, Registry,

RegistryInterface,

QUB_Properties,
QUB_Task,
QUB_Task_Data,
QUB_Task_Properties,
QUB_Node,
QUB_Profiles;


const

//Data Processed
DEF_DATA_PROCESSED            = DATA_PROCESSED_ASDISPLAYED;

DEF_PROCESSFILTER             = 1;
DEF_PROCESSFILTERFREQ       :Double  = 5000.0;
MIN_PROCESSFILTERFREQ       :Double  = 100.0;
MAX_PROCESSFILTERFREQ       :Double  = 100000.0;

DEF_PROCESSBASELINE           = 1;


type


TQUB_Task_Data_PropertiesForm = class(TQUB_Task_PropertiesForm)
  panXDataProcessed                :TPanel;
  lblXDataProcessed                :TLabel;
  chkXDataProcessedNone            :TRadioButton;
  chkXDataProcessedAsSuch          :TRadioButton;
  chkXDataProcessedAsDisplayed     :TRadioButton;
  chkXProcessFilter                :TCheckBox;
  txtXProcessFilterFreq            :TEdit;
  chkXProcessBaseline              :TCheckBox;

  procedure FormCreate(Sender: TObject);

end;


implementation


{$R *.DFM}


//******************************************************************************
procedure TQUB_Task_Data_PropertiesForm.FormCreate(Sender: TObject);
begin
  inherited;

  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["ProcessData"]',
                          'Data Processed', REGTYPE_INT, DataProcessedToString(DEF_DATA_PROCESSED))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkXDataProcessedNone,
                                       DataProcessedToString(DATA_PROCESSED_NONE),
                                       Integer(DATA_PROCESSED_NONE)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkXDataProcessedAsDisplayed,
                                       DataProcessedToString(DATA_PROCESSED_ASDISPLAYED),
                                       Integer(DATA_PROCESSED_ASDISPLAYED)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkXDataProcessedAsSuch,
                                       DataProcessedToString(DATA_PROCESSED_ASSUCH),
                                       Integer(DATA_PROCESSED_ASSUCH))
                               .Enables(chkXProcessFilter)
                               .Enables(chkXProcessBaseline)
                             )
                       );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["ProcessData"]["Filter"]',
                        'Process Filter', REGTYPE_BOOL, DEF_PROCESSFILTER,
                        chkXProcessFilter)
                       .Enables(txtXProcessFilterFreq) );
  AddEditProperty(TQUB_Property_Edit.Create('["ProcessData"]["FilterFreq"]',
                    'Process Filter Freq', REGTYPE_FLOAT, DEF_PROCESSFILTERFREQ,
                    txtXProcessFilterFreq,
                    'lambda x: acceptFloatBetween('+FloatToStr(MIN_PROCESSFILTERFREQ/1000)+', '+FloatToStr(MAX_PROCESSFILTERFREQ/1000)+')(x) * 1000.0',
                    'lambda node, ix: str(node.data[ix] / 1000.0)') );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["ProcessData"]["Baseline"]',
                        'Process Baseline', REGTYPE_BOOL, DEF_PROCESSBASELINE,
                        chkXProcessBaseline));
end;


//******************************************************************************
end.

