unit QUB_Task_IdlBase_Properties;

{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}

interface


uses


Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, ComCtrls, Registry,

RegistryInterface,

QUB_QFS_Channels,
QUB_Task,
QUB_Properties,
QUB_Task_Properties,
QUB_Task_Data_Properties,
QUB_IdlBase_Global,
QUB_Node, QUB_QFS,
QUB_Movies;


const


//Data Source
DEF_DATA_SOURCE               = DATA_SOURCE_SELECTION;

DEF_MOVIE_MAKE                = 0;
DEF_MOVIE_SAVEBITMAPS         = 0;
DEF_MOVIE_SHOWTITLES          = 0;
DEF_MOVIE_MAXFRAMECOUNT       = 100;
MIN_MOVIE_MAXFRAMECOUNT       = 0;
MAX_MOVIE_MAXFRAMECOUNT       = 1000;

MIN_MOVIE_PENWIDTH            = 0;
MAX_MOVIE_PENWIDTH            = 10;

DEF_MOVIE_IDL_PENWIDTH        = 0;
DEF_MOVIE_BASEX_PENWIDTH      = 0;
DEF_MOVIE_BASEP_PENWIDTH      = 0;

DEF_MOVIE_FOR_BASEX_COLOR     = clWhite;
DEF_MOVIE_FOR_BASEP_COLOR     = clGray;
DEF_MOVIE_FOR_IDL_COLOR       = clLime;
DEF_MOVIE_BAC_BASEX_COLOR     = clWhite;
DEF_MOVIE_BAC_BASEP_COLOR     = clGray;
DEF_MOVIE_BAC_IDL_COLOR       = clLime;
(*
DEF_MOVIE                     :TQUB_MovieRec  = (
  Make                        :DEF_MOVIE_MAKE;
  SaveBitmaps                 :DEF_MOVIE_SAVEBITMAPS;
  ShowTitles                  :DEF_MOVIE_SHOWTITLES;
  MaxFrameCount               :DEF_MOVIE_MAXFRAMECOUNT;
  IDLPenWidth                 :DEF_MOVIE_IDL_PENWIDTH;
  BaseXPenWidth               :DEF_MOVIE_BASEX_PENWIDTH;
  BasePPenWidth               :DEF_MOVIE_BASEP_PENWIDTH;
  ForBaseXColor               :DEF_MOVIE_FOR_BASEX_COLOR;
  ForBasePColor               :DEF_MOVIE_FOR_BASEP_COLOR;
  BacBaseXColor               :DEF_MOVIE_BAC_BASEX_COLOR;
  BacBasePColor               :DEF_MOVIE_BAC_BASEP_COLOR;
  ForIDLColor                 :DEF_MOVIE_FOR_IDL_COLOR;
  BacIDLColor                 :DEF_MOVIE_BAC_IDL_COLOR;
);
*)

type


TQUB_Task_IdlBase_PropertiesForm = class(TQUB_Task_Data_PropertiesForm)


  Label6                          :TLabel;
  Label7                          :TLabel;

  btnReset                        :TButton;
  panMethod                       :TPanel;
  panDataSource                   :TPanel;
  chkDataSourceWholeFile          :TRadioButton;
  chkDataSourceSelectionList      :TRadioButton;
  chkDataSourceSelection          :TRadioButton;
  Panel1                          :TPanel;
  chkReestNone                    :TRadioButton;
  chkReestSKM                     :TRadioButton;
  chkReestBW                      :TRadioButton;
  Label3                          :TLabel;
  Panel2                          :TPanel;
  Label4                          :TLabel;
  chkMLSSViterbi                  :TRadioButton;
  chkMLSSGamma                    :TRadioButton;
  Panel3                          :TPanel;
  Label9                          :TLabel;
  chkBaselineTrack                :TCheckBox;
  lblBaselineStd                  :TLabel;
  txtBaselineStd                  :TEdit;
  Panel4                          :TPanel;
  chkDropFirstLastIfClosed        :TCheckBox;
  chkDropFirstLastIfOpen          :TCheckBox;
  chkBaselineCorrect              :TCheckBox;
  lblBaselineMinY                 :TLabel;
  txtBaselineMinY                 :TEdit;
  Panel5                          :TPanel;
  Label14                         :TLabel;
  Panel6                          :TPanel;
  Label15                         :TLabel;
  txtSKMClass                     :TEdit;
  udSKMClass                      :TUpDown;
  chkFixKinetics                  :TCheckBox;
  chkFixAmp                       :TCheckBox;
  chkFixStd                       :TCheckBox;
  Label16                         :TLabel;

  panStaircase                    :TPanel;
  txtStaircaseMaxJump             :TEdit;
  udStaircaseMaxJump              :TUpDown;
  chkStaircase                    :TCheckBox;
  lblStaircaseMaxJump             :TLabel;
  chkStaircaseReestBW             :TCheckBox;
  chkStaircaseRightOnly           :TCheckBox;
  chkStaircaseGlobalReEst         :TCheckBox;
  chkStaircaseUpdateRefState      :TCheckBox;
  lblStaircaseUpdateRefStateEvery :TLabel;
  txtStaircaseUpdateRefStateEvery :TEdit;
  udStaircaseUpdateRefStateEvery  :TUpDown;
  lblStaircaseBaseJumpVar         :TLabel;
  txtStaircaseBaseJumpVar         :TEdit;
  lblStaircaseJumpAmpPlsMin       :TLabel;
  txtStaircaseJumpAmpPlsMin       :TEdit;
  udStaircaseJumpAmpPlsMin        :TUpDown;
  txtStaircaseJumpStd             :TEdit;
  chkStaircaseJumpStdReest        :TCheckBox;
  lblStaircaseJumpStd             :TLabel;
  txtStaircaseMergeDwellsPercent  :TEdit;
  chkStaircaseMergeDwells         :TCheckBox;
  chkStaircaseSplitDwells         :TCheckBox;
  txtStaircaseSplitDwellsPercent  :TEdit;
  chkStaircaseLLAddJump           :TCheckBox;
  chkStaircaseJumpStdWeighed      :TCheckBox;
  chkStaircaseJumpAmpWeighed      :TCheckBox;
  lblStaircaseJumpStdMinGamma     :TLabel;
  txtStaircaseJumpStdMinGamma     :TEdit;
  txtStaircaseJumpAmpWeight       :TEdit;
  txtStaircaseJumpAmps0           :TEdit;
  txtStaircaseJumpAmps1           :TEdit;
  chkStaircaseJumpAmpUniformSteps :TRadioButton;
  chkStaircaseJumpAmpAlternateSteps:TRadioButton;
  chkStaircaseJumpAmpConsecutive  :TRadioButton;
  chkStaircaseJumpAmpCombinations :TRadioButton;
  chkStaircaseJumpAmpConstrained  :TRadioButton;
  chkStaircaseJumpAmpUseInit      :TCheckBox;
  txtStaircaseBaseAmp             :TEdit;
  chkStaircaseBaseAmpUseInit      :TCheckBox;
  chkStaircaseJumpAmpReestimate   :TCheckBox;
  txtStaircaseMeasStd             :TEdit;
  chkStaircaseMeasStdReest        :TCheckBox;
  chkStaircaseMeasStdUseInit      :TCheckBox;
  txtStaircaseKineticsKf          :TEdit;
  chkStaircaseKineticsReest       :TCheckBox;
  txtStaircaseKineticsKb          :TEdit;
  chkStaircaseKineticsUseInit     :TCheckBox;

  chkReplaceIDL                   :TCheckBox;
  chkQuietOutput                  :TCheckBox;
  chkBaselineBackKalman           :TCheckBox;
  lblBaselineFBKCount             :TLabel;
  txtBaselineFBKCount             :TEdit;
  udBaselineFBKCount              :TUpDown;
  lblBaselineFKCount              :TLabel;
  txtBaselineFKCount              :TEdit;
  udBaselineFKCount               :TUpDown;
  chkMLSSFV                       :TRadioButton;
  Panel8                          :TPanel;
  chkMovieMake                    :TCheckBox;
  lblMovieMaxFrameCount           :TLabel;
  txtMovieMaxFrameCount           :TEdit;
  chkMovieSaveBitmaps             :TCheckBox;
  chkMovieShowTitles              :TCheckBox;
  Label10                         :TLabel;
  udMovieIdlPenWidth              :TUpDown;
  txtMovieIDLPenWidth             :TEdit;
  Label11                         :TLabel;
  txtMovieBaseXPenWidth           :TEdit;
  udMovieBaseXPenWidth            :TUpDown;
  Label12                         :TLabel;
  txtMovieBasePPenWidth           :TEdit;
  udMovieBasePPenWidth            :TUpDown;
  panMovieForIDLColor             :TPanel;
  panMovieBacIDLColor             :TPanel;
  panMovieForBaseXColor           :TPanel;
  panMovieBacBaseXColor           :TPanel;
  panMovieForBasePColor           :TPanel;
  panMovieBacBasePColor           :TPanel;
  chkBaselineReestPar             :TCheckBox;
  chkA2Q                          :TCheckBox;
  chkA2QEveryIter                 :TCheckBox;
  chkA2QEval                      :TCheckBox;
    panStaircaseStepAmp: TPanel;
    panStaircaseStepStd: TPanel;
    panStaircaseTricks: TPanel;
    lblStaircaseMergeDwellsPercent: TLabel;
    lblStaircaseSplitDwellsPercent: TLabel;
  chkQuietOutputEveryIter         :TCheckBox;
    lblStaircaseStepModel: TLabel;
    panStaircaseStepModel: TPanel;
  Panel13                         :TPanel;
    lblStaircaseJumpAmpWeight: TLabel;
    panStaircaseBaseAmp: TPanel;
    lblStaircaseBaseAmp: TLabel;
    panStaircaseMeasStd: TPanel;
    lblStaircaseTricks: TLabel;
    panStaircaseKinetics: TPanel;
    lblStaircaseKineticsKb: TLabel;
    lblStaircaseKineticsKf: TLabel;
    chkApplyDeadTime: TCheckBox;
    txtDeadTime: TEdit;
    lblMaxIter: TLabel;
    lblLLConv: TLabel;
    txtMaxIter: TEdit;
    txtLLConv: TEdit;
    Label1: TLabel;
    Panel7: TPanel;
    Label2: TLabel;
    chkOutputGroup: TRadioButton;
    chkOutputClass: TRadioButton;
    txtBaselineDecFactor: TEdit;
    udBaselineDecFactor: TUpDown;
    lblBaselineDecFactor: TLabel;


  procedure FormCreate(Sender: TObject);
  procedure FormShow(Sender: TObject);
  procedure FormHide(Sender: TObject);

  procedure chkDataSourceClick(Sender: TObject);


protected


  //Data Source
  prDataSource                    :TQUB_Task_Data_Source;

  //Make movies
  prMovie                         :TQUB_MovieRec;

  //Parameters
  prParams                        :TQUB_IdlBase_Params;

  //Data Source
  procedure prSetDataSource(s :TQUB_Task_Data_Source);

  //TO DO: LM. Implement these in the same way - Chris, John?
  //Kinetics
  procedure prSetStaircaseKinetics(Index :Integer; k :Double);
  function prGetStaircaseKinetics(Index :Integer) :Double;
  procedure prSetStaircaseJumpAmps(Index :Integer; a :Double);
  function prGetStaircaseJumpAmps(Index :Integer) :Double;


public


  procedure PropertiesToParams;


  //Data Source
  property DataSource                     :TQUB_Task_Data_Source      read prDataSource                           write prSetDataSource;

  //Movies
  property Movie                          :TQUB_MovieRec              read prMovie;
  property MovieMake                      :Boolean                    read prMovie.Make;                           
  property MovieSaveBitmaps               :Boolean                    read prMovie.SaveBitmaps;                    
  property MovieShowTitles                :Boolean                    read prMovie.ShowTitles;                     
  property MovieMaxFrameCount             :Integer                    read prMovie.MaxFrameCount;                  
  property MovieIDLPenWidth               :Integer                    read prMovie.IDLPenWidth;                    
  property MovieBaseXPenWidth             :Integer                    read prMovie.BaseXPenWidth;                  
  property MovieBasePPenWidth             :Integer                    read prMovie.BaseXPenWidth;                  
  property MovieForBaseXColor             :TColor                     read prMovie.ForBaseXColor;                  
  property MovieForBasePColor             :TColor                     read prMovie.ForBasePColor;                  
  property MovieForIDLColor               :TColor                     read prMovie.ForIDLColor;                    
  property MovieBacBaseXColor             :TColor                     read prMovie.BacBaseXColor;                  
  property MovieBacBasePColor             :TColor                     read prMovie.BacBasePColor;                  
  property MovieBacIDLColor               :TColor                     read prMovie.BacIDLColor;                    

  //Parameters
  property Params                         :TQUB_IdlBase_Params        read prParams;

  property Reestimation                   :TQUB_IdlBase_Reestimation  read prParams.Reestimation;
  property A2Q                            :Boolean                    read prParams.A2Q;                           
  property A2QEveryIter                   :Boolean                    read prParams.A2QEveryIter;                  
  property A2QEval                        :Boolean                    read prParams.A2QEval;                       
  property MLSS                           :TQUB_IdlBase_MLSS          read prParams.MLSS;
  property Output                         :TQUB_IdlBase_Output        read prParams.Output;

  property LLConv                         :Double                     read prParams.LLConv;
  property MaxIter                        :Integer                    read prParams.MaxIter;

  property FixKinetics                    :Boolean                    read prParams.FixKinetics;
  property FixAmp                         :Boolean                    read prParams.FixAmp;
  property FixStd                         :Boolean                    read prParams.FixStd;

  property DropFirstLastIfClosed          :Boolean                    read prParams.DropFirstLastIfClosed;
  property DropFirstLastIfOpen            :Boolean                    read prParams.DropFirstLastIfOpen;

  property ApplyDeadTime                  :Boolean                    read prParams.ApplyDeadTime;
  property DeadTime                       :Double                     read prParams.DeadTime;

  property BaselineTrack                  :Boolean                    read prParams.BaselineTrack;
  property BaselineBackKalman             :Boolean                    read prParams.BaselineBackKalman;
  property BaselineStd                    :Double                     read prParams.BaselineStd;
  property BaselineCorrect                :Boolean                    read prParams.BaselineCorrect;
  property BaselineDecFactor              :Integer                    read prParams.BaselineDecFactor;
  property BaselineMinY                   :Integer                    read prParams.BaselineMinY;
  property BaselineFBKCount               :Integer                    read prParams.BaselineFBKCount;
  property BaselineFKCount                :Integer                    read prParams.BaselineFKCount;
  property BaselineReestPar               :Boolean                    read prParams.BaselineReestPar;

  property Staircase                      :Boolean                    read prParams.Staircase;
  property StaircaseMaxJump               :Integer                    read prParams.StaircaseMaxJump;
  property StaircaseReestBW               :Boolean                    read prParams.StaircaseReestBW;
  property StaircaseRightOnly             :Boolean                    read prParams.StaircaseRightOnly;
  property StaircaseBaseJumpVar           :Double                     read prParams.StaircaseBaseJumpVar;
  property StaircaseGlobalReest           :Boolean                    read prParams.StaircaseGlobalReest;
  property StaircaseUpdateRefState        :Boolean                    read prParams.StaircaseUpdateRefState;
  property StaircaseUpdateRefStateEvery   :Integer                    read prParams.StaircaseUpdateRefStateEvery;
  property StaircaseLLAddJump             :Boolean                    read prParams.StaircaseLLAddJump;            

  //TO DO: LM.
  property StaircaseKineticsReest         :Boolean                    read prParams.StaircaseKineticsReest;
  property StaircaseKineticsUseInit       :Boolean                    read prParams.StaircaseKineticsUseInit;
  property StaircaseKinetics[Index :Integer] :Double                  read prGetStaircaseKinetics                      write prSetStaircaseKinetics;

  property StaircaseJumpAmpReestimate     :Boolean                    read prParams.StaircaseJumpAmpReestimate;
  property StaircaseJumpAmpReestMethod    :TQUB_IdlBase_JumpAmpReestMethod  read prParams.StaircaseJumpAmpReestMethod;
  property StaircaseJumpAmpUseInit        :Boolean                    read prParams.StaircaseJumpAmpUseInit;
  property StaircaseJumpAmpStepModel      :Integer                    read prParams.StaircaseJumpAmpStepModel;
  property StaircaseJumpAmps[Index :Integer] :Double                  read prGetStaircaseJumpAmps                      write prSetStaircaseJumpAmps;
  property StaircaseJumpAmpWeighed        :Boolean                    read prParams.StaircaseJumpAmpWeighed;
  property StaircaseJumpAmpWeight         :Double                     read prParams.StaircaseJumpAmpWeight;
  property StaircaseJumpAmpPlsMin         :Integer                    read prParams.StaircaseJumpAmpPlsMin;

  property StaircaseJumpStdReest          :Boolean                    read prParams.StaircaseJumpStdReest;
  property StaircaseJumpStd               :Double                     read prParams.StaircaseJumpStd;
  property StaircaseJumpStdMinGamma       :Double                     read prParams.StaircaseJumpStdMinGamma;
  property StaircaseJumpStdWeighed        :Boolean                    read prParams.StaircaseJumpStdWeighed;

  property StaircaseMeasStdReest          :Boolean                    read prParams.StaircaseMeasStdReest;
  property StaircaseMeasStdUseInit        :Boolean                    read prParams.StaircaseMeasStdUseInit;
  property StaircaseMeasStd               :Double                     read prParams.StaircaseMeasStd;

  property StaircaseBaseAmpUseInit        :Boolean                    read prParams.StaircaseBaseAmpUseInit;
  property StaircaseBaseAmp               :Double                     read prParams.StaircaseBaseAmp;

  property StaircaseMergeDwells           :Boolean                    read prParams.StaircaseMergeDwells;
  property StaircaseMergeDwellsPercent    :Double                     read prParams.StaircaseMergeDwellsPercent;
  property StaircaseSplitDwells           :Boolean                    read prParams.StaircaseSplitDwells;
  property StaircaseSplitDwellsPercent    :Double                     read prParams.StaircaseSplitDwellsPercent;

  property ReplaceIDL                     :Boolean                    read prParams.ReplaceIDL;
  property QuietOutput                    :Boolean                    read prParams.QuietOutput;
  property QuietOutputEveryIter           :Boolean                    read prParams.QuietOutputEveryIter;


end;


implementation


{$R *.DFM}


//******************************************************************************
//Data Source
procedure TQUB_Task_IdlBase_PropertiesForm.prSetDataSource(s :TQUB_Task_Data_Source);
begin
  prDataSource                       := s;
  chkDataSourceWholeFile.Checked     := DataSource = DATA_SOURCE_WHOLEFILE;
  chkDataSourceSelectionList.Checked := DataSource = DATA_SOURCE_SELECTIONLIST;
  chkDataSourceSelection.Checked     := DataSource = DATA_SOURCE_SELECTION;
end;

procedure TQUB_Task_IdlBase_PropertiesForm.prSetStaircaseKinetics(Index :Integer; k :Double);
begin
  prParams.StaircaseKinetics[Index]            := k;
  if Index = 0 then txtStaircaseKineticsKf.Text := FloatToStr(k);
  if Index = 1 then txtStaircaseKineticsKb.Text := FloatToStr(k);
end;

function TQUB_Task_IdlBase_PropertiesForm.prGetStaircaseKinetics(Index :Integer) :Double;
begin
  Result := prParams.StaircaseKinetics[Index];
end;


procedure TQUB_Task_IdlBase_PropertiesForm.prSetStaircaseJumpAmps(Index :Integer; a :Double);
begin
  prParams.StaircaseJumpAmps[Index]            := a;
  if Index = 0 then txtStaircaseJumpAmps0.Text := FloatToStr(a);
  if Index = 1 then txtStaircaseJumpAmps1.Text := FloatToStr(a);
end;

function TQUB_Task_IdlBase_PropertiesForm.prGetStaircaseJumpAmps(Index :Integer) :Double;
begin
  Result := prParams.StaircaseJumpAmps[Index];
end;



//******************************************************************************
procedure TQUB_Task_IdlBase_PropertiesForm.FormCreate(Sender: TObject);
begin
  inherited;

  //Movies
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Movie"]["Make"]',
                        '', REGTYPE_NONE, DEF_MOVIE_MAKE,
                        chkMovieMake)
                       .Enables(chkMovieSaveBitmaps)
                       .Enables(chkMovieShowTitles)
                       .Enables(txtMovieMaxFrameCount)
                       .Enables(txtMovieIdlPenWidth)
                       .Enables(udMovieIdlPenWidth)
                       .Enables(txtMovieBaseXPenWidth)
                       .Enables(udMovieBaseXPenWidth)
                       .Enables(txtMovieBasePPenWidth)
                       .Enables(udMovieBasePPenWidth)
                       .Enables(panMovieForIdlColor)
                       .Enables(panMovieBacIdlColor)
                       .Enables(panMovieForBaseXColor)
                       .Enables(panMovieBacBaseXColor)
                       .Enables(panMovieForBasePColor)
                       .Enables(panMovieBacBasePColor)
                     );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Movie"]["SaveBitmaps"]',
                        '', REGTYPE_NONE, DEF_MOVIE_SAVEBITMAPS,
                        chkMovieSaveBitmaps) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Movie"]["ShowTitles"]',
                        '', REGTYPE_NONE, DEF_MOVIE_SHOWTITLES,
                        chkMovieShowTitles) );
  AddEditProperty(TQUB_Property_Edit.Create('["Movie"]["MaxFrameCount"]',
                    '', REGTYPE_NONE, DEF_MOVIE_MAXFRAMECOUNT,
                    txtMovieMaxFrameCount,
                    AcceptIntBetween(MIN_MOVIE_MAXFRAMECOUNT, MAX_MOVIE_MAXFRAMECOUNT),
                    '') );
  AddUpDownProperty(TQUB_Property_UpDown.Create('["Movie"]["IdlPenWidth"]',
                      '', REGTYPE_NONE, DEF_MOVIE_IDL_PENWIDTH,
                      udMovieIdlPenWidth,
                      txtMovieIdlPenWidth,
                      AcceptIntGreaterThan(0)));
  AddUpDownProperty(TQUB_Property_UpDown.Create('["Movie"]["BaseXPenWidth"]',
                      '', REGTYPE_NONE, DEF_MOVIE_BASEX_PENWIDTH,
                      udMovieBaseXPenWidth,
                      txtMovieBaseXPenWidth,
                      AcceptIntGreaterThan(0)));
  AddUpDownProperty(TQUB_Property_UpDown.Create('["Movie"]["BasePPenWidth"]',
                      '', REGTYPE_NONE, DEF_MOVIE_BASEP_PENWIDTH,
                      udMovieBasePPenWidth,
                      txtMovieBasePPenWidth,
                      AcceptIntGreaterThan(0)));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Movie"]["ForIdlColor"]',
                          '', REGTYPE_NONE, Integer(DEF_MOVIE_FOR_IDL_COLOR),
                          panMovieForIdlColor));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Movie"]["BacIdlColor"]',
                          '', REGTYPE_NONE, Integer(DEF_MOVIE_BAC_IDL_COLOR),
                          panMovieBacIdlColor));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Movie"]["ForBaseXColor"]',
                          '', REGTYPE_NONE, Integer(DEF_MOVIE_FOR_BASEX_COLOR),
                          panMovieForBaseXColor));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Movie"]["BacBaseXColor"]',
                          '', REGTYPE_NONE, Integer(DEF_MOVIE_BAC_BASEX_COLOR),
                          panMovieBacBaseXColor));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Movie"]["ForBasePColor"]',
                          '', REGTYPE_NONE, Integer(DEF_MOVIE_FOR_BASEP_COLOR),
                          panMovieForBasePColor));
  AddColorPanelProperty(TQUB_Property_ColorPanel.Create('["Movie"]["BacBasePColor"]',
                          '', REGTYPE_NONE, Integer(DEF_MOVIE_BAC_BASEP_COLOR),
                          panMovieBacBasePColor));

  //Reestimation Method (Nona / SKM / BW)
  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["Reestimation"]',
                          'Reestimation', REGTYPE_INT, ReestimationToString(DEF_REESTIMATION))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkReestNone,
                                       ReestimationToString(IDLBASE_REEST_NONE),
                                       Integer(IDLBASE_REEST_NONE)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkReestSKM,
                                       ReestimationToString(IDLBASE_REEST_SKM),
                                       Integer(IDLBASE_REEST_SKM)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkReestBW,
                                       ReestimationToString(IDLBASE_REEST_BW),
                                       Integer(IDLBASE_REEST_BW)))
                       );

  //A2Q
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["A2Q"]',
                        'A2Q', REGTYPE_BOOL, DEF_A2Q,
                        chkA2Q)
                       .Enables(chkA2QEveryIter) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["A2Q EveryIter"]',
                        'A2Q EveryIter', REGTYPE_BOOL, DEF_A2QEVERYITER,
                        chkA2QEveryIter) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["A2Q Eval"]',
                        'A2Q Eval', REGTYPE_BOOL, DEF_A2QEVAL,
                        chkA2QEval) );

  //State Inference (Viterbi / Gamma / ForwardViterbi)
  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["MLSS"]',
                          'MLSS', REGTYPE_INT, MLSSToString(DEF_MLSS))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkMLSSViterbi,
                                       MLSSToString(IDLBASE_MLSS_VITERBI),
                                       Integer(IDLBASE_MLSS_VITERBI)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkMLSSGamma,
                                       MLSSToString(IDLBASE_MLSS_GAMMA),
                                       Integer(IDLBASE_MLSS_GAMMA)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkMLSSFV,
                                       MLSSToString(IDLBASE_MLSS_FORWARDVITERBI),
                                       Integer(IDLBASE_MLSS_FORWARDVITERBI)))
                       );

  //Sequence output (Class / Group)
  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["Output"]',
                          'Output', REGTYPE_INT, OutputToString(DEF_OUTPUT))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkOutputClass,
                                       OutputToString(IDLBASE_OUTPUT_CLASS),
                                       Integer(IDLBASE_OUTPUT_CLASS)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkOutputGroup,
                                       OutputToString(IDLBASE_OUTPUT_GROUP),
                                       Integer(IDLBASE_OUTPUT_GROUP)))
                       );

  //Optimization
  AddEditProperty(TQUB_Property_Edit.Create('["Optimize"]["ConvLL"]',
                    'LL Conv', REGTYPE_FLOAT, DEF_LLCONV,
                    txtLLConv,
                    AcceptFloatBetween(MIN_LLCONV, MAX_LLCONV),
                    '%.6g') );
  AddEditProperty(TQUB_Property_Edit.Create('["Optimize"]["MaxIterations"]',
                    'MaxIter', REGTYPE_INT, DEF_MAXITER,
                    txtMaxIter,
                    AcceptIntBetween(MIN_MAXITER, MAX_MAXITER),
                   '') );

  //Fix parameters (Kinetics, Amps, Stds)
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["FixKinetics"]',
                        'FixKinetics', REGTYPE_BOOL, DEF_FIXKINETICS,
                        chkFixKinetics) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["FixAmp"]',
                        'FixAmp', REGTYPE_BOOL, DEF_FIXAMP,
                        chkFixAmp) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["FixSD"]',
                        'FixStd', REGTYPE_BOOL, DEF_FIXSTD,
                        chkFixStd) );

  //Drop First/Last
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DropFirstLastIfClosed"]',
                        'DropFirstLastIfClosed', REGTYPE_BOOL, DEF_DROPFIRSTLASTIFCLOSED,
                        chkDropFirstLastIfClosed) );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DropFirstLastIfOpen"]',
                        'DropFirstLastIfOpen', REGTYPE_BOOL, DEF_DROPFIRSTLASTIFOPEN,
                        chkDropFirstLastIfOpen) );

  //Dead time correction
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["ApplyDeadTime"]',
                        'ApplyDeadTime', REGTYPE_BOOL, DEF_APPLYDEADTIME,
                        chkApplyDeadTime) );
  AddEditProperty(TQUB_Property_Edit.Create('["DeadTime"]',
                    'DeadTime', REGTYPE_FLOAT, QUB_IdlBase_Global.DEF_DEADTIME,
                    txtDeadTime,
                    AcceptFloatBetween(QUB_IdlBase_Global.MIN_DEADTIME, QUB_IdlBase_Global.MAX_DEADTIME),
                    '%.6g') );

  //Baseline Track and Correction
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Baseline"]["Track"]',
                        'Baseline Track', REGTYPE_BOOL, DEF_BASELINETRACK,
                        chkBaselineTrack)
                       .Enables(txtBaselineStd)
                       .Enables(lblBaselineStd)
                       .Enables(chkBaselineCorrect)
                       .Enables(txtBaselineDecFactor)
                       .Enables(udBaselineDecFactor)
                       .Enables(lblBaselineDecFactor)
                       .Enables(txtBaselineMinY)
                       .Enables(lblBaselineMinY)
                       .Enables(chkBaselineBackKalman)
                       .Enables(txtBaselineFKCount)
                       .Enables(lblBaselineFKCount)
                       .Enables(udBaselineFKCount)
                       .Enables(txtBaselineFBKCount)
                       .Enables(udBaselineFBKCount)
                       .Enables(lblBaselineFBKCount)
                       .Enables(chkBaselineReestPar)
                      );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Baseline"]["Correct"]',
                        'Baseline Correct', REGTYPE_BOOL, DEF_BASELINECORRECT,
                        chkBaselineCorrect) );
  AddUpDownProperty(TQUB_Property_UpDown.Create('["Baseline"]["DecFactor"]',
                      'Baseline DecFactor', REGTYPE_INT, DEF_BASELINEDECFACTOR,
                      udBaselineDecFactor,
                      txtBaselineDecFactor,
                      AcceptIntBetween(MIN_BASELINEDECFACTOR, MAX_BASELINEDECFACTOR)));
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["Std"]',
                    'Baseline Std', REGTYPE_FLOAT, DEF_BASELINESTD,
                    txtBaselineStd,
                    AcceptFloatBetween(MIN_BASELINESTD, MAX_BASELINESTD),
                    '') );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Baseline"]["BackKalman"]',
                        'Baseline BackKalman', REGTYPE_BOOL, DEF_BASELINEBackKalman,
                        chkBaselineBackKalman) );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["MinY"]',
                    'Baseline MinY', REGTYPE_INT, DEF_BASELINEMINY,
                    txtBaselineMinY,
                    AcceptIntBetween(MIN_BASELINEMINY, MAX_BASELINEMINY),
                    '') );
  AddUpDownProperty(TQUB_Property_UpDown.Create('["Baseline"]["F-B-K Count"]',
                      'Baseline FBKCount', REGTYPE_INT, DEF_BASELINEFBKCOUNT,
                      udBaselineFBKCount,
                      txtBaselineFBKCount,
                      AcceptIntBetween(MIN_BASELINEFBKCOUNT, MAX_BASELINEFBKCOUNT)));
  AddUpDownProperty(TQUB_Property_UpDown.Create('["Baseline"]["F-K Count"]',
                      'Baseline FKCount', REGTYPE_INT, DEF_BASELINEFKCOUNT,
                      udBaselineFKCount,
                      txtBaselineFKCount,
                      AcceptIntBetween(MIN_BASELINEFKCOUNT, MAX_BASELINEFKCOUNT)));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["ReestBasePar"]',
                        'Baseline Reest Par', REGTYPE_BOOL, DEF_BASELINEREESTPAR,
                        chkBaselineReestPar) );

  //Staircase
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]',
                        'Drift', REGTYPE_BOOL, DEF_STAIRCASE,
                        chkStaircase)
                       .Enables(txtStaircaseMaxJump)
                       .Enables(udStaircaseMaxJump)
                       .Enables(lblStaircaseMaxJump)
                       .Enables(chkStaircaseRightOnly)
                       .Enables(chkStaircaseGlobalReest)
                       .Enables(chkStaircaseLLAddJump)
                       .Enables(chkStaircaseReestBW)
                       .Enables(txtStaircaseBaseJumpVar)
                       .Enables(lblStaircaseBaseJumpVar)
                       .Enables(chkStaircaseUpdateRefState)
                       .Enables(txtStaircaseUpdateRefStateEvery)
                       .Enables(udStaircaseUpdateRefStateEvery)
                       .Enables(lblStaircaseUpdateRefStateEvery)
                       .Enables(chkStaircaseJumpAmpReestimate)
                       .Enables(chkStaircaseJumpAmpConsecutive)
                       .Enables(chkStaircaseJumpAmpCombinations)
                       .Enables(chkStaircaseJumpAmpConstrained)
                       .Enables(lblStaircaseStepModel)
                       .Enables(chkStaircaseJumpAmpUniformSteps)
                       .Enables(chkStaircaseJumpAmpAlternateSteps)
                       .Enables(chkStaircaseJumpAmpUseInit)
                       .Enables(txtStaircaseJumpAmps0)
                       .Enables(txtStaircaseJumpAmps1)
                       .Enables(lblStaircaseJumpAmpWeight)
                       .Enables(txtStaircaseJumpAmpWeight)
                       .Enables(chkStaircaseJumpAmpWeighed)
                       .Enables(lblStaircaseJumpAmpPlsMin)
                       .Enables(txtStaircaseJumpAmpPlsMin)
                       .Enables(udStaircaseJumpAmpPlsMin)

                       .Enables(lblStaircaseTricks)
                       .Enables(chkStaircaseMergeDwells)
                       .Enables(txtStaircaseMergeDwellsPercent)
                       .Enables(lblStaircaseMergeDwellsPercent)
                       .Enables(chkStaircaseSplitDwells)
                       .Enables(txtStaircaseSplitDwellsPercent)
                       .Enables(lblStaircaseSplitDwellsPercent)

                       .Enables(chkStaircaseKineticsReest)
                       .Enables(chkStaircaseKineticsUseInit)
                       .Enables(txtStaircaseKineticsKf)
                       .Enables(lblStaircaseKineticsKf)
                       .Enables(txtStaircaseKineticsKb)
                       .Enables(lblStaircaseKineticsKb)

                       .Enables(chkStaircaseJumpStdReest)
                       .Enables(lblStaircaseJumpStd)
                       .Enables(txtStaircaseJumpStd)
                       .Enables(lblStaircaseJumpStdMinGamma)
                       .Enables(txtStaircaseJumpStdMinGamma)
                       .Enables(chkStaircaseJumpStdWeighed)

                       .Enables(lblStaircaseBaseAmp)
                       .Enables(chkStaircaseBaseAmpUseInit)
                       .Enables(txtStaircaseBaseAmp)

                       .Enables(chkStaircaseMeasStdReest)
                       .Enables(chkStaircaseMeasStdUseInit)
                       .Enables(txtStaircaseMeasStd)
                     );
  //MaxJump
  AddUpDownProperty(TQUB_Property_UpDown.Create('["Staircase"]["MaxJump"]',
                      'DriftMaxJump', REGTYPE_INT, DEF_STAIRCASE_MAXJUMP,
                      udStaircaseMaxJump,
                      txtStaircaseMaxJump,
                      AcceptIntBetween(MIN_STAIRCASE_MAXJUMP, MAX_STAIRCASE_MAXJUMP)));
  //RightOnly
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]["RightOnly"]',
                        'DriftRightOnly', REGTYPE_BOOL, DEF_STAIRCASE_RIGHTONLY,
                        chkStaircaseRightOnly) );
  //GlobalEst
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]["Global est"]',
                        'DriftGlobalReest', REGTYPE_BOOL, DEF_STAIRCASE_GLOBALREEST,
                        chkStaircaseGlobalReest) );
  //LLAddJump
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]["LLAddJump"]',
                        '', REGTYPE_NONE, DEF_STAIRCASE_LLADDJUMP,
                        chkStaircaseLLAddJump) );
  //ReestBW
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]["ReestBW"]',
                        'DriftReestBW', REGTYPE_BOOL, DEF_STAIRCASE_REESTBW,
                        chkStaircaseReestBW) );
  //BaseJumpVar
  AddEditProperty(TQUB_Property_Edit.Create('["Staircase"]["BaseJumpVar"]',
                    'DriftBaseJumpVar', REGTYPE_FLOAT, DEF_STAIRCASE_BASEJUMPVAR,
                    txtStaircaseBaseJumpVar,
                    AcceptFloatBetween(MIN_STAIRCASE_BASEJUMPVAR, MAX_STAIRCASE_BASEJUMPVAR),
                    '%.6g') );
  //UpdateRefState
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]["UpdateRefState"]',
                        'DriftUpdateRefState', REGTYPE_BOOL, DEF_STAIRCASE_UPDATEREFSTATE,
                        chkStaircaseUpdateRefState) );
  AddUpDownProperty(TQUB_Property_UpDown.Create('["Staircase"]["UpdateRefStateEvery"]',
                      'DriftUpdateRefStateEvery', REGTYPE_INT, DEF_STAIRCASE_UPDATEREFSTATEEVERY,
                      udStaircaseUpdateRefStateEvery,
                      txtStaircaseUpdateRefStateEvery,
                      AcceptIntGreaterThan(0)));
  //JumpAmp
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]["JumpAmpReestimate"]',
                        '', REGTYPE_NONE, DEF_STAIRCASE_JUMPAMPREESTIMATE,
                        chkStaircaseJumpAmpReestimate));
  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["Staircase"]["JumpAmpReestMethod"]',
                          '', REGTYPE_NONE, Integer(DEF_STAIRCASE_JUMPAMPREESTMETHOD))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkStaircaseJumpAmpConsecutive,
                                       Integer(JUMPAMP_CONSECUTIVE),
                                       Integer(JUMPAMP_CONSECUTIVE)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkStaircaseJumpAmpCombinations,
                                       Integer(JUMPAMP_COMBINATIONS),
                                       Integer(JUMPAMP_COMBINATIONS)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkStaircaseJumpAmpConstrained,
                                       Integer(JUMPAMP_CONSTRAINED),
                                       Integer(JUMPAMP_CONSTRAINED)))
                       );
  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["Staircase"]["JumpAmpStepModel"]',
                          '', REGTYPE_NONE, Integer(DEF_STAIRCASE_JUMPAMPSTEPMODEL))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkStaircaseJumpAmpUniformSteps,
                                       Integer(STAIRCASE_STEPMODEL_UNIFORM),
                                       Integer(STAIRCASE_STEPMODEL_UNIFORM)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkStaircaseJumpAmpAlternateSteps,
                                       Integer(STAIRCASE_STEPMODEL_ALTERNATE),
                                       Integer(STAIRCASE_STEPMODEL_ALTERNATE)))
                       );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]["JumpAmpUseInit"]',
                        '', REGTYPE_NONE, DEF_STAIRCASE_JUMPAMPUSEINIT,
                        chkStaircaseJumpAmpUseInit));
  AddEditProperty(TQUB_Property_Edit.Create('["Staircase"]["JumpAmps0"]',
                    '', REGTYPE_NONE, DEF_STAIRCASE_JUMPAMP,
                    txtStaircaseJumpAmps0,
                    AcceptFloatBetween(MIN_STAIRCASE_JUMPAMP, MAX_STAIRCASE_JUMPAMP),
                    '%.6g') );
  AddEditProperty(TQUB_Property_Edit.Create('["Staircase"]["JumpAmps1"]',
                    '', REGTYPE_NONE, DEF_STAIRCASE_JUMPAMP,
                    txtStaircaseJumpAmps1,
                    AcceptFloatBetween(MIN_STAIRCASE_JUMPAMP, MAX_STAIRCASE_JUMPAMP),
                    '%.6g') );
  AddEditProperty(TQUB_Property_Edit.Create('["Staircase"]["JumpAmpWeight"]',
                    '', REGTYPE_NONE, DEF_STAIRCASE_JUMPAMPWEIGHT,
                    txtStaircaseJumpAmpWeight,
                    AcceptFloatBetween(MIN_STAIRCASE_JUMPAMPWEIGHT, MAX_STAIRCASE_JUMPAMPWEIGHT),
                    '%.6g') );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]["JumpAmpWeighed"]',
                        '', REGTYPE_NONE, DEF_STAIRCASE_JUMPAMPWEIGHED,
                        chkStaircaseJumpAmpWeighed) );
  AddUpDownProperty(TQUB_Property_UpDown.Create('["Staircase"]["JumpAmpPlsMin"]',
                      'DriftJumpAmpPlsMin', REGTYPE_INT, DEF_STAIRCASE_JUMPAMPPLSMIN,
                      udStaircaseJumpAmpPlsMin,
                      txtStaircaseJumpAmpPlsMin,
                      AcceptIntBetween(MIN_STAIRCASE_JUMPAMPPLSMIN, MAX_STAIRCASE_JUMPAMPPLSMIN)));
  //Tricks
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]["MergeDwells"]',
                        '', REGTYPE_NONE, DEF_STAIRCASE_MERGEDWELLS,
                        chkStaircaseMergeDwells) );
  AddEditProperty(TQUB_Property_Edit.Create('["Staircase"]["MergeDwellsPercent"]',
                    '', REGTYPE_NONE, DEF_STAIRCASE_MERGEDWELLSPERCENT,
                    txtStaircaseMergeDwellsPercent,
                    AcceptFloatBetween(0.0, 1.0),
                    '%.6g') );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]["SplitDwells"]',
                        '', REGTYPE_NONE, DEF_STAIRCASE_SPLITDWELLS,
                        chkStaircaseSplitDwells) );
  AddEditProperty(TQUB_Property_Edit.Create('["Staircase"]["SplitDwellsPercent"]',
                    '', REGTYPE_NONE, DEF_STAIRCASE_SPLITDWELLSPERCENT,
                    txtStaircaseSplitDwellsPercent,
                    AcceptFloatBetween(0.0, 1.0),
                    '%.6g') );
  //Kinetics
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]["KineticsReest"]',
                        '', REGTYPE_NONE, DEF_STAIRCASE_KINETICSREEST,
                        chkStaircaseKineticsReest));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]["KineticsUseInit"]',
                        '', REGTYPE_NONE, DEF_STAIRCASE_KINETICSUSEINIT,
                        chkStaircaseKineticsUseInit));
  AddEditProperty(TQUB_Property_Edit.Create('["Staircase"]["Kinetics0"]',
                    '', REGTYPE_NONE, DEF_STAIRCASE_KINETICS,
                    txtStaircaseKineticsKf,
                    AcceptFloatBetween(MIN_STAIRCASE_KINETICS, MAX_STAIRCASE_KINETICS),
                    '%.6g'));
  AddEditProperty(TQUB_Property_Edit.Create('["Staircase"]["Kinetics1"]',
                    '', REGTYPE_NONE, DEF_STAIRCASE_KINETICS,
                    txtStaircaseKineticsKb,
                    AcceptFloatBetween(MIN_STAIRCASE_KINETICS, MAX_STAIRCASE_KINETICS),
                    '%.6g'));
  //JumpStd
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]["JumpStdReest"]',
                        '', REGTYPE_NONE, DEF_STAIRCASE_JUMPSTDREEST,
                        chkStaircaseJumpStdReest));
  AddEditProperty(TQUB_Property_Edit.Create('["Staircase"]["JumpStd"]',
                    '', REGTYPE_NONE, DEF_STAIRCASE_JUMPSTD,
                    txtStaircaseJumpStd,
                    AcceptFloatBetween(MIN_STAIRCASE_JUMPSTD, MAX_STAIRCASE_JUMPSTD),
                    '%.6g'));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]["JumpStdWeighed"]',
                        '', REGTYPE_NONE, DEF_STAIRCASE_JUMPSTDWEIGHED,
                        chkStaircaseJumpStdWeighed));
  AddEditProperty(TQUB_Property_Edit.Create('["Staircase"]["JumpStdMinGamma"]',
                    '', REGTYPE_NONE, DEF_STAIRCASE_JUMPSTDMINGAMMA,
                    txtStaircaseJumpStdMinGamma,
                    AcceptFloatBetween(MIN_STAIRCASE_JUMPSTDMINGAMMA, MAX_STAIRCASE_JUMPSTDMINGAMMA),
                    '%.6g'));
  //BaseAmp
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]["BaseAmpUseInit"]',
                        '', REGTYPE_NONE, DEF_STAIRCASE_BASEAMPUSEINIT,
                        chkStaircaseBaseAmpUseInit));
  AddEditProperty(TQUB_Property_Edit.Create('["Staircase"]["BaseAmp"]',
                    '', REGTYPE_NONE, DEF_STAIRCASE_BASEAMP,
                    txtStaircaseBaseAmp,
                    AcceptFloatBetween(MIN_STAIRCASE_BASEAMP, MAX_STAIRCASE_BASEAMP),
                    '%.6g'));
  //MeasStd
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]["MeasStdReest"]',
                        '', REGTYPE_NONE, DEF_STAIRCASE_MEASSTDREEST,
                        chkStaircaseMeasStdReest));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Staircase"]["MeasStdUseInit"]',
                        '', REGTYPE_NONE, DEF_STAIRCASE_MEASSTDUSEINIT,
                        chkStaircaseMeasStdUseInit));
  AddEditProperty(TQUB_Property_Edit.Create('["Staircase"]["MeasStd"]',
                    '', REGTYPE_NONE, DEF_STAIRCASE_MEASSTD,
                    txtStaircaseMeasStd,
                    AcceptFloatBetween(MIN_STAIRCASE_MEASSTD, MAX_STAIRCASE_MEASSTD),
                    '%.6g'));

  //ReplaceIDL
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["ReplaceIDL"]',
                        'ReplaceIDL', REGTYPE_BOOL, DEF_REPLACEIDL,
                        chkReplaceIDL));
  //QuietOutput
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["QuietOutput"]',
                        'QuietOutput', REGTYPE_BOOL, DEF_QUIETOUTPUT,
                        chkQuietOutput));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["QuietOutputEveryIter"]',
                        '', REGTYPE_NONE, DEF_QUIETOUTPUTEVERYITER,
                        chkQuietOutputEveryIter));

  RegKeyName            := 'Software\QUB\Task IdlBase data';
  ProfileCat            := 'IB';
  prBeforeGetProperties := PropertiesToParams;

  WikiTopic             := 'Modeling:Idl/Base#Properties';
end;

procedure TQUB_Task_IdlBase_PropertiesForm.FormShow(Sender: TObject);
begin
  inherited;

  DataSource             := DataSource;
end;

procedure TQUB_Task_IdlBase_PropertiesForm.FormHide(Sender: TObject);
begin
  inherited;

  PropertiesToParams;
end;

//Data Source
procedure TQUB_Task_IdlBase_PropertiesForm.chkDataSourceClick(Sender: TObject);
begin
  inherited;
  DataSource := TQUB_Task_Data_Source(TRadioButton(Sender).Tag);
end;


//******************************************************************************
procedure TQUB_Task_IdlBase_PropertiesForm.PropertiesToParams;
begin
  //Movies
  prMovie.Make                              := 0<>Properties['Movie']['Make'].Data[0];
  prMovie.SaveBitmaps                       := 0<>Properties['Movie']['SaveBitmaps'].Data[0];
  prMovie.ShowTitles                        := 0<>Properties['Movie']['ShowTitles'].Data[0];
  prMovie.MaxFrameCount                     := Properties['Movie']['MaxFrameCount'].Data[0];
  prMovie.IDLPenWidth                       := Properties['Movie']['IdlPenWidth'].Data[0];
  prMovie.BaseXPenWidth                     := Properties['Movie']['BaseXPenWidth'].Data[0];
  prMovie.BasePPenWidth                     := Properties['Movie']['BasePPenWidth'].Data[0];
  prMovie.ForBaseXColor                     := Properties['Movie']['ForBaseXColor'].Data[0];
  prMovie.ForBasePColor                     := Properties['Movie']['ForBasePColor'].Data[0];
  prMovie.BacBaseXColor                     := Properties['Movie']['BacBaseXColor'].Data[0];
  prMovie.BacBasePColor                     := Properties['Movie']['BacBasePColor'].Data[0];
  prMovie.ForIDLColor                       := Properties['Movie']['ForIdlColor'].Data[0];
  prMovie.BacIDLColor                       := Properties['Movie']['BacIdlColor'].Data[0];

  prParams.Reestimation                     := StringToReestimation(Properties['Reestimation'].DataAsString);
  prParams.A2Q                              := 0<>Properties['A2Q'].Data[0];
  prParams.A2QEveryIter                     := 0<>Properties['A2Q EveryIter'].Data[0];
  prParams.A2QEval                          := 0<>Properties['A2Q Eval'].Data[0];
  prParams.MLSS                             := StringToMLSS(Properties['MLSS'].DataAsString);
  prParams.Output                           := StringToOutput(Properties['Output'].DataAsString);
  prParams.LLConv                           := Properties['Optimize']['ConvLL'].Data[0];
  prParams.MaxIter                          := Properties['Optimize']['MaxIterations'].Data[0];
  prParams.FixKinetics                      := 0<>Properties['FixKinetics'].Data[0];
  prParams.FixAmp                           := 0<>Properties['FixAmp'].Data[0];
  prParams.FixStd                           := 0<>Properties['FixSD'].Data[0];
  prParams.DropFirstLastIfClosed            := 0<>Properties['DropFirstLastIfClosed'].Data[0];
  prParams.DropFirstLastIfOpen              := 0<>Properties['DropFirstLastIfOpen'].Data[0];
  prParams.ApplyDeadTime                    := 0<>Properties['ApplyDeadTime'].Data[0];
  prParams.DeadTime                         := Properties['DeadTime'].Data[0];

  //Baseline
  prParams.BaselineTrack                    := 0<>Properties['Baseline']['Track'].Data[0];
  prParams.BaselineBackKalman               := 0<>Properties['Baseline']['BackKalman'].Data[0];
  prParams.BaselineStd                      := Properties['Baseline']['Std'].Data[0];
  prParams.BaselineCorrect                  := 0<>Properties['Baseline']['Correct'].Data[0];
  prParams.BaselineDecFactor                := Properties['Baseline']['DecFactor'].Data[0];
  prParams.BaselineMinY                     := Properties['Baseline']['MinY'].Data[0];
  prParams.BaselineFBKCount                 := Properties['Baseline']['F-B-K Count'].Data[0];
  prParams.BaselineFKCount                  := Properties['Baseline']['F-K Count'].Data[0];
  prParams.BaselineReestPar                 := 0<>Properties['ReestBasePar'].Data[0];

  //Staircase
  prParams.Staircase                        := 0<>Properties['Staircase'].Data[0];
  prParams.StaircaseMaxJump                 := Properties['Staircase']['MaxJump'].Data[0];
  prParams.StaircaseRightOnly               := 0<>Properties['Staircase']['RightOnly'].Data[0];
  prParams.StaircaseGlobalReest             := 0<>Properties['Staircase']['Global est'].Data[0];
  prParams.StaircaseLLAddJump               := 0<>Properties['Staircase']['LLAddJump'].Data[0];
  prParams.StaircaseReestBW                 := 0<>Properties['Staircase']['ReestBW'].Data[0];
  prParams.StaircaseBaseJumpVar             := Properties['Staircase']['BaseJumpVar'].Data[0];
  prParams.StaircaseUpdateRefState          := 0<>Properties['Staircase']['UpdateRefState'].Data[0];
  prParams.StaircaseUpdateRefStateEvery     := Properties['Staircase']['UpdateRefStateEvery'].Data[0];
  //JumpAmp
  prParams.StaircaseJumpAmpReestimate       := 0<>Properties['Staircase']['JumpAmpReestimate'].Data[0];
  prParams.StaircaseJumpAmpReestMethod      := TQUB_IdlBase_JumpAmpReestMethod(Properties['Staircase']['JumpAmpReestMethod'].Data[0]);
  prParams.StaircaseJumpAmpStepModel        := Properties['Staircase']['JumpAmpStepModel'].Data[0];
  prParams.StaircaseJumpAmpUseInit          := 0<>Properties['Staircase']['JumpAmpUseInit'].Data[0];
  prParams.StaircaseJumpAmps[0]             := Properties['Staircase']['JumpAmps0'].Data[0];
  prParams.StaircaseJumpAmps[1]             := Properties['Staircase']['JumpAmps1'].Data[0];
  prParams.StaircaseJumpAmpWeight           := Properties['Staircase']['JumpAmpWeight'].Data[0];
  prParams.StaircaseJumpAmpWeighed          := 0<>Properties['Staircase']['JumpAmpWeighed'].Data[0];
  prParams.StaircaseJumpAmpPlsMin           := Properties['Staircase']['JumpAmpPlsMin'].Data[0];
  //Tricks
  prParams.StaircaseMergeDwells             := 0<>Properties['Staircase']['MergeDwells'].Data[0];
  prParams.StaircaseMergeDwellsPercent      := Properties['Staircase']['MergeDwellsPercent'].Data[0];
  prParams.StaircaseSplitDwells             := 0<>Properties['Staircase']['SplitDwells'].Data[0];
  prParams.StaircaseSplitDwellsPercent      := Properties['Staircase']['SplitDwellsPercent'].Data[0];
  //Kinetics
  prParams.StaircaseKineticsReest           := 0<>Properties['Staircase']['KineticsReest'].Data[0];
  prParams.StaircaseKineticsUseInit         := 0<>Properties['Staircase']['KineticsUseInit'].Data[0];
  prParams.StaircaseKinetics[0]             := Properties['Staircase']['Kinetics0'].Data[0];
  prParams.StaircaseKinetics[1]             := Properties['Staircase']['Kinetics1'].Data[0];
  //JumpStd
  prParams.StaircaseJumpStdReest            := 0<>Properties['Staircase']['JumpStdReest'].Data[0];
  prParams.StaircaseJumpStd                 := Properties['Staircase']['JumpStd'].Data[0];
  prParams.StaircaseJumpStdMinGamma         := Properties['Staircase']['JumpStdMinGamma'].Data[0];
  prParams.StaircaseJumpStdWeighed          := 0<>Properties['Staircase']['JumpStdWeighed'].Data[0];
  //BaseAmp
  prParams.StaircaseBaseAmpUseInit          := 0<>Properties['Staircase']['BaseAmpUseInit'].Data[0];
  prParams.StaircaseBaseAmp                 := Properties['Staircase']['BaseAmp'].Data[0];
  //MeasStd
  prParams.StaircaseMeasStdReest            := 0<>Properties['Staircase']['MeasStdReest'].Data[0];
  prParams.StaircaseMeasStdUseInit          := 0<>Properties['Staircase']['MeasStdUseInit'].Data[0];
  prParams.StaircaseMeasStd                 := Properties['Staircase']['MeasStd'].Data[0];

  prParams.ReplaceIDL                       := 0<>Properties['ReplaceIDL'].Data[0];
  prParams.QuietOutput                      := 0<>Properties['QuietOutput'].Data[0];
  prParams.QuietOutputEveryIter             := 0<>Properties['QuietOutputEveryIter'].Data[0];
end;


//******************************************************************************
end.
