unit QUB_Task_Mac_Properties;

{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}

interface


uses


Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, ComCtrls, Registry,

RegistryInterface,

QUB_Properties,
QUB_Task,
QUB_Task_Properties,
QUB_Task_Data_Properties,
QUB_Q_Model,
QUB_Mac_Global,
QUB_Node,
QUB_DataList,
QUB_Global,
QUB_Profiles;


{$include 'QUB_Task_Mac_Properties.hct'}


const


DEF_QUIETOUTPUT               = 0;


type


TQUB_Task_Mac_PropertiesForm  = class(TQUB_Task_Data_PropertiesForm)


  Label4                          :TLabel;

  panMethod                       :TPanel;
  
  chkEstRates                     :TCheckBox;
  chkEstChannelCount              :TCheckBox;
  panOptimization                 :TPanel;
  Label11                         :TLabel;
  Label7                          :TLabel;
  Label9                          :TLabel;
  Label10                         :TLabel;
  Label19                         :TLabel;
  txtOptLLConv                    :TEdit;
  txtOptGradConv                  :TEdit;
  txtOptMaxIter                   :TEdit;
  txtOptMaxStep                   :TEdit;
  chkEstUseVariance               :TCheckBox;
  chkQuietOutput                  :TCheckBox;
  panInitProb                     :TPanel;
  Label3                          :TLabel;
  panFitData                      :TPanel;
  chkOptShowFit                   :TCheckBox;
  chkOptSkip                      :TCheckBox;
  txtOptSkipTime                  :TEdit;
  Label13                         :TLabel;
  chkOptFitDataWhole              :TRadioButton;
  chkOptFitDataList               :TRadioButton;
  panRunMode                      :TPanel;
  chkOptModeOpt                   :TRadioButton;
  chkOptModeCheck                 :TRadioButton;
  chkOptModeSim                   :TRadioButton;
  Label12                         :TLabel;
  panBatch                        :TPanel;
  Label15                         :TLabel;
  chkOptSegmentsTogether          :TRadioButton;
  chkOptSegmentsGroup             :TRadioButton;
  txtOptSegmentsGroupCount        :TEdit;
  udOptSegmentsGroupCount         :TUpDown;
  chkOptSegmentsIdChunks          :TCheckBox;
  chkEstInitProbsFixed            :TRadioButton;
  chkEstInitProbsEq               :TRadioButton;
  chkEstInitProbsCondEq           :TRadioButton;
  lstFitData                      :TComboBox;
  lstExcData                      :TComboBox;
  chkOptExcData                   :TCheckBox;
  chkEstChannelCountPerFile       :TCheckBox;
  Panel3                          :TPanel;
  chkOptShowFitAvg                :TRadioButton;
  chkOptShowFitStd                :TRadioButton;
  chkOptSegmentsGroupList         :TRadioButton;
  txtOptSegmentsGroupList         :TEdit;
  Label16                         :TLabel;
  txtOptSegmentsMaxBatch          :TEdit;
  chkEstAmpOpen                   :TCheckBox;
  chkOptRestart                   :TCheckBox;
  chkOptSegmentsMUXFiles          :TCheckBox;
  chkEstVarOpen                   :TCheckBox;
  panConductance                  :TPanel;
  Label17                         :TLabel;
  chkOptUseVRev                   :TCheckBox;
  chkOptShowFitRes                :TRadioButton;
  txtEstMinRate                   :TEdit;
  chkEstMaxRate                   :TCheckBox;
  txtEstMaxRate                   :TEdit;
  chkEstMinRate                   :TCheckBox;
  chkNewIdlCond                   :TCheckBox;
  panSkipSlowChanges              :TPanel;
  chkSkipSlowChange               :TCheckBox;
  Label1                          :TLabel;
  txtSkipSlowStd                  :TEdit;
  chkOptSegmentsPropagateParams   :TCheckBox;
  lblLatency                      :TLabel;
  txtStimulusLatency              :TEdit;

  panScripts                      :TPanel;
  lblScripts                      :TLabel;
  chkOptScriptIteration           :TCheckBox;
  txtScriptIteration              :TEdit;
  chkOptScriptPenalty             :TCheckBox;
  txtScriptPenalty                :TEdit;

  chkOptPlotLL                    :TCheckBox;
  lblOptPlotLLPage                :TLabel;
  txtOptPlotLLPage                :TEdit;
  lblOptPlotLLTrace               :TLabel;
  txtOptPlotLLTrace               :TEdit;

  chkOptNumGrads                  :TCheckBox;
  txtOptNumGradStep               :TEdit;
  chkOptNumGradsFast              :TCheckBox;
  chkOptScriptSetPars             :TCheckBox;
  txtScriptSetPars                :TEdit;

  panStimulus                     :TPanel;
  Label2                          :TLabel;
  txtMinAbsStimulus               :TEdit;
  Panel2                          :TPanel;
  lblVRev                         :TLabel;
  txtVRev                         :TEdit;
  chkVrevFromModel                :TRadioButton;
  chkVrevHere                     :TRadioButton;
  Panel4                          :TPanel;
  lblGleak                        :TLabel;
  txtGleak                        :TEdit;
  chkGleakFromTable               :TRadioButton;
  chkGleakHere                    :TRadioButton;
  Panel1                          :TPanel;
  lblVleak                        :TLabel;
  txtVleak                        :TEdit;
  chkVleakFromTable               :TRadioButton;
  chkVleakHere                    :TRadioButton;


  procedure FormCreate(Sender: TObject);
  procedure FormShow(Sender: TObject);
  procedure FormHide(Sender: TObject);

  procedure lstFitDataClick(Sender: TObject);
  procedure lstExcDataClick(Sender: TObject);


protected


  //Data Source
  prDataList                      :TQUB_DataList;

  //QuietOutput
  prQuietOutput                   :Boolean;

  //Params
  prParams                        :TQUB_Mac_Opt_Params;

  //FitDataList
  prFitDataListName               :String;
  prExcDataListName               :String;


  function prGetFitDataListIdx: Integer;
  procedure prSetFitDataListIdx(i :Integer);
  procedure prSetFitDataList;
  function prGetExcDataListIdx: Integer;
  procedure prSetExcDataListIdx(i :Integer);
  procedure prSetExcDataList;
  
  procedure prSetOptVRev(v :Double);

  procedure prSetInitialProperties(Props :INode); override;
  // override: inherited; fill missing properties from registry or defaults;

  procedure prUpdateComponents; override;
  // override: put all your property values into the form
  // (supersedes MyProperty := MyProperty; in FormShow)
  // also called after SetProperties e.g. when user changes profile


public


  procedure PropertiesToParams;


  //Quiet output
  property QuietOutput                    :Boolean                   read prQuietOutput;

  //Estimation
  property EstRates                       :Integer                   read prParams.EstRates;
  property EstChannelCount                :Integer                   read prParams.EstChannelCount;
  property EstChannelCountPerFile         :Integer                   read prParams.EstChannelCountPerFile;
  property EstAmpOpen                     :Integer                   read prParams.EstAmpOpen;
  property EstVarOpen                     :Integer                   read prParams.EstVarOpen;
  property EstInitProbs                   :TQUB_Q_InitProbs          read prParams.EstInitProbs;
  property EstUseVariance                 :Integer                   read prParams.EstUseVariance;

  //Optimization
  property OptLLConv                      :Double                    read prParams.OptLLConv;
  property OptGradConv                    :Double                    read prParams.OptGradConv;
  property OptMaxStep                     :Double                    read prParams.OptMaxStep;
  property OptMaxIter                     :Integer                   read prParams.OptMaxIter;
  property OptStimDelta                   :Integer                   read prParams.OptStimDelta;
  property OptRestart                     :Integer                   read prParams.OptRestart;
  property OptNumGrads                    :Integer                   read prParams.OptNumGrads;
  property OptNumGradStep                 :Double                    read prParams.OptNumGradStep;
  property OptNumGradsFast                :Integer                   read prParams.OptNumGradsFast;
  property OptPlotLL                      :Integer                   read prParams.OptPlotLL;
  property OptPlotLLPage                  :Integer                   read prParams.OptPlotLLPage;
  property OptPlotLLTrace                 :Integer                   read prParams.OptPlotLLTrace;
  property OptFitDataMode                 :TQUB_Mac_Opt_FitDataMode  read prParams.OptFitDataMode;
  property OptShowFit                     :Integer                   read prParams.OptShowFit;
  property OptShowFitWhat                 :Integer                   read prParams.OptShowFitWhat;
  property OptSkip                        :Integer                   read prParams.OptSkip;
  property OptSkipTime                    :Double                    read prParams.OptSkipTime;
  property OptMode                        :TQUB_Mac_Opt_Mode         read prParams.OptMode;
  property OptSegments                    :TQUB_Mac_Opt_Segments     read prParams.OptSegments;
  property OptSegmentsGroupCount          :Integer                   read prParams.OptSegmentsGroupCount;
  property OptSegmentsMaxBatch            :Integer                   read prParams.OptSegmentsMaxBatch;
  property OptSegmentsIdChunks            :Integer                   read prParams.OptIdenticalChunks;
  property OptSegmentsMUXFiles            :Integer                   read prParams.OptMUXFiles;
  property OptSegmentsPropagateParams     :Integer                   read prParams.OptPropagateParams;
  property OptUseVRev                     :Integer                   read prParams.OptUseVRev;
  property OptVRev                        :Double                    read prParams.OptVRev                write prSetOptVRev;
  property OptGLeak                       :Double                    read prParams.OptGLeak;
  property OptVLeak                       :Double                    read prParams.OptVLeak;

  property FitDataListIdx                 :Integer                   read prGetFitDataListIdx             write prSetFitDataListIdx;
  property ExcDataListIdx                 :Integer                   read prGetExcDataListIdx             write prSetExcDataListIdx;

  property ModUseMinRate                  :Boolean                   read prParams.EstUseMinRate;
  property ModUseMaxRate                  :Boolean                   read prParams.EstUseMaxRate;
  property ModMinRate                     :Double                    read prParams.EstMinRate;
  property ModMaxRate                     :Double                    read prParams.EstMaxRate;

  property OptScriptPenalty               :Integer                   read prParams.OptScriptPenalty;
  property OptScriptPenaltyName           :String                    read prParams.OptScriptPenaltyName;
  property OptScriptIteration             :Integer                   read prParams.OptScriptIteration;
  property OptScriptIterationName         :String                    read prParams.OptScriptIterationName;
  property OptScriptSetPars               :Integer                   read prParams.OptScriptSetPars;
  property OptScriptSetParsName           :String                    read prParams.OptScriptSetParsName;
      
  property Params                         :TQUB_Mac_Opt_Params       read prParams;


end;


implementation


uses


QUB_Viewport_Model, QUB_QVO_QVM, QUB_GUIInterface;
//QUB_QVO_QVGraph;


{$R *.DFM}


//******************************************************************************
//FitData
function TQUB_Task_Mac_PropertiesForm.prGetFitDataListIdx :Integer;
begin
  if lstFitData.Items.Count > 0 then Result := lstFitData.ItemIndex else Result := -1;
end;

procedure TQUB_Task_Mac_PropertiesForm.prSetFitDataListIdx(i :Integer);
begin
  lstFitData.ItemIndex := i;
  prFitDataListName    := '';
  if lstFitData.ItemIndex <> -1 then begin
    prFitDataListName := lstFitData.Items[lstFitData.ItemIndex];
  end;
  prProperties['FitDataList'].SetData(prFitDataListName);
end;

procedure TQUB_Task_Mac_PropertiesForm.prSetFitDataList;
begin
  if lstFitData.Items.IndexOf(prFitDataListName) >= 0                 // in case it was set via profiles while the form is not visible / list not populated
  then FitDataListIdx := lstFitData.Items.IndexOf(prFitDataListName);
end;

//ExcData
function TQUB_Task_Mac_PropertiesForm.prGetExcDataListIdx :Integer;
begin
  if lstExcData.Items.Count > 0 then Result := lstExcData.ItemIndex else Result := -1;
end;

procedure TQUB_Task_Mac_PropertiesForm.prSetExcDataListIdx(i :Integer);
begin
  lstExcData.ItemIndex := i;
  prExcDataListName    := '';
  if lstExcData.ItemIndex <> -1 then begin
    prExcDataListName := lstExcData.Items[lstExcData.ItemIndex];
  end;
  prProperties['ExcDataList'].SetData(prExcDataListName);
end;

procedure TQUB_Task_Mac_PropertiesForm.prSetExcDataList;
begin
  if lstExcData.Items.IndexOf(prExcDataListName) >= 0
  then ExcDataListIdx := lstExcData.Items.IndexOf(prExcDataListName);
end;

//VRev
procedure TQUB_Task_Mac_PropertiesForm.prSetOptVRev(v :Double);
begin
  txtVRev.Text                  := FloatToStr(v);
  prParams.OptVRev              := v;
  Properties['OptVRev'].Data[0] := v;
end;


//******************************************************************************
procedure TQUB_Task_Mac_PropertiesForm.FormCreate(Sender: TObject);
begin
  inherited;

  //QuietOutput
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["QuietOutput"]',
                        'QuietOutput', REGTYPE_BOOL, DEF_QUIETOUTPUT,
                        chkQuietOutput));
  //Estimate
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Est"]["Rates"]',
                        'Estimate Rates', REGTYPE_BOOL, DEF_EST_RATES,
                        chkEstRates));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Est"]["ChannelCount"]',
                        'Estimate ChannelCount', REGTYPE_BOOL, DEF_EST_CHANNELCOUNT,
                        chkEstChannelCount));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Est"]["ChannelCountPerFile"]',
                        'Estimate ChannelCount Per File', REGTYPE_BOOL,  DEF_EST_CHANNELCOUNTPERFILE,
                        chkEstChannelCountPerFile));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Est"]["AmpOpen"]',
                        'Estimate AmpOpen', REGTYPE_BOOL, DEF_EST_AMPOPEN,
                        chkEstAmpOpen));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Est"]["VarOpen"]',
                        'Estimate VarOpen', REGTYPE_BOOL, DEF_EST_VAROPEN,
                        chkEstVarOpen));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Est"]["UseVariance"]',
                        'Estimate UseVariance', REGTYPE_BOOL, DEF_EST_USEVARIANCE,
                        chkEstUseVariance));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Est"]["UseMinRate"]',
                        'Estimate UseMinRate', REGTYPE_BOOL, DEF_EST_USEMINRATE,
                        chkEstMinRate));
  AddEditProperty(TQUB_Property_Edit.Create('["Est"]["MinRate"]',
                    'Estimate MinRate', REGTYPE_FLOAT, DEF_EST_MINRATE,
                    txtEstMinRate,
                    AcceptFloatBetween(MIN_EST_MINRATE, MAX_EST_MINRATE),
                    '') );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Est"]["UseMaxRate"]',
                        'Estimate UseMaxRate', REGTYPE_BOOL, DEF_EST_USEMAXRATE,
                        chkEstMaxRate));
  AddEditProperty(TQUB_Property_Edit.Create('["Est"]["MaxRate"]',
                    'Estimate MaxRate', REGTYPE_FLOAT, DEF_EST_MAXRATE,
                    txtEstMaxRate,
                    AcceptFloatBetween(MIN_EST_MAXRATE, MAX_EST_MAXRATE),
                    '') );
  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["Est"]["InitProbs"]',
                          'Estimate InitProbs', REGTYPE_INT, Q_InitProbsStringOf(DEF_EST_INITPROBS))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkEstInitProbsFixed,
                                       Q_InitProbsStringOf(INITPROBS_FIXED),
                                       Integer(INITPROBS_FIXED)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkEstInitProbsEq,
                                       Q_InitProbsStringOf(INITPROBS_EQ),
                                       Integer(INITPROBS_EQ)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkEstInitProbsCondEq,
                                       Q_InitProbsStringOf(INITPROBS_CONDEQ),
                                       Integer(INITPROBS_CONDEQ)))
                       );
  //Optimization
  AddEditProperty(TQUB_Property_Edit.Create('["DFP"]["ConvLL"]',
                    'Optimizer LLConv', REGTYPE_FLOAT, DEF_OPT_LLCONV,
                    txtOptLLConv,
                    AcceptFloatBetween(MIN_OPT_LLCONV, MAX_OPT_LLCONV),
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["DFP"]["ConvGrad"]',
                    'Optimizer GradConv', REGTYPE_FLOAT, DEF_OPT_GRADCONV,
                    txtOptGradConv,
                    AcceptFloatBetween(MIN_OPT_GRADCONV, MAX_OPT_GRADCONV),
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["DFP"]["MaxIterations"]',
                    'Optimizer MaxIter', REGTYPE_INT, DEF_OPT_MAXITER,
                    txtOptMaxIter,
                    AcceptIntBetween(MIN_OPT_MAXITER, MAX_OPT_MAXITER),
                    '') );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DFP"]["Restart"]',
                        'Optimizer Restart', REGTYPE_INT, DEF_OPT_RESTART,
                        chkOptRestart));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DFP"]["NumGrads"]',
                        'Optimizer NumGrads', REGTYPE_INT, DEF_OPT_NUMGRADS,
                        chkOptNumGrads)
                        .Enables(txtOptNumGradStep)
                        .Enables(chkOptNumGradsFast)
                        );
  AddEditProperty(TQUB_Property_Edit.Create('["DFP"]["NumGradStep"]',
                    'Optimizer NumGradStep', REGTYPE_FLOAT, DEF_OPT_NUMGRADSTEP,
                    txtOptNumGradStep,
                    AcceptFloatBetween(MIN_OPT_NUMGRADSTEP, MAX_OPT_NUMGRADSTEP),
                   '') );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DFP"]["NumGradsFast"]',
                        'Optimizer NumGradsFast', REGTYPE_INT, DEF_OPT_NUMGRADSFAST,
                        chkOptNumGradsFast)
                        );
{
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["DFP"]["PlotLL"]',
                        'Optimizer PlotLL', REGTYPE_INT, DEF_OPT_PLOTLL,
                        chkOptPlotLL)
                        .Enables(lblOptPlotLLPage)
                        .Enables(lblOptPlotLLTrace)
                        .Enables(txtOptPlotLLPage)
                        .Enables(txtOptPlotLLTrace)
                        );
  AddEditProperty(TQUB_Property_Edit.Create('["DFP"]["PlotLLPage"]',
                    'Optimizer PlotLLPage', REGTYPE_INT, DEF_OPT_PLOTLLPAGE,
                    txtOptPlotLLPage,
                    AcceptIntBetween(0, QUB_QVO_QVGRAPH_MAXPAGE),
                    ''));
  AddEditProperty(TQUB_Property_Edit.Create('["DFP"]["PlotLLTrace"]',
                    'Optimizer PlotLLTrace', REGTYPE_INT, DEF_OPT_PLOTLLTRACE,
                    txtOptPlotLLTrace,
                    AcceptIntBetween(0, QUB_QVO_QVGRAPH_MAXCHANNEL),
                    ''));
 }
  AddEditProperty(TQUB_Property_Edit.Create('["DFP"]["MaxStep"]',
                    'Optimizer MaxStep', REGTYPE_FLOAT, DEF_OPT_MAXSTEP,
                    txtOptMaxStep,
                    AcceptFloatBetween(MIN_OPT_MAXSTEP, MAX_OPT_MAXSTEP),
                   '') );
  //Latency
  AddEditProperty(TQUB_Property_Edit.Create('["OptStimLatency"]',
                    'StimulusLatency', REGTYPE_INT, DEF_OPT_STIMLATENCY,
                    txtStimulusLatency,
                    AcceptIntBetween(MIN_OPT_STIMLATENCY, MAX_OPT_STIMLATENCY),
                    '') );

  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["Mode"]',
                          'Optimizer Mode', REGTYPE_INT, MacOptModeStringOf(DEF_OPT_MODE))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkOptModeOpt,
                                       MacOptModeStringOf(MODE_OPTIMIZE),
                                       Integer(MODE_OPTIMIZE)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkOptModeCheck,
                                       MacOptModeStringOf(MODE_CHECK),
                                       Integer(MODE_CHECK)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkOptModeSim,
                                       MacOptModeStringOf(MODE_SIM),
                                       Integer(MODE_SIM)))
                       );
  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["use segments"]',
                          'Optimizer Segments', REGTYPE_INT, MacSegModeStringOf(DEF_OPT_SEGMENTS))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkOptSegmentsTogether,
                                       MacSegModeStringOf(OPTSEGS_TOGETHER),
                                       Integer(OPTSEGS_TOGETHER)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkOptSegmentsGroup,
                                       MacSegModeStringOf(OPTSEGS_GROUP),
                                       Integer(OPTSEGS_GROUP)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkOptSegmentsGroupList,
                                       MacSegModeStringOf(OPTSEGS_GROUPLIST),
                                       Integer(OPTSEGS_GROUPLIST)))
                       );
  //Fit Data , etc.
  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["OptFitDataMode"]',
                          'Optimizer FitDataMode', REGTYPE_INT, MacFitDataModeStringOf(DEF_OPT_FITDATAMODE))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkOptFitDataWhole,
                                       MacFitDataModeStringOf(FITDATA_WHOLE),
                                       Integer(FITDATA_WHOLE)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkOptFitDataList,
                                       MacFitDataModeStringOf(FITDATA_LIST),
                                       Integer(FITDATA_LIST)))
                       );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["OptExcData"]',
                        'Optimizer ExcData', REGTYPE_INT, DEF_OPT_EXCDATA,
                        chkOptExcData));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["ShowFit"]',
                        'Optimizer ShowFit', REGTYPE_INT, DEF_OPT_SHOWFIT,
                        chkOptShowFit));
  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["ShowFitWhat"]',
                          'Optimizer ShowFit What', REGTYPE_INT, DEF_OPT_SHOWFIT_WHAT)
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkOptShowFitAvg,
                                       SHOWFIT_AVG,
                                       SHOWFIT_AVG))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkOptShowFitStd,
                                       SHOWFIT_STD,
                                       SHOWFIT_STD))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkOptShowFitRes,
                                       SHOWFIT_RES,
                                       SHOWFIT_RES))
                       );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["OptSkip"]',
                        'Optimizer Skip', REGTYPE_INT, DEF_OPT_SKIP,
                        chkOptSkip));
  AddEditProperty(TQUB_Property_Edit.Create('["OptSkipTime"]',
                    'Optimizer SkipTime', REGTYPE_FLOAT, DEF_OPT_SKIPTIME,
                    txtOptSkipTime,
                    AcceptFloatBetween(MIN_OPT_SKIPTIME, MAX_OPT_SKIPTIME),
                    '') );
  AddUpDownProperty(TQUB_Property_UpDown.Create('["SegGroupCount"]',
                      'Optimizer Segments GroupCount', REGTYPE_INT, DEF_OPT_SEGMENTS_GROUPCOUNT,
                      udOptSegmentsGroupCount,
                      txtOptSegmentsGroupCount,
                      AcceptIntGreaterThan(0)));
  AddEditProperty(TQUB_Property_Edit.Create('["OptSegGroupList"]',
                    'Optimizer Segments GroupList', REGTYPE_STRING, IntToStr(DEF_OPT_SEGMENTS_GROUPCOUNT),
                    txtOptSegmentsGroupList,
                    '',
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["SegMaxBatch"]',
                    'Optimizer Segments MaxBatch', REGTYPE_INT, DEF_OPT_MAXBATCH,
                    txtOptSegmentsMaxBatch,
                    AcceptIntBetween(MIN_OPT_MAXBATCH, MAX_OPT_MAXBATCH),
                    '') );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["IdenticalChunks"]',
                        'Optimizer IdenticalChunks', REGTYPE_INT, DEF_OPT_IDENTICALCHUNKS,
                        chkOptSegmentsIdChunks));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["MUXFiles"]',
                        'Optimizer MUXFiles', REGTYPE_INT, DEF_OPT_MUXFILES,
                        chkOptSegmentsMUXFiles));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["PropagateParams"]',
                        'Optimizer PropagateParams', REGTYPE_INT, DEF_OPT_PROPAGATEPARAMS,
                        chkOptSegmentsPropagateParams));
  //I = f(Voltage)
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["OptUseVRev"]',
                        'Optimizer UseVRev', REGTYPE_INT, DEF_OPT_USEVREV,
                        chkOptUseVRev)
                      .Enables(lblVRev)
                      .Enables(chkVRevFromModel)
                      .Enables(chkVRevHere)
                      .Enables(lblGLeak)
                      .Enables(chkGLeakFromTable)
                      .Enables(chkGLeakHere)
                      .Enables(lblVLeak)
                      .Enables(chkVLeakFromTable)
                      .Enables(chkVLeakHere)
                      );
  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["OptVRevFromModel"]',
                          '', REGTYPE_NONE, 1)
                            .AddButton(TQUB_Property_RadioButton.Create(
                                         chkVrevFromModel, 1, 1)
                                       )
                            .AddButton(TQUB_Property_RadioButton.Create(
                                         chkVrevHere, 0, 0)
                                       .Enables(txtVRev)
                                       )
                       );
  AddEditProperty(TQUB_Property_Edit.Create('["OptVRev"]',
                    'Optimizer VRev', REGTYPE_FLOAT, DEF_OPT_VREV,
                    txtVRev,
                    AcceptFloatBetween(MIN_OPT_VREV, MAX_OPT_VREV),
                    '') );
  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["OptGLeakFromTable"]',
                          '', REGTYPE_NONE, 1)
                            .AddButton(TQUB_Property_RadioButton.Create(
                                         chkGleakFromTable, 1, 1)
                                       )
                            .AddButton(TQUB_Property_RadioButton.Create(
                                         chkGleakHere, 0, 0)
                                       .Enables(txtGleak)
                                       )
                       );
  AddEditProperty(TQUB_Property_Edit.Create('["OptGLeak"]',
                    '', REGTYPE_NONE, DEF_OPT_GLEAK,
                    txtGleak,
                    AcceptFloatBetween(MIN_OPT_GLEAK, MAX_OPT_GLEAK),
                    '') );
  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["OptVLeakFromTable"]',
                          '', REGTYPE_NONE, 1)
                            .AddButton(TQUB_Property_RadioButton.Create(
                                         chkVleakFromTable, 1, 1)
                                       )
                            .AddButton(TQUB_Property_RadioButton.Create(
                                         chkVleakHere, 0, 0)
                                       .Enables(txtVleak)
                                       )
                       );
  AddEditProperty(TQUB_Property_Edit.Create('["OptVLeak"]',
                    '', REGTYPE_NONE, DEF_OPT_VREV,
                    txtVleak,
                    AcceptFloatBetween(MIN_OPT_VREV, MAX_OPT_VREV),
                    '') );

  //AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["NewIdlCond"]',
  //                      '', REGTYPE_NONE, 1,
  //                      chkNewIdlCond));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["SkipSlowChange"]',
                        '', REGTYPE_NONE, DEF_SKIPSLOWCHANGE,
                        chkSkipSlowChange)
                      .Enables(txtSkipSlowStd)
                      );
  AddEditProperty(TQUB_Property_Edit.Create('["SkipSlowStd"]',
                    '', REGTYPE_NONE, DEF_SKIPSLOWSTD,
                    txtSkipSlowStd,
                    AcceptFloatGreaterThan(0.0),
                    '') );

  //Scripts
  {
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["OptScriptPenalty"]',
                        'Optimizer ScriptPenalty', REGTYPE_INT, DEF_OPT_SCRIPTPENALTY,
                        chkOptScriptPenalty)
                      .Enables(txtScriptPenalty)
                      );
  AddEditProperty(TQUB_Property_Edit.Create('["OptScriptPenaltyName"]',
                    '', REGTYPE_STRING, DEF_OPT_SCRIPTPENALTYNAME,
                    txtScriptPenalty,
                    AcceptString,
                    '') );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["OptScriptIteration"]',
                        'Optimizer ScriptIteration', REGTYPE_INT, DEF_OPT_SCRIPTITERATION,
                        chkOptScriptIteration)
                      .Enables(txtScriptIteration)
                      );
  AddEditProperty(TQUB_Property_Edit.Create('["OptScriptIterationName"]',
                    '', REGTYPE_STRING, DEF_OPT_SCRIPTITERATIONNAME,
                    txtScriptIteration,
                    AcceptString,
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["MinAbsStimulus"]',
                        '', REGTYPE_NONE, DEF_MINABSSTIMULUS,
                        txtMinAbsStimulus,
                        AcceptFloatGreaterThanOrEqualTo(0.0),
                        '') );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["OptScriptSetPars"]',
                        'Optimizer ScriptSetPars', REGTYPE_INT, DEF_OPT_SCRIPTSETPARS,
                        chkOptScriptSetPars)
                      .Enables(txtScriptSetPars)
                      );
  AddEditProperty(TQUB_Property_Edit.Create('["OptScriptSetParsName"]',
                    '', REGTYPE_STRING, DEF_OPT_SCRIPTSETPARSNAME,
                    txtScriptSetPars,
                    AcceptString,
                    '') );

  }
  RegKeyName            := 'Software\QUB\Task Mac optimizer';
  ProfileCat            := 'Mac';
  prBeforeGetProperties := PropertiesToParams;

  WikiTopic             := 'Modeling:Mac#Properties';

  prDataList            := TQUB_DataList.Create(Self);
  prDataList.Parent     := Self;
  prDataList.SetBounds(20, 50, 600, 100);

  mnuProfiles.SetBounds(329, 494, 127, mnuProfiles.Height);

  {$include 'QUB_Task_Mac_Properties.htx'}
end;

procedure TQUB_Task_Mac_PropertiesForm.FormShow(Sender: TObject);
var
  Model :TQUB_QVO_QVM;
begin
  inherited;

  prSetFitDataList;
  prSetExcDataList;

  prDataList.ShowFiles;
  prDataList.ShowVar('GLeak', '', 0.0, False);
  prDataList.ShowVar('VLeak', '', 0.0, False);
  prDataList.ShowVar('FitWeight', '', 1, False);
  prDataList.ShowVar('CCFixed', '', 0, False);

  Model := ViewportModel.CurrModel;
  if Model <> nil then begin
    prDataList.ShowModelVars(Model, True);
    chkOptUseVRev.Checked := Model.IeqFv;
    // prProperties['OptUseVRev'].Data[0] := Integer(Model.IeqFv); now this and model are alternatives
  end;

  prDataList.ShowFiles;

end;

procedure TQUB_Task_Mac_PropertiesForm.FormHide(Sender: TObject);
var
  Model :TQUB_QVO_QVM;
begin
  inherited;

  PropertiesToParams;

  Model := ViewportModel.CurrModel;
  if Model <> nil then begin
    Model.IeqFv := 0<>OptUseVRev;
  end;

  prDataList.HideAll;
end;


procedure TQUB_Task_Mac_PropertiesForm.prSetInitialProperties(Props :INode);
  // override: inherited; fill missing properties from registry or defaults;
begin
  inherited;

  // if they defaulted to a name, it'd be here:
  // if Props['FitDataList'].DataCount = 0 then Props['FitDataList'].SetData('DefName');

  prFitDataListName := Props['FitDataList'].DataAsString;
  prExcDataListName := Props['ExcDataList'].DataAsString;
end;

procedure TQUB_Task_Mac_PropertiesForm.prUpdateComponents;
  // override: put all your property values into the form
  // (supersedes MyProperty := MyProperty; in FormShow)
  // also called after SetProperties e.g. when user changes profile
begin
  inherited;

  prFitDataListName := prProperties['FitDataList'].DataAsString;
  prExcDataListName := prProperties['ExcDataList'].DataAsString;
  prSetFitDataList;
  prSetExcDataList;
end;

//Fit Data
procedure TQUB_Task_Mac_PropertiesForm.lstFitDataClick(Sender: TObject);
begin
  inherited;
  FitDataListIdx := TComboBox(Sender).ItemIndex;
end;

//Fit Data Exclude
procedure TQUB_Task_Mac_PropertiesForm.lstExcDataClick(Sender: TObject);
begin
  inherited;
  ExcDataListIdx := TComboBox(Sender).ItemIndex;
end;


//******************************************************************************
procedure TQUB_Task_Mac_PropertiesForm.PropertiesToParams;
begin
  prQuietOutput                      := RetardedBooleanCast( Properties['QuietOutput'].Data[0] );

  prParams.EstRates                  := Properties['Est']['Rates'].Data[0];
  prParams.EstChannelCount           := Properties['Est']['ChannelCount'].Data[0];
  prParams.EstChannelCountPerFile    := Properties['Est']['ChannelCountPerFile'].Data[0];
  prParams.EstAmpOpen                := Properties['Est']['AmpOpen'].Data[0];
  prParams.EstVarOpen                := Properties['Est']['VarOpen'].Data[0];
  prParams.EstInitProbs              := Q_InitProbsOfString( Properties['Est']['InitProbs'].DataAsString );
  prParams.EstUseVariance            := Properties['Est']['UseVariance'].Data[0];
  prParams.EstUseMinRate             := RetardedBooleanCast( Properties['Est']['UseMinRate'].Data[0] );
  prParams.EstUseMaxRate             := RetardedBooleanCast( Properties['Est']['UseMaxRate'].Data[0] );
  prParams.EstMinRate                := Properties['Est']['MinRate'].Data[0];
  prParams.EstMaxRate                := Properties['Est']['MaxRate'].Data[0];

  prParams.OptLLConv                 := Properties['DFP']['ConvLL'].Data[0];
  prParams.OptGradConv               := Properties['DFP']['ConvGrad'].Data[0];
  prParams.OptMaxStep                := Properties['DFP']['MaxStep'].Data[0];
  prParams.OptMaxIter                := Properties['DFP']['MaxIterations'].Data[0];
  prParams.OptRestart                := Properties['DFP']['Restart'].Data[0];
  prParams.OptNumGrads               := Properties['DFP']['NumGrads'].Data[0];
  prParams.OptNumGradStep            := Properties['DFP']['NumGradStep'].Data[0];
  prParams.OptNumGradsFast           := Properties['DFP']['NumGradsFast'].Data[0];
  //prParams.OptPlotLL                 := Properties['DFP']['PlotLL'].Data[0];
  //prParams.OptPlotLLPage             := Properties['DFP']['PlotLLPage'].Data[0];
  //prParams.OptPlotLLTrace            := Properties['DFP']['PlotLLTrace'].Data[0];

  prParams.OptMode                   := MacOptModeOfString( Properties['Mode'].DataAsString );
  prParams.OptSegments               := MacSegModeOfString( Properties['use segments'].DataAsString );

  prParams.OptStimLatency            := Properties['OptStimLatency'].Data[0];
  prParams.OptStimDelta              := DEF_OPT_STIMDELTA;//Properties['OptStimDelta'].Data[0];
  prParams.OptFitDataMode            := MacFitDataModeOfString( Properties['OptFitDataMode'].DataAsString);
  prParams.OptExcData                := Properties['OptExcData'].Data[0];
  prParams.OptShowFit                := Properties['ShowFit'].Data[0];
  prParams.OptShowFitWhat            := Properties['ShowFitWhat'].Data[0];
  prParams.OptSkip                   := Properties['OptSkip'].Data[0];
  prParams.OptSkipTime               := Properties['OptSkipTime'].Data[0];
  prParams.OptSegmentsGroupCount     := Properties['SegGroupCount'].Data[0];
  prParams.OptSegmentsMaxBatch       := Properties['SegMaxBatch'].Data[0];
  prParams.OptIdenticalChunks        := Properties['IdenticalChunks'].Data[0];
  prParams.OptMUXFiles               := Properties['MUXFiles'].Data[0];
  prParams.OptPropagateParams        := Properties['PropagateParams'].Data[0];
  prParams.OptUseVRev                := Properties['OptUseVRev'].Data[0];
  prParams.OptVRevFromModel          := 0<>Properties['OptVRevFromModel'].Data[0];
  prParams.OptVRev                   := Properties['OptVRev'].Data[0];
  prParams.OptGleakFromTable         := 0<>Properties['OptGLeakFromTable'].Data[0];
  prParams.OptGleak                  := Properties['OptGLeak'].Data[0];
  prParams.OptVleakFromTable         := 0<>Properties['OptVLeakFromTable'].Data[0];
  prParams.OptVleak                  := Properties['OptVLeak'].Data[0];
  {
  prParams.OptScriptPenalty          := Properties['OptScriptPenalty'].Data[0];
  prParams.OptScriptPenaltyName      := Properties['OptScriptPenaltyName'].DataAsString;
  prParams.OptScriptIteration        := Properties['OptScriptIteration'].Data[0];
  prParams.OptScriptIterationName    := Properties['OptScriptIterationName'].DataAsString;
  prParams.OptScriptSetPars          := Properties['OptScriptSetPars'].Data[0];
  prParams.OptScriptSetParsName      := Properties['OptScriptSetParsName'].DataAsString;
  }
end;


//******************************************************************************
end.
