unit QUB_Task_Simulate_Properties;

{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}

interface


uses


Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, ComCtrls, Registry, Grids, Math,

RegistryInterface,

QUB_Properties,
QUB_Task_Properties,
QUB_Global,
QUB_QVO_QVM,
QUB_QVO_QVD,
QUB_QVO_QVP,
QUB_QFS_Channels,
QUB_Task_Simulate,
QUB_ExpCond_Parameters, QUB_ExpCond_Editor,

QUB_Node,

QUB_Table;

//KPL_Kinetic,
//KPL_Program;


{$include 'QUB_Task_Simulate_Properties.hct'}


type


TQUB_Task_Simulate_PropertiesForm = class(TQUB_Task_PropertiesForm)


  Label2                          :TLabel;
  Label4                          :TLabel;
  Label5                          :TLabel;

  btnReset                        :TButton;

  PageControl                     :TPageControl;

  tabData                         :TTabSheet;
  tabModel                        :TTabSheet;
  tabSimulation                   :TTabSheet;
  tabStaircase                    :TTabSheet;
  chkFilterOn                     :TCheckBox;
  txtFilterFreq                   :TEdit;
  txtSegmentCount                 :TEdit;
  udSegmentCount                  :TUpDown;
  txtSegmentSize                  :TEdit;
  udSegmentSize                   :TUpDown;
  chkIdealizedData                :TCheckBox;
  panDataMode                     :TPanel;
  chkDataModeNew                  :TRadioButton;
  chkDataModeReplace              :TRadioButton;
  chkDataModeAppend               :TRadioButton;
  chkDataModeAppendCurr           :TRadioButton;
  lstModels                       :TListBox;
  txtModelChannelCount            :TEdit;
  udModelChannelCount             :TUpDown;
  panSource                       :TPanel;
  panResponse                     :TPanel;
  chkResponseStochastic           :TRadioButton;
  chkResponseDeterministic        :TRadioButton;

  tabBaseline                     :TTabSheet;
  chkBaselineFluct                :TCheckBox;
  panBaseline                     :TPanel;
  Label7                          :TLabel;
  txtBaselineFluctLifetime        :TEdit;
  Label8                          :TLabel;
  txtBaselineFluctMaxAmp          :TEdit;
  chkBaselineDrift                :TCheckBox;
  Panel1                          :TPanel;
  Label9                          :TLabel;
  Label10                         :TLabel;
  txtBaselineDriftSlope           :TEdit;
  txtBaselineDriftIntercept       :TEdit;
  Label11                         :TLabel;
  txtBaselineFluctN               :TEdit;
  chkBaselineJumps                :TCheckBox;
  Panel2                          :TPanel;
  Label12                         :TLabel;
  Label13                         :TLabel;
  txtBaselineJumpsSlow            :TEdit;
  txtBaselineJumpsFast            :TEdit;
  chkBaselinePeriodic             :TCheckBox;
  Panel3                          :TPanel;
  Label14                         :TLabel;
  Label15                         :TLabel;
  Label16                         :TLabel;
  txtBaselinePeriodicAmp          :TEdit;
  txtBaselinePeriodicFreq         :TEdit;
  txtBaselinePeriodicPhase        :TEdit;
  Label17                         :TLabel;
  txtBaselineJumpsLifetime        :TEdit;
  Label18                         :TLabel;
  txtBaselineJumpsAmpAvg          :TEdit;
  Label19                         :TLabel;
  txtBaselineJumpsAmpStd          :TEdit;
  Label20                         :TLabel;
  txtBaselineJumpsFastW           :TEdit;
  Panel4                          :TPanel;
  Label21                         :TLabel;
  chkIDLOutputState               :TRadioButton;
  chkIDLOutputClass               :TRadioButton;
  chkIDLOutputGroup               :TRadioButton;
  chkBaselineLGM                  :TCheckBox;
  Panel5                          :TPanel;
  Label22                         :TLabel;
  txtBaselineLGMProcStd           :TEdit;
  Label23                         :TLabel;
  Label24                         :TLabel;
  txtBaselineLGMx0                :TEdit;
  txtBaselineLGMx0p               :TEdit;
  chkBaselineLGM2State            :TCheckBox;
  chkRandomize                    :TCheckBox;
  Label25                         :TLabel;
  txtRandomSeed                   :TEdit;
    Panel6: TPanel;
    chkStimulationNone: TRadioButton;
    chkStimulationFile: TRadioButton;
    Label27: TLabel;
    chkStimulationScript: TRadioButton;
    Label28: TLabel;
    Label29: TLabel;
    lstStimData: TComboBox;
    Label3: TLabel;
    Label30: TLabel;
    chkUseCondVoltage: TCheckBox;
    txtCondVoltage: TEdit;
    LblCondVoltage: TLabel;
    chkFlux: TCheckBox;
    txtFluxStates: TEdit;
    Label33: TLabel;
    txtTransitionState1: TEdit;
    txtTransitionState2: TEdit;
    Label34: TLabel;
    tabMovie: TTabSheet;
    chkMakeMovie: TCheckBox;
    txtStructuresFile: TEdit;
    lblFileName: TLabel;
    btnBrowseFileName: TButton;
    Label1: TLabel;
    chkStaircase: TCheckBox;
    txtStaircaseStepStd: TEdit;
    lblStaircaseStepStd: TLabel;
    txtStaircaseSteps: TRichEdit;
    chkStaircaseStepsFromParam: TCheckBox;
    chkStaircaseNoJumpClass: TCheckBox;
    panStructures: TPanel;
    txtScriptFileName: TEdit;
    Label6: TLabel;
    chkILeak: TCheckBox;
    txtGLeak: TEdit;
    Label26: TLabel;
    Label31: TLabel;
    txtVLeak: TEdit;
    chkSaveMovieFiles: TCheckBox;
    chkApplyDeadTime: TCheckBox;
    Label32: TLabel;
    txtDeadTime: TEdit;
    panGatingUnits: TPanel;
    chkGating: TCheckBox;
    chkGatingV: TRadioButton;
    chkGatingMV: TRadioButton;
    chkGatingOther: TRadioButton;
    chkGatingInvert: TCheckBox;
    txtGatingOther: TEdit;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    txtMakeMovieFrameDuration: TEdit;


  procedure FormCreate(Sender: TObject);
  procedure FormDestroy(Sender: TObject);
  procedure FormShow(Sender: TObject);
  procedure FormHide(Sender: TObject);

  procedure btnOKClick(Sender: TObject);

  procedure chkDataModeClick(Sender: TObject);
  procedure lstModelsClick(Sender: TObject);
  procedure chkStimulationClick(Sender: TObject);
  procedure chkResponseStochasticClick(Sender: TObject);
  procedure txtSegmentCountKeyPress(Sender: TObject; var Key: Char);
  procedure txtSegmentCountExit(Sender: TObject);
  procedure udSegmentCountClick(Sender: TObject; Button: TUDBtnType);
  procedure udSegmentCountChanging(Sender: TObject; var AllowChange: Boolean);
  procedure txtSegmentSizeKeyPress(Sender: TObject; var Key: Char);
  procedure txtSegmentSizeExit(Sender: TObject);
  procedure udSegmentSizeClick(Sender: TObject; Button: TUDBtnType);
  procedure udSegmentSizeChanging(Sender: TObject; var AllowChange: Boolean);
  procedure udModelChannelCountClick(Sender: TObject; Button: TUDBtnType);
  procedure udModelChannelCountChanging(Sender: TObject; var AllowChange: Boolean);
  procedure txtModelChannelCountKeyPress(Sender: TObject; var Key: Char);
  procedure txtModelChannelCountExit(Sender: TObject);
  procedure lstStimDataClick(Sender: TObject);
  procedure btnBrowseFileNameClick(Sender: TObject);
    procedure chkFluxClick(Sender: TObject);


protected


  grdExpCond                      :TQUB_ExpCond_Editor;

  prPropertiesRec                 :TQUB_Task_Simulate_PropertiesRec;

  prDataMode                      :Integer;

  prModel                         :TQUB_QVO_QVM;

  prSegmentSizeChanging           :Boolean;
  prSegmentCountChanging          :Boolean;

  prModelChannelCount             :Integer;
  prModelChannelCountChanging     :Boolean;


  //Stimulation
  //prStimScript                    :String;
  prStimData                      :TQUB_QVO_QVD;
  prStimProto                     :TQUB_QVO_QVP;
  prProtoCount                    :Integer;
  //prSource                        :TKPL_Program;
  //prKinetic                       :TKPL_Kinetic;

  prModelParameters               :TQUB_ExpCond_Parameters;

  grdStructures                   :TQUB_Table;


  //procedure prOnChangeSource(Sender :TObject);

  procedure prInitExpCond;

  procedure prSetDataMode(d :Integer);
  function prGetDataModeString: String;
  procedure prSetDataModeString(x :String);

  procedure prSetModel(m :TQUB_QVO_QVM);

  //procedure prSetKinetic(k :TKPL_Kinetic);

  procedure prSetStimulation(s :TQUB_Task_Simulate_Stimulation);

  procedure prSetResponse(r :TQUB_Task_Simulate_Response);

  procedure prSetSegmentCount(c :Integer);
  procedure prSetSegmentSize(s :Integer);

  function prGetModelChannelCount :Integer;
  procedure prSetModelChannelCount(c :Integer);

  function prToggleFluxVisible(x :INode): INode;


  procedure prSetInitialProperties(Props :INode); override;
  procedure prUpdateComponents; override;

  procedure prLoadStructuresFile;
  

public



  procedure PropertiesToParams;


  //traditional Properties
  property Stimulation                    :TQUB_Task_Simulate_Stimulation   read prPropertiesRec.Stimulation             write prSetStimulation;
  property Response                       :TQUB_Task_Simulate_Response      read prPropertiesRec.Response             write prSetResponse;

  property SegmentCount                   :Integer                          read prPropertiesRec.SegmentCount            write prSetSegmentCount;
  property SegmentSize                    :Integer                          read prPropertiesRec.SegmentSize             write prSetSegmentSize;

  property DataMode                       :Integer                          read prDataMode                           write prSetDataMode;
  property DataModeString                 :String                           read prGetDataModeString                  write prSetDataModeString;

  property Model                          :TQUB_QVO_QVM                     read prModel                              write prSetModel;

  property ModelChannelCount              :Integer                          read prGetModelChannelCount               write prSetModelChannelCount;

  //property Source                         :TKPL_Program                     read prSource;
  //property Kinetic                        :TKPL_Kinetic                                                               write prSetKinetic;

  property ProtoCount                     :Integer                          read prProtoCount                         write prProtoCount;

  //read-only Properties
  property PropertiesRec                  :TQUB_Task_Simulate_PropertiesRec read prPropertiesRec;

  property UseCondVoltage                 :Boolean                          read prPropertiesRec.UseCondVoltage;
  property CondVoltage                    :Double                           read prPropertiesRec.CondVoltage;
  property ILeak                          :Boolean                          read prPropertiesRec.ILeak;
  property GLeak                          :Double                           read prPropertiesRec.GLeak;
  property VLeak                          :Double                           read prPropertiesRec.VLeak;

  property IdealizedData                  :Boolean                          read prPropertiesRec.IdealizedData;
  property IDLOutput                      :Integer                          read prPropertiesRec.IDLOutput;

  property DoRandomize                    :Boolean                          read prPropertiesRec.Randomize;
  property RandomSeed                     :Integer                          read prPropertiesRec.RandomSeed;

  property ApplyDeadTime                  :Boolean                          read prPropertiesRec.ApplyDeadTime;
  property DeadTime                       :Double                           read prPropertiesRec.DeadTime;

  property FilterOn                       :Boolean                          read prPropertiesRec.FilterOn;
  property FilterFreq                     :Double                           read prPropertiesRec.FilterFreq;

  property Flux                           :Boolean                          read prPropertiesRec.Flux;
  property FluxFrom                       :Integer                          read prPropertiesRec.FluxFrom;
  property FluxTo                         :Integer                          read prPropertiesRec.FluxTo;

  property Staircase                      :Boolean                          read prPropertiesRec.Staircase;
  property StaircaseUseSteps              :Boolean                          read prPropertiesRec.StaircaseUseSteps;
  property StaircaseSteps                 :String                           read prPropertiesRec.StaircaseSteps;
  property StaircaseStepStd               :Double                           read prPropertiesRec.StaircaseStepStd;
  property StaircaseNoJumpClass           :Boolean                          read prPropertiesRec.StaircaseNoJumpClass;

  property BaselineFluct                  :Boolean                          read prPropertiesRec.BaselineFluct;
  property BaselineFluctLifetime          :Double                           read prPropertiesRec.BaselineFluctLifetime;
  property BaselineFluctMaxAmp            :Double                           read prPropertiesRec.BaselineFluctMaxAmp;
  property BaselineFluctN                 :Integer                          read prPropertiesRec.BaselineFluctN;
  property BaselineDrift                  :Boolean                          read prPropertiesRec.BaselineDrift;
  property BaselineDriftSlope             :Double                           read prPropertiesRec.BaselineDriftSlope;
  property BaselineDriftIntercept         :Double                           read prPropertiesRec.BaselineDriftIntercept;
  property BaselineJumps                  :Boolean                          read prPropertiesRec.BaselineJumps;
  property BaselineJumpsAmpAvg            :Double                           read prPropertiesRec.BaselineJumpsAmpAvg;
  property BaselineJumpsAmpStd            :Double                           read prPropertiesRec.BaselineJumpsAmpStd;
  property BaselineJumpsLifetime          :Double                           read prPropertiesRec.BaselineJumpsLifetime;
  property BaselineJumpsFastW             :Double                           read prPropertiesRec.BaselineJumpsFastW;
  property BaselineJumpsFast              :Double                           read prPropertiesRec.BaselineJumpsFast;
  property BaselineJumpsSlow              :Double                           read prPropertiesRec.BaselineJumpsSlow;
  property BaselinePeriodic               :Boolean                          read prPropertiesRec.BaselinePeriodic;
  property BaselinePeriodicAmp            :Double                           read prPropertiesRec.BaselinePeriodicAmp;
  property BaselinePeriodicFreq           :Double                           read prPropertiesRec.BaselinePeriodicFreq;
  property BaselinePeriodicPhase          :Double                           read prPropertiesRec.BaselinePeriodicPhase;
  property BaselineLGM                    :Boolean                          read prPropertiesRec.BaselineLGM;
  property BaselineLGMProcStd             :Double                           read prPropertiesRec.BaselineLGMProcStd;
  property BaselineLGMX0                  :Double                           read prPropertiesRec.BaselineLGMX0;
  property BaselineLGMX0p                 :Double                           read prPropertiesRec.BaselineLGMX0p;
  property BaselineLGM2State              :Boolean                          read prPropertiesRec.BaselineLGM2State;

  property StimData                       :TQUB_QVO_QVD                     read prStimData;
  property StimProto                      :TQUB_QVO_QVP                     read prStimProto;

  property StructureFiles                 :TQUB_Table                       read grdStructures;
  

end;


implementation


{$R *.DFM}


uses


QUB_GUIInterface,
QUB_Python_Thread,
QUB_Viewport_Python,
QUB_Node_Python,
QUB_Main;


//******************************************************************************
procedure TQUB_Task_Simulate_PropertiesForm.prInitExpCond;
var
  Stimuli       :TStringList;  // actively in use in chosen models
  Model         :TQUB_QVO_QVM;
  Params        :TQUB_ExpCond_Parameters;
  Param         :TQUB_ExpCond_PParameter;
  i, j, k       :Integer;
begin
  if (Stimulation = SIM_STIM_FILE) then begin
    Stimuli            := TStringList.Create;
    Stimuli.Sorted     := True;
    Stimuli.Duplicates := dupIgnore;
    try
      // list active stimuli
      Params           := ViewportModel.DefExpCond;

      for i := 0 to lstModels.Items.Count - 1 do begin
        Model       := TQUB_QVO_QVM(lstModels.Items.Objects[i]);
        if not lstModels.Selected[i] then Continue;
        for j := 0 to Model.ModelObject.Rates.RateCount - 1 do begin
          for k := 1 to 2 do begin
            if Model.ModelObject.Rates[j].P[k] then Stimuli.Add(Model.ModelObject.Rates[j].PName[k]);
            if Model.ModelObject.Rates[j].Q[k] then Stimuli.Add(Model.ModelObject.Rates[j].QName[k]);
          end;
        end;
      end;

      // knock out inactive stimuli
      for i := 0 to Params.Count - 1 do begin
        if Stimuli.IndexOf(Params[i].Name) < 0 then begin
          Params.ChangeParChannel(i, -1);
        end;
      end;

      if prStimData <> nil then begin
        if (prStimData.DataObject.ADChannelCount = 1) and (Stimuli.Count = 1) then begin
          // if there's one channel avail for one stimulus, match 'em
          Params.ChangeParChannel(Params.IndexOf(Stimuli[0]), 1);
        end else begin
          // else if channel(s) in stimdata have same name as stimulus, match 'em
          for i := 0 to Stimuli.Count - 1 do begin
            Param := prStimData.ExpCond.ParameterByName[Stimuli[i]];
            if (Param <> nil) and (Param.Channel >= 0) and (Param.Channel < prStimData.DataObject.ADChannelCount) then begin
              Params.ChangeParChannel(Params.IndexOf(Stimuli[i]), Param.Channel+1);
            end;
          end;
        end;
      end;

      if prStimProto <> nil then begin
        if (prStimProto.Protocol.ChannelCount = 1) and (Stimuli.Count = 1) then begin
          Params.ChangeParChannel(Params.IndexOf(Stimuli[0]), 1);
        end;
      end;
      
      grdExpCond.ExpCond := Params; // update
    finally
      Stimuli.Free;
    end;
  end;
end;

//******************************************************************************
procedure TQUB_Task_Simulate_PropertiesForm.prSetResponse(r :TQUB_Task_Simulate_Response);
begin
  prPropertiesRec.Response         := r;
  chkResponseStochastic.Checked    := Integer(r) = chkResponseStochastic.Tag;
  chkResponseDeterministic.Checked := Integer(r) = chkResponseDeterministic.Tag;
  Properties['Simulation']['Response'].SetData(ResponseToString(r));
  
  chkFlux.Enabled          :=  r = SIM_RESPONSE_DETERMINISTIC;
  txtFluxStates.Enabled    := (r = SIM_RESPONSE_DETERMINISTIC) and (0<>Properties['Flux'].Data[0]);
end;

procedure TQUB_Task_Simulate_PropertiesForm.prSetStimulation(s :TQUB_Task_Simulate_Stimulation);
begin
  prPropertiesRec.Stimulation     := s;
  chkStimulationNone.Checked   := Integer(s) = chkStimulationNone.Tag;
  chkStimulationFile.Checked   := Integer(s) = chkStimulationFile.Tag;
  //chkStimulationScript.Checked := Integer(s) = chkStimulationScript.Tag;
  Properties['Simulation']['Stimulation'].SetData( StimulationToString(s) );

  txtSegmentSize.Enabled  := s <> SIM_STIM_FILE;
  txtSegmentCount.Enabled := s <> SIM_STIM_FILE;
  udSegmentSize.Enabled   := s <> SIM_STIM_FILE;
  udSegmentCount.Enabled  := s <> SIM_STIM_FILE;
end;

procedure TQUB_Task_Simulate_PropertiesForm.prSetSegmentCount(c :Integer);
begin
  prPropertiesRec.SegmentCount := c;
  Properties['Data']['SegmentCount'].Data[0] := c;
  txtSegmentCount.Text := IntToStr(SegmentCount);
end;

procedure TQUB_Task_Simulate_PropertiesForm.prSetSegmentSize(s :Integer);
begin
  prPropertiesRec.SegmentSize := s;
  Properties['Data']['SegmentSize'].Data[0] := s;
  txtSegmentSize.Text := IntToStr(SegmentSize);
end;

function TQUB_Task_Simulate_PropertiesForm.prGetModelChannelCount :Integer;
begin
  if Model <> nil then begin
    Result := Model.ModelObject.{Sim}ChannelCount;
  end else begin
    Result := 0;
  end;
end;

procedure TQUB_Task_Simulate_PropertiesForm.prSetDataMode(d :Integer);
begin
  prDataMode := d;
  Properties['Data']['DataMode'].SetData( DataModeString );
  chkDataModeNew.Checked        := prDataMode = chkDataModeNew.Tag;
  chkDataModeReplace.Checked    := prDataMode = chkDataModeReplace.Tag;
  chkDataModeAppend.Checked     := prDataMode = chkDataModeAppend.Tag;
  chkDataModeAppendCurr.Checked := prDataMode = chkDataModeAppendCurr.Tag;
end;

function TQUB_Task_Simulate_PropertiesForm.prGetDataModeString: String;
begin
  if DataMode = 0 then begin
    Result                    := 'New';
  end else if DataMode = 1 then begin
    Result                    := 'Replace';
  end else if DataMode = 2 then begin
    Result                    := 'Append';
  end else if DataMode = 3 then begin
    Result                    := 'AppendCurrent';
  end;
end;

procedure TQUB_Task_Simulate_PropertiesForm.prSetDataModeString(x :String);
begin
  if x = 'New' then begin
    DataMode                  := 0;
  end else if x = 'Replace' then begin
    DataMode                  := 1;
  end else if x = 'Append' then begin
    DataMode                  := 2;
  end else if x = 'AppendCurrent' then begin
    DataMode                  := 3;
  end;
end;

procedure TQUB_Task_Simulate_PropertiesForm.prSetModel(m :TQUB_QVO_QVM);
begin
  prModel := m;
  if prModel = nil then begin
    txtModelChannelCount.Text := '0';
  end else begin
    txtModelChannelCount.Text := IntToStr(Model.ModelObject.{Sim}ChannelCount);
  end;

  txtModelChannelCount.Enabled := Model <> nil;
  udModelChannelCount.Enabled  := Model <> nil;

  lstModels.ItemIndex := lstModels.Items.IndexOfObject(prModel);
  if (lstModels.ItemIndex >= 0) and (lstModels.ItemIndex < lstModels.Items.Count) then begin
    // apparently, in WINE, ItemIndex can be out of bounds; e.g. during initialization
    lstModels.Selected[lstModels.ItemIndex] := True;
  end;
end;

procedure TQUB_Task_Simulate_PropertiesForm.prSetModelChannelCount(c :Integer);
begin
  if Model <> nil then begin
    Model.ModelObject.{Sim}ChannelCount := c;
    txtModelChannelCount.Text := IntToStr(c);
  end;
end;
{
procedure TQUB_Task_Simulate_PropertiesForm.prSetKinetic(k :TKPL_Kinetic);
begin

  prSource.Kinetic := k;

end;
}

//******************************************************************************
procedure TQUB_Task_Simulate_PropertiesForm.FormCreate(Sender: TObject);
begin
  inherited;

  txtStaircaseSteps.ShowHint := True;
  txtStaircaseSteps.Hint     := 'Enter step sizes here, as follows:'#13#10 +
                                '  s[ize] = NUM, p[robability] = NUM, s = NUM, p = NUM, ...'#13#10#13#10 +
                                'The probability value is optional.'#13#10#13#10 +
                                'Separate alternating steps (or discrete distributions) by ";"'#13#10#13#10 +
                                'Example of myosin alternating steps:'#13#10 +
                                '  s = 30; s = 44'#13#10#13#10 +
                                'Example of dynein steps with discrete distribution:'#13#10 +
                                '  s=8, p=0.2, s=16, p=0.4, s=24, p=0.2,'#13#10 +
                                '  s=32, p=0.1, s=40, p=0.1'#13#10#13#10 +
                                'If p is not specified, the probabilities are assumed equal';

  chkStaircaseStepsFromParam.ShowHint := True;
  chkStaircaseStepsFromParam.Hint     := txtStaircaseSteps.Hint;


  Model := nil;
  {
  prSource              := TKPL_Program.Create(Self, 'Stimulation generator', nil);
  prSource.Options      := [KPL_PRG_BUTTONS, KPL_PRG_FILE, KPL_PRG_COMPILE];
  prSource.CanCompile   := False;
  prSource.CanRun       := False;
  prSource.Parent       := panSource;
  prSource.Align        := alClient;

  prSource.OnChangeFile := prOnChangeSource;
  }
  grdExpCond            := TQUB_ExpCond_Editor.Create(Self);
  grdExpCond.SetBounds(22, 170, 444, 155);
  grdExpCond.Parent     := tabModel;
  grdExpCond.ShowCond   := False;


  //Structure Movie ************************************************************
  grdStructures                   := TQUB_Table.Create(Self);
  grdStructures.Parent            := panStructures;
  grdStructures.Align             := alClient;
  grdStructures.ColCount          := 2;
  grdStructures.RowCount          := 21;
  grdStructures.Cells[0, 0]       := 'Idx';
  grdStructures.Cells[1, 0]       := 'Structure file';
  grdStructures.DefaultRowHeight  := 16;
  grdStructures.ColWidths[0]      := 40;
  grdStructures.ColWidths[1]      := panStructures.ClientWidth - grdStructures.ColWidths[0];
  grdStructures.Options           := [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine, goRangeSelect, goRowSizing, goColSizing, goRowMoving, goColMoving, goThumbTracking];

  AddEditProperty(TQUB_Property_Edit.Create('["StructuresFile"]',
                    'StructuresFile', REGTYPE_STRING, 'StructuresFile.txt',
                    txtStructuresFile,
                    '',
                    '') );
  //****************************************************************************
  {
  AddEditProperty(TQUB_Property_Edit.Create('["ScriptFileName"]',
                    'ScriptFileName', REGTYPE_STRING, '<none>',
                    txtScriptFileName,
                    '',
                    '') );
  }
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Data"]["IdealizedData"]',
                        'Idealized Data', REGTYPE_BOOL, DEF_IDEALIZEDDATA,
                        chkIdealizedData)
                       .Enables(chkIDLOutputState)
                       .Enables(chkIDLOutputClass)
                       .Enables(chkIDLOutputGroup)
                     );
  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["Data"]["IdlOutput"]',
                          'IDL Output', REGTYPE_INT, IdlOutputToString(DEF_IDLOUTPUT))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkIDLOutputState,
                                       IdlOutputToString(OUT_STATE),
                                       Integer(OUT_STATE)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkIDLOutputClass,
                                       IdlOutputToString(OUT_CLASS),
                                       Integer(OUT_CLASS)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkIDLOutputGroup,
                                       IdlOutputToString(OUT_GROUP),
                                       Integer(OUT_GROUP)))
                       );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Data"]["Randomize"]',
                        'Do Randomize', REGTYPE_BOOL, DEF_DORANDOMIZE,
                        chkRandomize));
  AddEditProperty(TQUB_Property_Edit.Create('["Data"]["RandomSeed"]',
                    'Random Seed', REGTYPE_INT, DEF_RANDOMSEED,
                    txtRandomSeed,
                    AcceptInt,
                    '') );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Data"]["ApplyDeadTime"]',
                        'Apply DeadTime', REGTYPE_BOOL, Integer(DEF_APPLYDEADTIME),
                        chkApplyDeadTime));
  AddEditProperty(TQUB_Property_Edit.Create('["Data"]["DeadTime"]',
                    'DeadTime', REGTYPE_FLOAT, DEF_DEADTIME,
                    txtDeadTime,
                    AcceptFloatGreaterThanOrEqualTo(0.0),
                    '') );

  AddEditProperty(TQUB_Property_Edit.Create('["Data"]["TransitionState1"]',
                    'Transition State 1', REGTYPE_INT, 0,
                    txtTransitionState1,
                    AcceptIntGreaterThan(-1),
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["Data"]["TransitionState2"]',
                    'Transition State 2', REGTYPE_INT, 0,
                    txtTransitionState2,
                    AcceptIntGreaterThan(-1),
                    '') );

  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["FilterOn"]',
                        'Filter On', REGTYPE_BOOL, DEF_FILTERON,
                        chkFilterOn));
  AddEditProperty(TQUB_Property_Edit.Create('["FilterFreq"]',
                    'Filter Freq', REGTYPE_FLOAT, DEF_FILTERFREQ,
                    txtFilterFreq,
                    AcceptFloatGreaterThan(0.0),
                    '') );

  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Gating"]',
                          '', REGTYPE_NONE, DEF_GATING,
                          chkGating)
                       .Enables(panGatingUnits)
                       .Enables(chkGatingInvert)
                     );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["GatingInvert"]',
                          '', REGTYPE_NONE, DEF_GATING_INVERT,
                          chkGatingInvert));
  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["GatingUnits"]',
                          '', REGTYPE_NONE, DEF_GATING_UNITS)
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkGatingV,
                                       GATING_V, GATING_V))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkGatingMV,
                                       GATING_MV, GATING_MV))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkGatingOther,
                                       GATING_OTHER, GATING_OTHER))
                       );
  AddEditProperty(TQUB_Property_Edit.Create('["GatingUnitsOther"]',
                    '', REGTYPE_NONE, DEF_GATING_OTHER,
                    txtGatingOther,
                    AcceptFloatGreaterThan(0.0),
                    '') );

  // need to intercept stimulation events to dis/enable segment size and count
  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["Simulation"]["Stimulation"]',
                          'Stimulation', REGTYPE_INT, StimulationToString(DEF_STIMULATION))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkStimulationNone,
                                       StimulationToString(SIM_STIM_NONE),
                                       Integer(SIM_STIM_NONE)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkStimulationFile,
                                       StimulationToString(SIM_STIM_FILE),
                                       Integer(SIM_STIM_FILE)))
                         {   .AddButton(TQUB_Property_RadioButton.Create(
                                       chkStimulationScript,
                                       StimulationToString(SIM_STIM_SCRIPT),
                                       Integer(SIM_STIM_SCRIPT)))  }
                       );
  AddRadioGroupProperty(TQUB_Property_RadioGroup.Create('["Simulation"]["Response"]',
                          'Response', REGTYPE_INT, ResponseToString(DEF_RESPONSE))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkResponseStochastic,
                                       ResponseToString(SIM_RESPONSE_STOCHASTIC),
                                       Integer(SIM_RESPONSE_STOCHASTIC)))
                            .AddButton(TQUB_Property_RadioButton.Create(
                                       chkResponseDeterministic,
                                       ResponseToString(SIM_RESPONSE_Deterministic),
                                       Integer(SIM_RESPONSE_Deterministic)))
                       );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Flux"]',
                        'Flux', REGTYPE_BOOL, DEF_FLUX,
                        chkFlux));
  AddEditProperty(TQUB_Property_Edit.Create('["FluxStates"]',
                    '', REGTYPE_NONE, 0,
                    txtFluxStates,
                    AcceptDimList( AcceptIntList(AcceptIntGreaterThan(-1)),
                                   2, '2 states please (from and to)' ),
                    'lambda node, ix: SpacedNodeData(node)') );

  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Simulation"]["UseCondVoltage"]',
                        'UseCondVoltage', REGTYPE_BOOL, DEF_USECONDVOLTAGE,
                        chkUseCondVoltage)
                       .Enables(txtCondVoltage)
                      );
  AddEditProperty(TQUB_Property_Edit.Create('["Simulation"]["CondVoltage"]',
                    'CondVoltage', REGTYPE_FLOAT, DEF_CONDVOLTAGE,
                    txtCondVoltage,
                    AcceptFloat,
                    '') );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Simulation"]["ILeak"]',
 // these new-style properties do not write the registry.
// REGTYPE_ is only for backward compatibility.
// It reads the registry only if there is no new-style saved setting,
// and only if REGTYPE_* indicates some other function had saved something in the registry.
                        '', REGTYPE_NONE, DEF_ILEAK,
                        chkILeak)
                       .Enables(txtGLeak)
                       .Enables(txtVLeak)
                      );
  AddEditProperty(TQUB_Property_Edit.Create('["Simulation"]["GLeak"]',
                    'GLeak', REGTYPE_FLOAT, DEF_GLEAK,
                    txtGLeak,
                    AcceptFloatBetween(0.0, 1e10),
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["Simulation"]["VLeak"]',
                    'VLeak', REGTYPE_FLOAT, DEF_VLEAK,
                    txtVLeak,
                    AcceptFloatBetween(-1e6, 1e6),
                    '') );

  //Staircase
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Simulation"]["Staircase"]',
                        'Staircase', REGTYPE_BOOL, DEF_STAIRCASE,
                        chkStaircase)
                       .Enables(chkStaircaseStepsFromParam)
                       .Enables(txtStaircaseSteps)
                       .Enables(lblStaircaseStepStd)
                       .Enables(txtStaircaseStepStd)
                       .Enables(chkStaircaseNoJumpClass)
                      );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Simulation"]["StaircaseUseSteps"]',
                        'StepsFromParam', REGTYPE_BOOL, DEF_STAIRCASEUSESTEPS,
                        chkStaircaseStepsFromParam)
                       .Enables(txtStaircaseSteps)
                      );
  AddEditProperty(TQUB_Property_Edit.Create('["Simulation"]["StaircaseSteps"]',
                    'Steps', REGTYPE_STRING, DEF_STAIRCASESTEPS,
                    txtStaircaseSteps,
                    AcceptString,
                    ''));
  AddEditProperty(TQUB_Property_Edit.Create('["Simulation"]["StaircaseStepStd"]',
                    'StepStd', REGTYPE_STRINGFLOAT, DEF_STAIRCASESTEPSTD,
                    txtStaircaseStepStd,
                    AcceptFloatBetween(0.0, 1000),
                    ''));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Simulation"]["StaircaseNoJumpClass"]',
                        'NoJumpClass', REGTYPE_BOOL, DEF_STAIRCASENOJUMPCLASS,
                        chkStaircaseNoJumpClass)
                      );

  //Baseline
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Baseline"]["Fluctuations"]',
                        'Baseline Fluctuations', REGTYPE_BOOL, DEF_BASELINEFLUCT,
                        chkBaselineFluct)
                       .Enables(txtBaselineFluctLifetime)
                       .Enables(txtBaselineFluctMaxAmp)
                       .Enables(txtBaselineFluctN)
                      );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["Fluctuations"]["Lifetime"]',
                    'Baseline Fluctuations Lifetime', REGTYPE_STRINGFLOAT, DEF_BASELINEFLUCT_LIFETIME,
                    txtBaselineFluctLifetime,
                    AcceptFloatGreaterThan(0.0),
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["Fluctuations"]["MaxAmp"]',
                    'Baseline Fluctuations Max Amp', REGTYPE_STRINGFLOAT, DEF_BASELINEFLUCT_MAXAMP,
                    txtBaselineFluctMaxAmp,
                    AcceptFloatGreaterThan(0.0),
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["Fluctuations"]["N"]',
                    'Baseline Fluctuations N', REGTYPE_INT, DEF_BASELINEFLUCT_N,
                    txtBaselineFluctN,
                    AcceptIntGreaterThan(0),
                    '') );

  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Baseline"]["Periodic"]',
                        'Baseline Periodic', REGTYPE_BOOL, DEF_BASELINEPERIODIC,
                        chkBaselinePeriodic)
                       .Enables(txtBaselinePeriodicAmp)
                       .Enables(txtBaselinePeriodicFreq)
                       .Enables(txtBaselinePeriodicPhase)
                      );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["Periodic"]["Amp"]',
                    'Baseline Periodic Amp', REGTYPE_STRINGFLOAT, DEF_BASELINEPERIODIC_AMP,
                    txtBaselinePeriodicAmp,
                    AcceptFloatGreaterThan(0.0),
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["Periodic"]["Freq"]',
                    'Baseline Periodic Freq', REGTYPE_STRINGFLOAT, DEF_BASELINEPERIODIC_FREQ,
                    txtBaselinePeriodicFreq,
                    AcceptFloatGreaterThan(0.0),
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["Periodic"]["Phase"]',
                    'Baseline Periodic Phase', REGTYPE_STRINGFLOAT, DEF_BASELINEPERIODIC_PHASE,
                    txtBaselinePeriodicPhase,
                    AcceptFloatBetween(0.0, 360.0),
                    '') );

  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Baseline"]["LinearGaussian"]',
                        'Baseline LGM', REGTYPE_BOOL, DEF_BASELINE_LGM,
                        chkBaselineLGM)
                       .Enables(txtBAselineLGMProcStd)
                       .Enables(txtBaselineLGMx0)
                       .Enables(txtBaselineLGMx0p)
                       .Enables(chkBaselineLGM2State)
                      );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["LinearGaussian"]["ProcessStd"]',
                    'Baseline LGM Proc Std', REGTYPE_STRINGFLOAT, DEF_BASELINE_LGM_PROCSTD,
                    txtBaselineLGMProcStd,
                    AcceptFloatGreaterThan(0.0),
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["LinearGaussian"]["X0"]',
                    'Baseline LGM Proc x0', REGTYPE_STRINGFLOAT, DEF_BASELINE_LGM_X0,
                    txtBaselineLGMx0,
                    AcceptFloatGreaterThan(0.0),
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["LinearGaussian"]["X0p"]',
                    'Baseline LGM Proc x0p', REGTYPE_STRINGFLOAT, DEF_BASELINE_LGM_X0P,
                    txtBaselineLGMx0p,
                    AcceptFloatGreaterThan(0.0),
                    '') );
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Baseline"]["LinearGaussian"]["2 state model"]',
                        'Baseline LGM 2State', REGTYPE_BOOL, DEF_BASELINE_LGM_2STATE,
                        chkBaselineLGM2State));

  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Baseline"]["Jumps"]',
                        'Baseline Jumps', REGTYPE_BOOL, DEF_BASELINEJUMPS,
                        chkBaselineJumps)
                       .Enables(txtBaselineJumpsAmpAvg)
                       .Enables(txtBaselineJumpsAmpStd)
                       .Enables(txtBaselineJumpsLifetime)
                       .Enables(txtBaselineJumpsFastW)
                       .Enables(txtBaselineJumpsFast)
                       .Enables(txtBaselineJumpsSlow)
                      );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["Jumps"]["AmpAvg"]',
                    'Baseline Jumps Amp Avg', REGTYPE_STRINGFLOAT, DEF_BASELINEJUMPS_AMPAVG,
                    txtBaselineJumpsAmpAvg,
                    AcceptFloatGreaterThan(0.0),
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["Jumps"]["AmpStd"]',
                    'Baseline Jumps Amp Std', REGTYPE_STRINGFLOAT, DEF_BASELINEJUMPS_AMPSTD,
                    txtBaselineJumpsAmpStd,
                    AcceptFloatGreaterThan(0.0),
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["Jumps"]["Lifetime"]',
                    'Baseline Jumps Lifetime', REGTYPE_STRINGFLOAT, DEF_BASELINEJUMPS_LIFETIME,
                    txtBaselineJumpsLifetime,
                    AcceptFloatGreaterThan(0.0),
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["Jumps"]["Fast w"]',
                    'Baseline Jumps Fast W', REGTYPE_STRINGFLOAT, DEF_BASELINEJUMPS_FASTW,
                    txtBaselineJumpsFastW,
                    AcceptFloatBetween(0.0, 1.0),
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["Jumps"]["Fast rec"]',
                    'Baseline Jumps Fast', REGTYPE_STRINGFLOAT, DEF_BASELINEJUMPS_FAST,
                    txtBaselineJumpsFast,
                    AcceptFloatBetween(MIN_BASELINEJUMPS_FAST, MAX_BASELINEJUMPS_FAST), //GreaterThan(0.0),
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["Jumps"]["Slow rec"]',
                    'Baseline Jumps Slow', REGTYPE_STRINGFLOAT, DEF_BASELINEJUMPS_SLOW,
                    txtBaselineJumpsSlow,
                    AcceptFloatBetween(MIN_BASELINEJUMPS_SLOW, MAX_BASELINEJUMPS_SLOW), //GreaterThan(0.0),
                    '') );

  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["Baseline"]["LinearDrift"]',
                        'Baseline Drift', REGTYPE_BOOL, DEF_BASELINEDRIFT,
                        chkBaselineDrift)
                       .Enables(txtBaselineDriftSlope)
                       .Enables(txtBaselineDriftIntercept)
                      );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["LinearDrift"]["Slope"]',
                    'Baseline Drift Slope', REGTYPE_STRINGFLOAT, DEF_BASELINEDRIFT_SLOPE,
                    txtBaselineDriftSlope,
                    AcceptFloat,
                    '') );
  AddEditProperty(TQUB_Property_Edit.Create('["Baseline"]["LinearDrift"]["Intercept"]',
                    'Baseline Drift Intercept', REGTYPE_STRINGFLOAT, DEF_BASELINEDRIFT_INTERCEPT,
                    txtBaselineDriftIntercept,
                    AcceptFloat,
                    '') );

  //Make Movie
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["MakeMovie"]',
                        'MakeMovie', REGTYPE_BOOL, DEF_MAKEMOVIE,
                        chkMakeMovie)
                      );
  //FrameDuration
  AddEditProperty(TQUB_Property_Edit.Create('["MakeMovie"]["FrameDuration"]',
                    'FrameDuration', REGTYPE_STRINGFLOAT, DEF_MAKEMOVIEFRAMEDURATION,
                    txtMakeMovieFrameDuration,
                    AcceptFloatGreaterThan(0.0),
                    '') );
  //Save Movie Files
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["MakeMovie"]["SaveFrames"]',
                        'SaveFrames', REGTYPE_BOOL, DEF_SAVEMOVIEFILES,
                        chkSaveMovieFiles)
                      );


  RegKeyName            := 'Software\QUB\Task Simulate data';
  ProfileCat            := 'Sim';
  prBeforeGetProperties := PropertiesToParams;

  if Properties['FluxStates'].DataCount <> 2 then begin
    if Properties['FluxStates'].DataCount = 0 then begin
      Properties['FluxStates'].SetData(0);
    end;
    Properties['FluxStates'].ResizeData(2);
    Properties['FluxStates'].Data[1] := 1;
  end;

  // need to intercept stimulation events to dis/enable segment size and count
  chkStimulationNone.OnClick   := chkStimulationClick;
  chkStimulationFile.OnClick   := chkStimulationClick;
  //chkStimulationScript.OnClick := chkStimulationClick;

  {$include 'QUB_Task_Simulate_Properties.htx'}

  PythonThread.BeginPython;
  PyNode_PublishNodeFunc( TNodeMeth.Create(prToggleFluxVisible), 'ToggleFluxVisible' );
  PythonThread.EndPython;

  txtStructuresFile.Text          := Properties['StructuresFile'].DataAsString;
  prLoadStructuresFile;
  (*
  txtScriptFileName.Text          := Properties['ScriptFileName'].DataAsString;
  if (txtScriptFileName.Text <> '<none>') and (txtScriptFileName.Text <> '') then begin
    //Load script
    prSource.Open(txtScriptFileName.Text, True{Silent});
  end;
  *)
end;

procedure TQUB_Task_Simulate_PropertiesForm.FormDestroy(Sender: TObject);
var
  Files :TStringList;
begin

  try

    Files := nil;
    try
      Files := TStringList.Create;
      try
        Files.Assign(grdStructures.Cols[1]);
        Files.SaveToFile(ExtractFilePath(Application.ExeName) + 'SimulationStructureFiles.txt');
      except
      end;
    finally
      Files.Free;
    end;

    //prSource.OnChangeFile := nil;

  finally

    inherited;

  end;

end;

procedure TQUB_Task_Simulate_PropertiesForm.FormShow(Sender: TObject);
var
  i :Integer;
begin
  inherited;

  if prStimData <> nil then begin
    i := lstStimData.Items.IndexOfObject(prStimData);
  end else if prStimProto <> nil then begin
    i := lstStimData.Items.IndexOfObject(prStimProto);
  end else begin
    i := -1;
  end;

  if i = -1 then begin
    prStimData := nil;
  end;
  lstStimData.ItemIndex  := i;

  //prSource.CanCompile    := True;

  grdExpCond.ExpCond     := ViewportModel.DefExpCond;

  chkUseCondVoltage.Checked  := ViewportModel.CurrModel.IeqFv;
  Properties['Simulation']['UseCondVoltage'].Data[0] := Integer(chkUseCondVoltage.Checked);

end;

procedure TQUB_Task_Simulate_PropertiesForm.FormHide(Sender: TObject);
begin
  inherited;

  //prSource.CanCompile    := False;

  grdExpCond.ExpCond     := nil;

  PropertiesToParams;

end;


//******************************************************************************
procedure TQUB_Task_Simulate_PropertiesForm.prLoadStructuresFile;
var
  Files   :TStringList;
  SFile   :String;
  i       :Integer;
begin
  Files := nil;
  try
    Files := TStringList.Create;
    try
      //SFile := ExtractFilePath(Application.ExeName) + 'SimulationStructureFiles.txt';
      SFile := txtStructuresFile.Text;
      if FileExists(SFile) then begin
        Files.LoadFromFile(SFile);
        if Files.Strings[0] <> 'Structure file' then Files.Insert(0, 'Structure file');
        if (grdStructures.RowCount - 1) < Files.Count then begin
          grdStructures.RowCount := Files.Count  + 1;
        end;
        grdStructures.Cols[1] := Files;
      end;
    except
    end;
  finally
    Files.Free;
  end;
  for i := 1 to grdStructures.RowCount - 1 do begin
    grdStructures.Cells[0, i] := IntToStr(i);
  end;
end;

procedure TQUB_Task_Simulate_PropertiesForm.prSetInitialProperties(Props :INode);
var
  Reg   :TRegistry;
  Prop  :INode;
  //bVal  :Boolean;
  iVal  :Integer;
begin
  inherited;

  Reg   := nil; // will be created as needed by ReadXRegistry*
  try
    Prop  := Props['FluxVisible'];
    if Prop.DataCount = 0 then Prop.SetData(0);
    
    Prop  := Props['Data']['SegmentCount'];
    if Prop.DataCount = 0 then begin
      if ReadXRegistryInteger(Reg, RegKeyName, 'Segment Count', iVal) then begin
        Prop.SetData(iVal);
      end else begin
        Prop.SetData(DEF_SEGMENT_COUNT);
      end;
    end;
    Prop  := Props['Data']['SegmentSize'];
    if Prop.DataCount = 0 then begin
      if ReadXRegistryInteger(Reg, RegKeyName, 'Segment Size', iVal) then begin
        Prop.SetData(iVal);
      end else begin
        Prop.SetData(DEF_SEGMENT_SIZE);
      end;
    end;

    Props['Simulation']['Response'].SetData(ResponseToString(Response));

    Props['Data']['DataMode'].SetData( DataModeString );
    (* maybe moved to main?
    Prop := Props['KineticScript'];
    sVal := Prop.DataAsString;
    if Prop.DataCount = 0 then begin
      ReadXRegistryString(Reg, RegKeyName, 'Kinetic Script', sVal);
    end;
    if sVal <> '' then prSource.Open(sVal, True{Silent});
    *)

  finally
    if Reg <> nil then begin
      Reg.CloseKey;
      Reg.Free;
    end;
  end;
end;

procedure TQUB_Task_Simulate_PropertiesForm.prUpdateComponents;
var
  vis             :Boolean;
begin
  inherited;

  Stimulation     := StringToStimulation( Properties['Simulation']['Stimulation'].DataAsString );
  Response        := StringToResponse(Properties['Simulation']['Response'].DataAsString);
  SegmentCount    := Properties['Data']['SegmentCount'].Data[0];
  SegmentSize     := Properties['Data']['SegmentSize'].Data[0];
  DataModeString  := Properties['Data']['DataMode'].DataAsString;

  vis := Properties['FluxVisible'].Data[0] <> 0;
  chkFlux.Visible        := vis;
  txtFluxStates.Visible  := vis;
end;

procedure TQUB_Task_Simulate_PropertiesForm.PropertiesToParams;
begin
  prPropertiesRec.UseCondVoltage           := 0<>Properties['Simulation']['UseCondVoltage'].Data[0];
  prPropertiesRec.CondVoltage              := Properties['Simulation']['CondVoltage'].Data[0];
  prPropertiesRec.ILeak                    := 0<>Properties['Simulation']['ILeak'].Data[0];
  prPropertiesRec.GLeak                    := Properties['Simulation']['GLeak'].Data[0];
  prPropertiesRec.VLeak                    := Properties['Simulation']['VLeak'].Data[0];

  prPropertiesRec.IdealizedData            := 0<>Properties['Data']['IdealizedData'].Data[0];
  prPropertiesRec.IDLOutput                := Integer(StringToIdlOutput(Properties['Data']['IdlOutput'].DataAsString));

  prPropertiesRec.Randomize                := 0<>Properties['Data']['Randomize'].Data[0];
  prPropertiesRec.RandomSeed               := Properties['Data']['RandomSeed'].Data[0];

  prPropertiesRec.ApplyDeadTime            := 0<>Properties['Data']['ApplyDeadTime'].Data[0];
  prPropertiesRec.DeadTime                 := Properties['Data']['DeadTime'].Data[0];

  prPropertiesRec.FilterOn                 := 0<>Properties['FilterOn'].Data[0];
  prPropertiesRec.FilterFreq               := Properties['FilterFreq'].Data[0];

  prPropertiesRec.TransitionStates[1]      := Properties['Data']['TransitionState1'].Data[0];
  prPropertiesRec.TransitionStates[2]      := Properties['Data']['TransitionState2'].Data[0];

  prPropertiesRec.Flux                     := 0<>Properties['Flux'].Data[0];
  if Properties['FluxStates'].DataCount = 2 then begin
    prPropertiesRec.FluxFrom               := Properties['FluxStates'].Data[0];
    prPropertiesRec.FluxTo                 := Properties['FluxStates'].Data[1];
  end;

  prPropertiesRec.Staircase                := 0<>Properties['Simulation']['Staircase'].Data[0];
  prPropertiesRec.StaircaseUseSteps        := 0<>Properties['Simulation']['StaircaseUseSteps'].Data[0];
  prPropertiesRec.StaircaseSteps           := Properties['Simulation']['StaircaseSteps'].DataAsString;
  prPropertiesRec.StaircaseStepStd         := Properties['Simulation']['StaircaseStepStd'].Data[0];
  prPropertiesRec.StaircaseNoJumpClass     := 0<>Properties['Simulation']['StaircaseNoJumpClass'].Data[0];

  prPropertiesRec.BaselineFluct            := 0<>Properties['Baseline']['Fluctuations'].Data[0];
  prPropertiesRec.BaselineFluctLifetime    := Properties['Baseline']['Fluctuations']['Lifetime'].Data[0];
  prPropertiesRec.BaselineFluctMaxAmp      := Properties['Baseline']['Fluctuations']['MaxAmp'].Data[0];
  prPropertiesRec.BaselineFluctN           := Properties['Baseline']['Fluctuations']['N'].Data[0];
  prPropertiesRec.BaselineDrift            := 0<>Properties['Baseline']['LinearDrift'].Data[0];
  prPropertiesRec.BaselineDriftSlope       := Properties['Baseline']['LinearDrift']['Slope'].Data[0];
  prPropertiesRec.BaselineDriftIntercept   := Properties['Baseline']['LinearDrift']['Intercept'].Data[0];
  prPropertiesRec.BaselineJumps            := 0<>Properties['Baseline']['Jumps'].Data[0];
  prPropertiesRec.BaselineJumpsAmpAvg      := Properties['Baseline']['Jumps']['AmpAvg'].Data[0];
  prPropertiesRec.BaselineJumpsAmpStd      := Properties['Baseline']['Jumps']['AmpStd'].Data[0];
  prPropertiesRec.BaselineJumpsLifetime    := Properties['Baseline']['Jumps']['Lifetime'].Data[0];
  prPropertiesRec.BaselineJumpsFastW       := Properties['Baseline']['Jumps']['Fast w'].Data[0];
  prPropertiesRec.BaselineJumpsFast        := Properties['Baseline']['Jumps']['Fast rec'].Data[0];
  prPropertiesRec.BaselineJumpsSlow        := Properties['Baseline']['Jumps']['Slow rec'].Data[0];
  prPropertiesRec.BaselinePeriodic         := 0<>Properties['Baseline']['Periodic'].Data[0];
  prPropertiesRec.BaselinePeriodicAmp      := Properties['Baseline']['Periodic']['Amp'].Data[0];
  prPropertiesRec.BaselinePeriodicFreq     := Properties['Baseline']['Periodic']['Freq'].Data[0];
  prPropertiesRec.BaselinePeriodicPhase    := Properties['Baseline']['Periodic']['Phase'].Data[0];
  prPropertiesRec.BaselineLGM              := 0<>Properties['Baseline']['LinearGaussian'].Data[0];
  prPropertiesRec.BaselineLGMProcStd       := Properties['Baseline']['LinearGaussian']['ProcessStd'].Data[0];
  prPropertiesRec.BaselineLGMX0            := Properties['Baseline']['LinearGaussian']['X0'].Data[0];
  prPropertiesRec.BaselineLGMX0p           := Properties['Baseline']['LinearGaussian']['X0p'].Data[0];
  prPropertiesRec.BaselineLGM2State        := Properties['Baseline']['LinearGaussian']['2 state model'].Data[0];

  prPropertiesRec.MakeMovie                := Properties['MakeMovie'].Data[0];
  prPropertiesRec.MakeMovieFrameDuration   := Properties['MakeMovie']['FrameDuration'].Data[0];
  prPropertiesRec.MakeMovieSaveFrames      := Properties['MakeMovie']['SaveFrames'].Data[0];
                                                                        
end;


//******************************************************************************
function TQUB_Task_Simulate_PropertiesForm.prToggleFluxVisible(x :INode): INode;
var
  vis          :Boolean;
begin
  Result       := x;
  vis := Properties['FluxVisible'].Data[0] = 0;
  Properties['FluxVisible'].Data[0]  := Integer(vis);

  SyncGUIProc(prUpdateComponents);
end;

procedure TQUB_Task_Simulate_PropertiesForm.btnOKClick(Sender: TObject);
begin
  inherited;

  //If Stimulation = SCRIPT, it requires the source to compile OK
  {
  if (Stimulation = SIM_STIM_SCRIPT) and (not prSource.Compiled) then begin
    Screen.Cursor := crHourGlass;
    try
      if prSource.Compile then begin
        ModalResult := mrNone;
      end;
    finally
      Screen.Cursor := crDefault;
    end;
  end;
  }
  //If Stimulation=File, a file must be selected 8-2004 JB
  if (Sender <> nil) and (Stimulation=SIM_STIM_FILE) and
      ((lstStimData.Items.Count=0) or (lstStimData.ItemIndex<0)) Then begin
      MessageDlg('File Stimulation is set with no file selected.', mtError, [mbOK], 0);
      ModalResult := mrNone;
  end;

end;

//******************************************************************************
procedure TQUB_Task_Simulate_PropertiesForm.chkDataModeClick(Sender: TObject);
begin
  inherited;
  DataMode := TRadioButton(Sender).Tag;
end;

procedure TQUB_Task_Simulate_PropertiesForm.lstModelsClick(Sender: TObject);
begin
  inherited;
  if (lstModels.ItemIndex >= 0) and (lstModels.Items.Count > 0) then begin
    Model := TQUB_QVO_QVM(lstModels.Items.Objects[lstModels.ItemIndex]);
  end;
  prInitExpCond;
end;

//Stimulation
procedure TQUB_Task_Simulate_PropertiesForm.chkStimulationClick(Sender: TObject);
begin
  inherited;
  Stimulation := TQUB_Task_Simulate_Stimulation(TControl(Sender).Tag);
  prInitExpCond;
end;

procedure TQUB_Task_Simulate_PropertiesForm.chkResponseStochasticClick(Sender: TObject);
begin
  inherited;
  Response := TQUB_Task_Simulate_Response(TControl(Sender).Tag);
end;

procedure TQUB_Task_Simulate_PropertiesForm.chkFluxClick(Sender: TObject);
begin
  txtFluxStates.Enabled    := (Response = SIM_RESPONSE_DETERMINISTIC) and (0<>Properties['Flux'].Data[0]);
end;

procedure TQUB_Task_Simulate_PropertiesForm.lstStimDataClick(Sender: TObject);
begin
  inherited;
  prStimData  := nil;
  prStimProto := nil;
  if lstStimData.ItemIndex >= 0 then begin
    if lstStimData.ItemIndex < ProtoCount then begin
      prStimProto := TQUB_QVO_QVP(lstStimData.Items.Objects[lstStimData.ItemIndex]);
    end else begin
      prStimData := TQUB_QVO_QVD(lstStimData.Items.Objects[lstStimData.ItemIndex]);
    end;
  end;
  prInitExpCond;
end;

//Segment Count
procedure TQUB_Task_Simulate_PropertiesForm.txtSegmentCountKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtSegmentCountExit(Sender);
  end;
end;

procedure TQUB_Task_Simulate_PropertiesForm.txtSegmentCountExit(Sender: TObject);
var
  c :Integer;
begin
  inherited;
  try
    c := StrToInt(TEdit(Sender).Text);
    if ((c < MIN_SEGMENT_COUNT) or (c > MAX_SEGMENT_COUNT)) then raise Exception.Create('');
  except
    MessageDlg('Invalid value; must be between ' + IntToStr(MIN_SEGMENT_COUNT) + ' and ' + IntToStr(MAX_SEGMENT_COUNT), mtError, [mbOK], 0);
    TEdit(Sender).Text := IntToStr(SegmentCount);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if c <> SegmentCount then begin
    SegmentCount := c;
  end;
end;

procedure TQUB_Task_Simulate_PropertiesForm.udSegmentCountClick(Sender: TObject; Button: TUDBtnType);
var
  Cnt :Integer;
begin
  inherited;
  Cnt := SegmentCount;
  if Button = btPrev then begin
    if      Cnt >= 20000000 then Dec(Cnt, 10000000)
    else if Cnt >= 2000000  then Dec(Cnt, 1000000)
    else if Cnt >= 200000   then Dec(Cnt, 100000)
    else if Cnt >= 20000    then Dec(Cnt, 10000)
    else if Cnt >= 2000     then Dec(Cnt, 1000)
    else if Cnt >= 200      then Dec(Cnt, 100)
    else if Cnt >= 20       then Dec(Cnt, 10)
    else                         Dec(Cnt, 1);
    if Cnt < MIN_SEGMENT_COUNT then Cnt := MIN_SEGMENT_COUNT;
  end else begin
    if      Cnt >= 10000000 then Inc(Cnt, 10000000)
    else if Cnt >= 1000000  then Inc(Cnt, 1000000)
    else if Cnt >= 100000   then Inc(Cnt, 100000)
    else if Cnt >= 10000    then Inc(Cnt, 10000)
    else if Cnt >= 1000     then Inc(Cnt, 1000)
    else if Cnt >= 100      then Inc(Cnt, 100)
    else if Cnt >= 10       then Inc(Cnt, 10)
    else                         Inc(Cnt, 1);
    if Cnt > MAX_SEGMENT_COUNT then Cnt := MAX_SEGMENT_COUNT;
  end;
  if Cnt <> SegmentCount then begin
    SegmentCount := Cnt;
  end;
end;

procedure TQUB_Task_Simulate_PropertiesForm.udSegmentCountChanging(Sender: TObject; var AllowChange: Boolean);
begin
  inherited;
  if prSegmentCountChanging then Exit;
  prSegmentCountChanging := True;
  try
    udSegmentCount.Position := 2;
  finally
    prSegmentCountChanging := False;
  end;
end;


//Segment Size
procedure TQUB_Task_Simulate_PropertiesForm.txtSegmentSizeKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtSegmentSizeExit(Sender);
  end;
end;

procedure TQUB_Task_Simulate_PropertiesForm.txtSegmentSizeExit(Sender: TObject);
var
  s :Integer;
begin
  inherited;
  try
    s := StrToInt(TEdit(Sender).Text);
    if ((s < MIN_SEGMENT_SIZE) or (s > MAX_SEGMENT_SIZE)) then raise Exception.Create('');
  except
    MessageDlg('Invalid value; must be between ' + IntToStr(MIN_SEGMENT_SIZE) + ' and ' + IntToStr(MAX_SEGMENT_SIZE), mtError, [mbOK], 0);
    TEdit(Sender).Text := IntToStr(SegmentSize);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if s <> SegmentSize then begin
    SegmentSize := s;
  end;
end;

procedure TQUB_Task_Simulate_PropertiesForm.udSegmentSizeClick(Sender: TObject; Button: TUDBtnType);
var
  Pts :Integer;
begin
  inherited;
  Pts := SegmentSize;
  if Button = btPrev then begin
    if      Pts >= 20000000 then Dec(Pts, 10000000)
    else if Pts >= 2000000  then Dec(Pts, 1000000)
    else if Pts >= 200000   then Dec(Pts, 100000)
    else if Pts >= 20000    then Dec(Pts, 10000)
    else if Pts >= 2000     then Dec(Pts, 1000)
    else if Pts >= 200      then Dec(Pts, 100)
    else                         Dec(Pts, 10);
    if Pts < MIN_SEGMENT_SIZE then Pts := MIN_SEGMENT_SIZE;
  end else begin
    if      Pts >= 10000000 then Inc(Pts, 10000000)
    else if Pts >= 1000000  then Inc(Pts, 1000000)
    else if Pts >= 100000   then Inc(Pts, 100000)
    else if Pts >= 10000    then Inc(Pts, 10000)
    else if Pts >= 1000     then Inc(Pts, 1000)
    else if Pts >= 100      then Inc(Pts, 100)
    else                         Inc(Pts, 10);
    if Pts > MAX_SEGMENT_SIZE then Pts := MAX_SEGMENT_SIZE;
  end;
  if Pts <> SegmentSize then begin
    SegmentSize := Pts;
  end;
end;

procedure TQUB_Task_Simulate_PropertiesForm.udSegmentSizeChanging(Sender: TObject; var AllowChange: Boolean);
begin
  inherited;
  if prSegmentSizeChanging then Exit;
  prSegmentSizeChanging := True;
  try
    udSegmentSize.Position := 2;
  finally
    prSegmentSizeChanging := False;
  end;
end;

//Model Channel Count
procedure TQUB_Task_Simulate_PropertiesForm.txtModelChannelCountKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
  if Key = #13 then begin
    Key := #0;
    txtModelChannelCountExit(Sender);
  end;
end;

procedure TQUB_Task_Simulate_PropertiesForm.txtModelChannelCountExit(Sender: TObject);
var
  c :Integer;
begin
  inherited;
  try
    c := StrToInt(TEdit(Sender).Text);
    if ((c < QUB_QFS_QMF_MIN_CHANNEL_COUNT) {or (c > QUB_QFS_QMF_MAX_CHANNEL_COUNT)}) then raise Exception.Create('');
  except
    MessageDlg('Invalid value; must be between ' + IntToStr(QUB_QFS_QMF_MIN_CHANNEL_COUNT) + ' and ' + IntToStr(QUB_QFS_QMF_MAX_CHANNEL_COUNT), mtError, [mbOK], 0);
    TEdit(Sender).Text := IntToStr(ModelChannelCount);
    TEdit(Sender).SetFocus;
    Exit;
  end;
  if c <> ModelChannelCount then begin
    ModelChannelCount := c;
  end;
end;

procedure TQUB_Task_Simulate_PropertiesForm.udModelChannelCountClick(Sender: TObject; Button: TUDBtnType);
var
  Cnt :Integer;
begin
  inherited;
  Cnt := ModelChannelCount;
  if Button = btPrev then begin
    //Cnt := Max(QUB_QFS_QMF_MIN_CHANNEL_COUNT, Cnt - Round(IntPower(10, Max(0, Round(log10(Cnt/2))))));
    // Consider - which is more efficient  - above line or next 9 ?
    //The above line doesn't work. Anyway, the 9 lines below are implemented more efficiently by the compiler. LM
    if      Cnt >= 20000000 then Dec(Cnt, 10000000)
    else if Cnt >= 2000000  then Dec(Cnt, 1000000)
    else if Cnt >= 200000   then Dec(Cnt, 100000)
    else if Cnt >= 20000    then Dec(Cnt, 10000)
    else if Cnt >= 2000     then Dec(Cnt, 1000)
    else if Cnt >= 200      then Dec(Cnt, 100)
    else if Cnt >= 20       then Dec(Cnt, 10)
    else                         Dec(Cnt, 1);
    if Cnt < QUB_QFS_QMF_MIN_CHANNEL_COUNT then Cnt := QUB_QFS_QMF_MIN_CHANNEL_COUNT;
  end else begin
    if      Cnt >= 10000000 then Inc(Cnt, 10000000)
    else if Cnt >= 1000000  then Inc(Cnt, 1000000)
    else if Cnt >= 100000   then Inc(Cnt, 100000)
    else if Cnt >= 10000    then Inc(Cnt, 10000)
    else if Cnt >= 1000     then Inc(Cnt, 1000)
    else if Cnt >= 100      then Inc(Cnt, 100)
    else if Cnt >= 10       then Inc(Cnt, 10)
    else                         Inc(Cnt, 1);
    //if Cnt > QUB_QFS_QMF_MAX_CHANNEL_COUNT then Cnt := QUB_QFS_QMF_MAX_CHANNEL_COUNT;
  end;
  if Cnt <> ModelChannelCount then begin
    ModelChannelCount := Cnt;
  end;
end;

procedure TQUB_Task_Simulate_PropertiesForm.udModelChannelCountChanging(Sender: TObject; var AllowChange: Boolean);
begin
  inherited;
  if prModelChannelCountChanging then Exit;
  prModelChannelCountChanging := True;
  try
    udModelChannelCount.Position := 2;
  finally
    prModelChannelCountChanging := False;
  end;
end;


//******************************************************************************
{
procedure TQUB_Task_Simulate_PropertiesForm.prOnChangeSource(Sender :TObject);
begin
  with Sender as TKPL_Program do begin
    txtScriptFileName.Text := FileName;
    Properties['ScriptFileName'].SetData(FileName);
  end;
end;
}

procedure TQUB_Task_Simulate_PropertiesForm.btnBrowseFileNameClick(Sender: TObject);
begin
  inherited;
  prLoadStructuresFile;
end;


//******************************************************************************
end.
