unit QUB_Task_Stat_Properties;

{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}

interface


uses


Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, ComCtrls, Registry,

RegistryInterface,

QUB_QFS_Channels,
QUB_Task,
QUB_Task_Data,
QUB_Properties,
QUB_Task_Properties,
QUB_Task_Data_Properties,
QUB_Node,
QUB_DataList;


const


DEF_HISTBINCOUNT              = 50;
MIN_HISTBINCOUNT              = 2;
MAX_HISTBINCOUNT              = 500;
DEF_APPLYDEADTIME             = 1;


type


TQUB_Task_Stat_PropertiesForm = class(TQUB_Task_Data_PropertiesForm)
  panMethod                       :TPanel;
  Label7                          :TLabel;
  txtHistBinCount                 :TEdit;
  Label4                          :TLabel;
  udHistBinCount                  :TUpDown;
    chkApplyDeadTime: TCheckBox;


  procedure FormCreate(Sender: TObject);
  procedure FormShow(Sender: TObject);
  procedure FormHide(Sender: TObject);


protected


  prDataList                      :TQUB_DataList;


public



end;


implementation


uses


QUB_GUIInterface;


{$R *.DFM}


//******************************************************************************
procedure TQUB_Task_Stat_PropertiesForm.FormCreate(Sender: TObject);
begin
  inherited;

  prDataList            := TQUB_DataList.Create(Self);
  prDataList.Parent     := Self;
  prDataList.Left       := 20;
  prDataList.Top        := 50;
  prDataList.Width      := 540;
  prDataList.Height     := 100;
  prDataList.FileListAvail := True;

  AddUpDownProperty(TQUB_Property_UpDown.Create('["Histograms"]["BinCount"]',
                      'Hist Bin Count', REGTYPE_INT, DEF_HISTBINCOUNT,
                      udHistBinCount,
                      txtHistBinCount,
                      AcceptIntBetween(MIN_HISTBINCOUNT, MAX_HISTBINCOUNT)));
  AddCheckBoxProperty(TQUB_Property_CheckBox.Create('["ApplyDeadTime"]',
                        '', REGTYPE_NONE, DEF_APPLYDEADTIME,
                        chkApplyDeadTime)
                      );

  RegKeyName            := 'Software\QUB\Task Stat';
  ProfileCat            := 'Stat';

  WikiTopic             := 'Modeling:Stat#Properties';

end;

procedure TQUB_Task_Stat_PropertiesForm.FormShow(Sender: TObject);
begin
  inherited;

  prDataList.ShowFiles;
end;

procedure TQUB_Task_Stat_PropertiesForm.FormHide(Sender: TObject);
begin
  inherited;

  prDataList.HideAll;
end;


//******************************************************************************
end.
