unit QUB_TrackBar;

{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}

interface


uses


Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Commctrl, ComCtrls;


type


TQUB_TrackBar = class(TTrackBar)
protected


  prOnMouseDown :TMouseEvent;
  prOnMouseUp   :TMouseEvent;


  procedure CreateParams(var Params: TCreateParams); override;
  procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;


published


  property OnMouseDown :TMouseEvent read prOnMouseDown write prOnMouseDown;
  property OnMouseUp   :TMouseEvent read prOnMouseUp   write prOnMouseUp;


end;


procedure Register;


//******************************************************************************
implementation


//******************************************************************************
procedure TQUB_TrackBar.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style  and (not TBS_FIXEDLENGTH);
end;

procedure TQUB_TrackBar.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Assigned(prOnMouseDown) then prOnMouseDown(Self, Button, Shift, X, Y);
end;

procedure TQUB_TrackBar.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Assigned(prOnMouseUp) then begin
    prOnMouseUp(Self, Button, Shift, X, Y);
  end;
end;


//******************************************************************************
procedure Register;
begin
  RegisterComponents('QUB', [TQUB_TrackBar]);
end;


//******************************************************************************
end.
