{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
// aka Data Notes
// edits ViewportData.CurrData.DataObject.Session['Comment']
// TODO - I don't see any way the popup menu is opened.  This would make the
//      the menu controls and clearitem and copyitem methods below unnecc.
// check further....

unit QUB_Viewport_DataComment;


interface


uses


Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, ComCtrls, Menus, Registry,

QUB_Viewport,

QUB_QVO_QVD;


type


TQUB_Viewport_DataComment = class(TQUB_Viewport)

  PopupMenu          :TPopupMenu;
    PropertiesItem   :TMenuItem;
    CopyItem: TMenuItem;
    N1: TMenuItem;
    ClearItem: TMenuItem;
    txtComment: TMemo;


  procedure CopyItemClick(Sender: TObject);
  procedure ClearItemClick(Sender: TObject);


protected


  prData               :TQUB_QVO_QVD;


public


  procedure DoOnChangeData(Sender :TObject);
  procedure DoOnClosingData(Sender :TObject);


end;


implementation


uses


QUB_Node;


{$R *.DFM}


//****************************************************************************//
procedure TQUB_Viewport_DataComment.DoOnChangeData(Sender :TObject);
begin
  if prData <> nil then begin
    prData.DataObject.Session['Comment'].SetData( txtComment.Text );
  end;
  prData    := TQUB_QVO_QVD(Sender);
  if prData <> nil then begin
    txtComment.Text    := prData.DataObject.Session.Find('Comment').DataAsString;
    txtComment.Enabled := True;
  end else begin
    txtComment.Text    := '';
    txtComment.Enabled := False;
  end;
end;

procedure TQUB_Viewport_DataComment.DoOnClosingData(Sender :TObject);
begin
  if Sender = prData then DoOnChangeData(nil);
end;


//******************************************************************************
procedure TQUB_Viewport_DataComment.CopyItemClick(Sender: TObject);
begin
  inherited;
  txtComment.CopyToClipboard;
end;

procedure TQUB_Viewport_DataComment.ClearItemClick(Sender: TObject);
begin
  inherited;
  txtComment.Clear;
end;


//******************************************************************************
end.
