{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
// -- General purpose dialogue for getting a single value from the user.
unit Single_Entry;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, RangedEdit,
  QUB_Global;

type
  TSingleEntry = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    lblPrompt: TLabel;
    Procedure Setup( iValue : Integer; iMin : Integer; iMax : Integer; cPrompt : String; cCaption : String );
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    edt1: TRangedEdit;

    constructor Create(AOwner :TComponent); override;

    { Public declarations }
  end;

implementation

{$R *.DFM}

constructor TSingleEntry.Create(AOwner :TComponent);
begin
  inherited;
  edt1 := TRangedEdit.Create(Self);
  edt1.Setup( Self, 64, 36, 85, 21, 2, 'edt1', -100000000, 100000000);
end;

Procedure TSingleEntry.Setup( iValue : Integer; iMin : Integer; iMax : Integer; cPrompt : String; cCaption : String );
Begin
  Caption := cCaption;
  lblPrompt.Caption := cPrompt;
  edt1.MinValue := iMin;
  edt1.MaxValue := iMax;
  edt1.Text := IntToStr(iValue);
End;

procedure TSingleEntry.OKBtnClick(Sender: TObject);
begin
  ModalResult := ValidStrToInt(edt1.Text,-1);
end;

procedure TSingleEntry.CancelBtnClick(Sender: TObject);
begin
  ModalResult := -1;
end;

end.
