program qub;

uses
  SysUtils,
  Classes,
  Windows,
  DDEMan,
  Forms,
  Alloc in '..\Lib\Alloc.pas',
  AllocTypes in '..\Lib\AllocTypes.pas',
  AMRandom in '..\Lib\AMRandom.pas',
  AMRandomRS in '..\Lib\AMRandomRS.pas',
  cvode_iface in '..\Lib\cvode_iface.pas',
  dfp_min_iface in '..\Lib\dfp_min_iface.pas',
  qubopt_iface in '..\Lib\qubopt_iface.pas',
  random in '..\Lib\random.pas',
  SCANF in '..\Lib\SCANF.PAS',
  Scanf_c in '..\Lib\Scanf_c.pas',
  SelectorListBox in '..\Lib\SelectorListBox.pas',
  UpdateCt in '..\Lib\UpdateCt.pas',
  Version in '..\Lib\Version.pas',
  KPL_Array in '..\KPL\KPL_Array.pas',
  KPL_BarProgress in '..\KPL\KPL_BarProgress.pas',
  KPL_Block in '..\KPL\KPL_Block.pas',
  KPL_CollectionConsole in '..\KPL\KPL_CollectionConsole.pas',
  KPL_CollectionDialogs in '..\KPL\KPL_CollectionDialogs.pas',
  KPL_CollectionMarkov in '..\KPL\KPL_CollectionMarkov.pas',
  KPL_CollectionMatrix in '..\KPL\KPL_CollectionMatrix.pas',
  KPL_CollectionODE in '..\KPL\KPL_CollectionODE.pas',
  KPL_CollectionQUBAcqProtocol in '..\KPL\KPL_CollectionQUBAcqProtocol.pas',
  KPL_CollectionQUBInterface in '..\KPL\KPL_CollectionQUBInterface.pas',
  KPL_CollectionQUBPulse in '..\KPL\KPL_CollectionQUBPulse.pas',
  KPL_CollectionQUBQVD in '..\KPL\KPL_CollectionQUBQVD.pas',
  KPL_CollectionQUBQVM in '..\KPL\KPL_CollectionQUBQVM.pas',
  KPL_CollectionQUBTypes in '..\KPL\KPL_CollectionQUBTypes.pas',
  KPL_Expression in '..\KPL\KPL_Expression.pas',
  KPL_Global in '..\KPL\KPL_Global.pas',
  KPL_Kinetic in '..\KPL\KPL_Kinetic.pas',
  KPL_Language in '..\KPL\KPL_Language.pas',
  KPL_Markov in '..\KPL\KPL_Markov.pas',
  KPL_MarkovArray in '..\KPL\KPL_MarkovArray.pas',
  KPL_Objects in '..\KPL\KPL_Objects.pas',
  KPL_ODE in '..\KPL\KPL_ODE.pas',
  KPL_Parameter in '..\KPL\KPL_Parameter.pas',
  KPL_ParameterArray in '..\KPL\KPL_ParameterArray.pas',
  KPL_Parser in '..\KPL\KPL_Parser.pas',
  KPL_Program in '..\KPL\KPL_Program.pas',
  KPL_Relation in '..\KPL\KPL_Relation.pas',
  KPL_Run in '..\KPL\KPL_Run.pas',
  KPL_Statement in '..\KPL\KPL_Statement.pas',
  KPL_Value in '..\KPL\KPL_Value.pas',
  KPL_Variable in '..\KPL\KPL_Variable.pas',
  KPL_VariableArray in '..\KPL\KPL_VariableArray.pas',
  ModelEnergyPlot in 'ModelEnergyPlot.pas',
  ModelEnergyPlotProperties in 'ModelEnergyPlotProperties.pas',
  PythonReadEvalPrint in 'PythonReadEvalPrint.pas',
  QUB_A2Q_Global in 'QUB_A2Q_Global.pas',
  QUB_A2Q_Model in 'QUB_A2Q_Model.pas',
  QUB_About in 'QUB_About.pas',
  QUB_Acquisition_AIChannel_Frame in 'QUB_Acquisition_AIChannel_Frame.pas',
  QUB_Acquisition_AOChannel_Frame in 'QUB_Acquisition_AOChannel_Frame.pas',
  QUB_Acquisition_DIChannel_Frame in 'QUB_Acquisition_DIChannel_Frame.pas',
  QUB_Acquisition_DOChannel_Frame in 'QUB_Acquisition_DOChannel_Frame.pas',
  QUB_Acquisition_Hardware in 'QUB_Acquisition_Hardware.pas',
  QUB_AcquisitionInput in 'QUB_AcquisitionInput.pas',
  QUB_AcquisitionInput_Properties in 'QUB_AcquisitionInput_Properties.pas',
  QUB_AcquisitionOutput in 'QUB_AcquisitionOutput.pas',
  QUB_AcquisitionOutput_Properties in 'QUB_AcquisitionOutput_Properties.pas',
  QUB_AcquisitionProtocol_Properties in 'QUB_AcquisitionProtocol_Properties.pas',
  QUB_AcquisitionSShot_Properties in 'QUB_AcquisitionSShot_Properties.pas',
  QUB_Action in 'QUB_Action.pas',
  QUB_Action_Properties in 'QUB_Action_Properties.pas',
  QUB_ActionSelector in 'QUB_ActionSelector.pas',
  QUB_ActionSelector_Acquisition in 'QUB_ActionSelector_Acquisition.pas',
  QUB_ActionSelector_Lists in 'QUB_ActionSelector_Lists.pas',
  QUB_ActionSelector_Modeling in 'QUB_ActionSelector_Modeling.pas',
  QUB_ActionSelector_Preprocessing in 'QUB_ActionSelector_Preprocessing.pas',
  QUB_ActionSelector_Simulation in 'QUB_ActionSelector_Simulation.pas',
  QUB_ActionSelector_Sound in 'QUB_ActionSelector_Sound.pas',
  QUB_Baseline in 'QUB_Baseline.pas',
  QUB_Baseline_Global in 'QUB_Baseline_Global.pas',
  QUB_ColorPanel in 'QUB_ColorPanel.pas',
  QUB_Console in 'QUB_Console.pas',
  QUB_DataList in 'QUB_DataList.pas',
  QUB_Deviates in 'QUB_Deviates.pas',
  QUB_DockManager in 'QUB_DockManager.pas',
  QUB_Drift_Model in 'QUB_Drift_Model.pas',
  QUB_Eigen in 'QUB_Eigen.pas',
  QUB_Events in 'QUB_Events.pas',
  QUB_Exp_Global in 'QUB_Exp_Global.pas',
  QUB_Exp_Model in 'QUB_Exp_Model.pas',
  QUB_ExpCond_Parameters in 'QUB_ExpCond_Parameters.pas',
  QUB_Extract_Global in 'QUB_Extract_Global.pas',
  QUB_Fit_Model in 'QUB_Fit_Model.pas',
  QUB_FitCurves in 'QUB_FitCurves.pas',
  QUB_Global in 'QUB_Global.pas',
  QUB_Globals in 'QUB_Globals.pas',
  QUB_GUIInterface in 'QUB_GUIInterface.pas',
  QUB_Histogram_Amp_Properties in 'QUB_Histogram_Amp_Properties.pas',
  QUB_Histogram_Dur_Properties in 'QUB_Histogram_Dur_Properties.pas',
  QUB_Histogram_FFT_Properties in 'QUB_Histogram_FFT_Properties.pas',
  QUB_Idealization in 'QUB_Idealization.pas',
  QUB_Idealize_Global in 'QUB_Idealize_Global.pas',
  QUB_IdlBase_Global in 'QUB_IdlBase_Global.pas',
  QUB_IdlCond in 'QUB_IdlCond.pas',
  QUB_Interface in 'QUB_Interface.pas',
  QUB_Interface_Button in 'QUB_Interface_Button.pas',
  QUB_Kalman in 'QUB_Kalman.pas',
  QUB_ListBox in 'QUB_ListBox.pas',
  QUB_LKC_Model in 'QUB_LKC_Model.pas',
  QUB_Mac_Global in 'QUB_Mac_Global.pas',
  QUB_Mac_Model in 'QUB_Mac_Model.pas',
  QUB_Main in 'QUB_Main.pas',
  QUB_Matrices in 'QUB_Matrices.pas',
  QUB_Matrix in 'QUB_Matrix.pas',
  QUB_MIL in 'QUB_MIL.pas',
  QUB_Mil_Global in 'QUB_Mil_Global.pas',
  QUB_MIP_Global in 'QUB_MIP_Global.pas',
  QUB_MIP_Model in 'QUB_MIP_Model.pas',
  QUB_Movies in 'QUB_Movies.pas',
  QUB_Multicast in 'QUB_Multicast.pas',
  QUB_Node in 'QUB_Node.pas',
  QUB_Node_HEKA in 'QUB_Node_HEKA.pas',
  QUB_Node_Model in 'QUB_Node_Model.pas',
  QUB_Node_Python in 'QUB_Node_Python.pas',
  QUB_NodeEditForm in 'QUB_NodeEditForm.pas',
  QUB_NodeEditor in 'QUB_NodeEditor.pas',
  QUB_ObjectCache in 'QUB_ObjectCache.pas',
  QUB_Params in 'QUB_Params.pas',
  QUB_Parser in 'QUB_Parser.pas',
  QUB_Powell in 'QUB_Powell.pas',
  QUB_Protocol in 'QUB_Protocol.pas',
  QUB_PyCmd_MenuButton in 'QUB_PyCmd_MenuButton.pas',
  QUB_Python_Data in 'QUB_Python_Data.pas',
  QUB_Python_ModalDialog in 'QUB_Python_ModalDialog.pas',
  QUB_Python_Model in 'QUB_Python_Model.pas',
  QUB_Python_Prompt in 'QUB_Python_Prompt.pas',
  QUB_Python_Thread in 'QUB_Python_Thread.pas',
  QUB_Python_Wizard in 'QUB_Python_Wizard.pas',
  QUB_Q_Global in 'QUB_Q_Global.pas',
  QUB_Q_Model in 'QUB_Q_Model.pas',
  QUB_QFS in 'QUB_QFS.pas',
  QUB_QFS_Channels in 'QUB_QFS_Channels.pas',
  QUB_QFS_DWT_Segments in 'QUB_QFS_DWT_Segments.pas',
  QUB_QFS_Edit in 'QUB_QFS_Edit.pas',
  QUB_QFS_File in 'QUB_QFS_File.pas',
  QUB_QFS_Node in 'QUB_QFS_Node.pas',
  QUB_QFS_QDF in 'QUB_QFS_QDF.pas',
  QUB_QFS_QDF_ABF in 'QUB_QFS_QDF_ABF.pas',
  QUB_QFS_QDF_Global in 'QUB_QFS_QDF_Global.pas',
  QUB_QFS_QDF_MPX in 'QUB_QFS_QDF_MPX.pas',
  QUB_QFS_QDF_Properties in 'QUB_QFS_QDF_Properties.pas',
  QUB_QFS_QDF_WAV in 'QUB_QFS_QDF_WAV.pas',
  QUB_QFS_QIF_Segments in 'QUB_QFS_QIF_Segments.pas',
  QUB_QFS_QMF in 'QUB_QFS_QMF.pas',
  QUB_QFS_QMF_QMatrix in 'QUB_QFS_QMF_QMatrix.pas',
  QUB_QFS_QPF in 'QUB_QFS_QPF.pas',
  QUB_QFS_Segments in 'QUB_QFS_Segments.pas',
  QUB_QVO in 'QUB_QVO.pas',
  QUB_QVO_Properties in 'QUB_QVO_Properties.pas',
  QUB_QVO_QVD in 'QUB_QVO_QVD.pas',
  QUB_QVO_QVD_Chop_Properties in 'QUB_QVO_QVD_Chop_Properties.pas',
  QUB_QVO_QVD_EventProcessor_Properties in 'QUB_QVO_QVD_EventProcessor_Properties.pas',
  QUB_QVO_QVD_Global in 'QUB_QVO_QVD_Global.pas',
  QUB_QVO_QVD_GoToPoint_Properties in 'QUB_QVO_QVD_GoToPoint_Properties.pas',
  QUB_QVO_QVD_Overlap in 'QUB_QVO_QVD_Overlap.pas',
  QUB_QVO_QVD_Play in 'QUB_QVO_QVD_Play.pas',
  QUB_QVO_QVD_Print_Properties in 'QUB_QVO_QVD_Print_Properties.pas',
  QUB_QVO_QVD_Properties in 'QUB_QVO_QVD_Properties.pas',
  QUB_QVO_QVD_SelectionProperties in 'QUB_QVO_QVD_SelectionProperties.pas',
  QUB_QVO_QVM in 'QUB_QVO_QVM.pas',
  QUB_QVO_QVM_Print_Properties in 'QUB_QVO_QVM_Print_Properties.pas',
  QUB_QVO_QVM_Properties in 'QUB_QVO_QVM_Properties.pas',
  QUB_QVO_QVM_Rate_Properties in 'QUB_QVO_QVM_Rate_Properties.pas',
  QUB_QVO_QVM_State_Properties in 'QUB_QVO_QVM_State_Properties.pas',
  QUB_QVO_QVP in 'QUB_QVO_QVP.pas',
  QUB_QVO_QVP_Stage_Properties in 'QUB_QVO_QVP_Stage_Properties.pas',
  QUB_QVO_QVR in 'QUB_QVO_QVR.pas',
  QUB_QVO_QVR_Window in 'QUB_QVO_QVR_Window.pas',
  QUB_QVO_QVS in 'QUB_QVO_QVS.pas',
  QUB_QVO_QVS_Properties in 'QUB_QVO_QVS_Properties.pas',
  QUB_QVO_QVSpectrum in 'QUB_QVO_QVSpectrum.pas',
  QUB_QVO_QVSpectrum_Properties in 'QUB_QVO_QVSpectrum_Properties.pas',
  QUB_QVO_QVT in 'QUB_QVO_QVT.pas',
  QUB_Reports_Editor in 'QUB_Reports_Editor.pas',
  QUB_Reports_Manager in 'QUB_Reports_Manager.pas',
  QUB_Results in 'QUB_Results.pas',
  QUB_Results_Chart in 'QUB_Results_Chart.pas',
  QUB_Results_Criteria in 'QUB_Results_Criteria.pas',
  QUB_Results_Histograms in 'QUB_Results_Histograms.pas',
  QUB_Results_Models in 'QUB_Results_Models.pas',
  QUB_Results_Select in 'QUB_Results_Select.pas',
  QUB_Results_VersusDialog in 'QUB_Results_VersusDialog.pas',
  QUB_Rich_Console in 'QUB_Rich_Console.pas',
  QUB_Servers in 'QUB_Servers.pas',
  QUB_ServerView in 'QUB_ServerView.pas',
  QUB_Sin_Model in 'QUB_Sin_Model.pas',
  QUB_Socket in 'QUB_Socket.pas',
  QUB_Spectrum in 'QUB_Spectrum.pas',
  QUB_Stats in 'QUB_Stats.pas',
  QUB_Table in 'QUB_Table.pas',
  QUB_Task in 'QUB_Task.pas',
  QUB_Task_AMP in 'QUB_Task_AMP.pas',
  QUB_Task_AMP_Properties in 'QUB_Task_AMP_Properties.pas',
  QUB_Task_AppendOverlap in 'QUB_Task_AppendOverlap.pas',
  QUB_Task_ApplyBaseline_Properties in 'QUB_Task_ApplyBaseline_Properties.pas',
  QUB_Task_BaseLineMT in 'QUB_Task_BaseLineMT.pas',
  QUB_Task_Data in 'QUB_Task_Data.pas',
  QUB_Task_DataMT in 'QUB_Task_DataMT.pas',
  QUB_Task_DataWav in 'QUB_Task_DataWav.pas',
  QUB_Task_DataWav_Properties in 'QUB_Task_DataWav_Properties.pas',
  QUB_Task_Drift in 'QUB_Task_Drift.pas',
  QUB_Task_Drift_Properties in 'QUB_Task_Drift_Properties.pas',
  QUB_Task_EvP in 'QUB_Task_EvP.pas',
  QUB_Task_EvP_Properties in 'QUB_Task_EvP_Properties.pas',
  QUB_Task_Exp in 'QUB_Task_Exp.pas',
  QUB_Task_Exp_Properties in 'QUB_Task_Exp_Properties.pas',
  QUB_Task_ExtractSelection in 'QUB_Task_ExtractSelection.pas',
  QUB_Task_ExtractSelection_Properties in 'QUB_Task_ExtractSelection_Properties.pas',
  QUB_Task_Fit_Dlog in 'QUB_Task_Fit_Dlog.pas',
  QUB_Task_Histogram in 'QUB_Task_Histogram.pas',
  QUB_Task_Idealize_Properties in 'QUB_Task_Idealize_Properties.pas',
  QUB_Task_IdealizeMT in 'QUB_Task_IdealizeMT.pas',
  QUB_Task_IdlBase in 'QUB_Task_IdlBase.pas',
  QUB_Task_IdlBase_Properties in 'QUB_Task_IdlBase_Properties.pas',
  QUB_Task_IdlFit in 'QUB_Task_IdlFit.pas',
  QUB_Task_IdlFit_Properties in 'QUB_Task_IdlFit_Properties.pas',
  QUB_Task_Mac in 'QUB_Task_Mac.pas',
  QUB_Task_Mac_Properties in 'QUB_Task_Mac_Properties.pas',
  QUB_Task_MdlRpt in 'QUB_Task_MdlRpt.pas',
  QUB_Task_MdlRpt_Properties in 'QUB_Task_MdlRpt_Properties.pas',
  QUB_Task_MIL in 'QUB_Task_MIL.pas',
  QUB_Task_MIL_Properties in 'QUB_Task_MIL_Properties.pas',
  QUB_Task_MIP in 'QUB_Task_MIP.pas',
  QUB_Task_MIP_Properties in 'QUB_Task_MIP_Properties.pas',
  QUB_Task_MMerge_Properties in 'QUB_Task_MMerge_Properties.pas',
  QUB_Task_MPL in 'QUB_Task_MPL.pas',
  QUB_Task_MPL_Properties in 'QUB_Task_MPL_Properties.pas',
  QUB_Task_MSearch in 'QUB_Task_MSearch.pas',
  QUB_Task_MSearch_Properties in 'QUB_Task_MSearch_Properties.pas',
  QUB_Task_Properties in 'QUB_Task_Properties.pas',
  QUB_Task_Protocol_To_Data in 'QUB_Task_Protocol_To_Data.pas',
  QUB_Task_Simulate in 'QUB_Task_Simulate.pas',
  QUB_Task_Simulate_Properties in 'QUB_Task_Simulate_Properties.pas',
  QUB_Task_Stat in 'QUB_Task_Stat.pas',
  QUB_Task_Stat_Properties in 'QUB_Task_Stat_Properties.pas',
  QUB_TaskView in 'QUB_TaskView.pas',
  QUB_Thread in 'QUB_Thread.pas',
  QUB_Thread_Baseline in 'QUB_Thread_Baseline.pas',
  QUB_Thread_Data in 'QUB_Thread_Data.pas',
  QUB_Thread_Idealize in 'QUB_Thread_Idealize.pas',
  QUB_Thread_Socket in 'QUB_Thread_Socket.pas',
  QUB_Thread_Socket_Baseline in 'QUB_Thread_Socket_Baseline.pas',
  QUB_Thread_Socket_Data in 'QUB_Thread_Socket_Data.pas',
  QUB_Thread_Socket_Idealize in 'QUB_Thread_Socket_Idealize.pas',
  QUB_TrackBar in 'QUB_TrackBar.pas',
  QUB_UserInterfaceProperties in 'QUB_UserInterfaceProperties.pas',
  QUB_Version in 'QUB_Version.pas',
  QUB_Viewport in 'QUB_Viewport.pas',
  QUB_Viewport_AcquisitionInput in 'QUB_Viewport_AcquisitionInput.pas',
  QUB_Viewport_AcquisitionNotes in 'QUB_Viewport_AcquisitionNotes.pas',
  QUB_Viewport_AcquisitionOutput in 'QUB_Viewport_AcquisitionOutput.pas',
  QUB_Viewport_AcquisitionProtocol in 'QUB_Viewport_AcquisitionProtocol.pas',
  QUB_Viewport_AcquisitionSShot in 'QUB_Viewport_AcquisitionSShot.pas',
  QUB_Viewport_Data in 'QUB_Viewport_Data.pas',
  QUB_Viewport_Data_New_Properties in 'QUB_Viewport_Data_New_Properties.pas',
  QUB_Viewport_Data_Shortcuts in 'QUB_Viewport_Data_Shortcuts.pas',
  QUB_Viewport_DataComment in 'QUB_Viewport_DataComment.pas',
  QUB_Viewport_DataOverlap in 'QUB_Viewport_DataOverlap.pas',
  QUB_Viewport_Files in 'QUB_Viewport_Files.pas',
  QUB_Viewport_Graph in 'QUB_Viewport_Graph.pas',
  QUB_Viewport_Graph_Properties in 'QUB_Viewport_Graph_Properties.pas',
  QUB_Viewport_Histogram in 'QUB_Viewport_Histogram.pas',
  QUB_Viewport_Model in 'QUB_Viewport_Model.pas',
  QUB_Viewport_Model_New_Properties in 'QUB_Viewport_Model_New_Properties.pas',
  QUB_Viewport_Protocol in 'QUB_Viewport_Protocol.pas',
  QUB_Viewport_Python in 'QUB_Viewport_Python.pas',
  QUB_Viewport_Report in 'QUB_Viewport_Report.pas',
  QUB_Viewport_Report_Properties in 'QUB_Viewport_Report_Properties.pas',
  QUB_Viewport_Results in 'QUB_Viewport_Results.pas',
  QUB_Viewport_Scripts in 'QUB_Viewport_Scripts.pas',
  QUB_WizardScaling in 'QUB_WizardScaling.pas',
  QUB_WizardSetup in 'QUB_WizardSetup.pas',
  QUB_ZoomBar in 'QUB_ZoomBar.pas',
  RangedEdit in 'RangedEdit.pas',
  RegistryInterface in 'RegistryInterface.pas',
  Single_Entry in 'Single_Entry.pas',
  MRNG in '..\Lib\MRNG.pas',
  eigen in '..\tpmath1\eigen.pas',
  fcomp in '..\tpmath1\fcomp.pas',
  FMath in '..\tpmath1\FMath.pas',
  fourier in '..\tpmath1\fourier.pas',
  matcomp in '..\tpmath1\matcomp.pas',
  matrices in '..\tpmath1\matrices.pas',
  mcmc in '..\tpmath1\mcmc.pas',
  optim in '..\tpmath1\optim.pas',
  pastring in '..\tpmath1\pastring.pas',
  plotvar in '..\tpmath1\plotvar.pas',
  polynom in '..\tpmath1\polynom.pas',
  regress in '..\tpmath1\regress.pas',
  simopt in '..\tpmath1\simopt.pas',
  stat in '..\tpmath1\stat.pas',
  texplot in '..\tpmath1\texplot.pas',
  winplot in '..\tpmath1\winplot.pas',
  PythonEngine in 'PythonEngine.pas';

{$E exe}

{$R *.res}

var


  DdeCC :TDdeClientConv;
  Pars  :TStringList;
  r     :Boolean;


begin
  Application.Initialize;
  Application.Title := 'QuB';
  Application.HelpFile := 'C:\Shared\qs\QuBSuite\QUBHELP.HLP';
  r := (OpenMutex(MUTEX_ALL_ACCESS, False, PChar('QuB')) <> 0);

  if r then begin
  //Mutex already exists

    if ParamCount > 1 then begin
    //Pass the parameters to the running instance using DDE and quit

      DdeCC := nil;
      Pars  := nil;
      try
        DdeCC := TDdeClientConv.Create(nil);
        DdeCC.ConnectMode := ddeAutomatic;
        DdeCC.ServiceApplication := Application.ExeName;
        if DdeCC.SetLink('QuB', 'Commands') then begin
          Pars := TStringList.Create;
          try
            Params(Pars);
            DdeCC.PokeDataLines('CommandsItem', Pars);
          finally
            DdeCC.CloseLink;
          end;
        end;
      finally
        DdeCC.Free;
        Pars.Free;
      end;

    end else begin
    //Can call another instance, provided there are no arguments

      r := False;

    end;

  end else begin

    CreateMutex( nil, False, PChar('QuB'));

  end;

  if r then begin
    Application.Terminate;
    Exit;
  end;

  Application.CreateForm(TQUB_MainForm, QUB_MainForm);
  Console      := QUB_MainForm.Console;
  GraphConsole := QUB_MainForm.GraphConsole;
  Application.CreateForm(TQUB_AboutForm, QUB_AboutForm);
  QUB_AboutForm.OnHide := QUB_MainForm.OnAboutHide;

  if ParamCount = 0 then begin
    QUB_MainForm.ReadParams;
  end;

  QUB_AboutForm.Show;
  QUB_AboutForm.Refresh;

  Application.HintHidePause := 10000;

  Application.Run;

end.

