program qub;


uses
  SysUtils,
  Classes,
  Windows,
  DDEMan,
  Forms,
  QUB_Params,
  QUB_Main in 'QUB_Main.pas' {QUB_MainForm},
  QUB_About in 'QUB_About.pas' {QUB_AboutForm},
  QUB_Action in 'QUB_Action.pas',
  QUB_ActionSelector in 'QUB_ActionSelector.pas' {QUB_ActionSelector},
  QUB_ActionSelector_Lists in 'QUB_ActionSelector_Lists.pas' {QUB_ActionSelector_Lists},
  QUB_ActionSelector_Modeling in 'QUB_ActionSelector_Modeling.pas' {QUB_ActionSelector_Modeling},
  QUB_ActionSelector_Preprocessing in 'QUB_ActionSelector_Preprocessing.pas' {QUB_ActionSelector_Preprocessing},
  QUB_ActionSelector_Simulation in 'QUB_ActionSelector_Simulation.pas' {QUB_ActionSelector_Simulation},
  QUB_ActionSelector_Sound in 'QUB_ActionSelector_Sound.pas' {QUB_ActionSelector_Sound},
  QUB_GUIInterface in 'QUB_GUIInterface.pas',
  QUB_Acquisition_Hardware in 'QUB_Acquisition_Hardware.pas',
  QUB_AcquisitionInput in 'QUB_AcquisitionInput.pas' {QUB_Acquisition_Input: TFrame},
  QUB_AcquisitionInput_Properties in 'QUB_AcquisitionInput_Properties.pas' {QUB_AcquisitionInput_Properties_Form},
  QUB_AcquisitionOutput in 'QUB_AcquisitionOutput.pas' {QUB_Acquisition_Output: TFrame},
  QUB_AcquisitionOutput_Properties in 'QUB_AcquisitionOutput_Properties.pas' {QUB_AcquisitionOutput_Properties_Form},
  QUB_Baseline_Global in 'QUB_Baseline_Global.pas',
  QUB_ColorPanel in 'QUB_ColorPanel.pas',
  QUB_Deviates in 'QUB_Deviates.pas',
  QUB_DockManager in 'QUB_DockManager.pas',
  QUB_Drift_Model in 'QUB_Drift_Model.pas',
  QUB_Extract_Global in 'QUB_Extract_Global.pas',
  QUB_Global in 'QUB_Global.pas',
  QUB_Globals in 'QUB_Globals.pas',
  QUB_Histogram_Amp_Properties in 'QUB_Histogram_Amp_Properties.pas' {QUB_Histogram_Amp_PropertiesForm},
  QUB_Histogram_Dur_Properties in 'QUB_Histogram_Dur_Properties.pas' {QUB_Histogram_Dur_PropertiesForm},
  QUB_Histogram_FFT_Properties in 'QUB_Histogram_FFT_Properties.pas' {QUB_Histogram_FFT_PropertiesForm},
  QUB_Idealize_Global in 'QUB_Idealize_Global.pas',
  QUB_IdlBase_Global in 'QUB_IdlBase_Global.pas',
  QUB_Interface in 'QUB_Interface.pas',
  QUB_Interface_Button in 'QUB_Interface_Button.pas',
  QUB_Kalman in 'QUB_Kalman.pas',
  QUB_ListBox in 'QUB_ListBox.pas',
  QUB_Mac_Global in 'QUB_Mac_Global.pas',
  QUB_Mac_Model in 'QUB_Mac_Model.pas',
  QUB_Matrices in 'QUB_Matrices.pas',
  QUB_Matrix in 'QUB_Matrix.pas',
  QUB_MIL in 'QUB_MIL.pas',
  QUB_Mil_Global in 'QUB_Mil_Global.pas',
  QUB_MIP_Global in 'QUB_MIP_Global.pas',
  QUB_MIP_Model in 'QUB_MIP_Model.pas',
  QUB_Multicast in 'QUB_Multicast.pas',
  QUB_Node in 'QUB_Node.pas',
  QUB_Node_Model in 'QUB_Node_Model.pas',
  QUB_Node_Python in 'QUB_Node_Python.pas',
  QUB_Parser in 'QUB_Parser.pas',
  QUB_Powell in 'QUB_Powell.pas',
  QUB_PyCmd_MenuButton in 'QUB_PyCmd_MenuButton.pas',
  QUB_Python_Data in 'QUB_Python_Data.pas',
  QUB_Python_Model in 'QUB_Python_Model.pas',
  QUB_Python_Prompt in 'QUB_Python_Prompt.pas' {QUB_Python_Prompt},
  QUB_Python_Thread in 'QUB_Python_Thread.pas',
  QUB_Q_Global in 'QUB_Q_Global.pas',
  QUB_Q_Model in 'QUB_Q_Model.pas',
  QUB_QFS in 'QUB_QFS.pas',
  QUB_QFS_Channels in 'QUB_QFS_Channels.pas',
  QUB_QFS_DWT_Segments in 'QUB_QFS_DWT_Segments.pas',
  QUB_QFS_Edit in 'QUB_QFS_Edit.pas',
  QUB_QFS_File in 'QUB_QFS_File.pas',
  QUB_QFS_QDF in 'QUB_QFS_QDF.pas',
  QUB_QFS_QDF_ABF in 'QUB_QFS_QDF_ABF.pas',
  QUB_QFS_QDF_Global in 'QUB_QFS_QDF_Global.pas',
  QUB_QFS_QDF_MPX in 'QUB_QFS_QDF_MPX.pas',
  QUB_QFS_QDF_Properties in 'QUB_QFS_QDF_Properties.pas' {QUB_QFS_QDF_PropertiesForm},
  QUB_QFS_QDF_WAV in 'QUB_QFS_QDF_WAV.pas',
  QUB_QFS_QIF_Segments in 'QUB_QFS_QIF_Segments.pas',
  QUB_QFS_QMF in 'QUB_QFS_QMF.pas',
  QUB_QFS_QMF_QMatrix in 'QUB_QFS_QMF_QMatrix.pas',
  QUB_QFS_Segments in 'QUB_QFS_Segments.pas',
  QUB_QVO in 'QUB_QVO.pas',
  QUB_QVO_Properties in 'QUB_QVO_Properties.pas' {QUB_QVO_PropertiesForm},
  QUB_QVO_QVD in 'QUB_QVO_QVD.pas',
  QUB_QVO_QVD_Chop_Properties in 'QUB_QVO_QVD_Chop_Properties.pas' {QUB_QVO_QVD_Chop_PropertiesForm},
  QUB_QVO_QVD_Global in 'QUB_QVO_QVD_Global.pas',
  QUB_QVO_QVD_Play in 'QUB_QVO_QVD_Play.pas',
  QUB_QVO_QVD_Print_Properties in 'QUB_QVO_QVD_Print_Properties.pas' {QUB_QVO_QVD_Print_PropertiesForm},
  QUB_QVO_QVD_Properties in 'QUB_QVO_QVD_Properties.pas' {QUB_QVO_QVD_PropertiesForm},
  QUB_QVO_QVM in 'QUB_QVO_QVM.pas',
  QUB_QVO_QVM_Print_Properties in 'QUB_QVO_QVM_Print_Properties.pas' {QUB_QVO_QVM_Print_PropertiesForm},
  QUB_QVO_QVM_Properties in 'QUB_QVO_QVM_Properties.pas' {QUB_QVO_QVM_PropertiesForm},
  QUB_QVO_QVM_Rate_Properties in 'QUB_QVO_QVM_Rate_Properties.pas' {QUB_QVO_QVM_Rate_PropertiesForm},
  QUB_QVO_QVM_State_Properties in 'QUB_QVO_QVM_State_Properties.pas' {QUB_QVO_QVM_State_PropertiesForm},
  QUB_QVO_QVR in 'QUB_QVO_QVR.pas',
  QUB_QVO_QVS in 'QUB_QVO_QVS.pas',
  QUB_QVO_QVS_Properties in 'QUB_QVO_QVS_Properties.pas' {QUB_QVO_QVS_PropertiesForm},
  QUB_QVO_QVSpectrum in 'QUB_QVO_QVSpectrum.pas',
  QUB_QVO_QVSpectrum_Properties in 'QUB_QVO_QVSpectrum_Properties.pas' {QUB_QVO_QVS_PropertiesForm},
  QUB_QVO_QVT in 'QUB_QVO_QVT.pas',
  QUB_Results in 'QUB_Results.pas',
  QUB_Results_Chart in 'QUB_Results_Chart.pas',
  QUB_Results_Criteria in 'QUB_Results_Criteria.pas',
  QUB_Results_Models in 'QUB_Results_Models.pas',
  QUB_Results_Select in 'QUB_Results_Select.pas',
  QUB_Rich_Console in 'QUB_Rich_Console.pas',
  QUB_Servers in 'QUB_Servers.pas',
  QUB_Socket in 'QUB_Socket.pas',
  QUB_Spectrum in 'QUB_Spectrum.pas',
  QUB_Stats in 'QUB_Stats.pas',
  QUB_Table in 'QUB_Table.pas',
  QUB_Task in 'QUB_Task.pas',
  QUB_Task_AMP in 'QUB_Task_AMP.pas',
  QUB_Task_AMP_Properties in 'QUB_Task_AMP_Properties.pas' {QUB_Task_AMP_PropertiesForm},
  QUB_Task_ApplyBaseLine_Properties in 'QUB_Task_ApplyBaseline_Properties.pas' {QUB_Task_ApplyBaseline_PropertiesForm},
  QUB_Task_BaselineMT in 'QUB_Task_BaseLineMT.pas',
  QUB_Task_Data in 'QUB_Task_Data.pas',
  QUB_Task_DataMT in 'QUB_Task_DataMT.pas',
  QUB_Task_Drift in 'QUB_Task_Drift.pas',
  QUB_Task_Drift_Properties in 'QUB_Task_Drift_Properties.pas' {QUB_Task_Drift_PropertiesForm},
  QUB_Task_EvP in 'QUB_Task_EvP.pas',
  QUB_Task_EvP_Properties in 'QUB_Task_EvP_Properties.pas' {QUB_Task_EvP_Properties},
  QUB_Task_ExtractSelection in 'QUB_Task_ExtractSelection.pas',
  QUB_Task_ExtractSelection_Properties in 'QUB_Task_ExtractSelection_Properties.pas' {QUB_Task_ExtractSelection_PropertiesForm},
  QUB_Task_Idealize_Properties in 'QUB_Task_Idealize_Properties.pas' {QUB_Task_Idealize_PropertiesForm},
  QUB_Task_IdealizeMT in 'QUB_Task_IdealizeMT.pas',
  QUB_Task_IdlBase in 'QUB_Task_IdlBase.pas',
  QUB_Task_IdlBase_Properties in 'QUB_Task_IdlBase_Properties.pas' {QUB_Task_IdlBase_PropertiesForm},
  QUB_Task_Mac in 'QUB_Task_Mac.pas',
  QUB_Task_Mac_Properties in 'QUB_Task_Mac_Properties.pas' {QUB_Task_Mac_PropertiesForm},
  QUB_Task_MIL in 'QUB_Task_MIL.pas',
  QUB_Task_Mil_Properties in 'QUB_Task_Mil_Properties.pas' {QUB_Task_Mil_PropertiesForm},
  QUB_Task_MIP in 'QUB_Task_MIP.pas',
  QUB_Task_MIP_Properties in 'QUB_Task_MIP_Properties.pas' {QUB_Task_MIP_PropertiesForm},
  QUB_Task_MPL in 'QUB_Task_MPL.pas',
  QUB_Task_MPL_Properties in 'QUB_Task_MPL_Properties.pas' {QUB_Task_MPL_PropertiesForm},
  QUB_Task_MSearch in 'QUB_Task_MSearch.pas',
  QUB_Task_MSearch_Properties in 'QUB_Task_MSearch_Properties.pas' {QUB_Task_MSearch_PropertiesForm},
  QUB_Task_Properties in 'QUB_Task_Properties.pas' {QUB_Task_PropertiesForm},
  QUB_Task_Simulate in 'QUB_Task_Simulate.pas',
  QUB_Task_Simulate_Properties in 'QUB_Task_Simulate_Properties.pas' {QUB_Task_Simulate_PropertiesForm},
  QUB_TaskView in 'QUB_TaskView.pas' {QUB_TaskViewForm},
  QUB_Thread in 'QUB_Thread.pas',
  QUB_Thread_Baseline in 'QUB_Thread_Baseline.pas',
  QUB_Thread_Data in 'QUB_Thread_Data.pas',
  QUB_Thread_Socket in 'QUB_Thread_Socket.pas',
  QUB_Thread_Socket_Data in 'QUB_Thread_Socket_Data.pas',
  QUB_Viewport in 'QUB_Viewport.pas' {QUB_Viewport},
  QUB_Viewport_AcquisitionInput in 'QUB_Viewport_AcquisitionInput.pas' {QUB_Viewport_AcquisitionInput},
  QUB_Viewport_AcquisitionOutput in 'QUB_Viewport_AcquisitionOutput.pas' {QUB_Viewport_AcquisitionOutput},
  QUB_Viewport_Data in 'QUB_Viewport_Data.pas' {QUB_Viewport_Data},
  QUB_Viewport_Data_New_Properties in 'QUB_Viewport_Data_New_Properties.pas' {QUB_Viewport_Data_New_PropertiesForm},
  QUB_Viewport_Data_Shortcuts in 'QUB_Viewport_Data_Shortcuts.pas' {QUB_Viewport_Data_Shortcuts: TFrame},
  QUB_Viewport_Files in 'QUB_Viewport_Files.pas' {QUB_Viewport_Files},
  QUB_Viewport_Histogram in 'QUB_Viewport_Histogram.pas' {QUB_Viewport_Histogram},
  QUB_Viewport_Model in 'QUB_Viewport_Model.pas' {QUB_Viewport_Model},
  QUB_Viewport_Model_New_Properties in 'QUB_Viewport_Model_New_Properties.pas' {QUB_Viewport_Model_New_PropertiesForm},
  QUB_Viewport_Python in 'QUB_Viewport_Python.pas' {QUB_Viewport_Python},
  QUB_Viewport_Report in 'QUB_Viewport_Report.pas' {QUB_Viewport_Report},
  QUB_Viewport_Report_Properties in 'QUB_Viewport_Report_Properties.pas' {QUB_Viewport_Report_PropertiesForm},
  QUB_Viewport_Results in 'QUB_Viewport_Results.pas' {QUB_Viewport_Results},
  QUB_Viewport_Scripts in 'QUB_Viewport_Scripts.pas' {QUB_Viewport_Scripts},
  Alloc in '..\Lib\Alloc.pas',
  AllocTypes in '..\Lib\AllocTypes.pas',
  qubopt_iface in '..\Lib\qubopt_iface.pas',
  QUB_Results_VersusDialog in 'QUB_Results_VersusDialog.pas' {QUB_Results_VersusDialog},
  QUB_Task_Fit_Dlog in 'QUB_Task_Fit_Dlog.pas' {OKHelpBottomDlg},
  QUB_IdlCond in 'QUB_IdlCond.pas',
  QUB_Task_Histogram in 'QUB_Task_Histogram.pas',
  QUB_ExpCond_Parameters in 'QUB_ExpCond_Parameters.pas',
  QUB_QVO_QVD_GoToPoint_Properties in 'QUB_QVO_QVD_GoToPoint_Properties.pas' {QUB_QVO_QVD_GoToPoint_PropertiesForm},
  QUB_QFS_Node in 'QUB_QFS_Node.pas',
  QUB_Results_Histograms in 'QUB_Results_Histograms.pas',
  QUB_Task_MMerge_Properties in 'QUB_Task_MMerge_Properties.pas' {QUB_Task_MMerge_PropertiesForm},
  QUB_Node_HEKA in 'QUB_Node_HEKA.pas',
  QUB_Python_Wizard in 'QUB_Python_Wizard.pas',
  QUB_ObjectCache in 'QUB_ObjectCache.pas',
  QUB_Task_DataWav_Properties in 'QUB_Task_DataWav_Properties.pas' {QUB_Task_DataWav_PropertiesForm},
  QUB_Task_DataWav in 'QUB_Task_DataWav.pas',
  QUB_Baseline in 'QUB_Baseline.pas',
  QUB_Idealization in 'QUB_Idealization.pas',
  QUB_DataList in 'QUB_DataList.pas' {Frame1: TFrame},
  QUB_Viewport_AcquisitionSShot in 'QUB_Viewport_AcquisitionSShot.pas' {QUB_Viewport_AcquisitionSShot},
  QUB_Acquisition_DOChannel_Frame in 'QUB_Acquisition_DOChannel_Frame.pas' {QUB_Acquisition_DOChannelFrame: TFrame},
  QUB_Acquisition_AIChannel_Frame in 'QUB_Acquisition_AIChannel_Frame.pas' {QUB_Acquisition_AIChannelFrame: TFrame},
  QUB_Acquisition_AOChannel_Frame in 'QUB_Acquisition_AOChannel_Frame.pas' {QUB_Acquisition_AOChannelFrame: TFrame},
  QUB_Acquisition_DIChannel_Frame in 'QUB_Acquisition_DIChannel_Frame.pas' {QUB_Acquisition_DIChannelFrame: TFrame},
  QUB_AcquisitionSShot_Properties in 'QUB_AcquisitionSShot_Properties.pas' {QUB_AcquisitionSShot_PropertiesForm},
  QUB_QVO_QVD_SelectionProperties in 'QUB_QVO_QVD_SelectionProperties.pas' {QUB_QVO_QVD_SelectionPropertiesForm},
  QUB_Protocol in 'QUB_Protocol.pas',
  QUB_NodeEditForm in 'QUB_NodeEditForm.pas' {QUB_NodeEditForm},
  QUB_NodeEditor in 'QUB_NodeEditor.pas' {QUB_NodeEditor: TFrame},
  QUB_QFS_QPF in 'QUB_QFS_QPF.pas',
  QUB_QVO_QVP in 'QUB_QVO_QVP.pas',
  SelectorListBox in '..\Lib\SelectorListBox.pas',
  QUB_QVO_QVP_Stage_Properties in 'QUB_QVO_QVP_Stage_Properties.pas' {QUB_QVO_QVP_Stage_PropertiesFrame: TFrame},
  KPL_CollectionQUBPulse in '..\KPL\KPL_CollectionQUBPulse.pas',
  KPL_Kinetic in '..\KPL\KPL_Kinetic.pas',
  KPL_Program in '..\KPL\KPL_Program.pas' {KPL_Program: TFrame},
  QUB_Task_Protocol_To_Data in 'QUB_Task_Protocol_To_Data.pas',
  QUB_Task_Stat in 'QUB_Task_Stat.pas',
  QUB_Task_Stat_Properties in 'QUB_Task_Stat_Properties.pas' {QUB_Task_Stat_PropertiesForm},
  QUB_Viewport_DataOverlap in 'QUB_Viewport_DataOverlap.pas' {QUB_Viewport_DataOverlap},
  QUB_QVO_QVD_Overlap in 'QUB_QVO_QVD_Overlap.pas',
  QUB_Task_AppendOverlap in 'QUB_Task_AppendOverlap.pas',
  QUB_Python_ModalDialog in 'QUB_Python_ModalDialog.pas' {QUB_Python_ModalDialog},
  QUB_Reports_Editor in 'QUB_Reports_Editor.pas' {QUB_Reports_EditForm},
  QUB_Reports_Manager in 'QUB_Reports_Manager.pas' {QUB_Reports_ManageForm},
  QUB_WizardSetup in 'QUB_WizardSetup.pas' {frmHardwareConfigure},
  RegistryInterface in 'RegistryInterface.pas',
  QUB_Action_Properties in 'QUB_Action_Properties.pas' {frmActionProperties},
  QUB_UserInterfaceProperties in 'QUB_UserInterfaceProperties.pas' {UserInterfaceProperties},
  QUB_Task_Exp_Properties in 'QUB_Task_Exp_Properties.pas' {QUB_Task_Exp_PropertiesForm},
  QUB_Task_Exp in 'QUB_Task_Exp.pas',
  QUB_Exp_Global in 'QUB_Exp_Global.pas',
  QUB_Exp_Model in 'QUB_Exp_Model.pas',
  QUB_WizardScaling in 'QUB_WizardScaling.pas' {frmWizardScaling},
  QUB_FitCurves in 'QUB_FitCurves.pas',
  QUB_Events in 'QUB_Events.pas',
  QUB_Task_IdlFit_Properties in 'QUB_Task_IdlFit_Properties.pas' {QUB_Task_IdlFit_PropertiesForm},
  QUB_Task_IdlFit in 'QUB_Task_IdlFit.pas',
  ModelEnergyPlot in 'ModelEnergyPlot.pas' {EnergyPlot},
  QUB_Thread_Socket_Baseline in 'QUB_Thread_Socket_Baseline.pas',
  QUB_Thread_Idealize in 'QUB_Thread_Idealize.pas',
  QUB_Task_MdlRpt_Properties in 'QUB_Task_MdlRpt_Properties.pas' {QUB_Task_MdlRpt_PropertiesForm},
  QUB_Task_MdlRpt in 'QUB_Task_MdlRpt.pas',
  QUB_Console in 'QUB_Console.pas',
  QUB_Viewport_DataComment in 'QUB_Viewport_DataComment.pas' {QUB_Viewport_DataComment},
  QUB_Viewport_AcquisitionNotes in 'QUB_Viewport_AcquisitionNotes.pas' {QUB_Viewport_AcquisitionNotes},
  QUB_Viewport_Graph_Properties in 'QUB_Viewport_Graph_Properties.pas' {QUB_Viewport_Graph_PropertiesForm},
  QUB_Viewport_Graph in 'QUB_Viewport_Graph.pas' {QUB_Viewport_Graph},
  ModelEnergyPlotProperties in 'ModelEnergyPlotProperties.pas' {ModelEnergyPlotProperties},
  QUB_Viewport_Protocol in 'QUB_Viewport_Protocol.pas' {QUB_Viewport_Protocol},
  Single_Entry in 'Single_Entry.pas' {SingleEntry};

{$R *.RES}


var


  DdeCC :TDdeClientConv;
  Pars  :TStringList;
  r     :Boolean;


begin
  Application.Initialize;
  Application.Title := 'QuB';
  r := (OpenMutex(MUTEX_ALL_ACCESS, False, PChar('QuB')) <> 0);

  if r then begin
  //Mutex already exists

    if ParamCount > 1 then begin
    //Pass the parameters to the running instance using DDE and quit

      DdeCC := nil;
      Pars  := nil;
      try
        DdeCC := TDdeClientConv.Create(nil);
        DdeCC.ConnectMode := ddeAutomatic;
        DdeCC.ServiceApplication := Application.ExeName;
        if DdeCC.SetLink('QuB', 'Commands') then begin
          Pars := TStringList.Create;
          try
            Params(Pars);
            DdeCC.PokeDataLines('CommandsItem', Pars);
          finally
            DdeCC.CloseLink;
          end;
        end;
      finally
        DdeCC.Free;
        Pars.Free;
      end;

    end else begin
    //Can call another instance, provided there are no arguments

      r := False;

    end;

  end else begin

    CreateMutex( nil, False, PChar('QuB'));

  end;

  if r then begin
    Application.Terminate;
    Exit;
  end;

  Application.CreateForm(TQUB_MainForm, QUB_MainForm);
  Console      := QUB_MainForm.Console;
  GraphConsole := QUB_MainForm.GraphConsole;
  Application.CreateForm(TQUB_AboutForm, QUB_AboutForm);
  QUB_AboutForm.OnHide := QUB_MainForm.OnAboutHide;

  if ParamCount = 0 then begin
    QUB_MainForm.ReadParams;
  end;

  QUB_AboutForm.Show;
  QUB_AboutForm.Refresh;

  Application.HintHidePause := 10000;

  Application.Run;

end.

