(*********************************************************************)
(*                                                                   *)
(* This file contains definitions for constants required for some    *)
(* of the NI-DAQ functions.                                          *)
(*                                                                   *)
(* You should use symbols defined here in your programs;  do not     *)
(* use the numerical values.                                         *)
(*                                                                   *)
(* See your NI-DAQ Function Reference Manual for details concerning  *)
(* use of constants defined here.                                    *)
(*                                                                   *)
(*********************************************************************)

CONST	ND_ABOVE_HIGH_LEVEL           	 = 11020;
	ND_ACK_REQ_EXCHANGE_GR1       	 = 11030;
	ND_ACK_REQ_EXCHANGE_GR2       	 = 11035;
	ND_ADC_RESOLUTION             	 = 11040;
	ND_AI_CALDAC_COUNT            	 = 11050;
	ND_AI_CHANNEL_COUNT           	 = 11060;
	ND_AI_FIFO_INTERRUPTS         	 = 11600;
	ND_ANALOG_FILTER              	 = 11065;
	ND_AO48XDC_SET_POWERUP_STATE  	 = 42100;
	ND_AO_CALDAC_COUNT            	 = 11070;
	ND_AO_CHANNEL_COUNT           	 = 11080;
	ND_AO_EXT_REF_CAPABLE         	 = 11090;
	ND_AO_UNIPOLAR_CAPABLE        	 = 11095;
	ND_ARM                        	 = 11100;
	ND_ARMED                      	 = 11200;
	ND_ATC_OUT                    	 = 11250;
	ND_ATTENUATION                	 = 11260;
	ND_AUTOINCREMENT_COUNT        	 = 11300;
	ND_AUTOMATIC                  	 = 11400;
	ND_AVAILABLE_POINTS           	 = 11500;

	ND_BASE_ADDRESS               	 = 12100;
	ND_BELOW_LOW_LEVEL            	 = 12130;
	ND_BOARD_CLOCK                	 = 12170;
	ND_BUFFERED_EVENT_CNT         	 = 12200;
	ND_BUFFERED_PERIOD_MSR        	 = 12300;
	ND_BUFFERED_PULSE_WIDTH_MSR   	 = 12400;
	ND_BUFFERED_SEMI_PERIOD_MSR   	 = 12500;
	ND_BURST                      	 = 12600;
	ND_BURST_INTERVAL             	 = 12700;

	ND_CAL_CONST_AUTO_LOAD        	 = 13050;
	ND_CALIBRATION_FRAME_SIZE     	 = 13060;
	ND_CALIBRATION_FRAME_PTR      	 = 13065;
	ND_CJ_TEMP                    	 = ($8000);
	ND_CLEAN_UP                   	 = 13100;
	ND_CLOCK_REVERSE_MODE_GR1     	 = 13120;
	ND_CLOCK_REVERSE_MODE_GR2     	 = 13130;
	ND_CONFIG_MEMORY_SIZE         	 = 13150;
	ND_CONTINUOUS                 	 = 13160;
	ND_COUNT                      	 = 13200;
	ND_COUNTER_0                  	 = 13300;
	ND_COUNTER_1                  	 = 13400;
	ND_COUNTER_1_SOURCE           	 = 13430;
	ND_COUNT_AVAILABLE            	 = 13450;
	ND_COUNT_DOWN                 	 = 13465;
	ND_COUNT_UP                   	 = 13485;
	ND_COUNT_1                    	 = 13500;
	ND_COUNT_2                    	 = 13600;
	ND_COUNT_3                    	 = 13700;
	ND_COUNT_4                    	 = 13800;
	ND_CURRENT_OUTPUT             	 = 40200;

	ND_DAC_RESOLUTION             	 = 13950;
	ND_DATA_TRANSFER_CONDITION    	 = 13960;
	ND_DATA_XFER_MODE_AI          	 = 14000;
	ND_DATA_XFER_MODE_AO_GR1      	 = 14100;
	ND_DATA_XFER_MODE_AO_GR2      	 = 14200;
	ND_DATA_XFER_MODE_DIO_GR1     	 = 14300;
	ND_DATA_XFER_MODE_DIO_GR2     	 = 14400;
	ND_DATA_XFER_MODE_DIO_GR3     	 = 14500;
	ND_DATA_XFER_MODE_DIO_GR4     	 = 14600;
	ND_DATA_XFER_MODE_DIO_GR5     	 = 14700;
	ND_DATA_XFER_MODE_DIO_GR6     	 = 14800;
	ND_DATA_XFER_MODE_DIO_GR7     	 = 14900;
	ND_DATA_XFER_MODE_DIO_GR8     	 = 15000;
	ND_DATA_XFER_MODE_GPCTR0      	 = 15100;
	ND_DATA_XFER_MODE_GPCTR1      	 = 15200;
	ND_DEVICE_NAME                	 = 15260;
	ND_DEVICE_POWER               	 = 15270;
	ND_DEVICE_SERIAL_NUMBER       	 = 15280;
	ND_DEVICE_TYPE_CODE           	 = 15300;
	ND_DIGITAL_FILTER             	 = 15350;
	ND_DIO128_GET_PORT_THRESHOLD  	 = 41200;
	ND_DIO128_SELECT_INPUT_PORT   	 = 41100;
	ND_DIO128_SET_PORT_THRESHOLD  	 = 41300;
	ND_DISABLED                   	 = 15400;
	ND_DISARM                     	 = 15450;
	ND_DMA_A_LEVEL                	 = 15500;
	ND_DMA_B_LEVEL                	 = 15600;
	ND_DMA_C_LEVEL                	 = 15700;
	ND_DONE                       	 = 15800;
	ND_DONT_CARE                  	 = 15900;
	ND_DONT_KNOW                  	 = 15950;

	ND_EDGE_SENSITIVE             	 = 16000;
	ND_ENABLED                    	 = 16050;
	ND_END                        	 = 16055;
	ND_EXTERNAL                   	 = 16060;
	ND_EXTERNAL_CALIBRATE         	 = 16100;

	ND_FACTORY_CALIBRATION_DATE   	 = 16200;
	ND_FACTORY_CALIBRATION_EQUIP  	 = 16210;
	ND_FACTORY_EEPROM_AREA        	 = 16220;
	ND_FIFO_EMPTY                 	 = 16230;
	ND_FIFO_HALF_FULL_OR_LESS     	 = 16240;
	ND_FIFO_HALF_FULL_OR_LESS_UNTIL_FULL	 = 16245;
	ND_FIFO_NOT_FULL              	 = 16250;
	ND_FIFO_TRANSFER_COUNT        	 = 16260;
	ND_FILTER_CORRECTION_FREQ     	 = 16300;
	ND_FREQ_OUT                   	 = 16400;
	ND_FSK                        	 = 16500;

	ND_GATE                       	 = 17100;
	ND_GATE_POLARITY              	 = 17200;
	ND_GPCTR0_GATE                	 = 17300;
	ND_GPCTR0_OUTPUT              	 = 17400;
	ND_GPCTR0_SOURCE              	 = 17500;
	ND_GPCTR1_GATE                	 = 17600;
	ND_GPCTR1_OUTPUT              	 = 17700;
	ND_GPCTR1_SOURCE              	 = 17800;
	ND_GROUND_DAC_REFERENCE       	 = 17900;

	ND_HARDWARE                   	 = 18000;
	ND_HIGH                       	 = 18050;
	ND_HIGH_HYSTERESIS            	 = 18080;
	ND_HIGH_TO_LOW                	 = 18100;
	ND_HW_ANALOG_TRIGGER          	 = 18900;

	ND_IMPEDANCE                  	 = 19000;
	ND_INITIAL_COUNT              	 = 19100;
	ND_INIT_PLUGPLAY_DEVICES      	 = 19110;
	ND_INSIDE_REGION              	 = 19150;
	ND_INTERNAL                   	 = 19160;
	ND_INTERNAL_100_KHZ           	 = 19200;
	ND_INTERNAL_10_MHZ            	 = 19300;
	ND_INTERNAL_1250_KHZ          	 = 19320;
	ND_INTERNAL_20_MHZ            	 = 19400;
	ND_INTERNAL_2500_KHZ          	 = 19420;
	ND_INTERNAL_7160_KHZ          	 = 19460;
	ND_INTERNAL_TIMER             	 = 19500;
	ND_INTERRUPTS                 	 = 19600;
	ND_INTERRUPT_A_LEVEL          	 = 19700;
	ND_INTERRUPT_B_LEVEL          	 = 19800;
	ND_INTERRUPT_TRIGGER_MODE     	 = 19850;
	ND_IN_CHANNEL_CLOCK_TIMEBASE  	 = 19900;
	ND_IN_CHANNEL_CLOCK_TB_POL    	 = 20000;
	ND_IN_CONVERT                 	 = 20100;
	ND_IN_CONVERT_POL             	 = 20200;
	ND_IN_DATA_FIFO_SIZE          	 = 20250;
	ND_IN_EXTERNAL_GATE           	 = 20300;
	ND_IN_EXTERNAL_GATE_POL       	 = 20400;
	ND_IN_SCAN_CLOCK_TIMEBASE     	 = 20500;
	ND_IN_SCAN_CLOCK_TB_POL       	 = 20600;
	ND_IN_SCAN_IN_PROG            	 = 20650;
	ND_IN_SCAN_START              	 = 20700;
	ND_IN_SCAN_START_POL          	 = 20800;
	ND_IN_START_TRIGGER           	 = 20900;
	ND_IN_START_TRIGGER_POL       	 = 21000;
	ND_IN_STOP_TRIGGER            	 = 21100;
	ND_IN_STOP_TRIGGER_POL        	 = 21200;
	ND_INTERRUPT_EVERY_SAMPLE     	 = 11700;
	ND_INTERRUPT_HALF_FIFO        	 = 11800;
	ND_IO_CONNECTOR               	 = 21300;

	ND_LEVEL_SENSITIVE            	 = 24000;
	ND_LINK_COMPLETE_INTERRUPTS   	 = 24010;
	ND_LOW                        	 = 24050;
	ND_LOW_HYSTERESIS             	 = 24080;
	ND_LOW_TO_HIGH                	 = 24100;
	ND_LPT_DEVICE_MODE            	 = 24200;

	ND_MARKER                     	 = 24500;
	ND_MEMORY_TRANSFER_WIDTH      	 = 24600;

	ND_NEGATIVE                   	 = 26100;
	ND_NEW                        	 = 26190;
	ND_NI_DAQ_SW_AREA             	 = 26195;
	ND_NO                         	 = 26200;
	ND_NO_STRAIN_GAUGE            	 = 26225;
	ND_NO_TRACK_AND_HOLD          	 = 26250;
	ND_NONE                       	 = 26300;
	ND_NOT_APPLICABLE             	 = 26400;
	ND_NUMBER_DIG_PORTS           	 = 26500;

	ND_OFF                        	 = 27010;
	ND_OFFSET                     	 = 27020;
	ND_ON                         	 = 27050;
	ND_OTHER                      	 = 27060;
	ND_OTHER_GPCTR_OUTPUT         	 = 27300;
	ND_OTHER_GPCTR_TC             	 = 27400;
	ND_OUT_DATA_FIFO_SIZE         	 = 27070;
	ND_OUT_EXTERNAL_GATE          	 = 27080;
	ND_OUT_EXTERNAL_GATE_POL      	 = 27082;
	ND_OUT_START_TRIGGER          	 = 27100;
	ND_OUT_START_TRIGGER_POL      	 = 27102;
	ND_OUT_UPDATE                 	 = 27200;
	ND_OUT_UPDATE_POL             	 = 27202;
	ND_OUT_UPDATE_CLOCK_TIMEBASE  	 = 27210;
	ND_OUT_UPDATE_CLOCK_TB_POL    	 = 27212;
	ND_OUTPUT_ENABLE              	 = 27220;
	ND_OUTPUT_MODE                	 = 27230;
	ND_OUTPUT_POLARITY            	 = 27240;
	ND_OUTPUT_STATE               	 = 27250;
	ND_OUTPUT_TYPE                	 = 40000;

	ND_PAUSE                      	 = 28040;
	ND_PAUSE_ON_HIGH              	 = 28045;
	ND_PAUSE_ON_LOW               	 = 28050;
	ND_PFI_0                      	 = 28100;
	ND_PFI_1                      	 = 28200;
	ND_PFI_2                      	 = 28300;
	ND_PFI_3                      	 = 28400;
	ND_PFI_4                      	 = 28500;
	ND_PFI_5                      	 = 28600;
	ND_PFI_6                      	 = 28700;
	ND_PFI_7                      	 = 28800;
	ND_PFI_8                      	 = 28900;
	ND_PFI_9                      	 = 29000;
	ND_PLL_REF_FREQ               	 = 29010;
	ND_PLL_REF_SOURCE             	 = 29020;
	ND_PRE_ARM                    	 = 29050;
	ND_POSITIVE                   	 = 29100;
	ND_PREPARE                    	 = 29200;
	ND_PROGRAM                    	 = 29300;
	ND_PULSE                      	 = 29350;
	ND_PULSE_SOURCE               	 = 29500;
	ND_PULSE_TRAIN_GNR            	 = 29600;

	ND_REGLITCH                   	 = 31000;
	ND_RESERVED                   	 = 31100;
	ND_RESET                      	 = 31200;
	ND_RESUME                     	 = 31250;
	ND_RETRIG_PULSE_GNR           	 = 31300;
	ND_REVISION                   	 = 31350;
	ND_RTSI_0                     	 = 31400;
	ND_RTSI_1                     	 = 31500;
	ND_RTSI_2                     	 = 31600;
	ND_RTSI_3                     	 = 31700;
	ND_RTSI_4                     	 = 31800;
	ND_RTSI_5                     	 = 31900;
	ND_RTSI_6                     	 = 32000;
	ND_RTSI_CLOCK                 	 = 32100;

	ND_SC_2040_MODE               	 = 32500;
	ND_SC_2043_MODE               	 = 32600;
	ND_SELF_CALIBRATE             	 = 32700;
	ND_SET_DEFAULT_LOAD_AREA      	 = 32800;
	ND_SIMPLE_EVENT_CNT           	 = 33100;
	ND_SINGLE                     	 = 33150;
	ND_SINGLE_PERIOD_MSR          	 = 33200;
	ND_SINGLE_PULSE_GNR           	 = 33300;
	ND_SINGLE_PULSE_WIDTH_MSR     	 = 33400;
	ND_SINGLE_TRIG_PULSE_GNR      	 = 33500;
	ND_SOFTWARE                   	 = 33600;
	ND_SOURCE                     	 = 33700;
	ND_SOURCE_POLARITY            	 = 33800;
	ND_STEPPED                    	 = 33825;
	ND_STRAIN_GAUGE               	 = 33850;
	ND_STRAIN_GAUGE_EX0           	 = 33875;
	ND_SUB_REVISION               	 = 33900;
	ND_SYNC_DUTY_CYCLE_HIGH       	 = 33930;
	ND_SYNC_OUT                   	 = 33970;

	ND_TC_REACHED                 	 = 34100;
	ND_THE_AI_CHANNEL             	 = 34400;
	ND_TOGGLE                     	 = 34700;
	ND_TOGGLE_GATE                	 = 34800;
	ND_TRACK_AND_HOLD             	 = 34850;
	ND_TRIG_PULSE_WIDTH_MSR       	 = 34900;
	ND_TRIGGER_SOURCE             	 = 34930;
	ND_TRIGGER_MODE               	 = 34970;

	ND_UI2_TC                     	 = 35100;
	ND_UP_DOWN                    	 = 35150;
	ND_UP_TO_1_DMA_CHANNEL        	 = 35200;
	ND_UP_TO_2_DMA_CHANNELS       	 = 35300;
	ND_USE_CAL_CHAN               	 = 36000;
	ND_USE_AUX_CHAN               	 = 36100;
	ND_USER_EEPROM_AREA           	 = 37000;
	ND_USER_EEPROM_AREA_2         	 = 37010;
	ND_USER_EEPROM_AREA_3         	 = 37020;
	ND_USER_EEPROM_AREA_4         	 = 37030;
	ND_USER_EEPROM_AREA_5         	 = 37040;

	ND_VOLTAGE_OUTPUT             	 = 40100;
	ND_VOLTAGE_REFERENCE          	 = 38000;

	ND_VXI_SC                     	 = ($2000);
	ND_VXIMIO_SET_ALLOCATE_MODE   	 = 43100;
	ND_VXIMIO_USE_ONBOARD_MEMORY_AI	 = 43500;
	ND_VXIMIO_USE_ONBOARD_MEMORY_AO	 = 43600;
	ND_VXIMIO_USE_ONBOARD_MEMORY_GPCTR	 = 43700;
	ND_VXIMIO_USE_PC_MEMORY_AI    	 = 43200;
	ND_VXIMIO_USE_PC_MEMORY_AO    	 = 43300;
	ND_VXIMIO_USE_PC_MEMORY_GPCTR 	 = 43400;

	ND_YES                        	 = 39100;

