unit nidaqmx_types;


interface


uses


AllocTypes;


type


TtaskHandle = LongWord;


const


DAQmx_Val_Volts                        = 10348;

DAQmx_Val_GroupByChannel               = 0;// Group by Channel
DAQmx_Val_GroupByScanNumber            = 1;// Group by Scan Number

//*** Value for the Terminal Config parameter of DAQmxCreateAIVoltageChan, DAQmxCreateAICurrentChan and DAQmxCreateAIVoltageChanWithExcit ***
DAQmx_Val_Cfg_Default                  = -1;// Default

//*** Value set for the ActiveEdge parameter of DAQmxCfgSampClkTiming ***
DAQmx_Val_Rising                       = 10280; // Rising
DAQmx_Val_Falling                      = 10171; // Falling

//*** Values for DAQmx_SampQuant_SampMode ***
//*** Value set AcquisitionType ***
DAQmx_Val_FiniteSamps                  = 10178; // Finite Samples
DAQmx_Val_ContSamps                    = 10123; // Continuous Samples
DAQmx_Val_HWTimedSinglePoint           = 12522; // Hardware Timed Single Point
              

type


//All these functions available in 'nicaiu.dll'


//Task
TDAQmxCreateTask                       = function (const taskName :PChar; var taskHandle :TtaskHandle) :LongInt; stdcall;
TDAQmxClearTask                        = function (taskHandle :TtaskHandle) :LongInt; stdcall;
TDAQmxStartTask                        = function (taskHandle :TtaskHandle) :LongInt; stdcall;
TDAQmxStopTask                         = function (taskHandle :TtaskHandle) :LongInt; stdcall;

//Channels
TDAQmxCreateAIVoltageChan              = function (taskHandle :TtaskHandle; const physicalChannel, nameToAssignToChannel :PChar; terminalConfig :LongInt; minVal, maxVal :Double; units :LongInt; const customScaleName :PChar) :LongInt; stdcall;
TDAQmxCreateAOVoltageChan              = function (taskHandle :TtaskHandle; const physicalChannel, nameToAssignToChannel :PChar; minVal, maxVal :Double; units :LongInt; const customScaleName :PChar) :LongInt; stdcall;

TDAQmxGetAIResolutionUnits             = function (taskHandle :TtaskHandle; const channel :PChar; var data :LongInt) :LongInt; stdcall;
TDAQmxGetAIResolution                  = function (taskHandle :TtaskHandle; const channel :PChar; var data :Double) :LongInt; stdcall;
TDAQmxGetAOResolutionUnits             = function (taskHandle :TtaskHandle; const channel :PChar; var data :LongInt) :LongInt; stdcall;
TDAQmxGetAOResolution                  = function (taskHandle :TtaskHandle; const channel :PChar; var data :Double) :LongInt; stdcall;
TDAQmxGetAIRngHigh                     = function (taskHandle :TtaskHandle; const channel :PChar; var data :Double) :LongInt; stdcall;
TDAQmxGetAIRngLow                      = function (taskHandle :TtaskHandle; const channel :PChar; var data :Double) :LongInt; stdcall;
TDAQmxGetAODACRngHigh                  = function (taskHandle :TtaskHandle; const channel :PChar; var data :Double) :LongInt; stdcall;
TDAQmxGetAODACRngLow                   = function (taskHandle :TtaskHandle; const channel :PChar; var data :Double) :LongInt; stdcall;

//Error
TDAQmxGetErrorString                   = function (errorCode :LongInt; errorString :PChar; bufferSize :LongWord) :LongInt; stdcall;
TDAQmxGetExtendedErrorInfo             = function (errorString :PChar; bufferSize :LongWord) :LongInt; stdcall;

//Write
TDAQmxWriteBinaryI16                   = function (taskHandle :TtaskHandle; numSampsPerChan :LongInt; autoStart :LongBool; timeout :Double; dataLayout :LongInt; writeArray :TPASmallInt; var sampsPerChanWritten :LongInt; Reserved :Pointer) :LongInt; stdcall;
TDAQmxWriteRaw                         = function (taskHandle :TtaskHandle; numSamps :LongInt; autoStart :LongBool; timeout :Double; writeArray :Pointer; var sampsPerChanWritten :LongInt; Reserved :Pointer) :LongInt; stdcall;

//Read
TDAQmxReadAnalogF64                    = function (taskHandle :TtaskHandle; numSampsPerChan :LongInt; timeout :Double; fillMode :LongInt; readArray :TPADouble; arraySizeInSamps :LongWord; var sampsPerChanRead :LongInt; Reserved :Pointer) :LongInt; stdcall;
TDAQmxReadBinaryI16                    = function (taskHandle :TtaskHandle; numSampsPerChan :LongInt; timeout :Double; fillMode :LongInt; readArray :TPASmallInt; arraySizeInSamps :LongWord; var sampsPerChanRead :LongInt; Reserved :Pointer) :LongInt; stdcall;
TDAQmxReadRaw                          = function (taskHandle :TtaskHandle; numSampsPerChan :LongInt; timeout :Double; readArray :Pointer; arraySizeInBytes :LongWord; var sampsRead :LongInt; var numBytesPerSamp :LongInt; Reserved :Pointer) :LongInt; stdcall;

//Timing
TDAQmxCfgSampClkTiming                 = function (taskHandle :TtaskHandle; const source :PChar; rate :Double; activeEdge :LongInt; sampleMode :LongInt; sampsPerChan :{u}Int64) :LongInt; stdcall;


//int32 DllExport __CFUNC     DAQmxClearTask            (TaskHandle taskHandle);
//int32 DllExport __CFUNC     DAQmxCreateTask           (const char taskName[], TaskHandle *taskHandle);

//int32 DllExport __CFUNC     DAQmxStartTask            (TaskHandle taskHandle);
//int32 DllExport __CFUNC     DAQmxStopTask             (TaskHandle taskHandle);

//int32 DllExport __CFUNC     DAQmxGetErrorString       (int32 errorCode, char errorString[], uInt32 bufferSize);
//int32 DllExport __CFUNC     DAQmxGetExtendedErrorInfo (char errorString[], uInt32 bufferSize);

//int32 DllExport __CFUNC     DAQmxCreateAIVoltageChan          (TaskHandle taskHandle, const char physicalChannel[], const char nameToAssignToChannel[], int32 terminalConfig, float64 minVal, float64 maxVal, int32 units, const char customScaleName[]);
//int32 DllExport __CFUNC     DAQmxCreateAOVoltageChan  (TaskHandle taskHandle, const char physicalChannel[], const char nameToAssignToChannel[], float64 minVal, float64 maxVal, int32 units, const char customScaleName[]);

//int32 DllExport __CFUNC DAQmxGetAIResolutionUnits(TaskHandle taskHandle, const char channel[], int32 *data);
//int32 DllExport __CFUNC DAQmxGetAIResolution(TaskHandle taskHandle, const char channel[], float64 *data);
//int32 DllExport __CFUNC DAQmxGetAOResolutionUnits(TaskHandle taskHandle, const char channel[], int32 *data);
//int32 DllExport __CFUNC DAQmxGetAOResolution(TaskHandle taskHandle, const char channel[], float64 *data);
//int32 DllExport __CFUNC DAQmxGetAIRngHigh(TaskHandle taskHandle, const char channel[], float64 *data);
//int32 DllExport __CFUNC DAQmxGetAIRngLow(TaskHandle taskHandle, const char channel[], float64 *data);
//int32 DllExport __CFUNC DAQmxGetAODACRngHigh(TaskHandle taskHandle, const char channel[], float64 *data);
//int32 DllExport __CFUNC DAQmxGetAODACRngLow(TaskHandle taskHandle, const char channel[], float64 *data);

//int32 DllExport __CFUNC     DAQmxReadAnalogF64         (TaskHandle taskHandle, int32 numSampsPerChan, float64 timeout, bool32 fillMode, float64 readArray[], uInt32 arraySizeInSamps, int32 *sampsPerChanRead, bool32 *reserved);
//int32 DllExport __CFUNC     DAQmxReadBinaryI16        (TaskHandle taskHandle, int32 numSampsPerChan, float64 timeout, bool32 fillMode, int16 readArray[], uInt32 arraySizeInSamps, int32 *sampsPerChanRead, bool32 *reserved);
//int32 DllExport __CFUNC     DAQmxReadRaw              (TaskHandle taskHandle, int32 numSampsPerChan, float64 timeout, void *readArray, uInt32 arraySizeInBytes, int32 *sampsRead, int32 *numBytesPerSamp, bool32 *reserved);

//int32 DllExport __CFUNC     DAQmxWriteBinaryI16       (TaskHandle taskHandle, int32 numSampsPerChan, bool32 autoStart, float64 timeout, bool32 dataLayout, int16 writeArray[], int32 *sampsPerChanWritten, bool32 *reserved);
//int32 DllExport __CFUNC     DAQmxWriteRaw             (TaskHandle taskHandle, int32 numSamps, bool32 autoStart, float64 timeout, void *writeArray, int32 *sampsPerChanWritten, bool32 *reserved);

//int32 DllExport __CFUNC     DAQmxCfgSampClkTiming          (TaskHandle taskHandle, const char source[], float64 rate, int32 activeEdge, int32 sampleMode, uInt64 sampsPerChan);


implementation


end.
