import traceback


Items = {}        # maps item name to item function(results, context)
ItemsForType = {} # maps ResultType to list of item names

#known types include SKM, AMP, MIL, MPL, ChopIdl, Stat, IV, HalfAmp, IdlBase, MSearch

def Add(name, item, resultTypes=[]):
    Items[name] = item
    for type in resultTypes:
        if not ItemsForType.has_key(type):
            ItemsForType[type] = []
        if not (name in ItemsForType[type]):
            ItemsForType[type].append(name)

def ListItems(type):
    try:
        return ItemsForType[type]
    except:
        traceback.print_exc()
        return []

def RunOne(name, results, context):
    try:
        Items[name](results, context)
    except Exception, msg:
        print name, ':'
        traceback.print_exc()

class Context:
    pass

def RunList(names, results):
    context = Context()
    for name in names:
        RunOne(name, results, context)
