# Call delphi func to ompute a least squares fit of the selected data then set
# 3 baseline nodes on the line at x=0, selection start and selection end.
#import os
#import os.path
#import re
#import string
#import qubtree
#import QUB
from Buttons import *

def SearchDataNotes(path, pattern, isRegexp, subfolders):
    repattern = re.compile(pattern)
    for root, dirs, files in os.walk(path):
        if not subfolders:
            del dirs[:]
        for name in [fname for fname in files if re.search('.qsf$', fname)]:
            sess = qubtree.Open(name, 1)
            notes = str(sess.find('Comment').data)
            name = name[:len(name)-4] + str(sess.find('FileExt').data)
            del sess

            if (isRegexp and repattern.search(notes)
            or (notes.find(pattern) >= 0)):
                yield root + name


def ReportDataNotes(props):
    path = props['path']
    pattern = props['pattern']
    isRegexp = props['isRegexp'] == 'yes'
    subfolders = props['subfolders'] == 'yes'

    QUB.Report('Searching for data notes containing "' + pattern + '" ...')

    for fname in SearchDataNotes(path, pattern, isRegexp, subfolders):
        QUB.Report(' > ' + fname)

    QUB.Report('... done searching')        


AddTaskButton( 'ArtNode', AddArthurNode, 'ANode', 1, 1,
                      'Add baseline node for fit line', '',
                      'No properties',
                      [],
                      'Preprocessing ')
