"""Implements menuitem Send to -> QtiPlot.  This script is executed inside QtiPlot.
Do not edit this file -- it may be replaced by QuB Upgrade.  Instead, make a copy,
and it will be a separate option in the Send To menu.
"""

import numpy
from numpy import *

def add_data_plot(title, xlabel, ylabel, plot_ser, xser, ysers):
    """Adds a Table and Graph (line plot).

    @param title: name for the table and graph
    @param xlabel: label for the x axis
    @param ylabel: label for the y axis
    @param plot_ser: index of y series to plot
    @param xser: array of x coordinates (each point)
    @param ysers: array of array of y coordinates
"""
    t = newTable(title, len(xser), len(ysers)+1)
    t.setColData(1, xser, 0)
    for i, y in enumerate(ysers):
        t.setColData(2+i, y, 0)
    g = newGraph()
    l = g.activeLayer()
    l.addCurves(t, (plot_ser+2,), Layer.Line)
    l.setAntialiasing()
    l.setTitle(title)
    l.enableAxis(Layer.Bottom, True)
    l.setAxisTitle(Layer.Bottom, xlabel)
    l.enableAxis(Layer.Left, True)
    l.setAxisTitle(Layer.Left, ylabel)

