RequestExecutionLevel admin
Name QuB
OutFile QuB-Install-2-0-0-33.exe
CRCCheck on
ComponentText "This will install QuB on your computer."
InstType /COMPONENTSONLYONCUSTOM
InstType QuB
InstType "QuB without file associations"
DirText "Please select a location to install QuB (or use the default)."

InstallDir "$PROGRAMFILES\QuB"
InstallDirRegKey HKEY_LOCAL_MACHINE SOFTWARE\QUB "Install_Dir"

Section "QuB Program"
SectionIn 1
SectionIn 2
SetShellVarContext all
SetOutPath $INSTDIR
SetOverwrite try
SetCompress auto

WriteRegDWord HKEY_LOCAL_MACHINE SOFTWARE\QUB "Installed_Version_Num" 2
WriteRegDWord HKEY_LOCAL_MACHINE SOFTWARE\QUB "Installed_Version_Pt"  0
WriteRegDWord HKEY_LOCAL_MACHINE SOFTWARE\QUB "Installed_Version_Sub" 0
WriteRegDWord HKEY_LOCAL_MACHINE SOFTWARE\QUB "Installed_Version_Rev" 33

SetOutPath "$STARTMENU\Programs\QuB"
File "About QuB.txt"

SetOutPath $INSTDIR

File kinopt.dll
File maxill.dll
File qubaxo.dll
File qubacqni.dll
File qubacqnm.dll
File qubacqsc.dll
File qubacqdx.dll
File qublib.dll
File qubopt.dll
Delete qubtree.pyd
File qubtree.dll
File _qubtree.pyd
File qubfits.dll
File _qubfits.pyd

File msearch-models.qtr

File "one pulse.kin"
File "test wave.kin"

File qub.exe
File qubhelp.hlp
File qubhelp.cnt
File qubnews.txt
File LICENSE.txt

File msvcp60.dll
File msvcp71.dll
File msvcr71.dll
File vcomp90.dll
File libgsl-0.dll
File libgslcblas-0.dll
File Abffio.dll
File acquirefile.dll
File cvodelib.dll
File python25.zip
File Python25.dll
File pywintypes25.dll
File pythoncom25.dll

File QUBB.py
File /r /x .svn site-packages
File "python25\DLLs\*.pyd"
File "python25\DLLs\*.dll"

File qtiplot_start_remote_ctl.py
File qtiplot_remote_ctl.py
File remote_ctl.py

CreateShortCut "$STARTMENU\Programs\QuB\qub.lnk" "$INSTDIR\qub.exe" "" "" 0
CreateShortCut "$DESKTOP\QuB.lnk" "$INSTDIR\qub.exe" "" "" 0

SetOutPath "$INSTDIR\qubacqctl"
File "..\qubacqctl\Release\*.exe"

SetOutPath "$INSTDIR\QtiPlotScripts\Histogram"
File "QtiPlotScripts\Histogram\QtiPlot.py"
SetOutPath "$INSTDIR\QtiPlotScripts\Scatter"
File "QtiPlotScripts\Scatter\QtiPlot.py"
SetOutPath "$INSTDIR\QtiPlotScripts\Trace"
File "QtiPlotScripts\Trace\QtiPlot.py"

Delete "$INSTDIR\PythonScripts\*.pyc"

SetOutPath "$INSTDIR\PythonScripts"
File "PythonScripts\qubtree.py"
File "PythonScripts\AcquisitionProtocol.py"
File "PythonScripts\AdvancedMIL.py"
File "PythonScripts\Buttons.py"
File "PythonScripts\Commands.py"
File "PythonScripts\CurveFitting.py"
File "PythonScripts\Dialogs.py"
File "PythonScripts\ExpoFit.py"
File "PythonScripts\ExpoPlusCFit.py"
File "PythonScripts\FuzzyFit.py"
File "PythonScripts\QUBFuzzyFit.py"
File "PythonScripts\GaussFit.py"
File "PythonScripts\HistogramCommands.py"
File "PythonScripts\IdlToList.py"
File "PythonScripts\LinReg.py"
File "PythonScripts\ListStim.py"
File "PythonScripts\LogExpoFit.py"
File "PythonScripts\LorentzFit.py"
File "PythonScripts\ModelBuilder.py"
File "PythonScripts\Reports.py"
File "PythonScripts\ResultsCommands.py"
File "PythonScripts\SelectCommands.py"
File "PythonScripts\SelectKMeans.py"
File "PythonScripts\SearchDataNotes.py"
File "PythonScripts\WordReport.py"
File "PythonScripts\ModelReport.py"
File "PythonScripts\ExcelReport.py"
File "PythonScripts\Correlation.py"
File "PythonScripts\Classify.py"
File "PythonScripts\Stability.py"
File "PythonScripts\HistogramExcel.py"

SetOutPath "$INSTDIR\ProtocolShapes"
File "ProtocolShapes\Hold.bmp"
File "ProtocolShapes\Step.bmp"
File "ProtocolShapes\Ramp.bmp"
File "ProtocolShapes\Sine.bmp"

SetOutPath "$INSTDIR\Sample Protocols"
File "Sample Protocols\conditioning ladder.qpf"
File "Sample Protocols\conditioning time ladder.qpf"
File "Sample Protocols\conditioning recovery time.qpf"
File "Sample Protocols\voltage ladder.qpf"
File "Sample Protocols\voltage ramp.qpf"
File "Sample Protocols\white noise.qpf"
File "Sample Protocols\voltage dependent capacitance.qpf"

SetOutPath "$INSTDIR\Reports\MIL"
File "Reports\MIL\MIL Word Report.txt"
File "Reports\MIL\Excel Histograms.txt"

SetOutPath "$INSTDIR\Reports\MIP"
File "Reports\MIP\MIP Word Report.txt"

SetOutPath "$INSTDIR\Reports\MdlRpt"
File "Reports\MdlRpt\word - with dead time.txt"
File "Reports\MdlRpt\word - no dead time.txt"
File "Reports\MdlRpt\word - both.txt"

SetOutPath "$INSTDIR\Reports\Mac"
File "Reports\Mac\ExcelRow.txt"
File "Reports\Mac\ExcelCol.txt"
File "Reports\Mac\Model with Table.txt"

SetOutPath "$INSTDIR\Reports\SKM"
File "Reports\SKM\SKM Report.txt"

SetOutPath "$INSTDIR\Reports\MSearch"
File "Reports\MSearch\Model Search Top 10.txt"

SetOutPath "$INSTDIR\Reports\Prtb"
File "Reports\Prtb\Top 10.txt"

SetOutPath "$INSTDIR\Curve Plugins"
File "Curve Plugins\qubcurves.dll"
File "Curve Plugins\customcurve.dll"

SetOutPath "$INSTDIR\Profiles\Fitter-HistogramA"
File "Profiles\Fitter-HistogramA\__active.qpr"
SetOutPath "$INSTDIR\Profiles\Fitter-HistogramF"
File "Profiles\Fitter-HistogramF\__active.qpr"
SetOutPath "$INSTDIR\Profiles\Fitter-HistogramD"
File "Profiles\Fitter-HistogramD\__active.qpr"
SetOutPath "$INSTDIR\Profiles\Fitter-HistogramR"
File "Profiles\Fitter-HistogramR\__active.qpr"
SetOutPath "$INSTDIR\Profiles\Fitter-Overlap"
File "Profiles\Fitter-Overlap\__active.qpr"
SetOutPath "$INSTDIR\Profiles\Fitter-QVT"
File "Profiles\Fitter-QVT\__active.qpr"
SetOutPath "$INSTDIR\Profiles\Fitter-Select"
File "Profiles\Fitter-Select\__active.qpr"
SetOutPath "$INSTDIR\Profiles\Fitter-Select2"
File "Profiles\Fitter-Select2\__active.qpr"

SetOutPath "$INSTDIR\Profiles\Amp"
File "Profiles\Amp\Default.qpr"
SetOutPath "$INSTDIR\Profiles\Base"
File "Profiles\Base\Default.qpr"
SetOutPath "$INSTDIR\Profiles\Bkg-"
File "Profiles\Bkg-\Single Channel.qpr"
File "Profiles\Bkg-\Whole Cell.qpr"
SetOutPath "$INSTDIR\Profiles\ChpIdl"
File "Profiles\ChpIdl\Default.qpr"
SetOutPath "$INSTDIR\Profiles\CopyData"
File "Profiles\CopyData\Default.qpr"
File "Profiles\CopyData\Hi-Res.qpr"
File "Profiles\CopyData\Lo-Res.qpr"
SetOutPath "$INSTDIR\Profiles\CopyModel"
File "Profiles\CopyModel\Default.qpr"
File "Profiles\CopyModel\Hi-Res.qpr"
File "Profiles\CopyModel\Lo-Res.qpr"
SetOutPath "$INSTDIR\Profiles\dWAV"
File "Profiles\dWAV\Default.qpr"
SetOutPath "$INSTDIR\Profiles\Exp"
File "Profiles\Exp\Default.qpr"
SetOutPath "$INSTDIR\Profiles\Ext"
File "Profiles\Ext\Default.qpr"
SetOutPath "$INSTDIR\Profiles\HistogramAmp"
File "Profiles\HistogramAmp\Default.qpr"
SetOutPath "$INSTDIR\Profiles\HistogramDur"
File "Profiles\HistogramDur\Default.qpr"
SetOutPath "$INSTDIR\Profiles\HistogramFFT"
File "Profiles\HistogramFFT\Default.qpr"
SetOutPath "$INSTDIR\Profiles\IB"
File "Profiles\IB\Default.qpr"
SetOutPath "$INSTDIR\Profiles\Idl"
File "Profiles\Idl\Default.qpr"
SetOutPath "$INSTDIR\Profiles\IdlCnd"
File "Profiles\IdlCnd\Default.qpr"
SetOutPath "$INSTDIR\Profiles\Mac"
File "Profiles\Mac\Default.qpr"
SetOutPath "$INSTDIR\Profiles\MdlRpt"
File "Profiles\MdlRpt\Default.qpr"
SetOutPath "$INSTDIR\Profiles\MIL"
File "Profiles\MIL\Default.qpr"
SetOutPath "$INSTDIR\Profiles\MIP"
File "Profiles\MIP\Default.qpr"
SetOutPath "$INSTDIR\Profiles\MPL"
File "Profiles\MPL\Default.qpr"
SetOutPath "$INSTDIR\Profiles\msrch"
File "Profiles\msrch\Default.qpr"
SetOutPath "$INSTDIR\Profiles\Sim"
File "Profiles\Sim\Default.qpr"
SetOutPath "$INSTDIR\Profiles\Stair"
File "Profiles\Stair\Default.qpr"
SetOutPath "$INSTDIR\Profiles\Stat"
File "Profiles\Stat\Default.qpr"

SetOutPath "$INSTDIR\Profiles\QVM"
File "Profiles\Stat\Default.qpr"
SetOutPath "$INSTDIR\Profiles\QVD"
File "Profiles\Stat\Default.qpr"


WriteRegStr HKEY_CLASSES_ROOT ".mdl" "" "QuB.MDLFile"
WriteRegStr HKEY_CLASSES_ROOT "QuB.MDLFile" "" "QuB Model File"
WriteRegStr HKEY_CLASSES_ROOT "QuB.MDLFile\shell" "" "open"
WriteRegStr HKEY_CLASSES_ROOT "QuB.MDLFile\shell\open\command" "" '$INSTDIR\qub.exe -om "%1"'

WriteRegStr HKEY_CLASSES_ROOT ".ldt" "" "QuB.LDTFile"
WriteRegStr HKEY_CLASSES_ROOT "QuB.LDTFile" "" "QuB LDT File"
WriteRegStr HKEY_CLASSES_ROOT "QuB.LDTFile\shell" "" "open"
WriteRegStr HKEY_CLASSES_ROOT "QuB.LDTFile\shell\open\command" "" '$INSTDIR\qub.exe -od "%1"'

WriteRegStr HKEY_CLASSES_ROOT ".dwt" "" "QuB.DWTFile"
WriteRegStr HKEY_CLASSES_ROOT "QuB.DWTFile" "" "QuB DWT File"
WriteRegStr HKEY_CLASSES_ROOT "QuB.DWTFile\shell" "" "open"
WriteRegStr HKEY_CLASSES_ROOT "QuB.DWTFile\shell\open\command" "" '$INSTDIR\qub.exe -od "%1"'

WriteRegStr HKEY_CLASSES_ROOT ".qmf" "" "QuB.QMFFile"
WriteRegStr HKEY_CLASSES_ROOT "QuB.QMFFile" "" "QuB Model File"
WriteRegStr HKEY_CLASSES_ROOT "QuB.QMFFile\shell" "" "open"
WriteRegStr HKEY_CLASSES_ROOT "QuB.QMFFile\shell\open\command" "" '$INSTDIR\qub.exe -om "%1"'

!ifndef NO_UNINST
WriteUninstaller "$INSTDIR\uninst-qub.exe"
CreateShortCut "$STARTMENU\Programs\QuB\Uninstall QuB.lnk" "$INSTDIR\uninst-qub.exe" "" "" 0
!endif

SectionEnd

Section "Register File Types"
SectionIn 1
SetShellVarContext all

ReadRegStr $R0 HKEY_CLASSES_ROOT ".dat" ""
StrCmp $R0 "" SKIPDATBK DATBK
DATBK:
StrCmp $R0 "QuB.DATFile" SKIPDATBK REALDATBK
REALDATBK:
WriteRegStr HKEY_CLASSES_ROOT ".dat" "bk" "$R0"
SKIPDATBK:
WriteRegStr HKEY_CLASSES_ROOT ".dat" "" "QuB.DATFile"
WriteRegStr HKEY_CLASSES_ROOT "QuB.DATFile" "" "QuB DAT File"
WriteRegStr HKEY_CLASSES_ROOT "QuB.DATFile\shell" "" "open"
WriteRegStr HKEY_CLASSES_ROOT "QuB.DATFile\shell\open\command" "" '$INSTDIR\qub.exe -od "%1"'

ReadRegStr $R0 HKEY_CLASSES_ROOT ".abf" ""
StrCmp $R0 "" SKIPABFBK ABFBK
ABFBK:
StrCmp $R0 "QuB.ABFFile" SKIPABFBK REALABFBK
REALABFBK:
WriteRegStr HKEY_CLASSES_ROOT ".abf" "bk" "$R0"
SKIPABFBK:
WriteRegStr HKEY_CLASSES_ROOT ".abf" "" "QuB.ABFFile"
WriteRegStr HKEY_CLASSES_ROOT "QuB.ABFFile" "" "ABF File"
WriteRegStr HKEY_CLASSES_ROOT "QuB.ABFFile\shell" "" "open"
WriteRegStr HKEY_CLASSES_ROOT "QuB.ABFFile\shell\open\command" "" '$INSTDIR\qub.exe -od "%1"'

SectionEnd

Section "Finish Installing"
SectionIn 1
SectionIn 2

SectionEnd

!ifndef NO_UNINST
UninstallText "This will remove QuB from your system:"

Section Uninstall
SetShellVarContext all

ReadRegStr $R0 HKEY_CLASSES_ROOT ".dat" ""
StrCmp $R0 "QuB.DATFile" REVDAT IGNDAT
REVDAT:
ReadRegStr $R0 HKEY_CLASSES_ROOT ".dat" "bk"
DeleteRegKey HKEY_CLASSES_ROOT ".dat"
StrCmp $R0 "" IGNDAT REDAT
REDAT:
WriteRegStr HKEY_CLASSES_ROOT ".dat" "" "$R0"
IGNDAT:

ReadRegStr $R0 HKEY_CLASSES_ROOT ".abf" ""
StrCmp $R0 "QuB.ABFFile" REVABF IGNABF
REVABF:
ReadRegStr $R0 HKEY_CLASSES_ROOT ".abf" "bk"
DeleteRegKey HKEY_CLASSES_ROOT ".abf"
StrCmp $R0 "" IGNABF REABF
REABF:
WriteRegStr HKEY_CLASSES_ROOT ".abf" "" "$R0"
IGNABF:

RMDir /r $INSTDIR
RMDIR /r $STARTMENU\Programs\QuB
RmDir /r "$APPDATA\QuB"

DeleteRegKey HKEY_CURRENT_USER "SOFTWARE\QUB"
DeleteRegKey HKEY_LOCAL_MACHINE SOFTWARE\QUB

SectionEnd

!endif

