RequestExecutionLevel admin
Name QuB
OutFile QuB-Upgrade-2-0-0-33.exe
CRCCheck on
ComponentText "This will upgrade an existing QuB 2.0 or newer."
InstType /COMPONENTSONLYONCUSTOM
InstType QuB
DirText "Please select the location of QuB."

InstallDir "$PROGRAMFILES\QuB"
InstallDirRegKey HKEY_LOCAL_MACHINE SOFTWARE\QUB "Install_Dir"

Section "QuB Program"
SectionIn 1
SetShellVarContext all
SetOutPath $INSTDIR
SetOverwrite try
SetCompress auto

ClearErrors
ReadRegDWord $0 HKEY_LOCAL_MACHINE SOFTWARE\QUB "Installed_Version_Num"
IfErrors 0 FoundVer
Abort "Could not find a previous installation of QuB 2.0; try the full installer."

FoundVer:
IntCmp $0 2 NoAbort VerLT2 NoAbort
 
VerLT2:
Abort "Could not find a previous installation of QuB 2.0 or newer; try the full installer."

NoAbort:

WriteRegDWord HKEY_LOCAL_MACHINE SOFTWARE\QUB "Installed_Version_Num" 2
WriteRegDWord HKEY_LOCAL_MACHINE SOFTWARE\QUB "Installed_Version_Pt"  0
WriteRegDWord HKEY_LOCAL_MACHINE SOFTWARE\QUB "Installed_Version_Sub" 0
WriteRegDWord HKEY_LOCAL_MACHINE SOFTWARE\QUB "Installed_Version_Rev" 33


SetOutPath "$STARTMENU\Programs\QuB"
File "About QuB.txt"
SetOutPath $INSTDIR

File qub.exe
File qublib.dll
File qubopt.dll
File maxill.dll
File _qubfits.pyd
File _qubtree.pyd
File qubfits.dll
File qubaxo.dll
File qubtree.dll
File qubacqnm.dll
File qubnews.txt

File vcomp90.dll

SetOutPath "$INSTDIR\Curve Plugins"
File "Curve Plugins\customcurve.dll"
File "Curve Plugins\qubcurves.dll"


SetOutPath "$INSTDIR\PythonScripts"
File "PythonScripts\HistogramExcel.py"

SetOutPath "$INSTDIR\Reports\MIL"
File "Reports\MIL\Excel Histograms.txt"

SetOutPath "$INSTDIR\qubacqctl"
File "..\qubacqctl\Release\*.exe"

SectionEnd

