{
/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}
unit AllocTypes;

// begin_html
// See also:
// <ul>
// <li><a href="maxill_iface.pas.html">maxill_iface.pas</a></li>
// <li><a href="Maxill_Utils.pas.html">Maxill_Utils.pas</a></li>
// <li><a href="Alloc.pas.html">Alloc.pas</a></li>
// </ul>
// <b>Up:</b> <a href="index.html">Index</a>
// end_html  

interface


uses


Windows;


type


UInt64                              = Int64;//for now, since it is not defined.


//Pointers *********************************************************************
TPShortInt                          = ^ShortInt;
TPByte                              = ^Byte;
TPSmallInt                          = ^SmallInt;
TPWord                              = ^Word;
TPLongWord                          = ^LongWord;
TPLongInt                           = ^LongInt;
TPInteger                           = ^Integer;
TPInt64                             = ^Int64;
TPBoolean                           = ^Boolean;
TPLongBool                          = ^LongBool;
TPSingle                            = ^Single;
TPDouble                            = ^Double;
TPExtended                          = ^Extended;

TPVariant                           = ^Variant;

TSingleXY                           = record
  x                                 :Single;
  y                                 :Single;
end;
TPSingleXY                          = ^TSingleXY;

TDoubleXY                           = record
  x                                 :Double;
  y                                 :Double;
end;
TPDoubleXY                          = ^TDoubleXY;

ArrayOfInteger                      = Array of Integer;


//Arrays ***********************************************************************
TAByte                              = Array[0..(MaxInt div (SizeOf(Byte)*2))] of Byte;
TPAByte                             = ^TAByte;
TMByte                              =  Array[0..(MaxInt div (SizeOf(TPAByte)*2))] of TPAByte;
TPMByte                             = ^TMByte;

TAShort                             = Array[0..(MaxInt div (SizeOf(ShortInt)*2))] of ShortInt;
TPAShort                            = ^TAShort;
TMShort                             =  Array[0..(MaxInt div (SizeOf(TPAShort)*2))] of TPAShort;
TPMShort                            = ^TMShort;

TASmall                             = Array[0..(MaxInt div (SizeOf(SmallInt)*2))] of SmallInt;
TPASmall                            = ^TASmall;
TMSmall                             =  Array[0..(MaxInt div (SizeOf(TPASmall)*2))] of TPASmall;
TPMSmall                            = ^TMSmall;

TAWord                              = Array[0..(MaxInt div (SizeOf(Word)*2))] of Word;
TPAWord                             = ^TAWord;
TMWord                              =  Array[0..(MaxInt div (SizeOf(TPAWord)*2))] of TPAWord;
TPMWord                             = ^TMWord;

TALongWord                          = Array[0..(MaxInt div (SizeOf(LongWord)*2))] of LongWord;
TPALongWord                         = ^TALongWord;
TMLongWord                          =  Array[0..(MaxInt div (SizeOf(TPALongWord)*2))] of TPALongWord;
TPMLongWord                         = ^TMLongWord;

TASmallInt                          = Array[0..(MaxInt div (SizeOf(SmallInt)*2))] of SmallInt;
TPASmallInt                         = ^TASmallInt;
TMSmallInt                          =  Array[0..(MaxInt div (SizeOf(TPASmallInt)*2))] of TPASmallInt;
TPMSmallInt                         = ^TMSmallInt;

TALongInt                           = Array[0..(MaxInt div (SizeOf(LongInt)*2))] of LongInt;
TPALongInt                          = ^TALongInt;
TMLongInt                           =  Array[0..(MaxInt div (SizeOf(TPALongInt)*2))] of TPALongInt;
TPMLongInt                          = ^TMLongInt;

TAInteger                           = Array[0..(MaxInt div (SizeOf(Integer)*2))] of Integer;
TPAInteger                          = ^TAInteger;
TMInteger                           =  Array[0..(MaxInt div (SizeOf(TPAInteger)*2))] of TPAInteger;
TPMInteger                          = ^TMInteger;

TAInt64                             = Array[0..(MaxInt div (SizeOf(Int64)*2))] of Int64;
TPAInt64                            = ^TAInt64;
TMInt64                             =  Array[0..(MaxInt div (SizeOf(TPAInt64)*2))] of TPAInt64;
TPMInt64                            = ^TMInt64;

TAUInt64                            = Array[0..(MaxInt div (SizeOf(UInt64)*2))] of UInt64;
TPAUInt64                           = ^TAUInt64;
TMUInt64                            =  Array[0..(MaxInt div (SizeOf(TPAUInt64)*2))] of TPAUInt64;
TPMUInt64                           = ^TMUInt64;

TABoolean                           = Array[0..(MaxInt div (SizeOf(Boolean)*2))] of Boolean;
TPABoolean                          = ^TABoolean;
TMBoolean                           =  Array[0..(MaxInt div (SizeOf(TPABoolean)*2))] of TPABoolean;
TPMBoolean                          = ^TMBoolean;

TACardinal                          = Array[0..(MaxInt div (SizeOf(Cardinal)*2))] of Cardinal;
TPACardinal                         = ^TACardinal;
TMCardinal                          =  Array[0..(MaxInt div (SizeOf(TPACardinal)*2))] of TPACardinal;
TPMCardinal                         = ^TMCardinal;

TASingle                            = Array[0..(MaxInt div (SizeOf(Single)*2))] of Single;
TPASingle                           = ^TASingle;
TMSingle                            =  Array[0..(MaxInt div (SizeOf(TPASingle)*2))] of TPASingle;
TPMSingle                           = ^TMSingle;

TADouble                            = Array[0..(MaxInt div (SizeOf(Double)*2))] of Double;
TPADouble                           = ^TADouble;
TMDouble                            =  Array[0..(MaxInt div (SizeOf(TPADouble)*2))] of TPADouble;
TPMDouble                           = ^TMDouble;

TAExtended                          = Array[0..(MaxInt div (SizeOf(Extended)*2))] of Extended;
TPAExtended                         = ^TAExtended;
TMExtended                          =  Array[0..(MaxInt div (SizeOf(TPAExtended)*2))] of TPAExtended;
TPMExtended                         = ^TMExtended;

TPAChar                             = PChar;
TMChar                              =  Array[0..(MaxInt div (SizeOf(TPAChar)*2))] of TPAChar;
TPMChar                             = ^TMChar;

TAPoint                             = Array[0..(MaxInt div (SizeOf(TPoint)*2))] of TPoint;
TPAPoint                            = ^TAPoint;
TMPoint                             =  Array[0..(MaxInt div (SizeOf(TPAPoint)*2))] of TPAPoint;
TPMPoint                            = ^TMPoint;

TAPointer                           = Array[0..(MaxInt div (SizeOf(Pointer)*2))] of Pointer;
TPAPointer                          = ^TAPointer;
TMPointer                           =  Array[0..(MaxInt div (SizeOf(TPAPointer)*2))] of TPAPointer;
TPMPointer                          = ^TMPointer;

TThreeBytes                         = Array[1..3] of Byte;
TAThreeBytes                        = Array[0..(MaxInt div (SizeOf(TThreeBytes)*2))] of TThreeBytes;
TPAThreeBytes                       = ^TAThreeBytes;
TMThreeBytes                        =  Array[0..(MaxInt div (SizeOf(TPAThreeBytes)*2))] of TPAThreeBytes;
TPMThreeBytes                       = ^TMThreeBytes;

TASingleXY                          = Array[0..(MaxInt div (SizeOf(TSingleXY)*2))] of TSingleXY;
TPASingleXY                         = ^TASingleXY;
TMSingleXY                          =  Array[0..(MaxInt div (SizeOf(TPASingleXY)*2))] of TPASingleXY;
TPMSingleXY                         = ^TMSingleXY;

TADoubleXY                          = Array[0..(MaxInt div (SizeOf(TDoubleXY)*2))] of TDoubleXY;
TPADoubleXY                         = ^TADoubleXY;
TMDoubleXY                          =  Array[0..(MaxInt div (SizeOf(TPADoubleXY)*2))] of TPADoubleXY;
TPMDoubleXY                         = ^TMDoubleXY;

TMatrixInteger                      = record
  RowCount                          :Integer;
  ColCount                          :Integer;
  Data                              :TPMInteger;
end;
TPMatrixInteger                     = ^TMatrixInteger;

TMPXBufferInteger                   = record
  BufferCount                       :Integer;
  ElemCount                         :Integer;
  Buffer                            :TPAInteger;
end;
TPMPXBufferInteger                  = ^TMPXBufferInteger;

TArrayofString                      = Array of String;


implementation


//******************************************************************************
end.
