/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */

#ifndef MATRIXUTIL_H
#define MATRIXUTIL_H

/*
begin_html
See also:
<ul>
<li><a href="matrixutil.cpp.html">matrixutil.h</a></li>
<li><a href="milutil.h.html">milutil.h</a></li>  
<li><a href="ublas_matrixutil.h.html">ublas_matrixutil.h</a></li>  
</ul>
<b>Up:</b> <a href="index.html">Index</a>
end_html
*/

#include <iostream>
#include "milutil.h"   
#include "matrix.h"

BOOL eigen(double** a, int n, double* wr, double* wi, double** v, std::ostream &msgOut);
extern "C" MAXILL_API int __stdcall svdcmp_dll( double **a, int m, int n, double *w, double **v );
int svdecomp(double **a, int m, int n, double *w, double **v, std::ostream &msgOut);
BOOL gaussj0(double** a, int n, double **b, int m, std::ostream &msgOut);
BOOL gaussj_invert(fq::matrix<double>& mat, int n, std::ostream& msgOut);

#endif
