# find average current of each class, each seg
# throw in a random histogram.

import QUB
import Buttons
import qubtree
import os.path

def ExtractFileName( name ):
    withext = os.path.split(name)[1]
    return os.path.splitext(withext)[0]

def AvgCurrOfSeg(seg):
    segbounds = seg.data
    classes = seg['Classes'].data
    firsts  = seg['Firsts'].data
    lasts   = seg['Lasts'].data
    ndwell  = len(classes)
    nclass  = len(seg['amp'].data)

    seg['AvgAmp'].data = [0.0] * nclass
    avgs = seg['AvgAmp'].data
    counts  = [0] * nclass
    
    QUB.fillData(seg)
    data    = seg['Channel'].data
    
    for i in range(ndwell):
        for j in range(firsts[i] - segbounds[0], lasts[i] + 1 - segbounds[0]):
            avgs[ classes[i] ] = avgs[ classes[i] ] + data[j]
        counts[ classes[i] ] = counts[ classes[i] ] + lasts[i] - firsts[i] + 1
    for i in range(nclass):
        if counts[i] > 0:
            avgs[i] = avgs[i] / counts[i]
    
    data = None
    seg.remove( seg['Channel'] )

def RemoveIdlFromSeg(seg):
    seg.remove( seg.find('Classes') )
    seg.remove( seg.find('Durations') )
    seg.remove( seg.find('Firsts') )
    seg.remove( seg.find('Lasts') )

def AvgCurr(settings):
    result = QUB.getChosenIdealization()
    ds = result.find('DataSet')
    while not ds.isNull:
        seg = ds.find('Segment')
        while not seg.isNull:
            AvgCurrOfSeg(seg)
            RemoveIdlFromSeg(seg)
            seg = seg.next('Segment')
        ds = ds.next('DataSet')
    
    result.name = 'AvgCurr ' + ExtractFileName( str(result['DataSet']['FileName'].data) )
    result['ResultType'].data = 'AvgCurr'
    QUB.ResultsView.addResults( result )

Buttons.AddTaskButton('AvgCurr', AvgCurr, 'AvgC', 0, 0, 'Calculate average current for each idealized class', '', 'no settings', [])
