{

                               Qub Visual Data
                                     unit



(C) 2000 Lorin Milescu
}
{
/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */
}


//01-31-2000   Creation date

unit QUB_QVO_QVD;


//******************************************************************************
interface


uses


Messages, Windows, Sysutils, Classes, SyncObjs, Graphics, Controls, StdCtrls, ExtCtrls, Menus, Dialogs, Registry, Clipbrd, Math, Forms,
AllocTypes, Alloc,

QUB_Parser,
RegistryInterface,
QUB_Global, QUB_Globals, QUB_QVO_QVD_Global,
QUB_QVO, QUB_QVO_QVT,

QUB_Profiles,

QUB_QVO_QVD_XProperties,
QUB_QVO_QVD_Print_Properties,
QUB_QVO_QVD_Chop_Properties,
QUB_QVO_QVD_EventProcessor_Properties,
QUB_QVO_QVD_GoToPoint_Properties,
QUB_QVO_QVD_SelectionProperties,

QUB_Task_EvP_Properties,

QUB_QFS, QUB_QFS_File, QUB_QFS_QDF, QUB_QFS_QDF_Global, QUB_QFS_QDF_MPX, QUB_QFS_Channels, QUB_QFS_Segments,
QUB_QFS_QIF_Segments,
QUB_Node,
QUB_ExpCond_Parameters,

QUB_Baseline,
QUB_Idealization,
QUB_FitCurves,

QUB_Console, QUB_Rich_Console,

PythonEngine,
QUB_Python_Thread,

QUB_Viewport;


const


WM_QUB_DATAMESSAGE = WM_USER + 100;
QUB_QVO_QVD_HINTCYCLE = 10;


type


//Forward class declarations ***************************************************
TQUB_QVO_QVD                                   = class;
TQUB_Python_Data                               = class;


//Object
TQUB_QVO_QVD                                   = class(TQUB_QVO)
protected


  prPyHandle                                   :TQUB_Python_Data; // python surrogate of Self

  //Data
  prDataObject                                 :TQUB_QFS_QDF;
  prDataSegmentCount                           :Integer;
  prDataChannelCount                           :Integer;
  prDataPointCount                             :Integer;
  prData                                       :TPMInteger;
  prDataPoint                                  :TQUB_FirstLast;
  prDataCache                                  :TQUB_FirstLast;
  prDataAllocCount                             :Integer;
  prDataDraw                                   :TQUB_FirstLast;
  prDataWindow                                 :TQUB_FirstLast;
  prDataSel                                    :TQUB_FirstLast;
  prDataZoomSel                                :TQUB_FirstLast;
  prDataBaselineSel                            :TQUB_FirstLast;
  prDataEraseSel                               :TQUB_FirstLast;
  prDataCurr                                   :Integer;
  prDataOldCurr                                :Integer;
  prDataZoomCurr                               :Integer;
  prDataBreakPoints                            :TPAInteger;
  prDataYMinAuto                               :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Integer;
  prDataYMaxAuto                               :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Integer;

  prDataChannelDisplay                         :TQUB_QVO_QVD_DataChannelDisplay;//Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of TPAInteger;
  prDataChannelAlloc                           :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of TQUB_FirstLast;
  prDataChannelAllocated                       :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Boolean;
  prDataChannelProcess                         :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Byte;

  prDataChannelName                            :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of String;
  prDataChannelUnits                           :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of String;
  prDataChannelScaling                         :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Double;
  prDataChannelOffset                          :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Double;

  //Graphics settings
  prXAxisTickCount                             :Integer;
  prYAxisTickCount                             :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Integer;

  prDisplayProperties                          :INode;

  //B A S E L I N E
  prDataBaseline                               :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Integer;
  prBaselineNodes                              :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of TQUB_Baseline;

  prFitCurves                                  :TQUB_FitCurves;

  //Markers
  prDataMarker                                 :Integer;
  prDataMarkers                                :TPADouble;
  prDataMarkersCh                              :TPAInteger;
  prDataMarkersCount                           :Integer;

  //Time Markers
  prDataTimeMarker                             :Integer;
  prDataTimeMarkers                            :TPADouble;
  prDataTimeMarkersCount                       :Integer;

  //Kinetic Parameters Markers
  prDataKinParamsMarker                        :Integer;
  prDataKinParamsMarkers                       :TPAInteger;
  prDataKinParamsMarkersPars                   :TArrayofString;
  prDataKinParamsMarkersNote                   :TArrayofString;
  prDataKinParamsMarkersCount                  :Integer;

  //Active Channel
  prActiveChannel                              :Integer;

  //Interactive properties - all should be here ********************************

  //Colors
  prColorData                                  :Array[0..7] of TColor;
  prColorSel                                   :TColor;
  prColorBreak                                 :TColor;
  prColorBaseline                              :TColor;
  prColorBaselineNodes                         :TColor;
  prColorIdealized                             :TColor;
  prColorIdealizedSel                          :TColor;
  prColorSelList                               :TColor;
  prColorParameters                            :TColor;
  prColorSegLabel                              :TColor;
  prColorCurr                                  :TColor;

  //Page settings
  prSelectable                                 :Boolean;
  prTracesPerPage                              :Integer;
  prPointsPerTrace                             :Integer;
  prTraceChangeOnBreak                         :Boolean;
  prCacheSize                                  :Integer;
  prScaling                                    :Double;
  prSampling                                   :Double;
  prOverlapChannels                            :Boolean;
  prOverlapTraces                              :Boolean;
  prDrawMode                                   :TQUB_QVO_QVD_DrawMode;
  prDrawPoints                                 :Boolean;
  prDrawActiveThick                            :Boolean;
  prDrawBaseline                               :Boolean;
  prDrawBaselineNodes                          :Boolean;
  prDrawSegLabels                              :Boolean;
  prDrawIdealized                              :Boolean;
  prDrawIdealizedAbove                         :Boolean;
  prDrawIdealizedColor                         :Boolean;
  prDrawListOverlapped                         :Boolean;
  prDrawSelList                                :Boolean;
  prDrawParameters                             :Boolean;
  prDrawInverted                               :Boolean;
  prDrawRaster                                 :Boolean;
  prDrawLabels                                 :Boolean;
  prMarginH                                    :Integer;
  prMarginV                                    :Integer;

  //Scale Bar
  prScaleBarSamples                            :Integer;
  prScaleBarADUnits                            :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Integer;
  //prScaleBarCount                              :TPoint;
  prScaleBarPixel                              :TPoint;

  prAutoScale                                  :Boolean;
  prDataYMin                                   :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Integer;
  prDataYMax                                   :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Integer;
  prDataYFactor                                :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Double;

  prDrawItoG                                   :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Boolean;

  prChannelVisible                             :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Boolean;

  prAutoScroll                                 :Boolean;
  
  //Filter
  prFilterOn                                   :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Boolean;
  prFilterMAOn                                 :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Boolean;
  prFilterFreq                                 :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Double;
  prFilterMACount                              :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Integer;

  //Baseline
  prBaselineOn                                 :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Boolean;
  prWarnOnBaseline                             :Array[0..QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1] of Boolean;
  //****************************************************************************

  //Chop
  prChopSkipBeforePoints                       :Integer;
  prChopSkipAfterPoints                        :Integer;
  prChopGetPoints                              :Integer;
  prChopOnce                                   :Boolean;
  prChopIgnoreSegments                         :Boolean;
  prChopDiscardPartial                         :Boolean;
  prChopAddToList                              :Boolean;
  prChopOutputList                             :String;
  prChopUseGetList                             :Boolean;
  prChopGetListName                            :String;


  //GoTo Point
  prGoToPointStart                             :TQUB_GOTOPOINT_MODE;
  prGoToPointStartPoint                        :Integer;
  prGoToPointStartTime                         :Double;
  prGoToPointStartMarker                       :Integer;
  prGoToPointEnd                               :TQUB_GOTOPOINT_MODE;
  prGoToPointEndPoint                          :Integer;
  prGoToPointEndTime                           :Double;
  prGoToPointEndMarker                         :Integer;
  prGoToPointEndPoints                         :Integer;
  prGoToPointEndDuration                       :Double;
  prGoToPointRelativeToSel                     :Boolean;
  prGoToPointRealTime                          :Boolean;
  prGoToPointAddToList                         :Boolean;
  prGoToPointListName                          :String;

  //Flags
  prDataMeasured                               :Boolean;
  prMouse                                      :TPoint;
  prMouseSel                                   :TPoint;
  prSelMove                                    :TQUB_FirstLast;
  prSelMoveOffset                              :Integer;
  prPrevAction                                 :Integer;
  prWindowDrawMode                             :Boolean;
  prSelecting                                  :Boolean;
  prSelMoving                                  :Boolean;
  prKeyeing                                    :Boolean;
  prKeyCode                                    :Integer;
  prSelListNameCount                           :Integer;
  prPlayingSelection                           :Boolean;
  prForSegment                                 :Boolean;
  prCopyASCII                                  :Boolean;
  prBrowsing                                   :Boolean;
  prProcessingForDisplay                       :Boolean;
  prPointing                                   :Boolean;
  prPointingPoint                              :Integer;
  prPopupListSel                               :Integer;
  prCanUnExpand                                :Boolean;
  prExpanding                                  :Boolean;
  prBeforeExpand                               :TQUB_FirstLast;

  prShiftSelValue                              :Integer;
  prExpandSelValue                             :Integer;

  prPrintDrawData                              :Boolean;
  prPrintDrawIDLData                           :Boolean;
  prPrintDrawBase                              :Boolean;
  prPrintDrawMode                              :TQUB_QVO_QVD_DrawMode;

  prExpCond                                    :TQUB_ExpCond_Parameters;

  prHintCycle                                  :Integer;


  //Data Message
  prDataMessaging                              :Boolean;
  prDataMessageSendAgain                       :Boolean;
  prDataMsgLastWParam                          :LongInt;
  prDataMsgLastLParam                          :LongInt;
  // there might be 10 redraw messages in the queue -- rather than redraw 9 pointless times, have DataMessage "or" all the requests then send DATA_MSG_USE_ACC to have all accumulated requests done then cleared in one go
  prDataMsgAccWParam                           :LongInt;

  //Scroll bar
  prScrollBar                                  :TScrollBar;

  prZoom                                       :TQUB_QVO_QVT;

  prPropertiesForm                             :TQUB_QVO_QVD_XPropertiesForm;
  prChopPropertiesForm                         :TQUB_QVO_QVD_Chop_PropertiesForm;
  prPrintPropertiesForm                        :TQUB_QVO_QVD_Print_PropertiesForm;
  prEvtListProcessorPropertiesForm             :TQUB_Task_EvP_Properties; // TQUB_QVO_QVD_EventProcessor_PropertiesForm;
  prGoToPointPropertiesForm                    :TQUB_QVO_QVD_GoToPoint_PropertiesForm;
  prSelectionPropertiesForm                    :TQUB_QVO_QVD_SelectionPropertiesForm;

  //Selection List *************************************************************
  prResultsList                                :TQUB_QVO_QVD_ResultsList;
  prSelectionLists                             :TQUB_QVO_QVD_SelectionLists;
  prSelectionListPanel                         :TPanel;
  prConteinerResults                           :TPanel;
  prConteinerLists                             :TPanel;
  prConteinerList                              :TPanel;
  m_lListLoading                               :Boolean;   // 12/05 : Flag when list is loading to prevent activation for each added item.
  //****************************************************************************

  //Popup menus
  prExpandZoomItem                             :TMenuItem;
  prUnExpandZoomItem                           :TMenuItem;
  prSetBaselineItem                            :TMenuItem;//new
  prNodesAddItem                               :TMenuItem;
  prBaselineExtrasItem                         :TMenuItem;
  prNodesDelItem                               :TMenuItem;
  prNodesDelAllItem                            :TMenuItem;
  prVMarkersAddItem                            :TMenuItem;
  prVMarkersDelItem                            :TMenuItem;
  prVMarkersSetItem                            :TMenuItem;
  prTMarkersAddItem                            :TMenuItem;
  prTMarkersDelItem                            :TMenuItem;
  prTMarkersDelAllItem                         :TMenuItem;
  prKMarkerSaveItem                            :TMenuItem;
  prSelListDelItem                             :TMenuItem;
  prSelListPropertiesItem                      :TMenuItem;
  prCurveFitItem                               :TMenuItem;
  prCopyFitItem                                :TMenuItem;
  prDelFitItem                                 :TMenuItem;
  prEditCutItem                                :TMenuItem;
  prEditCopyItem                               :TMenuItem;
  prEditCopyListItem                           :TMenuItem;
  prEditCopyHintItem                           :TMenuItem;
  prEditPasteItem                              :TMenuItem;
  prEditAppendItem                             :TMenuItem;
  prEditDeleteItem                             :TMenuItem;
  prSetEraseItem                               :TMenuItem;
  prEditEraseItem                              :TMenuItem;
  prEditFillItem                               :TMenuItem;
  prEditFillIdlItem                            :TMenuItem;
  prEditBreakItem                              :TMenuItem;
  prEditUndoItem                               :TMenuItem;

  prEditJoinIdlItem                            :TMenuItem;
  prEditDeleteIdlItem                          :TMenuItem;
  prEditDelAllIdlItem                          :TMenuItem;
  prSendToItem                                 :TMenuItem;

  prMenuCaller                                 :TQUB_QVO;

  //Record/Playback Lock change
  prOnChangeLockRecord                         :TNotifyEvent;
  prOnChangeLockPlayback                       :TNotifyEvent;

  prCurrModel                                  :TQUB_QVO;

  prSelectionListsPopupMenu                    :TPopupMenu;
  prListsLoadItem                              :TMenuItem;
  prListsSaveItem                              :TMenuItem;
  prListsRenameItem                            :TMenuItem;
  prListsCutItem                               :TMenuItem;
  prListsCopyItem                              :TMenuItem;
  prListsPasteItem                             :TMenuItem;
  prListsDelItem                               :TMenuItem;
  prListsListCutItem                           :TMenuItem;
  prListsListCopyItem                          :TMenuItem;
  prListsListPasteItem                         :TMenuItem;
  prListsListDelItem                           :TMenuItem;

  prSelectionListPopupMenu                     :TPopupMenu;
  prListCutItem                                :TMenuItem;
  prListCopyItem                               :TMenuItem;
  prListPasteItem                              :TMenuItem;
  prListDelItem                                :TMenuItem;
  prListSelectAllItem                          :TMenuItem;
  prListInvertSelItem                          :TMenuItem;
  prListShiftSelItem                           :TMenuItem;
  prListExpandSelItem                          :TMenuItem;
  prListExtractListItem                        :TMenuItem;
  prListPropertiesItem                         :TMenuItem;

  prDataMsgCritSection                         :TCriticalSection;

  prLockedRecordCount                          :Integer;
  prLockedPlaybackCount                        :Integer;

  prRecording                                  :Boolean;

  prClosing                                    :Boolean;

  prListed                                     :Boolean;


  procedure prCreatePyInstance;
  procedure prCleanupPyInstance;

  //Events
  procedure DoOnFileOpen(Sender :TObject); override;
  procedure DoOnFileClose(Sender :TObject); override;
  procedure DoOnFileEdit(Sender :TObject; EditOper :TQUB_EditOperation; var Param; var Param2); override;
  procedure DoOnFileInfoEdit(Sender :TObject; EditOper :TQUB_EditOperation; var Param; var Param2);
  procedure DoOnFitCurvesChanged(Sender :TObject);

  //Add Series/Sweep - used with HEKA files
  procedure DoOnAddSeries(Sender :TObject; const SeriesName :String; Private :Boolean);
  procedure DoOnAddSweep(Sender :TObject; const SeriesName, SweepName :String; const Sel :TQUB_FirstLast; ForceAdd :Boolean);

  procedure DoOnExpCondChanged(Sender :TObject);

  //Event setters
  procedure prAddDataEvents(DataObject :TQUB_QFS_QDF);
  procedure prDelDataEvents(DataObject :TQUB_QFS_QDF);


  procedure prResetData;
  procedure prRecountData;

  procedure prDeleteAllMarkers;
  procedure prDeleteAllTimeMarkers;
  procedure prDeleteAllKinParamsMarkers;


  procedure prInitDisplayProperties;
  procedure prOnSetDisplayProperties(Sender :TQUB_ProfileCat; Updates :INode);

  //Session
  procedure prReadSession;
  procedure prUpdateSession(Session :INode);

  procedure prReadSessionLists;
  procedure prUpdateSessionLists(Session :INode);

  procedure prReadSessionIdl;
  procedure prUpdateSessionIdl(Session :INode);

  procedure prReadSessionResults;
  procedure prUpdateSessionResults(Session :INode);

  procedure prReadSessionBaseline;
  procedure prUpdateSessionBaseline(Session :INode);

  procedure prReadSessionMarkers;
  procedure prUpdateSessionMarkers(Session :INode);

  procedure prReadSessionTimeMarkers;
  procedure prUpdateSessionTimeMarkers(Session :INode);

  procedure prReadSessionKinParamsMarkers;

  function prCopyListsToClipboard :Boolean;
  function prPasteListsFromClipboard :Boolean;

  function prCopySelectionsToClipboard :Boolean;
  function prPasteSelectionsFromClipboard :Boolean;

  procedure prAdjustListsOnDelete(Sel :TQUB_FirstLast);

  function prAllocCache(const NewCache :TQUB_FirstLast; FullSize :Boolean; var ReAllocd :Boolean) :Boolean;
  //function prReadCache :Boolean;
  function prReadCache(const NewCache :TQUB_FirstLast; Expand :Boolean) :Boolean;

  function prMouseToPoint(const p :TPoint; var MoveCmd :TQUB_QVO_QVD_Command) :Integer;
  function prMouseOnPoint(const xyPoint :TPoint; var Point :Integer) :Boolean;

  function prUpdatePointing :Boolean;

  //Draw
  procedure prErase; override;
  procedure prDrawData;
  procedure prDrawDataSel;
  procedure prDrawDataSelDowning;
  procedure prDrawDataSelRunning;
  procedure prDrawDataSelMoving;
  procedure prDrawDataSelKeyeing;

  procedure prDoDblClick;
  procedure prHilightSelection;

  procedure prUpdateStimValues(Curr :Integer);

  //Print
  function prPrint(Dlg :TPrintDialog) :Boolean; override;

  //Data processing
  function prCleanFilterBounds(Buffer :TPAInteger; Sel :TQUB_FirstLast; ChannelIndex :Integer; FilterFreq :Double): Boolean;
  function prSegmentsCleanFilterBounds(Buffer, FilterBuffer :TPAInteger; Sel :TQUB_FirstLast; FilterFreq :Double): Boolean;
  function prNewCleanFilterBounds(Buffer, FilterBuffer :TPAInteger; Sel :TQUB_FirstLast; FilterFreq :Double): Boolean;
  procedure prProcessDataForDisplay(const NewDraw, ProcSel :TQUB_FirstLast);
  function prDoFilterMA(Data, DataF :TPAInteger; DataCount :Integer; CoeffCount :Integer) :Boolean;
  procedure prDoProcessData(Data :TPMInteger; Sel :TQUB_FirstLast; ProcessFilter :Boolean; ProcessBaseLine :Boolean);
  procedure prDoProcessDataChannel(Data :TPAInteger; ChannelIndex :Integer; Sel :TQUB_FirstLast; ProcessFilter :Boolean; ProcessBaseLine :Boolean);
  procedure prDoDataBaseline(Buffer :TPMInteger; ChannelIndex :Integer; Count :Integer); overload;
  procedure prDoDataBaseline(Buffer :TPAInteger; ChannelIndex :Integer; Count :Integer); overload;
  procedure prDoBaseline(Data :TPAInteger; ChannelIndex :Integer; Sel :TQUB_FirstLast);

  procedure prGetYAvgMinMax(NewDraw :TQUB_FirstLast);

  //Property setters ***********************************************************
  procedure prSetDataYMinAuto(Index :Integer; m :Integer);
  function  prGetDataYMinAuto(Index :Integer) :Integer;
  procedure prSetDataYMaxAuto(Index :Integer; m :Integer);
  function  prGetDataYMAxAuto(Index :Integer) :Integer;

  procedure prSetActiveChannel(c :Integer);

  //Interactive Property setters ***********************************************
  //Margin
  procedure prSetMargin(Index: Integer; m: Integer); override;

  //Color
  procedure prSetColor(c :TColor); override;
  procedure prSetColorBack(c :TColor); override;
  procedure prSetColorFrame(c :TColor); override;

  procedure prSetColorData(Index :Integer; c :TColor);
  function  prGetColorData(Index :Integer) :TColor;
  procedure prSetColorSel(c :TColor);
  procedure prSetColorBreak(c :TColor);
  procedure prSetColorCurr(c :TColor);
  procedure prSetColorBaseline(c :TColor);
  procedure prSetColorBaselineNodes(c :TColor);
  procedure prSetColorIdealized(c :TColor);
  procedure prSetColorIdealizedSel(c :TColor);
  procedure prSetColorSelList(c :TColor);
  procedure prSetColorParameters(c :TColor);
  procedure prSetColorSegLabel(c :TColor);

  //Page
  procedure prSetTracesPerPage(t :Integer);
  procedure prSetPointsPerTrace(p :Integer);
  procedure prSetCacheSize(c :Integer);
  procedure prSetPage(TracesPerPage, PointsPerTrace, CacheSize :Integer);
  procedure prSetScaling(s :Double);
  procedure prSetSampling(s :Double);
  procedure prSetTraceChangeOnBreak(c :Boolean);
  procedure prSetOverlapChannels(o :Boolean);
  procedure prSetOverlapTraces(o :Boolean);
  procedure prSetDrawPoints(p :Boolean);
  procedure prSetDrawActiveThick(t :Boolean);
  procedure prSetDrawBaseline(b :Boolean);
  procedure prSetDrawBaselineNodes(b :Boolean);
  procedure prSetDrawSegLabels(b :Boolean);
  procedure prSetDrawIdealized(i :Boolean);
  procedure prSetDrawIdealizedAbove(a :Boolean);
  procedure prSetDrawIdealizedColor(c :Boolean);
  procedure prSetDrawListOverlapped(l :Boolean);
  procedure prSetDrawSelList(x :Boolean);
  procedure prSetDrawParameters(x :Boolean);
  procedure prSetDrawMode(m :TQUB_QVO_QVD_DrawMode);
  procedure prSetDrawInverted(i :Boolean);
  procedure prSetDrawRaster(r :Boolean);
  procedure prSetDrawLabels(l :Boolean);
  procedure prSetMarginH(m :Integer);
  procedure prSetMarginV(m :Integer);

  //Scale
  procedure prSetAutoScale(a :Boolean);

  function  prGetScaleBarADUnits(Index :Integer): Integer;
  procedure prSetDataYMin(Index :Integer; m :Integer);
  function  prGetDataYMin(Index :Integer) :Integer;
  procedure prSetDataYMax(Index :Integer; m :Integer);
  function  prGetDataYMax(Index :Integer) :Integer;
  procedure prSetDataYFactor(Index :Integer; f :Double);
  function  prGetDataYFactor(Index :Integer) :Double;

  procedure prSetDrawItoG(Index :Integer; d :Boolean);
  function prGetDrawItoG(Index :Integer) :Boolean;

  procedure prSetChannelVisible(Index :Integer; o :Boolean);
  function  prGetChannelVisible(Index :Integer) :Boolean;

  procedure prSetDataChannelName(Index :Integer; x :String);
  function prGetDataChannelName(Index :Integer): String;
  procedure prSetDataChannelUnits(Index :Integer; x :String);
  function prGetDataChannelUnits(Index :Integer): String;
  procedure prSetDataChannelScaling(Index :Integer; x :Double);
  function prGetDataChannelScaling(Index :Integer): Double;
  procedure prSetDataChannelOffset(Index :Integer; x :Double);
  function prGetDataChannelOffset(Index :Integer): Double;

  //Graphics settings
  procedure prSetXAxisTickCount(c :Integer);
  function prGetXAxisTickCount: Integer;
  procedure prSetYAxisTickCount(Index :Integer; c :Integer);
  function prGetYAxisTickCount(Index :Integer): Integer;

  //Filter
  procedure prSetFilterOn(Index :Integer; o :Boolean);
  function  prGetFilterOn(Index :Integer) :Boolean;
  procedure prSetFilterMAOn(Index :Integer; o :Boolean);
  function  prGetFilterMAOn(Index :Integer) :Boolean;
  procedure prSetFilterFreq(Index :Integer; f :Double);
  function  prGetFilterFreq(Index :Integer) :Double;
  procedure prSetFilterMACount(Index :Integer; c :Integer);
  function  prGetFilterMACount(Index :Integer) :Integer;

  //Baseline
  procedure prSetBaselineOn(Index :Integer; o :Boolean);
  function  prGetBaselineOn(Index :Integer) :Boolean;
  procedure prSetWarnOnBaseline(Index :Integer; o :Boolean);
  function  prGetWarnOnBaseline(Index :Integer) :Boolean;

  procedure prSetDataBaseLine(ChannelIndex :Integer; NewBaseline :Integer);

  function prConfirmSetBaseline: Boolean;  // if WarnOnBaseline[ActiveChannel]

  //Tips
  procedure prSetTipsOn(t :Boolean); override;

  //Registry, properties
  procedure prSetInitialProperties; override;
  procedure prPropertiesRegistry(Read :Boolean); override;
  //****************************************************************************


  procedure prSetZoom(z :TQUB_QVO_QVT);
  procedure prSetZoomData(ZoomDraw :Boolean);

  procedure prSetDataCurr(c :Integer);
  procedure prSetHint;

  procedure prSetListed(x :Boolean);

  function prGetCurrList: TQUB_QVO_QVD_SelectionList;
  function prGetCurrListName: String;
  procedure prSetCurrListName(x :String);

  procedure prSetConteinerResults(c :TPanel);
  procedure prSetConteinerList(c :TPanel);
  procedure prSetConteinerSel(c :TPanel);

  function prGetFileName :String; override;
  function prGetFileExt :String; override;
  function prGetModified :Boolean; override;
  function prGetSaved :Boolean; override;

  //Baseline
  function  prGetDataBaseline(Index :Integer) :Integer;
  function  prGetBaselineNodes(Ix :Integer): TQUB_Baseline;

  //Properties
  procedure prOnGetProperties(Sender :TObject); override;
  procedure prOnPutProperties(Sender :TObject); override;
  procedure prOnResetProperties(Sender :TObject); override;
  procedure prOnSetAsDefaultProperties(Sender :TObject); override;

  //Chop properties
  procedure prOnGetChopProperties(Sender :TObject);
  procedure prOnPutChopProperties(Sender :TObject);

  //GoTo Point properties
  procedure prOnGetGoToPointProperties(Sender :TObject);
  procedure prOnPutGoToPointProperties(Sender :TObject);

  //Popup Menu
  procedure prCreatePopUpMenu; override;

  // ask on del/insert if sel.lists could be broken
  function prConfirmSelListInvalidate: Boolean;
  // inform that cut/delete is a bad idea
  function prConfirmDataCorruption: Boolean;

  //Popup Menu events
  procedure prOnExpandZoom(Sender :TObject);
  procedure prOnUnExpandZoom(Sender :TObject);
  procedure prOnSetBaseline(Sender :TObject);
  procedure prOnBaselineEdit(Sender :TObject);
  procedure prOnSetErase(Sender :TObject);
  procedure prOnNodesAdd(Sender :TObject);
  procedure prOnNodesDel(Sender :TObject);
  procedure prOnNodesDelAll(Sender :TObject);
  procedure prOnVMarkersAdd(Sender :TObject);
  procedure prOnVMarkersDel(Sender :TObject);
  procedure prOnVMarkersSet(Sender :TObject);
  procedure prOnTMarkersAdd(Sender :TObject);
  procedure prOnTMarkersDel(Sender :TObject);
  procedure prOnTMarkersDelAll(Sender :TObject);
  procedure prOnKMarkerSave(Sender :TObject);
  procedure prOnCurveFit(Sender :TObject);
  procedure prOnCopyFit(Sender :TObject);
  procedure prOnDelFit(Sender :TObject);
  procedure prOnCut(Sender :TObject);
  procedure prOnCopy(Sender :TObject);
  procedure prOnCopyList(Sender :TObject);
  procedure prOnCopyHint(Sender :TObject);
  procedure prOnPaste(Sender :TObject);
  procedure prOnAppend(Sender :TObject);
  procedure prOnDelete(Sender :TObject);
  procedure prOnErase(Sender :TObject);
  procedure prOnFill(Sender :TObject);
  procedure prOnFillIdl(Sender :TObject);
  procedure prOnBreak(Sender :TObject);
  procedure prOnUndo(Sender :TObject);
  procedure prOnJoinIdl(Sender :TObject);
  procedure prOnDeleteIdl(Sender :TObject);
  procedure prOnDelAllIdl(Sender :TObject);
  procedure prOnCopyImage(Sender :TObject); override;
  procedure prOnPrint(Sender :TObject); override;
  procedure prOnSendToQtiPlot(Sender :TObject);
  procedure prOnProperties(Sender :TObject); override;
  procedure prOnPopUp(Sender :TObject); override;

  procedure prSetPopUpComponent(PUC :TComponent);

  //Edit Lists
  procedure prOnListsLoad(Sender :TObject);
  procedure prOnListsSave(Sender :TObject);
  procedure prOnListsRename(Sender :TObject);
  procedure prOnListsCopy(Sender :TObject);
  procedure prOnListsCut(Sender :TObject);
  procedure prOnListsPaste(Sender :TObject);
  procedure prOnListsDel(Sender :TObject);

  //Edit List
  procedure prOnListCut(Sender :TObject);
  procedure prOnListCopy(Sender :TObject);
  procedure prOnListPaste(Sender :TObject);
  procedure prOnListDel(Sender :TObject);
  procedure prOnListSelectAll(Sender :TObject);
  procedure prOnListInvertSel(Sender :TObject);
  procedure prOnListExtractList(Sender :TObject);
  procedure prOnListShiftSel(Sender :TObject);
  procedure prOnListExpandSel(Sender :TObject);
  procedure prOnListProperties(Sender :TObject);

  procedure prOnSelListDel(Sender :TObject);
  procedure prOnSelListProperties(Sender :TObject);

  //Zoom events
  procedure prOnZoomChangeSel(Sender :TObject);
  procedure prOnZoomEditPoint(Sender :TObject; Point :Integer; Change :Integer);
  procedure prOnZoomChangeVMarker(Sender :TObject);
  procedure prOnZoomChangeTMarker(Sender :TObject);
  procedure prOnZoomChangeKMarker(Sender :TObject);


  procedure prGetSelection(var Sel :TQUB_FirstLast; Sender :TObject; ForSegment :Boolean);
  //****************************************************************************

  procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
  procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  procedure DblClick; override;
  function  DoMouseWheel(Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint): Boolean; override;

  procedure CNKeyDown(var Message: TWMKeyDown); message CN_KEYDOWN;

  procedure prOnResultsListKeyDown(Sender :TObject; var Key: Word; Shift: TShiftState);
  procedure prOnResultsListItemChange(Sender :TObject);
  procedure prOnResultsListItemDblClick(Sender :TObject);
  procedure prOnSelectionListsKeyDown(Sender :TObject; var Key: Word; Shift: TShiftState);
  procedure prOnSelectionListsItemChange(Sender :TObject);
  procedure prOnSelectionListsItemDblClick(Sender :TObject);
  procedure prOnSelectionListKeyDown(Sender :TObject; var Key: Word; Shift: TShiftState);
  procedure prOnSelectionListItemChange(Sender :TObject);
  procedure prOnSelectionListItemDblClick(Sender :TObject);
  procedure prOnSelectionListActiveChanged(Sender :TObject);
  //****************************************************************************

  procedure prDoOnChangePage;


  //Data Message handler
  procedure DoOnDataMessage(var Message: TMessage); message WM_QUB_DATAMESSAGE;


  //****************************************************************************
  function prGetMaxPrintPage :Integer; override;

  procedure prListLoad;
  procedure prListSave;
  function prAddList(Name :String): TQUB_QVO_QVD_SelectionList;

  //Locked Record/Playback
  function prGetLockedRecord :Boolean;
  function prGetLockedPlayback :Boolean;

  procedure prSetActOnHiRes(x :Boolean);


  //Baseline Nodes Load/Save
  function prLoadBaselineNodes(ChannelIndex :Integer; const FileName :String) :Boolean;
  function prSaveBaselineNodes(ChannelIndex :Integer; const FileName :String) :Boolean;


public


  constructor Create(AOwner :TComponent); override;
  destructor Destroy; override;

  procedure Paint; override;

  procedure Activate; override;
  procedure DeActivate; override;

  procedure AddArthurNode(Sender :TObject);

  //File .......................................................................
  function New(const FileName :String) :Boolean; override;
  function Open(const FileName :String) :Boolean; override;
  function Open(const FileName :String; OpenStream :TStream) :Boolean; override;
  function Save(const FileName :String) :Boolean; override;
  function Close :Boolean; override;
  //OpenFromString should become obsolete
  function OpenFromString(const MemFile :String) :Boolean; override;
  function SaveToString(var MemFile :String; FileType :Integer) :Boolean; override;

  function CanSaveAs(var FileName :String; Confirmation :Boolean) :Boolean;

  function LoadInfo(ChannelIndex :Integer; const FileName :String) :Boolean;
  function SaveInfo(ChannelIndex :Integer; const FileName :String) :Boolean;
  function SaveInfoStat(ChannelIndex :Integer; const FileName :String) :Boolean;
  function SaveInfoASCII(ChannelIndex :Integer; const FileName :String) :Boolean;

  function CanLoadInfo(ChannelIndex :Integer) :Boolean;
  function CanSaveInfo(ChannelIndex :Integer) :Boolean;

  function LoadBaselineNodes(ChannelIndex :Integer; const FileName :String) :Boolean;
  function SaveBaselineNodes(ChannelIndex :Integer; const FileName :String) :Boolean;

  function CanLoadBaseNodes(ChannelIndex :Integer) :Boolean;
  function CanSaveBaseNodes(ChannelIndex :Integer) :Boolean;

  function CopyImage(ShowProperties :Boolean) :Boolean; override;

  function Properties :Boolean; override;

  function CloneSession: INode;


  //Edit .......................................................................
  function CutSelection :Boolean;
  function CopySelection :Boolean;
  function CopyList :Boolean;
  function PasteSelection :Boolean;
  function AppendSelection :Boolean;
  function DeleteSelection :Boolean;
  function EraseSelection :Boolean;
  function FillSelection :Boolean;
  function FillIdlSelection :Boolean;
  function AppendData(Buffer :Pointer; BufferSize, BufferCount :Integer; NewSegment :Boolean; StartTime :Double; Refresh, Acq :Boolean) :Boolean;
  function NewSegment(StartTime :Double; Refresh :Boolean; ForceNewIfEmpty :Boolean) :Boolean;
  function ReplaceData(Buffer :Pointer; BufferSize :Integer; Sel :TQUB_FirstLast; Refresh :Boolean) :Boolean;
  function Clear :Boolean;

  //View .......................................................................
  function ZoomIn(Factor :Single) :Boolean;
  function ZoomOut(Factor :Single) :Boolean;
  function OffsetUp(Factor :Single) :Boolean;
  function OffsetDown(Factor :Single) :Boolean;
  function FindTrace :Boolean;

  //Grab
  function GrabAvgStd(var Avg, Std :Double) :Boolean;
  function GetAverage(Channel :Integer; var Avg :Double; var Std :Double) :Boolean; overload;
  function GetAverage(Channel :Integer; First, Last :Integer; var Avg, Std :Double) :Boolean; overload;
  function Average(Channel :Integer; First, Last :Integer) :Double;
  function GetMinMax(Channel :Integer; First, Last :Integer; var Min, Max :Double; var MinIdx, MaxIdx :Integer) :Boolean;
  function GetClosestIndexOfValue(Channel, First, Last :Integer; Value :Double) :Integer;

  //Tasks ......................................................................
  function MoveSelectionIntoWindow(Sel :TQUB_FirstLast; Curr :Integer) :Boolean;
  procedure ExpandZoom;
  procedure UnExpandZoom;
  function AddSegmentList :Boolean;
  function AddIdlSegmentList :Boolean;
  function ChopSegments(Properties :Boolean) :Boolean;
  function EvtListProcess(Properties :Boolean; OnActionDone :TNotifyEvent) :Boolean;
  function GoToPoint(Properties :Boolean) :Boolean;
  function AddList :Boolean; overload;
  function AddList(const Name :String) :TQUB_QVO_QVD_SelectionList; overload;
  function GetList(const Name :String) :TQUB_QVO_QVD_SelectionList;
  function ChooseList(const Name :String): Boolean; overload;
  function ChooseList(Ix :Integer): Boolean; overload;

  function CutLists :Boolean; overload;
  function CopyLists :Boolean; overload;
  function PasteLists :Boolean; overload;
  function DeleteLists :Boolean; overload;

  function DelList :Boolean; overload;
  function DelList(const Name :String) :Boolean; overload;

  function CutSelections :Boolean;
  function CopySelections :Boolean;
  function PasteSelections :Boolean;
  function DeleteSelections :Boolean;
  function SelectAllSelections :Boolean;
  function InvertSelections :Boolean;

  function ShiftSelection :Boolean;
  function ExpandSelection :Boolean;

  function AddSelection :Boolean; overload;
  function AddSelections(FromZoom :Boolean):Boolean;
  function AddSelection(const ListName, SelName :String; Sel :TQUB_FirstLast; ForceAdd :Boolean) :Boolean; overload;
  function DelSelection :Boolean;
  function ShowSelectionProperties :Boolean;
  function DelSelected(Inverted :Boolean) :Boolean;
  function PlaySelection(ChannelIndex :Integer) :Boolean;
  function StopSelection :Boolean;
  function AddNote(const ListName :String) :Boolean; overload;
  function AddNote(const ListName, Name, Comments :String) :Boolean; overload;
  //function AddNote(const ListName :String; Pars :INode) :Boolean; overload;

  function SegmentData(ISels, OSels :TList; Segmentation :Boolean; MaxSize :Integer) :Boolean;

  function CreateDataSet: INode;
  function GetChosenData: INode;
  procedure FillDataSegment(SegNode :INode);
  procedure FillDataSegmentCh(SegNode :INode);
  function GetChosenIdl: INode; overload;
  function GetChosenIdl(Fragments :Boolean): INode; overload;
  function GetChosenIdl(DropFirstLast, DropIfCls :Boolean; DropCls :Integer): INode; overload;
  function GetChosenIdlSignals: INode;

  //Load Data ..................................................................
  function LoadData(Buffer :TPMInteger; Sel :TQUB_FirstLast; Process :Boolean; ProcessFilter :Boolean; ProcessBaseLine :Boolean) :Boolean;
  function LoadDataChannel(Buffer :TPAInteger; ChannelIndex :Integer; Sel :TQUB_FirstLast; Process :Boolean; ProcessFilter :Boolean; ProcessBaseLine :Boolean; ProcessConstBaseline :Boolean = True) :Boolean;
  function LoadDataChannelProcess(Buffer :TPAInteger; ChannelIndex :Integer; Sel :TQUB_FirstLast; FilterOn :Boolean; FilterFreq :Double; BaseLineOn :Boolean; ProcessConstBaseline :Boolean = True) :Boolean;
  function LoadDataProcessed(Buffer :TPMInteger; Sel :TQUB_FirstLast) :Boolean;

  //Baseline
  procedure ApplyBaseLineNodes(ChannelIndex :Integer; NodeCount :Integer; Nodes, NodesDBl :TPAInteger; Combine :Boolean; Baseline :Integer);
  procedure AddBaseLineNodes(ChannelIndex :Integer; NodeCount :Integer; Nodes, NodesDBl :TPAInteger);
  procedure DelBaseLineNodes(ChannelIndex :Integer; Sel :TQUB_FirstLast);
  procedure ClearBaseLineNodes(ChannelIndex :Integer);


  //Browse .....................................................................
  procedure Browse(Command :TQUB_QVO_QVD_Command; var Position, Max :Integer; Display, SetScroll, Process, ForceCache, Appending, SetZoom :Boolean);

  //Data Message
  procedure DataMessage(WParam :WPARAM; LParam :LPARAM);
  procedure RefreshLists;


  //Lock
  procedure LockWrite; override;
  procedure UnLockWrite; override;
  procedure LockReadWrite; override;
  procedure UnLockReadWrite; override;
  procedure LockRecord;
  procedure UnLockRecord;
  procedure LockPlayback;
  procedure UnLockPlayback;


  function WhichTimeForPoint(p :Integer; Relative :Boolean = False): Double;
  function WhichSegmentForPoint(p :Integer) :Integer;
  function WhichPointForTrace(t :Integer) :Integer;
  function WhichPointForPage(p :Integer) :Integer;
  function WhichTraceForPoint(p :Integer) :Integer;
  function WhichPointForLast(p :Integer) :Integer;
  function WhichPointForFirst(p :Integer) :Integer;
  function WhichSegmentFirstForPoint(p :Integer) :Integer;
  function WhichSegmentLastForPoint(p :Integer) :Integer;
  function WhichSegmentFirstForSegment(s :Integer) :Integer;



  property PyHandle                            :TQUB_Python_Data       read prPyHandle;

  property DisplayProperties                   :INode                  read prDisplayProperties;

  //All the interactive properties must be here ********************************

  //Colors
  property ColorData[Index :Integer]           :TColor                 read prGetColorData              write prSetColorData;
  property ColorSel                            :TColor                 read prColorSel                  write prSetColorSel;
  property ColorBreak                          :TColor                 read prColorBreak                write prSetColorBreak;
  property ColorBaseline                       :TColor                 read prColorBaseline             write prSetColorBaseline;
  property ColorBaselineNodes                  :TColor                 read prColorBaselineNodes        write prSetColorBaselineNodes;
  property ColorIdealized                      :TColor                 read prColorIdealized            write prSetColorIdealized;
  property ColorIdealizedSel                   :TColor                 read prColorIdealizedSel         write prSetColorIdealizedSel;
  property ColorSelList                        :TColor                 read prColorSelList              write prSetColorSelList;
  property ColorParameters                     :TColor                 read prColorParameters           write prSetColorParameters;
  property ColorSegLabel                       :TColor                 read prColorSegLabel             write prSetColorSegLabel;
  property ColorCurr                           :TColor                 read prColorCurr                 write prSetColorCurr;

  property TracesPerPage                       :Integer                read prTracesPerPage             write prSetTracesPerPage;
  property PointsPerTrace                      :Integer                read prPointsPerTrace            write prSetPointsPerTrace;

  property CacheSize                           :Integer                read prCacheSize                 write prSetCacheSize;
  property Scaling                             :Double                 read prScaling                   write prSetScaling;
  property Sampling                            :Double                 read prSampling                  write prSetSampling;

  property TraceChangeOnBreak                  :Boolean                read prTraceChangeOnBreak        write prSetTraceChangeOnBreak;
  property OverlapChannels                     :Boolean                read prOverlapChannels           write prSetOverlapChannels;
  property OverlapTraces                       :Boolean                read prOverlapTraces             write prSetOverlapTraces;
  property DrawPoints                          :Boolean                read prDrawPoints                write prSetDrawPoints;
  property DrawActiveThick                     :Boolean                read prDrawActiveThick           write prSetDrawActiveThick;
  property DrawBaseline                        :Boolean                read prDrawBaseline              write prSetDrawBaseline;
  property DrawBaselineNodes                   :Boolean                read prDrawBaselineNodes         write prSetDrawBaselineNodes;
  property DrawSegLabels                       :Boolean                read prDrawSegLabels             write prSetDrawSegLabels;
  property DrawIdealized                       :Boolean                read prDrawIdealized             write prSetDrawIdealized;
  property DrawIdealizedAbove                  :Boolean                read prDrawIdealizedAbove        write prSetDrawIdealizedAbove;
  property DrawIdealizedColor                  :Boolean                read prDrawIdealizedColor        write prSetDrawIdealizedColor;
  property DrawListOverlapped                  :Boolean                read prDrawListOverlapped        write prSetDrawListOverlapped;
  property DrawSelList                         :Boolean                read prDrawSelList               write prSetDrawSelList;
  property DrawParameters                      :Boolean                read prDrawParameters            write prSetDrawParameters;
  property DrawMode                            :TQUB_QVO_QVD_DrawMode  read prDrawMode                  write prSetDrawMode;
  property DrawInverted                        :Boolean                read prDrawInverted              write prSetDrawInverted;
  property DrawRaster                          :Boolean                read prDrawRaster                write prSetDrawRaster;
  property DrawLabels                          :Boolean                read prDrawLabels                write prSetDrawLabels;
  property MarginH                             :Integer                read prMarginH                   write prSetMarginH;
  property MarginV                             :Integer                read prMarginV                   write prSetMarginV;

  //ScaleBar
  //property ScaleBarCount                       :TPoint                 read prScaleBarCount;
  property ScaleBarSamples                     :Integer                read prScaleBarSamples;
  property ScaleBarADUnits[Index :Integer]     :Integer                read prGetScaleBarADUnits;
  property ScaleBarPixel                       :TPoint                 read prScaleBarPixel;

  property AutoScale                           :Boolean                read prAutoScale                 write prSetAutoScale;
  property DataYMinAuto[Index :Integer]        :Integer                read prGetDataYMinAuto           write prSetDataYMinAuto;
  property DataYMaxAuto[Index :Integer]        :Integer                read prGetDataYMaxAuto           write prSetDataYMaxAuto;
  property DataYMin[Index :Integer]            :Integer                read prGetDataYMin               write prSetDataYMin;
  property DataYMax[Index :Integer]            :Integer                read prGetDataYMax               write prSetDataYMax;
  property DataYFactor[Index :Integer]         :Double                 read prGetDataYFactor            write prSetDataYFactor;

  property DrawItoG[Index :Integer]            :Boolean                read prGetDrawItoG               write prSetDrawItoG;

  property DataChannelName[Index :Integer]     :String                 read prGetDataChannelName        write prSetDataChannelName;
  property DataChannelUnits[Index :Integer]    :String                 read prGetDataChannelUnits       write prSetDataChannelUnits;
  property DataChannelScaling[Index :Integer]  :Double                 read prGetDataChannelScaling     write prSetDataChannelScaling;
  property DataChannelOffset[Index :Integer]   :Double                 read prGetDataChannelOffset      write prSetDataChannelOffset;

  //Graphics settings
  property XAxisTickCount                      :Integer                read prGetXAxisTickCount         write prSetXAxisTickCount;
  property YAxisTickCount[Index :Integer]      :Integer                read prGetYAxisTickCount         write prSetYAxisTickCount;

  property AutoScroll                          :Boolean                read prAutoScroll                write prAutoScroll;

  property ChannelVisible[Index :Integer]      :Boolean                read prGetChannelVisible         write prSetChannelVisible;
  property FilterOn[Index :Integer]            :Boolean                read prGetFilterOn               write prSetFilterOn;
  property FilterMAOn[Index :Integer]          :Boolean                read prGetFilterMAOn             write prSetFilterMAOn;
  property FilterFreq[Index :Integer]          :Double                 read prGetFilterFreq             write prSetFilterFreq;
  property FilterMACount[Index :Integer]       :Integer                read prGetFilterMACount          write prSetFilterMACount;

  property BaselineOn[Index :Integer]          :Boolean                read prGetBaselineOn             write prSetBaselineOn;
  property WarnOnBaseline[Index :Integer]      :Boolean                read prGetWarnOnBaseline         write prSetWarnOnBaseline;
  //****************************************************************************

  property ActiveChannel                       :Integer                read prActiveChannel             write prSetActiveChannel;

  property OnChangeLockRecord                  :TNotifyEvent           read prOnChangeLockRecord        write prOnChangeLockRecord;
  property OnChangeLockPlayback                :TNotifyEvent           read prOnChangeLockPlayback      write prOnChangeLockPlayback;

  property DataPointCount                      :Integer                read prDataPointCount;
  property DataChannelCount                    :Integer                read prDataChannelCount;
  property DataSegmentCount                    :Integer                read prDataSegmentCount;

  property DataBreakPoints                     :TPAInteger             read prDataBreakPoints;

  property ScrollBar                           :TScrollBar             read prScrollBar                 write prScrollBar;
  property Zoom                                :TQUB_QVO_QVT           read prZoom                      write prSetZoom;

  property ConteinerResults                    :TPanel                 read prConteinerResults          write prSetConteinerResults;
  property ConteinerList                       :TPanel                 read prConteinerLists            write prSetConteinerList;
  property ConteinerSel                        :TPanel                 read prConteinerList             write prSetConteinerSel;
  property ResultsList                         :TQUB_QVO_QVD_ResultsList    read prResultsList;
  property SelectionLists                      :TQUB_QVO_QVD_SelectionLists read prSelectionLists;
  property CurrList                            :TQUB_QVO_QVD_SelectionList  read prGetCurrList;
  property CurrListName                        :String                 read prGetCurrListName           write prSetCurrListName;

  property DataObject                          :TQUB_QFS_QDF           read prDataObject;

  property Data                                :TPMInteger             read prData;
  property DataChannelDisplay                  :TQUB_QVO_QVD_DataChannelDisplay read prDataChannelDisplay;

  property DataCurr                            :Integer                read prDataCurr                  write prSetDataCurr;
  property DataSel                             :TQUB_FirstLast         read prDataSel;
  property DataDraw                            :TQUB_FirstLast         read prDataDraw;
  property DataZoomSel                         :TQUB_FirstLast         read prDataZoomSel;
  property DataBaselineSel                     :TQUB_FirstLast         read prDataBaselineSel;
  property DataEraseSel                        :TQUB_FirstLast         read prDataEraseSel;
  property DataPoint                           :TQUB_FirstLast         read prDataPoint;

  property DataBaseline[Index :Integer]        :Integer                read prGetDataBaseline           write prSetDataBaseline;
  property BaselineNodes[Ix :Integer]          :TQUB_Baseline          read prGetBaselineNodes;

  property FitCurves                           :TQUB_FitCurves         read prFitCurves;

  //Markers
  property DataMarker                          :Integer                read prDataMarker;
  property DataMarkers                         :TPADouble              read prDataMarkers;
  property DataMarkersCh                       :TPAInteger             read prDataMarkersCh;
  property DataMarkersCount                    :Integer                read prDataMarkersCount;

  //Time Markers
  property DataTimeMarker                      :Integer                read prDataTimeMarker;
  property DataTimeMarkers                     :TPADouble              read prDataTimeMarkers;
  property DataTimeMarkersCount                :Integer                read prDataTimeMarkersCount;

  //Kinetic Parameters Markers
  property DataKinParamsMarker                 :Integer                read prDataKinParamsMarker;
  property DataKinParamsMarkers                :TPAInteger             read prDataKinParamsMarkers;
  property DataKinParamsMarkersPars            :TArrayofString         read prDataKinParamsMarkersPars;
  property DataKinParamsMarkersNote            :TArrayofString         read prDataKinParamsMarkersNote;
  property DataKinParamsMarkersCount           :Integer                read prDataKinParamsMarkersCount;

  property PropertiesForm                      :TQUB_QVO_QVD_XPropertiesForm               read prPropertiesForm                 write prPropertiesForm;
  property ChopPropertiesForm                  :TQUB_QVO_QVD_Chop_PropertiesForm           read prChopPropertiesForm             write prChopPropertiesForm;
  property PrintPropertiesForm                 :TQUB_QVO_QVD_Print_PropertiesForm          read prPrintPropertiesForm            write prPrintPropertiesForm;
  property EvtListProcessorPropertiesForm      :TQUB_Task_EvP_Properties                   read prEvtListProcessorPropertiesForm write prEvtListProcessorPropertiesForm;
  property GoToPointPropertiesForm             :TQUB_QVO_QVD_GoToPoint_PropertiesForm      read prGoToPointPropertiesForm        write prGoToPointPropertiesForm;
  property SelectionPropertiesForm             :TQUB_QVO_QVD_SelectionPropertiesForm       read prSelectionPropertiesForm        write prSelectionPropertiesForm;
               
  property ExpCond                             :TQUB_ExpCond_Parameters read prExpCond                  write prExpCond;
  property CurrModel                           :TQUB_QVO               read prCurrModel                 write prCurrModel;

  property LockedRecord                        :Boolean                read prGetLockedRecord;
  property LockedPlayback                      :Boolean                read prGetLockedPlayback;

  property Recording                           :Boolean                read prRecording                 write prRecording;

  property PrintDrawData                       :Boolean                read prPrintDrawData             write prPrintDrawData;
  property PrintDrawIDLData                    :Boolean                read prPrintDrawIDLData          write prPrintDrawIDLData;
  property PrintDrawBase                       :Boolean                read prPrintDrawBase             write prPrintDrawBase;
  property PrintDrawMode                       :TQUB_QVO_QVD_DrawMode  read prPrintDrawMode             write prPrintDrawMode;

  property ActOnHiRes                          :Boolean                                                 write prSetActOnHiRes;

  property Closing                             :Boolean                read prClosing                   write prClosing;

  property Listed                              :Boolean                read prListed                    write prSetListed;

  property PopUpComponent                      :TComponent                                              write prSetPopUpComponent;


end;
//..............................................................................


TQUB_Python_DataResults = class;
TQUB_Python_DataLists = class;
TQUB_Python_DataList = class;

TQUB_Python_Data = class(TPyObject)
protected


  prData              :TQUB_QVO_QVD;

  prResultsPy         :TQUB_Python_DataResults;
  prListsPy           :TQUB_Python_DataLists;

  prActiveChannel     :Integer;
  prListed            :Boolean;
  prListName          :String;
  prPyList            :PPyObject;
  prSel               :TQUB_FirstLast;
  prConfig            :PPyObject;
  prResults           :INode;
  prCurrResults       :PPyObject;
  prNode              :INode;


  procedure prSetData(x :TQUB_QVO_QVD);
  procedure prSetActiveChannel;
  procedure prSetListed;
  procedure prChooseList;
  procedure prGetList;
  procedure prSetList;
  procedure prSelect;
  procedure prCopyImage;
  procedure prAddResults;
  procedure prGetCurrResults;
  procedure prSetFitCurve;


public


  destructor Destroy; override;


  function  GetAttr(key : PChar) : PPyObject; override;
  function  SetAttr(key : PChar; value : PPyObject) : Integer; override;

  // Class methods
  class procedure RegisterMethods( PythonType : TPythonType ); override;
  function ChooseList( args :PPyObject ): PPyObject; cdecl;
  function GetList( args :PPyObject ): PPyObject; cdecl;
  function SetList( args :PPyObject ): PPyObject; cdecl;
  function Select( args :PPyObject ): PPyObject; cdecl;
  function TimeOfPoint( args :PPyObject ): PPyObject; cdecl;
  function PointOfTime( args :PPyObject ): PPyObject; cdecl;
  function CopyImage( args :PPyObject ): PPyObject; cdecl;
  function AddResults( args :PPyObject ): PPyObject; cdecl;
  function GetBaseline( args :PPyObject ): PPyObject; cdecl;
  function GetIdealization( args :PPyObject ): PPyObject; cdecl;
  function SetFitCurve( args :PPyObject ): PPyObject; cdecl;


  property Data   :TQUB_QVO_QVD  read prData   write prSetData;


end;


TQUB_Python_DataResults = class(TPyObject)
protected
  prData              :TQUB_QVO_QVD;

  prResultNode        :INode;
  prResultIx          :Integer;

  procedure prGetLength;
  procedure prGetItem;
  procedure prAdd;
  procedure prDelete;
  procedure prChoose;

public

  // Python interface:
  function  GetAttr(key : PChar) : PPyObject; override;
  function  SqLength : Integer; override;
  function  SqItem( idx : Integer ) : PPyObject; override;

  class procedure RegisterMethods( PythonType : TPythonType ); override;
  function AddPy( args :PPyObject ): PPyObject; cdecl;
  function DeletePy( args :PPyObject ): PPyObject; cdecl;
  function ChoosePy( args :PPyObject ): PPyObject; cdecl;

  property Data   :TQUB_QVO_QVD  read prData   write prData;

end;


TQUB_Python_DataLists = class(TPyObject)
protected
  prData              :TQUB_QVO_QVD;

  prList              :TQUB_QVO_QVD_SelectionList;
  prIx                :Integer;
  prName              :String;

  procedure prGetLength;
  procedure prGetItem;
  procedure prGetCurr;
  procedure prDelete;
  procedure prIndexOf;
  procedure prByName;
  procedure prChoose;
  procedure prRename;

public

  // Python interface:
  function  GetAttr(key : PChar) : PPyObject; override;
  function  SqLength : Integer; override;
  function  SqItem( idx : Integer ) : PPyObject; override;

  class procedure RegisterMethods( PythonType : TPythonType ); override;
  function DeletePy( args :PPyObject ): PPyObject; cdecl;
  function IndexOfPy( args :PPyObject ): PPyObject; cdecl;
  function ByNamePy( args :PPyObject ): PPyObject; cdecl;
  function ChoosePy( args :PPyObject ): PPyObject; cdecl;
  function RenamePy( args :PPyObject ): PPyObject; cdecl;

  property Data   :TQUB_QVO_QVD  read prData   write prData;

end;


TQUB_Python_DataList = class(TPyObject)
protected
  prList              :TQUB_QVO_QVD_SelectionList;

  prSel               :TQUB_FirstLast;
  prIx                :Integer;
  prName              :String;
  prTree              :INode;

  procedure prGetAsTree;
  procedure prGetLength;
  procedure prGetItem;
  procedure prAdd;
  procedure prDelete;
  procedure prClear;
  procedure prRename;
  procedure prSetFromTree;

public

  // Python interface:
  function  GetAttr(key : PChar) : PPyObject; override;
  function  SqLength : Integer; override;
  function  SqItem( idx : Integer ) : PPyObject; override;

  class procedure RegisterMethods( PythonType : TPythonType ); override;
  function AddPy( args :PPyObject ): PPyObject; cdecl;
  function DeletePy( args :PPyObject ): PPyObject; cdecl;
  function ClearPy( args :PPyObject ): PPyObject; cdecl;
  function RenamePy( args :PPyObject ): PPyObject; cdecl;
  function SetFromTreePy( args :PPyObject ): PPyObject; cdecl;

  property List   :TQUB_QVO_QVD_SelectionList  read prList   write prList;

end;


TQUB_QVO_QVD_DataBuffer = class
protected
  prData                  :TQUB_QVO_QVD;
  prProcess               :Boolean;
  prBuffer                :TPMInteger;
  prBufferCount           :Integer;
  prBaseIndex             :Integer;

public
  constructor Create(AData :TQUB_QVO_QVD; ABufferCount :Integer; AProcess :Boolean);
  destructor Destroy; override;

  function LoadFrom(i :Integer): Boolean;
  function ValueAt(ch, i :Integer): Double;

  property Buffer         :TPMInteger         read prBuffer;
  property BufferCount    :Integer            read prBufferCount;
  property BaseIndex      :Integer            read prBaseIndex;
end;


TQUB_QVO_QVD_DataBufferOne = class
protected
  prData                  :TQUB_QVO_QVD;
  prChannelIndex          :Integer;
  prScaling               :Double;
  prOffset                :Double;
  prProcess               :Boolean;
  prProcessConstBaseline  :Boolean;
  prProcessBaseline       :Boolean;
  prProcessFilter         :Boolean;
  prFitCurve              :Boolean;
  prBuffer                :TPAInteger;
  prBufferCount           :Integer;
  prBaseIndex             :Integer;


  function prLoadDataFrom(i :Integer): Boolean;
  function prLoadFitFrom(First :Integer): Boolean;


public


  constructor Create(AData :TQUB_QVO_QVD; AChannelIndex, ABufferCount :Integer; AProcess, AFitCurve :Boolean; AProcessConstBaseline :Boolean = True; AProcessBaseline :Boolean = True; AProcessFilter :Boolean = True);
  destructor Destroy; override;


  function LoadFrom(i :Integer): Boolean;
  function ValueAt(i :Integer): Double;


  property Buffer         :TPAInteger         read prBuffer;
  property BufferCount    :Integer            read prBufferCount;
  property BaseIndex      :Integer            read prBaseIndex;
  property Scaling        :Double             read prScaling;


end;


var


DataPyType                        :TPythonType;
DataResultsPyType                 :TPythonType;
DataListsPyType                   :TPythonType;
DataListPyType                    :TPythonType;


procedure InitDataPyTypes;


procedure Register;

//DLL Functions
function DLLFilterIntData(source_data, dest_data :TPAInteger; data_count :Integer; dt :Double{seconds}; freq :Double{Hz}; fft_count :Integer) :Integer; stdcall; external 'qublib.dll' name '_filterintdata@32';
function DLLFilterIntData_nfir(freq{Hz}, dt :Double{seconds}) :Integer; stdcall; external 'qublib.dll' name '_filterintdata_nfir@16';

function DLLFilterDoubleData(source_data, dest_data :TPADouble; data_count :Integer; dt :Double{seconds}; freq :Double{kHz}) :Integer; stdcall; external 'qublib.dll' name '_filterdatad@28';
function DLLFilterDoubleData_Notch(source_data, dest_data :TPADouble; data_count :Integer; dt :Double; LowHz, HighHz :Double; TransitionWidth :Double; fft_count :Integer) :Integer; stdcall; external 'qublib.dll' name '_filterdatad_notch@48';
function DLLFilterDoubleData_nfir_Notch(TransitionWidth :Double; Sampling :Double):Integer; stdcall; external 'qublib.dll' name '_filterdatad_nfir_notch@16';


//******************************************************************************
implementation


uses


{$IFDEF DELPHI6_OR_HIGHER}
Variants,
{$ENDIF}
MessageCheckDialog,
QUB_QtiPlot,
QUB_QVO_QVD_Play,
QUB_QVO_QVR,
QUB_GUIInterface,
QUB_Viewport_Data,
QUB_Viewport_Model,
QUB_QVO_QVM,
QUB_Task_EvP,
QUB_Node_Python,
QUB_Viewport_Python,
QUB_Main,
QUB_Task,
QUB_Task_Data;


//****************************************************************************//
//                                                                            //
//                               QUB_QVO_QVD                                  //
//                                                                            //
//****************************************************************************//
constructor TQUB_QVO_QVD.Create(AOwner :TComponent);
begin
  inherited Create(AOwner);

  prDataMarker         := -1;
  prDataTimeMarker     := -1;
  prDataKinParamsMarker:= -1;

  prDataMsgCritSection := TCriticalSection.Create;

  prExpCond            := TQUB_ExpCond_Parameters.Create;
  prExpCond.Events.AddEvent('OnChange', DoOnExpCondChanged);

  prHintCycle          := 0;

  prClosing            := False;

  //Create the data object and set its events
  prDataObject         := TQUB_QFS_QDF.Create(CHANNELS_DATA_FILE_NAME, nil);
  prDataObject.QVDParent := Self;
  prDataObject.Permanent := True;
  prDisplayProperties  := prDataObject.Session['Display'];

  prAddDataEvents(DataObject);

  //PopUp Menu
  prCreatePopUpMenu;

  //Selection List
  prSelectionListPanel             := TPanel.Create(Self);
  prSelectionListPanel.Align       := alClient;
  prSelectionListPanel.BevelOuter  := bvNone;
  prSelectionLists                 := TQUB_QVO_QVD_SelectionLists.Create(Self);
  prSelectionLists.Color           := clBtnFace;
  prSelectionLists.OnKeyDown       := prOnSelectionListsKeyDown;
  prSelectionLists.OnItemChange    := prOnSelectionListsItemChange;
  prSelectionLists.OnItemDblClick  := prOnSelectionListsItemDblClick;
  prSelectionLists.OnMouseDown     := TFrame(AOwner).OnMouseDown;
  prSelectionLists.PopupMenu       := prSelectionListsPopupMenu;
  m_lListLoading                   := False;

  //Results List
  prResultsList                    := TQUB_QVO_QVD_ResultsList.Create(Self);
  prResultsList.Color              := clBtnFace;
  prResultsList.OnKeyDown          := prOnResultsListKeyDown;
  prResultsList.OnItemChange       := prOnResultsListItemChange;
  prResultsList.OnItemDblClick     := prOnResultsListItemDblClick;
  prResultsList.OnMouseDown        := TFrame(AOwner).OnMouseDown;

  prMenuCaller                     := Self;

  prDrawFocusRect                  := True;

  //To give some initial values, before any calculations are made:
  prSetInitialProperties;

  prSelectable                     := True;

  prResetData;

  ShowHint                         := True;

  prSelListNameCount               := 1;

  //Flags
  prMustRedraw                     := True;

  PythonThread.SneakPyProc( prCreatePyInstance );

  prFitCurves                      := TQUB_FitCurves.Create;
  prFitCurves.Events.AddEvent('OnChanged', DoOnFitCurvesChanged);
  prFitCurves.UseTempFile;
end;

procedure TQUB_QVO_QVD.prCreatePyInstance;
var
  PyInst                  :PPyObject;
begin
  PyInst                  := DataPyType.CreateInstance;
  prPyHandle              := TQUB_Python_Data( PythonToDelphi(PyInst) );
  prPyHandle.Data         := Self;
end;

procedure TQUB_QVO_QVD.prCleanupPyInstance;
begin
  prPyHandle.Data         := nil;
  GetPythonEngine.Py_DECREF( prPyHandle.GetSelf );
end;

destructor TQUB_QVO_QVD.Destroy;
begin
  if Play_Data = Self then Play_Stop(Play_Data);

  try

    PythonThread.SneakPyProc( prCleanupPyInstance );

    prDelDataEvents(prDataObject);

    prZoom := nil;

    prResetData;

    prDataObject.Free;

    prDataMsgCritSection.Free;

    prExpCond.Free;

    prFitCurves.Free;

  finally

    inherited;

  end;

end;

//****************************************************************************//
//                                                                            //
//                   A C T I V A T E  /  D E A C T I V A T E                  //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVD.Activate;
var
  Cat          :TQUB_ProfileCat;
begin
  if not Active then begin
    if prZoom <> nil then prZoom.BringToFront;
    prResultsList.Activate;
    prSelectionLists.Activate;
    prSelectionListPanel.BringToFront;
  end;

  //testing. LM .....................
  //ViewportModel.ExpCond := ExpCond;
  //.................................

  inherited;
  prDoOnChangePage;
                                                            
  Cat          := ProfileMgr['QVD'];
  Cat.Active   := DisplayProperties;
  Cat.OnSet    := prOnSetDisplayProperties;
end;

procedure TQUB_QVO_QVD.DeActivate;
var
  Cat          :TQUB_ProfileCat;
  Foo          :TQUB_Profile_OnSet;
begin
  if Active then begin
    prResultsList.DeActivate;
    prSelectionLists.DeActivate;
  end;

  //testing. LM .................
  if Closing then begin
    ViewportModel.ExpCond := nil;
  end;
  //.............................

  inherited;
  prDoOnChangePage;

  Cat          := ProfileMgr['QVD'];
  Foo          := prOnSetDisplayProperties;
  if (@Cat.OnSet = @Foo)
  then Cat.OnSet := nil;
end;

procedure TQUB_QVO_QVD.prAddDataEvents(DataObject :TQUB_QFS_QDF);
begin
  DataObject.OnOpen             := DoOnFileOpen;
  DataObject.OnClose            := DoOnFileClose;
  DataObject.OnEdit             := DoOnFileEdit;
  DataObject.OnInfoEdit         := DoOnFileInfoEdit;
  DataObject.OnAddSeries        := DoOnAddSeries;
  DataObject.OnAddSweep         := DoOnAddSweep;
end;

procedure TQUB_QVO_QVD.prDelDataEvents(DataObject :TQUB_QFS_QDF);
begin
  DataObject.OnOpen             := nil;
  DataObject.OnClose            := nil;
  DataObject.OnEdit             := nil;
  DataObject.OnInfoEdit         := nil;
  DataObject.OnAddSeries        := nil;
  DataObject.OnAddSweep         := nil;
end;


procedure TQUB_QVO_QVD.prCreatePopUpMenu;
var
  ItemPos :Integer;
begin

  inherited;

  //----- Menu revised 5-2004 - wrapped in function calls {JB}
  //----- ZOOM menu
  ItemPos := 0;
  
  prExpandZoomItem       := AddPopUpMenuItem(ShortCut(Word('H'), [ssCtrl]), 'Expand', prOnExpandZoom, prPopUpMenu, ItemPos);
  prUnExpandZoomItem     := AddPopUpMenuItem(ShortCut(Word('U'), [ssCtrl]), 'Un-Expand', prOnUnExpandZoom, prPopUpMenu, ItemPos);
                            AddPopUpMenuItem(0, '-', nil, prPopUpMenu, ItemPos);

  //----- Baseline menu
  prSetBaselineItem      := AddPopUpMenuItem(ShortCut(Word('B'), [ssCtrl]), 'Set Baseline', prOnSetBaseline, prPopUpMenu, ItemPos);
  prNodesAddItem         := AddPopUpMenuItem(ShortCut(Word('N'), []), 'Add a baseline node', prOnNodesAdd, prPopUpMenu, ItemPos);
  prBaselineExtrasItem   := AddPopUpMenuItem(0, 'Baseline', nil, prPopUpMenu, ItemPos);
                            AddPopUpMenuItem(0, '-', nil, prPopUpMenu, ItemPos);
  // Submenu
                            AddPopUpMenuItem(0, 'Edit constant baseline...', prOnBaselineEdit, nil, TPInteger(nil)^, prBaselineExtrasItem);
  prNodesDelItem         := AddPopUpMenuItem(ShortCut(Word('M'), []), 'Delete selected nodes', prOnNodesDel, nil, TPInteger(nil)^, prBaselineExtrasItem);
  prNodesDelAllItem      := AddPopUpMenuItem(0, 'Delete all nodes', prOnNodesDelAll, nil, TPInteger(nil)^, prBaselineExtrasItem);
                            AddPopUpMenuItem(0, 'Add Linear Fit Node', AddArthurNode, nil, TPInteger(nil)^, prBaselineExtrasItem);

  //Markers
  prVMarkersAddItem      := AddPopUpMenuItem(0, 'Add a marker', prOnVMarkersAdd, prPopUpMenu, ItemPos);
  prVMarkersDelItem      := AddPopUpMenuItem(0, 'Delete a marker', prOnVMarkersDel, prPopUpMenu, ItemPos);
  prVMarkersSetItem      := AddPopUpMenuItem(0, 'Set marker', prOnVMarkersSet, prPopUpMenu, ItemPos);
                            AddPopUpMenuItem(0, '-', nil, prPopUpMenu, ItemPos);

  //Time Markers
  prTMarkersAddItem      := AddPopUpMenuItem(0, 'Add a Time marker', prOnTMarkersAdd, prPopUpMenu, ItemPos);
  prTMarkersDelItem      := AddPopUpMenuItem(0, 'Delete a Time marker', prOnTMarkersDel, prPopUpMenu, ItemPos);
  prTMarkersDelAllItem   := AddPopUpMenuItem(0, 'Delete All Time markers', prOnTMarkersDelAll, prPopUpMenu, ItemPos);
                            AddPopUpMenuItem(0, '-', nil, prPopUpMenu, ItemPos);

  //Kinetic Marker
  prKMarkerSaveItem      := AddPopUpMenuItem(0, 'Save Kinetic Parameters', prOnKMarkerSave, prPopUpMenu, ItemPos);
                                                                                                         
  //-----Selection List
  prSelListDelItem       := AddPopUpMenuItem(0, '', prOnSelListDel, prPopUpMenu, ItemPos);
  prSelListPropertiesItem:= AddPopUpMenuItem(0, '', prOnSelListProperties, prPopUpMenu, ItemPos);
                            AddPopUpMenuItem(0, '-', nil, prPopUpMenu, ItemPos);

  //-----Curve Fit
  prCurveFitItem         := AddPopUpMenuItem(0, 'Curve Fitting...', prOnCurveFit, prPopUpMenu, ItemPos);
  prCopyFitItem          := AddPopUpMenuItem(0, 'Copy fit curve', prOnCopyFit, prPopUpMenu, ItemPos);
  prDelFitItem           := AddPopUpMenuItem(0, 'Clear fit curve', prOnDelFit, prPopUpMenu, ItemPos);
                            AddPopUpMenuItem(0, '-', nil, prPopUpMenu, ItemPos);

  //-----Edit
  prEditCutItem          := AddPopUpMenuItem(ShortCut(Word('X'), [ssCtrl]), '', prOnCut, prPopUpMenu, ItemPos);
  prEditCopyItem         := AddPopUpMenuItem(ShortCut(Word('C'), [ssCtrl]), '', prOnCopy, prPopUpMenu, ItemPos);
  prEditCopyListItem     := AddPopUpMenuItem(0, 'Copy list', prOnCopyList, prPopUpMenu, ItemPos);
  prEditCopyHintItem     := AddPopUpMenuItem(0, 'Copy tooltip', prOnCopyHint, prPopUpMenu, ItemPos);
  prEditPasteItem        := AddPopUpMenuItem(ShortCut(Word('V'), [ssCtrl]), '', prOnPaste, prPopUpMenu, ItemPos);
  prEditAppendItem       := AddPopUpMenuItem(0, 'Append', prOnAppend, prPopUpMenu, ItemPos);
  prEditDeleteItem       := AddPopUpMenuItem(ShortCut(VK_DELETE, []), '', prOnDelete, prPopUpMenu, ItemPos);
  prSetEraseItem         := AddPopUpMenuItem(0, 'Set Erase buffer', prOnSetErase, prPopUpMenu, ItemPos);
  prEditEraseItem        := AddPopUpMenuItem(ShortCut(Word('E'), [ssCtrl]), '', prOnErase, prPopUpMenu, ItemPos);
  prEditFillItem         := AddPopUpMenuItem(0, '', prOnFill, prPopUpMenu, ItemPos);
  prEditFillIdlItem      := AddPopUpMenuItem(0, '', prOnFillIdl, prPopUpMenu, ItemPos);
  prEditBreakItem        := AddPopUpMenuItem(ShortCut(13, [ssCtrl]), 'Brea&k segment', prOnBreak, prPopUpMenu, ItemPos);
                            AddPopUpMenuItem(0, '-', nil, prPopUpMenu, ItemPos);
  prEditUndoItem         := AddPopUpMenuItem(ShortCut(Word('Z'), [ssCtrl]), '&Undo', prOnUndo, prPopUpMenu, ItemPos);
                            AddPopUpMenuItem(0, '-', nil, prPopUpMenu, ItemPos);
  prEditJoinIdlItem      := AddPopUpMenuItem(ShortCut(Word('J'), []), '&Join Idl', prOnJoinIdl, prPopUpMenu, ItemPos);
  prEditDeleteIdlItem    := AddPopUpMenuItem(0, '', prOnDeleteIdl, prPopUpMenu, ItemPos);
  prEditDelAllIdlItem    := AddPopUpMenuItem(0, 'Delete entire idealization', prOnDelAllIdl, prPopUpMenu, ItemPos);
                            AddPopUpMenuItem(0, '-', nil, prPopUpMenu, ItemPos);
  prSendToItem           := AddPopUpMenuItem(0, 'Send to', nil, prPopUpMenu, ItemPos);

  //===== Selection Lists Menu - in lists list 0 rt click
  prSelectionListsPopupMenu       := TPopupMenu.Create(Self);
  ItemPos := 0;
  prListsSaveItem        := AddPopUpMenuItem(0, 'Save selection list',   prOnListsSave,   prSelectionListsPopupMenu, ItemPos);
  prListsLoadItem        := AddPopUpMenuItem(0, 'Load selection list',   prOnListsLoad,   prSelectionListsPopupMenu, ItemPos);
  prListsRenameItem      := AddPopUpMenuItem(0, 'Rename selection list', prOnListsRename, prSelectionListsPopupMenu, ItemPos);
                            AddPopUpMenuItem(0, '-',                     nil,             prSelectionListsPopupMenu, ItemPos);
  prListsCutItem         := AddPopUpMenuItem(ShortCut(Word('X'), [ssCtrl]), 'Cut selection lists',    prOnListsCut,    prSelectionListsPopupMenu, ItemPos);
  prListsCopyItem        := AddPopUpMenuItem(ShortCut(Word('C'), [ssCtrl]), 'Copy selection lists',   prOnListsCopy,   prSelectionListsPopupMenu, ItemPos);
  prListsPasteItem       := AddPopUpMenuItem(ShortCut(Word('V'), [ssCtrl]), 'Paste selection lists',  prOnListsPaste,  prSelectionListsPopupMenu, ItemPos);
  prListsDelItem         := AddPopUpMenuItem(ShortCut(VK_DELETE, []),       'Delete selection lists', prOnListsDel,    prSelectionListsPopupMenu, ItemPos);
                            AddPopUpMenuItem(0, '-',                     nil,             prSelectionListsPopupMenu, ItemPos);
  prListsListCutItem     := AddPopUpMenuItem(ShortCut(Word('X'), [ssShift, ssCtrl]), 'Cut selections',         prOnListCut,     prSelectionListsPopupMenu, ItemPos);
  prListsListCopyItem    := AddPopUpMenuItem(ShortCut(Word('C'), [ssShift, ssCtrl]), 'Copy selections',        prOnListCopy,    prSelectionListsPopupMenu, ItemPos);
  prListsListPasteItem   := AddPopUpMenuItem(ShortCut(Word('V'), [ssShift, ssCtrl]), 'Paste selections',       prOnListPaste,   prSelectionListsPopupMenu, ItemPos);
  prListsListDelItem     := AddPopUpMenuItem(ShortCut(VK_DELETE, [ssShift]),         'Delete selections',      prOnListDel,     prSelectionListsPopupMenu, ItemPos);

  //=====Selection List Menu in list of selection segments - rt click
  prSelectionListPopupMenu       := TPopupMenu.Create(Self);
  ItemPos := 0;
  prListCutItem          := AddPopUpMenuItem(ShortCut(Word('X'), [ssCtrl]), 'Cut selections',         prOnListCut,         prSelectionListPopupMenu, ItemPos);
  prListCopyItem         := AddPopUpMenuItem(ShortCut(Word('C'), [ssCtrl]), 'Copy selections',        prOnListCopy,        prSelectionListPopupMenu, ItemPos);
  prListPasteItem        := AddPopUpMenuItem(ShortCut(Word('V'), [ssCtrl]), 'Paste selections',       prOnListPaste,       prSelectionListPopupMenu, ItemPos);
  prListDelItem          := AddPopUpMenuItem(ShortCut(VK_DELETE, []),       'Delete selections',      prOnListDel,         prSelectionListPopupMenu, ItemPos);
                            AddPopUpMenuItem(0,                             '-',                      nil,                 prSelectionListPopupMenu, ItemPos);
  prListSelectAllItem    := AddPopUpMenuItem(ShortCut(Word('A'), [ssCtrl]), 'Select All',             prOnListSelectAll,   prSelectionListPopupMenu, ItemPos);
  prListInvertSelItem    := AddPopUpMenuItem(0,                             'Invert selection',       prOnListInvertSel,   prSelectionListPopupMenu, ItemPos);
  prListShiftSelItem     := AddPopUpMenuItem(0,                             'Shift selection',        prOnListShiftSel,    prSelectionListPopupMenu, ItemPos);
  prListExpandSelItem    := AddPopUpMenuItem(0,                             'Expand selection',       prOnListExpandSel,   prSelectionListPopupMenu, ItemPos);
  prListExtractListItem  := AddPopUpMenuItem(0,                             'Create list of selected...', prOnListExtractList, prSelectionListPopupMenu, ItemPos);
                            AddPopUpMenuItem(0,                             '-',                      nil,                 prSelectionListPopupMenu, ItemPos);
  prListPropertiesItem   := AddPopUpMenuItem(0,                             '&Properties...',         prOnListProperties,  prSelectionListPopupMenu, ItemPos);

  prPopupListSel         := -1;

end;

procedure TQUB_QVO_QVD.prSetPopUpComponent(PUC :TComponent);
begin
  prPopupMenu.PopUpComponent := PUC;
end;


//****************************************************************************//
//                                                                            //
//                                  F I L E                                   //
//                                                                            //
//****************************************************************************//
function TQUB_QVO_QVD.New(const FileName :String) :Boolean;
begin
  Result := prDataObject.New(FileName);

  if not Result then begin
    //Read properties from registry:
    prPropertiesRegistry(True{Read});

    prDisplayProperties := prDataObject.Session['Display'];
    prInitDisplayProperties;
  end;
end;

function TQUB_QVO_QVD.Open(const FileName :String) :Boolean;
begin
  Result := prDataObject.Open(FileName);

  if not Result then begin
    //Read properties from registry:
    prPropertiesRegistry(True{Read});

    prDisplayProperties := prDataObject.Session['Display'];
    prInitDisplayProperties;

    prReadSession;
  end;
end;

function TQUB_QVO_QVD.Open(const FileName :String; OpenStream :TStream) :Boolean;
begin
  Result := prDataObject.Open(FileName, OpenStream);


  if not Result then begin
    //Read properties from registry:
    prPropertiesRegistry(True{Read});

    prDisplayProperties := prDataObject.Session['Display'];
    prInitDisplayProperties;

    prReadSession;
  end;
  //Shouldn't do it, because chances are it's the same name but different data (on the fly)
  // but this is just interpreting the session read by qdf -- disable it there
end;

function TQUB_QVO_QVD.Save(const FileName :String) :Boolean;
begin
  prUpdateSession(DataObject.Session);

  //TO DO: LM. Check if FileName has the full path
  //if Modified or (ExtractFileExt(FileName) <> DataObject.FileExt) then begin
  if Modified or (FileName <> DataObject.FileName) then begin
    if Play_Data = Self then Play_Stop(Play_Data);
    Result := prDataObject.Save(FileName);
  end else begin
    Result := prDataObject.SaveSession;
  end;

  prDisplayProperties := prDataObject.Session['Display'];
  prInitDisplayProperties;
  prReadSession;
end;

function TQUB_QVO_QVD.CanSaveAs(var FileName :String; Confirmation :Boolean) :Boolean;
begin
  Result := prDataObject.CanSaveAs(FileName, Confirmation);
end;

function TQUB_QVO_QVD.CanLoadInfo(ChannelIndex :Integer) :Boolean;
begin
  Result := DataObject.CanLoadInfo(ChannelIndex);
end;

function TQUB_QVO_QVD.CanSaveInfo(ChannelIndex :Integer) :Boolean;
begin
  Result := DataObject.CanSaveInfo(ChannelIndex);
end;

function TQUB_QVO_QVD.CanLoadBaseNodes(ChannelIndex :Integer) :Boolean;
begin
  Result := True;
end;

function TQUB_QVO_QVD.CanSaveBaseNodes(ChannelIndex :Integer) :Boolean;
begin
  Result := True;//Check if Nodes exist
end;

function TQUB_QVO_QVD.Close :Boolean;
begin
  if (LockedAny) or (LockedRecord) or (LockedPlayback) then begin
    Result := True;
  end else begin
    if not DataObject.DiscardChanges then prUpdateSession(DataObject.Session);

    if Play_Data = Self then Play_Stop(Play_Data);
    Result := prDataObject.Close;
  end;
end;

function TQUB_QVO_QVD.OpenFromString(const MemFile :String) :Boolean;
begin
  Result := False;
end;

function TQUB_QVO_QVD.SaveToString(var MemFile :String; FileType :Integer) :Boolean;
begin
  if Play_Data = Self then Play_Stop(Play_Data);
  Result := False;
end;

//Idealized Data
function TQUB_QVO_QVD.LoadInfo(ChannelIndex :Integer; const FileName :String) :Boolean;
var
  DWT, Seg        :INode;
  SampMS          :Double;
  At              :Integer;
  AtD             :Double;
  Firsts, Lasts   :TPAInteger;
  Durs            :TPASingle;
  DwellCount      :Integer;
  i               :Integer;
begin

  Result := True;

  if Play_Data = Self then Play_Stop(Play_Data);

  if LockedReadWrite then begin
    MessageHelpDlg('File is read-locked and idealization cannot be loaded', mtError, [mbOK], 0, 'Error:Data_File_Read-locked');
    Exit;
  end;

  LockReadWrite;

  try

    DWT        := QUB_Idl_ReadDWT(FileName);
    if DWT.IsNull then Exit;

    SampMS     := Sampling * 1.0e3;

    Seg            := DWT.Find('Segment');
    while not Seg.IsNull do begin
      DwellCount   := Seg['DwellCount'].Data[0];
      Durs         := TPASingle( Seg['Durations'].DataPtr );
      Seg['Firsts'].SetupNumData( NODE_DATATYPE_LONGINT, DwellCount, 1 );
      Firsts       := TPAInteger( Seg['Firsts'].DataPtr );
      Seg['Lasts'].SetupNumData( NODE_DATATYPE_LONGINT, DwellCount, 1 );
      Lasts        := TPAInteger( Seg['Lasts'].DataPtr );

      DataObject.WhichPointForRealTime( Seg['start'].Data[0] * 1.0e-3, At );
      AtD          := At;

      for i := 0 to DwellCount - 1 do begin
        Firsts[i]  := Round(AtD);
        AtD        := AtD + Durs[i] / SampMS;
        Lasts[i]   := Max(Firsts[i], Round(AtD)-1);
      end;

      Seg.SetupNumData( NODE_DATATYPE_LONGINT, 2, 1 );
      Seg.Data[0]  := Firsts[0];
      Seg.Data[1]  := Lasts[ DwellCount-1 ];

      Seg          := Seg.SiblingSameName;
    end;

    DataObject.Idealization[ChannelIndex].Clear;
    DataObject.Idealization[ChannelIndex].SetDwells(DWT);

    Result := False;

  finally

    UnLockReadWrite;

  end;

end;

function TQUB_QVO_QVD.SaveInfo(ChannelIndex :Integer; const FileName :String) :Boolean;
var
  DS, Seg               :INode;
  DwellCount            :Integer;
  Classes               :TPAInteger;
  Durations             :TPASingle;
  Amp, Std              :INode;
  i, s                  :Integer;
  f                     :TextFile;
  FileOpened            :Boolean;
  Entry                 :Integer;

  DecSeparator          :Char;

begin
  DecSeparator          := DecimalSeparator; // to restore global setting at end
  DecimalSeparator      := '.'; // no decimal comma allowed

  Result := True;

  if Play_Data = Self then Play_Stop(Play_Data);

  if LockedReadWrite then begin
    MessageHelpDlg('File is read-locked and idealization cannot be saved', mtError, [mbOK], 0, 'Error:Data_File_Read-locked');
    Exit;
  end;

  LockWrite;

  FileOpened            := False;

  try

    DS     := DataObject.Idealization[ChannelIndex].ToTree;
    Seg    := DS.Find('Segment');
    if Seg.IsNull then  Exit;

    try
      AssignFile(f, FileName);
      ReWrite(f);
      FileOpened := True;
    except
      Console.NewEntry( 'Cannot open output file.'#13#10'Medium may be read-only or a file with the same name is in use', COLOR_TEXT);
      Exit;
    end;

    Entry := Console.NewEntry('Saving idealized file ' + FileName + ' ...', COLOR_TEXT);

    s      := 1;
    while not Seg.IsNull do begin
      Console.SetEntry(Entry, 'Saving idealized file ' + FileName + ' ... Segment ' + IntToStr(s), COLOR_TEXT);

      DwellCount   := Seg['DwellCount'].Data[0];
      Classes      := TPAInteger( Seg['Classes'].DataPtr );
      Durations    := TPASingle( Seg['Durations'].DataPtr );
      Amp          := Seg['amp'];
      Std          := Seg['sd'];

      // write header
      Write(f, Format('Segment: %d Dwells: %d Sampling(ms): %.16g Start(ms): %.16g ClassCount: %d',
                      [s, DwellCount, Sampling * 1.0e3,
                       WhichTimeForPoint(Seg.Data[0]) * 1.0e3, Amp.DataCount]) );

      for i := 0 to Amp.DataCount - 1 do begin
        Write(f, Format(' %.16g %.16g', [Double(Amp.Data[i]), Double(Std.Data[i])]));
      end;
      Write(f, #13#10);

      for i := 0 to DwellCount - 1 do begin
        Write(f, Format('%d'#9'%.12g'#13#10, [Classes[i], Durations[i]]));
      end;

      Inc(s);
      Seg  := Seg.SiblingSameName;
    end;

    Result := False;
    Console.SetEntry(Entry, 'Saving idealized file ' + FileName + ' ... Done.', COLOR_GRAY);

  finally

    if FileOpened then begin
      try
        CloseFile(f);
      except
      end;
    end;

    UnLockWrite;

    DecimalSeparator := DecSeparator;

  end;

end;

function TQUB_QVO_QVD.SaveInfoStat(ChannelIndex :Integer; const FileName :String) :Boolean;
var
  DS, Seg               :INode;
  DwellCount            :Integer;
  Classes               :TPAInteger;
  Durations             :TPASingle;
  Firsts, Lasts         :TPAInteger;
  Amp, Std              :INode;
  EvtAmp, EvtStd        :Double;
  EvtAmps               :Array of Double;
  SegData               :TPADouble;
  Off                   :Integer;
  i, s, j               :Integer;
  f                     :TextFile;
  FileOpened            :Boolean;
  Entry                 :Integer;
  Sel                   :TQUB_FirstLast;
  PartFirst, PartLast   :Integer;

  DecSeparator          :Char;

begin
  DecSeparator          := DecimalSeparator; // to restore global setting at end
  DecimalSeparator      := '.'; // no decimal comma allowed

  Result := True;

  if Play_Data = Self then Play_Stop(Play_Data);

  if LockedReadWrite then begin
    MessageHelpDlg('File is read-locked and idealization cannot be saved', mtError, [mbOK], 0, 'Error:Data_File_Read-locked');
    Exit;
  end;

  LockWrite;

  FileOpened            := False;

  try

    DS     := DataObject.Idealization[ChannelIndex].ToTree;
    DS['ProcessData'].SetData('AsDisplayed');
    Seg    := DS.Find('Segment');
    if Seg.IsNull then  Exit;

    try
      AssignFile(f, FileName);
      ReWrite(f);
      FileOpened := True;
    except
      Console.NewEntry( 'Cannot open output file.'#13#10'Medium may be read-only or a file with the same name is in use', COLOR_TEXT);
      Exit;
    end;

    Entry := Console.NewEntry('Saving idealized file ' + FileName + ' ...', COLOR_TEXT);

    s      := 1;
    while not Seg.IsNull do begin
      Console.SetEntry(Entry, 'Saving idealized file ' + FileName + ' ... Segment ' + IntToStr(s), COLOR_TEXT);

      DwellCount   := Seg['DwellCount'].Data[0];
      Classes      := TPAInteger( Seg['Classes'].DataPtr );
      Durations    := TPASingle( Seg['Durations'].DataPtr );
      Firsts       := TPAInteger( Seg['Firsts'].DataPtr );
      Lasts        := TPAInteger( Seg['Lasts'].DataPtr );
      Amp          := Seg['amp'];
      Std          := Seg['sd'];

      // write header
      Write(f, Format('Segment: %d Dwells: %d Sampling(ms): %.16g Start(ms): %.16g ClassCount: %d',
                      [s, DwellCount, Sampling * 1.0e3,
                       WhichTimeForPoint(Seg.Data[0]) * 1.0e3, Amp.DataCount]) );

      for i := 0 to Amp.DataCount - 1 do begin
        Write(f, Format(' %.16g %.16g', [Double(Amp.Data[i]), Double(Std.Data[i])]));
      end;
      Write(f, #13#10);

      // amp
      SetLength(EvtAmps, DwellCount);
      i        := 0; // to DwellCount - 1
      j        := Seg.Data[0];
      EvtAmp   := 0.0;
      Sel.First := Seg.Data[0];
      Sel.Last  := Seg.Data[1];
      PartFirst := Sel.First;
      while PartFirst <= Sel.Last do begin
        PartLast := Min(PartFirst + ONE_MEGABYTE - 1, Sel.Last);
        Seg.Data[0] := PartFirst;
        Seg.Data[1] := PartLast;
        FillDataSegment(Seg);
        SegData := TPADouble(Seg['Channel'].DataPtr);
        while j <= PartLast do begin
          while j <= Min(PartLast, Lasts[i]) do begin
            EvtAmp := EvtAmp + SegData[j-PartFirst];
            Inc(j);
          end;
          if j > Lasts[i] then begin
            EvtAmp := EvtAmp / (Lasts[i] - Firsts[i] + 1);
            EvtAmps[i] := EvtAmp;
            Inc(i);
            EvtAmp   := 0.0;
          end;
        end;

        PartFirst := PartLast + 1;
      end;

      // std
      i        := 0; // to DwellCount - 1
      j        := Seg.Data[0];
      EvtAmp   := EvtAmps[i];
      EvtStd   := 0.0;
      Sel.First := Seg.Data[0];
      Sel.Last  := Seg.Data[1];
      PartFirst := Sel.First;
      while PartFirst <= Sel.Last do begin
        PartLast := Min(PartFirst + ONE_MEGABYTE - 1, Sel.Last);
        Seg.Data[0] := PartFirst;
        Seg.Data[1] := PartLast;
        FillDataSegment(Seg);
        SegData := TPADouble(Seg['Channel'].DataPtr);
        while j <= PartLast do begin
          while j <= Min(PartLast, Lasts[i]) do begin
            EvtStd := EvtStd + (EvtAmp - SegData[j-PartFirst]) * (EvtAmp - SegData[j-PartFirst]);
            Inc(j);
          end;
          if j > Lasts[i] then begin
            EvtStd := EvtStd / (Lasts[i] - Firsts[i] + 1);

            Write(f, Format('%d'#9'%.12g'#9'%.16g'#9'%.16g'#13#10,
            [Classes[i], Durations[i], EvtAmp, EvtStd]));

            Inc(i);
            EvtAmp   := EvtAmps[i];
            EvtStd   := 0.0;
          end;
        end;

        Seg.RemoveChild(Seg['Channel']);// empty
        PartFirst := PartLast + 1;
      end;

      Inc(s);
      Seg  := Seg.SiblingSameName;
    end;

    Result := False;
    Console.SetEntry(Entry, 'Saving idealized file ' + FileName + ' ... Done.', COLOR_GRAY);

  finally

    if FileOpened then begin
      try
        CloseFile(f);
      except
      end;
    end;

    UnLockWrite;

    DecimalSeparator := DecSeparator;

  end;

end;

function TQUB_QVO_QVD.SaveInfoASCII(ChannelIndex :Integer; const FileName :String) :Boolean;
begin

  if Play_Data = Self then Play_Stop(Play_Data);

  if LockedReadWrite then begin
    Result := True;
    MessageHelpDlg('File is read-locked and idealization cannot be saved', mtError, [mbOK], 0, 'Error:Data_File_Read-locked');
    Exit;
  end;

  LockWrite;

  try

    Result := DataObject.Idealization[ChannelIndex].SaveASCII(FileName);

  finally

    UnLockWrite;

  end;

end;


function TQUB_QVO_QVD.LoadBaselineNodes(ChannelIndex :Integer; const FileName :String) :Boolean;
begin

  if Play_Data = Self then Play_Stop(Play_Data);

  if LockedReadWrite then begin
    Result := True;
    MessageHelpDlg('File is read-locked and baseline nodes cannot be loaded', mtError, [mbOK], 0, 'Error:Data_File_Read-locked');
    Exit;
  end;

  LockReadWrite;

  try

    Result := prLoadBaselineNodes(ChannelIndex, FileName);

  finally

    UnLockReadWrite;

  end;

end;

function TQUB_QVO_QVD.SaveBaselineNodes(ChannelIndex :Integer; const FileName :String) :Boolean;
begin

  if Play_Data = Self then Play_Stop(Play_Data);

  if LockedReadWrite then begin
    Result := True;
    MessageHelpDlg('File is read-locked and baseline nodes cannot be saved', mtError, [mbOK], 0, 'Error:Data_File_Read-locked');
    Exit;
  end;

  LockWrite;

  try

    Result := prSaveBaselineNodes(ChannelIndex, FileName);

  finally

    UnLockWrite;

  end;

end;


(*
  Baseline Nodes Data:     (.qbn : old-style)

    NodeCount :Integer;
    Baseline  :Integer;
    Nodes     :Array[1..NodeCount] of Integer
    NodesDBL  :Array[1..NodeCount] of Integer

  Baseline Nodes Data:     (.qbf : new-style)
    qubtree text format:
      BaselineSegments
      {
        Baseline = int offset
        BaselineSegment = First Last
        {
	  Sampling = %d #\ sec
          NodeCount = N
          (Points   Values
           0        -20
           ...         )
        }
      }
*)



procedure ResampleNodes( BaseSegs :INode; Multiplier :Double );
var
  Seg         :INode;
  Points      :TPAInteger;
  i, N        :Integer;
begin
  Seg := BaseSegs.Find('BaselineSegment');
  while not Seg.IsNull do begin
    try

      Seg.Data[0] := Integer( Round( Seg.Data[0] * Multiplier ) );
      Seg.Data[1] := Integer( Round( Seg.Data[1] * Multiplier ) );

      N         := Seg['NodeCount'].Data[0];
      Points    := TPAInteger(Seg['Points'].DataPtr);

      for i := 0 to N - 1 do begin
        Points[i] := Round( Multiplier * Points[i] );
      end;
    except
    end;

    Seg   := Seg.SiblingSameName;
  end;
end;



function TQUB_QVO_QVD.prLoadBaselineNodes(ChannelIndex :Integer; const FileName :String) :Boolean;
var
  FStream   :TFileStream;
  Baseline  :Integer;
  NodeCount :Integer;
  Nodes     :TPAInteger;
  NodesDBL  :TPAInteger;
  BaseChan  :INode;
  SampNode  :INode;
  SampMult  :Double;
begin

  Result    := False;

  if ExtractFileExt(FileName) = '.qbn' then begin // old-style

    FStream  := nil;
    Nodes    := nil;
    NodesDBL := nil;

    try

      try

        FStream := TFileStream.Create(FileName, fmOpenRead or fmShareDenyWrite);

        FStream.ReadBuffer(NodeCount, SizeOf(Integer));
        if (NodeCount < 1) or (NodeCount > MAX_NODECOUNT) then begin
          Result := True;
          Exit;
        end;

        Nodes    := IAlloc1(NodeCount);
        NodesDBL := IAlloc1(NodeCount);

        FStream.ReadBuffer(Baseline,    SizeOf(Integer));
        FStream.ReadBuffer(Nodes   [0], NodeCount * SizeOf(Integer));
        FStream.ReadBuffer(NodesDBL[0], NodeCount * SizeOf(Integer));

        ApplyBaseLineNodes(ChannelIndex, NodeCount, Nodes, NodesDBl, False{Combine}, Baseline);

      except

        Result := True;
        Exit;

      end;

    finally

      FStream.Free;
      FreeMem(Nodes);
      FreeMem(NodesDBL);

    end;

  end else begin // new-style

    try

      BaseChan   := TNode.CreateFromText(FileName);
      if BaseChan.Name = 'BaselineSegments' then begin
        SampNode := BaseChan.Find('Sampling');
        if SampNode.DataCount > 0 then begin
          SampMult := Double(SampNode.Data[0]) / Sampling;
          if SampMult <> 1.0 then begin
            ResampleNodes( BaseChan, SampMult );
          end;
        end;

        DataBaseLine[ChannelIndex] := ReadIntProperty( BaseChan.Find('Baseline'), prDataBaseline[ChannelIndex] );
        BaselineNodes[ChannelIndex].AddNodes( BaseChan );

        prDataMeasured := False;//?1
        DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA, 0);
        DoOnEdit;
      end;

    except
    end;

  end;

end;

function TQUB_QVO_QVD.prSaveBaselineNodes(ChannelIndex :Integer; const FileName :String) :Boolean;
var
  i         :Integer;
  BaseChan  :INode;
begin

  prUpdateSessionBaseline(DataObject.Session);

  BaseChan  := DataObject.Session['Baseline'].Find('BaselineSegments');
  i         := 0;
  while (i < ChannelIndex) and not BaseChan.IsNull do begin
    BaseChan := BaseChan.SiblingSameName;
    Inc(i);
  end;

  Result    := BaseChan.IsNull;
  if not Result then begin
    BaseChan['Sampling'].SetData( Sampling );
    BaseChan.SaveAsText(FileName);
  end;
  
end;

//Image
function TQUB_QVO_QVD.CopyImage(ShowProperties :Boolean) :Boolean;
begin
  prPrintPropertiesForm.Model := g_CurrModel();
  Result := prPrintPropertiesForm.Print(prMenuCaller, nil, True{CopyImage}, ShowProperties);
  prMenuCaller := Self;
end;


//Print
function TQUB_QVO_QVD.prGetMaxPrintPage :Integer;
begin              
  Result := WhichTraceForPoint(prDataPoint.Last);
  Result := (Result div prTracesPerPage) + 1;
end;


function TQUB_QVO_QVD.prPrint(Dlg :TPrintDialog) :Boolean;
begin
  prPrintPropertiesForm.Model := g_CurrModel();
  Result := prPrintPropertiesForm.Print(prMenuCaller, Dlg, False{CopyImage}, True{ShowProperties});
  prMenuCaller := Self;
end;



//****************************************************************************//
//                                                                            //
//                                  E D I T                                   //
//                                                                            //
//****************************************************************************//
function TQUB_QVO_QVD.CutSelection :Boolean;
begin
  if not LockedAny then begin
    if Play_Data = Self then Play_Stop(Play_Data);
    Result := prDataObject.CutSelection(prDataSel.First, prDataSel.Last, prCopyASCII);
  end else begin
    Result := True;
  end;
end;

function TQUB_QVO_QVD.CopySelection :Boolean;
begin
  if not LockedReadWrite then begin
    if Play_Data = Self then Play_Stop(Play_Data);
    Result := prDataObject.CopySelection(prDataSel.First, prDataSel.Last, prCopyASCII);
  end else begin
    Result := True;
  end;
end;

function TQUB_QVO_QVD.CopyList :Boolean;
begin
  if not LockedReadWrite then begin
    if Play_Data = Self then Play_Stop(Play_Data);
    Result := prDataObject.CopyList(CurrList, CurrListName, prCopyASCII);
  end else begin
    Result := True;
  end;
end;

function TQUB_QVO_QVD.PasteSelection :Boolean;
begin
  if not LockedAny then begin
    if Play_Data = Self then Play_Stop(Play_Data);
    Result := prDataObject.PasteSelection(prDataSel.First, prDataSel.Last);
  end else begin
    Result := True;
  end;
end;

function TQUB_QVO_QVD.AppendSelection :Boolean;
begin
  if not LockedAny then begin
    if Play_Data = Self then Play_Stop(Play_Data);
    Result := prDataObject.Append;
  end else begin
    Result := True;
  end;
end;

function TQUB_QVO_QVD.DeleteSelection :Boolean;
begin
  if not LockedAny then begin
    if Play_Data = Self then Play_Stop(Play_Data);
    Result := prDataObject.DeleteSelection(prDataSel.First, prDataSel.Last);
  end else begin
    Result := True;
  end;
end;

function TQUB_QVO_QVD.EraseSelection :Boolean;
begin
  if DataEraseSel.First = DataEraseSel.Last then begin
    Result := True;
    Exit;
  end;
  if not LockedAny then begin
    if Play_Data = Self then Play_Stop(Play_Data);
    Result := prDataObject.EraseSelection(prDataSel.First, prDataSel.Last, DataEraseSel.First, DataEraseSel.Last);
  end else begin
    Result := True;
  end;
end;

function TQUB_QVO_QVD.FillSelection :Boolean;
begin
  if not LockedAny then begin
    if Play_Data = Self then Play_Stop(Play_Data);
    Result := prDataObject.FillSelection(prDataSel.First, prDataSel.Last, ActiveChannel, 0);
  end else begin
    Result := True;
  end;
end;

function TQUB_QVO_QVD.FillIdlSelection :Boolean;
begin
  Result := False;
  if not LockedAny then begin
    prDataObject.Idealization[ActiveChannel].SetDwell(prDataSel.First, prDataSel.Last, 0);
  end else begin
    Result := True;
  end;
end;

function TQUB_QVO_QVD.AppendData(Buffer :Pointer; BufferSize, BufferCount :Integer; NewSegment :Boolean; StartTime :Double; Refresh, Acq :Boolean) :Boolean;
begin
  Result := False;
  try
    if (Buffer <> nil) and (BufferSize > 0) and (BufferCount > 0) then begin
      if Acq then begin
        Result := prDataObject.RecordData(Buffer, BufferSize, BufferCount, NewSegment, StartTime, Refresh);
      end else begin
        Result := prDataObject.AppendData(Buffer, BufferSize, BufferCount, NewSegment, StartTime, Refresh);
      end;
    end else begin
      DoOnFileEdit(prDataObject, EDIT_OPER_UPDATE, nil^, nil^);
    end;
  except
  end;
end;

function TQUB_QVO_QVD.NewSegment(StartTime :Double; Refresh :Boolean; ForceNewIfEmpty :Boolean) :Boolean;
begin
  Result := False;
  try
    Result := prDataObject.NewSegment(StartTime, Refresh, ForceNewIfEmpty);
  except
  end;
end;

function TQUB_QVO_QVD.ReplaceData(Buffer :Pointer; BufferSize :Integer; Sel :TQUB_FirstLast; Refresh :Boolean) :Boolean;
begin
  Result := False;
  try
    Result := prDataObject.ReplaceData(Buffer, BufferSize, Sel, Refresh);
  except
  end;
end;

function TQUB_QVO_QVD.Clear :Boolean;
begin
  if not LockedAny then begin
    if Play_Data = Self then Play_Stop(Play_Data);
    Result := prDataObject.Clear;
  end else begin
    Result := True;
  end;
end;


//****************************************************************************//
//                                                                            //
//                                 V I E W                                    //
//                                                                            //
//****************************************************************************//
function TQUB_QVO_QVD.ZoomIn(Factor :Single) :Boolean;
var
  Dy :Integer;
  Sgn:Integer;
  d  :Double;
begin
  Result := (prDataPointCount = 0);
  if Result then Exit;

  Dy  := DataYMax[ActiveChannel] - DataYMin[ActiveChannel];
  Sgn := 1;
  if Dy < 0 then begin
    Dy := - Dy;
    Sgn := -1;
  end;
  if Dy <= 1 then Exit;

  d := Dy / Factor;
  if d < 1 then d := 1;

  DataYMin[ActiveChannel] := Round(DataYMin[ActiveChannel] + d*Sgn);
  DataYMax[ActiveChannel] := Round(DataYMax[ActiveChannel] - d*Sgn);

  if DataYMin[ActiveChannel] = DataYMax[ActiveChannel] then DataYMax[ActiveChannel] := DataYMin[ActiveChannel] + 1*Sgn;

  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA, 0);
end;

function TQUB_QVO_QVD.ZoomOut(Factor :Single) :Boolean;
var
  Dy :Integer;
  Sgn:Integer;
  d  :Double;
begin
  Result := (prDataPointCount = 0);
  if Result then Exit;

  Dy  := DataYMax[ActiveChannel] - DataYMin[ActiveChannel];
  Sgn := 1;
  if Dy < 0 then begin
    Dy  := - Dy;
    Sgn := -1;
  end;

  d := Dy / Factor;
  if d < 1 then d := 1;
  DataYMin[ActiveChannel] := Round(DataYMin[ActiveChannel] - d*Sgn);
  DataYMax[ActiveChannel] := Round(DataYMax[ActiveChannel] + d*Sgn);

  if DataYMin[ActiveChannel] = DataYMax[ActiveChannel] then DataYMax[ActiveChannel] := DataYMin[ActiveChannel] + 1*Sgn;

  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA, 0);
end;

function TQUB_QVO_QVD.OffsetUp(Factor :Single) :Boolean;
var
  Dy  :Double;
  Sgn :Integer;
  Min :Integer;
  Max :Integer;
begin
  Result := (prDataPointCount = 0);
  if Result then Exit;

  if DataYMax[ActiveChannel] > DataYMin[ActiveChannel] then begin
    Sgn := 1;
  end else begin
    Sgn := -1;
  end;
  Dy := Abs((DataYMax[ActiveChannel] - DataYMin[ActiveChannel]) / Factor);
  if Dy < 1 then Dy := 1;
  Min := Round(DataYMin[ActiveChannel] - Dy*Sgn);
  Max := Round(DataYMax[ActiveChannel] - Dy*Sgn);
  if Min < QUB_QVO_QVD_MIN_DATAY then Min := QUB_QVO_QVD_MIN_DATAY;
  if Max > QUB_QVO_QVD_MAX_DATAY then Max := QUB_QVO_QVD_MAX_DATAY;
  DataYMin[ActiveChannel] := Min;
  DataYMax[ActiveChannel] := Max;

  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA, 0);
end;

function TQUB_QVO_QVD.OffsetDown(Factor :Single) :Boolean;
var
  Dy  :Double;
  Sgn :Integer;
  Min :Integer;
  Max :Integer;
begin
  Result := (prDataPointCount = 0);
  if Result then Exit;

  if DataYMax[ActiveChannel] > DataYMin[ActiveChannel] then begin
    Sgn := 1;
  end else begin
    Sgn := -1;
  end;
  Dy := Abs((DataYMax[ActiveChannel] - DataYMin[ActiveChannel]) / Factor);
  if Dy < 1 then Dy := 1;
  Min := Round(DataYMin[ActiveChannel] + Dy*Sgn);
  Max := Round(DataYMax[ActiveChannel] + Dy*Sgn);
  if Min < QUB_QVO_QVD_MIN_DATAY then Min := QUB_QVO_QVD_MIN_DATAY;
  if Max > QUB_QVO_QVD_MAX_DATAY then Max := QUB_QVO_QVD_MAX_DATAY;
  DataYMin[ActiveChannel] := Min;
  DataYMax[ActiveChannel] := Max;

  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA, 0);
end;

function TQUB_QVO_QVD.FindTrace :Boolean;
var
  Sel :TQUB_FirstLast;
  Min :Integer;
  Max :Integer;
  Val :Integer;
  Dy  :Integer;
  i   :Integer;
begin
  Result := (prDataPointCount = 0);
  if Result then Exit;

  Sel := prDataSel;
  if Sel.First < prDataDraw.First then Sel.First := prDataDraw.First;
  if Sel.Last  > prDataDraw.Last  then Sel.Last  := prDataDraw.Last;

  Min := prDataChannelDisplay[ActiveChannel, Sel.First - prDataDraw.First];
  Max := Min;
  for i := Sel.First + 1 to Sel.Last do begin
    Val := prDataChannelDisplay[ActiveChannel, i - prDataDraw.First];
    if Val < Min then Min := Val;
    if Val > Max then Max := Val;
  end;

  Dy := Max - Min;

  Min := Round(Min - Dy / 10);
  Max := Round(Max + Dy / 10);

  if Min = Max then begin
    Dec(Min);
    Inc(Max);
  end;

  if DataChannelScaling[ActiveChannel] > 0 then begin
    DataYMin[ActiveChannel] := Min;
    DataYMax[ActiveChannel] := Max;
  end else begin
    DataYMin[ActiveChannel] := Max;
    DataYMax[ActiveChannel] := Min;
  end;

  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA, 0);
end;

//Returns scaled values
function TQUB_QVO_QVD.GrabAvgStd(var Avg, Std :Double) :Boolean;
var
  Sel  :TQUB_FirstLast;
  Scl  :Double;
  n, p :Integer;
begin
  Result := True;

  if Zoom = nil  then begin
    Sel := DataSel;
  end else begin
    if ((DataZoomSel.First + (prDataDraw.First - prDataPoint.First)) >= DataSel.First) and ((DataZoomSel.Last + (prDataDraw.First - prDataPoint.First)) <= DataSel.Last) then begin
      Sel.First := DataZoomSel.First + prDataDraw.First - prDataPoint.First;//DataOffset;
      Sel.Last  := DataZoomSel.Last  + prDataDraw.First - prDataPoint.First;
      if Sel.First >= Sel.Last then begin
        Sel := DataSel;
      end;
    end else begin
      Sel := DataSel;
    end;
  end;

  if Sel.First >= Sel.Last then begin
    Result := False;
    Exit;
  end;

  if Sel.First < DataDraw.First then Sel.First := DataDraw.First;
  if Sel.Last  > DataDraw.Last  then Sel.Last  := DataDraw.Last;

  n := Sel.Last - Sel.First + 1;

  Scl  := 1 / Scaling;

  Avg := 0;
  Std := 0;
  try
    for p := Sel.First to Sel.Last do begin
      Avg := Avg + Scl * prDataChannelDisplay[prActiveChannel, p - prDataDraw.First];
    end;
  except
  end;
  Avg := Avg / n;
  try
    for p := Sel.First to Sel.Last do begin
      Std := Std + Sqr(Scl * prDataChannelDisplay[prActiveChannel, p - prDataDraw.First] - Avg);
    end;
  except
  end;
  if n > 1 then begin
    Std := Sqrt(Std / (n));
  end;

  Avg := Avg / prDataChannelScaling[prActiveChannel] + prDataChannelOffset[prActiveChannel];
  Std := Std / prDataChannelScaling[prActiveChannel] + prDataChannelOffset[prActiveChannel];

end;


//****************************************************************************//
//                                                                            //
//                                T A S K S                                   //
//                                                                            //
//****************************************************************************//
function TQUB_QVO_QVD.MoveSelectionIntoWindow(Sel :TQUB_FirstLast; Curr :Integer) :Boolean;
var
  w, l :LongInt;
begin
  Result := (prDataPointCount = 0);
  if Result then Exit;
  Result := (Sel.First < DataPoint.First) or (Sel.Last > DataPoint.Last) or (Sel.First > DataPoint.Last) or (Sel.Last < DataPoint.First);
  if Result then Exit;

  w := DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA;

  if not ((Sel.First >= prDataDraw.First) and (Sel.Last <= prDataDraw.Last)) then begin
    l := WhichPointForTrace(WhichTraceForPoint(Sel.First));
  end else begin
    l := prDataDraw.First;
  end;

  if l <> prDataDraw.First then begin
    w := w or DATA_MSG_SET_SCROLL or DATA_MSG_BROWSE_TO_P;
  end;

  prDataSel     := Sel;
  prSelMove     := Sel;
  if DataCurr <> -1 then begin
    prDataCurr  := Curr;
  end else begin
    prDataCurr  := Sel.Last;
  end;
  prDataOldCurr := prDataCurr;

  DataMessage(w, l);

  prSetHint;
end;

procedure TQUB_QVO_QVD.ExpandZoom;
var
  Sel  :TQUB_FirstLast;
  w, l :LongInt;
begin
  if (prDataPointCount = 0) then Exit;
  if prZoom = nil then Exit;

  if prDrawListOverlapped then begin

    Sel.First := prZoom.DataSel.First + prDataSel.First;
    Sel.Last  := prZoom.DataSel.Last  + prDataSel.First;

    prBeforeExpand := prDataSel;

    w := DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA;
    l := prDataDraw.First;

  end else begin

    Sel.First := prZoom.DataSel.First + prZoom.DataOffset;
    Sel.Last  := prZoom.DataSel.Last  + prZoom.DataOffset;
    if (Sel.First < DataPoint.First) or (Sel.Last > DataPoint.Last) or
       (Sel.First > DataPoint.Last) or (Sel.Last < DataPoint.First) or
       (Sel.Last = Sel.First) then Exit;

    prBeforeExpand := prDataSel;

    w := DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA;

    if not ((Sel.First >= prDataDraw.First) and (Sel.Last <= prDataDraw.Last)) then begin
      l := WhichPointForTrace(WhichTraceForPoint(Sel.First));
    end else begin
      l := prDataDraw.First;
    end;

    if l <> prDataDraw.First then begin
      w := w or DATA_MSG_SET_SCROLL or DATA_MSG_BROWSE_TO_P;
    end;

  end;//DrawListOverlapped

  prDataSel     := Sel;
  prSelMove     := Sel;
  prDataCurr    := Sel.Last;
  prDataOldCurr := prDataCurr;

  prExpanding   := True;

  DataMessage(w, l);

  prSetHint;

end;

procedure TQUB_QVO_QVD.UnExpandZoom;
var
  Sel  :TQUB_FirstLast;
  w, l :LongInt;
begin
  if (not prCanUnExpand) then Exit;
  if (prDataPointCount = 0) then Exit;

  if prDrawListOverlapped then begin

    Sel := prBeforeExpand;
    w := DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA;
    l := prDataDraw.First;

  end else begin

    Sel := prBeforeExpand;

    w := DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA;

    if not ((Sel.First >= prDataDraw.First) and (Sel.Last <= prDataDraw.Last)) then begin
      l := WhichPointForTrace(WhichTraceForPoint(Sel.First));
    end else begin
      l := prDataDraw.First;
    end;

    if l <> prDataDraw.First then begin
      w := w or DATA_MSG_SET_SCROLL or DATA_MSG_BROWSE_TO_P;
    end;

  end;//DrawListOverlapped

  prDataSel     := Sel;
  prSelMove     := Sel;
  prDataCurr    := Sel.Last;
  prDataOldCurr := prDataCurr;

  prCanUnExpand := False;

  DataMessage(w, l);

  prSetHint;

end;

function TQUB_QVO_QVD.AddIdlSegmentList :Boolean;
var
  List      :TQUB_QVO_QVD_SelectionList;
  s         :Integer;
  DS, Seg   :INode;
begin
  Result := LockedReadWrite;

  if Result then Exit;

  LockWrite;

  try

    m_lListLoading := True;

    s := prSelectionLists.Items.IndexOf('Idl Segments');
    if s = -1 then begin
      List                   := prAddList('Idl Segments');
      s                      := List.Items.Count - 1;
    end else begin
      List := TQUB_QVO_QVD_SelectionList(prSelectionLists.Items.Objects[s]);
      List.Clear;
    end;

    DS  := DataObject.Idealization[ActiveChannel].ToTree;
    Seg := DS.Find('Segment');
    while not Seg.IsNull do begin
      List.AddSelection(Seg.Data[0], Seg.Data[1], '');
      Seg := Seg.SiblingSameName;
    end;

    ChooseList(s);

  finally

    m_lListLoading := False;
    UnLockWrite;
    RefreshLists;

  end;

end;

function TQUB_QVO_QVD.AddSegmentList :Boolean;
var
  List      :TQUB_QVO_QVD_SelectionList;
  Sel       :TQUB_FirstLast;
  s, i      :Integer;
begin
  Result := LockedReadWrite;

  if Result then Exit;

  LockWrite;

  try

    m_lListLoading := true;
    s := prSelectionLists.Items.IndexOf('Segments');
    if s = -1 then begin
      List                   := prAddList('Segments');
      s                      := List.Items.Count - 1;
    end else begin
      List := TQUB_QVO_QVD_SelectionList(prSelectionLists.Items.Objects[s]);
      List.Clear;
    end;

    Sel.First := 0;
    for i := 0 to prDataSegmentCount - 1 do begin
      Sel.Last := prDataBreakPoints[i] - 1;
      List.AddSelection(Sel.First, Sel.Last, '');
      Sel.First := Sel.Last + 1;
    end;
    m_lListLoading := false;

    ChooseList(s);
  
  finally

    m_lListLoading := false;
    UnLockWrite;
    RefreshLists;

  end;

end;


//Chop *************************************************************************
(*
i had converted the old form to QUB_Properties style.
for now lorin's revisions are intact below,
and chop inherits from QUB_Classic_Properties

procedure TQUB_QVO_QVD.prOnGetChopProperties(Sender :TObject);
begin
  with Sender as TQUB_QVO_QVD_Chop_PropertiesForm do begin
    Self.prChopSkipBeforePoints := Properties['SkipBeforePoints'].Data[0];
    Self.prChopSkipAfterPoints  := Properties['SkipAfterPoints'].Data[0];
    Self.prChopGetPoints        := Properties['GetPoints'].Data[0];
    Self.prChopIgnoreSegments   := 0<>Properties['IgnoreSegments'].Data[0];
    Self.prChopOnce             := 0<>Properties['OncePerSegment'].Data[0];
    Self.prChopDiscardPartial   := 0<>Properties['DiscardPartial'].Data[0];
    Self.prChopOutputList       := Properties['OutputList'].DataAsString;
  end;//with
end;
*)
procedure TQUB_QVO_QVD.prOnGetChopProperties(Sender :TObject);
begin
  with Sender as TQUB_QVO_QVD_Chop_PropertiesForm do begin
    Self.prChopSkipBeforePoints := SkipBeforePoints;
    Self.prChopSkipAfterPoints  := SkipAfterPoints;
    Self.prChopGetPoints        := GetPoints;
    Self.prChopIgnoreSegments   := IgnoreSegments;
    Self.prChopOnce             := Once;
    Self.prChopDiscardPartial   := DiscardPartial;
    Self.prChopAddToList        := AddToList;
    Self.prChopOutputList       := OutputList;
    Self.prChopUseGetList       := UseGetList;
    Self.prChopGetListName      := GetListName;
  end;//with
end;

procedure TQUB_QVO_QVD.prOnPutChopProperties(Sender :TObject);
begin
  with Sender as TQUB_QVO_QVD_Chop_PropertiesForm do begin
    SamplingTime := Self.Sampling;
  end;//with
end;

function TQUB_QVO_QVD.ChopSegments(Properties :Boolean) :Boolean;
var
  DS, Seg   :INode;
  NextSeg   :INode;
  List      :TQUB_QVO_QVD_SelectionList;
  GetList   :TQUB_QVO_QVD_SelectionList;
  Sel       :TQUB_FirstLast;
  Entry     :Integer;
  f, l, ll  :Integer;
  s         :Integer;
  NewListIx :Integer;
  i         :Integer;
begin

  DS        := GetChosenData;

  Result    := LockedReadWrite;

  if Result then Exit;

  LockWrite;

  m_lListLoading := True;

  try

    prChopPropertiesForm.OnGetProperties := prOnGetChopProperties;
    prChopPropertiesForm.OnPutProperties := prOnPutChopProperties;
    prChopPropertiesForm.SamplingTime    := Sampling;

    if (Properties) or (Result) then begin
      // 12/05 - Preload current selection offset within segment as 'Grab' parameters for chop properties.
      i := WhichSegmentFirstForPoint(prDataSel.First);
      prChopPropertiesForm.m_iGrabStart := prDataSel.First - i;
      prChopPropertiesForm.m_iGrabLength := min( prDataSel.Last, WhichSegmentLastForPoint(prDataSel.First) )- i;

      prChopPropertiesForm.ShowModal;
    end else begin
      prChopPropertiesForm.FormShow(prChopPropertiesForm);
      prChopPropertiesForm.ModalResult := mrOK;
      prChopPropertiesForm.btnOKClick(prChopPropertiesForm);
    end;

    Result := prChopPropertiesForm.ModalResult = mrCancel;
    if Result then Exit;

    //Create the output list if it doesn't exist
    s := prSelectionLists.Items.IndexOf(prChopOutputList);
    if s = -1 then begin
      List                   := prAddList(prChopOutputList);
      NewListIx              := List.Items.Count - 1;
    end else begin
      List := TQUB_QVO_QVD_SelectionList(prSelectionLists.Items.Objects[s]);
      if not prChopAddToList then List.Clear;
      NewListIx              := s;
    end;

    //Find the GetList
    GetList := nil;
    if prChopUseGetList then begin
      s := prSelectionLists.Items.IndexOf(prChopGetListName);
      if s <> -1 then begin
        GetList := TQUB_QVO_QVD_SelectionList(prSelectionLists.Items.Objects[s]);
      end else begin
        Result := True;
        Console.NewEntry('Segment chopper error: no GetList selected', COLOR_ERROR);
        Exit;
      end;
      if GetList.Items.Count = 0 then begin
        Result := True;
        Console.NewEntry('Segment chopper error: GetList ''' + prChopGetListName + ''' is empty!', COLOR_ERROR);
        Exit;
      end;
    end;

    Screen.Cursor := crHourglass;
    Entry := Console.NewEntry('Segment chopper ...', COLOR_TEXT);

    try

      if prChopIgnoreSegments then begin

        //What happens if the source is multiple disjoined segments?! LM
        Seg              := DS.Find('Segment');
        NextSeg          := Seg.SiblingSameName;
        while not NextSeg.IsNull do begin
          if (Seg.Data[1] + 1) = NextSeg.Data[0] then begin
            Seg.Data[1]  := NextSeg.Data[1];
            DS.RemoveChild( NextSeg );
            NextSeg      := Seg.SiblingSameName;
          end else begin
            Seg          := NextSeg;
            NextSeg      := Seg.SiblingSameName;
          end;
        end;

      end;

      Seg                := DS.Find('Segment');
      ll                 := prDataObject.Segments.TotalDataCount - 1;
      i                  := 1;
      while not Seg.IsNull do begin

        f := Seg.Data[0];
        l := Seg.Data[1];

        if l < f then Exit;

        if prChopUseGetList then begin
        //Get the selections from the GetList

          for s := 0 to GetList.Items.Count - 1 do begin

            Sel       := GetList[s].Sel;
            Inc(Sel.First, f);
            Inc(Sel.Last, f);
            if Sel.First > l then Continue;
            if Sel.Last  > l then begin
              if prChopDiscardPartial then Continue;
              Sel.Last := l;
            end;

            if prChopAddToList then begin
              List.AddSelection(Sel.First, Sel.Last, '');
            end else begin
              List.AddSelection(Sel.First, Sel.Last, IntToStr(i));
            end;
            Inc(i);

          end;//s

        end else begin
        //Get the selections from the Skip/Get/Skip parameters

          Sel.First := f;
          repeat

            //SkipBefore
            Inc(Sel.First, prChopSkipBeforePoints);

            Sel.Last  := Sel.First + prChopGetPoints - 1;
            if Sel.Last > l then Sel.Last := l;

            //GetPoints
            if (Sel.Last = (Sel.First + prChopGetPoints - 1)) or not prChopDiscardPartial then begin
              if prChopAddToList then begin
                List.AddSelection(Sel.First, Sel.Last, '');
              end else begin
                List.AddSelection(Sel.First, Sel.Last, IntToStr(i), not (prChopOnce or ((Sel.Last+1) > l)));
              end;
              Inc(i);
            end;

            Sel.First := Sel.Last + 1;

            //SkipAfter
            Inc(Sel.First, prChopSkipAfterPoints);

            Application.ProcessMessages;
            Console.SetEntry(Entry, 'Segment chopper ...' + IntToStr(Round(100 *(Sel.Last + 1) / (ll + 1))), COLOR_TEXT);

          until((prChopOnce) or (Sel.First > l));

        end;//UseGetList

        //Next segment
        Seg       := Seg.SiblingSameName;

      end;

    finally

      RefreshLists;
      Beep;
      Screen.Cursor := crDefault;
      Console.SetEntry(Entry, 'Segment chopper ... Done.', COLOR_GRAY);

    end;

    ChooseList(NewListIx);

  finally

    m_lListLoading := False;
    UnLockWrite;

  end;

end;


(*
function TQUB_QVO_QVD.ChopSegments(Properties :Boolean) :Boolean;
var
  List      :TQUB_QVO_QVD_SelectionList;
  Sel       :TQUB_FirstLast;
  Entry     :Integer;
  f, l, ll  :Integer;
  s         :Integer;
  NewListIx :Integer;
begin

  Result := LockedReadWrite;

  if Result then Exit;

  LockWrite;

  try

    prChopPropertiesForm.OnGetProperties := prOnGetChopProperties;
    prChopPropertiesForm.OnPutProperties := prOnPutChopProperties;

    if (Properties) or (Result) then begin
      prChopPropertiesForm.ShowModal;
    end else begin
      prChopPropertiesForm.FormShow(prChopPropertiesForm);
      prChopPropertiesForm.ModalResult := mrOK;
      prChopPropertiesForm.btnOKClick(prChopPropertiesForm);
    end;

    Result := prChopPropertiesForm.ModalResult = mrCancel;
    if Result then Exit;

    s := prSelectionLists.Items.IndexOf(prChopOutputList);
    if s = -1 then begin
      List                   := prAddList(prChopOutputList);
      NewListIx              := List.Items.Count - 1;
    end else begin
      List := TQUB_QVO_QVD_SelectionList(prSelectionLists.Items.Objects[s]);
      List.Clear;
      NewListIx              := s;
    end;

    Screen.Cursor := crHourglass;
    Entry := Console.NewEntry('Segment chopper ...', COLOR_TEXT);

    try

      if prChopIgnoreSegments then begin

        f := 0;
        l := f + prDataObject.Segments.TotalDataCount - 1;
        Sel.First := f;

        if l < f then Exit;

        repeat

          Inc(Sel.First, prChopSkipBeforePoints);

          Sel.Last  := Sel.First + prChopGetPoints - 1;
          if Sel.Last > l then Sel.Last := l;

          List.AddSelection(Sel.First, Sel.Last, '');

          Sel.First := Sel.Last + 1;

          Inc(Sel.First, prChopSkipAfterPoints);

          Application.ProcessMessages;
          Console.SetEntry(Entry, 'Segment chopper ...' + IntToStr(Round(100 *(Sel.Last + 1) / (l + 1))), COLOR_TEXT);

        until ((prChopOnce) or (Sel.First > l));

      end else begin

        f := 0;
        ll := f + prDataObject.Segments.TotalDataCount - 1;

        for s := 0 to prDataObject.Segments.SegmentCount - 1 do begin

          l := f + prDataObject.Segments[s].Channels.DataCount - 1;
          if l < f then Exit;

          Sel.First := f;
          repeat

            Inc(Sel.First, prChopSkipBeforePoints);

            Sel.Last  := Sel.First + prChopGetPoints - 1;
            if Sel.Last > l then Sel.Last := l;

            List.AddSelection(Sel.First, Sel.Last, '');

            Sel.First := Sel.Last + 1;

            Inc(Sel.First, prChopSkipAfterPoints);

            Application.ProcessMessages;
            Console.SetEntry(Entry, 'Segment chopper ...' + IntToStr(Round(100 *(Sel.Last + 1) / (ll + 1))), COLOR_TEXT);

          until((prChopOnce) or (Sel.First > l));

          f := l + 1;

        end;

      end;

    finally

      RefreshLists;
      Beep;
      Screen.Cursor := crDefault;
      Console.SetEntry(Entry, 'Segment chopper ... Done.', COLOR_GRAY);

    end;

    ChooseList(NewListIx);

  finally

    UnLockWrite;

  end;

end;
*)


//GoTo Point *******************************************************************
(*
i had converted the old form to QUB_Properties style.
for now lorin's revisions are intact below,
and gotopoint inherits from QUB_Classic_Properties

procedure TQUB_QVO_QVD.prOnGetGoToPointProperties(Sender :TObject);
begin
  with Sender as TQUB_QVO_QVD_GoToPoint_PropertiesForm do begin
    Self.prGoToPointPointOrTime := Properties['PointOrTime'].Data[0] = GOTOPOINT_POINT;
    Self.prGoToPointPoint       := Properties['Point'].Data[0];
    Self.prGoToPointTime        := Properties['Time'].Data[0];
    Self.prGoToPointSelected    := Properties['Selected'].Data[0];
    Self.prGoToPointDuration    := Properties['Duration'].Data[0];
    Self.prGoToPointRealTime    := 0<>Properties['RealTime'].Data[0];
  end;//with
end;
*)
procedure TQUB_QVO_QVD.prOnGetGoToPointProperties(Sender :TObject);
begin
  with Sender as TQUB_QVO_QVD_GoToPoint_PropertiesForm do begin
    Self.prGoToPointStart         := GoToPointStart;
    Self.prGoToPointStartPoint    := GoToPointStartPoint;
    Self.prGoToPointStartTime     := GoToPointStartTime;
    Self.prGoToPointStartMarker   := GoToPointStartMarker;

    Self.prGoToPointEnd           := GoToPointEnd;
    Self.prGoToPointEndPoint      := GoToPointEndPoint;
    Self.prGoToPointEndTime       := GoToPointEndTime;
    Self.prGoToPointEndMarker     := GoToPointEndMarker;
    Self.prGoToPointEndPoints     := GoToPointEndPoints;
    Self.prGoToPointEndDuration   := GoToPointEndDuration;

    Self.prGoToPointRelativeToSel := GoToPointRelativeToSel;
    Self.prGoToPointRealTime      := GoToPointRealTime;
    Self.prGoToPointAddToList     := GoToPointAddToList;
    Self.prGoToPointListName      := GoToPointListName;
  end;//with
end;

procedure TQUB_QVO_QVD.prOnPutGoToPointProperties(Sender :TObject);
begin
  with Sender as TQUB_QVO_QVD_GoToPoint_PropertiesForm do begin
    DataSel                     := Self.DataSel;
  end;//with
end;

function TQUB_QVO_QVD.GoToPoint(Properties :Boolean) :Boolean;
var
  List :TQUB_QVO_QVD_SelectionList;
  Sel  :TQUB_FirstLast;
  PSel :TQUB_FirstLast;
  p    :Integer;
begin

  Result := LockedReadWrite;

  if Result then Exit;

  LockWrite;

  try

    prGoToPointPropertiesForm.OnGetProperties := prOnGetGoToPointProperties;
    prGoToPointPropertiesForm.OnPutProperties := prOnPutGoToPointProperties;

    prGoToPointAddToList := False;

    PSel := prDataSel;

    repeat

      if (Properties) or (Result) then begin
        prGoToPointPropertiesForm.ShowModal;
      end else begin
        prGoToPointPropertiesForm.FormShow(prGoToPointPropertiesForm);
        prGoToPointPropertiesForm.ModalResult := mrOK;
        prGoToPointPropertiesForm.btnOKClick(prGoToPointPropertiesForm);
      end;

      Result := prGoToPointPropertiesForm.ModalResult = mrCancel;
      if Result then Exit;

      //Start
      case prGoToPointStart of

        //Point
        GOTOPOINT_POINT:
          Sel.First := prGoToPointStartPoint;

        //Time
        GOTOPOINT_TIME:
          if prGoToPointRealTime then begin
            Sel.First := DataCurr;
            DataObject.WhichPointForRealTime(prGoToPointStartTime, Sel.First);
          end else begin
            Sel.First := Round(prGoToPointStartTime / Sampling);
          end;

        //Marker
        GOTOPOINT_MARKER:
          Sel.First := Round(prDataTimeMarkers[prGoToPointStartMarker]);

      end;

      //End
      case prGoToPointEnd of

        //Point
        GOTOPOINT_POINT:
          Sel.Last := prGoToPointEndPoint;

        //Time
        GOTOPOINT_TIME:
          if prGoToPointRealTime then begin
            Sel.Last := DataCurr;
            DataObject.WhichPointForRealTime(prGoToPointEndTime, Sel.Last);
          end else begin
            Sel.Last := Round(prGoToPointEndTime / Sampling);
          end;

        //Marker
        GOTOPOINT_MARKER:
          Sel.Last := Round(prDataTimeMarkers[prGoToPointEndMarker]) - 1{The end marker should belong to the next selection, if any};

        //Points
        GOTOPOINT_POINTS:
          Sel.Last := Sel.First + prGoToPointEndPoints - 1;

        //Times
        GOTOPOINT_DURATION:
          Sel.Last := Sel.First + Round(prGoToPointEndDuration / Sampling) - 1;

      end;

      if prGoToPointRelativeToSel then begin
        Sel.First := Sel.First + PSel.First;
        Sel.Last  := Sel.Last  + PSel.First;
      end;

      if Sel.First < DataPoint.First then Sel.First := DataPoint.First;
      if Sel.First > DataPoint.Last  then Sel.First := DataPoint.Last;
      if Sel.Last  < DataPoint.First then Sel.Last  := DataPoint.First;
      if Sel.Last  > DataPoint.Last  then Sel.Last  := DataPoint.Last;

      DataCurr   := Sel.First;

      //Negative selection is fine, just select backwards;
      if Sel.Last < Sel.First then begin
        p         := Sel.First;
        Sel.First := Sel.Last;
        Sel.Last  := p;
      end;

      MoveSelectionIntoWindow(Sel, DataCurr);

      //Add Selection to List
      if prGotoPointAddToList then begin
        //Create the output list if it doesn't exist
        p := prSelectionLists.Items.IndexOf(prGoToPointListName);
        if p = -1 then begin
          List := prAddList(prGoToPointListName);
        end else begin
          List := TQUB_QVO_QVD_SelectionList(prSelectionLists.Items.Objects[p]);
        end;
        //AddSelection
        List.AddSelection(Sel.First, Sel.Last, '');
      end;

    until(prGoToPointAddToList = False);

  finally

    UnLockWrite;

  end;

end;


//EvtListProcessor *************************************************************
function TQUB_QVO_QVD.EvtListProcess( Properties :Boolean; OnActionDone :TNotifyEvent ) :Boolean;
var
  Task               :TQUB_Task_EvP;
begin
  Result     := False;

  Task       := TQUB_Task_EvP.Create(True{Suspended});
  Task.OnTerminate := OnActionDone;
  Task.Data  := Self;

  prEvtListProcessorPropertiesForm.OnGetProperties := Task.OnGetProperties;
  prEvtListProcessorPropertiesForm.OnPutProperties := Task.OnPutProperties;
  prEvtListProcessorPropertiesForm.ClassCount      := DataObject.Idealization[ActiveChannel].ClsCount;

  if (Properties) or (Result) then begin
    prEvtListProcessorPropertiesForm.ShowModal;
  end else begin
    prEvtListProcessorPropertiesForm.FormShow(prEvtListProcessorPropertiesForm);
    prEvtListProcessorPropertiesForm.ModalResult := mrOK;
    prEvtListProcessorPropertiesForm.btnOKClick(prEvtListProcessorPropertiesForm);
  end;

  if prEvtListProcessorPropertiesForm.ModalResult = mrCancel then begin
  //Cancel
    Task.Terminate;
  end else if prEvtListProcessorPropertiesForm.ModalResult = mrNo then begin
  //Reset
    Task.Terminate;
  //end else begin
  //OK
  end;
  Task.Resume;

end;


//Segment Data and Idealized Data
function TQUB_QVO_QVD.SegmentData(ISels, OSels :TList; Segmentation :Boolean; MaxSize :Integer) :Boolean;
var
  Segm       :TList;
  MaxS       :TList;

  Sel        :TQUB_PFirstLast;
  Sgm        :TQUB_PFirstLast;

  First      :Integer;
  Last       :Integer;

  s, l       :Integer;
begin

  Result := False;

  Segm := nil;
  MaxS := nil;

  try

    //Segment according to Segmentation
    if Segmentation then begin
      Segm := TList.Create;
    end else begin
      Segm := ISels;
    end;

    //Segment according to Segmentation
    if Segmentation then begin

      for l := 0 to ISels.Count - 1 do begin

        Sel := TQUB_PFirstLast(ISels.List[l]);

        First := prDataPoint.First;
        for s := 0 to prDataSegmentCount - 1 do begin

          Last := prDataBreakPoints[s] - 1;
          if not ((Last < Sel.First) or (First > Sel.Last)) then begin

            System.New(Sgm);
            Segm.Add(Sgm);

            Sgm.First := First;
            if Sgm.First < Sel.First then Sgm.First := Sel.First;
            Sgm.Last  := Last;
            if Sgm.Last  > Sel.Last  then Sgm.Last  := Sel.Last;

          end;

          First := Last + 1;

        end;

      end;//for of l

    end;//of Segmentation

    //At this point we have either a new Segm list or a reference to ISels (Segm = ISels)

    //Segment according to MaxSize
    if MaxSize > 0 then begin
      MaxS := TList.Create;
    end else begin
      MaxS := Segm;
    end;

    //Segment according to MaxSize
    if MaxSize > 0 then begin

      for l := 0 to Segm.Count - 1 do begin

        Sel := TQUB_PFirstLast(Segm.List[l]);

        First := Sel.First;
        repeat

          Last := First + MaxSize - 1;
          if Last > Sel.Last then Last := Sel.Last;

          System.New(Sgm);
          MaxS.Add(Sgm);
          Sgm.First := First;
          Sgm.Last  := Last;

          First := Last + 1;

        until(First > Sel.Last);

      end;//for of l

    end;//of MaxSize

    //At this point we have either a new MaxS list or a reference to ISels (Segm = ISels)

    //Now copy the selections within the Segmentation list into the Idls list
    for l := 0 to MaxS.Count - 1 do begin
      System.New(Sgm);
      OSels.Add(Sgm);
      Sgm^ := TQUB_PFirstLast(MaxS.List[l])^;
    end;

  finally

    //Free Segmentation List
    if Segmentation then begin
      for l := 0 to Segm.Count - 1 do begin
        Dispose(TQUB_PFirstLast(Segm.List[l]));
      end;
      Segm.Free;
    end;

    //Free MaxSize List
    if MaxSize > 0 then begin
      for l := 0 to MaxS.Count - 1 do begin
        Dispose(TQUB_PFirstLast(MaxS.List[l]));
      end;
      MaxS.Free;
    end;

  end;

end;


//******************************************************************************

function TQUB_QVO_QVD.CreateDataSet: INode;
var
  Channels, Channel      :INode;
  i                      :Integer;
begin
  Result                 := TNode.Create('DataSet');

  Result['FileName'].SetData(FileName);
  Result['sampling'].SetData(Sampling * 1.0e3);//TO DO "Sampling"??? LM.  too late -Chris
  Result['Scaling'].SetData(Scaling);
  Result['ADChannelCount'].SetData(DataObject.ADChannelCount);
  Result['ActiveChannel'].SetData( ActiveChannel);

  Channels               := Result['Channels'];
  Channels['XAxisTickCount'].SetData(XAxisTickCount);
  Channel                := QUB_Node_NULL;
  for i := 0 to DataObject.ADChannelCount - 1 do begin
    Channel              := Channels.InsertChild(Channel, 'Channel');
    Channel['DataYMin'].SetData(DataYMin[i]);
    Channel['DataYMax'].SetData(DataYMax[i]);
    Channel['DataYFactor'].SetData(DataYFactor[i]);
    Channel['Name'].SetData(DataChannelName[i]);
    Channel['Units'].SetData(DataChannelUnits[i]);
    Channel['Scaling'].SetData(DataChannelScaling[i]);
    Channel['Offset'].SetData(DataChannelOffset[i]);
    Channel['YAxisTickCount'].SetData(YAxisTickCount[i]);
  end;

  Result.AppendChild(ExpCond.ToTree);
end;

function TQUB_QVO_QVD.GetChosenData: INode;
var
  ISels            :TList;
  OIdlx            :TList;
  OIdls            :TList;
  OSels            :TList;

  Sel              :TQUB_PFirstLast;
  Dat              :TQUB_FirstLast;

  s, l             :Integer;

  Seg              :INode;

  SelList          :TQUB_QVO_QVD_SelectionList;
  ListIter         :TQUB_QVO_QVD_SelectionListIter;

  StartTime        :Double;
  First            :Integer;
  Retries          :Integer;
begin
  Result := CreateDataSet;

  Retries   := 10;
  while (Retries > 0) and LockedReadWrite do begin
    Retries := Retries - 1;
    Sleep( 500 );
  end;

  if LockedReadWrite then Exit;
  LockWrite;         // prevent others from writing

  ISels := nil;
  OIdlx := nil;
  OIdls := nil;
  OSels := nil;
  SelList := nil;


  try
    if SelectionLists.Items.Count > 0 then begin
      if SelectionLists.ItemIndex <> -1 then begin
        SelList := SelectionLists[SelectionLists.ItemIndex];
        //if SelList.Locked then begin
        //  SelList := nil;
        //end else begin
        //  SelList.Lock;
        //end;
      end;
    end;

    ISels := TList.Create;
    OIdlx := TList.Create;
    OIdls := TList.Create;
    OSels := TList.Create;

    if (QUB_MainForm.DataSource = DATA_SOURCE_WHOLEFILE) or (QUB_MainForm.DataSource = DATA_SOURCE_FILELIST) or ((QUB_MainForm.DataSource = DATA_SOURCE_SELECTIONLIST) and (SelList = nil)) then begin

      Result['DataDescription'].SetData('file');
      System.New(Sel);
      ISels.Add(Sel);
      Sel^ := DataPoint;

    end else if QUB_MainForm.DataSource = DATA_SOURCE_SELECTIONLIST then begin

      Result['DataDescription'].SetData('"' + CurrListName + '"');

      ListIter := SelList.Find(0, DataPoint.Last, True{ActiveOnly});
      if not ListIter.Done then repeat
        System.New(Sel);
        ISels.Add(Sel);
        Sel^ := ListIter.Sel;
      until ListIter.Next;
      ListIter.Free;
      (*
      for s := 0 to SelList.Items.Count - 1 do begin
        if SelList[s].Sel.First < SelList[s].Sel.Last then begin
          System.New(Sel);
          ISels.Add(Sel);
          Sel^ := SelList[s].Sel;
        end;
      end;
      *)
    end else if QUB_MainForm.DataSource = DATA_SOURCE_SELECTION then begin

      if DataSel.First < DataSel.Last then begin
        Result['DataDescription'].SetData(Format('%d - %d', [DataSel.First, DataSel.Last]));
        System.New(Sel);
        ISels.Add(Sel);
        Sel^ := DataSel;
      end;

    end;

    if ISels.Count < 1 then begin
    //  Result     := True;
    //  prError    := True;
    //  prErrorMsg := 'No selection active or empty selection list or empty selection';
      Exit;
    end;

    if (SegmentData(ISels, OSels, True{Segmentation}, 0{MaxSize !!!})) or (OSels.Count < 1) then begin
      //Result     := True;
      //prError    := True;
      //prErrorMsg := 'Data could not be segmented';
      Exit;
    end;

    for l := 0 to OSels.Count - 1 do begin

      //Idealized selection
      Dat      := TQUB_PFirstLast(OSels.List[l])^;

      Seg      := TNode.Create('Segment');
      Result.AppendChild( Seg );

      Seg.SetupNumData( NODE_DATATYPE_LONGINT, 2, 1 );
      Seg.Data[0] := Dat.First;
      Seg.Data[1] := Dat.Last;

      StartTime       := 0;
      for s := 0 to DataSegmentCount - 1 do begin
        if Dat.First <= (DataBreakpoints[s] - 1) then begin
          if s = 0 then First := 0 else First := DataBreakpoints[s - 1];
          StartTime := DataObject.Segments[s].StartTime + Sampling * (Dat.First - First);
          Break;
        end;
      end;
      Seg['start'].SetData( 1.0e3 * (StartTime - DataObject.Segments[0].StartTime) );

    end;

  finally

    UnLockWrite;

    //if SelList <> nil then SelList.Unlock;

    if ISels <> nil then begin
      for s := 0 to ISels.Count - 1 do begin
        FreeMem(TQUB_PFirstLast(ISels.List[s]));
      end;
      ISels.Free;
    end;
    if OSels <> nil then begin
      for s := 0 to OSels.Count - 1 do begin
        FreeMem(TQUB_PFirstLast(OSels.List[s]));
      end;
      OSels.Free;
    end;
    if OIdlx <> nil then begin
      for s := 0 to OIdlx.Count - 1 do begin
        FreeMem(TQUB_PFirstLast(OIdlx.List[s]));
      end;
      OIdlx.Free;
    end;
    if OIdls <> nil then begin
      for s := 0 to OIdls.Count - 1 do begin
        FreeMem(TQUB_PFirstLast(OIdls.List[s]));
      end;
      OIdls.Free;
    end;

  end;

end;

// now FillDataSegment can handle negative indices (but not too-large ones sorry)
// but FillDataSegmentCh still requires all existing indices

procedure TQUB_QVO_QVD.FillDataSegment(SegNode :INode);
var
  Sel             :TQUB_FirstLast;
  RealSel         :TQUB_FirstLast;
  Channel         :INode;
  ChannelIndex    :Integer;
  RealCount       :Integer;
  FakeCount       :Integer;
  i               :Integer;
  DataProcessed   :TQUB_Task_Data_Processed;
  ProcessFilter   :Boolean;
  ProcessBaseline :Boolean;
  ProcessFilterFreq :Double;
  DataProcNode    :INode;
  n               :INode;
  DataAsInts      :TPAInteger;
  DataAsDoubles   :TPADouble;
  Scaling         :Double;  
  Offset          :Double;
  Retries         :Integer;
  Fill            :Double;
begin
  Channel         := SegNode['Channel'];

  Retries   := 10;
  while (Retries > 0) and LockedReadWrite do begin
    Retries := Retries - 1;
    Sleep( 500 );
  end;

  if LockedReadWrite then Exit;
  LockWrite;

  try

    n               := SegNode.Parent.Find('ActiveChannel');
    if n.DataCount > 0 then begin
      ChannelIndex := n.Data[0];
    end else begin
      ChannelIndex := ActiveChannel;
    end;

    DataProcessed   := DATA_PROCESSED_NONE;
    ProcessFilter   := False;
    ProcessFilterFreq := 0.0;
    ProcessBaseline := False;

    DataProcNode    := SegNode.Parent.Find('ProcessData');
    if not DataProcNode.IsNull then begin
      if DataProcNode.DataAsString = 'AsDisplayed' then begin
        DataProcessed      := DATA_PROCESSED_ASDISPLAYED;
      end else if DataProcNode.DataAsString = 'AsSuch' then begin
        DataProcessed      := DATA_PROCESSED_ASSUCH;

        n                  := DataProcNode.Find('Filter');
        ProcessFilter      := (n.DataCount > 0) and (Integer(n.Data[0]) <> 0);
        if ProcessFilter then begin
          ProcessFilterFreq := Double(DataProcNode['FilterFreq'].Data[0]);
        end;

        ProcessBaseline    := not DataProcNode.Find('Baseline').IsNull;
      end;
    end;

    Sel.First     := Integer( SegNode.Data[0] );
    Sel.Last      := Integer( SegNode.Data[1] );
    RealSel.First := Max(0, Sel.First);
    RealSel.Last  := Max(0, Sel.Last);
    RealCount     := RealSel.Last - RealSel.First + 1;
    FakeCount     := (Sel.Last - Sel.First + 1) - RealCount;

    Channel.SetupNumData( NODE_DATATYPE_DOUBLE, FakeCount + RealCount, 1 );
    DataAsDoubles := TPADouble( Channel.DataPtr );
    DataAsInts    := TPAInteger( PChar(Channel.DataPtr) + (FakeCount + RealCount)*SizeOf(Integer) ); // second half of DataAsDoubles (for in-place conversion)

    case DataProcessed of
      DATA_PROCESSED_NONE:
        LoadDataChannel       (@(DataAsInts[FakeCount]), ChannelIndex, RealSel, False{Process}, False, False);
      DATA_PROCESSED_ASDISPLAYED:
        LoadDataChannelProcess(@(DataAsInts[FakeCount]), ChannelIndex, RealSel, FilterOn[ChannelIndex], FilterFreq[ChannelIndex], BaselineOn[ChannelIndex]);
      DATA_PROCESSED_ASSUCH:
        LoadDataChannelProcess(@(DataAsInts[FakeCount]), ChannelIndex, RealSel, ProcessFilter,               ProcessFilterFreq,             ProcessBaseline);
    end;

    Scaling       := 1.0 / (DataObject.Scaling * DataChannelScaling[ChannelIndex]);
    Offset        := DataChannelOffset[ChannelIndex];
    for i := FakeCount to FakeCount + RealCount - 1 do begin
      DataAsDoubles[i] := DataAsInts[i] * Scaling + Offset;
    end;

    if RealCount > 0 then begin
      Fill        := DataAsDoubles[FakeCount];
    end else begin
      Fill        := 0.0;
    end;
    for i := 0 to FakeCount - 1 do begin
      DataAsDoubles[i] := Fill;
    end;

  except
  end;

  UnlockWrite;
end;

//check this. LM
procedure TQUB_QVO_QVD.FillDataSegmentCh(SegNode :INode);
var
  Sel             :TQUB_FirstLast;
  Channel         :INode;
  ChannelIndex    :Integer;
  len             :Integer;
  i               :Integer;
  DataProcessed   :TQUB_Task_Data_Processed;
  ProcessFilter   :Boolean;
  ProcessBaseline :Boolean;
  ProcessFilterFreq :Double;
  DataProcNode    :INode;
  n               :INode;
  DataAsInts      :TPAInteger;
  DataAsDoubles   :TPADouble;
  Scaling         :Double;
  Offset          :Double;
  Retries         :Integer;
begin
  Channel         := SegNode['Channel'];

  Retries   := 10;
  while (Retries > 0) and LockedReadWrite do begin
    Retries := Retries - 1;
    Sleep( 500 );
  end;

  if LockedReadWrite then Exit;
  LockWrite;

  try

    DataProcessed   := DATA_PROCESSED_NONE;
    ProcessFilter   := False;
    ProcessFilterFreq := 0.0;
    ProcessBaseline := False;

    DataProcNode    := SegNode.Parent.Find('ProcessData');
    if not DataProcNode.IsNull then begin
      if DataProcNode.DataAsString = 'AsDisplayed' then begin
        DataProcessed      := DATA_PROCESSED_ASDISPLAYED;
      end else if DataProcNode.DataAsString = 'AsSuch' then begin
        DataProcessed      := DATA_PROCESSED_ASSUCH;

        n                  := DataProcNode.Find('Filter');
        ProcessFilter      := (n.DataCount > 0) and (Integer(n.Data[0]) <> 0);
        if ProcessFilter then begin
          ProcessFilterFreq := Double(DataProcNode['FilterFreq'].Data[0]);
        end;

        ProcessBaseline    := not DataProcNode.Find('Baseline').IsNull;
      end;
    end;

    Sel.First     := Integer( SegNode.Data[0] );
    Sel.Last      := Integer( SegNode.Data[1] );
    len           := Sel.Last - Sel.First + 1;

    Channel.SetupNumData( NODE_DATATYPE_DOUBLE, len*prDataChannelCount, 1 );
    DataAsDoubles := TPADouble( Channel.DataPtr );
    DataAsInts    := TPAInteger( PChar(Channel.DataPtr) + len*SizeOf(Integer)*prDataChannelCount ); // second half of DataAsDoubles (for in-place conversion)

    for ChannelIndex:=0 to prDataChannelCount-1 do begin
      case DataProcessed of
        DATA_PROCESSED_NONE:
          LoadDataChannel       (@(DataAsInts[ChannelIndex*len]), ChannelIndex, Sel,
                                  False{Process}, False, False);
        DATA_PROCESSED_ASDISPLAYED:
          LoadDataChannelProcess(@(DataAsInts[ChannelIndex*len]), ChannelIndex, Sel,
                                  FilterOn[ChannelIndex], FilterFreq[ChannelIndex], BaselineOn[ChannelIndex]);
        DATA_PROCESSED_ASSUCH:
          LoadDataChannelProcess(@(DataAsInts[ChannelIndex*len]), ChannelIndex, Sel, 
                                  ProcessFilter,               ProcessFilterFreq,             ProcessBaseline);
      end;
      Scaling := 1.0 / (DataObject.Scaling * DataChannelScaling[ChannelIndex]);
      Offset  := DataChannelOffset[ChannelIndex];
      for i := 0 to len - 1 do begin
        DataAsDoubles[i+ChannelIndex*len] := DataAsInts[i+ChannelIndex*len] * Scaling + Offset;
      end;
    end;


  except
  end;

  UnlockWrite;
end;

function TQUB_QVO_QVD.GetChosenIdl: INode;
begin
  Result := GetChosenIdl(False);
end;

function TQUB_QVO_QVD.GetChosenIdl(Fragments :Boolean): INode;
var
  DataSource       :TQUB_Task_Data_Source;

  Seg              :INode;

  SelList          :TQUB_QVO_QVD_SelectionList;
  ListIter         :TQUB_QVO_QVD_SelectionListIter;
  ChannelIndex     :Integer;
  Retries          :Integer;

  Idealization     :TQUB_IdlSegments;
  TmpTree, Tmp3    :INode;
begin
  Result := CreateDataSet;

  DataSource       := QUB_MainForm.DataSource;
  if DataSource = DATA_SOURCE_FILELIST then DataSource := DATA_SOURCE_WHOLEFILE;

  Retries   := 10;
  while (Retries > 0) and LockedReadWrite do begin
    Retries := Retries - 1;
    Sleep( 500 );
  end;

  if LockedReadWrite then Exit;
  LockWrite;         // prevent others from writing

  SelList := nil;

  try
    ChannelIndex := ActiveChannel;
    Idealization := DataObject.Idealization[ChannelIndex];

    if SelectionLists.Items.Count > 0 then begin
      if SelectionLists.ItemIndex <> -1 then begin
        SelList := SelectionLists[SelectionLists.ItemIndex];
        //if SelList.Locked then begin
       //  SelList := nil;
        //end else begin
        //  SelList.Lock;
        //end;
      end;
    end;

    if (DataSource = DATA_SOURCE_WHOLEFILE) or ((DataSource = DATA_SOURCE_SELECTIONLIST) and (SelList = nil)) then begin

      Result['DataDescription'].SetData('file');
      //Idealization.GetDwellsInto(0, DataPoint.Last, Integer(Fragments), 1, Result, 0);
      //The above call misses the last dwell, even when it's not a fragment - LM. This is a temporary fix. Chris, please?
      //Chris says: I just tested it and it works, however...
      //there are by definition no fragments when you get the whole file, so it's moot.
      Idealization.GetDwellsInto(0, DataPoint.Last, 1, 1, Result, 0);

    end else if DataSource = DATA_SOURCE_SELECTIONLIST then begin

      Result['DataDescription'].SetData('"' + CurrListName + '"');

      // going this way, with insertAsFirst==true,
      // the segment(s) from the first sel will be last.
      // but if there's more than one segment for a sel,
      // they will (internally) not be in reverse order.
      // thus we reverse each sel's segments, then reverse the whole list.

      TmpTree := TNode.Create('');
      Tmp3    := TNode.Create('');
      ListIter := SelList.Find(0, DataPoint.Last, True{ActiveOnly});
      if not ListIter.Done then repeat
        Idealization.GetDwellsInto(ListIter.Sel.First, ListIter.Sel.Last, Integer(Fragments), 1, Tmp3, 1);
        while not Tmp3.Child.IsNull do begin
          TmpTree.InsertChild(QUB_NODE_NULL, Tmp3.Child);
        end;
      until ListIter.Next;
      ListIter.Free;

      while not TmpTree.Child.IsNull do begin
        Result.InsertChild(QUB_NODE_NULL, TmpTree.Child);
      end;
      (*
      for s := SelList.Items.Count - 1 downto 0 do begin
        if SelList[s].Sel.First < SelList[s].Sel.Last then begin

          Idealization.GetDwells(SelList[s].Sel.First, SelList[s].Sel.Last, Integer(Fragments), 1, Result, 1);

        end;
      end;
      *)
    end else if DataSource = DATA_SOURCE_SELECTION then begin

      Result['DataDescription'].SetData(Format('%d - %d', [DataSel.First, DataSel.Last]));
      Idealization.GetDwellsInto(DataSel.First, DataSel.Last, Integer(Fragments), 1, Result, 0);

    end;

    Seg := Result.Find('Segment');
    while not Seg.IsNull do begin
      Seg['start'].SetData( WhichTimeForPoint( Seg.Data[0], True{Rel} ) * 1.0e3 );

      Seg := Seg.SiblingSameName;
    end;

  finally
    UnLockWrite;
    //if SelList <> nil then SelList.Unlock;
  end;
end;


function TQUB_QVO_QVD.GetChosenIdl(DropFirstLast, DropIfCls :Boolean; DropCls :Integer): INode;
var
  DataSource       :TQUB_Task_Data_Source;

  Seg              :INode;
  TmpTree, Tmp3    :INode;

  SelList          :TQUB_QVO_QVD_SelectionList;
  ListIter         :TQUB_QVO_QVD_SelectionListIter;
  ChannelIndex     :Integer;
  Retries          :Integer;

  Idealization     :TQUB_IdlSegments;
begin
  Result := CreateDataSet;

  DataSource       := QUB_MainForm.DataSource;
  if DataSource = DATA_SOURCE_FILELIST then DataSource := DATA_SOURCE_WHOLEFILE;

  if not DropFirstLast then DropIfCls := False;

  Retries   := 10;
  while (Retries > 0) and LockedReadWrite do begin
    Retries := Retries - 1;
    Sleep( 500 );
  end;

  if LockedReadWrite then Exit;
  LockWrite;         // prevent others from writing

  SelList := nil;

  try
    ChannelIndex := ActiveChannel;
    Idealization := DataObject.Idealization[ChannelIndex];

    if SelectionLists.Items.Count > 0 then begin
      if SelectionLists.ItemIndex <> -1 then begin
        SelList := SelectionLists[SelectionLists.ItemIndex];
        //if SelList.Locked then begin
        //  SelList := nil;
        //end else begin
        //  SelList.Lock;
        //end;
      end;
    end;

    if (DataSource = DATA_SOURCE_WHOLEFILE) or ((DataSource = DATA_SOURCE_SELECTIONLIST) and (SelList = nil)) then begin

      Idealization.GetDwellsWDrop(0, DataPoint.Last, 1, Integer(DropFirstLast), Integer(DropIfCls), DropCls, Result, 0)

    end else if DataSource = DATA_SOURCE_SELECTIONLIST then begin

      // going this way, with insertAsFirst==true,
      // the segment(s) from the first sel will be last.
      // but if there's more than one segment for a sel,
      // they will (internally) not be in reverse order.
      // thus we reverse each sel's segments, then reverse the whole list.

      TmpTree := TNode.Create('');
      Tmp3    := TNode.Create('');
      ListIter := SelList.Find(0, DataPoint.Last, True{ActiveOnly});
      if not ListIter.Done then repeat
        Idealization.GetDwellsWDrop(ListIter.Sel.First, ListIter.Sel.Last, 1, Integer(DropFirstLast), Integer(DropIfCls), DropCls, Tmp3, 1);
        while not Tmp3.Child.IsNull do begin
          TmpTree.InsertChild(QUB_NODE_NULL, Tmp3.Child);
        end;
      until ListIter.Next;
      ListIter.Free;

      while not TmpTree.Child.IsNull do begin
        Result.InsertChild(QUB_NODE_NULL, TmpTree.Child);
      end;

      ///ListIter := SelList.Find(0, DataPoint.Last, True{ActiveOnly});
      ///if not ListIter.Done then repeat
      ///  Idealization.GetDwellsWDrop(ListIter.Sel.First, ListIter.Sel.Last, 1, Integer(DropFirstLast), Integer(DropIfCls), DropCls, Result, 1)
      ///until ListIter.Next;
      ///ListIter.Free;
      (*
      for s := SelList.Items.Count - 1 downto 0 do begin
        if SelList[s].Sel.First < SelList[s].Sel.Last then begin

          Idealization.GetDwellsWDrop(SelList[s].Sel.First, SelList[s].Sel.Last, 1, Integer(DropFirstLast), Integer(DropIfCls), DropCls, Result, 1)

        end;
      end;
      *)
    end else if DataSource = DATA_SOURCE_SELECTION then begin

      Idealization.GetDwellsWDrop(DataSel.First, DataSel.Last, 1, Integer(DropFirstLast), Integer(DropIfCls), DropCls, Result, 0)

    end;

    Seg := Result.Find('Segment');
    while not Seg.IsNull do begin
      Seg['start'].SetData( WhichTimeForPoint( Seg.Data[0], True ) * 1.0e3 );

      Seg := Seg.SiblingSameName;
    end;

  finally
    UnLockWrite;
    //if SelList <> nil then SelList.Unlock;
  end;
end;


function TQUB_QVO_QVD.GetChosenIdlSignals: INode;
var
  OrigChannel        :Integer;
  DataSet            :INode;
  Signal             :INode;
  Temp               :INode;
  c                  :Integer;

  procedure RepackSegments(DataSet, Idealization :INode);
  var
    Segment, Last      :INode;
  begin
    Last      := TNode.CreateNull;
    Segment   := DataSet.Find('Segment');
    while not Segment.IsNull do begin
      Last    := Idealization.InsertChild(Last, Segment);
      Segment := DataSet.Find('Segment');
    end;
  end;
begin
  OrigChannel        := ActiveChannel;
  Result             := GetChosenIdl;
  Signal             := TNode.CreateNull;
  Temp               := TNode.Create('');
  RepackSegments(Result, Temp);

  for c := 0 to DataObject.ADChannelCount - 1 do begin
    ActiveChannel    := c;
    Signal           := Result.InsertChild(Signal, 'Signal');
    Signal['Name'].SetData(DataChannelName[c]);
    Signal['ChannelIndex'].SetData(c);
    if c = OrigChannel then begin
      DataSet        := Temp;
    end else begin
      DataSet        := GetChosenIdl;
    end;
    RepackSegments(DataSet, Signal['Idealization']);
  end;
  ActiveChannel      := OrigChannel;
  // DataSet
  //   ...
  //   Signal
  //     Name = ...
  //     ChannelIndex = ...
  //     Idealization
  //       Segment
  //       ...
  //   ...
end;


//******************************************************************************
function TQUB_QVO_QVD.AddList :Boolean;
var
  n    :String;
begin
  n := 'Selection list ' + IntToStr(prSelListNameCount);
  Result := InputQuery('Add selection list', 'List name:', n);
  if not Result then begin
    Result := True;
    Exit;
  end;
  Result := False;

  n := Trim(n);
  if n = '' then n := 'Selection list ' + IntToStr(prSelListNameCount);
  Inc(prSelListNameCount);

  prAddList(n);
  ChooseList(n);
end;

function TQUB_QVO_QVD.AddList(const Name :String) :TQUB_QVO_QVD_SelectionList;
var
  List  :TQUB_QVO_QVD_SelectionList;
  xName :String;
begin
  xName := Name;
  if xName = '' then begin
    xName := 'Selection list ' + IntToStr(prSelListNameCount);
  end;
  //TO DO: ChooseList is called unnecessarily about three times!!! LM
  List := prAddList(xName);
  ChooseList(xName);
  Inc(prSelListNameCount);
  Result := List;
end;

function TQUB_QVO_QVD.GetList(const Name :String) :TQUB_QVO_QVD_SelectionList;
var
  List   :TQUB_QVO_QVD_SelectionList;
begin
  List   := prSelectionLists.ListByName[ Name ];
  if List = nil then begin
    List        := prAddList(Name);
    Inc(prSelListNameCount);
  end;

  Result := List;
end;

function TQUB_QVO_QVD.ChooseList(const Name :String): Boolean;
begin
  Result := ChooseList(prSelectionLists.Items.IndexOf(Name));
end;

function TQUB_QVO_QVD.ChooseList(Ix :Integer): Boolean;
var
  i     :Integer;
begin
  if prSelectionLists.ItemIndex >= 0 then prSelectionLists[ prSelectionLists.ItemIndex ].DeActivate;
  for i := 0 to prSelectionLists.Items.Count - 1 do begin
    prSelectionLists.Selected[i] := False;
  end;

  if Ix >= 0 then begin
    prSelectionLists.ItemIndex := Ix;
    prSelectionLists.Selected[Ix] := True;
    prSelectionLists[Ix].Activate;
    Result := False;
    RefreshLists;
  end else begin
    Result := True;
  end;
end;

function TQUB_QVO_QVD.prGetCurrListName: String;
begin
  Result := '';
  if prSelectionLists.ItemIndex >= 0 then Result := prSelectionLists.Items.Strings[ prSelectionLists.ItemIndex ];
end;

procedure TQUB_QVO_QVD.prSetCurrListName(x :String);
begin
  if prSelectionLists.ItemIndex >= 0 then begin
    prSelectionLists.RenameList(prSelectionLists.ItemIndex, x);
  end;
end;

//Edit Lists operations
function TQUB_QVO_QVD.CutLists :Boolean;
begin
  Result := CopyLists;
  if not Result then Result := DeleteLists;
end;

function TQUB_QVO_QVD.CopyLists :Boolean;
begin
  Result := prCopyListsToClipboard;
end;

function TQUB_QVO_QVD.PasteLists :Boolean;
begin
  Result := prPasteListsFromClipboard;
end;

function TQUB_QVO_QVD.DeleteLists :Boolean;
begin
  Result := False;
  prSelectionLists.DelSelLists;
end;

function TQUB_QVO_QVD.DelList :Boolean;
begin
  Result := False;
  if prSelectionLists.Items.Count = 0 then Exit;
  if prSelectionLists.ItemIndex = -1 then Exit;
  prSelectionLists.DelList(prSelectionLists.ItemIndex);
end;

function TQUB_QVO_QVD.DelList(const Name :String) :Boolean;
var
  ix     :Integer;
begin
  ix     := prSelectionLists.Items.IndexOf(Name);
  if ix >= 0 then begin
    prSelectionLists.DelList(ix);
    Result := False;
  end else begin
    Result := True;
  end;
end;

function TQUB_QVO_QVD.AddSelection :Boolean;
var
  List     :TQUB_QVO_QVD_SelectionList;
  Selected :Integer;
begin
  Result := False;

  if prData = nil then Exit;

  //One point selection should be permitted - they are, in fact, markers
  //if prDataSel.First = prDataSel.Last then Exit;

  if prSelectionLists.ItemIndex = -1 then Exit;

  if prSelectionLists.ItemIndex >= 0 then begin
    List := prSelectionLists.List[prSelectionLists.ItemIndex];
  end else if prSelectionLists.Items.Count > 0 then begin
    List := prSelectionLists.List[0];
  end else begin
    Result := AddList;
    if Result then Exit;
    List := prSelectionLists.List[0];
  end;

  Selected := prGoToPointEndPoints;

  if (KeyControl) then begin
  //Add selection from current point
    List.AddSelection(DataCurr, DataCurr + Selected - 1, '');
    MoveSelectionIntoWindow(QUB_FirstLast(DataCurr, DataCurr + Selected - 1), DataCurr + Selected - 1);
  end else if (KeyShift) and (Zoom <> nil) then begin
  //Add selection from current point in the Zoom
    List.AddSelection(Zoom.DataCurr + Zoom.DataOffset, Zoom.DataCurr + Zoom.DataOffset + Selected - 1, '');
    MoveSelectionIntoWindow(QUB_FirstLast(Zoom.DataCurr + Zoom.DataOffset, Zoom.DataCurr + Zoom.DataOffset + Selected - 1), Zoom.DataCurr + Zoom.DataOffset + Selected - 1);
  end else begin
    List.AddSelection(prDataSel.First, prDataSel.Last, '');
  end;
  RefreshLists;

end;

//Adds multiple selections, when DrawListOverlapped = True
function TQUB_QVO_QVD.AddSelections(FromZoom :Boolean) :Boolean;
var
  List     :TQUB_QVO_QVD_SelectionList;
  ToList   :TQUB_QVO_QVD_SelectionList;
  //Selected :Integer;
  Sel      :TQUB_FirstLast;
  l        :Integer;
begin
  Result := False;

  if prData = nil then Exit;

  //if prDataSel.First = prDataSel.Last then Exit;

  //What is being drawn
  if prSelectionLists.ItemIndex = -1 then Exit;
  if prSelectionLists.Items.Count = 0 then Exit;

  if prSelectionLists.ItemIndex >= 0 then begin
    List := prSelectionLists.List[prSelectionLists.ItemIndex];
  end else if prSelectionLists.Items.Count > 0 then begin
    List := prSelectionLists.List[0];
  end else begin
    List := nil;
  end;

  if List = nil then Exit;
  
  Result := AddList;
  if Result then Exit;

  ToList := prSelectionLists.List[prSelectionLists.Items.Count - 1];

  //Selected := prGoToPointEndPoints;

  for l := 0 to List.Items.Count - 1 do begin

    Sel := List.Selection[l].Sel;

    if (FromZoom) and (Zoom <> nil) then begin
    //Add selection from Zoom
      ToList.AddSelection(prDataSel.First + Sel.First + Zoom.DataSel.First, prDataSel.First + Sel.First + Zoom.DataSel.Last, '');
    end else begin
    //Add selection from main
      ToList.AddSelection(prDataSel.First + Sel.First, prDataSel.Last + Sel.First, '');
    end;

  end;//l

  RefreshLists;

end;

function TQUB_QVO_QVD.AddSelection(const ListName, SelName :String; Sel :TQUB_FirstLast; ForceAdd :Boolean) :Boolean;
var
  List :TQUB_QVO_QVD_SelectionList;
  l    :Boolean;
begin
  Result := False;

  if prDataObject = nil then Exit;

  List := prSelectionLists.ListByName[ListName];
  if List = nil then begin
    List := AddList(ListName);
    if List = nil then begin
      Result := True;
      Exit;
    end;
  end;

  //Adds selection even when list is locked -
  l := List.Locked;
  if (l) and (ForceAdd) then List.Unlock;
  List.AddSelection(Sel.First, Sel.Last, SelName);
  if (l) and (ForceAdd) then List.Lock;
  RefreshLists;

end;

function TQUB_QVO_QVD.DelSelection :Boolean;
begin
  Result := False;

  if prSelectionLists.Items.Count = 0 then Exit;
  if prSelectionLists.ItemIndex = -1 then Exit;

  if prSelectionLists[prSelectionLists.ItemIndex].Items.Count = 0 then Exit;
  if prSelectionLists[prSelectionLists.ItemIndex].ItemIndex = -1 then Exit;

  prSelectionLists.List[prSelectionLists.ItemIndex].DelSelection(prSelectionLists.List[prSelectionLists.ItemIndex].ItemIndex);

  RefreshLists;
end;

function TQUB_QVO_QVD.DelSelected(Inverted :Boolean) :Boolean;
begin
  Result := False;

  if prSelectionLists.Items.Count = 0 then Exit;
  if prSelectionLists.ItemIndex = -1 then Exit;

  if prSelectionLists[prSelectionLists.ItemIndex].Items.Count = 0 then Exit;
  if prSelectionLists[prSelectionLists.ItemIndex].ItemIndex = -1 then Exit;

  if prSelectionLists.List[prSelectionLists.ItemIndex].SelCount = 0 then begin
    prSelectionLists.List[prSelectionLists.ItemIndex].DelSelection(prSelectionLists.List[prSelectionLists.ItemIndex].ItemIndex);
  end else begin
    prSelectionLists.List[prSelectionLists.ItemIndex].DelSelected(Inverted);
  end;

  RefreshLists;
end;

//Edit Selections
function TQUB_QVO_QVD.CutSelections :Boolean;
begin
  Result := CopySelections;
  if not Result then Result := DeleteSelections;
end;

function TQUB_QVO_QVD.CopySelections :Boolean;
begin
  Result := prCopySelectionsToClipboard;
end;

function TQUB_QVO_QVD.PasteSelections :Boolean;
begin
  Result := prPasteSelectionsFromClipboard;
end;

function TQUB_QVO_QVD.DeleteSelections :Boolean;
begin
  Result := False;
  DelSelected(False);
end;

function TQUB_QVO_QVD.SelectAllSelections :Boolean;
var
  i :Integer;
begin
  Result := False;
  if prSelectionLists.Items.Count = 0 then Exit;
  if prSelectionLists.ItemIndex = -1 then Exit;
  with prSelectionLists[prSelectionLists.ItemIndex] do begin
    for i := 0 to Items.Count - 1 do begin
      Selected[i] := True;
    end;
  end;
end;

function TQUB_QVO_QVD.InvertSelections :Boolean;
var
  i :Integer;
begin
  Result := False;
  if prSelectionLists.Items.Count = 0 then Exit;
  if prSelectionLists.ItemIndex = -1 then Exit;
  with prSelectionLists[prSelectionLists.ItemIndex] do begin
    for i := 0 to Items.Count - 1 do begin
      Selected[i] := not Selected[i];
    end;
  end;
end;

function TQUB_QVO_QVD.ShiftSelection :Boolean;
var
  List :TQUB_QVO_QVD_SelectionList;
  Sel  :TQUB_FirstLast;
  Txt  :String;
  i    :Integer;
begin
  Result := False;
  if prSelectionLists.Items.Count = 0 then Exit;
  if prSelectionLists.ItemIndex = -1 then Exit;

  List := prSelectionLists[prSelectionLists.ItemIndex];
  if List.Items.Count = 0 then Exit;

  Txt := IntToStr(prShiftSelValue);
  if not InputQuery('Input the number of samples to shift by:', 'Value:', Txt) then Exit;
  try
    prShiftSelValue := StrToInt(Txt);
  except
    Exit;
  end;

  for i := 0 to List.Items.Count - 1 do begin

    if List.Selected[i] then begin
      Sel := List[i].Sel;
      Inc(Sel.First, prShiftSelValue);
      Inc(Sel.Last, prShiftSelValue);
      List[i].Sel := Sel;
    end;

  end;

  RefreshLists;

end;

function TQUB_QVO_QVD.ExpandSelection :Boolean;
var
  List :TQUB_QVO_QVD_SelectionList;
  Sel  :TQUB_FirstLast;
  Txt  :String;
  i    :Integer;
begin
  Result := False;
  if prSelectionLists.Items.Count = 0 then Exit;
  if prSelectionLists.ItemIndex = -1 then Exit;

  List := prSelectionLists[prSelectionLists.ItemIndex];
  if List.Items.Count = 0 then Exit;

  Txt := IntToStr(prExpandSelValue);
  if not InputQuery('Input the number of samples to expand/shrink by:', 'Value:', Txt) then Exit;
  try
    prExpandSelValue := StrToInt(Txt);
  except
    Exit;
  end;

  for i := 0 to List.Items.Count - 1 do begin

    if List.Selected[i] then begin
      Sel := List[i].Sel;
      Dec(Sel.First, prExpandSelValue);
      Inc(Sel.Last, prExpandSelValue);
      List[i].Sel := Sel;
      if Sel.First > Sel.Last then begin
        List[i].Sel := QUB_FirstLast(Sel.Last, Sel.First);
      end;
    end;

  end;

  RefreshLists;

end;

//Selection Properties
function TQUB_QVO_QVD.ShowSelectionProperties: Boolean;
begin
  Result := False;

  if prSelectionLists.Items.Count = 0 then Exit;
  if prSelectionLists.ItemIndex = -1 then Exit;

  if prSelectionLists[prSelectionLists.ItemIndex].Items.Count = 0 then Exit;
  if prSelectionLists[prSelectionLists.ItemIndex].ItemIndex = -1 then Exit;

  prSelectionLists.List[prSelectionLists.ItemIndex].ShowSelectionProperties(prSelectionLists.List[prSelectionLists.ItemIndex].ItemIndex);

  RefreshLists;
end;


function TQUB_QVO_QVD.AddNote(const ListName :String) :Boolean;
var
  List :TQUB_QVO_QVD_SelectionList;
  Idx  :Integer;
begin
  Result := False;

  if prData = nil then Exit;

  //Create the ListName list if it doesn't exist. LM
  if prSelectionLists.Items.IndexOf(ListName) < 0 then AddList(ListName);

  Idx := prSelectionLists.Items.IndexOf(ListName);
  Result := (Idx < 0);
  if Result then Exit;

  List := prSelectionLists.List[Idx];
  if Recording then begin
    List.AddSelection(DataPoint.Last + 1, DataPoint.Last + 1, prSelectionPropertiesForm.lstLabel.Text);
  end else begin
    List.AddSelection(DataSel.First, DataSel.Last, prSelectionPropertiesForm.lstLabel.Text);
  end;
  if not List.ShowSelectionProperties(List.ItemIndex) then begin
    List.DelSelection(List.ItemIndex);
    Exit;
  end;

  //Don't put unnecessary strain on Acquisition - extend this to other circumstances. LM
  if not Recording then begin
    RefreshLists;
  end;

end;

function TQUB_QVO_QVD.AddNote(const ListName, Name, Comments :String) :Boolean;
var
  List :TQUB_QVO_QVD_SelectionList;
  Sel  :TQUB_QVO_QVD_Selection;
  Idx  :Integer;
begin
  Result := False;

  if prData = nil then Exit;

  //Create the ListName list if it doesn't exist. LM
  if prSelectionLists.Items.IndexOf(ListName) < 0 then AddList(ListName);

  Idx := prSelectionLists.Items.IndexOf(ListName);
  Result := (Idx < 0);
  if Result then Exit;

  List := prSelectionLists.List[Idx];
  if Recording then begin
    Sel := List.AddSelection(DataPoint.Last + 1, DataPoint.Last + 1, Name);
  end else begin
    Sel := List.AddSelection(DataSel.First, DataSel.Last, Name);
  end;

  if Sel <> nil then begin
    Sel.Lbl     := Name;
    Sel.Comment := Comments;
  end;

  //Don't put unnecessary strain on Acquisition - extend this to other circumstances. LM
  if not Recording then begin
    RefreshLists;
  end;

end;

//function TQUB_QVO_QVD.AddNote(const ListName :String; Pars :INode) :Boolean;
//begin
//end;

function TQUB_QVO_QVD.PlaySelection(ChannelIndex :Integer) :Boolean;
begin
  Result := Play_Play(Self, ChannelIndex);
end;

function TQUB_QVO_QVD.StopSelection :Boolean;
begin
  Result := Play_Stop(Self);
end;


//****************************************************************************//
//                                                                            //
//                             L O A D     D A T A                            //
//                                                                            //
//****************************************************************************//
function TQUB_QVO_QVD.LoadData(Buffer :TPMInteger; Sel :TQUB_FirstLast; Process :Boolean; ProcessFilter :Boolean; ProcessBaseLine :Boolean) :Boolean;
begin
  Result := prDataObject.ReadData(Buffer, False{Raw}, -1{Channel}, Sel.First, Sel.Last);

  //Testing - for speed
  {if ProcessBaseLine then }prDoDataBaseline(Buffer, -1{Channel}, (Sel.Last - Sel.First + 1));

  if Process then begin

    prDoProcessData(Buffer, Sel, ProcessFilter, ProcessBaseLine);

  end;
end;

function TQUB_QVO_QVD.LoadDataChannel(Buffer :TPAInteger; ChannelIndex :Integer; Sel :TQUB_FirstLast; Process :Boolean; ProcessFilter :Boolean; ProcessBaseLine :Boolean; ProcessConstBaseline :Boolean) :Boolean;
begin
  Result := prDataObject.ReadData(Buffer, False{Raw}, ChannelIndex, Sel.First, Sel.Last);

  if ProcessConstBaseLine then prDoDataBaseline(Buffer, ChannelIndex, (Sel.Last - Sel.First + 1));

  if Process then begin

    try
      prDoProcessDataChannel(Buffer, ChannelIndex, Sel, ProcessFilter, ProcessBaseLine);
    except
    end;
    
  end;
end;

function TQUB_QVO_QVD.LoadDataChannelProcess(Buffer :TPAInteger; ChannelIndex :Integer; Sel :TQUB_FirstLast; FilterOn :Boolean; FilterFreq :Double; BaseLineOn :Boolean; ProcessConstBaseline :Boolean) :Boolean;
var
  FilterBuffer :TPAInteger;
begin
  Result := prDataObject.ReadData(Buffer, False{Raw}, ChannelIndex, Sel.First, Sel.Last);

  if not Result then begin

    if ProcessConstBaseline then prDoDataBaseline(Buffer, ChannelIndex, (Sel.Last - Sel.First + 1));

    if FilterOn then begin
    //Filter

      FilterBuffer := nil;
      try
        FilterBuffer := IAlloc1(Sel.Last - Sel.First + 1);
        FillChar(FilterBuffer[0], SizeOf(Integer) * (Sel.Last - Sel.First + 1), 0);
        try
          DLLFilterIntData(@Buffer[0], @FilterBuffer[0], Sel.Last - Sel.First + 1,  Sampling, FilterFreq, 1024);
        except
          Result := True;
        end;
        prNewCleanFilterBounds(Buffer, FilterBuffer, Sel, FilterFreq);
        //prCleanFilterBounds(FilterBuffer, Sel, ChannelIndex, FilterFreq);
        Move(FilterBuffer[0], Buffer[0], SizeOf(Integer) * (Sel.Last - Sel.First + 1));
      finally
        if FilterBuffer = nil then Result := True;
        FreeMem(FilterBuffer);
      end;

    end;

    if BaseLineOn  then begin
    //Baseline

      prDoBaseline(Buffer, ChannelIndex, Sel);

    end;

  end;
end;

function TQUB_QVO_QVD.LoadDataProcessed(Buffer :TPMInteger; Sel :TQUB_FirstLast) :Boolean;
var
  ChannelIndex :Integer;
  BufferC      :TPAInteger;
begin

  Result := prDataObject.ReadData(Buffer, False{Raw}, -1{ChannelIndex}, Sel.First, Sel.Last);

  if Result then Exit;

  BufferC := nil;

  try

    prDoDataBaseline(Buffer, -1{ChannelIndex}, (Sel.Last - Sel.First + 1));

    BufferC := IAlloc1(Sel.Last - Sel.First + 1);

    for ChannelIndex := 0 to prDataChannelCount - 1 do begin

      //Process this channel ?
      if FilterOn[ChannelIndex] then begin
      //FilterOn
        FillChar(BufferC[0], SizeOf(Integer) * (Sel.Last - Sel.First + 1), 0);
        try
          DLLFilterIntData(@Buffer[ChannelIndex, 0], @BufferC[0], Sel.Last - Sel.First + 1,  Sampling, FilterFreq[ChannelIndex], 1024);
        except
        end;
        prNewCleanFilterBounds(TPAInteger(@Buffer[ChannelIndex, 0]), BufferC, Sel, FilterFreq[ChannelIndex]);
        //prCleanFilterBounds(BufferC, Sel, ChannelIndex, FilterFreq[ChannelIndex]);
        Move(BufferC[0], Buffer[ChannelIndex, 0], SizeOf(Integer) * (Sel.Last - Sel.First + 1));
      end;

      if BaselineOn[ChannelIndex] then begin
      //BaselineOn
        prDoBaseline(Buffer[ChannelIndex], ChannelIndex, Sel);
      end;

    end;//ChannelIndex

  finally

    FreeMem(BufferC);

  end;

end;

function TQUB_QVO_QVD.prSegmentsCleanFilterBounds(Buffer, FilterBuffer :TPAInteger; Sel :TQUB_FirstLast; FilterFreq :Double): Boolean;
var
  f, l, ff, ll, s :Integer;
begin

  Result := False;
  f := 0;
  for s := 0 to prDataObject.Segments.SegmentCount - 1 do begin
    l := f + prDataObject.Segments[s].Channels.DataCount - 1;
    //Is a part of the segment contained in the Sel?
    if ((f >= Sel.First) and (f <= Sel.Last)) or ((l >= Sel.First) and (l <= Sel.Last)) then begin
      if f < Sel.First then ff := Sel.First else ff := f;
      if l > Sel.Last  then ll := Sel.Last  else ll := l;
      prNewCleanFilterBounds(TPAInteger(@Buffer[ff - Sel.First]), TPAInteger(@FilterBuffer[ff - Sel.First]), QUB_FirstLast(ff, ll), FilterFreq);
    end;
    f := l + 1;
  end;
end;

//The older function did not work well. I also applied the Cleaner to segment boundaries. 02-28-2008. LM
function TQUB_QVO_QVD.prNewCleanFilterBounds(Buffer, FilterBuffer :TPAInteger; Sel :TQUB_FirstLast; FilterFreq :Double): Boolean;
var
  DataBuf      :TPAInteger;
  FilterBuf    :TPAInteger;
  NFir         :Integer;
  x, i, r      :Integer;
begin

  //How many filter coeffiients?
  NFir         := DLLFilterIntData_nfir(FilterFreq, Sampling);
  //Make it a multiple of 1024
  NFir := ((NFir + 1023) div 1024) * 1024;

  //Fill left with n, leave 2*n from left, leave 2*n from right, fill right with n

  DataBuf      := nil;
  FilterBuf    := nil;

  try

    DataBuf    := IAlloc1(6*NFir + 2);
    FilterBuf  := IAlloc1(6*NFir + 2);

    //Fill left n with Buffer[Sel.First]:
    x := Buffer[Sel.First - Sel.First];
    for i := 0 to NFir - 1 do begin
      DataBuf[i] := x;
    end;

    //Copy left 2*n from Buffer to DataBuf (if necessary pad):
    for i := 0 to 2*NFir - 1 do begin
      if (Sel.First + i) > Sel.Last then begin
        DataBuf[i + NFir] := x;
      end else begin
        DataBuf[i + NFir] := Buffer[Sel.First - Sel.First + i];
        x := Buffer[i];
      end;
    end;

    //Fill right n with Buffer[Sel.Last]:
    x := Buffer[Sel.Last - Sel.First];
    for i := 0 to NFir - 1 do begin
      DataBuf[5*NFir + i] := x;
    end;

    //Copy right 2*n from Buffer to DataBuf (if necessary pad):
    for i := 0 to 2*NFir - 1 do begin
      if (Sel.Last - i) < Sel.First then begin
        DataBuf[5*NFir - i] := x;
      end else begin
        DataBuf[5*NFir - i] := Buffer[Sel.Last - Sel.First - i];
        x := Buffer[Sel.Last - Sel.First - i];
      end;
    end;

    FillChar(FilterBuf[0], SizeOf(Integer) * 6*NFir, 0);
    //Filter
    r := DLLFilterIntData(@DataBuf[0], @FilterBuf[0], 6*NFir,  Sampling, FilterFreq, 1024);
    if r <> 0 then Result := True;

    //Copy back into FilterBuffer
    for i := 0 to NFir - 1 do begin
      if (Sel.First + i) > Sel.Last then begin
        Break;
      end else begin
        FilterBuffer[Sel.First - Sel.First + i] := FilterBuf[i + NFir];
      end;
    end;
    for i := 0 to NFir - 1 do begin
      if (Sel.Last - i) < Sel.First then begin
        Break;
      end else begin
        FilterBuffer[Sel.Last - Sel.First - i] := FilterBuf[5*NFir - 1 - i];
      end;
    end;

  finally
    FreeMem(DataBuf);
    FreeMem(FilterBuf);
  end;

end;

function TQUB_QVO_QVD.prCleanFilterBounds(Buffer :TPAInteger; Sel :TQUB_FirstLast; ChannelIndex :Integer; FilterFreq :Double): Boolean;
var
  BufferCount  :Integer;
  DataBuf      :TPAInteger;
  FilterBuf    :TPAInteger;
  NFir         :Integer;
  XSel         :TQUB_FirstLast;

  function FilterXSel: Boolean;
  var
    RealSel       :TQUB_FirstLast;
    X             :Integer;
    i             :Integer;
  begin
    RealSel.First := Max(XSel.First, 0);
    RealSel.Last  := Min(XSel.Last,  DataObject.Segments.TotalDataCount-1);
    Result := prDataObject.ReadData(@(DataBuf[(RealSel.First-XSel.First)]), False{Raw}, ChannelIndex, RealSel.First, RealSel.Last);
    // and fill edges with first/last point
    X             := DataBuf[RealSel.First - XSel.First];
    for i := 0 to RealSel.First - XSel.First - 1 do begin
      DataBuf[i]  := X;
    end;
    X             := DataBuf[RealSel.Last - XSel.First];
    for i := (RealSel.Last + 1) - XSel.First to XSel.Last - XSel.First do begin
      DataBuf[i]  := X;
    end;
    // maybe it should be the average of the in-range points?

    if not Result then begin
      try
        prDoDataBaseline(DataBuf, ChannelIndex, (XSel.Last - XSel.First + 1));
      except
      end;
      FillChar(FilterBuf[0], SizeOf(Integer) * (XSel.Last - XSel.First + 1), 0);
      try
        DLLFilterIntData(@DataBuf[0], @FilterBuf[0], XSel.Last - XSel.First + 1,  Sampling, FilterFreq, 1024);
      except
        Result := True;
      end;
    end;
  end;
begin
  NFir         := DLLFilterIntData_nfir(FilterFreq, Sampling);
  DataBuf      := nil;
  FilterBuf    := nil;
  BufferCount  := Sel.Last - Sel.First + 1;

  if NFir > (BufferCount + 2) then begin
    // problem indexing
    Result := False;
    Exit;
  end;

  try

    DataBuf    := IAlloc1(2*NFir+2);
    FilterBuf  := IAlloc1(2*NFir+2);

    // not sure how many extra samples you need, but this should be enough

    // TODO: need theory advice on filter:
    // how many overlap points needed?  at end as well as beginning?

    // TODO: filter segments separately so filter doesn't bleed over

    XSel.First   := Sel.First - NFir - 1;
    XSel.Last    := Sel.First + NFir;
    Result       := FilterXSel;
    if Result then Exit;
    Move(FilterBuf[NFir+1], Buffer[0], Min(BufferCount, NFir+1)*SizeOf(Integer));

    XSel.First   := Sel.Last - NFir;
    XSel.Last    := Sel.Last + NFir + 1;
    Result       := FilterXSel;
    if Result then Exit;
    Move(FilterBuf[0], Buffer[(Sel.Last - Min(BufferCount,NFir+1) - 1) - Sel.First], Min(BufferCount,NFir+1)*SizeOf(Integer));
  finally
    FreeMem(DataBuf);
    FreeMem(FilterBuf);
  end;
end;


//****************************************************************************//
//                                                                            //
//                                  D R A W                                   //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVD.Paint;
begin
  if prDrawing then Exit;

  try

    if ((csDesigning in ComponentState) or prMustRedraw) then begin
      prMustRedraw := False;
      if (not prNoDraw) then begin
      //This flag is used when setting many properties at once, to prevent drawing each time
        try
          prDrawCritSection.Acquire;
          Canvas.Lock;
          prBitmapCanvas.Lock;
          if not prWindowDrawMode then begin
          //In WindowDrawMode, do NOT erase
            prErase;
          end else begin
            //Beep;
          end;
          if prData <> nil then begin
            prDrawData;
          end;
        finally
          prBitmapCanvas.UnLock;
          Canvas.UnLock;
          prDrawCritSection.Release;
        end;
      end;
    end;

  finally

    inherited;

  end;
end;

procedure TQUB_QVO_QVD.prErase;
begin
  inherited;

  if prDrawForPrinting then begin
    prBitmapCanvas.Pen.Width := prPrintPenWidth;
  end else begin
    prBitmapCanvas.Pen.Width := 0;
  end;
  prBitmapCanvas.Pen.Style   := psSolid;
  if prDrawForPrinting then begin
    if prDrawFrame then begin
      prBitmapCanvas.Brush.Style := Graphics.bsClear;
      prBitmapCanvas.Pen.Color   := clBlack;
      prBitmapCanvas.Rectangle(MarginLeft - 1, MarginTop - 1, prDrawWidth - MarginRight, prDrawHeight - MarginBottom);
    end;
  end else begin
    prBitmapCanvas.Brush.Style := bsSolid;
    prBitmapCanvas.Brush.Color := ColorBack;
    prBitmapCanvas.Pen.Color   := ColorFrame;
    prBitmapCanvas.Rectangle(MarginLeft - 1, MarginTop - 1, prDrawWidth - MarginRight, prDrawHeight - MarginBottom);
  end;

end;

procedure TQUB_QVO_QVD.prDrawData;
var
  ViewRegion        :HRGN;

  TraceRect         :TRect;
  TraceRegn         :TRect;
  TraceWidth        :Integer;
  TraceHeight       :Integer;
  TraceHeightM      :Integer;
  TraceXFirst       :Integer;
  TraceXLast        :Integer;
  TraceDX           :Integer;
  TraceDY           :Integer;

  CurrX             :Integer;

  TraceIndex        :Integer;
  ChannelIndex      :Integer;
  PointIndex        :Integer;

  BreakPoint        :Integer;
  BreakPointChannel :Integer;

  PrevPenColor      :Integer;
  PrevBrushColor    :Integer;

  PrvX              :Integer;
  MinY              :Integer;
  MaxY              :Integer;

  MorePoints        :Boolean;

  VisChannelCount   :Integer;
  VisChannelIndex   :Integer;

  ActualTraceCount  :Integer;
  ActualDrawMode    :TQUB_QVO_QVD_DrawMode;
  ActualTraceXFirst :Integer;
  ActualTraceXLast  :Integer;
  ActualDrawPoints  :Boolean;
  ActualDrawInverted:Integer;
  ActualTraceHeightM:Integer;
  ActualTraceVOffset:Integer;
  ActualSel         :TQUB_FirstLast;
  ActualYMin        :Integer;
  ActualYMax        :Integer;
  yAdd              :Integer;

  ListIter          :TQUB_QVO_QVD_SelectionListIter;
  SelRect           :TRect;

  BaseSegs          :TList;
  BaseSeg           :TQUB_BaselineSeg;
  BaseFrom          :TQUB_BaselineSeg_Node;
  BaseTo            :TQUB_BaselineSeg_Node;
  BaseValid         :Boolean;

  DrawTrace         :Boolean;
  x, y              :Integer;
  xp, yp            :Integer;

  s, s0             :Integer;
  p, n              :Integer;
  o                 :Boolean;

  ColorZone         :Integer;

  IdlFound          :Boolean;
  IdlDataSet        :INode;
  IdlSeg            :INode;
  Firsts            :TPAInteger;
  Lasts             :TPAInteger;
  Classes           :TPAInteger;
  DwellCount        :Integer;
  AmpCount          :Integer;
  Amp               :TPADouble;
  iscal             :Double;
  jscal             :Integer;
  ioff              :Double;

  IdlIter           :TQUB_IdlSegmentsIter;
  F, L, C           :Integer;
  A                 :Double;

  CurveIter         :TQUB_FitCurveIter;
  CurveData         :TPAInteger;
  CurveSel          :TQUB_FirstLast;
  CurveOff          :Integer;

  IsDWT             :Boolean;
  NoIdl             :Boolean;

  Lbl               :String;

  cList             :TQUB_QVO_QVD_SelectionList;
  cSel              :TQUB_FirstLast;
  lIdx              :Integer;
  lSelected         :Integer;
  IsSel             :Boolean;

  ActualOverlapped  :Boolean;

begin

  if prDrawing then Exit;

  prDrawing := True;

  try

    if prDataPointCount = 0 then Exit;

    try

      IsDWT := (DataObject.FileType = QFS_QDF_TYPE_DWT) or (DataObject.FileType = QFS_QDF_TYPE_EVL) or (DataObject.FileType = QFS_QDF_TYPE_PRT) or (DataObject.FileType = QFS_QDF_TYPE_QSF) or (DataObject.FileType = QFS_QDF_TYPE_TAC);
      NoIdl := False;

      //if (prSelectionLists.Items.Count > 0) and (prSelectionLists.ItemIndex >= 0) then begin
      //  ActualOverlapped := False;
      //end else begin
        ActualOverlapped := prDrawListOverlapped;
      //end;

      //Overlap?
      if (prOverlapTraces) or (ActualOverlapped) then begin
        ActualTraceCount := 1;
      end else begin
        ActualTraceCount := prTracesPerPage;
      end;

      TraceWidth        := prDrawWidth - prMargin.Left - prMargin.Right - 1;
      TraceHeight       := (prDrawHeight - prMargin.Top - prMargin.Bottom - 1) div ActualTraceCount;
      TraceHeightM      := TraceHeight - 2*QUB_QVO_QVD_TraceVMargin;
      TraceRect.Left    := 0 + prMargin.Left;
      TraceRect.Right   := TraceRect.Left + TraceWidth;

      TraceDx           := prPointsPerTrace - 1;

      prBitmapCanvas.Pen.Style := psSolid;
      if prDrawForPrinting then begin
        prBitmapCanvas.Pen.Width := prPrintPenWidth;
      end else begin
        prBitmapCanvas.Pen.Width := 0;
      end;

      MorePoints        := (TraceDx > (3 * TraceWidth));

      //TO DO: LM. Modify here if in Overlap mode
      ActualSel         := prDataSel;
      if ActualSel.First = ActualSel.Last then begin
        ActualSel.First := prDataPoint.First - 1;
        ActualSel.Last  := prDataPoint.First - 1;
      end;

      VisChannelCount   := 0;
      for ChannelIndex := 0 to prDataChannelCount - 1 do begin
        if ChannelVisible[ChannelIndex] then VisChannelCount := VisChannelCount + 1;
      end;

      if prOverlapChannels then begin
        ActualTraceHeightM := TraceHeightM + 0{New, 0};
      end else begin
        ActualTraceHeightM := TraceHeightM div Max(1, VisChannelCount) + 0{New, 0};  //-- 9/2004 no error if no visible channels
      end;

      if prDrawIdealizedAbove then begin
        ActualTraceHeightM := ActualTraceHeightM div 2;
      end;

      if ActualTraceHeightM <= 0 then ActualTraceHeightM := 1;

      //Scaling Bar **************************************************************
      for ChannelIndex := 0 to prDataChannelCount - 1 do begin
        if prAutoScale then begin
          prScaleBarADUnits[ChannelIndex] := Abs(DataYMaxAuto[ChannelIndex] - DataYMinAuto[ChannelIndex]);
        end else begin
          prScaleBarADUnits[ChannelIndex] := Abs(DataYMax[ChannelIndex]     - DataYMin[ChannelIndex]);
        end;
        if prScaleBarADUnits[ChannelIndex] = 0 then prScaleBarADUnits[ChannelIndex] := 1;
      end;
      prScaleBarPixel.y := ActualTraceHeightM;
      prScaleBarSamples := prPointsPerTrace;
      prScaleBarPixel.x := TraceWidth;
      //**************************************************************************


      if (prDrawMode = DRAWMODE_SLOW)  or
         //Slow Draw - draw every point
         ((prDrawMode = DRAWMODE_NORM) and (not MorePoints)) or
         //Slow Draw - Norm Draw, but less points than pixels - draw every point
         ((prDrawMode = DRAWMODE_FAST) and (not MorePoints)) then begin
         //Slow Draw - Fast Draw, but less points than pixels - draw every point
        ActualDrawMode := DRAWMODE_SLOW;
      end else if ((prDrawMode = DRAWMODE_NORM) and (MorePoints)) then begin
         //Norm Draw
        ActualDrawMode := DRAWMODE_NORM;
      end else if ((prDrawMode = DRAWMODE_FAST) and (MorePoints)) then begin
         //Fast Draw
        ActualDrawMode := DRAWMODE_FAST;
      end else begin
        ActualDrawMode := prDrawMode;
      end;

      if prDrawForPrinting then ActualDrawMode := PrintDrawMode;

      if (prDrawPoints) and (TraceDx < (TraceWidth div 6)) then begin
        ActualDrawPoints := True;
      end else begin
        ActualDrawPoints := False;
      end;


      if prDrawInverted then ActualDrawInverted := -1 else ActualDrawInverted := 1;


      //Drawing accesories

      if ActualOverlapped then begin
      //List Overlapped


      end else begin
      //Normal

        CurrX             := prDataDraw.First;
        BreakPoint        := WhichSegmentForPoint(CurrX);

        //TraceLoop for background elements (erase, seglabel, listbg, channame)
        //a lot of geometry is repeated from the main drawing loop below
        for TraceIndex := 1 to prTracesPerPage do begin

          if (TraceIndex = 1) or (not OverlapTraces) then begin
            TraceRect.Top    := 0 + prMargin.Top + Round((TraceIndex - 1) * ((prDrawHeight - prMargin.Top - prMargin.Bottom - 1) / ActualTraceCount));
            TraceRect.Bottom := TraceRect.Top + TraceHeight;
          end;

          //Calculate boundaries of the current trace
          TraceXFirst := CurrX;
          TraceXLast  := TraceXFirst + TraceDx;

          //Adjust boundaries
          if TraceXLast > prDataDraw.Last then TraceXLast := prDataDraw.Last;
          if (prTraceChangeOnBreak) and (prDataSegmentCount > 1) then begin
            if TraceXLast > prDataBreakPoints[BreakPoint] then begin
              TraceXLast := prDataBreakPoints[BreakPoint] - 1;
              Inc(BreakPoint);
            end;
          end;

          BreakPointChannel := BreakPoint;

          ActualTraceXFirst := TraceXFirst;
          ActualTraceXLast  := TraceXLast;

          //Check if in WindowDrawMode and make the necessary adjustments
          if prWindowDrawMode then begin

            DrawTrace := False;

            //Has this trace any points to be drawn ?
            if not ((prDataWindow.First > TraceXLast) or (prDataWindow.Last < TraceXFirst)) then begin
            //Yes

              DrawTrace := True;

              if prDataWindow.First > ActualTraceXFirst then begin
                //prDataWindow.First := ActualTraceXFirst;
                //ActualTraceXFirst := prDataWindow.First;// - 1;
                //if ActualTraceXFirst < TraceXFirst then ActualTraceXFirst := TraceXFirst;
              end;
              if prDataWindow.Last  < ActualTraceXLast  then begin
                //prDataWindow.Last{was First}  := ActualTraceXLast;
                //ActualTraceXLast := prDataWindow.Last;//  + 1;
                //if ActualTraceXLast  > TraceXLast then ActualTraceXLast := TraceXLast;
              end;

            end;

          end else begin

            DrawTrace := True;

          end;

          TraceRegn := TraceRect;
          Inc(TraceRegn.Top, QUB_QVO_QVD_TraceVMargin);
          Dec(TraceRegn.Bottom, QUB_QVO_QVD_TraceVMargin);
          ViewRegion := CreateRectRgnIndirect(TraceRegn);
          SelectClipRgn(prBitmapCanvas.Handle, ViewRegion);

          //Draw this Trace
          if DrawTrace then begin

            if (TraceIndex = 1) or not prOverlapTraces then begin
              //Erase background in Window mode
              if prWindowDrawMode then begin
                prBitmapCanvas.Brush.Color := prColorBack;
                prBitmapCanvas.Pen.Color   := prColorBack;
                prBitmapCanvas.Rectangle(TraceRect);
              end;
            end;

            if prDrawSegLabels and prTraceChangeOnBreak and not prOverlapTraces then begin
              //Draw "Segment %d" watermark
              if TraceHeight > 10 Then Begin
                y                          := prBitmapCanvas.Font.Size;
                prBitmapCanvas.Brush.Color := prColorBack;
                prBitmapCanvas.Font.Color  := prColorSegLabel;
                prBitmapCanvas.Font.Style  := [fsBold];
                prBitmapCanvas.Font.Size   := 20;

                Lbl                        := Format('[%d]', [WhichSegmentForPoint(ActualTraceXFirst)+1]);
                while (prBitmapCanvas.Font.Size>6) and (prBitmapCanvas.TextHeight(Lbl)>TraceHeight) do begin
                  prBitmapCanvas.Font.Size := prBitmapCanvas.Font.Size - 1;
                end;
                x                          := prBitmapCanvas.TextWidth(Lbl);
                prBitmapCanvas.TextOut(TraceRect.Left+TraceWidth-x, TraceRect.Top, Lbl);
                prBitmapCanvas.Font.Size   := y;
              end;

              // then cover up the part with data overlapping it
              y                          := TraceRect.Right;
              TraceRect.Right            := TraceRect.Left + ((ActualTraceXLast - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
              prBitmapCanvas.Brush.Color := prColorBack;
              prBitmapCanvas.Pen.Color   := prColorBack;
              prBitmapCanvas.Rectangle(TraceRect);
              TraceRect.Right            := y;
            end;

            //ChannelLoop
            VisChannelIndex := -1;
            for ChannelIndex := 0 to prDataChannelCount - 1 do begin

              if not ChannelVisible[ChannelIndex] then Continue;
              VisChannelIndex := VisChannelIndex + 1;

              if prAutoScale then begin
                ActualYMin := DataYMinAuto[ChannelIndex];
                ActualYMax := DataYMaxAuto[ChannelIndex];
                //TraceDy    := DataYMinAuto[ChannelIndex] - DataYMaxAuto[ChannelIndex];
              end else begin
                ActualYMin := DataYMin[ChannelIndex];
                ActualYMax := DataYMax[ChannelIndex];
                //TraceDy    := DataYMin[ChannelIndex]     - DataYMax[ChannelIndex];
              end;

              if prOverlapChannels then begin
                ActualTraceVOffset := TraceRect.Top + QUB_QVO_QVD_TraceVMargin - 0{New, 0};
              end else begin
                ActualTraceVOffset := TraceRect.Top + QUB_QVO_QVD_TraceVMargin - 0{New, 0} + Round(VisChannelIndex * TraceHeightM / VisChannelCount);
              end;

              if prDrawIdealizedAbove then begin
                Inc(ActualTraceVOffset, ActualTraceHeightM);
              end;


              //Selection List
              if prDrawSelList
              and (ChannelIndex = ActiveChannel)
              and (not prOverlapChannels)
              and (SelectionLists.Items.Count > 0)
              and (SelectionLists.ItemIndex <> -1) then begin

                ListIter := SelectionLists[SelectionLists.ItemIndex].Find(ActualTraceXFirst, ActualTraceXLast, True{ActiveOnly});

                // prBitmapCanvas.Brush.Style := bsDiagCross;
                prBitmapCanvas.Brush.Color := ColorSelList;
                prBitmapCanvas.Pen.Color   := ColorSelList;

                SelRect.Top                := ActualTraceVOffset;
                SelRect.Bottom             := ActualTraceVOffset + ActualTraceHeightM - 1;

                if not ListIter.Done then repeat
                  SelRect.Left             := ((ListIter.Sel.First - TraceXFirst) * TraceWidth)  div (TraceDx) + TraceRect.Left;
                  SelRect.Right            := ((ListIter.Sel.Last  - TraceXFirst) * TraceWidth)  div (TraceDx) + TraceRect.Left;

                  prBitmapCanvas.Rectangle(SelRect);

                until ListIter.Next;

                ListIter.Free;
                // prBitmapCanvas.Brush.Style := bsSolid;

              end;

              //This is necessary because SelectionLists.ItemIndex messes up somehow:
              SelectClipRgn(prBitmapCanvas.Handle, ViewRegion);


              //This should be expanded in the future, to print trace index, scale etc. LM.
              //Draw A/D Channel name:
              if (prDrawSelList) and (not prDrawForPrinting) then begin
                prBitmapCanvas.Brush.Style := Graphics.bsClear;
                prBitmapCanvas.Font.Style  := [];
                prBitmapCanvas.Font.Color  := ColorSelList;
                prBitmapCanvas.TextOut(TraceRect.Left, ActualTraceVOffset + (ActualTraceHeightM div 2) - prBitmapCanvas.TextHeight('M') div 2 , IntToStr(ChannelIndex));
                prBitmapCanvas.Brush.Style := bsSolid;
              end;


              BreakPointChannel := BreakPoint;

            end;//ChannelIndex

          end;//DrawTrace;

          //**********************************************************************

          DeleteObject(ViewRegion);

          CurrX := TraceXLast + 1;
          BreakPoint := BreakPointChannel;

          if CurrX = prDataBreakPoints[BreakPoint] then begin
            Inc(BreakPoint);
          end;

          if CurrX > prDataDraw.Last then Break;

        end;//TraceIndex -- background elements

      end;//DrawListOverlapped
      //************************************************************************



      //**********************************************************************//
      //                                                                      //
      //                          Draw the actual data                        //
      //                                                                      //
      //**********************************************************************//


      if ActualOverlapped then begin

      //**********************************************************************//
      //                                                                      //
      //            Draw the current list with overlapped selections          //
      //                                                                      //
      //**********************************************************************//

        cList := CurrList;
        if cList <> nil then begin

          cList.Lock;

          TraceRect.Top    := prMargin.Top;
          TraceRect.Bottom := TraceRect.Top + TraceHeight;
          TraceRegn        := TraceRect;
          Inc(TraceRegn.Top, QUB_QVO_QVD_TraceVMargin);
          Dec(TraceRegn.Bottom, QUB_QVO_QVD_TraceVMargin);
          ViewRegion       := CreateRectRgnIndirect(TraceRegn);
          SelectClipRgn(prBitmapCanvas.Handle, ViewRegion);


          try


            //Loop twice, first draw the non-selected, then the selected traces
            for lSelected := 1 to 2 do begin

              //Draw each selection
              for lIdx := 0 to cList.Items.Count - 1 do begin

                IsSel := cList.Selected[lIdx];
                if (lSelected = 1) and (IsSel)     then Continue;
                if (lSelected = 2) and (not IsSel) then Continue;

                cSel  := cList.Selection[lIdx].Sel;
                if (cSel.First > prDataDraw.Last) or (cSel.Last < prDataDraw.First) then begin
                  //Beep;
                  Continue;
                end;

                if cSel.First < prDataDraw.First then cSel.First := prDataDraw.First;
                if cSel.Last  > prDataDraw.Last  then cSel.Last  := prDataDraw.Last;

                CurrX := cSel.First;

                //Calculate boundaries of the current selection
                TraceXFirst := CurrX;
                TraceXLast  := TraceXFirst + TraceDx;
                if TraceXLast > cSel.Last then TraceXLast := cSel.Last;

                ActualTraceXFirst := TraceXFirst;
                ActualTraceXLast  := TraceXLast;

                SelectClipRgn(prBitmapCanvas.Handle, ViewRegion);

                //Channel Loop
                VisChannelIndex  := -1;
                for ChannelIndex := 0 to prDataChannelCount - 1 do begin

                  if not ChannelVisible[ChannelIndex] then Continue;
                  VisChannelIndex := VisChannelIndex + 1;

                  if prAutoScale then begin
                    ActualYMin := DataYMinAuto[ChannelIndex];
                    ActualYMax := DataYMaxAuto[ChannelIndex];
                    TraceDy    := DataYMinAuto[ChannelIndex] - DataYMaxAuto[ChannelIndex];
                  end else begin
                    ActualYMin := DataYMin[ChannelIndex];
                    ActualYMax := DataYMax[ChannelIndex];
                    TraceDy    := DataYMin[ChannelIndex]     - DataYMax[ChannelIndex];
                  end;
                  if TraceDy = 0 then TraceDy := 1;

                  if prDrawInverted then begin
                    yAdd :=  ActualYMin;
                  end else begin
                    yAdd := -ActualYMax;
                  end;

                  if prOverlapChannels then begin
                    ActualTraceVOffset := TraceRect.Top + QUB_QVO_QVD_TraceVMargin - 0{New, 0};
                  end else begin
                    ActualTraceVOffset := TraceRect.Top + QUB_QVO_QVD_TraceVMargin - 0{New, 0} + Round(VisChannelIndex * TraceHeightM / VisChannelCount);
                  end;

                  if prDrawIdealizedAbove then begin
                    Inc(ActualTraceVOffset, ActualTraceHeightM);
                  end;


                  PointIndex := ActualTraceXFirst;

                  //Color Change
                  if (prDrawForPrinting) and (prDrawBW) then begin
                  //Printing B/W
                    prBitmapCanvas.Pen.Color   := clBlack;
                    prBitmapCanvas.Brush.Color := clBlack;
                  end else begin
                    if ((PointIndex - cSel.First) >= ActualSel.First) and ((PointIndex - cSel.First) <= ActualSel.Last) then begin
                      if not IsSel then prBitmapCanvas.Pen.Color := ColorSel else prBitmapCanvas.Pen.Color := ColorData[ChannelIndex];
                      if ActualDrawPoints then begin
                        if not IsSel then prBitmapCanvas.Brush.Color := ColorSel else prBitmapCanvas.Brush.Color := ColorData[ChannelIndex];
                      end;
                      ColorZone := 1;//Selection Color
                    end else begin
                      if not IsSel then prBitmapCanvas.Pen.Color := ColorData[ChannelIndex] else prBitmapCanvas.Pen.Color := ColorSel;
                      if ActualDrawPoints then begin
                        if not IsSel then prBitmapCanvas.Brush.Color := ColorData[ChannelIndex] else prBitmapCanvas.Brush.Color := ColorSel;
                      end;
                      ColorZone := 0;//Normal Color
                    end;
                  end;

                  if ((prDrawForPrinting) and (prPrintDrawData)) or (not prDrawForPrinting) then begin

                    //MoveTo TraceXFirst
                    x := ((ActualTraceXFirst - TraceXFirst{ActualTraceXFirst}) * TraceWidth) div (TraceDx) + TraceRect.Left;
                    y := ((ActualDrawInverted * prDataChannelDisplay[ChannelIndex, ActualTraceXFirst - prDataDraw.First] + yAdd) * ActualTraceHeightM + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

                    prBitmapCanvas.MoveTo(x, y);

                    if ActualDrawPoints then begin
                      prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                    end;

                    PrvX := x;
                    MinY := y;
                    MaxY := y;

                    //PointLoop
                    for PointIndex := ActualTraceXFirst + 1 to ActualTraceXLast do begin

                      //Color Change
                      if (not prDrawForPrinting) or ((prDrawForPrinting) and (not prDrawBW)) then begin
                        if (PointIndex - cSel.First) = (ActualSel.First + 1) then begin
                          if ColorZone <> 1 then begin
                            if not IsSel then prBitmapCanvas.Pen.Color := ColorSel else prBitmapCanvas.Pen.Color := ColorData[ChannelIndex];
                            if ActualDrawPoints then begin
                              if not IsSel then prBitmapCanvas.Brush.Color := ColorSel else prBitmapCanvas.Brush.Color := ColorData[ChannelIndex];
                            end;
                            ColorZone := 1;
                          end;
                        end else if (PointIndex - cSel.First) = (ActualSel.Last + 1) then begin
                          if ColorZone <> 0 then begin
                            if not IsSel then prBitmapCanvas.Pen.Color := ColorData[ChannelIndex] else prBitmapCanvas.Pen.Color := ColorSel;
                            if ActualDrawPoints then begin
                              if not IsSel then prBitmapCanvas.Brush.Color := ColorData[ChannelIndex] else prBitmapCanvas.Brush.Color := ColorSel;
                            end;
                            ColorZone := 0;
                          end;
                        end;
                      end;

                      x := ((PointIndex - TraceXFirst)                                                                      * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                      y := ((ActualDrawInverted * prDataChannelDisplay[ChannelIndex, PointIndex - prDataDraw.First] + yAdd) * ActualTraceHeightM + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

                      case ActualDrawMode of
                        DRAWMODE_SLOW:  // Draws line from every point to next point
                          begin
                            //LineTo PointIndex
                            prBitmapCanvas.LineTo(x, y);
                            if ActualDrawPoints then begin
                              prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                            end;
                          end;
                        DRAWMODE_NORM:  // Accumulates min and max y values until x changes, then draws a line at x from minY to maxY
                          begin
                            if MinY > y then MinY := y;
                            if MaxY < y then MaxY := y;
                            if x <> PrvX then begin
                              prBitmapCanvas.MoveTo(PrvX, MinY);
                              prBitmapCanvas.LineTo(PrvX, MaxY + 1);
                              PrvX := x;
                              MinY := y;
                              MaxY := y;
                            end;
                          end;
                        DRAWMODE_FAST:  // Ignores lines where previous x and x match
                          begin
                            if x <> PrvX then begin
                              //LineTo PointIndex
                              prBitmapCanvas.LineTo(x, y);
                              if ActualDrawPoints then begin
                                prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                              end;
                              PrvX := x;
                            end;
                          end;
                      end;//case ActualDrawMode

                    end;//PointIndex

                    //Draw the remaining points, if in Norm or Fast mode ...................
                    case ActualDrawMode of
                      DRAWMODE_NORM:
                        begin
                          if x = PrvX then begin
                            prBitmapCanvas.MoveTo(PrvX, MinY);
                            prBitmapCanvas.LineTo(PrvX, MaxY + 1);
                          end;
                        end;
                      DRAWMODE_FAST:
                        begin
                          if x = PrvX then begin
                            prBitmapCanvas.LineTo(x, y);
                            if ActualDrawPoints then begin
                              prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                            end;
                          end;
                        end;
                    end;//case ActualDrawMode
                    //......................................................................

                    //Draw current point
                    if (prDataCurr >= TraceXFirst) and (prDataCurr <= TraceXLast) then begin
                      if not prDrawForPrinting then begin
                        x := ((prDataCurr                                                         - TraceXFirst)              * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                        y := ((ActualDrawInverted * prDataChannelDisplay[ChannelIndex, prDataCurr - prDataDraw.First] + yAdd) * ActualTraceHeightM + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;
                        prBitmapCanvas.Brush.Color := ColorCurr;
                        prBitmapCanvas.Pen.Color   := ColorCurr;
                        if ActualDrawPoints then begin
                          prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                        end else begin
                          prBitmapCanvas.MoveTo(x,     y);
                          prBitmapCanvas.LineTo(x + 1, y);
                        end;
                      end;
                    end;

                  end;

                  //Overlap Data *****************************************************
                  if prDrawIdealized then begin

                    CurveIter    := nil;

                    if prDrawIdealizedAbove then begin
                      Dec(ActualTraceVOffset, ActualTraceHeightM);
                    end;

                    try

                      CurveIter    := FitCurves.Find(TraceXFirst);
                      if (ChannelIndex = ActiveChannel) and (0 = CurveIter.Done) then begin

                        if ((prDrawForPrinting) and (prPrintDrawIDLData{prPrintDrawData})) or (not prDrawForPrinting) then begin

                          while (0 = CurveIter.Done) and (CurveIter.Curve.First <= TraceXLast) do begin
                            CurveData       := CurveIter.Curve.Data;
                            CurveSel.First  := CurveIter.Curve.First;
                            CurveSel.Last   := CurveIter.Curve.Last;
                            CurveOff        := 0;
                            if CurveSel.First < TraceXFirst then begin
                              CurveOff       := TraceXFirst - CurveSel.First;
                              CurveSel.First := TraceXFirst;
                            end;
                            if CurveSel.Last  > TraceXLast  then CurveSel.Last  := TraceXLast;

                            //MoveTo TraceXFirst
                            x := ((CurveSel.First - TraceXFirst)                                                                   * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                            y := ((ActualDrawInverted * CurveData[CurveSel.First{TraceXFirst} - CurveSel.First + CurveOff] + yAdd) * ActualTraceHeightM + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

                            prBitmapCanvas.MoveTo(x, y);

                            if ActualDrawPoints then begin
                              prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                            end;

                            PrvX    := x;
                            MinY    := y;
                            MaxY    := y;

                            PointIndex := CurveSel.First;

                            //Color Change
                            if (prDrawForPrinting) and (prDrawBW) then begin
                            //Printing B/W
                              prBitmapCanvas.Pen.Color   := clBlack;
                              prBitmapCanvas.Brush.Color := clBlack;
                            end else begin
                              if ((PointIndex - cSel.First) >= ActualSel.First) and ((PointIndex - cSel.First) <= ActualSel.Last) then begin
                                if not IsSel then prBitmapCanvas.Pen.Color := ColorIdealizedSel else prBitmapCanvas.Pen.Color := ColorIdealized;
                                if ActualDrawPoints then begin
                                  if not IsSel then prBitmapCanvas.Brush.Color := ColorIdealizedSel else prBitmapCanvas.Brush.Color := ColorIdealized;
                                end;
                                ColorZone := 1;//Selection Color
                              end else begin
                                if not IsSel then prBitmapCanvas.Pen.Color := ColorIdealized else prBitmapCanvas.Pen.Color := ColorIdealizedSel;
                                if ActualDrawPoints then begin
                                  if not IsSel then prBitmapCanvas.Brush.Color := ColorIdealized else prBitmapCanvas.Brush.Color := ColorIdealizedSel;
                                end;
                                ColorZone := 0;//Normal Color
                              end;
                            end;

                            //PointLoop
                            for PointIndex := CurveSel.First + 1{TraceXFirst + 1} to CurveSel.Last{TraceXLast} do begin

                              //Color Change
                              if (not prDrawForPrinting) or ((prDrawForPrinting) and (not prDrawBW)) then begin
                                if (PointIndex - cSel.First) = (ActualSel.First + 1) then begin
                                  if ColorZone <> 1 then begin
                                    if not IsSel then prBitmapCanvas.Pen.Color := ColorIdealizedSel else prBitmapCanvas.Pen.Color := ColorIdealized;
                                    if ActualDrawPoints then begin
                                      if not IsSel then prBitmapCanvas.Brush.Color := ColorIdealizedSel else prBitmapCanvas.Brush.Color := ColorIdealized;
                                    end;
                                    ColorZone := 1;
                                  end;
                                end else if (PointIndex - cSel.First) = (ActualSel.Last + 1) then begin
                                  if ColorZone <> 0 then begin
                                    if not IsSel then prBitmapCanvas.Pen.Color := ColorIdealized else prBitmapCanvas.Pen.Color := ColorIdealizedSel;
                                    if ActualDrawPoints then begin
                                      if not IsSel then prBitmapCanvas.Brush.Color := ColorIdealized else prBitmapCanvas.Brush.Color := ColorIdealizedSel;
                                    end;
                                    ColorZone := 0;
                                  end;
                                end;
                              end;

                              x := ((PointIndex - TraceXFirst)                                                       * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                              y := ((ActualDrawInverted * CurveData[PointIndex  - CurveSel.First + CurveOff] + yAdd) * ActualTraceHeightM + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

                              case ActualDrawMode of
                                DRAWMODE_SLOW:
                                  begin
                                    //LineTo PointIndex
                                    prBitmapCanvas.LineTo(x, y);
                                    if ActualDrawPoints then begin
                                      prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                                    end;
                                  end;
                                DRAWMODE_NORM:
                                  begin
                                    if MinY > y then MinY := y;
                                    if MaxY < y then MaxY := y;
                                    if x <> PrvX then begin
                                      //LineTo PointIndex
                                      prBitmapCanvas.MoveTo(PrvX, MinY);
                                      prBitmapCanvas.LineTo(PrvX, MaxY + 1);
                                      PrvX := x;
                                      MinY := y;
                                      MaxY := y;
                                    end;
                                  end;
                                DRAWMODE_FAST:
                                  begin
                                    if x <> PrvX then begin
                                      //LineTo PointIndex
                                      prBitmapCanvas.LineTo(x, y);
                                      if ActualDrawPoints then begin
                                        prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                                      end;
                                      PrvX := x;
                                    end;
                                  end;
                              end;//case ActualDrawMode

                            end;//PointIndex

                            //Draw the remaining points, if in Norm or Fast mode .........
                            case ActualDrawMode of
                              DRAWMODE_NORM:
                                begin
                                  if x = PrvX then begin
                                    prBitmapCanvas.MoveTo(PrvX, MinY);
                                    prBitmapCanvas.LineTo(PrvX, MaxY + 1);
                                  end;
                                end;
                              DRAWMODE_FAST:
                                begin
                                  if x = PrvX then begin
                                    prBitmapCanvas.LineTo(x, y);
                                    if ActualDrawPoints then begin
                                      prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                                    end;
                                  end;
                                end;
                            end;//case ActualDrawMode
                            //............................................................

                            CurveIter.Next;

                          end;

                        end;

                      end;//**************************************************************

                    finally
                      if CurveIter <> nil then CurveIter.Free;
                    end;

                    //if prDrawIdealizedAbove then begin
                    //  Inc(ActualTraceVOffset, ActualTraceHeightM);
                    //end;

                  end;//Overlap data


                  //Selection List Labels
                  (*
                  if prDrawSelList
                  and (ChannelIndex = ActiveChannel)
                  and (not prOverlapChannels)
                  and (not prOverlapTraces)
                  and (SelectionLists.Items.Count > 0)
                  and (SelectionLists.ItemIndex <> -1) then begin

                    ListIter := SelectionLists[SelectionLists.ItemIndex].Find(ActualTraceXFirst, ActualTraceXLast, True{ActiveOnly});

                    prBitmapCanvas.Font.Color  := clInfoText; // ColorData[ChannelIndex];
                    prBitmapCanvas.Font.Style  := [fsBold];
                    prBitmapCanvas.Brush.Color := clInfoBk; // ColorBack;
                    prBitmapCanvas.Pen.Color   := clBlack;
                    SelRect.Top                := ActualTraceVOffset;

                    if not ListIter.Done then repeat
                      SelRect.Left             := ((ListIter.Sel.First - TraceXFirst) * TraceWidth)  div (TraceDx) + TraceRect.Left;
                      prBitmapCanvas.TextOut(SelRect.Left+2, SelRect.Top+2, ListIter.Lbl);
                    until ListIter.Next;

                    ListIter.Free;

                  end;
                  *)

                  //Parameters
                  if prDrawParameters
                  and (ChannelIndex = ActiveChannel)
                  and (not prOverlapChannels)
                  and (not prOverlapTraces)
                  {and (SelectionLists.Items.Count > 0)
                  and (SelectionLists.ItemIndex <> -1)} then begin


                  end;

                end;//ChannelIndex

              end;//lIdx

            end;//lSelected;

            //Cursor *******************************************************************
            DeleteObject(ViewRegion);
            Dec(TraceRegn.Top, QUB_QVO_QVD_TraceVMargin);
            Inc(TraceRegn.Bottom, QUB_QVO_QVD_TraceVMargin);
            ViewRegion := CreateRectRgnIndirect(TraceRegn);
            SelectClipRgn(prBitmapCanvas.Handle, ViewRegion);

            if not prDrawForPrinting then begin

              //Delete old current point marker
              if (prDataOldCurr >= (TraceXFirst - cSel.First)) and (prDataOldCurr <= (TraceXLast - cSel.First)) then begin
                x := ((prDataOldCurr - (TraceXFirst - cSel.First)) * TraceWidth) div (TraceDx) + TraceRect.Left;
                prBitmapCanvas.Brush.Color := ColorBack;
                prBitmapCanvas.Pen.Color   := ColorBack;
                prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Top),        Point(x + 3, TraceRect.Top),        Point(x, TraceRect.Top        + (QUB_QVO_QVD_TraceVMargin - 1))]);
                prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Bottom - 1), Point(x + 3, TraceRect.Bottom - 1), Point(x, TraceRect.Bottom - 1 - (QUB_QVO_QVD_TraceVMargin - 1))]);
              end;

              //Draw current point marker
              if (prDataCurr >= (TraceXFirst - cSel.First)) and (prDataCurr <= (TraceXLast - cSel.First)) then begin
                x := ((prDataCurr - (TraceXFirst - cSel.First)) * TraceWidth) div (TraceDx) + TraceRect.Left;
                prBitmapCanvas.Brush.Color := ColorCurr;
                prBitmapCanvas.Pen.Color   := ColorCurr;
                prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Top),        Point(x + 3, TraceRect.Top),        Point(x, TraceRect.Top        + (QUB_QVO_QVD_TraceVMargin - 1))]);
                prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Bottom - 1), Point(x + 3, TraceRect.Bottom - 1), Point(x, TraceRect.Bottom - 1 - (QUB_QVO_QVD_TraceVMargin - 1))]);
              end;

            end;
            //**************************************************************************

            DeleteObject(ViewRegion);

          finally
            cList.Unlock;
          end;

        end;//cList <> nil;

      end else begin


      //**********************************************************************//
      //                                                                      //
      //                              Draw normal                             //
      //                                                                      //
      //**********************************************************************//

        CurrX             := prDataDraw.First;
        BreakPoint        := WhichSegmentForPoint(CurrX);

        //TraceLoop
        for TraceIndex := 1 to prTracesPerPage do begin

          if (TraceIndex = 1) or (not OverlapTraces) then begin
            TraceRect.Top    := 0 + prMargin.Top + Round((TraceIndex - 1) * ((prDrawHeight - prMargin.Top - prMargin.Bottom - 1) / ActualTraceCount));
            TraceRect.Bottom := TraceRect.Top + TraceHeight;
          end;

          //Calculate boundaries of the current trace
          TraceXFirst := CurrX;
          TraceXLast  := TraceXFirst + TraceDx;

          //Adjust boundaries
          if TraceXLast > prDataDraw.Last then TraceXLast := prDataDraw.Last;
          if (prTraceChangeOnBreak) and (prDataSegmentCount > 1) then begin
            if TraceXLast > prDataBreakPoints[BreakPoint] then begin
              TraceXLast := prDataBreakPoints[BreakPoint] - 1;
              Inc(BreakPoint);
            end;
          end;

          BreakPointChannel := BreakPoint;

          ActualTraceXFirst := TraceXFirst;
          ActualTraceXLast  := TraceXLast;

          //Check if in WindowDrawMode and make the necessary adjustments
          if prWindowDrawMode then begin

            DrawTrace := False;

            //Has this trace any points to be drawn ?
            if not ((prDataWindow.First > TraceXLast) or (prDataWindow.Last < TraceXFirst)) then begin
            //Yes

              DrawTrace := True;

              if prDataWindow.First > ActualTraceXFirst then begin
                //prDataWindow.First := ActualTraceXFirst;
                //ActualTraceXFirst := prDataWindow.First;// - 1;
                //if ActualTraceXFirst < TraceXFirst then ActualTraceXFirst := TraceXFirst;
              end;
              if prDataWindow.Last  < ActualTraceXLast  then begin
                //prDataWindow.Last{was First}  := ActualTraceXLast;
                //ActualTraceXLast := prDataWindow.Last;//  + 1;
                //if ActualTraceXLast  > TraceXLast then ActualTraceXLast := TraceXLast;
              end;

            end;

          end else begin

            DrawTrace := True;

          end;

          TraceRegn := TraceRect;
          Inc(TraceRegn.Top, QUB_QVO_QVD_TraceVMargin);
          Dec(TraceRegn.Bottom, QUB_QVO_QVD_TraceVMargin);
          ViewRegion := CreateRectRgnIndirect(TraceRegn);
          SelectClipRgn(prBitmapCanvas.Handle, ViewRegion);

          //Draw this Trace
          if DrawTrace then begin
            { moved up to bg elements
            //Erase background in Window mode
            if prWindowDrawMode then begin
              prBitmapCanvas.Brush.Color := prColorBack;
              prBitmapCanvas.Pen.Color   := prColorBack;
              prBitmapCanvas.Rectangle(TraceRect);
            end;

            if prDrawSegLabels and prTraceChangeOnBreak and not prOverlapTraces then begin
              //Draw "Segment %d" watermark
              if TraceHeight > 10 Then Begin
                y                          := prBitmapCanvas.Font.Size;
                prBitmapCanvas.Brush.Color := prColorBack;
                prBitmapCanvas.Font.Color  := prColorSegLabel;
                prBitmapCanvas.Font.Style  := [fsBold];
                prBitmapCanvas.Font.Size   := 20;

                Lbl                        := Format('[%d]', [WhichSegmentForPoint(ActualTraceXFirst)+1]);
                while (prBitmapCanvas.Font.Size>6) and (prBitmapCanvas.TextHeight(Lbl)>TraceHeight) do begin
                  prBitmapCanvas.Font.Size := prBitmapCanvas.Font.Size - 1;
                end;
                x                          := prBitmapCanvas.TextWidth(Lbl);
                prBitmapCanvas.TextOut(TraceRect.Left+TraceWidth-x, TraceRect.Top, Lbl);
                prBitmapCanvas.Font.Size   := y;
              end;

              // then cover up the part with data overlapping it
              y                          := TraceRect.Right;
              TraceRect.Right            := TraceRect.Left + ((ActualTraceXLast - TraceXFirst)                                                                      * TraceWidth)                     div (TraceDx) + TraceRect.Left;
              prBitmapCanvas.Brush.Color := prColorBack;
              prBitmapCanvas.Pen.Color   := prColorBack;
              prBitmapCanvas.Rectangle(TraceRect);
              TraceRect.Right            := y;
            end;
            }
            //ChannelLoop
            VisChannelIndex := -1;
            for ChannelIndex := 0 to prDataChannelCount - 1 do begin

              if not ChannelVisible[ChannelIndex] then Continue;
              VisChannelIndex := VisChannelIndex + 1;

              if prAutoScale then begin
                ActualYMin := DataYMinAuto[ChannelIndex];
                ActualYMax := DataYMaxAuto[ChannelIndex];
                TraceDy    := DataYMinAuto[ChannelIndex] - DataYMaxAuto[ChannelIndex];
              end else begin
                ActualYMin := DataYMin[ChannelIndex];
                ActualYMax := DataYMax[ChannelIndex];
                TraceDy    := DataYMin[ChannelIndex]     - DataYMax[ChannelIndex];
              end;
              if TraceDy = 0 then TraceDy := 1;

              if prDrawInverted then begin
                yAdd :=  ActualYMin;
              end else begin
                yAdd := -ActualYMax;
              end;

              if prOverlapChannels then begin
                ActualTraceVOffset := TraceRect.Top + QUB_QVO_QVD_TraceVMargin - 0{New, 0};
              end else begin
                ActualTraceVOffset := TraceRect.Top + QUB_QVO_QVD_TraceVMargin - 0{New, 0} + Round(VisChannelIndex * TraceHeightM / VisChannelCount);
              end;

              if prDrawIdealizedAbove then begin
                Inc(ActualTraceVOffset, ActualTraceHeightM);
              end;

              (* moved up to bg elements
              //Selection List
              if prDrawSelList
              and (ChannelIndex = ActiveChannel)
              and (not prOverlapChannels)
              and (not prOverlapTraces)
              and (SelectionLists.Items.Count > 0)
              and (SelectionLists.ItemIndex <> -1) then begin

                ListIter := SelectionLists[SelectionLists.ItemIndex].Find(ActualTraceXFirst, ActualTraceXLast, True{ActiveOnly});

                // prBitmapCanvas.Brush.Style := bsDiagCross;
                prBitmapCanvas.Brush.Color := ColorSelList;
                prBitmapCanvas.Pen.Color   := ColorSelList;

                SelRect.Top                := ActualTraceVOffset;
                SelRect.Bottom             := ActualTraceVOffset + ActualTraceHeightM - 1;

                if not ListIter.Done then repeat
                  SelRect.Left             := ((ListIter.Sel.First - TraceXFirst) * TraceWidth)  div (TraceDx) + TraceRect.Left;
                  SelRect.Right            := ((ListIter.Sel.Last  - TraceXFirst) * TraceWidth)  div (TraceDx) + TraceRect.Left;

                  prBitmapCanvas.Rectangle(SelRect);

                until ListIter.Next;

                ListIter.Free;
                // prBitmapCanvas.Brush.Style := bsSolid;

              end;

              //This is necessary because SelectionLists.ItemIndex messes up somehow:
              SelectClipRgn(prBitmapCanvas.Handle, ViewRegion);


              //This should be expanded in the future, to print trace index, scale etc. LM.
              //Draw A/D Channel name:
              if (prDrawSelList) and (not prDrawForPrinting) then begin
                prBitmapCanvas.Brush.Style := Graphics.bsClear;
                prBitmapCanvas.Font.Style  := [];
                prBitmapCanvas.Font.Color  := ColorSelList;
                prBitmapCanvas.TextOut(TraceRect.Left, ActualTraceVOffset + (ActualTraceHeightM div 2) - prBitmapCanvas.TextHeight('M') div 2 , IntToStr(ChannelIndex));
                prBitmapCanvas.Brush.Style := bsSolid;
              end;
              *)

              BreakPointChannel := BreakPoint;

              PointIndex := ActualTraceXFirst;

              //Color Change
              if (prDrawForPrinting) and (prDrawBW) then begin
              //Printing B/W
                prBitmapCanvas.Pen.Color   := clBlack;
                prBitmapCanvas.Brush.Color := clBlack;
              end else begin
                if (PointIndex >= ActualSel.First) and (PointIndex <= ActualSel.Last) then begin
                  prBitmapCanvas.Pen.Color := ColorSel;
                  if ActualDrawPoints then begin
                    prBitmapCanvas.Brush.Color := ColorSel;
                  end;
                  ColorZone := 1;//Selection Color
                end else begin
                  prBitmapCanvas.Pen.Color := ColorData[ChannelIndex];
                  if ActualDrawPoints then begin
                    prBitmapCanvas.Brush.Color := ColorData[ChannelIndex];
                  end;
                  ColorZone := 0;//Normal Color
                end;
              end;

              if ((prDrawForPrinting) and (prPrintDrawData)) or (not prDrawForPrinting) then begin

                //MoveTo TraceXFirst
                x := ((ActualTraceXFirst - TraceXFirst{ActualTraceXFirst}) * TraceWidth) div (TraceDx) + TraceRect.Left;
                y := ((ActualDrawInverted * prDataChannelDisplay[ChannelIndex, ActualTraceXFirst - prDataDraw.First] + yAdd) * ActualTraceHeightM + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

                prBitmapCanvas.MoveTo(x, y);

                if ActualDrawPoints then begin
                  prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                end;

                PrvX := x;
                MinY := y;
                MaxY := y;

                //PointLoop
                for PointIndex := ActualTraceXFirst + 1 to ActualTraceXLast do begin

                  //Color Change
                  if (not prDrawForPrinting) or ((prDrawForPrinting) and (not prDrawBW)) then begin
                    if PointIndex = (ActualSel.First + 1) then begin
                      if ColorZone <> 1 then begin
                        prBitmapCanvas.Pen.Color := ColorSel;
                        if ActualDrawPoints then begin
                          prBitmapCanvas.Brush.Color := ColorSel;
                        end;
                        ColorZone := 1;
                      end;
                    end else if PointIndex = (ActualSel.Last + 1) then begin
                      if ColorZone <> 0 then begin
                        prBitmapCanvas.Pen.Color := ColorData[ChannelIndex];
                        if ActualDrawPoints then begin
                          prBitmapCanvas.Brush.Color := ColorData[ChannelIndex];
                        end;
                        ColorZone := 0;
                      end;
                    end;
                  end;

                  if PointIndex = prDataBreakPoints[BreakPointChannel] then begin

                    Inc(BreakPointChannel);

                    //MoveTo PointIndex
                    x := ((PointIndex - TraceXFirst)                                                                      * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                    y := ((ActualDrawInverted * prDataChannelDisplay[ChannelIndex, PointIndex - prDataDraw.First] + yAdd) * ActualTraceHeightM + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

                    prBitmapCanvas.MoveTo(x, y);

                    if ActualDrawPoints then begin
                      prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                    end;

                    PrvX := x;
                    MinY := y;
                    MaxY := y;

                  end else begin

                    x := ((PointIndex - TraceXFirst)                                                                      * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                    y := ((ActualDrawInverted * prDataChannelDisplay[ChannelIndex, PointIndex - prDataDraw.First] + yAdd) * ActualTraceHeightM + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

                    case ActualDrawMode of

                      DRAWMODE_SLOW:  // Draws line from every point to next point

                        begin

                          //LineTo PointIndex
                          prBitmapCanvas.LineTo(x, y);

                          if ActualDrawPoints then begin
                            prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                          end;

                        end;

                      DRAWMODE_NORM:  // Accumulates min and max y values until x changes, then draws a line at x from minY to maxY

                        begin

                          if MinY > y then MinY := y;
                          if MaxY < y then MaxY := y;

                          if x <> PrvX then begin

                            prBitmapCanvas.MoveTo(PrvX, MinY);
                            prBitmapCanvas.LineTo(PrvX, MaxY + 1);

                            PrvX := x;
                            MinY := y;
                            MaxY := y;

                          end;

                        end;

                      DRAWMODE_FAST:  // Ignores lines where previous x and x match

                        begin

                          if x <> PrvX then begin

                            //LineTo PointIndex
                            prBitmapCanvas.LineTo(x, y);

                            if ActualDrawPoints then begin
                              prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                            end;

                            PrvX := x;

                          end;

                        end;

                    end;//case ActualDrawMode

                  end;

                end;//PointIndex

                //Draw the remaining points, if in Norm or Fast mode ...................
                case ActualDrawMode of
                  DRAWMODE_NORM:
                    begin
                      if x = PrvX then begin
                        prBitmapCanvas.MoveTo(PrvX, MinY);
                        prBitmapCanvas.LineTo(PrvX, MaxY + 1);
                      end;
                    end;
                  DRAWMODE_FAST:
                    begin
                      if x = PrvX then begin
                        prBitmapCanvas.LineTo(x, y);
                        if ActualDrawPoints then begin
                          prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                        end;
                      end;
                    end;
                end;//case ActualDrawMode
                //......................................................................

                //Draw current point
                if (prDataCurr >= TraceXFirst) and (prDataCurr <= TraceXLast) then begin
                  if not prDrawForPrinting then begin
                    x := ((prDataCurr                                                        - TraceXFirst)               * TraceWidth)                    div (TraceDx) + TraceRect.Left;
                    y := ((ActualDrawInverted * prDataChannelDisplay[ChannelIndex, prDataCurr - prDataDraw.First] + yAdd) * ActualTraceHeightM + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;
                    prBitmapCanvas.Brush.Color := ColorCurr;
                    prBitmapCanvas.Pen.Color   := ColorCurr;
                    if ActualDrawPoints then begin
                      prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                    end else begin
                      prBitmapCanvas.MoveTo(x,     y);
                      prBitmapCanvas.LineTo(x + 1, y);
                    end;
                  end;
                end;

              end;

              //Overlap Data *****************************************************
              if prDrawIdealized then begin

                CurveIter    := nil;

                if prDrawIdealizedAbove then begin
                  Dec(ActualTraceVOffset, ActualTraceHeightM);
                end;

                try

                  CurveIter    := FitCurves.Find(TraceXFirst);
                  if (ChannelIndex = ActiveChannel) and (0 = CurveIter.Done) then begin

                    //Color Change
                    if (prDrawForPrinting) and (prDrawBW) then begin
                      prBitmapCanvas.Pen.Color   := clBlack;
                      prBitmapCanvas.Brush.Color := clBlack;
                    end else begin
                      prBitmapCanvas.Pen.Color   := ColorIdealized;
                      prBitmapCanvas.Brush.Color := ColorIdealized;
                    end;

                    if ((prDrawForPrinting) and (prPrintDrawIDLData{prPrintDrawData})) or (not prDrawForPrinting) then begin

                      while (0 = CurveIter.Done) and (CurveIter.Curve.First <= TraceXLast) do begin
                        CurveData       := CurveIter.Curve.Data;
                        CurveSel.First  := CurveIter.Curve.First;
                        CurveSel.Last   := CurveIter.Curve.Last;
                        CurveOff        := 0;
                        if CurveSel.First < TraceXFirst then begin
                          CurveOff       := TraceXFirst - CurveSel.First;
                          CurveSel.First := TraceXFirst;
                        end;
                        if CurveSel.Last  > TraceXLast  then CurveSel.Last  := TraceXLast;

                        //MoveTo TraceXFirst
                        x := ((CurveSel.First - TraceXFirst)                                                                   * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                        y := ((ActualDrawInverted * CurveData[CurveSel.First{TraceXFirst} - CurveSel.First + CurveOff] + yAdd) * ActualTraceHeightM + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

                        prBitmapCanvas.MoveTo(x, y);

                        if ActualDrawPoints then begin
                          prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                        end;

                        PrvX    := x;
                        MinY    := y;
                        MaxY    := y;

                        //PointLoop
                        for PointIndex := CurveSel.First + 1{TraceXFirst + 1} to CurveSel.Last{TraceXLast} do begin

                          x := ((PointIndex - TraceXFirst)                                                       * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                          y := ((ActualDrawInverted * CurveData[PointIndex  - CurveSel.First + CurveOff] + yAdd) * ActualTraceHeightM + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

                          case ActualDrawMode of

                            DRAWMODE_SLOW:

                              begin

                                //LineTo PointIndex
                                prBitmapCanvas.LineTo(x, y);

                                if ActualDrawPoints then begin
                                  prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                                end;

                              end;

                            DRAWMODE_NORM:

                              begin

                                if MinY > y then MinY := y;
                                if MaxY < y then MaxY := y;

                                if x <> PrvX then begin

                                  //LineTo PointIndex
                                  prBitmapCanvas.MoveTo(PrvX, MinY);
                                  prBitmapCanvas.LineTo(PrvX, MaxY + 1);

                                  PrvX := x;
                                  MinY := y;
                                  MaxY := y;

                                end;

                              end;

                            DRAWMODE_FAST:

                              begin

                                if x <> PrvX then begin

                                  //LineTo PointIndex
                                  prBitmapCanvas.LineTo(x, y);

                                  if ActualDrawPoints then begin
                                    prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                                  end;

                                  PrvX := x;

                                end;

                              end;

                          end;//case ActualDrawMode

                        end;//PointIndex

                          //Draw the remaining points, if in Norm or Fast mode .........
                        case ActualDrawMode of
                          DRAWMODE_NORM:
                            begin
                              if x = PrvX then begin
                                prBitmapCanvas.MoveTo(PrvX, MinY);
                                prBitmapCanvas.LineTo(PrvX, MaxY + 1);
                              end;
                            end;
                          DRAWMODE_FAST:
                            begin
                              if x = PrvX then begin
                                prBitmapCanvas.LineTo(x, y);
                                if ActualDrawPoints then begin
                                  prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                                end;
                              end;
                            end;
                        end;//case ActualDrawMode
                        //............................................................

                        CurveIter.Next;

                      end;

                    end;

                  end;//**************************************************************
                finally
                  if CurveIter <> nil then CurveIter.Free;
                end;

                if prDrawIdealizedAbove then begin
                  Inc(ActualTraceVOffset, ActualTraceHeightM);
                end;

              end;//Overlap data


              if ((prDrawForPrinting) and (prPrintDrawBase)) or (not prDrawForPrinting) then begin

                //Draw Baseline
                if prDrawBaseline then begin

                  if (prDrawForPrinting) and (prDrawBW) then begin
                    prBitmapCanvas.Pen.Color   := clBlack;
                  end else begin
                    prBitmapCanvas.Pen.Color   := ColorBaseline;
                  end;
                  x := ((TraceXFirst - TraceXFirst)                                * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                  // y := ((ActualDrawInverted * prDataBaseline[ChannelIndex] + yAdd) * ActualTraceHeightM + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;
                  y := ((ActualDrawInverted * 0 + yAdd) * ActualTraceHeightM + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;

                  prBitmapCanvas.MoveTo(x, y);
                  x := ((TraceXLast  - TraceXFirst)                                * TraceWidth)                     div (TraceDx) + TraceRect.Left;
                  prBitmapCanvas.LineTo(x + 1, y);

                end;

                //Draw Baseline Nodes
                if prDrawBaselineNodes then begin
                  if (prDrawForPrinting) and (prDrawBW) then begin
                    prBitmapCanvas.Pen.Color   := clBlack;
                    prBitmapCanvas.Brush.Color := clBlack;
                  end else begin
                    prBitmapCanvas.Pen.Color   := ColorBaselineNodes;
                    prBitmapCanvas.Brush.Color := ColorBaselineNodes;
                  end;

                  if BaselineOn[ChannelIndex] then begin
                    jscal   := 0;
                  end else begin
                    jscal   := 1;
                  end;

                  BaseSegs  := TList.Create;
                  if not BaselineNodes[ChannelIndex].GetReadSegs(TraceXFirst, TraceXLast, BaseSegs) then begin
                    try
                      p := TraceXFirst;
                      for n := 0 to BaseSegs.Count - 1 do begin
                        BaseSeg   := TQUB_BaselineSeg(BaseSegs[n]);
                        BaseValid := not BaseSeg.RangeAt(p, BaseFrom, BaseTo);
                        if not BaseValid then Continue;
                        if BaseFrom.Point >= p then begin
                          x := ((BaseFrom.Point - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
                          y := ((ActualDrawInverted * jscal * (0 - BaseFrom.Value) + yAdd) * ActualTraceHeightM + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;
                          prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                          prBitmapCanvas.MoveTo(x, y);
                        end else begin
                          x := ((p - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
                          y := ((ActualDrawInverted * jscal * (0 - BaseSeg.ValueAt(p)) + yAdd) * ActualTraceHeightM + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;
                          prBitmapCanvas.MoveTo(x, y);
                        end;
                        while BaseValid and(BaseFrom.Point <= TraceXLast) do begin
                          if BaseTo.Point <= TraceXLast then begin
                            xp := BaseTo.Point;
                            yp := 0 - BaseTo.Value;
                          end else begin
                            xp := TraceXLast;
                            yp := 0 - BaseSeg.ValueAt(xp);
                          end;
                          x := ((xp - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
                          y := ((ActualDrawInverted * jscal * yp + yAdd) * ActualTraceHeightM + 1{New, 0}) div (TraceDy) + ActualTraceVOffset;
                          prBitmapCanvas.LineTo(x, y);
                          if (BaseTo.Point <= TraceXLast) {or (BaseTo.Point = BaseSeg.Last)} then begin
                            prBitmapCanvas.Rectangle(x - 2, y - 2, x + 2, y + 2);
                          end;
                          BaseValid := not BaseSeg.NextRange(BaseFrom, BaseTo);
                        end;

                        p := BaseSeg.Last + 1;
                      end;
                    except
                    end;
                  end;
                  for n := 0 to BaseSegs.Count - 1 do begin
                    TQUB_BaselineSeg(BaseSegs[n]).Free;
                  end;
                  BaseSegs.Free;
                end;

              end;


              if (prDrawIdealized) or (IsDWT) then begin

                if ((prDrawForPrinting) and (prPrintDrawIDLData)) or (not prDrawForPrinting) then begin

                  IdlIter := nil;

                  try

                    if prDrawIdealizedAbove then begin
                      Dec(ActualTraceVOffset, ActualTraceHeightM);
                    end;

                    if (prDrawForPrinting) and (prDrawBW) then begin
                      prBitmapCanvas.Pen.Color   := clBlack;
                      prBitmapCanvas.Brush.Color := clBlack;
                    end else begin
                      prBitmapCanvas.Pen.Color   := ColorIdealized;
                      prBitmapCanvas.Brush.Color := ColorIdealized;
                    end;

                    if (not prDrawBW) and (prDrawIdealizedColor) then begin
                      if prBitmapCanvas.Pen.Width <> 0 then begin
                        prBitmapCanvas.Pen.Width   := prBitmapCanvas.Pen.Width * 2;
                      end else begin
                        prBitmapCanvas.Pen.Width   := 2;
                      end;
                    end;

                    iscal      := Scaling * DataChannelScaling[ChannelIndex];
                    ioff       := - DataChannelOffset[ChannelIndex];

                    IdlFound   := False;
                    IdlIter    := DataObject.Idealization[ChannelIndex].FindIter(TraceXFirst);
                    while 0 <> IdlIter.Valid do begin
                      IdlIter.Read(@F, @L, @C, @A);
                      IdlIter.Next;

                      if C < 0 then begin
                        IdlFound := False;
                        Continue;
                      end;

                      if F > ActualTraceXLast  then Break;
                      if F < ActualTraceXFirst then F := ActualTraceXFirst;
                      if L > ActualTraceXLast  then L := ActualTraceXLast;

                      x := Round(((F - 0.5 - TraceXFirst) * TraceWidth) / (TraceDx) + TraceRect.Left);
                      y := Round((A + ioff) * iscal);
                      y := ((ActualDrawInverted * y + yAdd) * ActualTraceHeightM + 1) div (TraceDy) + ActualTraceVOffset;
                      if IdlFound then begin
                        {
                        if not prDrawForPrinting then begin
                          if prDrawIdealizedColor then begin
                            prBitmapCanvas.Pen.Color := ColorIdealized;
                          end;
                        end;
                        }
                        if (not prDrawForPrinting) and (prDrawIdealizedColor) then begin
                          prBitmapCanvas.MoveTo(x, y);
                        end else begin
                          prBitmapCanvas.LineTo(x, y);
                        end;
                      end else begin
                        prBitmapCanvas.MoveTo(x, y);
                      end;
                      IdlFound := True;
                      x := Round(((L + 0.5 - TraceXFirst) * TraceWidth) / (TraceDx) + TraceRect.Left);
                      if not prDrawForPrinting then begin
                        if prDrawIdealizedColor then begin
                          prBitmapCanvas.Pen.Color := QUB_QFS_QMF_CLASS_COLORS[C mod QUB_QFS_QMF_DEF_NCLASS];
                        end;
                      end;
                      prBitmapCanvas.LineTo(x, y);

                    end;

                    if (not prDrawBW) and (prDrawIdealizedColor) then begin
                      if prDrawForPrinting and (prBitmapCanvas.Pen.Width <> 2) then begin
                        prBitmapCanvas.Pen.Width   := prBitmapCanvas.Pen.Width div 2;
                      end else begin
                        prBitmapCanvas.Pen.Width   := 0;
                      end;
                    end;

                  finally

                    if IdlIter <> nil then IdlIter.Free;

                  end;

                end;

              end;//of Draw Idealized

              //Selection List Labels
              if prDrawSelList
              and (ChannelIndex = ActiveChannel)
              and (not prOverlapChannels)
              and (not prOverlapTraces)
              and (SelectionLists.Items.Count > 0)
              and (SelectionLists.ItemIndex <> -1) then begin

                ListIter := SelectionLists[SelectionLists.ItemIndex].Find(ActualTraceXFirst, ActualTraceXLast, True{ActiveOnly});
                x := -1;
                y := ActualTraceVOffset;

                prBitmapCanvas.Font.Color  := clInfoText; // ColorData[ChannelIndex];
                prBitmapCanvas.Font.Style  := [fsBold];
                prBitmapCanvas.Brush.Color := clInfoBk; // ColorBack;
                prBitmapCanvas.Pen.Color   := clBlack;
                SelRect.Top                := ActualTraceVOffset;

                if not ListIter.Done then repeat
                  SelRect.Left             := ((ListIter.Sel.First - TraceXFirst) * TraceWidth)  div (TraceDx) + TraceRect.Left;
                  if SelRect.Left < x then begin
                    y := ActualTraceVOffset + ((y - ActualTraceVOffset + prBitmapCanvas.TextHeight(ListIter.Lbl) + 2) mod (TraceHeightM - (ActualTraceVOffset - TraceRect.Top)));
                  end else begin
                    y := SelRect.Top;
                  end;
                  prBitmapCanvas.TextOut(SelRect.Left+2, y+2, ListIter.Lbl);
                  x := SelRect.Left + 4 + prBitmapCanvas.TextWidth(ListIter.Lbl);
                until ListIter.Next;

                ListIter.Free;

              end;


            end;//ChannelIndex

          end;//DrawTrace;

          //Cursor *******************************************************************
          DeleteObject(ViewRegion);
          Dec(TraceRegn.Top, QUB_QVO_QVD_TraceVMargin);
          Inc(TraceRegn.Bottom, QUB_QVO_QVD_TraceVMargin);
          ViewRegion := CreateRectRgnIndirect(TraceRegn);
          SelectClipRgn(prBitmapCanvas.Handle, ViewRegion);

          if not prDrawForPrinting then begin
            //Delete old current point marker
            if (prDataOldCurr >= TraceXFirst) and (prDataOldCurr <= TraceXLast) then begin
              x := ((prDataOldCurr - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
              prBitmapCanvas.Brush.Color := ColorBack;
              prBitmapCanvas.Pen.Color   := ColorBack;
              prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Top),        Point(x + 3, TraceRect.Top),        Point(x, TraceRect.Top        + (QUB_QVO_QVD_TraceVMargin - 1))]);
              prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Bottom - 1), Point(x + 3, TraceRect.Bottom - 1), Point(x, TraceRect.Bottom - 1 - (QUB_QVO_QVD_TraceVMargin - 1))]);
            end;

            if not ((prTraceChangeOnBreak) and (prDataSegmentCount > 1)) then begin
            //Mark segment end
              s0 := BreakPoint;
              if BreakPoint > 0 then Dec(s0);
              for s := s0 to prDataSegmentCount - 1 do begin
                if prDataBreakPoints[s] > ActualTraceXLast then Break;
                x := ((prDataBreakPoints[s] - 1 - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
                prBitmapCanvas.Brush.Color := ColorBreak;
                prBitmapCanvas.Pen.Color   := ColorBreak;
                prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Top),        Point(x + 3, TraceRect.Top),        Point(x, TraceRect.Top        + (QUB_QVO_QVD_TraceVMargin - 1))]);
                prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Bottom - 1), Point(x + 3, TraceRect.Bottom - 1), Point(x, TraceRect.Bottom - 1 - (QUB_QVO_QVD_TraceVMargin - 1))]);
              end;
            end;

            //Draw current point marker
            if (prDataCurr >= TraceXFirst) and (prDataCurr <= TraceXLast) then begin
              x := ((prDataCurr - TraceXFirst) * TraceWidth) div (TraceDx) + TraceRect.Left;
              prBitmapCanvas.Brush.Color := ColorCurr;
              prBitmapCanvas.Pen.Color   := ColorCurr;
              prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Top),        Point(x + 3, TraceRect.Top),        Point(x, TraceRect.Top        + (QUB_QVO_QVD_TraceVMargin - 1))]);
              prBitmapCanvas.Polygon([Point(x - 3, TraceRect.Bottom - 1), Point(x + 3, TraceRect.Bottom - 1), Point(x, TraceRect.Bottom - 1 - (QUB_QVO_QVD_TraceVMargin - 1))]);
            end;

          end;
          //**************************************************************************

          DeleteObject(ViewRegion);

          CurrX := TraceXLast + 1;
          BreakPoint := BreakPointChannel;

          if CurrX = prDataBreakPoints[BreakPoint] then begin
            Inc(BreakPoint);
          end;

          if CurrX > prDataDraw.Last then Break;

        end;//TraceIndex

      end;//DrawListOverlapped

      SelectClipRgn(prBitmapCanvas.Handle, 0);

    except

      //Beep;

    end;

  finally

    prDrawing := False;

  end;
end;


//****************************************************************************//
//                                                                            //
//                 This method is used to draw the Selection                  //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVD.prDrawDataSel;
begin

  if prDataPointCount = 0 then Exit;

  //Find the Selection point, stored in prMouseSel

  if prMouseDowning then begin
  //The Mouse just hit the cheese

    if KeyShift then begin
    //If Shift then extend selection ... simulate selection mode

      prDrawDataSelRunning;

    end else if KeyControl then begin
    //If Control then move selection

      prDrawDataSelMoving;

    end else begin

      prDrawDataSelDowning;

    end;

  end else if prMouseRunning then begin
  //The Mouse is running scared

    prDrawDataSelRunning;

  end else if prKeyeing then begin
  //A key was hit

    prDrawDataSelKeyeing;

  end;

end;

//Draws data when the mouse is Left-Clicked
//if there was a selection, it is unselected
//the cursor is position where the mouse hit
procedure TQUB_QVO_QVD.prDrawDataSelDowning;
var
  MoveCode   :TQUB_QVO_QVD_Command;
  f, i, n    :Integer;
begin

  f := prMouseToPoint(prMouseSel, MoveCode);
  prDataCurr            := f;

  prWindowDrawMode      := True;
  if (prDataCurr >= prDataSel.First) and (prDataCurr <= prDataSel.Last) then begin
    n := 1;
  end else begin
    n := 2;
  end;
  try
    for i := 1 to n do begin
      //Draw the window only if within Display range !!!  Check this !?!?!?!
      prDataWindow.First := prDataSel.First;
      prDataWindow.Last  := prDataSel.Last;
      prDataSel.First    := f;
      prDataSel.Last     := f;
      Draw;
    end;
  finally
    prWindowDrawMode    := False;
    prSelMove.First     := f;
    prSelMove.Last      := f;
  end;

  DataCurr            := prDataCurr;
end;

//Draws the data when the mouse is selecting
procedure TQUB_QVO_QVD.prDrawDataSelRunning;
var
  MoveCode1 :TQUB_QVO_QVD_Command;
  MoveCode2 :TQUB_QVO_QVD_Command;
  p, s      :Integer;
begin

  if prSelMoving then prSelMoveOffset := prDataCurr;

  p := prDataDraw.First;
  s := prDataSel.Last - prDataSel.First + 1;
  prDataCurr := prMouseToPoint(prMouseSel, MoveCode1);

  if MoveCode1 <> QUB_QVO_QVD_CMD_GOTO_POINT then begin
  //if the mouse gives a browse command (page/trace up/dn etc), then Browse

    Browse(MoveCode1, p, p, False{Display}, True{SetScroll}, True{Process}, False, False{Append}, True{SetZoom});
    prDataCurr := prMouseToPoint(prMouseSel, MoveCode2{not used});

  end;

  if MoveCode1 = QUB_QVO_QVD_CMD_GOTO_POINT then begin
  //if there was no Browse command, then just adjust the selection

    if prSelMoving then begin

      prDataWindow := DataSel;
      Inc(prDataSel.First, prDataCurr - prSelMoveOffset);
      Inc(prDataSel.Last,  prDataCurr - prSelMoveOffset);
      if prDataSel.First < prDataPoint.First  then begin
        prDataSel.First := prDataPoint.First;
        prDataSel.Last  := prDataSel.First + s - 1;
      end;
      if prDataSel.Last  > prDataPoint.Last   then begin
        prDataSel.Last  := prDataPoint.Last;
        prDataSel.First := prDataSel.Last - s + 1;
      end;
      if prDataSel.First < prDataPoint.First  then prDataSel.First := prDataPoint.First;
      if prDataSel.Last  > prDataPoint.Last   then prDataSel.Last  := prDataPoint.Last;
      if prDataWindow.First > prDataSel.First then prDataWindow.First := prDataSel.First;
      if prDataWindow.Last  < prDataSel.Last  then prDataWindow.Last  := prDataSel.Last;
      prSelMoveOffset := prDataCurr;

    end else begin

      prDataWindow.First := prSelMove.Last;
      prDataWindow.Last  := prDataCurr;
      if prDataWindow.First > prDataWindow.Last then begin
        prDataWindow.First := prDataCurr;
        prDataWindow.Last  := prSelMove.Last;
      end;

    end;
    prWindowDrawMode := True;

  end else begin

    if prSelMoving then begin

      Inc(prDataSel.First, prDataCurr - prSelMoveOffset);
      Inc(prDataSel.Last,  prDataCurr - prSelMoveOffset);
      if prDataSel.First < prDataPoint.First  then begin
        prDataSel.First := prDataPoint.First;
        prDataSel.Last  := prDataSel.First + s - 1;
      end;
      if prDataSel.Last  > prDataPoint.Last   then begin
        prDataSel.Last  := prDataPoint.Last;
        prDataSel.First := prDataSel.Last - s + 1;
      end;
      if prDataSel.First < prDataPoint.First  then prDataSel.First := prDataPoint.First;
      if prDataSel.Last  > prDataPoint.Last   then prDataSel.Last  := prDataPoint.Last;
      prSelMoveOffset := prDataCurr;

    end;

  end;

  prSelMove.Last := prDataCurr;

  if not prSelMoving then begin
    prDataSel.First := prSelMove.First;
    prDataSel.Last  := prSelMove.Last;
    if prDataSel.First > prDataSel.Last then begin
      prDataSel.First := prSelMove.Last;
      prDataSel.Last  := prSelMove.First;
    end;
  end;

  try
    Draw;
  finally
    prWindowDrawMode := False;
  end;

  DataCurr            := prDataCurr;
end;

//Moves the Selection
procedure TQUB_QVO_QVD.prDrawDataSelMoving;
var
  MoveCode1 :TQUB_QVO_QVD_Command;
begin

  prDataCurr := prMouseToPoint(prMouseSel, MoveCode1);

  if MoveCode1 <> QUB_QVO_QVD_CMD_GOTO_POINT then Exit;

  prSelMoving     := True;

  prDataWindow.First := prSelMove.Last;
  prDataWindow.Last  := prDataCurr;
  if prDataWindow.First > prDataWindow.Last then begin
    prDataWindow.First := prDataCurr;
    prDataWindow.Last  := prSelMove.Last;
  end;
  prWindowDrawMode := True;
  prSelMove.Last := prDataCurr;

  try
    Draw;
  finally
    prWindowDrawMode := False;
  end;

  DataCurr            := prDataCurr;
end;

procedure TQUB_QVO_QVD.prDrawDataSelKeyeing;
var
  Motion  :Integer;
  Trace   :Integer;
  LTrace  :Integer;
  First   :Integer;
  Prev    :Integer;
  dp      :Integer;
begin

  Motion := QUB_QVO_QVD_MOVE_NO;

  case prKeyCode of

    VK_LEFT:
      begin
        if (KeyControl) and ((prPointsPerTrace div 100) <> 0) then begin
          Dec(prDataCurr, prPointsPerTrace div 100);
        end else begin
          Dec(prDataCurr);
        end;
        Motion := QUB_QVO_QVD_MOVE_UP;
      end;
    VK_RIGHT:
      begin
        if (KeyControl) and ((prPointsPerTrace div 100) <> 0) then begin
          Inc(prDataCurr, prPointsPerTrace div 100);
        end else begin
          Inc(prDataCurr);
        end;
        Motion := QUB_QVO_QVD_MOVE_DN;
      end;
    VK_UP:
      begin
        //Dec(prDataCurr, prPointsPerTrace);
        Trace := WhichTraceForPoint(prDataCurr);
        if Trace = 0 then begin
          prDataCurr := prDataPoint.First;
        end else begin
          First := WhichPointForTrace(Trace);
          dp := prDataCurr - First;
          Prev := WhichPointForTrace(Trace - 1);
          prDataCurr := Prev + dp;
          if prDataCurr > First then prDataCurr := First - 1;
        end;
        Motion := QUB_QVO_QVD_MOVE_UP;
      end;
    VK_DOWN:
      begin
        //Inc(prDataCurr, prPointsPerTrace);
        Trace := WhichTraceForPoint(prDataCurr);
        LTrace := WhichTraceForPoint(prDataPoint.Last);
        if Trace = LTrace then begin
          prDataCurr := prDataPoint.Last;
        end else begin
          First := WhichPointForTrace(Trace);
          dp := prDataCurr - First;
          Prev := WhichPointForTrace(Trace + 1);
          prDataCurr := Prev + dp;
          if prDataCurr < First then prDataCurr := First + 1;
        end;
        Motion := QUB_QVO_QVD_MOVE_DN;
      end;
    VK_PRIOR:
      begin
        Dec(prDataCurr, prPointsPerTrace * prTracesPerPage);
        Motion := QUB_QVO_QVD_MOVE_UP;
      end;
    VK_NEXT:
      begin
        Inc(prDataCurr, prPointsPerTrace * prTracesPerPage);
        Motion := QUB_QVO_QVD_MOVE_DN;
      end;
    VK_HOME:
      begin
        if KeyControl then begin
          prDataCurr := prDataPoint.First;
        end else begin
          prDataCurr := WhichSegmentFirstForPoint(prDataCurr);
        end;
        Motion := QUB_QVO_QVD_MOVE_UP;
      end;
    VK_END:
      begin
        if KeyControl then begin
          prDataCurr := prDataPoint.Last;
        end else begin
          prDataCurr := WhichSegmentLastForPoint(prDataCurr);
        end;
        Motion := QUB_QVO_QVD_MOVE_DN;
      end;

  end;//case

  if prDataCurr < prDataPoint.First then prDataCurr := prDataPoint.First;
  if prDataCurr > prDataPoint.Last  then prDataCurr := prDataPoint.Last;


  {*****************************************************************************

  Set the coordinates for window drawing or browsing

  *****************************************************************************}

  //if DataCurr went out of display, we have to Browse
  if (prDataCurr < prDataDraw.First) or (prDataCurr > prDataDraw.Last) then begin

    Trace := 0;

    //if it went up, then prDataCurr must be on the first trace
    if Motion = QUB_QVO_QVD_MOVE_UP then begin

      Trace := WhichTraceForPoint(prDataCurr);

    //else on the last
    end else if Motion = QUB_QVO_QVD_MOVE_DN then begin

      Trace := WhichTraceForPoint(prDataCurr);
      Dec(Trace, prTracesPerPage - 1);
      if Trace < 0 then Trace := 0;

    end;

    //Browse quietly there
    Browse(QUB_QVO_QVD_CMD_GOTO_TRACE, Trace, Trace, False{No Display}, True{SetScroll}, True{Process}, False, False{Append}, True{SetZoom});

  //if DataCurr is still within the display, draw window
  end else begin

    //If extending selection
    if KeyShift then begin

      prDataWindow.First := prSelMove.Last;
      prDataWindow.Last  := prDataCurr;
      if prDataWindow.First > prDataWindow.Last then begin
        prDataWindow.First := prDataCurr;
        prDataWindow.Last  := prSelMove.Last;
      end;

    //if clearing selection
    end else begin

      prDataWindow.First := prDataSel.First;
      prDataWindow.Last  := prDataSel.Last;
      if prDataCurr > prDataWindow.Last then begin
        prDataWindow.Last := prDataCurr;
      end;
      if prDataCurr < prDataWindow.First then begin
        prDataWindow.First := prDataCurr;
      end;

    end;

    prWindowDrawMode := True;

  end;

  prSelMove.Last := prDataCurr;


  {*****************************************************************************

  Set the coordinates for selection

  *****************************************************************************}

  //No shift, erase selection
  if not KeyShift then begin

    prDataSel.First := prDataCurr;
    prDataSel.Last  := prDataCurr;
    prSelMove.First := prDataCurr;

  //shift, extend selection
  end else begin

    prDataSel.First := prSelMove.First;
    prDataSel.Last  := prSelMove.Last;
    if prDataSel.First > prDataSel.Last then begin
      prDataSel.First := prSelMove.Last;
      prDataSel.Last  := prSelMove.First;
    end;

  end;

  try
    Draw;
  finally
    prWindowDrawMode    := False;
  end;

  DataCurr            := prDataCurr;
end;

function TQUB_QVO_QVD.prGetFileName :String;
begin
  Result := prDataObject.FileName;
end;

function TQUB_QVO_QVD.prGetFileExt :String;
begin
  Result := prDataObject.FileExt;
end;

function TQUB_QVO_QVD.prGetModified :Boolean;
begin
  Result := prDataObject.Modified;
end;

function TQUB_QVO_QVD.prGetSaved :Boolean;
begin
  Result := prDataObject.Saved;
end;

//Lock
procedure TQUB_QVO_QVD.LockWrite;
begin
  inherited;
  prDataObject.LockWrite;
end;

procedure TQUB_QVO_QVD.UnLockWrite;
begin
  inherited;
  prDataObject.UnLockWrite;
end;

procedure TQUB_QVO_QVD.LockReadWrite;
begin
  inherited;
  prDataObject.LockReadWrite;
end;

procedure TQUB_QVO_QVD.UnLockReadWrite;
begin
  inherited;
  prDataObject.UnLockReadWrite;
end;

procedure TQUB_QVO_QVD.LockRecord;
begin
  Inc(prLockedRecordCount);
  prDataObject.LockRecord;
  if Assigned(prOnChangeLockRecord) then begin
    prOnChangeLockRecord(Self);
  end;
end;

procedure TQUB_QVO_QVD.UnLockRecord;
begin
  Dec(prLockedRecordCount);
  if prLockedRecordCount < 0 then prLockedRecordCount := 0;
  prDataObject.UnLockRecord;
  if Assigned(prOnChangeLockRecord) then begin
    prOnChangeLockRecord(Self);
  end;
end;

procedure TQUB_QVO_QVD.LockPlayback;
begin
  Inc(prLockedPlaybackCount);
  prDataObject.LockPlayback;
  if Assigned(prOnChangeLockPlayback) then begin
    prOnChangeLockPlayback(Self);
  end;
end;

procedure TQUB_QVO_QVD.UnLockPlayback;
begin
  Dec(prLockedPlaybackCount);
  if prLockedPlaybackCount < 0 then prLockedPlaybackCount := 0;
  prDataObject.UnLockPlayback;
  if Assigned(prOnChangeLockPlayback) then begin
    prOnChangeLockPlayback(Self);
  end;
end;

function TQUB_QVO_QVD.prGetLockedRecord :Boolean;
begin
  Result := prLockedRecordCount > 0;
end;

function TQUB_QVO_QVD.prGetLockedPlayback :Boolean;
begin
  Result := prLockedPlaybackCount > 0;
end;


//****************************************************************************//
//                                                                            //
//                           D A T A    B R O W S E                           //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVD.Browse(Command :TQUB_QVO_QVD_Command; var Position, Max :Integer; Display, SetScroll, Process, ForceCache, Appending, SetZoom :Boolean);
var
  NewDraw         :TQUB_FirstLast;
  NewSel          :TQUB_FirstLast;
  NewCache        :TQUB_FirstLast;
  NeedUpdateStim  :Boolean;
  CacheReAllocd   :Boolean;
  Action          :Integer;
  s, p, f         :Integer;
begin

  if prExpanding then prCanUnExpand := True else prCanUnExpand := False;
  prExpanding     := False;

  if prBrowsing then Exit;

  prBrowsing      := True;

  NeedUpdateStim  := False;

  try

    NewDraw       := prDataDraw;
    Action        := QUB_QVO_QVD_MOVE_NO;

    try

      if prTracesPerPage = 1 then begin
        case Command of
          QUB_QVO_QVD_CMD_TRACE_UP, QUB_QVO_QVD_CMD_HALF_PAGE_UP:
            Command := QUB_QVO_QVD_CMD_PAGE_UP;
          QUB_QVO_QVD_CMD_TRACE_DN, QUB_QVO_QVD_CMD_HALF_PAGE_DN:
            Command := QUB_QVO_QVD_CMD_PAGE_DN;
        end;
      end;

      case Command of

        QUB_QVO_QVD_CMD_HOME:

          begin

            NewDraw.First := 0;
            NewDraw.Last  := WhichPointForFirst(NewDraw.First);
            Action        := QUB_QVO_QVD_MOVE_UP;

          end;//HOME

        QUB_QVO_QVD_CMD_END:

          begin

            NewDraw.Last  := prDataPoint.Last;
            NewDraw.First := WhichPointForLast(prDataPoint.Last);
            Action        := QUB_QVO_QVD_MOVE_DN;

          end;//END

        QUB_QVO_QVD_CMD_SEG_HOME:

          begin

            NewDraw.First := WhichSegmentFirstForPoint(prDataCurr);
            NewDraw.First := WhichPointForTrace(WhichTraceForPoint(NewDraw.First));
            NewDraw.Last  := WhichPointForFirst(NewDraw.First);
            Action        := QUB_QVO_QVD_MOVE_UP;

          end;//SEG_HOME

        QUB_QVO_QVD_CMD_SEG_END:

          begin

            NewDraw.First := WhichSegmentLastForPoint(prDataCurr);
            NewDraw.First := WhichTraceForPoint(NewDraw.First) - prTracesPerPage + 1;
            if NewDraw.First < 0 then NewDraw.First := 0;
            NewDraw.First := WhichPointForTrace(NewDraw.First);
            NewDraw.Last  := WhichPointForFirst(NewDraw.First);
            Action        := QUB_QVO_QVD_MOVE_DN;

          end;//SEG_END

        QUB_QVO_QVD_CMD_PAGE_UP:

          begin

            if NewDraw.First > 0 then begin

              NewDraw.First := WhichTraceForPoint(NewDraw.First) - prTracesPerPage;
              if NewDraw.First < 0 then NewDraw.First := 0;
              NewDraw.First := WhichPointForTrace(NewDraw.First);
              NewDraw.Last  := WhichPointForFirst(NewDraw.First);
              Action        := QUB_QVO_QVD_MOVE_UP;

            end;

          end;//PG_UP

        QUB_QVO_QVD_CMD_PAGE_DN:

          begin

            if NewDraw.Last < prDataPoint.Last then begin

              s := WhichTraceForPoint(prDataPoint.Last);
              NewDraw.First := WhichTraceForPoint(NewDraw.First) + prTracesPerPage;
              if NewDraw.First > s then NewDraw.First := s;
              NewDraw.First := WhichPointForTrace(NewDraw.First);
              NewDraw.Last  := WhichPointForFirst(NewDraw.First);
              Action        := QUB_QVO_QVD_MOVE_DN;

            end;

          end;//PG_DN

        QUB_QVO_QVD_CMD_HALF_PAGE_UP:

          begin

            if NewDraw.First > 0 then begin

              NewDraw.First := WhichTraceForPoint(NewDraw.First) - (prTracesPerPage div 2);
              if NewDraw.First < 0 then NewDraw.First := 0;
              NewDraw.First := WhichPointForTrace(NewDraw.First);
              NewDraw.Last  := WhichPointForFirst(NewDraw.First);
              Action        := QUB_QVO_QVD_MOVE_UP;

            end;

          end;//HALF_PG_UP

        QUB_QVO_QVD_CMD_HALF_PAGE_DN:

          begin

            if NewDraw.Last < prDataPoint.Last then begin

              s := WhichTraceForPoint(prDataPoint.Last);
              NewDraw.First := WhichTraceForPoint(NewDraw.First) + (prTracesPerPage div 2);
              if NewDraw.First > s then NewDraw.First := s;
              NewDraw.First := WhichPointForTrace(NewDraw.First);
              NewDraw.Last  := WhichPointForFirst(NewDraw.First);
              Action        := QUB_QVO_QVD_MOVE_DN;

            end;

          end;//HALF_PG_DN

        QUB_QVO_QVD_CMD_TRACE_UP:

          begin

            if NewDraw.First > 0 then begin

              NewDraw.First := WhichTraceForPoint(NewDraw.First) - 1;
              if NewDraw.First < 0 then NewDraw.First := 0;
              NewDraw.First := WhichPointForTrace(NewDraw.First);
              NewDraw.Last  := WhichPointForFirst(NewDraw.First);
              Action        := QUB_QVO_QVD_MOVE_UP;

            end;

          end;//TRACE_UP

        QUB_QVO_QVD_CMD_TRACE_DN:

          begin

            if NewDraw.Last < prDataPoint.Last then begin

              s := WhichTraceForPoint(prDataPoint.Last);
              NewDraw.First := WhichTraceForPoint(NewDraw.First) + 1;
              if NewDraw.First > s then NewDraw.First := s;
              NewDraw.First := WhichPointForTrace(NewDraw.First);
              NewDraw.Last  := WhichPointForFirst(NewDraw.First);
              Action        := QUB_QVO_QVD_MOVE_DN;

            end;

          end;//TRACE_DN

        QUB_QVO_QVD_CMD_SEL_UP:

          begin

            NewSel := DataSel;
            if NewSel.First > DataPoint.First then begin

              s := NewSel.Last - NewSel.First + 1;
              Dec(NewSel.First, s);
              if NewSel.First < DataPoint.First then NewSel.First := DataPoint.First;
              NewSel.Last := NewSel.First + s - 1;
              if NewSel.Last  > DataPoint.Last  then NewSel.Last  := DataPoint.Last;

              if NewDraw.First > NewSel.First then begin
              //Needs UP
                NewDraw.First := WhichTraceForPoint(NewSel.First);
                if NewDraw.First < 0 then NewDraw.First := 0;
                NewDraw.First := WhichPointForTrace(NewDraw.First);
                NewDraw.Last  := WhichPointForFirst(NewDraw.First);
                Action        := QUB_QVO_QVD_MOVE_UP;
              end;
              prDataSel := NewSel;
            end;

          end;//SEL_UP

        QUB_QVO_QVD_CMD_SEL_DN:

          begin

            NewSel := DataSel;
            if NewSel.Last < DataPoint.Last then begin

              s := NewSel.Last - NewSel.First + 1;
              Inc(NewSel.Last, s);
              if NewSel.Last > DataPoint.Last then NewSel.Last := DataPoint.Last;
              NewSel.First := NewSel.Last - s + 1;
              if NewSel.First  < DataPoint.First  then NewSel.First  := DataPoint.First;

              if NewDraw.Last < NewSel.Last then begin
              //Nees DN
                s := WhichTraceForPoint(prDataPoint.Last);
                NewDraw.First := WhichTraceForPoint(NewSel.First);
                if NewDraw.First > s then NewDraw.First := s;
                NewDraw.First := WhichPointForTrace(NewDraw.First);
                NewDraw.Last  := WhichPointForFirst(NewDraw.First);
                Action        := QUB_QVO_QVD_MOVE_DN;
              end;
              prDataSel := NewSel;
            end;

          end;//SEL_DN

        QUB_QVO_QVD_CMD_SEL_UPSEG:

          begin

            NewSel := DataSel;

            s := WhichSegmentForPoint(NewSel.First);
            if s > 0 then begin

              p := NewSel.First - WhichSegmentFirstForPoint(NewSel.First);
              p := WhichSegmentFirstForSegment(s - 1) + p;
              NewSel.Last  := p + (NewSel.Last - NewSel.First + 1) - 1;
              NewSel.First := p;

              if NewDraw.First > NewSel.First then begin
              //Needs UP
                NewDraw.First := WhichTraceForPoint(NewSel.First);
                if NewDraw.First < 0 then NewDraw.First := 0;
                NewDraw.First := WhichPointForTrace(NewDraw.First);
                NewDraw.Last  := WhichPointForFirst(NewDraw.First);
                Action        := QUB_QVO_QVD_MOVE_UP;
              end;
              prDataSel := NewSel;
            end;

          end;//SEL_UPSEG

        QUB_QVO_QVD_CMD_SEL_DNSEG:

          begin

            NewSel := DataSel;

            s := WhichSegmentForPoint(NewSel.First);
            if s < (prDataSegmentCount - 1) then begin

              p := NewSel.First - WhichSegmentFirstForPoint(NewSel.First);
              p := WhichSegmentFirstForSegment(s + 1) + p;
              NewSel.Last  := p + (NewSel.Last - NewSel.First + 1) - 1;
              NewSel.First := p;

              if NewDraw.Last < NewSel.Last then begin
              //Nees DN
                s := WhichTraceForPoint(prDataPoint.Last);
                NewDraw.First := WhichTraceForPoint(NewSel.First);
                if NewDraw.First > s then NewDraw.First := s;
                NewDraw.First := WhichPointForTrace(NewDraw.First);
                NewDraw.Last  := WhichPointForFirst(NewDraw.First);
                Action        := QUB_QVO_QVD_MOVE_DN;
              end;
              prDataSel := NewSel;
            end;


          end;//SEL_DNSEG

        QUB_QVO_QVD_CMD_GOTO_SEG:

          begin

            NewDraw.First := WhichSegmentFirstForSegment(Position);
            NewDraw.First := WhichPointForTrace(WhichTraceForPoint(NewDraw.First));
            NewDraw.Last  := WhichPointForFirst(NewDraw.First);

          end;//GOTO_SEG

        QUB_QVO_QVD_CMD_GOTO_TRACE:

          begin

            NewDraw.First := WhichPointForTrace(Position);
            NewDraw.Last  := WhichPointForFirst(NewDraw.First);

          end;//GO_TO_TRACE

        QUB_QVO_QVD_CMD_GOTO_POINT:

          begin

            NewDraw.First := WhichPointForTrace(WhichTraceForPoint(Position));
            NewDraw.Last  := WhichPointForFirst(NewDraw.First);
            NeedUpdateStim := True;

          end;//GOTO_POINT

        QUB_QVO_QVD_CMD_GOTO_PAGE:

          begin

            NewDraw.First := WhichPointForPage(Position);
            NewDraw.Last  := WhichPointForFirst(NewDraw.First);

          end;//GOTO_POINT

        QUB_QVO_QVD_CMD_CHANGE_SEL:

          begin
          end;//GOTO_POINT

      end;

      if NewDraw.First < DataPoint.First then begin
        NewDraw.First := DataPoint.First;
        NewDraw.Last  := WhichPointForFirst(NewDraw.First);
      end;
      if NewDraw.First > DataPoint.Last then begin
        NewDraw.Last  := DataPoint.Last;
        NewDraw.First := WhichPointForLast(NewDraw.Last);
      end;
      if NewDraw.Last > DataPoint.Last then begin
        NewDraw.Last  := DataPoint.Last;
      end;

      if NewDraw.First < DataPoint.First then begin
        NewDraw.First := DataPoint.First;
        NewDraw.Last  := NewDraw.First;
      end;
      
      if Action = QUB_QVO_QVD_MOVE_NO then begin
        if NewDraw.First > prDataDraw.First then begin
          Action := QUB_QVO_QVD_MOVE_DN;
        end else if NewDraw.First < prDataDraw.First then begin
          Action := QUB_QVO_QVD_MOVE_UP;
        end else begin
          Action := prPrevAction;
        end;
      end else begin
        prPrevAction := Action;
      end;

      //If the new draw window does not fit in the existing cache then adjust the cache
      NewCache := prDataCache;

      //Prevents allocating big cache with no data. LM.
      if (prDataPoint.Last - prDataPoint.First + 1) = 0 then begin
      //No data
        NewCache := QUB_FirstLast(0, 0);
      end;

      //If the new draw window does not fit in the existing cache then adjust the cache
      if (NewDraw.First < prDataCache.First) or (NewDraw.Last > prDataCache.Last) then begin

        if Appending then begin
          NewCache.First := prDataCache.First;
          NewCache.Last  := NewDraw.Last;
          //First try to encompass the old Draw.First + CacheSize
          if (NewCache.Last - NewCache.First + 1) > prCacheSize then begin
            NewCache.First := prDataDraw.First;
            NewCache.Last  := NewCache.First + prCacheSize - 1;
            if NewCache.Last > prDataPoint.Last then begin
              NewCache.Last  := prDataPoint.Last;
            end;
          end;
          //Now make sure NewDraw is in view
          if (NewDraw.First < NewCache.First) or (NewDraw.Last > NewCache.Last) then begin
            NewCache.First := NewDraw.First;
            NewCache.Last  := NewCache.First + prCacheSize - 1;
            if NewCache.Last > prDataPoint.Last then begin
              NewCache.Last  := prDataPoint.Last;
            end;
          end;
        end else begin
          case Action of
            QUB_QVO_QVD_MOVE_UP:
              begin
                NewCache.Last  := NewDraw.Last;
                NewCache.First := NewCache.Last  - prCacheSize + 1;
              end;
            QUB_QVO_QVD_MOVE_DN, QUB_QVO_QVD_MOVE_NO:
              begin
                NewCache.First := NewDraw.First;
                NewCache.Last  := NewCache.First + prCacheSize - 1;
              end;
          end;//case Action
        end;
        prPrevAction := Action;
        if NewCache.First < prDataPoint.First then begin
          NewCache.First := prDataPoint.First;
          NewCache.Last  := NewCache.First + prCacheSize - 1;
          if NewCache.Last > prDataPoint.Last then begin
            NewCache.Last := prDataPoint.Last;
          end;
        end;
        if NewCache.Last > prDataPoint.Last then begin
          NewCache.Last  := prDataPoint.Last;
          NewCache.First := NewCache.Last  - prCacheSize + 1;
          if NewCache.First < prDataPoint.First then begin
            NewCache.First := prDataPoint.First;
          end;
        end;
      end;

      //The following is recovery from Can't allocate cache.
      //May happen with 100 AD channels (yes, I needed and tried it!) LM.
      if prAllocCache(NewCache, Appending{FullSize}, CacheReAllocd) then begin
      //could not allocate NewCache, try again smaller
        if prAllocCache(NewCache, False{FullSize}, CacheReAllocd) then begin
        //Still cant allocate - doom! LM.
          CacheReAllocd := True;
          NewCache.Last := NewCache.First - 1;//no cache
        end;
      end;

      //If new Cache <> old Cache, then read in the new cache
      if (NewCache.First <> prDataCache.First) or
         (NewCache.Last <> prDataCache.Last)   or
         (ForceCache)                          or
         (CacheReAllocd)                       then begin
        //prDataCache := NewCache;
        //prReadCache;
        prReadCache(NewCache, (Appending) and
                              (NewCache.First    = prDataCache.First) and
                              (prDataCache.Last <> prDataCache.First) and
                              (not CacheReAllocd));
      end;

      //ProcessDataForDisplay ******************************************************
      if (prDataDraw.First <> NewDraw.First) or
         (prDataDraw.Last  <> NewDraw.Last)  or
         (Display){Force Drawing}            or
         (CacheReAllocd)                     or
         (Process)                           then begin

        try
          if (Appending)                            and
             (NewDraw.First     = prDataDraw.First) and
             (NewDraw.Last     >= prDataDraw.Last)  then begin
            prProcessDataForDisplay(NewDraw, QUB_FirstLast(prDataDraw.Last + 1, NewDraw.Last));
          end else begin
            prProcessDataForDisplay(NewDraw, NewDraw);
          end;
        except
          //for testing
          //Beep;
        end;

      end;

      //****************************************************************************

      try
        prGetYAvgMinMax(NewDraw);
      except
        //for testing
        //Beep;
      end;

      //If new Draw <> old Draw, then draw the new Draw
      if (prDataDraw.First <> NewDraw.First) or (prDataDraw.Last <> NewDraw.Last) or (Display){Force Drawing} then begin
        prDataDraw := NewDraw;
        if Display then begin
          Draw;
        end;
        if NeedUpdateStim then prUpdateStimValues(DataCurr);
      end;

      //Adjust Zoom selection
      if SetZoom then prSetZoomData(True{ZoomDraw});

      if SetScroll then begin
        prDoOnChangePage;
      end else begin
        Position := WhichTraceForPoint(prDataDraw.First);
        Max      := WhichTraceForPoint(WhichPointForLast(prDataPoint.Last));
        if Max < Position then Max := Position;
      end;

    except

      //Beep;

    end

  finally

    prBrowsing := False;

  end;

end;

//******************************************************************************
procedure TQUB_QVO_QVD.prInitDisplayProperties;
var
  Cat        :TQUB_ProfileCat;

  procedure Init(const Name :String; Def :Variant; Count :Integer = 1; LookInChan :Boolean = False);
  var
    Node, ActiveNode :INode;
    ActualCount      :Integer;
    i                :Integer;
    Chan             :INode;
  begin
    Node             := DisplayProperties[Name];
    ActualCount      := LongInt(Node.DataCount);
    if ActualCount = 0 then Node.SetData(Def); // establish data type (before u can resize)
    Node.ResizeData(Count);

    if ActualCount < Count then begin
      ActiveNode     := Cat.Active.Find(Name);
      for i := ActualCount to Min(Count, LongInt(ActiveNode.DataCount)) - 1 do begin
        Node.Data[i] := ActiveNode.Data[i];
      end;
      ActualCount    := Min(Count, LongInt(ActiveNode.DataCount));
    end;
    if (ActualCount < Count) and LookInChan then begin
      Chan           := DisplayProperties.Find('Channels').Find('Channel');
      i              := 0;
      while (not Chan.IsNull) and (i < ActualCount) do begin
        Chan         := Chan.SiblingSameName;
        Inc(i);
      end;
      while (not Chan.IsNull) and (i < Count) do begin
        ActiveNode   := Chan.Find(Name);
        if ActiveNode.DataCount = 0 then Break;
        Node.Data[i] := ActiveNode.Data[0];
        Chan         := Chan.SiblingSameName;
        Inc(i);
      end;
      ActualCount    := Max(ActualCount, i);
    end;
    for i := ActualCount to Count - 1 do begin
      Node.Data[i]   := Def;
    end;
  end;
begin
  Cat        := ProfileMgr['QVD'];

  try
    Init('Color Back',           Integer(QUB_QVO_QVD_DEF_COLORBACK));
    Init('Color Sel',            Integer(QUB_QVO_QVD_DEF_COLORSEL));
    Init('Color Curr',           Integer(QUB_QVO_QVD_DEF_COLORCURR));
    Init('Color Break',          Integer(QUB_QVO_QVD_DEF_COLORBREAK));
    Init('Color Baseline',       Integer(QUB_QVO_QVD_DEF_COLORBASELINE));
    Init('Color BaselineNodes',  Integer(QUB_QVO_QVD_DEF_COLORBASELINENODES));
    Init('Color Idealized',      Integer(QUB_QVO_QVD_DEF_COLORIDEALIZED));
    Init('Color IdealizedSel',   Integer(QUB_QVO_QVD_DEF_COLORIDEALIZEDSEL));
    Init('Color Frame',          Integer(QUB_QVO_QVD_DEF_COLORFRAME));
    Init('Color',                Integer(QUB_QVO_QVD_DEF_COLOR));
    Init('Color SelList',        Integer(QUB_QVO_QVD_DEF_COLORSELLIST));
    Init('Color Parameters',     Integer(QUB_QVO_QVD_DEF_COLORPARAMETERS));
    Init('Color SegLabel',       Integer(QUB_QVO_QVD_DEF_COLORSEGLABEL));
    Init('Color Data 0',         Integer(QUB_QVO_QVD_DEF_COLORDATA[0]));
    Init('Color Data 1',         Integer(QUB_QVO_QVD_DEF_COLORDATA[1]));
    Init('Color Data 2',         Integer(QUB_QVO_QVD_DEF_COLORDATA[2]));
    Init('Color Data 3',         Integer(QUB_QVO_QVD_DEF_COLORDATA[3]));
    Init('Color Data 4',         Integer(QUB_QVO_QVD_DEF_COLORDATA[4]));
    Init('Color Data 5',         Integer(QUB_QVO_QVD_DEF_COLORDATA[5]));
    Init('Color Data 6',         Integer(QUB_QVO_QVD_DEF_COLORDATA[6]));
    Init('Color Data 7',         Integer(QUB_QVO_QVD_DEF_COLORDATA[7]));
    Init('TracesPerPage',        QUB_QVO_QVD_DEF_TRACESPERPAGE);
    Init('PointsPerTrace',       QUB_QVO_QVD_DEF_POINTSPERTRACE);
    Init('CacheSize',            QUB_QVO_QVD_DEF_CACHESIZE);
    Init('DrawMode',             Integer(QUB_QVO_QVD_DEF_DRAWMODE));
    Init('DrawRaster',           Integer(QUB_QVO_QVD_DEF_DRAWRASTER));
    Init('DrawLabels',           Integer(QUB_QVO_QVD_DEF_DRAWLABELS));
    Init('DrawIdealized',        Integer(QUB_QVO_QVD_DEF_DRAWIDEALIZED));
    Init('DrawIdealizedAbove',   Integer(QUB_QVO_QVD_DEF_DRAWIDEALIZEDABOVE));
    Init('DrawIdealizedColor',   Integer(QUB_QVO_QVD_DEF_DRAWIDEALIZEDCOLOR));
    Init('DrawListOverlapped',   Integer(QUB_QVO_QVD_DEF_DRAWLISTOVERLAPPED));
    Init('MarginH',              QUB_QVO_QVD_DEF_MARGIN);
    Init('MarginV',              QUB_QVO_QVD_DEF_MARGIN);
    Init('TraceChangeOnBreak',   Integer(QUB_QVO_QVD_DEF_TRACECHANGEONBREAK));
    Init('OverlapChannels',      Integer(QUB_QVO_QVD_DEF_OVERLAPCHANNELS));
    Init('OverlapTraces',        Integer(QUB_QVO_QVD_DEF_OVERLAPTRACES));
    Init('DrawPoints',           Integer(QUB_QVO_QVD_DEF_DRAWPOINTS));
    Init('DrawInverted',         Integer(QUB_QVO_QVD_DEF_DRAWINVERTED));
    Init('DrawActiveThick',      Integer(QUB_QVO_QVD_DEF_DRAWACTIVETHICK));
    Init('DrawBaseline',         Integer(QUB_QVO_QVD_DEF_DRAWBASELINE));
    Init('DrawBaselineNodes',    Integer(QUB_QVO_QVD_DEF_DRAWBASELINENODES));
    Init('DrawSegLabels',        Integer(QUB_QVO_QVD_DEF_DRAWSEGLABELS));
    Init('DrawSelList',          Integer(QUB_QVO_QVD_DEF_DRAWSELLIST));
    Init('DrawParameters',       Integer(QUB_QVO_QVD_DEF_DRAWPARAMETERS));
    Init('AutoScale',            Integer(QUB_QVO_QVD_DEF_AUTOSCALE));
    Init('AutoScroll',           Integer(QUB_QVO_QVD_DEF_AUTOSCROLL));

    Init('DataYMin',             QUB_QVO_QVD_DEF_DATAYMIN, DataObject.ADChannelCount, True);
    Init('DataYMax',             QUB_QVO_QVD_DEF_DATAYMAX, DataObject.ADChannelCount, True);
    Init('DataYFactor',          QUB_QVO_QVD_DEF_DATAYFACTOR, DataObject.ADChannelCount, True);
    Init('ChannelVisible',       Integer(QUB_QVO_QVD_DEF_CHANNELVISIBLE), DataObject.ADChannelCount, True);
    Init('FilterOn',             Integer(QUB_QVO_QVD_DEF_FILTERON), DataObject.ADChannelCount, True);
    Init('FilterMAOn',           Integer(QUB_QVO_QVD_DEF_FILTERMAON), DataObject.ADChannelCount, True);
    Init('FilterFreq',           QUB_QVO_QVD_DEF_FILTERFREQ, DataObject.ADChannelCount, True);
    Init('FilterMACount',        QUB_QVO_QVD_DEF_FILTERMACOUNT, DataObject.ADChannelCount, True);
    Init('BaselineOn',           Integer(QUB_QVO_QVD_DEF_BASELINEON), DataObject.ADChannelCount, True);

    //TO DO: How to add new properties without the ominous Node out of bounds or whatever message?! LM
    // just like in old days: find-in-files a similar option such as BaselineOn,
    // and copy everything.

    // one note: defaults must be in qubtree-compatible data types
    // i.e. Integer not Boolean
    // and Double not Currency (!) (see DefDeadTime below)

    Init('DrawItoG',             Integer(QUB_QVO_QVD_DEF_DRAWITOG), DataObject.ADChannelCount, True);

    Init('DefDeadTime',          0.1 / 1.0);

  except
  end;

  prOnSetDisplayProperties(Cat, DisplayProperties);

  ExpCond.AddPar('DeadTime', DisplayProperties['DefDeadTime'].Data[0], -1, False, -1);
end;

procedure TQUB_QVO_QVD.prOnSetDisplayProperties(Sender :TQUB_ProfileCat; Updates :INode);
var
  i                  :Integer;
  Node               :INode;
  Sel                :TQUB_FirstLast;
  Curr               :Integer;

  function Upd(Fallback :Variant; const Name :String): Variant;
  var
    Node             :INode;
  begin
    Node             := Updates.Find(Name);
    if Node.DataCount > 0
    then Result      := Node.Data[0]
    else Result      := Fallback;
  end;

begin

  Sel  := prDataSel;
  Curr := prDataCurr;

  ColorBack              := TColor(Upd(ColorBack, 'Color Back'));
  ColorSel               := TColor(Upd(ColorSel, 'Color Sel'));
  ColorCurr              := TColor(Upd(ColorCurr, 'Color Curr'));
  ColorBreak             := TColor(Upd(ColorBreak, 'Color Break'));
  ColorBaseline          := TColor(Upd(ColorBaseline, 'Color Baseline'));
  ColorBaselineNodes     := TColor(Upd(ColorBaselineNodes, 'Color BaselineNodes'));
  ColorIdealized         := TColor(Upd(ColorIdealized, 'Color Idealized'));
  ColorIdealizedSel      := TColor(Upd(ColorIdealizedSel, 'Color IdealizedSel'));
  ColorFrame             := TColor(Upd(ColorFrame, 'Color Frame'));
  Color                  := TColor(Upd(Color, 'Color'));
  ColorSelList           := TColor(Upd(ColorSelList, 'Color SelList'));
  ColorParameters        := TColor(Upd(ColorParameters, 'Color Parameters'));
  ColorSegLabel          := TColor(Upd(ColorSegLabel, 'Color SegLabel'));
  ColorData[0]           := TColor(Upd(ColorData[0], 'Color Data 0'));
  ColorData[1]           := TColor(Upd(ColorData[1], 'Color Data 1'));
  ColorData[2]           := TColor(Upd(ColorData[2], 'Color Data 2'));
  ColorData[3]           := TColor(Upd(ColorData[3], 'Color Data 3'));
  ColorData[4]           := TColor(Upd(ColorData[4], 'Color Data 4'));
  ColorData[5]           := TColor(Upd(ColorData[5], 'Color Data 5'));
  ColorData[6]           := TColor(Upd(ColorData[6], 'Color Data 6'));
  ColorData[7]           := TColor(Upd(ColorData[7], 'Color Data 7'));

  Self.prSetPage( Upd(TracesPerPage, 'TracesPerPage'),
                  Upd(PointsPerTrace, 'PointsPerTrace'),
                  Upd(CacheSize, 'CacheSize') );

  DrawMode               := TQUB_QVO_QVD_DrawMode(Upd(DrawMode, 'DrawMode'));
  DrawRaster             := 0<>Upd(DrawRaster, 'DrawRaster');
  DrawLabels             := 0<>Upd(DrawLabels, 'DrawLabels');
  DrawIdealized          := 0<>Upd(DrawIdealized, 'DrawIdealized');
  DrawIdealizedAbove     := 0<>Upd(DrawIdealizedAbove, 'DrawIdealizedAbove');
  DrawIdealizedColor     := 0<>Upd(DrawIdealizedColor, 'DrawIdealizedColor');
  DrawListOverlapped     := 0<>Upd(DrawListOverlapped, 'DrawListOverlapped');
  MarginH                := Upd(MarginH, 'MarginH');
  MarginV                := Upd(MarginV, 'MarginV');
  TraceChangeOnBreak     := 0<>Upd(TraceChangeOnBreak, 'TraceChangeOnBreak');
  OverlapChannels        := 0<>Upd(OverlapChannels, 'OverlapChannels');
  OverlapTraces          := 0<>Upd(OverlapTraces, 'OverlapTraces');
  DrawPoints             := 0<>Upd(DrawPoints, 'DrawPoints');
  DrawInverted           := 0<>Upd(DrawInverted, 'DrawInverted');
  DrawActiveThick        := 0<>Upd(DrawActiveThick, 'DrawActiveThick');
  DrawBaseline           := 0<>Upd(DrawBaseline, 'DrawBaseline');
  DrawBaselineNodes      := 0<>Upd(DrawBaselineNodes, 'DrawBaselineNodes');
  DrawSegLabels          := 0<>Upd(DrawSegLabels, 'DrawSegLabels');
  DrawSelList            := 0<>Upd(DrawSelList, 'DrawSelList');
  DrawParameters         := 0<>Upd(DrawParameters, 'DrawParameters');
  AutoScroll             := 0<>Upd(AutoScroll, 'AutoScroll');
  AutoScale              := 0<>Upd(AutoScale, 'AutoScale');

  Node                   := Updates.Find('DefDeadTime');
  if Node.DataCount > 0
  then DisplayProperties['DefDeadTime'].Data[0] := Node.Data[0];

  Node                   := Updates.Find('DataYMin');
  for i := 0 to Min(Node.DataCount, DataObject.ADChannelCount) - 1 do begin
    DataYMin[i]          := Node.Data[i];
  end;
  Node                   := Updates.Find('DataYMax');
  for i := 0 to Min(Node.DataCount, DataObject.ADChannelCount) - 1 do begin
    DataYMax[i]          := Node.Data[i];
  end;
  Node                   := Updates.Find('DataYFactor');
  for i := 0 to Min(Node.DataCount, DataObject.ADChannelCount) - 1 do begin
    DataYFactor[i]       := Node.Data[i];
  end;

  //TO DO
  //Node                   := Updates.Find('DrawItoG');
  //for i := 0 to Min(Node.DataCount, DataObject.ADChannelCount) - 1 do begin
  //  DrawItoG[i]          := Node.Data[i];
  //end;

  Node                   := Updates.Find('ChannelVisible');
  for i := 0 to Min(Node.DataCount, DataObject.ADChannelCount) - 1 do begin
    ChannelVisible[i]    := 0<>Node.Data[i];
  end;
  Node                   := Updates.Find('FilterOn');
  for i := 0 to Min(Node.DataCount, DataObject.ADChannelCount) - 1 do begin
    FilterOn[i]          := 0<>Node.Data[i];
  end;
  Node                   := Updates.Find('FilterMAOn');
  for i := 0 to Min(Node.DataCount, DataObject.ADChannelCount) - 1 do begin
    FilterMAOn[i]        := 0<>Node.Data[i];
  end;
  Node                   := Updates.Find('FilterFreq');
  for i := 0 to Min(Node.DataCount, DataObject.ADChannelCount) - 1 do begin
    FilterFreq[i]        := Node.Data[i];
  end;
  Node                   := Updates.Find('FilterMACount');
  for i := 0 to Min(Node.DataCount, DataObject.ADChannelCount) - 1 do begin
    FilterMACount[i]     := Node.Data[i];
  end;
  Node                   := Updates.Find('BaselineOn');
  for i := 0 to Min(Node.DataCount, DataObject.ADChannelCount) - 1 do begin
    BaselineOn[i]        := 0<>Node.Data[i];
  end;

  for i := 0 to Min(Node.DataCount, DataObject.ADChannelCount) - 1 do begin
    prDataChannelProcess[i]          := Integer(prFilterOn[i])   * QUB_QVO_QVD_PROCESS_SET_FILTER_ON
                                      + Integer(prBaselineOn[i]) * QUB_QVO_QVD_PROCESS_SET_BASELINE_ON;
  end;

  
  prDataSel  := Sel;
  prDataCurr := Curr;

  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA or DATA_MSG_SET_SCROLL, 0);

end;


//******************************************************************************

function TQUB_QVO_QVD.CloneSession: INode;
begin
  Result      := TNode.Create('SessionFile');
  Result.AppendClone(DisplayProperties, True);
  prUpdateSession(Result);
end;

procedure TQUB_QVO_QVD.prReadSession;
var
  Sess                               :INode;
  Chan                               :INode;
  Tree                               :INode;
  i                                  :Integer;
  s                                  :Integer;
begin
  prActiveChannel                    := ReadIntProperty( DataObject.Session.Find('ActiveChannel'), ActiveChannel );

  Sess                               := DataObject.Session.Find('Display');

  Tree                               := Sess['Channels'];
  Chan                               := Tree['Channel'];
  i                                  := 0;
  while (i < DataObject.ADChannelCount) and not Chan.IsNull do begin
    prDataYMin[i]                    := ReadIntProperty(Chan.Find('DataYMin'), DataYMin[i]);
    prDataYMax[i]                    := ReadIntProperty(Chan.Find('DataYMax'), DataYMax[i]);
    prDataYFactor[i]                 := ReadDoubleProperty(Chan.Find('DataYFactor'), DataYFactor[i]);

    //TO DO
    //prDrawItoG[i]                    := ReadBoolProperty(Chan.Find('DrawItoG'), DrawItoG[i]);

    prWarnOnBaseline[i]              := ReadBoolProperty( Chan.Find('WarnOnBaseline'), WarnOnBaseline[i] );

    Inc(i);
    Chan                             := Chan.SiblingSameName;
  end;

  // ---------------------------------

  Tree                               := DataObject.Session.Find('DataChannels');
  Chan                               := Tree.Find('Channel');
  i                                  := 0;
  while (i < DataObject.ADChannelCount) and not Chan.IsNull do begin

    prDataChannelName[i]             := Chan['Name'].DataAsString;
    prDataChannelUnits[i]            := Chan['Units'].DataAsString;
    prDataChannelScaling[i]          := ReadDoubleProperty(Chan.Find('Scaling'), prDataChannelScaling[i]);
    prDataChannelOffset[i]           := ReadDoubleProperty(Chan.Find('Offset'), prDataChannelOffset[i]);

    if (prDataChannelScaling[i] < 0) and (prDataYMin[i] < prDataYMax[i]) then begin
      s             := prDataYMax[i];
      prDataYMax[i] := prDataYMin[i];
      prDataYMin[i] := s;
    end;

    Inc(i);
    Chan                             := Chan.SiblingSameName;

  end;

  //Graphics settings
  Tree                               := DataObject.Session.Find('Graphics');
  prXAxisTickCount                   := ReadIntProperty(Tree.Find('XAxisTickCount'), prXAxisTickCount);
  Chan                               := Tree.Find('Channel');
  i                                  := 0;
  while (i < DataObject.ADChannelCount) and not Chan.IsNull do begin

    prYAxisTickCount[i]              := ReadIntProperty(Chan.Find('YAxisTickCount'), prYAxisTickCount[i]);

    Inc(i);
    Chan                             := Chan.SiblingSameName;

  end;


  // ---------------------------------

  prExpCond.Clear;
  prExpCond.ReadTree( DataObject.Session.Find('ExpCond') );

  prReadSessionLists;
  prReadSessionIdl;
  prReadSessionResults;
  prReadSessionBaseline;
  prReadSessionMarkers;
  prReadSessionTimeMarkers;
  prReadSessionKinParamsMarkers;

  //Refresh;//?!?! {todo: I think it should. LM}

end;

procedure TQUB_QVO_QVD.prUpdateSession(Session :INode);
var
  Sess          :INode;
  Chan          :INode;
  Tree          :INode;
  i             :Integer;
begin
  Session['FileExt'].SetData( DataObject.FileExt );  // to help find the data given the session e.g. when searching for data with "notes" containing ...

  Sess          := Session['Display'];

  Tree         := Sess['Channels'];
  while not Tree.Child.IsNull do begin
    Tree.RemoveChild(Tree.Child);
  end;

  Chan         := TNode.CreateNull;  // inserting after null means insert at beginning
  for i := 0 to DataObject.ADChannelCount - 1 do begin
    Chan       := Tree.InsertChild(Chan, 'Channel');
    Chan['DataYMin'].SetData(prDataYMin[i]);
    Chan['DataYMax'].SetData(prDataYMax[i]);
    Chan['DataYFactor'].SetData(prDataYFactor[i]);

    //TO DO
    //Chan['DrawItoG'].SetData(DrawItoG[i]);

    Chan['WarnOnBaseline'].SetData( Integer(WarnOnBaseline[i]) );
  end;

  // ----------------------------------

  Tree     := Session['DataChannels'];
  while not Tree.Child.IsNull do begin
    Tree.RemoveChild(Tree.Child);
  end;

  Chan         := TNode.CreateNull;  // inserting before null means insert at beginning
  for i := 0 to DataObject.ADChannelCount - 1 do begin
    Chan       := Tree.InsertChild(Chan, 'Channel');
    Chan['Name'].SetData(prDataChannelName[i]);
    Chan['Units'].SetData(prDataChannelUnits[i]);
    Chan['Scaling'].SetData(prDataChannelScaling[i]);
    Chan['Offset'].SetData(prDataChannelOffset[i]);
  end;

  //Graphics settings
  Tree     := Session['Graphics'];
  while not Tree.Child.IsNull do begin
    Tree.RemoveChild(Tree.Child);
  end;
  Tree['XAxisTickCount'].SetData(prXAxisTickCount);
  Chan         := TNode.CreateNull;  // inserting before null means insert at beginning
  for i := 0 to DataObject.ADChannelCount - 1 do begin
    Chan       := Tree.InsertChild(Chan, 'Channel');
    Chan['YAxisTickCount'].SetData(prYAxisTickCount[i]);
  end;

  // ----------------------------------

  Session.RemoveChild( Session.Find('ExpCond') );
  Session.AppendChild( prExpCond.ToTree );

  prUpdateSessionLists(Session);
  prUpdateSessionIdl(Session);
  prUpdateSessionResults(Session);
  prUpdateSessionBaseline(Session);
  prUpdateSessionMarkers(Session);
  prUpdateSessionTimeMarkers(Session);
  //prUpdateSessionKineticParamsMarkers(Session);


end;

procedure TQUB_QVO_QVD.prReadSessionLists;
var
  List                :TQUB_QVO_QVD_SelectionList;
  ListNode            :INode;
begin
  m_lListLoading := true;
  try
    ListNode            := DataObject.Session.Find('Lists').Find('List');
    while not ListNode.IsNull do begin
      //Create List
      // we could be re-reading session so replace not duplicate
      //List              := AddList( ListNode.DataAsString );
      List              := GetList( ListNode.DataAsString );
      if not List.Locked then begin
        List.Clear;
        //Read ListNode into List.
        List.AsTree       := ListNode;
        if List = nil then Beep;
      end;
      ListNode          := ListNode.SiblingSameName;
    end;

    ListNode            := DataObject.Session.Find('Lists').Find('ListIndex');
    if not ListNode.IsNull then begin
      try
        prSelectionLists.ItemIndex := ListNode.Data[0];
        prSelectionLists.Selected[prSelectionLists.Items.Count - 1] := False;
        prSelectionLists.Selected[ListNode.Data[0]] := True;
      except
      end;
    end;
    ListNode            := DataObject.Session.Find('Lists').Find('SelFirst');
    if not ListNode.IsNull then prDataSel.First := ListNode.Data[0];
    ListNode            := DataObject.Session.Find('Lists').Find('SelLast');
    if not ListNode.IsNull then prDataSel.Last  := ListNode.Data[0];
    ListNode            := DataObject.Session.Find('Lists').Find('ZoomSelFirst');
    if not ListNode.IsNull then prDataZoomSel.First := ListNode.Data[0];
    ListNode            := DataObject.Session.Find('Lists').Find('ZoomSelLast');
    if not ListNode.IsNull then prDataZoomSel.Last  := ListNode.Data[0];
    //ListNode            := DataObject.Session.Find('Lists').Find('DataCurr');
    //if not ListNode.IsNull then prDataCurr  := ListNode.Data[0];

  finally
    m_lListLoading := False;
  end;
end;

procedure TQUB_QVO_QVD.prUpdateSessionLists(Session :INode);
var
  i                   :Integer;
  List                :TQUB_QVO_QVD_SelectionList;
  ListsNode, ListNode :INode;
begin
  ListsNode           := Session.Find('Lists');
  if not ListsNode.IsNull then Session.RemoveChild( ListsNode );

  ListsNode           := Session.AppendChild('Lists');
  ListNode            := TNode.CreateNull;

  for i := 0 to prSelectionLists.Items.Count - 1 do begin
    List              := prSelectionLists[i];
    if List.Private then Continue;
    ListNode          := ListsNode.InsertChild(ListNode, List.AsTree);
    ListNode.SetData( prSelectionLists.Items[i] );
  end;

  ListNode            := ListsNode.AppendChild('ListIndex');
  ListNode.SetData(prSelectionLists.ItemIndex);
  ListNode            := ListsNode.AppendChild('SelFirst');
  ListNode.SetData(prDataSel.First);
  ListNode            := ListsNode.AppendChild('SelLast');
  ListNode.SetData(prDataSel.Last);
  ListNode            := ListsNode.AppendChild('ZoomSelFirst');
  ListNode.SetData(prDataZoomSel.First);
  ListNode            := ListsNode.AppendChild('ZoomSelLast');
  ListNode.SetData(prDataZoomSel.Last);
  //ListNode            := ListsNode.AppendChild('DataCurr');
  //ListNode.SetData(prDataCurr);

end;

procedure TQUB_QVO_QVD.prReadSessionIdl;
var
  ChanNode             :INode;
  SegNode              :INode;
  c                    :Integer;
begin
  ChanNode             := DataObject.Session.Find('Idealization').Find('Channel');
  c                    := 0;
  while (c < DataObject.ADChannelCount) and not ChanNode.IsNull do begin
    SegNode            := ChanNode.Find('Segment');

    if not SegNode.IsNull then begin
      DataObject.Idealization[c].SetDwells(ChanNode);
    end;

    ChanNode           := ChanNode.SiblingSameName;
    c                  := c + 1;
  end;

  DataObject.Session.RemoveChild( DataObject.Session.Find('Idealization') );
end;

procedure TQUB_QVO_QVD.prUpdateSessionIdl(Session :INode);
var
  IdlNode              :INode;
  ChanNode             :INode;
  c                    :Integer;
begin
  IdlNode              := Session.Find('Idealization');
  if not IdlNode.IsNull then Session.RemoveChild( IdlNode );

  if (DataObject.FileType <> QFS_QDF_TYPE_DWT) and (DataObject.FileType <> QFS_QDF_TYPE_EVL) and (DataObject.FileType <> QFS_QDF_TYPE_PRT) and (DataObject.FileType <> QFS_QDF_TYPE_QSF) then begin
    IdlNode              := Session.AppendChild('Idealization');
    ChanNode             := TNode.CreateNull;

    for c := 0 to DataObject.ADChannelCount - 1 do begin
      ChanNode           := IdlNode.InsertChild(ChanNode, DataObject.Idealization[c].GetDwells(0, DataObject.Segments.TotalDataCount-1, 1, 1));
      ChanNode.Name      := 'Channel';
    end;
  end;
end;

procedure TQUB_QVO_QVD.prReadSessionResults;
var
  ResultsParent, Results     :INode;
begin
  ResultsList.Clear;
  ResultsParent := DataObject.Session.Find('Results');
  Results       := ResultsParent.Child;
  while not Results.IsNull do begin
    if Results.Find('Hold').IsNull then Results['Hold'].SetData( 1 ); // default: 'Hold' all results that predate the Hold feature
    ResultsList.AddResultsBehind( Results );
    ResultsParent.RemoveChild( Results );
    Results := ResultsParent.Child;
  end;
  if ResultsList.Items.Count > 0 then begin
    // weird side effect: when saving only session, results window goes blank (choose a result to restore it)
    ResultsList.ChooseResults( ResultsList.Items.Count - 1 );
  end;
end;

procedure TQUB_QVO_QVD.prUpdateSessionResults(Session :INode);
var
  ResultsParent, Results :INode;
  i                      :Integer;
begin
  ResultsParent          := Session['Results'];
  Results                := TNode.CreateNull;
  for i := 0 to ResultsList.Items.Count - 1 do begin
    Results := ResultsParent.InsertChild(Results, ResultsList.ResultsNode[i]);
  end;
end;

procedure TQUB_QVO_QVD.prReadSessionBaseline;
var
  Tree, Chan           :INode;
  AllNodes             :TQUB_FirstLast;
  Baseline, NodeCount  :Integer;
  i                    :Integer;
begin
  Tree                 := DataObject.Session['Baseline'];

  // Old-style
  Chan                 := Tree.Find('Channel');
  i                    := 0;
  while (i < DataObject.ADChannelCount) and not Chan.IsNull do begin
    Baseline                   := ReadIntProperty( Chan.Find('Baseline'), prDataBaseline[i] );
    NodeCount                  := ReadIntProperty( Chan.Find('NodeCount'), 0 );
    if (NodeCount > 0) then begin
      AllNodes                   := QUB_FirstLast(0, NodeCount);
      ApplyBaseLineNodes(i, NodeCount, TPAInteger(Chan.Find('Nodes').DataPtr), TPAInteger(Chan.Find('NodesDBl').DataPtr), False{Combine}, Baseline);
    end else begin
      DataBaseLine[i]            := Baseline;
    end;

    i                  := i + 1;
    Chan               := Chan.SiblingSameName;
  end;

  // New-style
  Chan                 := Tree.Find('BaselineSegments');
  i                    := 0;
  while (i < DataObject.ADChannelCount) and not Chan.IsNull do begin
    DataBaseLine[i]    := ReadIntProperty( Chan.Find('Baseline'), prDataBaseline[i] );
    BaselineNodes[i].AddNodes( Chan );

    Inc(i);
    Chan               := Chan.SiblingSameName;
  end;

  if i > 0 then begin // some new-style baseline nodes
    prDataMeasured := False;//?1
    DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA, 0);
    DoOnEdit;
  end;

end;

procedure TQUB_QVO_QVD.prUpdateSessionBaseline(Session :INode);
var
  Tree, Chan        :INode;
  i                 :Integer;
begin
  Tree         := Session['Baseline'];
  while not Tree.Child.IsNull do Tree.RemoveChild( Tree.Child );

  Chan         := TNode.CreateNull;
  for i := 0 to DataObject.ADChannelCount - 1 do begin
    if BaselineNodes[i] <> nil then begin
      Chan       := Tree.InsertChild( Chan, BaselineNodes[i].ToTree );
      Chan['Baseline'].SetData( prDataBaseline[i] );
    end;
  end;
end;

//Session Markers
procedure TQUB_QVO_QVD.prReadSessionMarkers;
var
  Tree, Marker         :INode;
  MCount               :Integer;
  i                    :Integer;
begin

  //Delete all Markers
  prDeleteAllMarkers;

  MCount               := 0;

  Tree                 := DataObject.Session['Markers'];
  if Tree.IsNull then Exit;

  Marker               := Tree.Find('Marker');
  i                    := 0;

  while not Marker.IsNull do begin

    if (i + 1) > MCount then begin
      Inc(MCount, 10);//not likely to have more than 10 markers
      ReAllocMem(prDataMarkers,   SizeOf(Double)  * MCount);
      ReAllocMem(prDataMarkersCh, SizeOf(Integer) * MCount);
    end;

    Inc(prDataMarkersCount);

    prDataMarkers[i]   := ReadDoubleProperty(Marker.Find('Value'), 0);
    prDataMarkersCh[i] := ReadIntProperty(Marker.Find('Channel'), 0);

    Marker             := Marker.SiblingSameName;

    Inc(i);

  end;

  if prDataMarkersCount <> MCount then begin
    ReAllocMem(prDataMarkers,   SizeOf(Double)  * prDataMarkersCount);
    ReAllocMem(prDataMarkersCh, SizeOf(Integer) * prDataMarkersCount);
  end;

  if prDataMarkersCount > 0 then begin
    DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA, 0);
    DoOnEdit;
  end;

end;

procedure TQUB_QVO_QVD.prUpdateSessionMarkers(Session :INode);
var
  Tree, Marker :INode;
  i            :Integer;
begin

  Tree         := Session['Markers'];
  while not Tree.Child.IsNull do Tree.RemoveChild( Tree.Child );

  for i := 0 to prDataMarkersCount - 1 do begin
    Marker     := Tree.AppendChild('Marker');
    // Lorin: these are created and appended automatically by the [] property (if they're not already there)
    //Marker.AppendChild('Value');
    //Marker.AppendChild('Channel');
    Marker['Value'].SetData(VarAsType(prDataMarkers[i], varDouble));
    Marker['Channel'].SetData(VarAsType(prDataMarkersCh[i], varInteger));
  end;
end;

//Session Time Markers
procedure TQUB_QVO_QVD.prReadSessionTimeMarkers;
var
  Tree, Marker         :INode;
  MCount               :Integer;
  i                    :Integer;
begin

  //Delete all Time Markers
  prDeleteAllTimeMarkers;

  MCount               := 0;

  Tree                 := DataObject.Session['TimeMarkers'];
  if Tree.IsNull then Exit;

  Marker               := Tree.Find('TimeMarker');
  i                    := 0;

  while not Marker.IsNull do begin

    if (i + 1) > MCount then begin
      Inc(MCount, 10);//not likely to have more than 10 markers
      ReAllocMem(prDataTimeMarkers,   SizeOf(Double)  * MCount);
    end;

    Inc(prDataTimeMarkersCount);

    prDataTimeMarkers[i]   := ReadDoubleProperty(Marker.Find('Value'), 0);

    Marker             := Marker.SiblingSameName;

    Inc(i);

  end;

  if prDataTimeMarkersCount <> MCount then begin
    ReAllocMem(prDataTimeMarkers,   SizeOf(Double)  * prDataTimeMarkersCount);
  end;

  if prDataTimeMarkersCount > 0 then begin
    DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA, 0);
    DoOnEdit;
  end;

end;

procedure TQUB_QVO_QVD.prUpdateSessionTimeMarkers(Session :INode);
var
  Tree, Marker :INode;
  i            :Integer;
begin

  Tree         := Session['TimeMarkers'];
  while not Tree.Child.IsNull do Tree.RemoveChild( Tree.Child );

  for i := 0 to prDataTimeMarkersCount - 1 do begin
    Marker     := Tree.AppendChild('TimeMarker');
    Marker['Value'].SetData(VarAsType(prDataTimeMarkers[i], varDouble));
  end;
end;


//Session Kinetic Parameters
procedure TQUB_QVO_QVD.prReadSessionKinParamsMarkers;
var
  List          :TQUB_QVO_QVD_SelectionList;
  Sel           :TQUB_QVO_QVD_Selection;
  ParamsToDraw  :INode;
  Params        :INode;
  TheNote       :INode;
  ChangePoint   :INode;
  CurrPoint     :INode;
  ThisPoint     :Integer;
  Pars          :String;
  Note          :String;
  MCount        :Integer;
  i             :Integer;
const
  lName = 'KineticParameters';
begin

  //Delete all KinParams Markers
  prDeleteAllKinParamsMarkers;

  List := GetList(lName);

  ParamsToDraw := DataObject.Session.Find('KineticParameters');
  if ParamsToDraw.IsNull then begin
    if List <> nil then begin
      DelList(lName);
    end;
  end else begin

    if List = nil then begin
      List := prAddList(lName);
    end;
    List.Clear;

    MCount := 0;
    i := 0;
    ChangePoint := ParamsToDraw.Find('ChangePoint');
    while not ChangePoint.IsNull do begin
      CurrPoint := ChangePoint.Find('CurrPoint');
      ThisPoint := CurrPoint.Data[0];
      Params    := ChangePoint.Find('Parameters');
      TheNote   := ChangePoint.Find('Note');

      Pars      := Params.AsString;
      Note      := TheNote.DataAsString;

      Sel := List.AddSelection(ThisPoint, ThisPoint, 'Kin par change ' + inttostr(i), True{InBunch});
      Sel.Comment := Note + #13#10#13#10 + Pars;

      if (i + 1) > MCount then begin
        Inc(MCount, 20);//not likely to have more than 20 markers
        ReAllocMem(prDataKinParamsMarkers, SizeOf(Integer) * MCount);
        SetLength(prDataKinParamsMarkersPars, MCount);
        SetLength(prDataKinParamsMarkersNote, MCount);
      end;

      Inc(prDataKinParamsMarkersCount);
      prDataKinParamsMarkers[i] := ThisPoint;
      prDataKinParamsMarkersPars[i] := Pars;
      prDataKinParamsMarkersNote[i] := Note;

      Inc(i);

      ChangePoint := ChangePoint.SiblingSameName;
    end;

    List.Lock;

    if prDataKinParamsMarkersCount <> MCount then begin
      ReAllocMem(prDataKinParamsMarkers, SizeOf(Integer) * prDataKinParamsMarkersCount);
      SetLength(prDataKinParamsMarkersPars, prDataKinParamsMarkersCount);
      SetLength(prDataKinParamsMarkersNote, prDataKinParamsMarkersCount);
    end;

  end;

  if prDataKinParamsMarkersCount > 0 then begin
    DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA, 0);
    DoOnEdit;
  end;

end;

//Edit Lists operations
function TQUB_QVO_QVD.prCopyListsToClipboard :Boolean;
var
  List      :TQUB_QVO_QVD_SelectionList;
  ListNode  :INode;
  ListsNode :INode;
  i         :Integer;
begin
  Result := prSelectionLists.Items.Count = 0;
  if Result then Exit;

  ListsNode := TNode.Create('Lists');

  for i := 0 to prSelectionLists.Items.Count - 1 do begin
    if prSelectionLists.Selected[i] then begin
      List      := prSelectionLists[i];
      ListNode  := List.AsTree;
      ListNode.SetData(prSelectionLists.Items[i]);
      ListsNode.AppendChild(ListNode);
    end;
  end;

  Result := not ListsNode.Copy;
end;

function TQUB_QVO_QVD.prPasteListsFromClipboard :Boolean;
var
  List      :TQUB_QVO_QVD_SelectionList;
  ListName  :String;
  ListNode  :INode;
  ListsNode :INode;
begin
  Result := True;
  if CanPasteNode(ListName) and (ListName = 'Lists') then begin

    Result     := False;
    ListsNode  := TNode.Paste;
    ListNode   := ListsNode.Find('List');
    while not ListNode.IsNull do begin
      //Create List
      ListName          := ListNode.DataAsString;
      if SelectionLists.ListByName[ListName] <> nil then begin
        ListName        := 'copy of ' + ListName;
      end;
      List              := AddList(ListName);
      //Read ListNode into List
      List.AsTree       := ListNode;
      ListNode          := ListNode.SiblingSameName;
    end;

  end;
end;


//Edit Selections operations
function TQUB_QVO_QVD.prCopySelectionsToClipboard :Boolean;
var
  List      :TQUB_QVO_QVD_SelectionList;
  ListNode  :INode;
  ListsNode :INode;
begin
  Result := prSelectionLists.Items.Count = 0;
  if not Result then Result := prSelectionLists.ItemIndex = -1;
  if Result then Exit;

  try
    ListsNode := TNode.Create('Selections');
    List      := prSelectionLists[prSelectionLists.ItemIndex];
    if List = nil then Exit;
    ListNode  := List.AsTreeSelected;
    ListNode.SetData(prSelectionLists.Items[prSelectionLists.ItemIndex]);
    ListsNode.AppendChild(ListNode);
    Result    := not ListsNode.Copy;
  except
    Result := True;
  end;
end;

function TQUB_QVO_QVD.prPasteSelectionsFromClipboard :Boolean;
var
  List      :TQUB_QVO_QVD_SelectionList;
  ListName  :String;
  ListNode  :INode;
  ListsNode :INode;
begin
  Result := True;
  if CanPasteNode(ListName) and (ListName = 'Selections') then begin
    try
      Result     := False;
      ListsNode  := TNode.Paste;
      ListNode   := ListsNode.Find('List');
      if not ListNode.IsNull then begin
        ListName          := ListNode.DataAsString;
        //Insert selections into current List
        if prSelectionLists.ItemIndex = -1 then begin
        //Create List
          List            := AddList(ListName);
        end else begin
          List            := prSelectionLists[prSelectionLists.ItemIndex];
        end;
        //Read ListNode into List
        List.AsTreeAppend := ListNode;
      end;
    except
      Result := True;
    end;
  end;
end;

//******************************************************************************
function TQUB_QVO_QVD.prAllocCache(const NewCache :TQUB_FirstLast; FullSize :Boolean; var ReAllocd :Boolean) :Boolean;
begin

  (*

     The Old prAllocCache:

  //Redo this for MAX_CHANNELS !!!
  if prData = nil then begin

    if prDataChannelCount > 0 then begin
      if (NewCache.Last - NewCache.First + 1) > 0 then begin
        prData := IAlloc2(prDataChannelCount, NewCache.Last - NewCache.First + 1);
      end;
    end;

  end else begin

    if (NewCache.Last - NewCache.First) <> (prDataCache.Last - prDataCache.First) then begin

      Free2(TPMChar(prData));
      prData := nil;
      if (NewCache.Last - NewCache.First + 1) > 0 then begin
        prData := IAlloc2(prDataChannelCount, NewCache.Last - NewCache.First + 1);
      end;

    end;

  end;

  *)

  Result   := False;
  ReAllocd := False;

  if prDataChannelCount <= 0 then Exit;

  //DeAllocate ?
  if (prData <> nil) and
     (
      ((    FullSize) and ((NewCache.Last - NewCache.First + 1)  > prDataAllocCount)) or
      ((not FullSize) and ((NewCache.Last - NewCache.First + 1) <> prDataAllocCount))
     )  then begin

    Free2(TPMChar(prData));
    prData           := nil;
    prDataAllocCount := 0;
    ReAllocd         := True;

  end;

  //Allocate ?
  if (FullSize) and ((NewCache.Last - NewCache.First + 1)  > prDataAllocCount) then begin

    prDataAllocCount := prCacheSize;
    if prDataAllocCount < (NewCache.Last - NewCache.First + 1) then begin
      prDataAllocCount := (NewCache.Last - NewCache.First + 1)
    end;
    if (prDataChannelCount <> 0) and (prDataAllocCount <> 0) then begin
      try
        prData       := IAlloc2(prDataChannelCount, prDataAllocCount);
      except
        Result       := True;
      end;
      ReAllocd       := True;
    end;

  end else if (not FullSize) and ((NewCache.Last - NewCache.First + 1) <> prDataAllocCount) then begin

    prDataAllocCount := (NewCache.Last - NewCache.First + 1);
    if (prDataChannelCount <> 0) and (prDataAllocCount <> 0) then begin
      try
        prData       := IAlloc2(prDataChannelCount, prDataAllocCount);
      except
        Result       := True;
      end;
      ReAllocd       := True;
    end;

  end;

end;

{
This function reads data into the cache.
It does it by allocating the necessary memory and then telling the DataObject
  to fill it between Cache.Start and Cache.Last
}
//******************************************************************************
function TQUB_QVO_QVD.prReadCache(const NewCache :TQUB_FirstLast; Expand :Boolean) :Boolean;
var
  i :Integer;
begin

  (*

  The old prReadCache:

  Result := prDataObject.ReadData(prData, False{Raw}, -1{Channel}, prDataCache.First, prDataCache.Last);

  //This should go into Browse, after processing, and be done for each DisplayData !!!
  if not Result then begin
    // prGetYAvgMinMax;

    prDoDataBaseline(prData, -1{Channel}, (prDataCache.Last - prDataCache.First + 1));
  end;

  *)


  Result := False;

  if Expand then begin

    for i := 0 to prDataChannelCount - 1 do begin

      if not Result then begin
        try
          Result := prDataObject.ReadData(@prData[i, prDataCache.Last - prDataCache.First + 1], False{Raw}, i{Channel}, prDataCache.Last + 1, NewCache.Last);
        except
          Result := True;
        end;
      end;

      //This is very time consuming for large files, and it should not be done unless turned on
      if not Result then begin
        //I added the check for baselineon (LM)
        //if prBaselineOn[i] then  begin
          try
            prDoDataBaseline(TPAInteger(@prData[i, prDataCache.Last - prDataCache.First + 1]), i{Channel}, NewCache.Last - prDataCache.Last);
          except
          end;  
        //end;
      end;

    end;

  end else begin

    try
      Result := prDataObject.ReadData(prData, False{Raw}, -1{Channel}, NewCache.First, NewCache.Last);
    except
      Result := True;
    end;

    //This is very time consuming for large files, and it should not be done unless turned on
    if not Result then begin
      try
        prDoDataBaseline(prData, -1{Channel}, (NewCache.Last - NewCache.First + 1));
      except
      end;
    end;

  end;

  prDataCache := NewCache;

end;

procedure TQUB_QVO_QVD.prDoProcessDataChannel(Data :TPAInteger; ChannelIndex :Integer; Sel :TQUB_FirstLast; ProcessFilter :Boolean; ProcessBaseLine :Boolean);
var
  Buffer       :TPAInteger;
begin

  Buffer := nil;

  try

    Buffer := IAlloc1(Sel.Last - Sel.First + 1);

    //Process this channel ?
    if (ProcessFilter) or (ProcessBaseline) {prDataChannelProcess[ChannelIndex] <> QUB_QVO_QVD_PROCESS_NONE} then begin
    //Yes !

      if {((prDataChannelProcess[ChannelIndex] and QUB_QVO_QVD_PROCESS_GET_FILTER) <> 0) and} (ProcessFilter) then begin
      //FilterOn

        FillChar(Buffer[0], SizeOf(Integer) * (Sel.Last - Sel.First + 1), 0);
        try
          DLLFilterIntData(@Data[0], @Buffer[0], Sel.Last - Sel.First + 1,  Sampling, FilterFreq[ChannelIndex], 1024);
        except
        end;
        //prCleanFilterBounds(Buffer, Sel, ChannelIndex, FilterFreq[ChannelIndex]);
        prNewCleanFilterBounds(Data, Buffer, Sel, FilterFreq[ChannelIndex]);
        Move(Buffer[0], Data[0], SizeOf(Integer) * (Sel.Last - Sel.First + 1));

      end;

      if ProcessBaseline then begin
      //BaselineOn

        prDoBaseline(Data, ChannelIndex, Sel);

      end;

    end;

  finally
    FreeMem(Buffer);
  end;

end;

procedure TQUB_QVO_QVD.prDoProcessData(Data :TPMInteger; Sel :TQUB_FirstLast; ProcessFilter :Boolean; ProcessBaseLine :Boolean);
var
  ChannelIndex :Integer;
  Buffer       :TPAInteger;
begin

  Buffer := nil;

  try

    Buffer := IAlloc1(Sel.Last - Sel.First + 1);

    for ChannelIndex := 0 to QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1 do begin

      if ChannelIndex > (prDataChannelCount - 1) then Break;

      //Process this channel ?
      if (ProcessFilter) or (ProcessBaseline) {prDataChannelProcess[ChannelIndex] <> QUB_QVO_QVD_PROCESS_NONE} then begin
      //Yes !

        if {((prDataChannelProcess[ChannelIndex] and QUB_QVO_QVD_PROCESS_GET_FILTER) <> 0) and} (ProcessFilter) then begin
        //FilterOn

          FillChar(Buffer[0], SizeOf(Integer) * (Sel.Last - Sel.First + 1), 0);
          try
            DLLFilterIntData(@Data[ChannelIndex, 0], @Buffer[0], Sel.Last - Sel.First + 1,  Sampling, FilterFreq[ChannelIndex], 1024);
          except
          end;
          prNewCleanFilterBounds(TPAInteger(@Data[ChannelIndex, 0]), Buffer, Sel, FilterFreq[ChannelIndex]);
          //prCleanFilterBounds(Buffer, Sel, ChannelIndex, FilterFreq[ChannelIndex]);
          Move(Buffer[0], Data[ChannelIndex, 0], SizeOf(Integer) * (Sel.Last - Sel.First + 1));

        end;

        if ProcessBaseline then begin
        //BaselineOn

          prDoBaseline(Data[ChannelIndex], ChannelIndex, Sel);

        end;

      end;

    end;//ChannelIndex

  finally
    FreeMem(Buffer);
  end;

end;



//****************************************************************************//
//                                                                            //
//                               B A S E L I N E                              //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVD.prDoDataBaseline(Buffer :TPMInteger; ChannelIndex :Integer; Count :Integer);
var
  c           :Integer;
begin
  if Buffer = nil then Exit;

  if ChannelIndex >= 0 then begin
    prDoDataBaseline(Buffer[ChannelIndex], ChannelIndex, Count);
  end else begin
    for c := 0 to prDataChannelCount - 1 do begin
      prDoDataBaseline(Buffer[c], c, Count);
    end;
  end;
end;

procedure TQUB_QVO_QVD.prDoDataBaseline(Buffer :TPAInteger; ChannelIndex :Integer; Count :Integer);
var
  i           :Integer;
  b           :Integer;
begin
  b           := - prDataBaseLine[ChannelIndex];
  for i := 0 to Count - 1 do begin
    Buffer[i] := Buffer[i] + b;
  end;
end;


procedure TQUB_QVO_QVD.DelBaseLineNodes(ChannelIndex :Integer; Sel :TQUB_FirstLast);
begin

  BaselineNodes[ChannelIndex].ClearNodes(Sel.First, Sel.Last);

  //Done
  prDataMeasured := False;
  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA, 0);

end;

procedure TQUB_QVO_QVD.AddBaseLineNodes(ChannelIndex :Integer; NodeCount :Integer; Nodes, NodesDBl :TPAInteger);
begin

  BaselineNodes[ChannelIndex].AddNodes(NodeCount, Nodes, NodesDBl);

  //Done
  prDataMeasured := False;//?1
  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA, 0);

end;


procedure TQUB_QVO_QVD.ApplyBaseLineNodes(ChannelIndex :Integer; NodeCount :Integer; Nodes, NodesDBl :TPAInteger; Combine :Boolean; Baseline :Integer);
begin

  BaselineNodes[ChannelIndex].AddNodes(NodeCount, Nodes, NodesDBl);
  DataBaseLine[ChannelIndex]            := Baseline;

  //Done
  prDataMeasured := False;//?1
  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA, 0);

  DoOnEdit;

end;

procedure TQUB_QVO_QVD.ClearBaseLineNodes(ChannelIndex :Integer);
begin

  BaselineNodes[ChannelIndex].ClearNodes(0, DataObject.Segments.TotalDataCount - 1);

  prDataMeasured := False;//?1
  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA, 0);

  DoOnEdit;

end;

procedure TQUB_QVO_QVD.prDoBaseline(Data :TPAInteger; ChannelIndex :Integer; Sel :TQUB_FirstLast);
var
  Segs                :TList;
  Seg                 :TQUB_BaselineSeg;
  RFrom, RTo          :TQUB_BaselineSeg_Node;
  RangeValid          :Boolean;
  Slope               :Double;
  s                   :Integer;
  pAbs, pBuf          :Integer;
begin
  Segs                := TList.Create;
  try
    if not BaselineNodes[ChannelIndex].GetReadSegs(Sel.First, Sel.Last, Segs) then begin
      for s := 0 to Segs.Count - 1 do begin
        Seg           := TQUB_BaselineSeg(Segs[s]);
        pAbs          := Max(Sel.First, Seg.First);
        RangeValid    := not Seg.RangeAt( pAbs, RFrom, RTo );
        while RangeValid and (RFrom.Point <= Sel.Last) do begin
          Slope       := (RTo.Value - RFrom.Value) * 1.0 / (RTo.Point - RFrom.Point);
          for pBuf := pAbs - Sel.First to Min(Sel.Last, RTo.Point) - Sel.First do begin
          // while pAbs <= RTo.Point do begin
            Data[pBuf{pAbs - Sel.First}] := Data[pBuf{pAbs - Sel.First}]
                                  + RFrom.Value + Round(Slope * (pAbs - RFrom.Point));
            Inc(pAbs);
          end;
          RangeValid  := not Seg.NextRange(RFrom, RTo);
        end;
      end;
    end;
  except
  end;

  for s := 0 to Segs.Count - 1 do begin
    TQUB_BaselineSeg(Segs[s]).Free;
  end;
  Segs.Free;
end;

procedure TQUB_QVO_QVD.prProcessDataForDisplay(const NewDraw, ProcSel :TQUB_FirstLast);
var
  ChannelIndex :Integer;
begin

  if prProcessingForDisplay then Exit;
  prProcessingForDisplay := True;
  try

    for ChannelIndex := 0 to QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1 do begin

      if ChannelIndex > (prDataChannelCount - 1) then begin
      //Deallocate

        if prDataChannelAllocated[ChannelIndex] then begin
          prDataChannelAlloc[ChannelIndex].First := 0;
          prDataChannelAlloc[ChannelIndex].Last  := 0;
          FreeMem(prDataChannelDisplay[ChannelIndex]);
          prDataChannelDisplay[ChannelIndex]     := nil;
          prDataChannelAllocated[ChannelIndex]   := False;
        end;

      end else begin

        //Process this channel ?
        if prDataChannelProcess[ChannelIndex] <> QUB_QVO_QVD_PROCESS_NONE then begin
        //Yes !

          if not prDataChannelAllocated[ChannelIndex] then begin
          //Data was not allocated yet - allocate it !

            prDataChannelAlloc[ChannelIndex].First := NewDraw.First - NewDraw.First;
            prDataChannelAlloc[ChannelIndex].Last  := NewDraw.Last  - NewDraw.First;
            prDataChannelDisplay[ChannelIndex]     := IAlloc1(prDataChannelAlloc[ChannelIndex].Last - prDataChannelAlloc[ChannelIndex].First + 1);
            prDataChannelAllocated[ChannelIndex]   := True;

          end else if (prDataChannelAlloc[ChannelIndex].Last - prDataChannelAlloc[ChannelIndex].First) < (NewDraw.Last - NewDraw.First) then begin
          //Data was allocated, but not enough - reallocate it !

            prDataChannelAlloc[ChannelIndex].First := NewDraw.First - NewDraw.First;
            prDataChannelAlloc[ChannelIndex].Last  := NewDraw.Last  - NewDraw.First;
            ReAllocMem(prDataChannelDisplay[ChannelIndex], SizeOf(Integer) * prDataChannelAlloc[ChannelIndex].Last - prDataChannelAlloc[ChannelIndex].First + 1);
            prDataChannelAllocated[ChannelIndex]   := True;

          end;

          //Now do the processing

          if (prDataChannelProcess[ChannelIndex] and QUB_QVO_QVD_PROCESS_GET_FILTER) <> 0 then begin
          //If FilterOn, then Do Filter, from SourceBuffer (Data) to DestBuffer (DataDisplay)

            if FilterMAOn[ChannelIndex] then begin

              prDoFilterMA(@prData[ChannelIndex, ProcSel.First - prDataCache.First], @prDataChannelDisplay[ChannelIndex][prDataChannelAlloc[ChannelIndex].First + (ProcSel.First - NewDraw.First)], ProcSel.Last - ProcSel.First + 1, prFilterMACount[ChannelIndex]);

            end else begin

              //Clear Dest_Data
              FillChar(prDataChannelDisplay[ChannelIndex][prDataChannelAlloc[ChannelIndex].First + (ProcSel.First - NewDraw.First)], SizeOf(Integer) * (ProcSel.Last - ProcSel.First + 1), 0);
              try
                DLLFilterIntData(@prData[ChannelIndex, ProcSel.First - prDataCache.First], @prDataChannelDisplay[ChannelIndex][prDataChannelAlloc[ChannelIndex].First + (ProcSel.First - NewDraw.First)], ProcSel.Last - ProcSel.First + 1,  Sampling, FilterFreq[ChannelIndex], 1024);
                prSegmentsCleanFilterBounds(TPAInteger(@prData[ChannelIndex, ProcSel.First - prDataCache.First]), TPAInteger(@prDataChannelDisplay[ChannelIndex][prDataChannelAlloc[ChannelIndex].First + (ProcSel.First - NewDraw.First)]), ProcSel, FilterFreq[ChannelIndex]);
                //prNewCleanFilterBounds(TPAInteger(@prData[ChannelIndex, ProcSel.First - prDataCache.First]), TPAInteger(@prDataChannelDisplay[ChannelIndex][prDataChannelAlloc[ChannelIndex].First + (ProcSel.First - NewDraw.First)]), ProcSel, FilterFreq[ChannelIndex]);
                //prCleanFilterBounds(FilterBuffer, Sel, ChannelIndex, FilterFreq);
              except
              end;

            end;

          end else begin
          //If FilterOff, then just move the data, from SourceBuffer (Data) to DestBuffer (DataDisplay)
          //So that it can be processed by the baseline and the other processors

            Move(prData[ChannelIndex, ProcSel.First - prDataCache.First], prDataChannelDisplay[ChannelIndex][prDataChannelAlloc[ChannelIndex].First + (ProcSel.First - NewDraw.First)], SizeOf(Integer) * (ProcSel.Last - ProcSel.First + 1));

          end;

          if (prDataChannelProcess[ChannelIndex] and QUB_QVO_QVD_PROCESS_GET_BASELINE) <> 0 then begin
          //If BaselineOn, then Do Baseline

            prDoBaseline(@prDataChannelDisplay[ChannelIndex][prDataChannelAlloc[ChannelIndex].First + (ProcSel.First - NewDraw.First)], ChannelIndex, ProcSel);

          end;

        end else begin
        //No, don't Process

          //FreeMem if necessary
          if prDataChannelAllocated[ChannelIndex] then begin
            FreeMem(prDataChannelDisplay[ChannelIndex]);
            prDataChannelDisplay[ChannelIndex]     := nil;
            prDataChannelAlloc[ChannelIndex].First := 0;
            prDataChannelAlloc[ChannelIndex].Last  := 0;
            prDataChannelAllocated[ChannelIndex]   := False;
          end;

          //Point Display to Data
          if prData <> nil then begin
            prDataChannelDisplay[ChannelIndex] := @prData[ChannelIndex, NewDraw.First - prDataCache.First];
          end else begin
            prDataChannelDisplay[ChannelIndex] := nil;
          end;
        end;

        if (prDataChannelDisplay[ChannelIndex] = nil) and (ChannelIndex < prDataChannelCount) then begin
          //Beep;
        end;


      end;//ChannelIndex < ChannelCount - 1

    end;//of ChannelIndex;

  finally

    prProcessingForDisplay := False;

  end;
end;

function TQUB_QVO_QVD.prDoFilterMA(Data, DataF :TPAInteger; DataCount :Integer; CoeffCount :Integer) :Boolean;
var
  FilterSum   :Integer;
  CoeffCount2 :Integer;
  p           :Integer;
begin
  Result := False;
  try

    //Filter data
    if CoeffCount < DataCount then begin

      CoeffCount2 := CoeffCount div 2 + 1;

      //Middle
      FilterSum := 0;
      for p := 0 to CoeffCount - 2 do begin
        Inc(FilterSum, Data[p]);
      end;
      for p := CoeffCount2 - 1 to DataCount - CoeffCount2 do begin
        Inc(FilterSum, Data[p + CoeffCount2 - 1]);
        DataF[p] := FilterSum div CoeffCount;
        Dec(FilterSum, Data[p - CoeffCount2 + 1]);
      end;
      //Start
      FilterSum := 0;
      for p := 0 to CoeffCount2 - 1 do begin
        Inc(FilterSum, Data[p]);
      end;
      for p := 0 to CoeffCount2 - 1 do begin
        DataF[p] := FilterSum div (CoeffCount2 + p);
        Inc(FilterSum, Data[p + CoeffCount2]);
      end;
      //End
      FilterSum := 0;
      for p := DataCount - 1 downto DataCount - CoeffCount2 do begin
        Inc(FilterSum, Data[p]);
      end;
      for p := DataCount - 1 downto DataCount - CoeffCount2 do begin
        DataF[p] := FilterSum div (CoeffCount2 + DataCount - p - 1);
        Inc(FilterSum, Data[p - CoeffCount2]);
      end;

    end;

  except
    Result := True;
  end;
end;

procedure TQUB_QVO_QVD.prGetYAvgMinMax(NewDraw :TQUB_FirstLast);
var
  Min  :Integer;
  Max  :Integer;
  Dat  :Integer;
  Any  :Boolean;
  c, i :Integer;
begin

  if prDataMeasured then Exit;

  for c := 0 to prDataChannelCount - 1 do begin

    Any := False;

    if (NewDraw.Last - NewDraw.First + 1) > 0 then begin

      if prDataChannelAllocated[c] then begin

        Min := prDataChannelDisplay[c][NewDraw.First - NewDraw.First];
        Max := prDataChannelDisplay[c][NewDraw.First - NewDraw.First];

        for i := NewDraw.First + 1 to NewDraw.Last do begin

          Dat := prDataChannelDisplay[c][i - NewDraw.First];
          if Dat < Min then Min := Dat;
          if Dat > Max then Max := Dat;

        end;//data

        Any := True;

      end else begin

        Min := prData[c][NewDraw.First - prDataCache.First];
        Max := prData[c][NewDraw.First - prDataCache.First];

        for i := NewDraw.First + 1 to NewDraw.Last do begin

          Dat := prData[c][i - prDataCache.First];
          if Dat < Min then Min := Dat;
          if Dat > Max then Max := Dat;

        end;//data

        Any := True

      end;

    end;

    if Any then begin
      if DataChannelScaling[c] > 0 then begin
        DataYMinAuto[c] := Min;
        DataYMaxAuto[c] := Max;
      end else begin
        DataYMinAuto[c] := Max;
        DataYMaxAuto[c] := Min;
      end;
    end;

    if c = (QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1) then Break;

  end;//channels

  prDataMeasured := True;

end;


//******************************************************************************
function TQUB_QVO_QVD.WhichTimeForPoint(p :Integer; Relative :Boolean = False): Double;
var
  s, off :Integer;
begin
  s := WhichSegmentForPoint(p);
  if (s < 0) or (s >= prDataSegmentCount) then begin
    Result := 0.0;
    Exit;
  end;

  if s = 0 then begin
    off := p;
  end else begin
    off := p - prDataBreakPoints[s-1];
  end;

  Result := DataObject.Segments[s].StartTime + off * Sampling;
  if Relative then Result := Result - DataObject.Segments[0].StartTime;
end;

function TQUB_QVO_QVD.WhichSegmentForPoint(p :Integer) :Integer;
var
  s :Integer;
begin

  if prDataPointCount = 0 then begin
    Result := 0;
    Exit;
  end;

  s := 0;
  repeat

    if p < prDataBreakPoints[s] then Break;

    Inc(s);

  until s = prDataSegmentCount;

  if s = prDataSegmentCount then begin
    Result := -1;
  end else begin
    Result := s;
  end;

end;

function TQUB_QVO_QVD.WhichPointForTrace(t :Integer) :Integer;
var
  s, f, tt, st :Integer;
begin

  Result := -1;

  if prDataPointCount = 0 then begin
    Result := 0;
    Exit;
  end;



  if (prTraceChangeOnBreak) and (prDataSegmentCount > 1) then begin

    s  := 0;//segment
    tt := 0;//trace
    f  := 0;//first point

    repeat

      st := prDataBreakPoints[s] - f;
      st := ((st - 1) div prPointsPerTrace);

      if (tt + st) >= t then begin

        tt := t - tt;//how many traces do we need
        Result := f + tt * prPointsPerTrace;
        Break;

      end else begin

        f := prDataBreakPoints[s];
        Inc(tt, st + 1);
        Inc(s);

      end;

    until (s = prDataSegmentCount);

  end else begin

    Result := t * prPointsPerTrace;
    if Result > prDataPoint.Last then begin
      Result := - 1;
    end;

  end;

end;


function TQUB_QVO_QVD.WhichPointForPage(p :Integer) :Integer;
begin

  Result := WhichPointForTrace(prTracesPerPage * p);

end;


function TQUB_QVO_QVD.WhichTraceforPoint(p :Integer) :Integer;
var
  s, ss, f, l, t, tt :Integer;
begin

  Result := -1;

  if prDataPointCount = 0 then begin
    Result := 0;
    Exit;
  end;

  if (p < prDataPoint.First) or (p > prDataPoint.Last) then begin
    Exit;
  end;

  if (prTraceChangeOnBreak) and (prDataSegmentCount > 1) then begin

    ss := WhichSegmentForPoint(p);
    s  := 0;
    tt := 0;

    repeat

      if s = 0 then begin
        f := 0;
      end else begin
        f := prDataBreakPoints[s - 1];
      end;
      l := prDataBreakPoints[s] - 1;

      if (p >= f) and (p <= l) then begin

        t := (p - f) div prPointsPerTrace + 1;
        Result := tt + t - 1;

      end else begin

        t := (l - f) div prPointsPerTrace + 1;
        Inc(tt, t);

      end;

      Inc(s);

    until (s > ss);

  end else begin

    Result := p div prPointsPerTrace;

  end;

end;


function TQUB_QVO_QVD.WhichPointForFirst(p :Integer) :Integer;
var
  s, o, t, tt, f :Integer;
begin
  Result := -1;

  if prDataPointCount = 0 then begin
    Result := p;
    Exit;
  end;

  if (prTraceChangeOnBreak) and (prDataSegmentCount > 1) then begin

    tt := 0;
    f := p;
    s := WhichSegmentForPoint(f);

    repeat

      //What is the leftover from the point in its segment ?
      o := prDataBreakPoints[s] - f;
      t := ((o - 1) div prPointsPerTrace) + 1;

      if (tt + t) >= prTracesPerPage then begin

        tt := prTracesPerPage - tt;

        Result := f + tt * prPointsPerTrace - 1;
        if Result > prDataPoint.Last then begin
          Result := prDataPoint.Last;
        end;
        if Result > (prDataBreakPoints[s] - 1) then begin
          Result := (prDataBreakPoints[s] - 1);
        end;

        Break;

      end else begin

        f := prDataBreakPoints[s] - 1;
        Inc(tt, t);
        Inc(s);
        if s < prDataSegmentCount then begin
          f := prDataBreakPoints[s - 1];
        end else begin
          Result := f;
        end;

      end;

    until(s = prDataSegmentCount);

  end else begin

    t := WhichTraceForPoint(p);
    t := WhichPointForTrace(t);
    t := t + prTracesPerPage * prPointsPerTrace - 1;
    if t > prDataPoint.Last then t := prDataPoint.Last;
    Result := t;

  end;

end;

{
This function returns the point which has to be displayed first,
so that the point p is _somewhere_ on the last displayed trace;
}
function TQUB_QVO_QVD.WhichPointForLast(p :Integer) :Integer;
var
  s, o, t, tt, f, st :Integer;
begin

  Result := -1;

  if prDataPointCount = 0 then begin
    Result := p;
    Exit;
  end;

  if (prTraceChangeOnBreak) and (prDataSegmentCount > 1) then begin

    t := 0;
    f := p;
    s := WhichSegmentForPoint(f);

    repeat

      //What is the offset of the point in its segment ?
      if s = 0 then begin
        o := f;
        f := 0;
      end else begin
        o := f - prDataBreakPoints[s - 1];
        f := prDataBreakPoints[s - 1];
      end;

      tt := (o div prPointsPerTrace) + 1;

      if (tt + t) >= prTracesPerPage then begin

        st := tt;
        tt := prTracesPerPage - t;
        Result := f + (st - tt) * prPointsPerTrace;
        if Result > prDataPoint.Last then begin
          Result := prDataPoint.Last;
        end;
        Break;

      end else begin

        Inc(t, tt);
        Dec(s);
        if s > -1 then begin
          Dec(f);
        end;

      end;

    until(s < 0);

  end else begin

    t := WhichTraceForPoint(p);
    t := WhichPointForTrace(t);
    t := t - (prTracesPerPage - 1) * prPointsPerTrace;
    if t < prDataPoint.First then t := prDataPoint.First;
    Result := t;

  end;

end;

function TQUB_QVO_QVD.WhichSegmentFirstForPoint(p :Integer) :Integer;
var
  s :Integer;
begin
  if prDataSegmentCount = 0 then begin
    Result := 0;
  end else begin
    s := WhichSegmentForPoint(p);
    if s = 0 then begin
      Result := 0;
    end else begin
      Result := prDataBreakPoints[s - 1];
    end;
  end;
end;

function TQUB_QVO_QVD.WhichSegmentLastForPoint(p :Integer) :Integer;
begin
  if prDataSegmentCount = 0 then begin
    Result := 0;
  end else begin
    Result := prDataBreakPoints[WhichSegmentForPoint(p)] - 1;
  end;
end;

function TQUB_QVO_QVD.WhichSegmentFirstForSegment(s :Integer) :Integer;
begin
  if prDataSegmentCount = 0 then begin
    Result := 0;
  end else begin
    if s = 0 then begin
      Result := 0;
    end else begin
      Result := prDataBreakPoints[s - 1];
    end;
  end;
end;

//****************************************************************************//
//                                                                            //
//                               P O I N T I N G                              //
//                                                                            //
//****************************************************************************//
function TQUB_QVO_QVD.prMouseOnPoint(const xyPoint :TPoint; var Point :Integer) :Boolean;
var
  p   :Integer;
  Cmd :TQUB_QVO_QVD_Command;
begin
  Result := False;

  p := prMouseToPoint(xyPoint, Cmd);

  if Cmd <> QUB_QVO_QVD_CMD_GOTO_POINT then Exit;
  if (p < prDataPoint.First) or (p > prDataPoint.Last) then Exit;

end;

function TQUB_QVO_QVD.prUpdatePointing :Boolean;
begin
  Result := False;
end;

function TQUB_QVO_QVD.prMouseToPoint(const p :TPoint; var MoveCmd :TQUB_QVO_QVD_Command) :Integer;
const
  MOVE_TRACE_REGION = 20;
var
  x, y       :Integer;
  t, o, b    :Integer;
  f, l, tt   :Integer;
begin

  if prDataPointCount = 0 then begin
    Result := 0;
    Exit;
  end;

  o := prDataDraw.First;

  //Find trace
  x := p.x;
  y := p.y;

  MoveCmd := QUB_QVO_QVD_CMD_GOTO_POINT;

  if prDrawListOverlapped then begin

    if x < prMargin.Left                   then x := prMargin.Left;
    if x > (Width  - prMargin.Right  - 1)  then x := (Width  - prMargin.Right  - 1);

    o := ((x - prMargin.Left) * (prPointsPerTrace - 1)) div (Width - prMargin.Left - prMargin.Right - 1);
    //o := o + prDataDraw.First;

  end else begin

    //PageUp
    if y < (prMargin.Top - MOVE_TRACE_REGION) then begin
      if prDataDraw.First > prDataPoint.First then begin
        MoveCmd := QUB_QVO_QVD_CMD_PAGE_UP;
      end;
    end else if (y >= (prMargin.Top - MOVE_TRACE_REGION)) and (y < prMargin.Top) then begin
      if prDataDraw.First > prDataPoint.First then begin
        MoveCmd := QUB_QVO_QVD_CMD_TRACE_UP;
      end;
    end else if (y > (Height - 1 - prMargin.Bottom)) and (y <= (Height - 1 - prMargin.Bottom + MOVE_TRACE_REGION)) then begin
      if prDataDraw.Last < prDataPoint.Last then begin
        MoveCmd := QUB_QVO_QVD_CMD_TRACE_DN;
      end;
    end else if y > (Height - 1 - prMargin.Bottom + MOVE_TRACE_REGION) then begin
      if prDataDraw.Last < prDataPoint.Last then begin
        MoveCmd := QUB_QVO_QVD_CMD_PAGE_DN;
      end;
    end;

    if y < prMargin.Top                    then y := prMargin.Top;
    if y > (Height - prMargin.Bottom - 1)  then y := (Height - prMargin.Bottom - 1);
    if x < prMargin.Left                   then x := prMargin.Left;
    if x > (Width  - prMargin.Right  - 1)  then x := (Width  - prMargin.Right  - 1);

    t := (y - prMargin.Top) div Round(((Height - prMargin.Top - prMargin.Bottom - 1) / prTracesPerPage)) + 1;

    if t < 1 then t := 1;
    if t > prTracesPerPage then t := prTracesPerPage;

    if (prTraceChangeOnBreak) and (prDataSegmentCount > 1) then begin
    //if Traces break on breakpoints, adjust the point by subtracting what each trace does NOT display

      b := WhichSegmentForPoint(prDataDraw.First);
      f := prDataDraw.First;
      l := f + prPointsPerTrace - 1;
      if l > prDataDraw.Last then begin
        l := prDataDraw.Last;
      end;

      for tt := 1 to prTracesPerPage do begin

        if prDataBreakPoints[b] <= l then begin
        //A breakpoint occurs here
          l := prDataBreakPoints[b] - 1;
          Inc(b);
        end;

        if tt = t then begin
        //If this is the hit trace

          o := ((x - prMargin.Left) * (prPointsPerTrace - 1)) div (Width - prMargin.Left - prMargin.Right - 1);

          o := f + o;
          if o > l then o := l;

          Break;

        end else begin

          f := l + 1;
          l := f + prPointsPerTrace - 1;
          if f > prDataDraw.Last then begin
            f := prDataDraw.Last;
          end;
          if l > prDataDraw.Last then begin
            l := prDataDraw.Last;
          end;

          if f = prDataBreakPoints[b] then begin
          //A breakpoint on the last point
            Inc(b);
          end;

        end;

      end;

    end else begin

      o := ((x - prMargin.Left) * (prPointsPerTrace - 1)) div (Width - prMargin.Left - prMargin.Right - 1);
      o := (t - 1)*prPointsPerTrace + o + prDataDraw.First;

    end;

    if o > prDataDraw.Last  then o := prDataDraw.Last;
    if o < prDataDraw.First then o := prDataDraw.First;

  end;//DrawListOverlapped

  Result := o;

end;


//****************************************************************************//
//                                                                            //
//                           D A T A    R E S E T                             //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVD.prResetData;
var
  i :Integer;
begin

  //Clear SelectionList
  prResultsList.Clear;
  prSelectionLists.Clear;

  prDataMeasured                               := False;

  prDataSegmentCount                           := 0;
  prDataChannelCount                           := 0;
  prDataPointCount                             := 0;

  Free2(TPMChar(prData));
  prData                                       := nil;
  prDataAllocCount                             := 0;
  
  FreeMem(prDataBreakPoints);
  prDataBreakPoints                            := nil;

  for i := 0 to QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1 do begin

    prBaselineNodes[i].Free;
    prBaselineNodes[i] := nil;
    prDataBaseLine[i] := 0;

  end;

  prDeleteAllMarkers;
  prDeleteAllTimeMarkers;
  prDeleteAllKinParamsMarkers;

  prDataPoint.First                            := 0;
  prDataPoint.Last                             := 0;

  prDataCache.First                            := 0;
  prDataCache.Last                             := 0;

  prDataDraw.First                             := 0;
  prDataDraw.Last                              := 0;

  prDataWindow.First                           := 0;
  prDataWindow.Last                            := 0;

  prDataSel.First                              := 0;
  prDataSel.Last                               := 0;

  prDataBaselineSel.First                      := 0;
  prDataBaselineSel.Last                       := 0;

  prDataEraseSel.First                         := 0;
  prDataEraseSel.Last                          := 0;

  prDataZoomSel.First                          := 0;
  prDataZoomSel.Last                           := 0;
  prDataZoomCurr                               := 0;

  //Reset Process Data
  for i := 0 to QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1 do begin
    if prDataChannelAllocated[i] then begin
      prDataChannelAlloc[i].First := 0;
      prDataChannelAlloc[i].Last  := 0;
      FreeMem(prDataChannelDisplay[i]);
      prDataChannelDisplay[i] := nil;
      prDataChannelAllocated[i] := False;
    end else begin
      prDataChannelDisplay[i] := nil;
    end;
  end;

end;

procedure TQUB_QVO_QVD.prDeleteAllMarkers;
begin
  prDataMarker               := -1;
  FreeMem(prDataMarkers);
  prDataMarkers              := nil;
  FreeMem(prDataMarkersCh);
  prDataMarkersCh            := nil;
  prDataMarkersCount         := 0;
end;

procedure TQUB_QVO_QVD.prDeleteAllTimeMarkers;
begin
  prDataTimeMarker           := -1;
  FreeMem(prDataTimeMarkers);
  prDataTimeMarkers          := nil;
  prDataTimeMarkersCount     := 0;
end;

procedure TQUB_QVO_QVD.prDeleteAllKinParamsMarkers;
begin
  prDataKinParamsMarker       := -1;
  FreeMem(prDataKinParamsMarkers);
  prDataKinParamsMarkers      := nil;
  SetLength(prDataKinParamsMarkersPars, 0);
  SetLength(prDataKinParamsMarkersNote, 0);
  prDataKinParamsMarkersCount := 0;
end;



//****************************************************************************//
//                                                                            //
//                          D A T A    E V E N T S                            //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVD.DoOnFileOpen(Sender :TObject);
begin
  prResetData;

  prRecountData;

  ActiveChannel := 0;

  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA or DATA_MSG_SET_SCROLL, 0);

end;

procedure TQUB_QVO_QVD.DoOnFileClose(Sender :TObject);
begin
  prResetData;

  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA or DATA_MSG_SET_SCROLL, 0);
end;


procedure TQUB_QVO_QVD.DataMessage(WParam :WPARAM; LParam :LPARAM);
begin

  if (not LockedRecord) and (0 = (WParam and DATA_MSG_NOT_BENIGN_FOR_ACC)) then begin
    prDataMsgCritSection.Acquire;
    prDataMsgAccWParam := prDataMsgAccWParam or WParam;
    WParam := DATA_MSG_USE_ACC;
    prDataMsgCritSection.Release;
  end;

  if Self.HandleAllocated then PostMessage(
              Self.Handle,
              WM_QUB_DATAMESSAGE,
              WParam,
              LParam
   );

end;

procedure TQUB_QVO_QVD.RefreshLists;
var
  s :Integer;
begin
  if (prDrawListOverLapped) or (prDrawSelList) then begin
    if prDrawListOverlapped then begin
      if CurrList <> nil then begin
        if CurrList.Items.Count > 0 then begin
          s := CurrList.Selection[0].Sel.First;
          if s < prDataPoint.First then s := prDataPoint.First;
          if s > prDataPoint.Last  then s := prDataPoint.First;
          DataMessage(DATA_MSG_BROWSE or DATA_MSG_BROWSE_TO_P or DATA_MSG_READ_CACHE or DATA_MSG_PROC_DATA or DATA_MSG_DRAW_DATA or DATA_MSG_SET_SCROLL, s);
        end;
      end;
    end else begin
      DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA{ or DATA_MSG_PROC_DATA}, 0);
    end;
  end;
end;

procedure TQUB_QVO_QVD.prAdjustListsOnDelete(Sel :TQUB_FirstLast);
var
  List    :TQUB_QVO_QVD_SelectionList;
  ThisSel :TQUB_FirstLast;
  Count   :Integer;
  l, s    :Integer;
begin

  Count := Sel.Last - Sel.First + 1;

  for l := 0 to prSelectionLists.Items.Count - 1 do begin
    List := prSelectionLists.List[l];
    for s := List.Items.Count - 1 downto 0 do begin
      ThisSel := List.Selection[s].Sel;
      if ((Sel.First >= ThisSel.First) and (Sel.First <= ThisSel.Last)) or ((Sel.Last >= ThisSel.First) and (Sel.Last <= ThisSel.Last))  then begin
      //if ThisSel contains some of what's deleted, then delete it (could refine this, but I don't have time now)
        List.DelSelection(s);
      end else if Sel.Last < ThisSel.First then begin
        Dec(ThisSel.First, Count);
        Dec(ThisSel.Last,  Count);
        List.Selection[s].Sel := ThisSel;
      end;
    end;
  end;
end;

{
    This procedure composes and sends a DataMessage
}
procedure TQUB_QVO_QVD.DoOnFileEdit(Sender :TObject; EditOper :TQUB_EditOperation; var Param; var Param2);
var
  WParam   :LongInt;
  LParam   :LongInt;
  SendMsg  :Boolean;
  c        :Integer;
  UndoInfo :INode;
  UndoChan :INode;
begin

  SendMsg := False;

  WParam  := DATA_MSG_DATA_EDIT;
  LParam  := -1;//Used for Browsing new position. If -1 then keep current. Scrolling should set it

  case EditOper of

    EDIT_OPER_CUT, EDIT_OPER_PASTE, EDIT_OPER_DELETE:

      begin

        SendMsg := True;
        WParam  := WParam or DATA_MSG_RECOUNT_DATA or DATA_MSG_BROWSE or DATA_MSG_SET_SCROLL;
        if TQUB_FirstLast(Param).First <= prDataCache.Last then WParam := WParam or DATA_MSG_READ_CACHE or DATA_MSG_PROC_DATA or DATA_MSG_DRAW_DATA;

        //TO DO: I added this, but it needs UNDO. LM
        if EditOper = EDIT_OPER_DELETE then begin
          prAdjustListsOnDelete(TQUB_FirstLast(Param));
        end;

      end;

    EDIT_OPER_CLEAR, EDIT_OPER_UNDO, EDIT_OPER_UPDATE:
      begin

        SendMsg := True;
        WParam  := WParam or DATA_MSG_RECOUNT_DATA or DATA_MSG_BROWSE    or DATA_MSG_SET_SCROLL or
                             DATA_MSG_READ_CACHE   or DATA_MSG_PROC_DATA or DATA_MSG_DRAW_DATA;

      end;

    EDIT_OPER_BREAK:
      begin

        SendMsg := True;
        WParam  := WParam or DATA_MSG_RECOUNT_DATA or DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_SET_SCROLL;

        for c := 0 to prDataChannelCount - 1 do begin
          BaselineNodes[c].BreakSegment( TQUB_FirstLast(Param).First );
        end;
      end;

    EDIT_OPER_ERASE, EDIT_OPER_FILL, EDIT_OPER_EDITPOINT:
      begin

        if TQUB_FirstLast(Param).First <= prDataCache.Last then begin
          SendMsg := True;
          WParam  := WParam or DATA_MSG_BROWSE or DATA_MSG_READ_CACHE or DATA_MSG_PROC_DATA or DATA_MSG_DRAW_DATA or DATA_MSG_SET_SCROLL;
        end;

      end;

    EDIT_OPER_APPEND:
      begin

        SendMsg := True;
        WParam  := WParam or DATA_MSG_RECOUNT_DATA or DATA_MSG_BROWSE      or DATA_MSG_READ_CACHE   or
                             DATA_MSG_DRAW_DATA    or DATA_MSG_PROC_DATA   or DATA_MSG_SET_SCROLL   or
                             DATA_MSG_DATA_APPEND;
        if {(LockedRecord) and} (AutoScroll) then begin
        //so it scrolls when data is streamed in from a simulation
          WParam  := WParam or DATA_MSG_SCROLLINVIEW;
        end;

      end;

    EDIT_OPER_INSERT_SEG:
      begin
        UndoInfo  := TNode.CreateUsing( TQUB_QFS_PNodeMem(Param2) );
        UndoChan  := UndoInfo.Find('BaselineSegments');
        for c := 0 to prDataChannelCount - 1 do begin
          BaselineNodes[c].InsertSegment( TQUB_FirstLast(Param).First, TQUB_FirstLast(Param).Last );
          if not UndoChan.IsNull then BaselineNodes[c].AddNodes( UndoChan );
          UndoChan := UndoChan.SiblingSameName;
        end;
      end;

    EDIT_OPER_INSERT_INTOSEG:
      begin
        UndoInfo  := TNode.CreateUsing( TQUB_QFS_PNodeMem(Param2) );
        UndoChan  := UndoInfo.Find('BaselineSegments');
        for c := 0 to prDataChannelCount - 1 do begin
          BaselineNodes[c].InsertPoints( TQUB_FirstLast(Param).First, (TQUB_FirstLast(Param).Last - TQUB_FirstLast(Param).First + 1) );
          if not UndoChan.IsNull then BaselineNodes[c].AddNodes( UndoChan );
          UndoChan := UndoChan.SiblingSameName;
        end;
      end;

    EDIT_OPER_DEL_SEG:
      begin
        UndoInfo  := TNode.CreateUsing( TQUB_QFS_PNodeMem(Param2) );
        for c := 0 to prDataChannelCount - 1 do begin
          if not UndoInfo.IsNull then UndoInfo.AppendChild( BaselineNodes[c].GetNodes( TQUB_FirstLast(Param).First, TQUB_FirstLast(Param).Last ) );
          BaselineNodes[c].DeleteData( TQUB_FirstLast(Param).First, TQUB_FirstLast(Param).Last );
        end;
      end;

    EDIT_OPER_DEL_SEL:
      begin
        UndoInfo  := TNode.CreateUsing( TQUB_QFS_PNodeMem(Param2) );
        for c := 0 to prDataChannelCount - 1 do begin
          if not UndoInfo.IsNull then UndoInfo.AppendChild( BaselineNodes[c].GetNodes( TQUB_FirstLast(Param).First, TQUB_FirstLast(Param).Last ) );
          BaselineNodes[c].DeleteData( TQUB_FirstLast(Param).First, TQUB_FirstLast(Param).Last );
        end;
      end;

    //EDIT_OPER_BREAK:
      //begin
        // see above
      //end;

    EDIT_OPER_JOIN:
      begin
        for c := 0 to prDataChannelCount - 1 do begin
          BaselineNodes[c].JoinSegments( TQUB_FirstLast(Param).First );
        end;
     end;

  end;//EditOper


  if SendMsg then begin

    DataMessage(WParam, LParam);

  end;

end;

procedure TQUB_QVO_QVD.DoOnFileInfoEdit(Sender :TObject; EditOper :TQUB_EditOperation; var Param; var Param2); // on idealization change
begin

  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_DATA_EDIT, 0);

end;

procedure TQUB_QVO_QVD.DoOnFitCurvesChanged(Sender :TObject);
begin

  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA{ or DATA_MSG_PROC_DATA}, 0);
  // prZoom.DoOnFitCurvesChanged(Sender);

end;


procedure TQUB_QVO_QVD.DoOnAddSeries(Sender :TObject; const SeriesName :String; Private :Boolean);
var
  List :TQUB_QVO_QVD_SelectionList;
begin

  List := AddList(SeriesName);
  if (List <> nil) and (Private) then begin
    List.Private := True;
    List.Lock;
  end;

end;

procedure TQUB_QVO_QVD.DoOnAddSweep(Sender :TObject; const SeriesName, SweepName :String; const Sel :TQUB_FirstLast; ForceAdd :Boolean);
begin

  AddSelection(SeriesName, SweepName, Sel, ForceAdd);

end;


//****************************************************************************//
//                                                                            //
//               D A T A   M E S S A G E    P R O C E S S O R                 //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVD.DoOnDataMessage(var Message: TMessage);
var
  RecntData    :Boolean;
  ReadCache    :Boolean;
  DrawData     :Boolean;
  ProcData     :Boolean;
  SetScroll    :Boolean;
  CondBrowse   :Boolean;
  BrowseData   :Boolean;
  BrowseToP    :Boolean;
  BrowseToT    :Boolean;
  BrowseCmd    :Boolean;
  DataEdit     :Boolean;
  DataAppend   :Boolean;
  ScrollInView :Boolean;
  DrawOnly     :TQUB_FirstLast;
  Cmd          :TQUB_QVO_QVD_Command;
  w, l         :LongInt;
  p, c1, c2    :Integer;
  t1, t2       :Integer;
begin

  if prDataMessaging then begin
    prDataMessageSendAgain := True;
    prDataMsgLastWParam    := Message.WParam;//(prDataMsgLastWParam or Message.WParam) and (not DATA_MSG_COND_BROWSE);
    prDataMsgLastLParam    := Message.LParam;
    Exit;
  end;

  try

    prDataMsgCritSection.Acquire;

    if Message.WParam = DATA_MSG_USE_ACC then begin
      Message.WParam     := prDataMsgAccWParam;
      prDataMsgAccWParam := 0;
    end;

  finally

    prDataMsgCritSection.Release;

  end;

  try

    prDataMessaging  := True;

    DataEdit         := False;
    DataAppend       := False;
    BrowseData       := False;
    Cmd              := QUB_QVO_QVD_CMD_GOTO_POINT;
    c1               := DataDraw.Last;

    try

      try

        RecntData    := (Message.WParam and DATA_MSG_RECOUNT_DATA) = DATA_MSG_RECOUNT_DATA;
        ReadCache    := (Message.WParam and DATA_MSG_READ_CACHE)   = DATA_MSG_READ_CACHE;
        DrawData     := (Message.WParam and DATA_MSG_DRAW_DATA)    = DATA_MSG_DRAW_DATA;
        ProcData     := (Message.WParam and DATA_MSG_PROC_DATA)    = DATA_MSG_PROC_DATA;
        SetScroll    := (Message.WParam and DATA_MSG_SET_SCROLL)   = DATA_MSG_SET_SCROLL;
        BrowseData   := (Message.WParam and DATA_MSG_BROWSE)       = DATA_MSG_BROWSE;
        CondBrowse   := (Message.WParam and DATA_MSG_COND_BROWSE)  = DATA_MSG_COND_BROWSE;
        BrowseToP    := (Message.WParam and DATA_MSG_BROWSE_TO_P)  = DATA_MSG_BROWSE_TO_P;
        BrowseToT    := (Message.WParam and DATA_MSG_BROWSE_TO_T)  = DATA_MSG_BROWSE_TO_T;
        BrowseCmd    := (Message.WParam and DATA_MSG_BROWSE_CMD)   = DATA_MSG_BROWSE_CMD;
        DataEdit     := (Message.WParam and DATA_MSG_DATA_EDIT)    = DATA_MSG_DATA_EDIT;
        DataAppend   := (Message.WParam and DATA_MSG_DATA_APPEND)  = DATA_MSG_DATA_APPEND;
        ScrollInView := (Message.WParam and DATA_MSG_SCROLLINVIEW) = DATA_MSG_SCROLLINVIEW;

        prDataMeasured := (DataEdit) or (RecntData);

        if BrowseToP then begin
          p := Message.LParam;
        end else if BrowseToT then begin
          p := Message.LParam;
        end else begin
          p := DataDraw.First;
          BrowseToP := True;
        end;

        if BrowseCmd then begin
          Cmd := TQUB_QVO_QVD_Command(Message.LParam);
        end;

        //Recount Data
        if RecntData then begin
          DrawOnly.First := prDataPointCount;
          prRecountData;
          DrawOnly.Last  := prDataPointCount - 1;
        end;

        //ScrollInView
        if ScrollInView then begin
          t1 := WhichTraceForPoint(prDataDraw.First);
          t2 := WhichTraceForPoint(prDataPointCount - 1);
          if t2 > (t1 + prTracesPerPage - 1) then begin
            p := WhichPointForTrace(t2);
            BrowseToP  := True;
          end else begin
            ScrollInView := False;
          end;
        end;

        //Cond Browse
        if CondBrowse then begin
          c2 := WhichPointForFirst(DataDraw.First);
          if c2 > c1 then BrowseData := True else BrowseData := False;
        end;

        //Append
        if (DataAppend) and (BrowseData) and (not ScrollInView) then begin
          prWindowDrawMode := True;
          prDataWindow     := DrawOnly;
        end else begin
          //Beep;
        end;

        //Browse
        if BrowseData then begin
          if BrowseCmd then begin
            Browse(Cmd,                        p, p, DrawData, SetScroll, ProcData, ReadCache, DataAppend, True{SetZoom});
          end else if BrowseToP then begin
            Browse(QUB_QVO_QVD_CMD_GOTO_POINT, p, p, DrawData, SetScroll, ProcData, ReadCache, DataAppend, True{SetZoom});
          end else if BrowseToT then begin
            Browse(QUB_QVO_QVD_CMD_GOTO_TRACE, p, p, DrawData, SetScroll, ProcData, ReadCache, DataAppend, True{SetZoom});
          end;
        end else if SetScroll then begin
          Browse(QUB_QVO_QVD_CMD_GOTO_POINT,   p, p, False{DrawData}, SetScroll, False{ProcData}, False{ReadCache}, DataAppend, False{SetZoom});
        end;


      finally


        //Append
        if (DataAppend) and (BrowseData) then begin
          prWindowDrawMode := False;
        end;

        if DataEdit then DoOnEdit;

        if prDataMessageSendAgain then begin
          prDataMessageSendAgain := False;
          w := prDataMsgLastWParam;
          l := prDataMsgLastLParam;
          prDataMsgLastWParam := 0;
          prDataMsgLastLParam := 0;
          if not DataAppend then DataMessage(w, l);
        end;


      end;

    except

      //Beep;

    end;

  finally

    prDataMessaging := False;

  end;
end;

procedure TQUB_QVO_QVD.prRecountData;
var
  p, c, s :Integer;
begin

  Scaling  := prDataObject.Scaling;
  Sampling := prDataObject.Sampling;

  prDataSegmentCount := prDataObject.Segments.SegmentCount;
  prDataChannelCount := prDataObject.ADChannelCount;

  prDataPointCount   := prDataObject.Segments.TotalDataCount;
  prDataPoint.First  := 0;
  prDataPoint.Last   := prDataPointCount - 1;

  if prDataSegmentCount > 0 then begin
    ReAllocMem(prDataBreakPoints, SizeOf(Integer) * prDataSegmentCount);
    p := 0;
    for s := 0 to prDataSegmentCount - 1 do begin
      c := prDataObject.Segments[s].Channels.DataCount;
      prDataBreakPoints[s] := p + c;
      Inc(p, c);
    end;
  end;

  prDataMeasured := False;

  if prDataSegmentCount > 0 then begin
    for c := 0 to prDataChannelCount - 1 do begin
      if BaselineNodes[c] = nil then begin
        prBaselineNodes[c] := TQUB_Baseline.Create;
        prBaselineNodes[c].AddSeg(0, prDataBreakPoints[0] - 1);
        for s := 1 to prDataSegmentCount - 1 do begin
          prBaselineNodes[c].AddSeg(prDataBreakPoints[s-1], prDataBreakPoints[s] - 1);
        end;
      end;
    end;
  end;

end;


procedure TQUB_QVO_QVD.DoOnExpCondChanged(Sender :TObject);
var
  Par            :TQUB_ExpCond_PParameter;
begin
  Par            := ExpCond.ParameterByName['DeadTime'];
  if Par <> nil then begin
    DisplayProperties['DefDeadTime'].Data[0] := Par.Value;
  end;
end;


//****************************************************************************//
//                                                                            //
//                             P R O P E R T I E S                            //
//                                                                            //
//****************************************************************************//
function TQUB_QVO_QVD.Properties :Boolean;
begin
  prPropertiesForm.OnGetProperties          := prOnGetProperties;
  prPropertiesForm.OnPutProperties          := prOnPutProperties;
  //prPropertiesForm.OnResetProperties        := prOnResetProperties;
  //prPropertiesForm.OnSetAsDefaultProperties := prOnSetAsDefaultProperties;
  prPropertiesForm.ADChannelCount           := DataObject.ADChannelCount;
  prPropertiesForm.ChannelIndex             := ActiveChannel;

  prPropertiesForm.ShowModal;
  Result := prPropertiesForm.ModalResult <> mrOK;
end;

procedure TQUB_QVO_QVD.prOnProperties(Sender :TObject);
begin
  Properties;
end;

procedure TQUB_QVO_QVD.prOnGetProperties(Sender :TObject);
var
  i :Integer;
begin
  with Sender as TQUB_QVO_QVD_XPropertiesForm do begin
    try

      for i := 0 to DataObject.ADChannelCount - 1 do begin
        Self.DataYMin[i]                   := DataYMin[i];
        Self.DataYMax[i]                   := DataYMax[i];
        Self.DataYFactor[i]                := DataYFactor[i];
        Self.DrawItoG[i]                   := DrawItoG[i];
        Self.DataChannelName[i]            := DataChannelName[i];
        Self.DataChannelUnits[i]           := DataChannelUnits[i];
        if (DataChannelScaling[i] <> Self.DataChannelScaling[i])
        or (DataChannelOffset[i]  <> Self.DataChannelOffset[i]) then begin
          if mrYes = MessageHelpDlg('If you change scaling or offset, it will delete any idealization.'#13#10'Change it anyway?',
                                    mtWarning, [mbYes, mbNo], 0, 'Warning:ChangeScaling') then begin
            DataObject.Idealization[i].Clear;
            Self.DataChannelScaling[i]     := DataChannelScaling[i];
            Self.DataChannelOffset[i]     := DataChannelOffset[i];
          end;
        end;
        Self.YAxisTickCount[i]             := YAxisTickCount[i];
      end;
      if Scaling <> Self.Scaling then begin
        if mrYes = MessageHelpDlg('If you change scaling it will delete any idealization.'#13#10'Change it anyway?',
                                  mtWarning, [mbYes, mbNo], 0, 'Warning:ChangeScaling') then begin
          Self.Scaling                     := Scaling;
          for i := 0 to DataObject.ADChannelCount - 1 do begin
            DataObject.Idealization[i].Clear;
          end;
        end;
      end;
      Self.XAxisTickCount                  := XAxisTickCount;
      Self.Scaling                         := Scaling;
      Self.Sampling                        := 1 / (Sampling * 1e3);

      Self.ExpCond.Clear;
      Self.ExpCond.ReadTree(ExpCond);

    finally

      DoOnEdit; // so vp_data_shortcuts can update properties
      if pagControl.ActivePage = tabDisplay then begin
        DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA or DATA_MSG_SET_SCROLL, 0);
      end else begin
        DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA, 0);
      end;
    end;
  end;//with
end;

procedure TQUB_QVO_QVD.prOnPutProperties(Sender :TObject);
var
  i :Integer;
begin
  with Sender as TQUB_QVO_QVD_XPropertiesForm do begin
    Data                            := Self;
    for i := 0 to DataObject.ADChannelCount - 1 do begin
      DataYMin[i]                   := Self.DataYMin[i];
      DataYMax[i]                   := Self.DataYMax[i];
      DataYFactor[i]                := Self.DataYFactor[i];
      DrawItoG[i]                   := Self.DrawItoG[i];
      DataChannelName[i]            := Self.DataChannelName[i];
      DataChannelUnits[i]           := Self.DataChannelUnits[i];
      DataChannelScaling[i]         := Self.DataChannelScaling[i];
      DataChannelOffset[i]          := Self.DataChannelOffset[i];
      YAxisTickCount[i]             := Self.YAxisTickCount[i];
    end;
    XAxisTickCount                  := Self.XAxisTickCount;
    Scaling                         := Self.Scaling;
    Sampling                        := (1 / Self.Sampling) * 1e-3;

    ExpCond                         := Self.ExpCond.ToTree;
  end;//with
end;

procedure TQUB_QVO_QVD.prOnResetProperties(Sender :TObject);
begin
  with Sender as TQUB_QVO_QVD_XPropertiesForm do begin
    try

      prPropertiesRegistry(True{Read});

    finally

      DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA or DATA_MSG_SET_SCROLL, 0);

    end;
  end;//with
end;

procedure TQUB_QVO_QVD.prOnSetAsDefaultProperties(Sender :TObject);
begin
  prPropertiesRegistry(False{Write});
end;


//Curve Fitting (Zoom) ---------------------------------------------------------
procedure TQUB_QVO_QVD.prOnCurveFit(Sender :TObject);
begin
  prZoom.ShowFitDlog;
end;

procedure TQUB_QVO_QVD.prOnCopyFit(Sender :TObject);
begin
  prZoom.CopyFit; //Copy FitCurve to Clipboard
end;

procedure TQUB_QVO_QVD.prOnDelFit(Sender :TObject);
begin
  prZoom.DelFit; // does FitCurves.Clear and also deletes fitting dialog if any
end;


//Edit Events ------------------------------------------------------------------
function TQUB_QVO_QVD.prConfirmSelListInvalidate: Boolean;
begin
  Result := True;
  if prSelectionLists.Items.Count > 0 then begin
    if mrCancel = MessageDlg('This will invalidate your selection lists.  Continue anyway?', mtWarning, mbOKCancel, 0)
    then Result := False;
  end;
end;

function TQUB_QVO_QVD.prConfirmDataCorruption: Boolean;
begin
  Result := True;
  if mrCancel = MessageDlg('This command is a known cause of data corruption.  If you must use it,'#13#10'make sure to Extract the file (to create a new, uncorrupted file) when you are done.'#13#10'Continue anyway?', mtWarning, mbOKCancel, 0)
  then Result := False;
end;

procedure TQUB_QVO_QVD.prOnCut(Sender :TObject);
var
  Sel :TQUB_FirstLast;
begin
  if Sender <> nil then begin
    Sender := prPopUpMenu.PopUpComponent;
  end;
  if not prConfirmDataCorruption then Exit;
  prGetSelection(Sel, Sender, prForSegment);
  prDataObject.CutSelection(Sel.First, Sel.Last, prCopyASCII);
end;

procedure TQUB_QVO_QVD.prOnCopy(Sender :TObject);
var
  Sel :TQUB_FirstLast;
begin
  Screen.Cursor := crHourglass;
  try
    if Sender <> nil then begin
      Sender := prPopUpMenu.PopUpComponent;
    end;
    prGetSelection(Sel, Sender, prForSegment);
    prDataObject.CopySelection(Sel.First, Sel.Last, prCopyASCII);
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TQUB_QVO_QVD.prOnCopyList(Sender :TObject);
begin
  Screen.Cursor := crHourglass;
  try
    prDataObject.CopyList(CurrList, CurrListName, prCopyASCII);
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TQUB_QVO_QVD.prOnCopyHint(Sender :TObject);
var
  Text   :String;
begin
  Text   := prMenuCaller.Hint + #13#10;
  Clipboard.SetTextBuf(PChar(Text));
end;

procedure TQUB_QVO_QVD.prOnCopyImage(Sender :TObject);
begin
  CopyImage(True);
end;

procedure TQUB_QVO_QVD.prOnPaste(Sender :TObject);
var
  Sel :TQUB_FirstLast;
begin
  if Sender <> nil then begin
    Sender := prPopUpMenu.PopUpComponent;
  end;
  if not prConfirmSelListInvalidate then Exit;
  prGetSelection(Sel, Sender, False);
  if prForSegment then begin
    prDataObject.PasteSegment(Sel.First, Sel.Last);
  end else begin
    prDataObject.PasteSelection(Sel.First, Sel.Last);
  end;
end;

procedure TQUB_QVO_QVD.prOnAppend(Sender :TObject);
begin
  prDataObject.Append;
end;

procedure TQUB_QVO_QVD.prOnDelete(Sender :TObject);
var
  Sel :TQUB_FirstLast;
begin
  if Sender <> nil then begin
    Sender := prPopUpMenu.PopUpComponent;
  end;
  if not prConfirmDataCorruption then Exit;
  prGetSelection(Sel, Sender, prForSegment);
  prDataObject.DeleteSelection(Sel.First, Sel.Last);
end;

procedure TQUB_QVO_QVD.prOnErase(Sender :TObject);
var
  Sel :TQUB_FirstLast;
begin
  if Sender <> nil then begin
    Sender := prPopUpMenu.PopUpComponent;
  end;
  if DataEraseSel.First = DataEraseSel.Last then Exit;
  prGetSelection(Sel, Sender, False{ForSegment});
  prDataObject.EraseSelection(Sel.First, Sel.Last, DataEraseSel.First, DataEraseSel.Last);
end;

procedure TQUB_QVO_QVD.prOnFill(Sender :TObject);
var
  Sel      :TQUB_FirstLast;
  Val      :Variant;
  Txt      :String;

  List     :TQUB_QVO_QVD_SelectionList;
  LSel     :TQUB_QVO_QVD_Selection;
  First    :Integer;
  Last     :Integer;
  l        :Integer;
begin
  Txt := '0';
  if not InputQuery('Input the fill-in value:', 'Value:', Txt) then Exit;
  if Sender <> nil then begin
    Sender := prPopUpMenu.PopUpComponent;
  end;
  try
    Val := (StrToFloat(Txt) - DataChannelOffset[ActiveChannel])
           * Scaling * DataChannelScaling[ActiveChannel];
  except
    Exit;
  end;

  if DrawListOverlapped then begin
  //DrawListOverlapped

    List   := CurrList;
    if List <> nil then begin
      for l := 0 to List.Items.Count - 1 do begin
        if List.Selected[l] then begin
          LSel := List[l];
          if (Sender = prPopUpMenu.PopUpComponent) then begin
            First := LSel.Sel.First + prDataSel.First + prDataZoomSel.First;
            Last  := LSel.Sel.First + prDataSel.First + prDataZoomSel.Last;
          end else begin
            First := LSel.Sel.First + prDataSel.First;
            Last  := LSel.Sel.First + prDataSel.Last;
          end;
          prDataObject.FillSelection(First, Last, ActiveChannel, Val);
        end;
      end;
    end;

  end else begin

    prGetSelection(Sel, Sender, False{ForSegment});
    prDataObject.FillSelection(Sel.First, Sel.Last, ActiveChannel, Val);
  end;
end;

procedure TQUB_QVO_QVD.prOnFillIdl(Sender :TObject);
var
  Sel      :TQUB_FirstLast;
  Cls      :Integer;
  Txt      :String;

  List     :TQUB_QVO_QVD_SelectionList;
  LSel     :TQUB_QVO_QVD_Selection;
  First    :Integer;
  Last     :Integer;
  l        :Integer;
begin
  Txt := '0';
  if not InputQuery('Input the fill-in value:', 'Value:', Txt) then Exit;
  if Sender <> nil then begin
    Sender := prPopUpMenu.PopUpComponent;
  end;
  try
    Cls := StrToInt(Txt);
  except
    Exit;
  end;

  if DrawListOverlapped then begin
  //DrawListOverlapped

    List   := CurrList;
    if List <> nil then begin
      for l := 0 to List.Items.Count - 1 do begin
        if List.Selected[l] then begin
          LSel := List[l];
          if (Sender = prPopUpMenu.PopUpComponent) then begin
            First := LSel.Sel.First + prDataSel.First + prDataZoomSel.First;
            Last  := LSel.Sel.First + prDataSel.First + prDataZoomSel.Last;
          end else begin
            First := LSel.Sel.First + prDataSel.First;
            Last  := LSel.Sel.First + prDataSel.Last;
          end;
          prDataObject.Idealization[ActiveChannel].SetDwell(First, Last, Cls);
        end;
      end;
    end;

  end else begin

    prGetSelection(Sel, Sender, False{ForSegment});
    prDataObject.Idealization[ActiveChannel].SetDwell(Sel.First, Sel.Last, Cls);
  end;
end;

procedure TQUB_QVO_QVD.prOnBreak(Sender :TObject);
var
  Sel :TQUB_FirstLast;
begin
  if Sender <> nil then begin
    Sender := prPopUpMenu.PopUpComponent;
  end;
  prGetSelection(Sel, Sender, False);
  prDataObject.BreakSegment(Sel.First, Sel.Last);
end;

procedure TQUB_QVO_QVD.prOnUndo(Sender :TObject);
begin
  prDataObject.Undo;
end;

procedure TQUB_QVO_QVD.prOnSendToQtiPlot(Sender :TObject);
begin
  prZoom.SendToQtiPlot(ChangeFileExt(StringReplace(TMenuItem(Sender).Caption, '&', '', [rfReplaceAll]), '.py'));
end;

procedure TQUB_QVO_QVD.prOnJoinIdl(Sender :TObject);
var
  Sel :TQUB_FirstLast;
begin
  prGetSelection(Sel, prPopUpMenu.PopUpComponent, False{prForSegment});
  prDataObject.Idealization[ActiveChannel].Join(Sel.First, Sel.Last);
end;

procedure TQUB_QVO_QVD.prOnDeleteIdl(Sender :TObject);
var
  Sel :TQUB_FirstLast;
begin
  prGetSelection(Sel, prPopUpMenu.PopUpComponent, prForSegment);
  prDataObject.Idealization[ActiveChannel].Erase(Sel.First, Sel.Last);
end;

procedure TQUB_QVO_QVD.prOnDelAllIdl(Sender :TObject);
var
  i :Integer;
begin
  for i := 0 to DataObject.ADChannelCount - 1 do begin
    prDataObject.Idealization[i].Clear;
  end;
end;


//Expand Zoom  -----------------------------------------------------------------
procedure TQUB_QVO_QVD.prOnExpandZoom(Sender :TObject);
begin
  ExpandZoom;
end;

procedure TQUB_QVO_QVD.prOnUnExpandZoom(Sender :TObject);
begin
  UnExpandZoom;
end;


{
                  How baseline used to work


  - each segment has a pair of terminal nodes
  - SetBaseline:
      - first creates the terminal nodes for all segments
        (even if it is called for segment) if they don't exist already,
        and sets them to SelAverage.
      - if nodes exist, then the non-marginal ones are deleted,
        all of them if for file, or only inside a segment if for segment
      - if for file, all marginal nodes are set to the selection average
      - if for segment, the segment's marginal nodes are set to the average.
  - ClearNodes (in Auto Baseline)
      - deletes absolutely every node (marginal or not)
  - AddNode
      - first checks for nodes to exist: if they don't, calls SetBaseline
      - then it adds a node
  -DelNodes
      - for each segment:
          - deletes non-marginal nodes within the selection and the segment

}

{
                   How baseline works

  - there is a constant dc offset for the whole file.  someday
    each segment may have its own dc offset.  someday
    this offset will initialize Idl/Base's baseline estimate.
    this offset is subtracted even for 'raw' data.
    there is currently no way to clear the dc offset to zero (DataBaseline, DoDataBaseline)

  - there are baseline nodes, managed by QUB_Baseline.
    DoOnFileEdit listens for changes such as delete, paste, append
    and passes them on to the baseline objects.

}


//Baseline ---------------------------------------------------------------------

function TQUB_QVO_QVD.prConfirmSetBaseline: Boolean;
var
  Warn           :Boolean;
begin
  Result   := True;
  if WarnOnBaseline[ActiveChannel] then begin
    Warn   := True;
    Result := (mrYes = MessageCheckDlg(Format('This is A/D Ch %d (%s).'#13#10'Really edit the baseline of this channel?', [ActiveChannel, DataChannelName[ActiveChannel]]),
                                       Format('Always ask for A/D Ch %d', [ActiveChannel]),
                                       Warn, [mbYes, mbNo]));
    if not Warn then WarnOnBaseline[ActiveChannel] := False;
  end;
end;

procedure TQUB_QVO_QVD.prOnSetBaseline(Sender :TObject);
var
  BaseList       :TQUB_QVO_QVD_SelectionList;
  Sum            :Extended;
  i              :Integer;
begin

  if Sender <> nil then begin
    Sender := prPopUpMenu.PopUpComponent;
  end;

  if not prConfirmSetBaseline then Exit;

  prGetSelection(prDataBaselineSel, Sender, False);
  if prDataBaselineSel.First < prDataDraw.First then prDataBaselineSel.First := prDataDraw.First;
  if prDataBaselineSel.Last  > prDataDraw.Last  then prDataBaselineSel.Last  := prDataDraw.Last;

  BaseList := prSelectionLists.ListByName['Baseline selection'];
  if BaseList = nil then begin
  //Create
    BaseList           := prAddList('Baseline selection');
  end else begin
  //Update
    Baselist.Clear;
  end;

  BaseList.AddSelection(prDataBaselineSel.First, prDataBaselineSel.Last, '');

  //Calculates the Average of the raw data
  Sum := 0;
  for i := prDataBaselineSel.First to prDataBaselineSel.Last do begin
    Sum := Sum + prData[ActiveChannel, (i - prDataDraw.First) + (prDataDraw.First - prDataCache.First)];//prDataChannelDisplay[ActiveChannel, i - prDataDraw.First];
  end;
  Sum := Sum / (prDataBaselineSel.Last - prDataBaselineSel.First + 1);

  DataBaseLine[ActiveChannel] := prDataBaseline[ActiveChannel] + Round(Sum);

  //Done
  prDataMeasured := False;
  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA, 0);
end;

procedure TQUB_QVO_QVD.prOnBaselineEdit(Sender :TObject);
var
  sBase   :String;
begin
  if not prConfirmSetBaseline then Exit;

  sBase   := FloatToStr(DataBaseLine[ActiveChannel] / (DataObject.Scaling * DataChannelScaling[ActiveChannel]) + DataChannelOffset[ActiveChannel]);
  if InputQuery('QuB - Edit constant baseline',
                'QuB subtracts this baseline constant even if "bline apply" is off:',
                sBase) then begin
    try
      DataBaseLine[ActiveChannel] := Round((StrToFloat(sBase) - DataChannelOffset[ActiveChannel]) * (DataObject.Scaling * DataChannelScaling[ActiveChannel]));
    except
    end;
  end;
end;

procedure TQUB_QVO_QVD.prSetDataBaseLine(ChannelIndex :Integer; NewBaseline :Integer);
var
  BaselineChange  :Integer;
begin
  BaselineChange  := NewBaseline - prDataBaseline[ChannelIndex];
  prDataBaseLine[ChannelIndex] := NewBaseline;
  if prZoom <> nil then prZoom.DataBaseLine[ChannelIndex] := prDataBaseLine[ChannelIndex];

  BaselineNodes[ActiveChannel].OffsetValues( BaselineChange );

  prDataMeasured := False;
  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA or DATA_MSG_READ_CACHE, 0);

end;

procedure TQUB_QVO_QVD.prOnSetErase(Sender :TObject);
var
  EraseList :TQUB_QVO_QVD_SelectionList;
begin

  if Sender <> nil then begin
    Sender := prPopUpMenu.PopUpComponent;
  end;

  prGetSelection(prDataEraseSel, Sender, False);
  if prDataEraseSel.First < prDataDraw.First then prDataEraseSel.First := prDataDraw.First;
  if prDataEraseSel.Last  > prDataDraw.Last  then prDataEraseSel.Last  := prDataDraw.Last;

  EraseList := prSelectionLists.ListByName['Erase selection'];
  if EraseList = nil then begin
  //Create
    EraseList           := prAddList('Erase selection');
  end else begin
  //Update
    EraseList.Clear;
  end;

  EraseList.AddSelection(prDataEraseSel.First, prDataEraseSel.Last, '');

end;

//Nodes ------------------------------------------------------------------------

procedure TQUB_QVO_QVD.prOnNodesAdd(Sender :TObject);
var
  Sel      :TQUB_FirstLast;
  DBl      :Double;
  i        :Integer;
begin
  if Sender <> nil then begin
    Sender := prPopUpMenu.PopUpComponent;
  end;

  if not prConfirmSetBaseline then Exit;

  prGetSelection(Sel, Sender, False);
  if Sel.First < prDataDraw.First then Sel.First := prDataDraw.First;
  if Sel.Last  > prDataDraw.Last  then Sel.Last  := prDataDraw.Last;

  DBl := 0;
  for i := Sel.First to Sel.Last do begin
    DBl := DBl + prData[ActiveChannel, (i - prDataDraw.First) + (prDataDraw.First - prDataCache.First)];
  end;
  DBl := DBl / (Sel.Last - Sel.First + 1);

  BaselineNodes[ActiveChannel].AddNode( (Sel.First + Sel.Last) div 2, {prDataBaseLine[ActiveChannel]} - Round(DBl) );

  //Done
  prDataMeasured := False;
  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA, 0);
end;

{
This function computes a least squares best fit of the selected data then sets
3 baseline nodes on the line at x=0, selection start and selection end.
}
procedure TQUB_QVO_QVD.AddArthurNode(Sender :TObject);
var
  Sel : TQUB_FirstLast;
  nX, nY : Double;
  nSumX, nSumY, nSumXY, nSumXX : Double;
  nSlope, nIntercept : Double;
  i, iX, iCount : Integer;
  iSamp : Integer;
begin
  if Sender <> nil then begin
    Sender := prPopUpMenu.PopUpComponent;
  end;

  if not prConfirmSetBaseline then Exit;

  prGetSelection(Sel, Sender, False);
  if Sel.First < prDataDraw.First then Sel.First := prDataDraw.First;
  if Sel.Last  > prDataDraw.Last  then Sel.Last  := prDataDraw.Last;

  //---- Minimize least squares linear fit
  nSumX:=0;
  nSumY:=0;
  nSumXY:=0;
  nSumXX:=0;
  iCount:=0;
  iSamp := max(1,(Sel.Last-Sel.First) Div 100);   // Check every n samples
  for i := Sel.First Div iSamp to (Sel.Last-1) Div iSamp do begin
    iX := i * iSamp;
    nX := iX;
    nY := prData[ActiveChannel][iX-prDataCache.First] ;
    nSumX := nSumX+nX;
    nSumY := nSumY+nY;
    nSumXY := nSumXY + nY * nX;
    nSumXX := nSumXX + nX*nX;
    iCount := iCount + 1;
  end;
  //iX := Sel.Last-Sel.First;                 // Number of points
  iX := iCount;
  nY := nSumXX*iX - nSumX*nSumX;            // Determinant
  nSlope := (nSumXY*iX - nSumX*nSumY)/nY;        // Slope
  nIntercept := (nSumXX*nSumY-nSumX*nSumXY)/nY;  // Intercept

  //----- add two baseline nodes based on least squares fit
  BaselineNodes[ActiveChannel].AddNode( 0, Round(0.0-nIntercept) );
  BaselineNodes[ActiveChannel].AddNode( Sel.First, Round(0.0-(nSlope*Sel.First+nIntercept) ) );
  BaselineNodes[ActiveChannel].AddNode( Sel.Last, Round(0.0-(nSlope*Sel.Last+nIntercept) ) );

  //-----Done
  prDataMeasured := False;
  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA, 0);

end;

procedure TQUB_QVO_QVD.prOnNodesDel(Sender :TObject);
var
  Sel :TQUB_FirstLast;
begin
  if Sender <> nil then begin
    Sender := prPopUpMenu.PopUpComponent;
  end;

  if not prConfirmSetBaseline then Exit;

  prGetSelection(Sel, Sender, False);

  DelBaseLineNodes(ActiveChannel, Sel);

end;

procedure TQUB_QVO_QVD.prOnNodesDelAll(Sender :TObject);
begin
  if not prConfirmSetBaseline then Exit;

  ClearBaseLineNodes(ActiveChannel);
end;

//Markers
procedure TQUB_QVO_QVD.prOnVMarkersAdd(Sender :TObject);
var
  Sel      :TQUB_FirstLast;
  Mark     :Double;
  Std      :Double;
  Scl      :Double;
  List     :TQUB_QVO_QVD_SelectionList;
  LSel     :TQUB_QVO_QVD_Selection;
  First    :Integer;
  Last     :Integer;
  p        :Integer;
begin

  if prDrawListOverlapped then begin

    First  := prDataSel.First;
    Last   := prDataSel.Last;
    LSel   := nil;
    List   := CurrList;
    if List <> nil then LSel := List.CurrSelection;
    if LSel <> nil then begin
      if (Sender <> nil) and (prPopUpMenu.PopUpComponent = prZoom) then begin
        First := LSel.Sel.First + prDataSel.First + prDataZoomSel.First;
        Last  := LSel.Sel.First + prDataSel.First + prDataZoomSel.Last;
      end else begin
        First := LSel.Sel.First + prDataSel.First;
        Last  := LSel.Sel.First + prDataSel.Last;
      end;
    end;

    GetAverage(ActiveChannel, First, Last, Mark, Std);

  end else begin

    if Sender <> nil then begin
      Sender := prPopUpMenu.PopUpComponent;
    end;
    prGetSelection(Sel, Sender, False);
    if Sel.First < prDataDraw.First then Sel.First := prDataDraw.First;
    if Sel.Last  > prDataDraw.Last  then Sel.Last  := prDataDraw.Last;

    Scl  := 1 / Scaling;
    Mark := 0;
    try
      for p := Sel.First to Sel.Last do begin
        Mark := Mark + Scl * prDataChannelDisplay[ActiveChannel, p - prDataDraw.First];
      end;
    except
    end;
    Mark := Mark / (Sel.Last - Sel.First + 1);

  end;

  Inc(prDataMarkersCount);
  ReAllocMem(prDataMarkers,   SizeOf(Double)  * prDataMarkersCount);
  prDataMarkers[prDataMarkersCount - 1] := Mark;
  ReAllocMem(prDataMarkersCh, SizeOf(Integer) * prDataMarkersCount);
  prDataMarkersCh[prDataMarkersCount - 1] := ActiveChannel;

  prDataMarker := - 1;

  if prZoom <> nil then begin
    prZoom.DataMarker       := prDataMarker;
    prZoom.DataMarkersCount := prDataMarkersCount;
    prZoom.DataMarkers      := prDataMarkers;
    prZoom.DataMarkersCh    := prDataMarkersCh;
  end;

  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA, 0);

end;

procedure TQUB_QVO_QVD.prOnVMarkersDel(Sender :TObject);
var
  v :Integer;
begin

  if prDataMarker = -1 then Exit;
  if prDataMarkersCount = 0 then Exit;

  for v := prDataMarker + 1 to prDataMarkersCount - 1 do begin
    prDataMarkers  [v - 1] := prDataMarkers  [v];
    prDataMarkersCh[v - 1] := prDataMarkersCh[v];
  end;

  Dec(prDataMarkersCount);

  if prDataMarker >= prDataMarkersCount then prDataMarker := prDataMarkersCount - 1;

  if prDataMarkersCount = 0 then begin
    FreeMem(prDataMarkers);
    prDataMarkers := nil;
    FreeMem(prDataMarkersCh);
    prDataMarkersCh := nil;
  end else begin
    ReAllocMem(prDataMarkers,   SizeOf(Double)  * prDataMarkersCount);
    ReAllocMem(prDataMarkersCh, SizeOf(Integer) * prDataMarkersCount);
  end;

  prDataMarker := - 1;

  if prZoom <> nil then begin
    prZoom.DataMarker       := prDataMarker;
    prZoom.DataMarkersCount := prDataMarkersCount;
    prZoom.DataMarkers      := prDataMarkers;
    prZoom.DataMarkersCh    := prDataMarkersCh;
  end;

  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA, 0);

end;

procedure TQUB_QVO_QVD.prOnVMarkersSet(Sender :TObject);
var
  Txt :String;
begin

  if prDataMarker = -1 then Exit;
  if prDataMarkersCount = 0 then Exit;

  try
    Txt := '0';
    if not InputQuery('Input the marker value:', 'Value:', Txt) then Exit;
    prDataMarkers[prDataMarker] := StrToFloat(Txt);
  except
    Exit;
  end;

  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA, 0);

end;

//Time Markers
procedure TQUB_QVO_QVD.prOnTMarkersAdd(Sender :TObject);
var
  Mark :Integer;
  i, p :Integer;
begin

  if prPopUpMenu.PopUpComponent = Self then begin
    Mark := DataCurr;
  end else if prPopUpMenu.PopUpComponent = prZoom then begin
    if prDrawListOverlapped then begin
      Mark := prZoom.DataSel.First + prDataSel.First;
    end else begin
      Mark := prZoom.DataCurr + prZoom.DataOffset;
    end;
  end else begin
    Exit;
  end;

  Inc(prDataTimeMarkersCount);
  ReAllocMem(prDataTimeMarkers,   SizeOf(Double)  * prDataTimeMarkersCount);

  //Find position where to insert the new marker
  p := prDataTimeMarkersCount - 1;
  for i := prDataTimeMarkersCount - 2 downto 0 do begin
    if Mark < prDataTimeMarkers[i] then begin
      p := i;
    end else begin
      Break;
    end;
  end;
  for i := prDataTimeMarkersCount - 2 downto p do begin
    prDataTimeMarkers[i + 1] := prDataTimeMarkers[i];
  end;
  prDataTimeMarkers[p] := Mark;

  prDataTimeMarker := - 1;

  if prZoom <> nil then begin
    prZoom.DataTimeMarker       := prDataTimeMarker;
    prZoom.DataTimeMarkersCount := prDataTimeMarkersCount;
    prZoom.DataTimeMarkers      := prDataTimeMarkers;
  end;

  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA, 0);

end;

procedure TQUB_QVO_QVD.prOnTMarkersDel(Sender :TObject);
var
  v :Integer;
begin

  if prDataTimeMarker = -1 then Exit;
  if prDataTimeMarkersCount = 0 then Exit;

  for v := prDataTimeMarker + 1 to prDataTimeMarkersCount - 1 do begin
    prDataTimeMarkers[v - 1] := prDataTimeMarkers[v];
  end;

  Dec(prDataTimeMarkersCount);

  if prDataTimeMarker >= prDataTimeMarkersCount then prDataTimeMarker := prDataTimeMarkersCount - 1;

  if prDataTimeMarkersCount = 0 then begin
    FreeMem(prDataTimeMarkers);
    prDataTimeMarkers := nil;
  end else begin
    ReAllocMem(prDataTimeMarkers, SizeOf(Double) * prDataTimeMarkersCount);
  end;

  prDataTimeMarker := - 1;

  if prZoom <> nil then begin
    prZoom.DataTimeMarker       := prDataTimeMarker;
    prZoom.DataTimeMarkersCount := prDataTimeMarkersCount;
    prZoom.DataTimeMarkers      := prDataTimeMarkers;
  end;

  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA, 0);

end;

procedure TQUB_QVO_QVD.prOnTMarkersDelAll(Sender :TObject);
begin

  if prDataTimeMarkersCount = 0 then Exit;

  prDeleteAllTimeMarkers;

  prDataTimeMarker := - 1;

  if prZoom <> nil then begin
    prZoom.DataTimeMarker       := prDataTimeMarker;
    prZoom.DataTimeMarkersCount := prDataTimeMarkersCount;
    prZoom.DataTimeMarkers      := prDataTimeMarkers;
  end;

  DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA, 0);

end;

//Kinetic Parameters
procedure TQUB_QVO_QVD.prOnKMarkerSave(Sender :TObject);
var
  ParamsToDraw  :INode;
  Params        :INode;
  ChangePoint   :INode;
  Dlg           :TSaveDialog;
  i             :Integer;
const
  lName = 'KineticParameters';
begin

  if prDataKinParamsMarker < 0 then Exit;
  Dlg := nil;

  try

    try

      ParamsToDraw := DataObject.Session.Find('KineticParameters');
      if ParamsToDraw.IsNull then Exit;

      i := 0;
      ChangePoint := ParamsToDraw.Find('ChangePoint');
      while (not ChangePoint.IsNull)  do begin

        if i = prDataKinParamsMarker then begin
          Params := ChangePoint.Find('Parameters');
          Break;
        end;

        Inc(i);
        ChangePoint := ChangePoint.SiblingSameName;
      end;

      if not Params.IsNull then begin
        Dlg := TSaveDialog.Create(Self);
        Dlg.Filter   := 'Kinetic parameters files (*.kint)|*.kint|All files (*.*)|*.*';
        Dlg.Options  := [ofPathMustExist, ofOverwritePrompt, ofEnableSizing];
        Dlg.FileName := ChangeFileExt(FileName, '') + '_KineticParameters';
        if Dlg.Execute then begin
          Params.SaveAs(ChangeFileExt(Dlg.FileName, '.kint'));
        end;
      end;

    except
    end;

  finally

    Dlg.Free;

  end;

end;


//Print
procedure TQUB_QVO_QVD.prOnPrint(Sender :TObject);
begin
  Print;
end;

//******************************************************************************
procedure TQUB_QVO_QVD.prGetSelection(var Sel :TQUB_FirstLast; Sender :TObject; ForSegment :Boolean);
var
  p :Integer;
begin
  if Sender = nil then begin
    if Self.Focused then begin
      Sender := Self;
    end else if (prZoom <> nil) and (prZoom.Focused) then begin
      Sender := prZoom;
    end else begin
      Sender := Self;
    end;
  end;
  if ForSegment then begin
    if (Sender = prZoom) and (prZoom <> nil) then begin
      p := prZoom.DataCurr;
      Inc(p, prZoom.DataOffset);
    end else begin
      p := DataCurr;
    end;
    p := WhichSegmentForPoint(p);
    if p = 0 then Sel.First := 0 else Sel.First := prDataBreakpoints[p - 1];
    Sel.Last := prDataBreakpoints[p] - 1;
  end else begin
    if (Sender = prZoom) and (prZoom <> nil) then begin
      Sel := prZoom.DataSel;
      Inc(Sel.First, prZoom.DataOffset);
      Inc(Sel.Last,  prZoom.DataOffset);
    end else begin
      Sel := prDataSel;
    end;
  end;
end;

procedure TQUB_QVO_QVD.prSetActOnHiRes(x :Boolean);
begin
  if x then begin
    prMenuCaller := Zoom;
  end else begin
    prMenuCaller := Self;
  end;
end;

//PopUp
procedure TQUB_QVO_QVD.prOnPopUp(Sender :TObject);
var
  IsDWT :Boolean;
  i     :Integer;
  Items :TStringList;
  Item  :TMenuItem;
begin
  prForSegment := KeyShift;
  prCopyASCII  := KeyControl;

  IsDWT := (DataObject.FileType = QFS_QDF_TYPE_DWT) or (DataObject.FileType = QFS_QDF_TYPE_EVL) or (DataObject.FileType = QFS_QDF_TYPE_PRT) or (DataObject.FileType = QFS_QDF_TYPE_QSF);

  ActOnHiRes := (prPopUpMenu.PopupComponent = prZoom) and (prZoom <> nil);
  {
  if (prPopUpMenu.PopupComponent = prZoom) and (prZoom <> nil) then begin
    prMenuCaller := Zoom;
  end else begin
    prMenuCaller := Self;
  end;
  }
  if (prPopUpMenu.PopupComponent = prZoom) and (prZoom <> nil) then begin
    prExpandZoomItem.Enabled     := (prZoom.DataSel.Last <> prZoom.DataSel.First);
    prUnExpandZoomItem.Enabled   := prCanUnExpand;
    prSetBaselineItem.Enabled    := (not IsDWT) and (prZoom.DataSel.Last <> prZoom.DataSel.First);
    prNodesAddItem.Enabled       := (not IsDWT) and (not LockedAny) and (prZoom.DataSel.Last <> prZoom.DataSel.First);
    prNodesDelItem.Enabled       := (not IsDWT) and (not LockedAny) and (prZoom.DataSel.Last <> prZoom.DataSel.First);
    prCurveFitItem.Visible       := prZoom.Data <> nil;
    prCopyFitItem.Visible        := not FitCurves.IsEmpty;
    prDelFitItem.Visible         := not FitCurves.IsEmpty;
    prSelListDelItem.Visible     := False;
    prSelListPropertiesItem.Visible := False;
    prSendToItem.Visible         := True;
  end else begin
    prExpandZoomItem.Enabled     := False;
    prUnExpandZoomItem.Enabled   := prCanUnExpand;
    prSetBaselineItem.Enabled    := (not IsDWT) and (prDataSel.Last <> prDataSel.First);
    prNodesAddItem.Enabled       := (not IsDWT) and (not LockedAny) and (prDataSel.Last <> prDataSel.First);
    prNodesDelItem.Enabled       := (not IsDWT) and (not LockedAny) and (prDataSel.Last <> prDataSel.First);
    prCurveFitItem.Visible       := prZoom.Data <> nil;
    prCopyFitItem.Visible        := not FitCurves.IsEmpty;
    prDelFitItem.Visible         := not FitCurves.IsEmpty;
    if prPopupListSel <> -1 then begin
      prSelListDelItem.Visible     := prPopupListSel <> -1;
      prSelListDelItem.Caption     := Format('Remove selection "%s" from list', [CurrList[prPopupListSel].Lbl]);
      prSelListPropertiesItem.Visible := prPopupListSel <> -1;
      prSelListPropertiesItem.Caption := Format('Selection "%s" properties...', [CurrList[prPopupListSel].Lbl]);
    end else begin
      prSelListDelItem.Visible     := False;
      prSelListPropertiesItem.Visible := False;
    end;
    prSendToItem.Visible         := False;
  end;

  prEditCutItem.Enabled          := (not IsDWT) and prDataObject.CanCut;
  prEditCopyItem.Enabled         := (not IsDWT) and prDataObject.CanCopy;
  prEditCopyListItem.Enabled     := (not IsDWT) and prDataObject.CanCopy and (CurrList <> nil);
  prEditPasteItem.Enabled        := (not IsDWT) and prDataObject.CanPaste;
  prEditPasteItem.Enabled        := (not IsDWT) and prDataObject.CanPaste;
  prEditDeleteItem.Enabled       := (not IsDWT) and prDataObject.CanDelete;
  prEditEraseItem.Enabled        := (not IsDWT) and prDataObject.CanErase;
  prEditFillItem.Enabled         := (not IsDWT) and prDataObject.CanFill;
  prEditFillIdlItem.Enabled      := (not IsDWT) and prDataObject.CanFill{Idl};
  prEditBreakItem.Enabled        := (not IsDWT) and prDataObject.CanBreak;
  prEditUndoItem.Enabled         := (not IsDWT) and prDataObject.CanUndo;
  prEditDeleteIdlItem.Enabled    := (not IsDWT) and prDataObject.CanDelete;
  prEditDelAllIdlItem.Enabled    := (not IsDWT) and prDataObject.CanDelete;
  prEditJoinIdlItem.Enabled      := (not IsDWT) and prDataObject.CanDelete;

  prPrintItem.Enabled            := True;
  prEditCopyImageItem.Enabled    := True;

  prEditCutItem.Caption          := 'Cu&t'           + Choice(prForSegment, ' segment', '') + Choice(prCopyASCII, ' as text', '');
  prEditCopyItem.Caption         := '&Copy'          + Choice(prForSegment, ' segment', '') + Choice(prCopyASCII, ' as text', '');
  //TO DO: Copy List As Text. LM
  prEditCopyListItem.Caption     := 'Copy list'      + Choice(prCopyASCII, ' as text', '');
  prEditPasteItem.Caption        := 'Paste'          + Choice(prForSegment, ' as segment', '');
  prEditAppendItem.Caption       := 'Append';
  prEditDeleteItem.Caption       := '&Delete'        + Choice(prForSegment, ' segment', '');
  prEditEraseItem.Caption        := 'Era&se';
  prEditFillItem.Caption         := 'Fill';
  prEditFillIdlItem.Caption      := 'Fill Idl';

  prEditDeleteIdlItem.Caption    := '&Delete Idl'    + Choice(prForSegment, ' segment', '');

  prSetBaselineItem.Caption      := 'Set baseline'   + Choice(prForSegment, ' for segment', '');

  prCopyFitItem.Caption          := 'Copy fit curve' + Choice(prCopyASCII, ' as text', '');

  prVMarkersDelItem.Enabled      := (prDataMarkersCount > 0) and (prDataMarker <> -1);
  prTMarkersDelItem.Enabled      := (prDataTimeMarkersCount > 0) and (prDataTimeMarker <> -1);
  prTMarkersDelAllItem.Enabled   := (prDataTimeMarkersCount > 0);
  prKMarkerSaveItem.Enabled      := (prDataKinParamsMarkersCount > 0) and (prDataKinParamsMarker <> -1);

  for i := prSendToItem.Count - 1 downto 0 do begin
    prSendToItem.Items[i].Free;
  end;
  if prPopUpMenu.PopupComponent = prZoom then begin
    Items                          := TStringList.Create;
    Items.Sorted                   := True;
    TQUB_QtiPlot_Connection.ListScripts('Trace', Items);
    for i := 0 to Items.Count - 1 do begin
      Item           := TMenuItem.Create(Self);
      Item.Caption   := ChangeFileExt(Items[i], '');
      Item.OnClick   := prOnSendToQtiPlot;
      prSendToItem.Add(Item);
    end;
    Items.Free;
  end;
end;


//Lists menu
procedure TQUB_QVO_QVD.prOnListsLoad(Sender :TObject);
begin
  prListLoad;
  prSetHint;
end;

procedure TQUB_QVO_QVD.prOnListsSave(Sender :TObject);
begin
  prListSave;
end;

procedure TQUB_QVO_QVD.prOnListsRename(Sender :TObject);
begin
  if CurrList <> nil then begin
    if not CurrList.Locked then begin
      CurrListName := InputBox('Rename Selection List', '', CurrListName);
    end;
  end;
end;

//Edit Lists
procedure TQUB_QVO_QVD.prOnListsCut(Sender :TObject);
begin
  CutLists;
  prSetHint;
end;

procedure TQUB_QVO_QVD.prOnListsCopy(Sender :TObject);
begin
  CopyLists;
end;

procedure TQUB_QVO_QVD.prOnListsPaste(Sender :TObject);
begin
  PasteLists;
  prSetHint;
end;

procedure TQUB_QVO_QVD.prOnListsDel(Sender :TObject);
begin
  DeleteLists;
  prSetHint;
end;


//List menu
procedure TQUB_QVO_QVD.prOnListCut(Sender :TObject);
begin
  CutSelections;
  prSetHint;
end;

procedure TQUB_QVO_QVD.prOnListCopy(Sender :TObject);
begin
  CopySelections;
end;

procedure TQUB_QVO_QVD.prOnListPaste(Sender :TObject);
begin
  PasteSelections;
  prSetHint;
end;

procedure TQUB_QVO_QVD.prOnListDel(Sender :TObject);
begin
  DeleteSelections;
  prSetHint;
end;

procedure TQUB_QVO_QVD.prOnListSelectAll(Sender :TObject);
begin
  SelectAllSelections;
end;

procedure TQUB_QVO_QVD.prOnListInvertSel(Sender :TObject);
begin
  InvertSelections;
end;

procedure TQUB_QVO_QVD.prOnListShiftSel(Sender :TObject);
begin
  ShiftSelection;
end;

procedure TQUB_QVO_QVD.prOnListExpandSel(Sender :TObject);
begin
  ExpandSelection;
end;

procedure TQUB_QVO_QVD.prOnListExtractList(Sender :TObject);
var
  iSel, i           :Integer;
  SrcList, ExtList  :TQUB_QVO_QVD_SelectionList;
  ExtName           :String;
begin
  // if no currlist or none highlighted then Exit;
  if CurrList = nil then Exit;
  SrcList         := CurrList;
  iSel            := -1;
  for i := CurrList.Items.Count - 1 downto 0 do begin
    if SrcList.Selected[i] then begin
      iSel        := i;
      Break;
    end;
  end;
  if iSel = -1 then Exit;

  // prompt new list name '%s sel'
  ExtName         := CurrListName + ' sel';
  if InputQuery('QuB - Create list of selected', 'New list name:', ExtName) then begin
    ExtList       := GetList(ExtName);
    ExtList.Clear;
    for i := 0 to SrcList.Items.Count - 1 do begin
      if SrcList.Selected[i] then begin
        ExtList.AddSelection( SrcList[i].Sel.First,
                              SrcList[i].Sel.Last,
                              SrcList[i].Lbl,
                              i <> iSel {not last one added} )
                      .Comment := SrcList[i].Comment;
      end;
    end;
    ChooseList(ExtName);
  end;
end;

procedure TQUB_QVO_QVD.prOnListProperties(Sender :TObject);
begin
  ShowSelectionProperties;
end;

// main popup
procedure TQUB_QVO_QVD.prOnSelListDel(Sender :TObject);
begin
  CurrList.DelSelection(prPopupListSel);
  RefreshLists;
end;

procedure TQUB_QVO_QVD.prOnSelListProperties(Sender :TObject);
begin
  CurrList.ShowSelectionProperties(prPopupListSel);
  RefreshLists;
end;


//****************************************************************************//
//                                                                            //
//                         C H A N G E   E V E N T S                          //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVD.prDoOnChangePage;
var
  Pos, Max :Integer;
begin
  if (prScrollBar <> nil) and (Active) then begin
    Pos := WhichTraceForPoint(prDataDraw.First);
    Max := WhichTraceForPoint(WhichPointForLast(prDataPoint.Last));
    if Max < Pos then Max := Pos;
    if Max >= 0 then begin
      prScrollBar.Max      := Max;
      prScrollBar.Position := Pos;
      prScrollBar.Enabled := True;
      prScrollBar.Refresh;
    end;
  end;
end;

procedure TQUB_QVO_QVD.prOnZoomChangeSel(Sender :TObject);
begin
  if TQUB_QVO_QVT(Sender).Data <> nil then begin
    prDataZoomSel  := TQUB_QVO_QVT(Sender).DataSel;
    prDataZoomCurr := TQUB_QVO_QVT(Sender).DataCurr;
  end;

  if (DataSel.First < DataSel.Last) and (prDataZoomCurr <> 0) then prUpdateStimValues(prDataSel.First + prDataZoomCurr);
end;

procedure TQUB_QVO_QVD.prOnZoomEditPoint(Sender :TObject; Point :Integer; Change :Integer);
begin
  prDataObject.EditPoint(ActiveChannel, Point, Change);
end;

procedure TQUB_QVO_QVD.prOnZoomChangeVMarker(Sender :TObject);
begin
  prDataMarker := TQUB_QVO_QVT(Sender).DataMarker;
  if prDataMarker = -1 then begin
    prVMarkersDelItem.Caption := 'Delete a marker';
  end else begin
    { TODO -oLorin : Take care of Scaling }
    prVMarkersDelItem.Caption := Format('Delete marker %d (%.6g)', [prDataMarker, prDataMarkers[prDataMarker]/(prDataChannelScaling[ActiveChannel]*Scaling)+prDataChannelOffset[ActiveChannel]]);
  end;
end;

procedure TQUB_QVO_QVD.prOnZoomChangeTMarker(Sender :TObject);
begin
  prDataTimeMarker := TQUB_QVO_QVT(Sender).DataTimeMarker;
  if prDataTimeMarker = -1 then begin
    prTMarkersDelItem.Caption := 'Delete a Time marker';
  end else begin
    prTMarkersDelItem.Caption := Format('Delete Time marker %d (%d)', [prDataTimeMarker, Round(prDataTimeMarkers[prDataTimeMarker])]);
  end;
end;

procedure TQUB_QVO_QVD.prOnZoomChangeKMarker(Sender :TObject);
begin
  prDataKinParamsMarker := TQUB_QVO_QVT(Sender).DataKinParamsMarker;
end;



//****************************************************************************//
//                                                                            //
//                          M O U S E   E V E N T S                           //
//                                                                            //
//****************************************************************************//
function TQUB_QVO_QVD.DoMouseWheel(Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint): Boolean;
begin
  Result := inherited DoMouseWheel(Shift, WheelDelta, MousePos);

  prKeyeing := True;
  if WheelDelta = 1 then begin
    prKeyCode := VK_UP;
  end else if WheelDelta > 1 then begin
    prKeyCode := VK_PRIOR;
  end else if WheelDelta = -1 then begin
    prKeyCode := VK_DOWN;
  end else if WheelDelta < -1 then begin
    prKeyCode := VK_NEXT;
  end;

  try
    prDrawDataSel;
  finally
    prKeyeing := False;
  end;
end;

procedure TQUB_QVO_QVD.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  IgnoreCmd       :TQUB_QVO_QVD_Command;
  DataPt          :Integer;
  ListIter        :TQUB_QVO_QVD_SelectionListIter;
begin

  inherited;

  Self.PopUpComponent := Self;

  try

    if (prMouseHitCount < 2) and (Button = mbLeft) then begin
      prMouse.x := x;
      prMouse.y := y;
      prMouseSel := prMouse;
      Exit;
    end;

    if prHasDblClicked then begin
      prMouse.x := x;
      prMouse.y := y;
      prMouseSel := prMouse;
      prDoDblClick;
      Exit;
    end;

    if Button = mbLeft then begin

      prMouse.x := x;
      prMouse.y := y;
      prMouseSel := prMouse;

      if prMouseOnPoint(prMouse, prPointingPoint) then begin

        prMouseDowning := True;
        prDrawDataSel;
        prPointing     := True;

      end else begin

        if not prSelectable then Exit;
        if prChanging then Exit;

        //Start selecting
        prMouseDowning := True;
        prSelMoving := False;
        prDrawDataSel;
        if not prSelMoving then prSelecting := True;
        //end;

      end;

    end else if Button = mbRight then begin

      if prDrawSelList and (CurrList <> nil) then begin
        prMouse.x := x;
        prMouse.y := y;
        DataPt   := prMouseToPoint(prMouse, IgnoreCmd);
        ListIter := CurrList.Find(DataPt, DataPt, True{ActiveOnly});
        prPopupListSel := ListIter.Ix;
        ListIter.Free;
      end else begin
        prPopupListSel := -1;
      end;

    end

  finally

    prHasDblClicked := False;
    prMouseDowning := False;

  end;
end;

procedure TQUB_QVO_QVD.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  try

    if prHintCycle = QUB_QVO_QVD_HINTCYCLE then begin
      ShowHint             := False;
      prHintCycle          := 0;
    end else begin
      if TipsOn then begin
        ShowHint             := True;
      end;
      prHintCycle          := prHintCycle + 1;
    end;

    if prSelecting then begin
    //Update selection
      prMouseRunning := True;
      prMouseSel.x := x;
      prMouseSel.y := y;
      if not prChanging then prDrawDataSel;
    end else if prSelMoving then begin
    //Selection Moving
      prMouseRunning := True;
      prMouseSel.x := x;
      prMouseSel.y := y;
      if not prChanging then prDrawDataSel;
    end else if prPointing then begin
      prMouseRunning := True;
      prMouseSel.x := x;
      prMouseSel.y := y;
      if not prChanging then begin
        prUpdatePointing;
        prDrawDataSel;
      end;
    end;

  finally

    prMouseRunning := False;
    inherited;

  end;
end;

procedure TQUB_QVO_QVD.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  try

    if prSelecting then begin
    //End selecting
      prSelecting := False;
    end else if prSelMoving then begin
    //Moving Selection
      prSelMoving := False;
    end else if prPointing then begin
    //End pointing
      prPointing := False;
    end;

  finally

    inherited;

  end;
end;

procedure TQUB_QVO_QVD.DblClick;
begin

  if (not prChanging) and (not prSelecting) then prHasDblClicked := True;

  inherited;

end;

procedure TQUB_QVO_QVD.prHilightSelection;
var
  Index :Integer;
  List  :TQUB_QVO_QVD_SelectionList;
  Sel   :TQUB_FirstLast;
  s     :Integer;
begin

  Index := prSelectionLists.ItemIndex;
  if Index = -1 then Exit;
  if prSelectionLists.Items.Count = 0 then Exit;

  List := prSelectionLists.List[Index];
  for s := 0 to List.Items.Count - 1 do begin
    Sel := List.Selection[s].Sel;
    if (Sel.First <= DataCurr) and (Sel.Last >= DataCurr) then begin
      List.ItemIndex := s;
      List.Selected[s] := True;
      Break;
    end;
  end;

end;

procedure TQUB_QVO_QVD.prUpdateStimValues(Curr :Integer);
var
  i         :Integer;
  Chan      :Integer;
begin
  if prDataChannelDisplay[0] = nil then Exit;
  if Curr >= DataObject.Segments.TotalDataCount then Exit;
  if prDataDraw.First = prDataDraw.Last then Exit;
  for i := 0 to ExpCond.Count - 1 do begin
    Chan    := ExpCond[i].Channel;
    if (Chan >= 0) and (Chan < DataObject.ADChannelCount) then begin
      ExpCond.ChangePar(i, prDataChannelDisplay[Chan, Curr - prDataDraw.First] / (Scaling * DataChannelScaling[Chan]) + DataChannelOffset[Chan]);
    end;
  end;
end;

procedure TQUB_QVO_QVD.prDoDblClick;
var
  Pnt :Integer;
  Sel :TQUB_FirstLast;
  Seg :Integer;
  Trc :Integer;
  Cmd :TQUB_QVO_QVD_Command;
begin

  if prDrawListOverlapped then begin

    if CurrList <> nil then begin
      if CurrList.Items.Count > 0 then begin
        Sel           := CurrList.Selection[0].Sel;
        Sel.Last      := Sel.Last - Sel.First;
        Sel.First     := 0;
        prDataSel     := Sel;
        prSelMove     := Sel;
        prDataCurr    := Sel.Last;
        prDataOldCurr := prDataCurr;
        DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA, prDataDraw.First);
      end;
    end;

  end else begin

    if KeyShift and KeyControl then begin
    //File

      Sel.First := DataPoint.First;
      Sel.Last  := DataPoint.Last;
      MoveSelectionIntoWindow(Sel, Sel.First);

    end else if KeyShift then begin
    //Segment

      Pnt := prMouseToPoint(prMouse, Cmd);
      Seg := WhichSegmentForPoint(Pnt);
      if Seg >= 0 then begin
        Sel.First := WhichSegmentFirstForPoint(DataCurr);
        Sel.Last  := WhichSegmentLastForPoint(DataCurr);
        MoveSelectionIntoWindow(Sel, Sel.First);
      end;

    end else begin
    //Trace

      Pnt := prMouseToPoint(prMouse, Cmd);
      Trc := WhichTraceForPoint(Pnt);
      if Trc >= 0 then begin
        Sel.First := WhichPointForTrace(Trc);
        Sel.Last  := WhichPointForTrace(Trc + 1) - 1;
        if (Sel.Last < DataPoint.First) or (Sel.Last > DataPoint.Last) then Sel.Last := DataPoint.Last;
        MoveSelectionIntoWindow(Sel, Pnt);
      end;

    end;
  end;

  prHilightSelection;

end;


//****************************************************************************//
//                                                                            //
//                             K E Y   E V E N T S                            //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVD.CNKeyDown(var Message: TWMKeyDown);
var
  Eaten :Boolean;
  Sel   :TQUB_FirstLast;
  tpp   :Integer;
  ppt   :Integer;
  //p     :Integer;
begin

  Eaten := False;
  if prChanging then Exit;

  case Message.CharCode of

    //Browse Commands
    VK_LEFT, VK_RIGHT, VK_UP, VK_DOWN, VK_PRIOR, VK_NEXT, VK_END, VK_HOME:
      begin

        prKeyeing := True;
        prKeyCode := Message.CharCode;
        try
          prDrawDataSel;
        finally
          Eaten := True;
          prKeyeing := False;
        end;
      end;

    Word('X')://Cut
      begin
        if KeyControl then begin
          prForSegment  := KeyShift;
          if DataObject.CanCut then prOnCut(nil);
          Eaten := True;
        end;
      end;

    Word('C')://Copy
      begin
        if KeyControl then begin
          prForSegment  := KeyShift;
          if DataObject.CanCopy then prOnCopy(nil);
          Eaten := True;
        end;
      end;

    Word('V')://Paste
      begin
        if KeyControl then begin
          prForSegment  := KeyShift;
          if DataObject.CanPaste then prOnPaste(nil);
          Eaten := True;
        end;
      end;

    VK_DELETE://Delete
      begin
        prForSegment  := KeyShift;
        if DataObject.CanDelete then prOnDelete(nil);
        Eaten := True;
      end;

    Word('E')://Erase
      begin
        prForSegment  := KeyShift;
        if DataObject.CanErase then prOnErase(nil);
        Eaten := True;
      end;

    Word('Z')://Undo
      begin
        if KeyControl then begin
          if DataObject.CanUndo then prOnUndo(nil);
          Eaten := True;
        end;
      end;

    13://Enter - Break
      begin
        if KeyControl then begin
          if DataObject.CanBreak then prOnBreak(nil);
          Eaten := True;
        end;
      end;

    Word('L')://Add list
      begin
        AddList;
        Eaten := True;
      end;

    Word('S')://Add selection
      begin
        if DrawListOverlapped then begin
          AddSelections(False{FromZoom});
        end else begin
          AddSelection;
        end;
        Eaten := True;
      end;

    Word('A')://Select All
      begin
        Sel.First := DataPoint.First;
        Sel.Last  := DataPoint.Last;
        MoveSelectionIntoWindow(Sel, Sel.First);
        Eaten := True;
      end;

    VK_ADD, Word(187) ://ZoomIn
      // Numpad + or keyboard (+ =) keys to ZoomIn. {JB}
      begin
        if KeyControl then begin
          tpp := TracesPerPage div 2;
          if tpp < 1 then tpp := 1;
          if tpp <> TracesPerPage then begin
            TracesPerPage := tpp;
            DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA or DATA_MSG_SET_SCROLL, 0);
            Eaten := True;
          end;
        end else begin
          ppt := PointsPerTrace div 2;
          if ppt < QUB_QVO_QVD_MIN_POINTSPERTRACE then ppt := QUB_QVO_QVD_MIN_POINTSPERTRACE;
          if ppt <> PointsPerTrace then begin
            PointsPerTrace := ppt;
            DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA or DATA_MSG_SET_SCROLL, 0);
            Eaten := True;
          end;
        end;
      end;

    VK_SUBTRACT, Word(189) ://ZoomOut
      // Numpad + or keyboard (+ =) keys to ZoomIn. {JB}
      begin
        if KeyControl then begin
          tpp := TracesPerPage * 2;
          if tpp > QUB_QVO_QVD_MAX_TRACESPERPAGE then tpp := QUB_QVO_QVD_MAX_TRACESPERPAGE;
          if tpp <> TracesPerPage then begin
            TracesPerPage := tpp;
            DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA or DATA_MSG_SET_SCROLL, 0);
            Eaten := True;
          end;
        end else begin
          ppt := PointsPerTrace * 2;
          if ppt > QUB_QVO_QVD_MAX_POINTSPERTRACE then ppt := QUB_QVO_QVD_MAX_POINTSPERTRACE;
          if ppt <> PointsPerTrace then begin
            PointsPerTrace := ppt;
            DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA or DATA_MSG_SET_SCROLL, 0);
            Eaten := True;
          end;
        end;
      end;

    Word('P')://Properties
      begin
        //if KeyControl then begin
          prOnProperties(nil);
          Eaten := True;
        //end;
      end;

    Word('H')://Expand
      begin
        //if KeyControl then begin
          ExpandZoom;
          Eaten := True;
        //end;
      end;

    Word('U')://Un-Expand
      begin
        //if KeyControl then begin
          UnExpandZoom;
          Eaten := True;
        //end;
      end;

    Word('F')://FindTrace
      begin
        FindTrace;
        Eaten := True;
      end;

  end;//case

  if not Eaten then inherited;

end;


//****************************************************************************//
//                                                                            //
//                    S E L E C T I O N   E V E N T S                         //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVD.prOnResultsListKeyDown(Sender :TObject; var Key: Word; Shift: TShiftState);
begin
  if prChanging then Exit;

  if Key = VK_DELETE then begin
    prResultsList.DelSelected;
  end;
end;

procedure TQUB_QVO_QVD.prOnResultsListItemChange(Sender :TObject);
begin
  //if prResultsList.ItemIndex >= 0 then begin
    //prResultsList[ prResultsList.ItemIndex ].Activate;
    prResultsList.Activate;
  //end;
end;

procedure TQUB_QVO_QVD.prOnResultsListItemDblClick(Sender :TObject);
begin
end;

//******************************************************************************
procedure TQUB_QVO_QVD.prOnSelectionListsKeyDown(Sender :TObject; var Key: Word; Shift: TShiftState);
begin
  if prChanging then Exit;

  case Key of

    Word('X')://Cut
      begin
        if KeyControl then begin
          CutLists;
        end;
      end;

    Word('C')://Copy
      begin
        if KeyControl then begin
          CopyLists;
        end;
      end;

    Word('V')://Paste
      begin
        if KeyControl then begin
          PasteLists;
        end;
      end;

    VK_DELETE://Delete
      begin
        DeleteLists;
      end;

  end;//case

end;

procedure TQUB_QVO_QVD.prOnSelectionListsItemChange(Sender :TObject);
begin
  RefreshLists;
  prSetHint;
end;

procedure TQUB_QVO_QVD.prOnSelectionListsItemDblClick(Sender :TObject);
begin
  if CurrList <> nil then CurrList.SetFocus;
end;

//******************************************************************************
procedure TQUB_QVO_QVD.prOnSelectionListKeyDown(Sender :TObject; var Key: Word; Shift: TShiftState);
begin
  if prChanging then Exit;
  if Key = VK_DELETE then begin
    DelSelected(KeyControl);
  end;
end;

procedure TQUB_QVO_QVD.prOnSelectionListItemChange(Sender :TObject);
var
  List :TListBox;
begin
  List := TListBox(Sender);
  if List.Items.Count = 0 then begin
    List.Hint := 'Empty list';
  end else begin
    if List.ItemIndex < 0 then begin
      List.Hint := IntToStr(List.Items.Count) + ' selections';
    end else begin
      List.Hint := IntToStr(List.ItemIndex + 1) + ' / ' + IntToStr(List.Items.Count) + ' selections';
      if List.Focused and not m_lListLoading then begin
        prOnSelectionListItemDblClick(Sender);  // added 12/05 - activate when clicked
      end;
    end;
  end;
  prSetHint;
end;

procedure TQUB_QVO_QVD.prOnSelectionListItemDblClick(Sender :TObject);
var
  SelSel  :TQUB_QVO_QVD_SelectionList;
  Sel     :TQUB_FirstLast;
begin
  if prChanging then Exit;

  if prDrawListOverlapped then begin

    DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA, prDataDraw.First);

  end else begin

    SelSel  := TQUB_QVO_QVD_SelectionList(Sender);

    if SelSel.ItemIndex <> -1 then begin
      Sel := SelSel.Selection[SelSel.ItemIndex].Sel;
      MoveSelectionIntoWindow(Sel, Sel.First);

      if SelSel.ResultObject <> nil then begin
        TQUB_QVO_QVR(SelSel.ResultObject).ChooseSelection( Self, Sel );
      end;
    end;

  end;
end;

procedure TQUB_QVO_QVD.prOnSelectionListActiveChanged(Sender :TObject);
begin
  RefreshLists;
end;


procedure TQUB_QVO_QVD.prSetActiveChannel(c :Integer);
begin
  if (c >= 0) and (c < prDataChannelCount) then prActiveChannel := c else prActiveChannel := 0;
  if prZoom <> nil then begin
    prZoom.ActiveChannel := ActiveChannel;
  end;
  Events.RaiseNotifyEvent('OnActiveChannelChange', Self);
end;

procedure TQUB_QVO_QVD.prListLoad;
var
  Dlg  :TOpenDialog;
  List :TQUB_QVO_QVD_SelectionList;
  l    :Integer;
begin

  Dlg := TOpenDialog.Create(Self);

  try

    Dlg.Filter := 'List files (*.txt)|*.txt|All files (*.*)|*.*';
    Dlg.Options := [ofPathMustExist, ofFileMustExist, ofEnableSizing];
    if Dlg.Execute then begin

      List := AddList(ChangeFileExt(ExtractFileName(Dlg.FileName), ''));
      if List <> nil then begin
        List.LoadFromFile(Dlg.FileName);

        for l := List.Items.Count - 1 downto 0 do begin
          if List[l].Sel.Last > DataPoint.Last then begin
            List.DelSelection(l);
          end else begin
            Break;
          end;
        end;
{
        l := 0;
        repeat
          try
            System.New(Sel);
            Text := List.Items.Strings[l];
            p := Pos('-', Text);
            Text := Copy(List.Items.Strings[l], 0, p - 2);
            Sel.First := StrToInt(Text);
            Text := Copy(List.Items.Strings[l], p + 2, Length(List.Items.Strings[l]) - p - 1);
            Sel.Last  := StrToInt(Text);
            if (Sel.First >= DataPoint.First) and (Sel.Last <= DataPoint.Last) then begin
              List.Items.Objects[l] := TObject(Sel);
              Inc(l);
            end else begin
              Dispose(Sel);
              List.Items.Delete(l);
            end;
          except
            List.Clear;
            Break;
          end;
        until (l >= List.Items.Count);
}
      end;

    end;

  finally

    Dlg.Free;
    RefreshLists;

  end;

end;

procedure TQUB_QVO_QVD.prListSave;
var
  Dlg  :TSaveDialog;
  List :TQUB_QVO_QVD_SelectionList;
  Name :String;
begin

  if prSelectionLists.Items.Count = 0 then Exit;
  if prSelectionLists.ItemIndex < 0 then Exit;

  List := prSelectionLists.List[prSelectionLists.ItemIndex];
  if List = nil then Exit;
  Name := ChangeFileExt(prSelectionLists.Items.Strings[prSelectionLists.ItemIndex], '_lst.txt');

  Dlg := TSaveDialog.Create(Self);

  try

    Dlg.Filter   := 'List files (*.txt)|*.txt|All files (*.*)|*.*';
    Dlg.Options  := [ofPathMustExist, ofOverwritePrompt, ofEnableSizing];
    Dlg.FileName := Name;
    if Dlg.Execute then begin

      List.SaveToFile(Dlg.FileName);
      prSelectionLists.Items.Strings[prSelectionLists.ItemIndex] := ChangeFileExt(ExtractFileName(Dlg.FileName), '');

    end;

  finally

    Dlg.Free;

  end;

end;

function TQUB_QVO_QVD.prAddList(Name :String): TQUB_QVO_QVD_SelectionList;
begin
  Result := TQUB_QVO_QVD_SelectionList.Create(prSelectionLists);//What Owner ?!
  Result.Parent            := prSelectionListPanel;
  Result.Color             := clBtnFace;
  Result.OnKeyDown         := prOnSelectionListKeyDown;
  Result.Events.AddEvent('ItemChanged', prOnSelectionListItemChange);
  Result.Events.AddEvent('ItemDblClicked', prOnSelectionListItemDblClick);
  Result.Events.AddEvent('ActiveChanged', prOnSelectionListActiveChanged);
  Result.Events.AddEvent('ActiveRangeChanged', prOnSelectionListActiveChanged);
  Result.OnMouseDown       := TPanel(Parent).OnMouseDown;
  Result.PopupMenu         := prSelectionListPopupMenu;
  prSelectionLists.AddList(Result, Name);
  if CurrList <> nil then CurrList.Activate else ChooseList(prSelectionLists.Items.Count - 1);
end;


//****************************************************************************//
//                                                                            //
//             I N T E R A C T I V E      P R O P E R T I E S                 //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVD.prSetMargin(Index :Integer; m :Integer);
begin
  inherited;
  if prZoom <> nil then begin
    case Index of
      0: prZoom.MarginLeft   := Self.MarginLeft;
      1: prZoom.MarginTop    := Self.MarginTop;
      2: prZoom.MarginRight  := Self.MarginRight;
      3: prZoom.MarginBottom := Self.MarginBottom;
    end;
  end;
end;

procedure TQUB_QVO_QVD.prSetColor(c :TColor);
begin
  inherited;
  if prZoom <> nil then prZoom.Color := c;
  DisplayProperties['Color'].Data[0] := Integer(c);
end;

procedure TQUB_QVO_QVD.prSetColorBack(c :TColor);
begin
  inherited;
  if prZoom <> nil then prZoom.ColorBack := Self.ColorBack;
  DisplayProperties['Color Back'].Data[0] := Integer(c);
end;

procedure TQUB_QVO_QVD.prSetColorFrame(c :TColor);
begin
  inherited;
  if prZoom <> nil then prZoom.ColorFrame := Self.ColorFrame;
  DisplayProperties['Color Frame'].Data[0] := Integer(c);
end;

procedure TQUB_QVO_QVD.prSetColorData(Index :Integer; c :TColor);
begin
  prColorData[((Index) mod 8)] := c;
  if prZoom <> nil then prZoom.ColorData[Index] := Self.ColorData[Index];
  prMustRedraw := True;
  DisplayProperties[Format('Color Data %d', [Index mod 8])].Data[0] := Integer(c);
end;

function TQUB_QVO_QVD.prGetColorData(Index :Integer) :TColor;
begin
  Result := prColorData[((Index) mod 8)];
end;

procedure TQUB_QVO_QVD.prSetColorSel(c :TColor);
begin
  prColorSel := c;
  if prZoom <> nil then prZoom.ColorSel := Self.ColorSel;
  DisplayProperties['Color Sel'].Data[0] := Integer(c);
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVD.prSetColorBreak(c :TColor);
begin
  prColorBreak := c;
  if prZoom <> nil then prZoom.ColorBreak := Self.ColorBreak;
  DisplayProperties['Color Break'].Data[0] := Integer(c);
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVD.prSetColorBaseline(c :TColor);
begin
  prColorBaseline := c;
  if prZoom <> nil then prZoom.ColorBaseline := Self.ColorBaseline;
  DisplayProperties['Color Baseline'].Data[0] := Integer(c);
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVD.prSetColorBaselineNodes(c :TColor);
begin
  prColorBaselineNodes := c;
  if prZoom <> nil then prZoom.ColorBaselineNodes := Self.ColorBaselineNodes;
  DisplayProperties['Color BaselineNodes'].Data[0] := Integer(c);
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVD.prSetColorIdealized(c :TColor);
begin
  prColorIdealized := c;
  if prZoom <> nil then prZoom.ColorIdealized := Self.ColorIdealized;
  DisplayProperties['Color Idealized'].Data[0] := Integer(c);
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVD.prSetColorIdealizedSel(c :TColor);
begin
  prColorIdealizedSel := c;
  if prZoom <> nil then prZoom.ColorIdealizedSel := Self.ColorIdealizedSel;
  DisplayProperties['Color IdealizedSel'].Data[0] := Integer(c);
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVD.prSetColorSelList(c :TColor);
begin
  prColorSelList := c;
  // if prZoom <> nil then prZoom.ColorSelList := Self.ColorSelList;
  DisplayProperties['Color SelList'].Data[0] := Integer(c);
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVD.prSetColorParameters(c :TColor);
begin
  prColorParameters := c;
  // if prZoom <> nil then prZoom.ColorParameters := Self.ColorParameters;
  DisplayProperties['Color Parameters'].Data[0] := Integer(c);
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVD.prSetColorSegLabel(c :TColor);
begin
  prColorSegLabel := c;
  // if prZoom <> nil then prZoom.ColorSegLabel := Self.ColorSegLabel;
  DisplayProperties['Color SegLabel'].Data[0] := Integer(c);
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVD.prSetColorCurr(c :TColor);
begin
  prColorCurr := c;
  if prZoom <> nil then prZoom.ColorCurr := Self.ColorCurr;
  DisplayProperties['Color Curr'].Data[0] := Integer(c);
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVD.prSetPage(TracesPerPage, PointsPerTrace, CacheSize :Integer);
begin
  if TracesPerPage * PointsPerTrace > CacheSize then begin
    MessageHelpDlg('(Traces per page * Points per trace) is larger than Cache size'#13#10 + 'Please try to decrease the number of traces per page, or points per trace,'#13#10 + 'or increase the cache size', mtError, [mbOK], 0, 'Error:Larger_than_Cache_size');
    Exit;
  end;

  prTracesPerPage  := TracesPerPage;
  prPointsPerTrace := PointsPerTrace;
  prCacheSize      := CacheSize;

  DisplayProperties['TracesPerPage'].Data[0]  := TracesPerPage;
  DisplayProperties['PointsPerTrace'].Data[0] := PointsPerTrace;
  DisplayProperties['CacheSize'].Data[0]      := CacheSize;

  prMustRedraw := True;
  //Browse(QUB_QVO_QVD_CMD_GOTO_POINT, prDataDraw.First, prDataDraw.First, False{Display}, True{SetScroll}, False{Process}, False, False{Append}, True{SetZoom});
end;

procedure TQUB_QVO_QVD.prSetTracesPerPage(t :Integer);
begin
  if t * prPointsPerTrace > prCacheSize then begin
    MessageHelpDlg('Value too large'#13#10 + 'Please try to decrease the number of points per trace,'#13#10 + 'or increase the cache size', mtError, [mbOK], 0, 'Error:Larger_than_Cache_size');
    Exit;
  end;

  prTracesPerPage := t;
  DisplayProperties['TracesPerPage'].Data[0]  := TracesPerPage;

  prMustRedraw := True;
  //Browse(QUB_QVO_QVD_CMD_GOTO_POINT, prDataDraw.First, prDataDraw.First, False{Display}, True{SetScroll}, False{Process}, False, False{Append}, True{SetZoom});
end;

procedure TQUB_QVO_QVD.prSetPointsPerTrace(p :Integer);
begin
  if prTracesPerPage * p > prCacheSize then begin
    MessageHelpDlg('Value too large'#13#10 + 'Please try to decrease the number of traces per page,'#13#10 + 'or increase the cache size', mtError, [mbOK], 0, 'Error:Larger_than_Cache_size');
    Exit;
  end;

  prPointsPerTrace := p;
  DisplayProperties['PointsPerTrace'].Data[0] := PointsPerTrace;

  prMustRedraw := True;
  //Browse(QUB_QVO_QVD_CMD_GOTO_POINT, prDataDraw.First, prDataDraw.First, False{Display}, True{SetScroll}, False{Process}, False, False{Append}, True{SetZoom});
end;

procedure TQUB_QVO_QVD.prSetCacheSize(c :Integer);
begin
  if prTracesPerPage * prPointsPerTrace > c then begin
    MessageHelpDlg('Value too small'#13#10 + 'Please try to decrease the number of traces per page,'#13#10 + 'or decrease the number of points per trace', mtError, [mbOK], 0, 'Error:Larger_than_Cache_size');
    Exit;
  end;
  prCacheSize := c;
  DisplayProperties['CacheSize'].Data[0]      := CacheSize;
end;

procedure TQUB_QVO_QVD.prSetScaling(s :Double);
begin
  prScaling := s;
  prDataObject.Scaling := Scaling;
  if prZoom <> nil then prZoom.Scaling := Scaling;
  prUpdateStimValues(DataCurr);
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVD.prSetSampling(s :Double);
begin
  prSampling := s;
  prDataObject.Sampling := Sampling;
  if prZoom <> nil then prZoom.Sampling := Sampling;
  prMustRedraw := True;
end;

procedure TQUB_QVO_QVD.prSetMarginH(m :Integer);
begin
  prMarginH      := m;
  prMargin.Left  := m;
  prMargin.Right := m;
  if prZoom <> nil then begin
    prZoom.MarginLeft  := m;
    prZoom.MarginRight := m;
  end;
  prMustRedraw := True;
  DisplayProperties['MarginH'].Data[0] := m;
end;

procedure TQUB_QVO_QVD.prSetMarginV(m :Integer);
begin
  prMarginV      := m;
  prMargin.Top    := m;
  prMargin.Bottom := m;
  if prZoom <> nil then begin
    prZoom.MarginTop    := m;
    prZoom.MarginBottom := m;
  end;
  prMustRedraw := True;
  DisplayProperties['MarginV'].Data[0] := m;
end;

procedure TQUB_QVO_QVD.prSetTraceChangeOnBreak(c :Boolean);
begin
  prTraceChangeOnBreak := c;

  if prDataSegmentCount > 1 then begin
    prMustRedraw := True;
    //Browse(QUB_QVO_QVD_CMD_GOTO_POINT, prDataDraw.First, prDataDraw.First, False{Display}, True{SetScroll}, False{Process}, False, False{Append}, True{SetZoom});
  end;
  DisplayProperties['TraceChangeOnBreak'].Data[0] := Integer(c);
end;

procedure TQUB_QVO_QVD.prSetOverlapChannels(o :Boolean);
begin
  prOverlapChannels := o;
  if prZoom <> nil then prZoom.OverlapChannels := Self.OverlapChannels;
  if prDataChannelCount > 1 then begin
    prMustRedraw := True;
  end;
  DisplayProperties['OverlapChannels'].Data[0] := Integer(o);
end;

procedure TQUB_QVO_QVD.prSetOverlapTraces(o :Boolean);
begin
  prOverlapTraces := o;
  if prTracesPerPage > 1 then begin
    prMustRedraw := True;
  end;
  DisplayProperties['OverlapTraces'].Data[0] := Integer(o);
end;

procedure TQUB_QVO_QVD.prSetDrawPoints(p :Boolean);
begin
  prDrawPoints := p;
  if prZoom <> nil then prZoom.DrawPoints := Self.DrawPoints;
  prMustRedraw := True;
  DisplayProperties['DrawPoints'].Data[0] := Integer(p);
end;

procedure TQUB_QVO_QVD.prSetDrawInverted(i :Boolean);
begin
  prDrawInverted := i;
  if prZoom <> nil then prZoom.DrawInverted := Self.DrawInverted;
  prMustRedraw := True;
  DisplayProperties['DrawInverted'].Data[0] := Integer(i);
end;

procedure TQUB_QVO_QVD.prSetDrawRaster(r :Boolean);
begin
  prDrawRaster := r;
  if prZoom <> nil then prZoom.DrawRaster := Self.DrawRaster;
  prMustRedraw := True;
  DisplayProperties['DrawRaster'].Data[0] := Integer(r);
end;

procedure TQUB_QVO_QVD.prSetDrawLabels(l :Boolean);
begin
  prDrawLabels := l;
  if prZoom <> nil then prZoom.DrawLabels := Self.DrawLabels;
  prMustRedraw := True;
  DisplayProperties['DrawLabels'].Data[0] := Integer(l);
end;

procedure TQUB_QVO_QVD.prSetDrawActiveThick(t :Boolean);
begin
  prDrawActiveThick := t;
  if prZoom <> nil then prZoom.DrawActiveThick := Self.DrawActiveThick;
  prMustRedraw := True;
  DisplayProperties['DrawActiveThick'].Data[0] := Integer(t);
end;

procedure TQUB_QVO_QVD.prSetDrawBaseline(b :Boolean);
begin
  prDrawBaseline := b;
  if prZoom <> nil then prZoom.DrawBaseline := Self.DrawBaseline;
  prMustRedraw := True;
  DisplayProperties['DrawBaseline'].Data[0] := Integer(b);
end;

procedure TQUB_QVO_QVD.prSetDrawIdealized(i :Boolean);
begin
  prDrawIdealized := i;
  if prZoom <> nil then prZoom.DrawIdealized := Self.DrawIdealized;
  prMustRedraw := True;
  DisplayProperties['DrawIdealized'].Data[0] := Integer(i);
  Events.RaiseNotifyEvent('OnDrawIdealizedChange', Self);
end;

procedure TQUB_QVO_QVD.prSetDrawIdealizedAbove(a :Boolean);
begin
  prDrawIdealizedAbove := a;
  if prZoom <> nil then prZoom.DrawIdealizedAbove := Self.DrawIdealizedAbove;
  prMustRedraw := True;
  DisplayProperties['DrawIdealizedAbove'].Data[0] := Integer(a);
end;

procedure TQUB_QVO_QVD.prSetDrawIdealizedColor(c :Boolean);
begin
  prDrawIdealizedColor := c;
  if prZoom <> nil then prZoom.DrawIdealizedColor := Self.DrawIdealizedColor;
  prMustRedraw := True;
  DisplayProperties['DrawIdealizedColor'].Data[0] := Integer(c);
end;

procedure TQUB_QVO_QVD.prSetDrawListOverlapped(l :Boolean);
begin
  prDrawListOverlapped := l;
  if prZoom <> nil then prZoom.DrawListOverlapped := Self.DrawListOverlapped;
  if l then begin
    prDataSel.First := 0;
    prDataSel.Last  := 0;
  end;
  prMustRedraw := True;
  DisplayProperties['DrawListOverlapped'].Data[0] := Integer(l);
  //TO DO. LM
  //Events.RaiseNotifyEvent('OnDrawIdealizedChange', Self);
end;

procedure TQUB_QVO_QVD.prSetDrawSelList(x :Boolean);
begin
  prDrawSelList := x;
  // if prZoom <> nil then prZoom.DrawSelList := Self.DrawSelList; //Draw it in here too?! LM
  prMustRedraw := True;
  DisplayProperties['DrawSelList'].Data[0] := Integer(x);
end;

procedure TQUB_QVO_QVD.prSetDrawParameters(x :Boolean);
begin
  prDrawParameters := x;
  // if prZoom <> nil then prZoom.DrawParameters := Self.DrawParameters; //Draw it in here too?! LM
  prMustRedraw := True;
  DisplayProperties['DrawParameters'].SetData(Integer(x));
end;

procedure TQUB_QVO_QVD.prSetDrawBaselineNodes(b :Boolean);
begin
  prDrawBaselineNodes := b;
  if prZoom <> nil then prZoom.DrawBaselineNodes := Self.DrawBaselineNodes;
  prMustRedraw := True;
  DisplayProperties['DrawBaselineNodes'].Data[0] := Integer(b);
end;

procedure TQUB_QVO_QVD.prSetDrawSegLabels(b :Boolean);
begin
  prDrawSegLabels := b;
  //if prZoom <> nil then prZoom.DrawSegLabels := Self.DrawSegLabels;
  prMustRedraw := True;
  DisplayProperties['DrawSegLabels'].Data[0] := Integer(b);
end;

procedure TQUB_QVO_QVD.prSetDrawMode(m :TQUB_QVO_QVD_DrawMode);
begin
  prDrawMode := m;
  if prZoom <> nil then prZoom.DrawMode := Self.DrawMode;
  prMustRedraw := True;
  DisplayProperties['DrawMode'].Data[0] := Integer(m);
end;

procedure TQUB_QVO_QVD.prSetAutoScale(a :Boolean);
var
  i :Integer;
begin
  prAutoScale := a;
  if prZoom <> nil then begin
    for i := 0 to QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1 do begin
      if prAutoScale then begin
        prZoom.DataYMin[i] := DataYMinAuto[i];
        prZoom.DataYMax[i] := DataYMaxAuto[i];
      end else begin
        prZoom.DataYMin[i] := DataYMin[i];
        prZoom.DataYMax[i] := DataYMax[i];
      end;
    end;
  end;
  prMustRedraw := True;
  DisplayProperties['AutoScale'].Data[0] := Integer(a);
end;

function TQUB_QVO_QVD.prGetScaleBarADUnits(Index :Integer) :Integer;
begin
  Result := prScaleBarADUnits[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD.prSetDataYMin(Index :Integer; m :Integer);
begin
  prDataYMin[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := m;
  if not prAutoScale then begin
    if prZoom <> nil then prZoom.DataYMin[Index] := DataYMin[Index];
  end;
  prMustRedraw := True;
  DisplayProperties['DataYMin'].Data[Index] := m;
end;

function TQUB_QVO_QVD.prGetDataYMin(Index :Integer) :Integer;
begin
  Result := prDataYMin[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD.prSetDataYMax(Index :Integer; m :Integer);
begin
  prDataYMax[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := m;
  if not prAutoScale then begin
    if prZoom <> nil then prZoom.DataYMax[Index] := DataYMax[Index];
  end;
  prMustRedraw := True;
  DisplayProperties['DataYMax'].Data[Index] := m;
end;

function TQUB_QVO_QVD.prGetDataYMax(Index :Integer) :Integer;
begin
  Result := prDataYMax[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD.prSetDataYFactor(Index :Integer; f :Double);
begin
  prDataYFactor[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := f;
  if not prAutoScale then begin
    if prZoom <> nil then prZoom.DataYFactor[Index] := DataYFactor[Index];
  end;
  prMustRedraw := True;
  DisplayProperties['DataYFactor'].Data[Index] := f;
end;

function TQUB_QVO_QVD.prGetDataYFactor(Index :Integer) :Double;
begin
  Result := prDataYFactor[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD.prSetDrawItoG(Index :Integer; d :Boolean);
begin
  prDrawItoG[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := d;
  if prZoom <> nil then prZoom.DrawItoG[Index] := DrawItoG[Index];
  prMustRedraw := True;
  //TO DO
  //DisplayProperties['DrawItoG'].Data[Index] := d;
end;

function TQUB_QVO_QVD.prGetDrawItoG(Index :Integer) :Boolean;
begin
  Result := prDrawItoG[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD.prSetChannelVisible(Index :Integer; o :Boolean);
begin
  prChannelVisible[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := o;
  if prZoom <> nil then prZoom.ChannelVisible[Index] := o;
  prMustRedraw := True;
  DisplayProperties['ChannelVisible'].Data[Index] := Integer(o);
end;

function TQUB_QVO_QVD.prGetChannelVisible(Index :Integer) :Boolean;
begin
  Result := prChannelVisible[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD.prSetDataChannelName(Index :Integer; x :String);
begin
  prDataChannelName[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := x;
  if prZoom <> nil then prZoom.DataChannelName[Index] := x;
  if prDrawLabels then prMustRedraw := True;
end;

function TQUB_QVO_QVD.prGetDataChannelName(Index :Integer) :String;
begin
  Result := prDataChannelName[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD.prSetDataChannelUnits(Index :Integer; x :String);
begin
  prDataChannelUnits[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := x;
  if prZoom <> nil then prZoom.DataChannelUnits[Index] := x;
  if prDrawLabels then prMustRedraw := True;
end;

function TQUB_QVO_QVD.prGetDataChannelUnits(Index :Integer): String;
begin
  Result := prDataChannelUnits[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD.prSetDataChannelScaling(Index :Integer; x :Double);
var
  s               :Integer;
begin
  prDataChannelScaling[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := x;
  if prZoom <> nil then prZoom.DataChannelScaling[Index] := x;
  prUpdateStimValues(DataCurr);
  if prDrawLabels then prMustRedraw := True;

  if (((x < 0) and (prDataYMin[Index] < prDataYMax[Index]))
  or  ((x > 0) and (prDataYMin[Index] > prDataYMax[Index]))) then begin
    s               := prDataYMax[Index];
    DataYMax[Index] := prDataYMin[Index];
    DataYMin[Index] := s;
  end;
end;

function TQUB_QVO_QVD.prGetDataChannelScaling(Index :Integer): Double;
begin
  Result := prDataChannelScaling[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD.prSetDataChannelOffset(Index :Integer; x :Double);
begin
  prDataChannelOffset[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := x;
  if prZoom <> nil then prZoom.DataChannelOffset[Index] := x;
  prUpdateStimValues(DataCurr);
  if prDrawLabels then prMustRedraw := True;
end;

function TQUB_QVO_QVD.prGetDataChannelOffset(Index :Integer): Double;
begin
  Result := prDataChannelOffset[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

//Graphics settings
procedure TQUB_QVO_QVD.prSetXAxisTickCount(c :Integer);
begin
  prXAxisTickCount := c;
  if prZoom <> nil then prZoom.XAxisTickCount := c;
  if prDrawLabels then prMustRedraw := True;
end;

function TQUB_QVO_QVD.prGetXAxisTickCount: Integer;
begin
  Result := prXAxisTickCount;
end;

procedure TQUB_QVO_QVD.prSetYAxisTickCount(Index :Integer; c :Integer);
begin
  prYAxisTickCount[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := c;
  if prZoom <> nil then prZoom.YAxisTickCount[Index] := c;
  if prDrawLabels then prMustRedraw := True;
end;

function TQUB_QVO_QVD.prGetYAxisTickCount(Index :Integer): Integer;
begin
  Result := prYAxisTickCount[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

//Filter
procedure TQUB_QVO_QVD.prSetFilterOn(Index :Integer; o :Boolean);
begin
  prFilterOn[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := o;
  if o then begin
    prDataChannelProcess[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := prDataChannelProcess[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] or  QUB_QVO_QVD_PROCESS_SET_FILTER_ON;
  end else begin
    prDataChannelProcess[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := prDataChannelProcess[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] and QUB_QVO_QVD_PROCESS_SET_FILTER_OFF;
  end;
  prMustRedraw := True;
  DisplayProperties['FilterOn'].Data[Index] := Integer(o);
  //DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA, 0);
  Events.RaiseNotifyEvent('OnFilterChange', Self);
end;

function TQUB_QVO_QVD.prGetFilterOn(Index :Integer) :Boolean;
begin
  Result := prFilterOn[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD.prSetFilterMAOn(Index :Integer; o :Boolean);
begin
  prFilterMAOn[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := o;
  prMustRedraw := True;
  DisplayProperties['FilterMAOn'].Data[Index] := Integer(o);
end;

function  TQUB_QVO_QVD.prGetFilterMAOn(Index :Integer) :Boolean;
begin
  Result := prFilterMAOn[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD.prSetFilterFreq(Index :Integer; f :Double);
begin
  prFilterFreq[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := f;
  prMustRedraw := True;
  DisplayProperties['FilterFreq'].Data[Index] := f;
  //DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA, 0);
  Events.RaiseNotifyEvent('OnFilterChange', Self);
end;

function TQUB_QVO_QVD.prGetFilterFreq(Index :Integer) :Double;
begin
  Result := prFilterFreq[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD.prSetFilterMACount(Index :Integer; c :Integer);
begin
  prFilterMACount[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := c;
  prMustRedraw := True;
  DisplayProperties['FilterMACount'].Data[Index] := c;
end;

function TQUB_QVO_QVD.prGetFilterMACount(Index :Integer) :Integer;
begin
  Result := prFilterMACount[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;


//Baseline
procedure TQUB_QVO_QVD.prSetBaselineOn(Index :Integer; o :Boolean);
begin
  prBaselineOn[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := o;
  if o then begin
    prDataChannelProcess[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := prDataChannelProcess[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] or  QUB_QVO_QVD_PROCESS_SET_BASELINE_ON;
  end else begin
    prDataChannelProcess[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := prDataChannelProcess[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] and QUB_QVO_QVD_PROCESS_SET_BASELINE_OFF;
  end;
  prMustRedraw := True;
  DisplayProperties['BaselineOn'].Data[Index] := Integer(o);
  //DataMessage(DATA_MSG_BROWSE or DATA_MSG_DRAW_DATA or DATA_MSG_PROC_DATA, 0);
  Events.RaiseNotifyEvent('OnBaselineApplyChange', Self);
end;

function TQUB_QVO_QVD.prGetWarnOnBaseline(Index :Integer) :Boolean;
begin
  Result := prWarnOnBaseline[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD.prSetWarnOnBaseline(Index :Integer; o :Boolean);
begin
  prWarnOnBaseline[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := o;
end;

function TQUB_QVO_QVD.prGetBaselineOn(Index :Integer) :Boolean;
begin
  Result := prBaselineOn[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD.prSetTipsOn(t :Boolean);
begin
  inherited;
  if prZoom <> nil then prZoom.ShowHint := t;
end;
//******************************************************************************




//****************************************************************************//
//                                                                            //
//         N O N   -   I N T E R A C T I V E      P R O P E R T I E S         //
//                                                                            //
//****************************************************************************//
procedure TQUB_QVO_QVD.prSetConteinerResults(c :TPanel);
begin
  prConteinerResults := c;
  prResultsList.Parent := prConteinerResults;
end;

procedure TQUB_QVO_QVD.prSetConteinerList(c :TPanel);
begin
  prConteinerLists := c;
  prSelectionLists.Parent := prConteinerLists;
end;

procedure TQUB_QVO_QVD.prSetConteinerSel(c :TPanel);
begin
  prConteinerList := c;
  prSelectionListPanel.Parent := prConteinerList;
end;

procedure TQUB_QVO_QVD.prSetZoom(z :TQUB_QVO_QVT);
var
  i :Integer;
begin
  prZoom := z;
  if prZoom = nil then Exit;
  prZoom.DataSource := Self;
  with prZoom do begin
    MarginLeft                                    := Self.MarginLeft;
    MarginTop                                     := Self.MarginTop;
    MarginRight                                   := Self.MarginRight;
    MarginBottom                                  := Self.MarginBottom;
    //Colors
    Color                                         := Self.Color;
    ColorBack                                     := Self.ColorBack;
    for i := 0 to 7 do ColorData[i]               := Self.ColorData[i];
    ColorSel                                      := Self.ColorSel;
    ColorBreak                                    := Self.ColorBreak;
    ColorFrame                                    := Self.ColorFrame;
    ColorBaseline                                 := Self.ColorBaseline;
    ColorBaselineNodes                            := Self.ColorBaselineNodes;
    ColorIdealized                                := Self.ColorIdealized;
    ColorIdealizedSel                             := Self.ColorIdealizedSel;
    // ColorSelList                                  := Self.ColorSelList;
    ColorParameters                               := Self.ColorParameters;
    // ColorSegLabel                                 := Self.ColorSegLabel;
    ColorCurr                                     := Self.ColorCurr;
    OverlapChannels                               := Self.OverlapChannels;
    //OverlapTraces                                 := Self.OverlapTraces;
    DrawPoints                                    := Self.DrawPoints;
    DrawInverted                                  := Self.DrawInverted;
    DrawRaster                                    := Self.DrawRaster;
    DrawLabels                                    := Self.DrawLabels;
    DrawActiveThick                               := Self.DrawActiveThick;
    DrawBaseline                                  := Self.DrawBaseline;
    DrawBaselineNodes                             := Self.DrawBaselineNodes;
    //DrawSegLabels                                 := Self.DrawSegLabels;
    DrawIdealized                                 := Self.DrawIdealized;
    DrawIdealizedAbove                            := Self.DrawIdealizedAbove;
    DrawIdealizedColor                            := Self.DrawIdealizedColor;
    DrawListOverlapped                            := Self.DrawListOverlapped;
    // DrawSelList                                   := Self.DrawSelList;
    DrawParameters                                := Self.DrawParameters;
    DrawMode                                      := Self.DrawMode;
    //AutoScale                                     := Self.AutoScale;
    for i := 0 to QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1 do begin
      ChannelVisible[i]                           := Self.ChannelVisible[i];
      if Self.AutoScale then begin
        DataYMin[i]                               := Self.DataYMinAuto[i];
        DataYMax[i]                               := Self.DataYMaxAuto[i];
      end else begin
        DataYMin[i]                               := Self.DataYMin[i];
        DataYMax[i]                               := Self.DataYMax[i];
      end;
      DataYFactor[i]                              := Self.DataYFactor[i];
      DrawItoG[i]                                 := Self.DrawItoG[i];
      DataBaseline[i]                             := Self.DataBaseline[i];
      BaselineNodes[i]                            := Self.BaselineNodes[i];
    end;
    AutoScroll                                    := Self.AutoScroll;
    FitCurves                                     := Self.FitCurves;
    //Markers
    DataMarker                                    := Self.DataMarker;
    DataMarkers                                   := Self.DataMarkers;
    DataMarkersCh                                 := Self.DataMarkersCh;
    DataMarkersCount                              := Self.DataMarkersCount;
    //Time Markers
    DataTimeMarker                                := Self.DataTimeMarker;
    DataTimeMarkers                               := Self.DataTimeMarkers;
    DataTimeMarkersCount                          := Self.DataTimeMarkersCount;
    //Kinetic Parameters Markers
    DataKinParamsMarker                           := Self.DataKinParamsMarker;
    DataKinParamsMarkers                          := Self.DataKinParamsMarkers;
    DataKinParamsMarkersPars                      := Self.DataKinParamsMarkersPars;
    DataKinParamsMarkersNote                      := Self.DataKinParamsMarkersNote;
    DataKinParamsMarkersCount                     := Self.DataKinParamsMarkersCount;
    OnChangeSel                                   := Self.prOnZoomChangeSel;
    OnEditPoint                                   := Self.prOnZoomEditPoint;
    OnChangeVMarker                               := Self.prOnZoomChangeVMarker;
    OnChangeTMarker                               := Self.prOnZoomChangeTMarker;
    OnChangeKMarker                               := Self.prOnZoomChangeKMarker;
  end;
end;

procedure TQUB_QVO_QVD.prSetDataYMinAuto(Index :Integer; m :Integer);
begin
  prDataYMinAuto[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := m;
  if prAutoScale then begin
    if prZoom <> nil then prZoom.DataYMin[Index] := DataYMinAuto[Index];
  end;
end;

function TQUB_QVO_QVD.prGetDataYMinAuto(Index :Integer) :Integer;
begin
  Result := prDataYMinAuto[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD.prSetDataYMaxAuto(Index :Integer; m :Integer);
begin
  prDataYMaxAuto[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)] := m;
  if prAutoScale then begin
    if prZoom <> nil then prZoom.DataYMax[Index] := DataYMaxAuto[Index];
  end;
end;

function TQUB_QVO_QVD.prGetDataYMaxAuto(Index :Integer) :Integer;
begin
  Result := prDataYMaxAuto[Index mod (QUB_QFS_QDF_MAX_ADCHANNELCOUNT)];
end;

procedure TQUB_QVO_QVD.prSetListed(x :Boolean);
begin
  if prListed <> x then begin
    prListed := x;
    if Events <> nil then Events.RaiseNotifyEvent('OnListedChanged', Self);
  end;
end;

function TQUB_QVO_QVD.prGetCurrList: TQUB_QVO_QVD_SelectionList;
begin
  Result := nil;

  if prSelectionLists.Items.Count = 0 then Exit;
  if prSelectionLists.ItemIndex = -1 then Exit;
  Result := prSelectionLists.List[prSelectionLists.ItemIndex];
end;

procedure TQUB_QVO_QVD.prSetDataCurr(c :Integer);
begin
  prDataCurr     := c;
  prDataOldCurr  := prDataCurr;

  prSetHint;
  prUpdateStimValues(DataCurr);

  //Set Zoom Data
  prSetZoomData(True{ZoomDraw});
end;


//----- Calculate average and standard deviation for sel
//Does NOT return scaled values!!!
function TQUB_QVO_QVD.GetAverage(Channel :Integer; var Avg, Std :Double) :Boolean;
var
  Sel      :TQUB_FirstLast;
  Scl      :Double;
  point    :Integer;
begin
  //Sel := prDataSel;

  { TODO : John, the convention used in qub is Result <> 0 if error. Please follow it. LM }
  { TODO : Check channel scaling. LM. }
  if Zoom = nil  then begin
    Sel := DataSel;
  end else begin
    if ((DataZoomSel.First + (prDataDraw.First - prDataPoint.First)) >= DataSel.First) and ((DataZoomSel.Last + (prDataDraw.First - prDataPoint.First)) <= DataSel.Last) then begin
      Sel.First := DataZoomSel.First + prDataDraw.First - prDataPoint.First;//DataOffset;
      Sel.Last  := DataZoomSel.Last  + prDataDraw.First - prDataPoint.First;
      if Sel.First >= Sel.Last then begin
        Sel := DataSel;
      end;
    end else begin
      Sel := DataSel;
    end;
  end;

  Scl := 1 / Scaling;
  Avg := 0;
  Std := 0;
  if prDataChannelDisplay[channel] = nil then begin
    Result := False;
  end else if (Sel.Last<prDataDraw.First) or (Sel.First>prDataDraw.Last) then begin
    Result := False;
  end else if (Sel.First=Sel.Last) then begin
    Avg := Scl * prDataChannelDisplay[channel, Sel.First-prDataDraw.First];
    Std := 1;
    Result := True;
  end else begin
    //-- Limit range of data
    Sel.First := Max(prDataDraw.First, Sel.First);
    Sel.Last  := Min(prDataDraw.Last,  Sel.Last);
    //-- Calc average
    try
      for point := Sel.First to Sel.Last do begin
        Avg := Avg + Scl * prDataChannelDisplay[channel, point - prDataDraw.First];
      end;
    except
    end;
    Avg := Avg / (Sel.Last - Sel.First + 1);

    //-- calc std dev
    try
      for point := Sel.First to Sel.Last do begin
        Std := Std + Sqr(Scl * prDataChannelDisplay[channel, point - prDataDraw.First] - Avg);
      end;
    except
    end;
    Std := Sqrt(Std / (Sel.Last - Sel.First + 1));
    Result := True;
  end;

end;

//Returns scaled values
function TQUB_QVO_QVD.GetAverage(Channel :Integer; First, Last :Integer; var Avg, Std :Double) :Boolean;
var
  Sel      :TQUB_FirstLast;
  Scl      :Double;
  Off      :Double;
  point    :Integer;
begin

  Result   := False;

  Sel.First:= First;
  Sel.Last := Last;

  Scl      := 1 / (Scaling * prDataChannelScaling[Channel]);
  Off      := prDataChannelOffset[Channel];
  Avg      := 0;
  Std      := 0;

  if prDataChannelDisplay[channel] = nil then begin

    Result := True;

  end else if (Sel.Last < prDataDraw.First) or (Sel.First > prDataDraw.Last) then begin

    Result := True;

  end else if (Sel.First = Sel.Last) then begin

    Avg    := Scl * prDataChannelDisplay[Channel, Sel.First - prDataDraw.First] + Off;
    Std    := 1;

  end else begin

    //-- Limit range of data
    Sel.First := Max(prDataDraw.First, Sel.First);
    Sel.Last  := Min(prDataDraw.Last,  Sel.Last);

    //-- Calc average
    try
      for Point := Sel.First to Sel.Last do begin
        Avg := Avg + Scl * prDataChannelDisplay[Channel, Point - prDataDraw.First] + Off;
      end;
    except
      Result := True;
    end;
    Avg := Avg / (Sel.Last - Sel.First + 1);

    //-- calc std dev
    try
      for Point := Sel.First to Sel.Last do begin
        Std := Std + Sqr(Scl * prDataChannelDisplay[Channel, Point - prDataDraw.First] + Off - Avg);
      end;
    except
      Result := True;
    end;
    Std := Sqrt(Std / (Sel.Last - Sel.First + 1));

  end;

  Avg := Avg;
  Std := Std;

end;

//Returns scaled values
function TQUB_QVO_QVD.Average(Channel :Integer; First, Last :Integer) :Double;
const
  BUFFCOUNT = 16384;
var
  Sel       :TQUB_FirstLast;
  Avg       :Double;
  Scl       :Double;
  Off       :Double;
  Point     :Integer;
  Buffer    :TPAInteger;
  Count     :Integer;
  f, l      :Integer;
begin

  Result    := 0;
  if (Last < DataPoint.First) or (First > DataPoint.Last) then begin
    Result  := 0;
    Exit;
  end;

  f := Max(DataPoint.First, First);
  l := Min(DataPoint.Last,  Last);

  Buffer    := nil;

  Scl       := 1 / (Scaling * prDataChannelScaling[Channel]);
  Off       := prDataChannelOffset[Channel];
  Avg       := 0;

  if (l - f + 1) > BUFFCOUNT then Count := BUFFCOUNT else Count := l - f + 1;

  try

    try

      Buffer := IAlloc1(Count);

      Sel.First := f;

      repeat

        Sel.Last  := Sel.First + Count - 1;
        if Sel.Last > Last then Sel.Last := l;

        try
          if LoadDataChannel(Buffer, Channel, Sel, True{Process}, True{ProcessFilter}, True{ProcessBaseLine}) then Exit;
        except
        end;

        for Point := Sel.First to Sel.Last do begin
          Avg := Avg + Scl * Buffer[Point - Sel.First] + Off;
        end;

        Sel.First := Sel.Last + 1;

      until Sel.First > l;

      Avg := Avg / (l - f + 1);

    except
    end;

  finally

    FreeMem(Buffer);
    Result := Avg;

  end;

  Result := Result;

end;

function TQUB_QVO_QVD.GetMinMax(Channel :Integer; First, Last :Integer; var Min, Max :Double; var MinIdx, MaxIdx :Integer) :Boolean;
var
  Sel      :TQUB_FirstLast;
  Scl      :Double;
  Off      :Double;
  v        :Double;
  point    :Integer;
begin

  Result   := False;

  Sel.First:= First;
  Sel.Last := Last;

  Scl      := 1 / (Scaling * prDataChannelScaling[Channel]);
  Off      := prDataChannelOffset[Channel];
  Min      := 0;
  Max      := 0;
  MinIdx   := First;
  MaxIdx   := First;

  if prDataChannelDisplay[channel] = nil then begin

    Result := True;

  end else if (Sel.Last < prDataDraw.First) or (Sel.First > prDataDraw.Last) then begin

    Result := True;

  end else if (Sel.First = Sel.Last) then begin

    Min    := Scl * prDataChannelDisplay[Channel, Sel.First - prDataDraw.First] + Off;
    Max    := Min;

  end else begin

    //-- Limit range of data
    Sel.First := Math.Max(prDataDraw.First, Sel.First);
    Sel.Last  := Math.Min(prDataDraw.Last,  Sel.Last);

    //-- Calc average
    try
      Point := Sel.First;
      Min := Scl * prDataChannelDisplay[Channel, Point - prDataDraw.First] + Off;
      Max := Min;
      MinIdx := First;
      MaxIdx := First;

      for Point := Sel.First + 1 to Sel.Last do begin
        v := Scl * prDataChannelDisplay[Channel, Point - prDataDraw.First] + Off;
        if v < Min then begin
          Min    := v;
          MinIdx := Point;
        end;
        if v > Max then begin
          Max    := v;
          MaxIdx := Point;
        end;
      end;
    except
      Result := True;
    end;

  end;

  Min := Min;
  Max := Max;

end;

function TQUB_QVO_QVD.GetClosestIndexOfValue(Channel, First, Last :Integer; Value :Double) :Integer;
var
  Sel      :TQUB_FirstLast;
  Scl      :Double;
  Off      :Double;
  Min      :Double;
  v        :Double;
  point    :Integer;
begin

  Sel.First:= First;
  Sel.Last := Last;

  Scl      := 1 / (Scaling * prDataChannelScaling[Channel]);
  Off      := prDataChannelOffset[Channel];

  if prDataChannelDisplay[channel] = nil then begin

    Result := First - 1;

  end else if (Sel.Last < prDataDraw.First) or (Sel.First > prDataDraw.Last) then begin

    Result := First - 1;

  end else begin

    //-- Limit range of data
    Sel.First := Math.Max(prDataDraw.First, Sel.First);
    Sel.Last  := Math.Min(prDataDraw.Last,  Sel.Last);

    try

      Point  := Sel.First;
      Result := Point;
      Min    := Abs(Value - (Scl * prDataChannelDisplay[Channel, Point - prDataDraw.First] + Off));

      for Point := Sel.First + 1 to Sel.Last do begin
        v := Abs(Value - (Scl * prDataChannelDisplay[Channel, Point - prDataDraw.First] + Off));
        if v < Min then begin
          Min    := v;
          Result := Point;
        end;
      end;

    except
      Result := First - 1;
    end;

  end;

end;
                     

procedure TQUB_QVO_QVD.prSetHint;
var
  Avg      :Double;
  Std      :Double;
  VarOverI :Double;
  AvgHint  :String;
  StdHint  :String;
  VoIHint  :String;
  ch       :Integer;
  ListIter :TQUB_QVO_QVD_SelectionListIter;
  List     :TQUB_QVO_QVD_SelectionList;
  Sel      :TQUB_QVO_QVD_Selection;
  Seg      :TQUB_QFS_Segment;
  First    :Integer;
  Last     :Integer;
  dt       :Double;
begin

  AvgHint  := '';
  StdHint  := '';
  VoIHint  := '';

  First    := prDataSel.First;
  Last     := prDataSel.Last;

  Sel      := nil;

  if prDrawListOverlapped then begin
    List := CurrList;
    if List <> nil then Sel := List.CurrSelection;
    if Sel <> nil then begin
      First := Sel.Sel.First + prDataSel.First;
      Last  := Sel.Sel.First + prDataSel.Last;
    end;
  end;

  for ch := 0 to prDataChannelCount - 1 do begin

    GetAverage(ch, First, Last, Avg, Std);
    if Avg <> 0.0 then begin
      VarOverI := Std*Std/Avg;
    end else begin
      VarOverI := 0.0;
    end;

    //AvgHint := AvgHint + FormatFloat('0.0000e+', Avg/prDataChannelScaling[ch]);
    //StdHint := StdHint + FormatFloat('0.0000e+', Std/prDataChannelScaling[ch]);

    AvgHint := AvgHint + Format('%10.6g ' + prDataChannelUnits[ch], [Avg]);
    StdHint := StdHint + Format('%10.6g ' + prDataChannelUnits[ch], [Std]);
    VoIHint := VoIHint + Format('%10.6g', [VarOverI]);

    if ch < (prDataChannelCount - 1) then begin
      AvgHint := AvgHint + ', ';
      StdHint := StdHint + ', ';
      VoIHint := VoIHint + ', ';
    end;

  end;

  Seg := DataObject.Segments[WhichSegmentForPoint(First)];
  dt  := (1/SecsPerDay)*((First - WhichSegmentFirstForPoint(First) + 1)*prSampling);

  if Seg <> nil then begin
    Hint := 'Start  '+TimeText(First * Sampling) + ' (' + DateTimeToStr(Seg.StartTime + dt) + ')'#13#10 +
            'Length '+TimeText((Last - First) * Sampling)+ #13#10 +
            'Avg         = ' + AvgHint + #13#10 +
            'Std          = ' + StdHint + #13#10 +
            'Var / I      = ' + VoIHint               + #13#10 +
            'Points      = ' + IntToStr(Last - First + 1) + '  [' + IntToStr(First) + ' - ' + IntToStr(Last) + ']' + #13#10 +
            'Segment   = ' + IntToStr(WhichSegmentForPoint(prDataCurr) + 1) + '/' + IntToStr(prDataSegmentCount);
            //Keep above spacing for alignment
  end else begin
    Hint := 'Start  '+TimeText(First * Sampling) + ' (' + DateTimeToStr(0 + dt) + ')'#13#10 +
            'Length '+TimeText((Last - First) * Sampling)+ #13#10 +
            'Avg         = ' + AvgHint + #13#10 +
            'Std          = ' + StdHint + #13#10 +
            'Var / I      = ' + VoIHint               + #13#10 +
            'Points      = ' + IntToStr(Last - First + 1) + '  [' + IntToStr(First) + ' - ' + IntToStr(Last) + ']' + #13#10 +
            'Segment   = ' + IntToStr(WhichSegmentForPoint(prDataCurr) + 1) + '/' + IntToStr(prDataSegmentCount);
            //Keep above spacing for alignment
  end;

  if CurrList <> nil then begin
    ListIter := CurrList.Find(DataCurr, DataCurr, True{ActiveOnly});
    if not ListIter.Done then begin
      if ListIter.Lbl <> '' then begin
        Hint := Hint + Format(#13#10#13#10'"%s" [%d - %d]', [ListIter.Lbl, ListIter.FullSel.First, ListIter.FullSel.Last]);
      end else if ListIter.Comment <> '' then begin
        Hint := Hint + Format(#13#10#13#10'Selection [%d - %d]', [ListIter.FullSel.First, ListIter.FullSel.Last]);
      end;
      if ListIter.Comment <> '' then begin
        Hint := Hint + ':'#13#10 + ListIter.Comment;
      end;
    end;
    ListIter.Free;
  end;
end;


{
The Zoom can display the selection only if the selection is within the Draw window,
since only the draw window is processed
}
procedure TQUB_QVO_QVD.prSetZoomData(ZoomDraw :Boolean);
var
  Sel :TQUB_FirstLast;
  i   :Integer;
begin
  if prZoom = nil then Exit;

  Sel := prDataSel;

  //Some selection
  if (Sel.First <> Sel.Last) and (prData <> nil) then begin

    if prDrawListOverlapped then begin

      //prZoom.Data                     := TPMInteger(@prDataChannelDisplay);
      prZoom.Data                     := @prDataChannelDisplay;
      prZoom.DataDraw                 := Sel;
      prZoom.DataSel                  := prDataZoomSel;
      prZoom.DataCurr                 := prDataZoomCurr;
      prZoom.DataChannelCount         := prDataChannelCount;
      prZoom.DataOffset               := prDataDraw{Cache}.First - prDataPoint.First;
      prZoom.Scaling                  := Scaling;
      prZoom.Sampling                 := Sampling;

      prZoom.DataObject               := DataObject;

      for i := 0 to QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1 do begin

        prZoom.ChannelVisible[i]      := ChannelVisible[i];
        prZoom.DataChannelName[i]     := DataChannelName[i];
        prZoom.DataChannelScaling[i]  := DataChannelScaling[i];
        prZoom.DataChannelOffset[i]   := DataChannelOffset[i];
        prZoom.DataChannelUnits[i]    := DataChannelUnits[i];

        //Graphics settings
        prZoom.YAxisTickCount[i]      := YAxisTickCount[i];

        if prAutoScale then begin
          prZoom.DataYMin[i]          := DataYMinAuto[i];
          prZoom.DataYMax[i]          := DataYMaxAuto[i];
        end else begin
          prZoom.DataYMin[i]          := DataYMin[i];
          prZoom.DataYMax[i]          := DataYMax[i];
        end;
        prZoom.DataYFactor[i]         := DataYFactor[i];

        prZoom.DrawItoG[i]            := DrawItoG[i];
        prZoom.DataBaseline[i]        := DataBaseline[i];
        prZoom.BaselineNodes[i]       := BaselineNodes[i];

      end;

      //Graphics settings
      prZoom.XAxisTickCount           := XAxisTickCount;

      prZoom.FitCurves                := FitCurves;
      //Markers
      prZoom.DataMarker               := DataMarker;
      prZoom.DataMarkers              := DataMarkers;
      prZoom.DataMarkersCh            := DataMarkersCh;
      prZoom.DataMarkersCount         := DataMarkersCount;
      //Time Markers
      prZoom.DataTimeMarker           := DataTimeMarker;
      prZoom.DataTimeMarkers          := DataTimeMarkers;
      prZoom.DataTimeMarkersCount     := DataTimeMarkersCount;
      //Kinetic Parameters Markers
      prZoom.DataKinParamsMarker      := DataKinParamsMarker;
      prZoom.DataKinParamsMarkers     := DataKinParamsMarkers;
      prZoom.DataKinParamsMarkersPars := DataKinParamsMarkersPars;
      prZoom.DataKinParamsMarkersNote := DataKinParamsMarkersNote;
      prZoom.DataKinParamsMarkersCount:= DataKinParamsMarkersCount;

    end else begin

      if (Sel.Last < prDataDraw{Cache}.First) or (Sel.First > prDataDraw{Cache}.Last) then begin
      //Selection is totally out of Draw window

        prZoom.Data := nil;

      end else begin
      //Some is within the window

        //Draw only if something changed

        if Sel.First < prDataDraw{Cache}.First then Sel.First := prDataDraw{Cache}.First;
        if Sel.Last  > prDataDraw{Cache}.Last  then Sel.Last  := prDataDraw{Cache}.Last;

        Dec(Sel.First, prDataDraw{Cache}.First);
        Dec(Sel.Last,  prDataDraw{Cache}.First);

        //prZoom.Data                     := TPMInteger(@prDataChannelDisplay);
        prZoom.Data                     := @prDataChannelDisplay;
        prZoom.DataDraw                 := Sel;
        prZoom.DataSel                  := prDataZoomSel;
        prZoom.DataCurr                 := prDataZoomCurr;
        prZoom.DataChannelCount         := prDataChannelCount;
        prZoom.DataOffset               := prDataDraw{Cache}.First - prDataPoint.First;
        prZoom.Scaling                  := Scaling;
        prZoom.Sampling                 := Sampling;

        prZoom.DataObject               := DataObject;

        for i := 0 to QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1 do begin

          prZoom.ChannelVisible[i]      := ChannelVisible[i];
          prZoom.DataChannelName[i]     := DataChannelName[i];
          prZoom.DataChannelScaling[i]  := DataChannelScaling[i];
          prZoom.DataChannelOffset[i]   := DataChannelOffset[i];
          prZoom.DataChannelUnits[i]    := DataChannelUnits[i];

          //Graphics settings
          prZoom.YAxisTickCount[i]      := YAxisTickCount[i];

          if prAutoScale then begin
            prZoom.DataYMin[i]          := DataYMinAuto[i];
            prZoom.DataYMax[i]          := DataYMaxAuto[i];
          end else begin
            prZoom.DataYMin[i]          := DataYMin[i];
            prZoom.DataYMax[i]          := DataYMax[i];
          end;
          prZoom.DataYFactor[i]         := DataYFactor[i];

          prZoom.DrawItoG[i]            := DrawItoG[i];
          prZoom.DataBaseline[i]        := DataBaseline[i];
          prZoom.BaselineNodes[i]       := BaselineNodes[i];

        end;

        //Graphics settings
        prZoom.XAxisTickCount           := XAxisTickCount;

        prZoom.FitCurves                := FitCurves;
        //Markers
        prZoom.DataMarker               := DataMarker;
        prZoom.DataMarkers              := DataMarkers;
        prZoom.DataMarkersCh            := DataMarkersCh;
        prZoom.DataMarkersCount         := DataMarkersCount;
        //Time Markers
        prZoom.DataTimeMarker           := DataTimeMarker;
        prZoom.DataTimeMarkers          := DataTimeMarkers;
        prZoom.DataTimeMarkersCount     := DataTimeMarkersCount;
        //Kinetic Parameters Markers
        prZoom.DataKinParamsMarker      := DataKinParamsMarker;
        prZoom.DataKinParamsMarkers     := DataKinParamsMarkers;
        prZoom.DataKinParamsMarkersPars := DataKinParamsMarkersPars;
        prZoom.DataKinParamsMarkersNote := DataKinParamsMarkersNote;
        prZoom.DataKinParamsMarkersCount:= DataKinParamsMarkersCount;

      end;

    end;//DrawListOverlapped
    
  end else begin
  //No selection or no Data

    prZoom.Data := nil;

  end;

  prZoom.UpdateData;
  prZoom.MustRedraw := True;
  if ZoomDraw then prZoom.Draw;

end;

function TQUB_QVO_QVD.prGetDataBaseline(Index :Integer) :Integer;
begin
  Result := prDataBaseline[Index];
end;

function TQUB_QVO_QVD.prGetBaselineNodes(Ix :Integer): TQUB_Baseline;
begin
  if (Ix < 0) or (Ix >= QUB_QFS_QDF_MAX_ADCHANNELCOUNT) then begin
    Result := nil;
    Exit;
  end;

  Result := prBaselineNodes[Ix];
end;


//******************************************************************************
procedure TQUB_QVO_QVD.prSetInitialProperties;
var
  i :Integer;
begin
  //Margins
  prMargin.Left                               := QUB_QVO_QVD_DEF_MARGIN;//LEFT;
  prMargin.Top                                := QUB_QVO_QVD_DEF_MARGIN;//TOP;
  prMargin.Right                              := QUB_QVO_QVD_DEF_MARGIN;//RIGHT;
  prMargin.Bottom                             := QUB_QVO_QVD_DEF_MARGIN;//BOTTOM;
  prMarginH                                   := QUB_QVO_QVD_DEF_MARGIN;
  prMarginV                                   := QUB_QVO_QVD_DEF_MARGIN;

  //Colors
  prColor                                     := QUB_QVO_QVD_DEF_COLOR;
  prColorBack                                 := QUB_QVO_QVD_DEF_COLORBACK;
  for i := 0 to 7 do begin
    prColorData[i]                            := QUB_QVO_QVD_DEF_COLORDATA[i];
  end;
  prColorSel                                  := QUB_QVO_QVD_DEF_COLORSEL;
  prColorBreak                                := QUB_QVO_QVD_DEF_COLORBREAK;
  prColorFrame                                := QUB_QVO_QVD_DEF_COLORFRAME;
  prColorBaseline                             := QUB_QVO_QVD_DEF_COLORBASELINE;
  prColorBaselineNodes                        := QUB_QVO_QVD_DEF_COLORBASELINENODES;
  prColorIdealized                            := QUB_QVO_QVD_DEF_COLORIDEALIZED;
  prColorIdealizedSel                         := QUB_QVO_QVD_DEF_COLORIDEALIZEDSEL;
  prColorSelList                              := QUB_QVO_QVD_DEF_COLORSELLIST;
  prColorParameters                           := QUB_QVO_QVD_DEF_COLORPARAMETERS;
  prColorSegLabel                             := QUB_QVO_QVD_DEF_COLORSEGLABEL;
  prColorCurr                                 := QUB_QVO_QVD_DEF_COLORCURR;
  //Page
  prTracesPerPage                             := QUB_QVO_QVD_DEF_TRACESPERPAGE;
  prPointsPerTrace                            := QUB_QVO_QVD_DEF_POINTSPERTRACE;
  prCacheSize                                 := QUB_QVO_QVD_DEF_CACHESIZE;
  prScaling                                   := QUB_QVO_QVD_DEF_SCALING;
  prSampling                                  := 1 / (QUB_QVO_QVD_DEF_SAMPLING * 1e3);
  prTraceChangeOnBreak                        := QUB_QVO_QVD_DEF_TRACECHANGEONBREAK;
  prOverlapChannels                           := QUB_QVO_QVD_DEF_OVERLAPCHANNELS;
  prOverlapTraces                             := QUB_QVO_QVD_DEF_OVERLAPTRACES;
  prDrawPoints                                := QUB_QVO_QVD_DEF_DRAWPOINTS;
  prDrawInverted                              := QUB_QVO_QVD_DEF_DRAWINVERTED;
  prDrawRaster                                := QUB_QVO_QVD_DEF_DRAWRASTER;
  prDrawLabels                                := QUB_QVO_QVD_DEF_DRAWLABELS;
  prDrawActiveThick                           := QUB_QVO_QVD_DEF_DRAWACTIVETHICK;
  prDrawBaseline                              := QUB_QVO_QVD_DEF_DRAWBASELINE;
  prDrawBaselineNodes                         := QUB_QVO_QVD_DEF_DRAWBASELINENODES;
  prDrawSegLabels                             := QUB_QVO_QVD_DEF_DRAWSEGLABELS;
  prDrawIdealized                             := QUB_QVO_QVD_DEF_DRAWIDEALIZED;
  prDrawIdealizedAbove                        := QUB_QVO_QVD_DEF_DRAWIDEALIZEDABOVE;
  prDrawIdealizedColor                        := QUB_QVO_QVD_DEF_DRAWIDEALIZEDCOLOR;
  prDrawListOverlapped                        := QUB_QVO_QVD_DEF_DRAWLISTOVERLAPPED;
  prDrawSelList                               := QUB_QVO_QVD_DEF_DRAWSELLIST;
  prDrawParameters                            := QUB_QVO_QVD_DEF_DRAWPARAMETERS;
  prAutoScale                                 := QUB_QVO_QVD_DEF_AUTOSCALE;
  for i := 0 to QUB_QFS_QDF_MAX_ADCHANNELCOUNT - 1 do begin
    prDataYMin[i]                             := QUB_QVO_QVD_DEF_DATAYMIN;
    prDataYMax[i]                             := QUB_QVO_QVD_DEF_DATAYMAX;
    prDataYFactor[i]                          := QUB_QVO_QVD_DEF_DATAYFACTOR;
    prDrawItoG[i]                             := QUB_QVO_QVD_DEF_DRAWITOG;
    prChannelVisible[i]                       := QUB_QVO_QVD_DEF_CHANNELVISIBLE;
    prFilterOn[i]                             := QUB_QVO_QVD_DEF_FILTERON;
    prFilterMAOn[i]                           := QUB_QVO_QVD_DEF_FILTERMAON;
    prFilterFreq[i]                           := QUB_QVO_QVD_DEF_FILTERFREQ;
    prFilterMACount[i]                        := QUB_QVO_QVD_DEF_FILTERMACOUNT;
    prBaselineOn[i]                           := QUB_QVO_QVD_DEF_BASELINEON;
    prWarnOnBaseline[i]                       := QUB_QVO_QVD_DEF_WARNONBASELINE;
    prDataChannelName[i]                      := 'Channel ' + IntToStr(i);
    if i = 0 then prDataChannelUnits[i]       := 'pA' else prDataChannelUnits[i] := 'V'; 
    prDataChannelScaling[i]                   := 1.0;
    prDataChannelOffset[i]                    := 0.0;
    prYAxisTickCount[i]                       := QUB_QVO_QVD_DEF_AXIS_TICKCOUNT;
  end;
  prXAxisTickCount                            := QUB_QVO_QVD_DEF_AXIS_TICKCOUNT;
  prWarnOnBaseline[0]                         := False;
  prAutoScroll                                := QUB_QVO_QVD_DEF_AUTOSCROLL;
  prDrawMode                                  := QUB_QVO_QVD_DEF_DRAWMODE;
end;


//----- Registry interface (condensed 5-2004) {JB}
// Note : Write is only called when the [Set as default] button is used in the data properties window.
{to do: it doesn't remember color changes}
procedure TQUB_QVO_QVD.prPropertiesRegistry(Read :Boolean);
var
  Reg   :TRegistry;
begin

  Reg := TRegistry.Create;
  try
    with Reg do begin

      if OpenKey('Software\QUB\Visual Data', True) then begin

        //All the interactive properties must be here **********************

        if Read then begin
        //Read

          //----- Read settings from registry
          //--Margins
          MarginLeft    := ReadRegistryInteger(Reg, 'Margin Left', QUB_QVO_QVD_DEF_MARGINLEFT);
          MarginTop     := ReadRegistryInteger(Reg, 'Margin Top', QUB_QVO_QVD_DEF_MARGINTOP);
          MarginRight   := ReadRegistryInteger(Reg, 'Margin Right', QUB_QVO_QVD_DEF_MARGINRIGHT);
          MarginBottom  := ReadRegistryInteger(Reg, 'Margin Bottom', QUB_QVO_QVD_DEF_MARGINBOTTOM);

        end else begin
        //Write

          //----- Write settings to registry
          try
            //--Margins
            WriteInteger('Margin Left', MarginLeft);
            WriteInteger('Margin Top', MarginTop);
            WriteInteger('Margin Right', MarginRight);
            WriteInteger('Margin Bottom', MarginBottom);
          except
          end;

        end;//Read/Write

      end;//OpenKey
      CloseKey;

    end;

  finally

    Reg.Free;

  end;
end;


//******************************************************************************
procedure TQUB_Python_Data.prSetData(x :TQUB_QVO_QVD);
var
  PyInst            :PPyObject;
begin
  prData            := x;

  if prResultsPy <> nil then begin
    prResultsPy.Data  := nil;
    GetPythonEngine.Py_DECREF( prResultsPy.GetSelf );
  end;
  PyInst           := DataResultsPyType.CreateInstance;
  prResultsPy      := TQUB_Python_DataResults( PythonToDelphi(PyInst) );
  prResultsPy.Data := x;

  if prListsPy <> nil then begin
    prListsPy.Data  := nil;
    GetPythonEngine.Py_DECREF( prListsPy.GetSelf );
  end;
  PyInst           := DataListsPyType.CreateInstance;
  prListsPy        := TQUB_Python_DataLists( PythonToDelphi(PyInst) );
  prListsPy.Data   := x;
end;

destructor TQUB_Python_Data.Destroy;
begin
  if prResultsPy <> nil then begin
    prResultsPy.Data  := nil;
    GetPythonEngine.Py_DECREF( prResultsPy.GetSelf );
  end;
  if prListsPy <> nil then begin
    prListsPy.Data  := nil;
    GetPythonEngine.Py_DECREF( prListsPy.GetSelf );
  end;
end;


function TQUB_Python_Data.GetAttr(key : PChar) : PPyObject;
begin
  if Data = nil then begin
    Result := inherited GetAttr(key);
    Exit;
  end;

  with GetPythonEngine do begin
    if key = 'fileName' then begin
      Result := PyString_FromString( PChar(Data.FileName) );
    end else if key = 'dataChannelCount' then begin
      Result := PyInt_FromLong( Data.DataChannelCount );
    end else if key = 'activeChannel' then begin
      Result := PyInt_FromLong( Data.ActiveChannel );
    end else if key = 'results' then begin
      Result := prResultsPy.GetSelf;
      Py_INCREF(Result);
    end else if key = 'lists' then begin
      Result := prListsPy.GetSelf;
      Py_INCREF(Result);
    end else if key = 'currResults' then begin
      if Data.ResultsList.ItemIndex >= 0 then begin
        PythonThread.SyncGUIProc( prGetCurrResults );
        Result := prCurrResults;
        Py_INCREF(Result);
      end else begin
        Result := ReturnNone;
      end;
    end else if key = 'listed' then begin
      Result := PyInt_FromLong( Integer( Data.Listed ) );;
    end else begin
      Result := inherited GetAttr(key);
    end;
  end;
end;

function  TQUB_Python_Data.SetAttr(key : PChar; value : PPyObject) : Integer;
begin
  if Data = nil then begin
    Result := inherited SetAttr(key, value);
    Exit;
  end;

  Result := 0;
  with GetPythonEngine do begin
    if key = 'activeChannel' then begin
      if PyArg_Parse( value, 'i:activeChannel', [@prActiveChannel] ) = 0 then begin
        Result := -1;
      end else begin
        PythonThread.SyncGUIProc( prSetActiveChannel );
      end;
    end else if key = 'listed' then begin
      prListed := 0 <> PyObject_IsTrue( value );
      PythonThread.SyncGUIProc( prSetListed );
    end else begin
      Result := inherited SetAttr(key, value);
    end;
  end;
end;

procedure TQUB_Python_Data.prSetActiveChannel;
begin
  Data.ActiveChannel := prActiveChannel;
end;

procedure TQUB_Python_Data.prSetListed;
begin
  Data.Listed := prListed;
end;

class procedure TQUB_Python_Data.RegisterMethods( PythonType : TPythonType );
begin
  inherited;
  with PythonType do begin
    AddMethod( 'chooseList',   @TQUB_Python_Data.ChooseList,      'Data.chooseList( name )' );
    AddMethod( 'getList',      @TQUB_Python_Data.GetList,         'Data.getList( name )' );
    AddMethod( 'setList',      @TQUB_Python_Data.SetList,         'Data.setList( name, list of pairs )' );
    AddMethod( 'select',       @TQUB_Python_Data.Select,          'Data.select( first, last )'       );
    AddMethod( 'timeOfPoint',  @TQUB_Python_Data.TimeOfPoint,     'Data.timeOfPoint( i )'  );
    AddMethod( 'pointOfTime',  @TQUB_Python_Data.PointOfTime,     'Data.pointOfTime( t )' );
    AddMethod( 'copyImage',    @TQUB_Python_Data.CopyImage,       'Data.copyImage( configDict )' );
    AddMethod( 'addResults',   @TQUB_Python_Data.AddResults,      'Data.addResults( resultsTree )' );
    AddMethod( 'baseline',     @TQUB_Python_Data.GetBaseline,     'Data.baseline( channel=0 )' );
    AddMethod( 'idealization', @TQUB_Python_Data.GetIdealization, 'Data.idealization( channel=0 )' );
    AddMethod( 'setFitCurve',  @TQUB_Python_Data.SetFitCurve,     'Data.setFitCurve( Segment node )' );
  end;
end;

function TQUB_Python_Data.ChooseList( args :PPyObject ): PPyObject;
var
  ListName        :PChar;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if Data = nil then begin
      PyErr_SetString( PyExc_TypeError^, PChar('data file is no longer open') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 's:chooseList', [@ListName] ) = 0 then begin
      Result := nil;
      Exit;
    end;

    prListName := ListName;
    PythonThread.SyncGUIProc( prChooseList );
    Result := ReturnNone;
  end;
end;

procedure TQUB_Python_Data.prChooseList;
begin
  Data.ChooseList( prListName );
end;

function TQUB_Python_Data.GetList( args :PPyObject ): PPyObject;
var
  ListName         :PChar;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if Data = nil then begin
      PyErr_SetString( PyExc_TypeError^, PChar('data file is no longer open') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 's:getList', [@ListName] ) = 0 then begin
      Result := nil;
      Exit;
    end;

    prListName     := ListName;
    PythonThread.SyncGUIProc( prGetList );
    Result         := prPyList;
  end;
end;

procedure TQUB_Python_Data.prGetList;
var
  List             :TQUB_QVO_QVD_SelectionList;
  i                :Integer;
begin
  PythonThread.BeginPython;
  try
    with GetPythonEngine do begin
      List             := Data.GetList( prListName );
      if List <> nil then begin
        prPyList       := PyList_New( List.Items.Count );
        for i := 0 to List.Items.Count - 1 do begin
          PyList_SetItem(prPyList, i, Py_BuildValue('ii', [List[i].Sel.First, List[i].Sel.Last]));
        end;
      end else begin
        prPyList       := PyList_New( 0 );
      end;
    end;
  finally
    PythonThread.EndPython;
  end;
end;

function TQUB_Python_Data.SetList( args :PPyObject ): PPyObject;
var
  ListName         :PChar;
  PyList           :PPyObject;
  PyItem           :PPyObject;
  i                :Integer;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if Data = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('data file is no longer open') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 'sO:setList', [@ListName, @PyList] ) = 0 then begin
      Result := nil;
      Exit;
    end;

    if not PyList_Check( PyList ) then begin
      PyErr_SetString( PyExc_TypeError^, PChar('getList(name, list of pairs)') );
      Result := nil;
      Exit;
    end;
    for i := 0 to PyList_Size( PyList ) - 1 do begin
      PyItem := PyList_GetItem(PyList, i);
      if (not PyTuple_Check( PyItem )) or (2 > PyTuple_Size( PyItem )) then begin
        PyErr_SetString( PyExc_TypeError^, PChar('getList(name, list of pairs)') );
        Result := nil;
        Exit;
      end;
    end;

    prListName := ListName;
    prPyList   := PyList;
    PythonThread.SyncGUIProc( prSetList );
    Result     := ReturnNone;
  end;
end;

procedure TQUB_Python_Data.prSetList;
var
  PyItem           :PPyObject;
  List             :TQUB_QVO_QVD_SelectionList;
  i, N              :Integer;
begin
  PythonThread.BeginPython;
  try
    with GetPythonEngine do begin
      List           := Data.GetList( prListName );
      if (List <> nil) and not List.Locked then begin
        List.Clear;
  
        N     := PyList_Size( prPyList ) - 1;
        for i := 0 to N do begin
          PyItem := PyList_GetItem( prPyList, i );
        if PyTuple_Size(PyItem) > 2 Then
          List.AddSelection( PyInt_AsLong( PyTuple_GetItem(PyItem, 0) ),
                             PyInt_AsLong( PyTuple_GetItem(PyItem, 1) ),
                             PyString_AsString( PyTuple_GetItem(PyItem, 2) ),
                             i<N )
        else
          List.AddSelection( PyInt_AsLong( PyTuple_GetItem(PyItem, 0) ),
                             PyInt_AsLong( PyTuple_GetItem(PyItem, 1) ),
                             '',
                             i<N );
        end;
  
        Data.RefreshLists;
      end;
    end;
  finally
    PythonThread.EndPython;
  end;
end;

function TQUB_Python_Data.Select( args :PPyObject ): PPyObject;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if Data = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('data file is no longer open') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 'ii:select', [@prSel.First, @prSel.Last] ) = 0 then begin
      Result := nil;
      Exit;
    end;

    PythonThread.SyncGUIProc( prSelect );
    Result := ReturnNone;
  end;
end;

procedure TQUB_Python_Data.prSelect;
begin
  Data.MoveSelectionIntoWindow( prSel, prSel.First );
end;

function TQUB_Python_Data.TimeOfPoint( args :PPyObject ): PPyObject;
begin
  Adjust(@Self);

  Result := GetPythonEngine.ReturnNone;
end;

function TQUB_Python_Data.PointOfTime( args :PPyObject ): PPyObject;
begin
  Adjust(@Self);

  Result := GetPythonEngine.ReturnNone;
end;

function TQUB_Python_Data.CopyImage( args :PPyObject ): PPyObject;
begin
  Adjust(@Self);

  prConfig    := nil;
  with GetPythonEngine do begin
    if Data = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('data file is no longer open') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, '|O:CopyImage( configDict )', [@prConfig] ) <> 0 then begin
      PythonThread.SyncGUIProc( prCopyImage );
      Result := ReturnNone;
    end else begin
      Result := nil;
    end;
  end;
end;

procedure TQUB_Python_Data.prCopyImage;
var
  PyVal                  :PPyObject;
  PyInt                  :PPyObject;
  SavedPars              :INode;
  NewPars                :INode;
begin
  PythonThread.BeginPython;
  with GetPythonEngine do begin
    SavedPars     := ProfileMgr['CopyData'].Active.Clone(True);
    NewPars       := TNode.Create('Properties');

    if (prConfig <> nil) and (PyMapping_Check(prConfig) <> 0) then begin
      if PyMapping_HasKeyString(prConfig, 'DrawData') <> 0 then begin
        PyVal                 := PyMapping_GetItemString(prConfig, 'DrawData');
          NewPars['Draw Data'].SetData(PyObject_IsTrue(PyVal));
        Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prConfig, 'DrawIDLData') <> 0 then begin
        PyVal                 := PyMapping_GetItemString(prConfig, 'DrawIDLData');
        NewPars['Draw IDL Data'].SetData(PyObject_IsTrue(PyVal));
        Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prConfig, 'DrawBase') <> 0 then begin
        PyVal                 := PyMapping_GetItemString(prConfig, 'DrawBase');
        NewPars['Draw Base'].SetData(PyObject_IsTrue(PyVal));
        Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prConfig, 'ScaleBars') <> 0 then begin
        PyVal                 := PyMapping_GetItemString(prConfig, 'ScaleBars');
        NewPars['Scale Bars'].SetData(PyObject_IsTrue(PyVal));
        Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prConfig, 'ScaleBarsTop') <> 0 then begin
        PyVal                 := PyMapping_GetItemString(prConfig, 'ScaleBarsTop');
        NewPars['Scale Bars Location'].SetData(PyObject_IsTrue(PyVal));
        Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prConfig, 'DrawFrame') <> 0 then begin
        PyVal               := PyMapping_GetItemString(prConfig, 'DrawFrame');
        NewPars['Draw Frame'].SetData(PyObject_IsTrue(PyVal));
        Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prConfig, 'ShowTitles') <> 0 then begin
        PyVal               := PyMapping_GetItemString(prConfig, 'ShowTitles');
        NewPars['Show Titles'].SetData(PyObject_IsTrue(PyVal));
        Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prConfig, 'ShowFilename') <> 0 then begin
        PyVal               := PyMapping_GetItemString(prConfig, 'ShowFilename');
        NewPars['Show Filename'].SetData(PyObject_IsTrue(PyVal));
        Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prConfig, 'Landscape') <> 0 then begin
        PyVal               := PyMapping_GetItemString(prConfig, 'Landscape');
        NewPars['Orientation'].SetData(PyObject_IsTrue(PyVal));
        Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prConfig, 'Bitmap') <> 0 then begin
        PyVal               := PyMapping_GetItemString(prConfig, 'Bitmap');
        NewPars['Format'].SetData(PyObject_IsTrue(PyVal));
        Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prConfig, 'Width') <> 0 then begin
        PyVal               := PyMapping_GetItemString(prConfig, 'Width');
        if PyNumber_Check( PyVal ) <> 0 then begin
          PyInt             := PyNumber_Int( PyVal );
          NewPars['Draw Width'].SetData(PyInt_AsLong(PyInt));
          Py_DECREF( PyInt );
        end;
        Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prConfig, 'Height') <> 0 then begin
        PyVal               := PyMapping_GetItemString(prConfig, 'Height');
        if PyNumber_Check( PyVal ) <> 0 then begin
          PyInt               := PyNumber_Int( PyVal );
          NewPars['Draw Height'].SetData(PyInt_AsLong(PyInt));
          Py_DECREF( PyInt );
        end;
        Py_DECREF( PyVal );
      end;
      if PyMapping_HasKeyString(prConfig, 'HiRes') <> 0 then begin
        PyVal               := PyMapping_GetItemString(prConfig, 'HiRes');
        Data.ActOnHiRes     := PyObject_IsTrue( PyVal ) <> 0;
        Py_DECREF( PyVal );
      end else begin
        Data.ActOnHiRes     := False;
      end;
    end;

    PythonTHread.EndPython;

    ProfileMgr['CopyData'].SetProperties(NewPars);
    Data.CopyImage(False);
    ProfileMgr['CopyData'].SetProperties(SavedPars);

    PythonThread.BeginPython;
  end;
  PythonThread.EndPython;
end;

function TQUB_Python_Data.AddResults( args :PPyObject ): PPyObject;
var
  ResultsPy              :PPyObject;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if Data = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('data file is no longer open') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 'O:addResults( resultsTree )', [@ResultsPy] ) <> 0 then begin
      prResults    := PyNode_ToNode( ResultsPy );
      PythonThread.SyncGUIProc( prAddResults );
      prResults    := TNode.CreateNull;
      Result       := ReturnNone;
    end else begin
      Result       := nil;
    end;
  end;
end;

procedure TQUB_Python_Data.prAddResults;
begin
  Data.ResultsList.AddResults( prResults );
end;

procedure TQUB_Python_Data.prGetCurrResults;
begin
  prCurrResults := Data.ResultsList[ Data.ResultsList.ItemIndex ].PyHandle.GetSelf;
end;

function TQUB_Python_Data.GetBaseline( args :PPyObject ): PPyObject;
var
  ChannelIndex           :Integer;
begin
  Adjust(@Self);
  ChannelIndex           := 0;

  with GetPythonEngine do begin
    if Data = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('data file is no longer open') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, '|i:baseline( channel=0 )', [@ChannelIndex] ) <> 0 then begin
      if Data.BaselineNodes[ChannelIndex] = nil then begin
        Result     := ReturnNone;
      end else begin
        Result     := Data.BaselineNodes[ChannelIndex].PyHandle.GetSelf;
        Py_INCREF(Result);
      end;
    end else begin
      Result       := nil;
    end;
  end;
end;

function TQUB_Python_Data.GetIdealization( args :PPyObject ): PPyObject;
var
  ChannelIndex           :Integer;
begin
  Adjust(@Self);
  ChannelIndex           := 0;

  with GetPythonEngine do begin
    if Data = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('data file is no longer open') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, '|i:idealization( channel=0 )', [@ChannelIndex] ) <> 0 then begin
      if Data.DataObject.Idealization[ChannelIndex] = nil then begin
        Result     := ReturnNone;
      end else begin
        Result := PyNode_FromNode( Data.DataObject.Idealization[ChannelIndex].ToTree );

       // Result     := Data.DataObject.Idealization[ChannelIndex].PyHandle.GetSelf;
       // Py_INCREF(Result);
      end;
    end else begin
      Result       := nil;
    end;
  end;
end;

function TQUB_Python_Data.SetFitCurve( args :PPyObject ): PPyObject;
var
  PyNode          :PPyObject;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if Data = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('data file is no longer open') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 'O:setFitCurve( Segment node )', [@PyNode] ) <> 0 then begin
      prNode    := PyNode_ToNode( PyNode );
      PythonThread.SyncGUIProc( prSetFitCurve );
      prNode    := TNode.CreateNull;
      Result    := ReturnNone;
    end else begin
      Result    := nil;
    end;
  end;
end;

procedure TQUB_Python_Data.prSetFitCurve;
var
  Sel         :TQUB_FirstLast;
  FData       :TPADouble;
  IData       :TPAInteger;
  Scaling     :Double;
  Offset      :Double;
  i           :Integer;
  Curve       :TQUB_FitCurveIter;
begin
  Curve       := nil;
  try
    Sel.First   := prNode.Data[0];
    Sel.Last    := prNode.Data[1];
    FData       := TPADouble(prNode.Find('Channel').DataPtr);

    // find any existing curve
    Curve       := Data.FitCurves.Find(Sel.First);
    if (0<>Curve.Done) or (Curve.Curve.Last < Sel.Last) then begin
      Curve.Free;
      Curve     := nil;
    end;
    // or make one
    if Curve = nil then begin
      Curve     := Data.FitCurves.Add(Sel.First, Sel.Last);
    end;
    IData       := Curve.Curve.Data;

    Scaling     := Data.DataObject.Scaling * Data.DataChannelScaling[Data.ActiveChannel];
    Offset      := Data.DataChannelScaling[Data.ActiveChannel];
    for i := (Sel.First - Sel.First) to (Sel.Last - Sel.First) do begin
      IData[i]  := Round(Scaling * (FData[i] - Offset));
    end;

    Curve.Free;
    Curve       := nil;

    Data.FitCurves.RaiseChanged;
  except
  end;

  if Curve <> nil then Curve.Free;
end;


//******************************************************************************

function  TQUB_Python_DataResults.GetAttr(key : PChar) : PPyObject;
begin
  Result := inherited GetAttr(key);
end;

function  TQUB_Python_DataResults.SqLength : Integer;
begin
  if Data = nil then begin
    Result := 0;
  end else begin
    PythonThread.SyncGUIProc( prGetLength );
    Result := prResultIx;
  end;
end;

procedure TQUB_Python_DataResults.prGetLength;
begin
  prResultIx := Data.ResultsList.Items.Count;
end;

function  TQUB_Python_DataResults.SqItem( idx : Integer ) : PPyObject;
begin
  prResultNode := QUB_Node_Null;

  if Data <> nil then begin
    prResultIx := idx;
    PythonThread.SyncGUIProc( prGetItem );
  end;

  with GetPythonEngine do begin
    if prResultNode.IsNull then begin
      PyErr_SetString( PyExc_IndexError^, PChar('index out of range') );
      Result := nil;
    end else begin
      Result := PyNode_FromNode( prResultNode );
    end;
  end;
end;

procedure TQUB_Python_DataResults.prGetItem;
begin
  if (prResultIx >= 0) and (prResultIx < Data.ResultsList.Items.Count) then begin
    prResultNode := Data.ResultsList.ResultsNode[prResultIx];
  end;
end;

class procedure TQUB_Python_DataResults.RegisterMethods( PythonType : TPythonType );
begin
  inherited;
  with PythonType do begin
    AddMethod( 'add',     @TQUB_Python_DataResults.AddPy,     'add( results )' );
    AddMethod( 'delete',  @TQUB_Python_DataResults.DeletePy,  'delete( index )' );
    AddMethod( 'choose',  @TQUB_Python_DataResults.ChoosePy,  'choose( index )' );
  end;
end;

function TQUB_Python_DataResults.AddPy( args :PPyObject ): PPyObject;
var
  ResultsPy       :PPyObject;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if Data = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('data file is no longer open') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 'O:add', [@ResultsPy] ) = 0 then begin
      Result := nil;
      Exit;
    end;

    if not PyNode_IsNode( ResultsPy ) then begin
      PyErr_SetString( PyExc_TypeError^, PChar('Data.results.add() takes one qubtree node as argument') );
      Result := nil;
      Exit;
    end;

    prResultNode := PyNode_ToNode( ResultsPy );
    PythonThread.SyncGUIProc( prAdd );
    Result := ReturnNone;
  end;
end;

procedure TQUB_Python_DataResults.prAdd;
begin
  if not prResultNode.IsNull then Data.ResultsList.AddResults( prResultNode );
end;

function TQUB_Python_DataResults.DeletePy( args :PPyObject ): PPyObject;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if Data = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('data file is no longer open') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 'i:delete', [@prResultIx] ) = 0 then begin
      Result := nil;
      Exit;
    end;

    PythonThread.SyncGUIProc( prDelete );
    Result := ReturnNone;
  end;
end;

procedure TQUB_Python_DataResults.prDelete;
begin
  Data.ResultsList.DelResults( prResultIx );
end;

function TQUB_Python_DataResults.ChoosePy( args :PPyObject ): PPyObject;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if Data = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('data file is no longer open') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 'i:choose', [@prResultIx] ) = 0 then begin
      Result := nil;
      Exit;
    end;

    PythonThread.SyncGUIProc( prChoose );
    Result := ReturnNone;
  end;
end;

procedure TQUB_Python_DataResults.prChoose;
begin
  Data.ResultsList.ChooseResults( prResultIx );
end;


//******************************************************************************

function  TQUB_Python_DataLists.GetAttr(key : PChar) : PPyObject;
begin
  with GetPythonEngine do begin
    if Key = 'currList' then begin
      PythonThread.SyncGUIProc( prGetCurr );
      if prList = nil then begin
        PyErr_SetString( PyExc_Exception^, PChar('no current list') );
        Result  := nil;
      end else begin
        Result  := DataListPyType.CreateInstance;
        TQUB_Python_DataList( PythonToDelphi(Result) ).List := prList;
      end;
    end else if Key = 'currIndex' then begin
      PythonThread.SyncGUIProc( prGetCurr );
      if prList = nil then begin
        PyErr_SetString( PyExc_Exception^, PChar('no current list') );
        Result  := nil;
      end else begin
        Result  := PyInt_FromLong( prIx );
      end;
    end else begin
  Result := inherited GetAttr(key);
  Exit;
end;
  end;
end;

procedure TQUB_Python_DataLists.prGetCurr;
begin
  prIx := Data.SelectionLists.ItemIndex;
  if prIx >= 0 then begin
    prList := Data.SelectionLists[ prIx ];
  end else begin
    prList := nil;
  end;
end;

function  TQUB_Python_DataLists.SqLength : Integer;
begin
  if Data = nil then begin
    Result := 0;
  end else begin
    PythonThread.SyncGUIProc( prGetLength );
    Result := prIx;
  end;
end;

procedure TQUB_Python_DataLists.prGetLength;
begin
  prIx := Data.SelectionLists.Items.Count;
end;

function  TQUB_Python_DataLists.SqItem( idx : Integer ) : PPyObject;
begin
  with GetPythonEngine do begin
    if Data <> nil then begin
      prIx := idx;
      PythonThread.SyncGUIProc( prGetItem );

      if prList = nil then begin
        PyErr_SetString( PyExc_IndexError^, PChar('index out of range') );
        Result := nil;
      end else begin
        Result       := DataListPyType.CreateInstance;
        TQUB_Python_DataList( PythonToDelphi(Result) ).List := prList;
      end;
    end else begin
      PyErr_SetString( PyExc_Exception^, PChar('data file is no longer open') );
      Result := nil;
    end;
  end;
end;

procedure TQUB_Python_DataLists.prGetItem;
begin
  if (prIx >= 0) and (prIx < Data.SelectionLists.Items.Count) then begin
    prList := Data.SelectionLists[prIx];
  end;
end;

class procedure TQUB_Python_DataLists.RegisterMethods( PythonType : TPythonType );
begin
  inherited;
  with PythonType do begin
    AddMethod( 'delete',  @TQUB_Python_DataLists.DeletePy,  'delete( index )' );
    AddMethod( 'indexOf', @TQUB_Python_DataLists.IndexOfPy, 'indexOf( name )' );
    AddMethod( 'byName',  @TQUB_Python_DataLists.ByNamePy,  'byName( name )' );
    AddMethod( 'choose',  @TQUB_Python_DataLists.ChoosePy,  'choose( index )' );
    AddMethod( 'rename',  @TQUB_Python_DataLists.RenamePy,  'rename( index, name )' );
  end;
end;

function TQUB_Python_DataLists.DeletePy( args :PPyObject ): PPyObject;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if Data = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('data file is no longer open') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 'i:delete', [@prIx] ) = 0 then begin
      Result := nil;
      Exit;
    end;

    PythonThread.SyncGUIProc( prDelete );
    Result       := ReturnNone;
  end;
end;

procedure TQUB_Python_DataLists.prDelete;
begin
  Data.SelectionLists.DelList( prIx );
end;

function TQUB_Python_DataLists.IndexOfPy( args :PPyObject ): PPyObject;
var
  XName            :PChar;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if Data = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('data file is no longer open') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 's:indexOf', [@XName] ) = 0 then begin
      Result := nil;
      Exit;
    end;

    prName := XName;

    PythonThread.SyncGUIProc( prIndexOf );
    Result       := PyInt_FromLong( prIx );
  end;
end;

procedure TQUB_Python_DataLists.prIndexOf;
begin
  prIx := Data.SelectionLists.Items.IndexOf( prName );
end;

function TQUB_Python_DataLists.ByNamePy( args :PPyObject ): PPyObject;
var
  XName            :PChar;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if Data = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('data file is no longer open') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 's:byName', [@XName] ) = 0 then begin
      Result := nil;
      Exit;
    end;

    prName := XName;
    PythonThread.SyncGUIProc( prByName );
    Result       := DataListPyType.CreateInstance;
    TQUB_Python_DataList( PythonToDelphi(Result) ).List := prList;
  end;
end;

procedure TQUB_Python_DataLists.prByName;
begin
  prList := Data.GetList(prName);
end;

function TQUB_Python_DataLists.ChoosePy( args :PPyObject ): PPyObject;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if Data = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('data file is no longer open') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 'i:choose', [@prIx] ) = 0 then begin
      Result := nil;
      Exit;
    end;

    PythonThread.SyncGUIProc( prChoose );
    Result       := ReturnNone;
  end;
end;

procedure TQUB_Python_DataLists.prChoose;
begin
  Data.ChooseList(prIx);
end;

function TQUB_Python_DataLists.RenamePy( args :PPyObject ): PPyObject;
var
  XName            :PChar;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if Data = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('data file is no longer open') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 'is:rename', [@prIx, @XName] ) = 0 then begin
      Result := nil;
      Exit;
    end;

    prName := XName;
    PythonThread.SyncGUIProc( prRename );
    Result       := ReturnNone;
  end;
end;

procedure TQUB_Python_DataLists.prRename;
begin
  Data.SelectionLists.RenameList(prIx, prName);
end;


//******************************************************************************

function  TQUB_Python_DataList.GetAttr(key : PChar) : PPyObject;
begin
  if List = nil then begin
    Result := inherited GetAttr(key);
    Exit;
  end;

  with GetPythonEngine do begin
    if key = 'asTree' then begin
      PythonThread.SyncGUIProc( prGetAsTree );
      Result := PyNode_FromNode( prTree );
    end else begin
      Result := inherited GetAttr(key);
    end;
  end;
end;

procedure TQUB_Python_DataList.prGetAsTree;
begin
  prTree := List.AsTree;
end;

function  TQUB_Python_DataList.SqLength : Integer;
begin
  if List = nil then begin
    Result := 0;
  end else begin
    PythonThread.SyncGUIProc( prGetLength );
    Result := prIx;
  end;
end;

procedure TQUB_Python_DataList.prGetLength;
begin
  prIx := List.Items.Count;
end;

function  TQUB_Python_DataList.SqItem( idx : Integer ) : PPyObject;
begin
  with GetPythonEngine do begin
    if List <> nil then begin
      prIx := idx;
      PythonThread.SyncGUIProc( prGetItem );

      if prSel.Last < 0 then begin
        PyErr_SetString( PyExc_IndexError^, PChar('index out of range') );
        Result := nil;
      end else begin
        Result       := Py_BuildValue('(ii)', [prSel.First, prSel.Last]);
      end;
    end else begin
      PyErr_SetString( PyExc_Exception^, PChar('list no longer exists') );
      Result := nil;
    end;
  end;
end;

procedure TQUB_Python_DataList.prGetItem;
begin
  if (prIx >= 0) and (prIx < List.Items.Count) then begin
    prSel := List[prIx].Sel;
  end else begin
    prSel.Last := -1;
  end;
end;

class procedure TQUB_Python_DataList.RegisterMethods( PythonType : TPythonType );
begin
  inherited;
  with PythonType do begin
    AddMethod( 'add',         @TQUB_Python_DataList.AddPy,         'add( first, last[, name] )' );
    AddMethod( 'delete',      @TQUB_Python_DataList.DeletePy,      'delete( index )' );
    AddMethod( 'clear',       @TQUB_Python_DataList.ClearPy,       'clear()' );
    AddMethod( 'rename',      @TQUB_Python_DataList.RenamePy,      'rename( index, name )' );
    AddMethod( 'setFromTree', @TQUB_Python_DataList.SetFromTreePy, 'setFromTree( tree )' );
  end;
end;

function TQUB_Python_DataList.AddPy( args :PPyObject ): PPyObject;
var
  XName         :PChar;
begin
  Adjust(@Self);
  XName   := nil;

  with GetPythonEngine do begin
    if List = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('list no longer exists') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 'ii|s:add', [@prSel.First, @prSel.Last, @XName] ) = 0 then begin
      Result := nil;
      Exit;
    end;

    if Pointer(XName) = nil then prName := '' else prName := XName;

    PythonThread.SyncGUIProc( prAdd );
    Result       := ReturnNone;
  end;
end;

procedure TQUB_Python_DataList.prAdd;
begin
  List.AddSelection( prSel.First, prSel.Last, prName );
end;

function TQUB_Python_DataList.DeletePy( args :PPyObject ): PPyObject;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if List = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('list no longer exists') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 'i:delete', [@prIx] ) = 0 then begin
      Result := nil;
      Exit;
    end;

    PythonThread.SyncGUIProc( prDelete );
    Result       := ReturnNone;
  end;
end;

procedure TQUB_Python_DataList.prDelete;
begin
  List.DelSelection( prIx );
end;

function TQUB_Python_DataList.ClearPy( args :PPyObject ): PPyObject;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if List = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('list no longer exists') );
      Result := nil;
      Exit;
    end;

    PythonThread.SyncGUIProc( prClear );
    Result       := ReturnNone;
  end;
end;

procedure TQUB_Python_DataList.prClear;
begin
  List.Clear;
end;

function TQUB_Python_DataList.RenamePy( args :PPyObject ): PPyObject;
var
  XName         :PChar;
begin
  Adjust(@Self);
  XName   := nil;

  with GetPythonEngine do begin
    if List = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('list no longer exists') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 'i|s:add', [@prIx, @XName] ) = 0 then begin
      Result := nil;
      Exit;
    end;

    if Pointer(XName) = nil then prName := '' else prName := XName;

    PythonThread.SyncGUIProc( prRename );
    Result       := ReturnNone;
  end;
end;

procedure TQUB_Python_DataList.prRename;
begin
  if (prIx >= 0) and (prIx < List.Items.Count) then begin
    List[prIx].Lbl := prName;
  end;
end;

function TQUB_Python_DataList.SetFromTreePy( args :PPyObject ): PPyObject;
var
  TreePy       :PPyObject;
begin
  Adjust(@Self);

  with GetPythonEngine do begin
    if List = nil then begin
      PyErr_SetString( PyExc_Exception^, PChar('list no longer exists') );
      Result := nil;
      Exit;
    end;

    if PyArg_ParseTuple( args, 'O:setFromTree', [@TreePy] ) = 0 then begin
      Result := nil;
      Exit;
    end;

    if not PyNode_IsNode( TreePy ) then begin
      PyErr_SetString( PyExc_TypeError^, PChar('list.setFromTree() takes one qubtree node as argument') );
      Result := nil;
      Exit;
    end;

    prTree := PyNode_ToNode( TreePy );
    PythonThread.SyncGUIProc( prSetFromTree );
    Result       := ReturnNone;
  end;
end;

procedure TQUB_Python_DataList.prSetFromTree;
begin
  List.AsTree := prTree;
end;


//******************************************************************************

procedure InitDataPyTypes;
begin
  DataPyType := TPythonType.Create(nil);
  DataPyType.Engine := GetPythonEngine;
  DataPyType.Module := PythonViewport.pmQUBTypes;
  DataPyType.TypeName := 'DataType';
  DataPyType.Services.Basic := [bsGetAttr, bsSetAttr];
  DataPyType.PyObjectClass := TQUB_Python_Data;
  DataPyType.Initialize;

  DataResultsPyType := TPythonType.Create(nil);
  DataResultsPyType.Engine := GetPythonEngine;
  DataResultsPyType.Module := PythonViewport.pmQUBTypes;
  DataResultsPyType.TypeName := 'DataResultsType';
  DataResultsPyType.Services.Basic := [bsGetAttr];
  DataResultsPyType.Services.Sequence  := [ssItem, ssLength];
  DataResultsPyType.PyObjectClass := TQUB_Python_DataResults;
  DataResultsPyType.Initialize;

  DataListsPyType := TPythonType.Create(nil);
  DataListsPyType.Engine := GetPythonEngine;
  DataListsPyType.Module := PythonViewport.pmQUBTypes;
  DataListsPyType.TypeName := 'DataListsType';
  DataListsPyType.Services.Basic := [bsGetAttr];
  DataListsPyType.Services.Sequence  := [ssItem, ssLength];
  DataListsPyType.PyObjectClass := TQUB_Python_DataLists;
  DataListsPyType.Initialize;

  DataListPyType := TPythonType.Create(nil);
  DataListPyType.Engine := GetPythonEngine;
  DataListPyType.Module := PythonViewport.pmQUBTypes;
  DataListPyType.TypeName := 'DataListType';
  DataListPyType.Services.Basic := [bsGetAttr];
  DataListPyType.Services.Sequence  := [ssItem, ssLength];
  DataListPyType.PyObjectClass := TQUB_Python_DataList;
  DataListPyType.Initialize;
end;


//******************************************************************************

constructor TQUB_QVO_QVD_DataBuffer.Create(AData :TQUB_QVO_QVD; ABufferCount :Integer; AProcess :Boolean);
begin
  prData            := AData;
  prBufferCount     := ABufferCount;
  prProcess         := AProcess;
  prBaseIndex       := -1;
  prBuffer          := IAlloc2(prData.DataObject.ADChannelCount, prBufferCount);
end;

destructor TQUB_QVO_QVD_DataBuffer.Destroy;
begin
  try
    FreeMem(prBuffer);
  finally
    inherited;
  end;
end;

function TQUB_QVO_QVD_DataBuffer.LoadFrom(i :Integer): Boolean;
begin
  if prProcess then begin
    Result := prData.LoadDataProcessed(Buffer, QUB_FirstLast(i, Min(i + BufferCount, prData.DataObject.Segments.TotalDataCount) - 1));
  end else begin
    Result := prData.LoadData(Buffer, QUB_FirstLast(i, Min(i + BufferCount, prData.DataObject.Segments.TotalDataCount) - 1), False, False, False);
  end;
  if not Result then prBaseIndex := i;
end;

function TQUB_QVO_QVD_DataBuffer.ValueAt(ch, i :Integer): Double;
begin
  if (BaseIndex < 0) or (i < BaseIndex) or (i >= BaseIndex + BufferCount) then begin
    LoadFrom(i);
  end;

  Result := prBuffer[ch][i-BaseIndex] / (prData.Scaling * prData.DataChannelScaling[ch]) + prData.DataChannelOffset[ch];
end;


//******************************************************************************

constructor TQUB_QVO_QVD_DataBufferOne.Create(AData :TQUB_QVO_QVD; AChannelIndex, ABufferCount :Integer; AProcess, AFitCurve :Boolean; AProcessConstBaseline :Boolean; AProcessBaseline :Boolean; AProcessFilter :Boolean);
begin
  prData            := AData;
  prChannelIndex    := AChannelIndex;
  prScaling         := prData.Scaling * prData.DataChannelScaling[prChannelIndex];
  prOffset          := prData.DataChannelOffset[prChannelIndex];
  prBufferCount     := ABufferCount;
  prProcess         := AProcess;
  prProcessConstBaseline := AProcessConstBaseline;
  prProcessBaseline := AProcessBaseline;
  prProcessFilter   := AProcessFilter;
  prFitCurve        := AFitCurve;
  prBaseIndex       := -1;
  prBuffer          := IAlloc1(prBufferCount);
end;

destructor TQUB_QVO_QVD_DataBufferOne.Destroy;
begin
  try
    FreeMem(prBuffer);
  finally
    inherited;
  end;
end;

function TQUB_QVO_QVD_DataBufferOne.LoadFrom(i :Integer): Boolean;
begin
  if prFitCurve then begin
    Result := prLoadFitFrom(i);
  end else begin
    Result := prLoadDataFrom(i);
  end;
  if not Result then prBaseIndex := i;
end;

function TQUB_QVO_QVD_DataBufferOne.prLoadDataFrom(i :Integer): Boolean;
begin
  if prProcess then begin
    Result := prData.LoadDataChannelProcess(Buffer, prChannelIndex, QUB_FirstLast(i, Min(i + BufferCount, prData.DataObject.Segments.TotalDataCount) - 1), prProcessFilter and prData.FilterOn[prChannelIndex], prData.FilterFreq[prChannelIndex], prProcessBaseline and prData.BaselineOn[prChannelIndex], prProcessConstBaseline);
  end else begin
    Result := prData.LoadDataChannel(Buffer, prChannelIndex, QUB_FirstLast(i, Min(i + BufferCount, prData.DataObject.Segments.TotalDataCount) - 1), False, False, False, prProcessConstBaseline);
  end;
end;

function TQUB_QVO_QVD_DataBufferOne.prLoadFitFrom(First :Integer): Boolean;
var
  Last            :Integer;
  At              :Integer;
  CurveIter       :TQUB_FitCurveIter;
  Curve           :TQUB_FitCurve;
begin
  Last            := First + BufferCount - 1;
  At              := First;
  CurveIter       := nil;
  try
    CurveIter       := prData.FitCurves.Find(First);
    while (0 = CurveIter.Done) and (CurveIter.Curve.First <= Last) do begin
      Curve         := CurveIter.Curve;
      if At < Curve.First then begin
        FillChar(Buffer[At-First], SizeOf(Integer) * (Curve.First - At), 0);
        At          := Curve.First;
      end;

      Move(Curve.Data[At - Curve.First], Buffer[At-First], SizeOf(Integer) * (Min(Last, Curve.Last) - At + 1));
      At            := Min(Last, Curve.Last) + 1;
      CurveIter.Next;
    end;
  finally
    CurveIter.Free;
  end;

  if At <= Last then begin
    FillChar(Buffer[At-First], SizeOf(Integer) * (Last-At+1), 0);
  end;

  Result          := False;
end;

function TQUB_QVO_QVD_DataBufferOne.ValueAt(i :Integer): Double;
begin
  if (BaseIndex < 0) or (i < BaseIndex) or (i >= BaseIndex + BufferCount) then begin
    LoadFrom(i);
  end;

  Result := prBuffer[i-BaseIndex] / prScaling;
end;


//******************************************************************************
procedure Register;
begin
  RegisterComponents('QUB', [TQUB_QVO_QVD]);
end;


//******************************************************************************
end.
